theory characteristic
  imports replication hobisimPres
begin

context env
begin

definition characteristic :: "'b \<Rightarrow> 'a \<Rightarrow> ('a,'b,'c) psi list \<Rightarrow> bool"
where "characteristic \<Psi> M Pvec = (supp \<Psi> = (supp M::name set) \<and> (\<forall> \<Psi>' \<phi>. \<Psi>' \<otimes> \<Psi> \<turnstile> \<phi> \<longleftrightarrow> ((\<exists> P. P \<in> set Pvec \<and> \<phi>=M\<Leftarrow>P) \<or> \<Psi>' \<turnstile> \<phi>)) \<and> (\<forall> M' P P'. (M\<Leftarrow>P = M'\<Leftarrow>P') = ((P = P') \<and> M = M')) \<and> (\<forall> P. (supp M::name set) \<subseteq> supp(M\<Leftarrow>P)) \<and> (\<forall> \<Psi>' P. \<Psi>' \<turnstile> M\<Leftarrow>P \<longrightarrow> (supp M) \<subseteq> ((supp \<Psi>')::name set)))"

lemma characteristicEqvt[eqvt]:
  fixes p::"name prm"
  shows "(p\<bullet>characteristic \<Psi> M Pvec) = characteristic (p\<bullet>\<Psi>) (p\<bullet>M) (p\<bullet>Pvec)"
  by(simp add: characteristic_def eqvts)

lemma characteristicI:
  assumes "supp M = (supp \<Psi>::name set)"
  and "\<And> \<Psi>' \<phi>. \<Psi>' \<otimes> \<Psi> \<turnstile> \<phi> = ((\<exists> P. P \<in> set Pvec \<and> \<phi>=M\<Leftarrow>P) \<or> \<Psi>' \<turnstile> \<phi>)"
  and "\<And> P P' M'. (M\<Leftarrow>P = M'\<Leftarrow>P') = ((P = P') \<and> M = M')"
  and "\<And> P. (supp M::name set) \<subseteq> supp(M\<Leftarrow>P)"
  and "\<And> \<Psi>' P. \<Psi>' \<turnstile> M\<Leftarrow>P \<Longrightarrow> (supp M) \<subseteq> ((supp \<Psi>')::name set)"
  shows "characteristic \<Psi> M Pvec"
  using assms
  by(simp add: characteristic_def)

lemma characteristicResUnit:
  assumes char: "characteristic \<Psi>\<^isub>c M\<^isub>a Pvec"
  and "\<not>(a \<sharp> M\<^isub>a)"
  shows "F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F"
proof -
  {
    fix \<phi>
    assume "(F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>)) \<turnstile>\<^sub>F \<phi>"
    hence "F \<turnstile>\<^sub>F \<phi>"
    proof -
      obtain A\<^isub>F \<Psi>\<^isub>F where "F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "A\<^isub>F \<sharp>* F" and "A\<^isub>F \<sharp>* \<phi>" and "a \<sharp> A\<^isub>F" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* \<Psi>\<^isub>c" and "A\<^isub>F \<sharp>* Pvec"
        by(rule_tac freshFrame[where F=F and C="(F,\<phi>,a,M\<^isub>a,\<Psi>\<^isub>c,Pvec)"]) auto
      obtain b::"name" where "b \<noteq> a" and "b \<sharp> F" and "b \<sharp> A\<^isub>F" and "b \<sharp> \<Psi>\<^isub>F" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> Pvec"
        by(generate_fresh "name") auto
      from `(F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>)) \<turnstile>\<^sub>F \<phi>`
      have "(F \<otimes>\<^sub>F (\<langle>[b],([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle>)) \<turnstile>\<^sub>F \<phi>" using `b \<sharp> \<Psi>\<^isub>c`
        by(subst (asm) frameChainAlpha[where p="[(a,b)]"]) (auto simp add: eqvt calc_atm)
      hence "(\<langle>(A\<^isub>F @ [b]),(\<Psi>\<^isub>F \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c))\<rangle>) \<turnstile>\<^sub>F \<phi>"
        unfolding `F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
        using `b \<sharp> A\<^isub>F` `a \<sharp> A\<^isub>F` `A\<^isub>F \<sharp>* \<Psi>\<^isub>c` `b \<sharp> \<Psi>\<^isub>F`
        by(subst (asm) mergeFrames) auto
      hence "\<Psi>\<^isub>F \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi>" using `b \<sharp> \<phi>` `A\<^isub>F \<sharp>* \<phi>`
        by(rule_tac frameImpE) (assumption|simp)+
      from char have char': "characteristic ([(a,b)]\<bullet>\<Psi>\<^isub>c) ([(a,b)]\<bullet>M\<^isub>a) ([(a,b)]\<bullet>Pvec)"
        by(subst (asm) perm_bool[where pi="[(a,b)]",symmetric]) (simp add: eqvts)
      with `\<Psi>\<^isub>F \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi>`
      have "((\<exists> P. P \<in> set([(a,b)]\<bullet>Pvec) \<and> \<phi>=([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P) \<or> \<Psi>\<^isub>F \<turnstile> \<phi>)"
        by(simp add: characteristic_def)
      hence "\<Psi>\<^isub>F \<turnstile> \<phi>"
      proof(rule disjE)
        assume "\<exists>P. P \<in> set ([(a, b)] \<bullet> Pvec) \<and> \<phi> = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
        then obtain P where "P \<in> set ([(a, b)] \<bullet> Pvec)" and "\<phi> = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
          by blast
        have "b \<in> supp(([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P)" using `\<not>(a \<sharp>M\<^isub>a)` char'
          apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
          by(simp add: fresh_def eqvts calc_atm characteristic_def) blast
        hence False using `\<phi> = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P` `b \<sharp> \<phi>`
          by(simp add: fresh_def)
        thus ?thesis
          by(rule FalseE)
      next
        show "\<Psi>\<^isub>F \<turnstile> \<phi> \<Longrightarrow> \<Psi>\<^isub>F \<turnstile> \<phi>" by -
      qed
      thus ?thesis
        unfolding `F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` using `A\<^isub>F \<sharp>* \<phi>`
        by(rule_tac frameImpI[OF refl])
    qed
  }
  moreover
  {
    fix \<phi>
    assume "F \<turnstile>\<^sub>F \<phi>"
    hence "(F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>)) \<turnstile>\<^sub>F \<phi>"
    proof -
      obtain A\<^isub>F \<Psi>\<^isub>F where "F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "A\<^isub>F \<sharp>* F" and "A\<^isub>F \<sharp>* \<phi>" and "a \<sharp> A\<^isub>F" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* \<Psi>\<^isub>c" and "A\<^isub>F \<sharp>* Pvec"
        by(rule_tac freshFrame[where F=F and C="(F,\<phi>,a,M\<^isub>a,\<Psi>\<^isub>c,Pvec)"]) auto
      with `F \<turnstile>\<^sub>F \<phi>` have "\<Psi>\<^isub>F \<turnstile> \<phi>"
        by(rule_tac frameImpE[where A\<^isub>F="A\<^isub>F"]) simp+
      obtain b::"name" where "b \<noteq> a" and "b \<sharp> F" and "b \<sharp> A\<^isub>F" and "b \<sharp> \<Psi>\<^isub>F" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> Pvec"
        by(generate_fresh "name") auto
      from char have char': "characteristic ([(a,b)]\<bullet>\<Psi>\<^isub>c) ([(a,b)]\<bullet>M\<^isub>a) ([(a,b)]\<bullet>Pvec)"
        by(subst (asm) perm_bool[where pi="[(a,b)]",symmetric]) (simp add: eqvts)
      with `\<Psi>\<^isub>F \<turnstile> \<phi>` have "\<Psi>\<^isub>F \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi>"
        by(simp add: characteristic_def)
      hence "(F \<otimes>\<^sub>F (\<langle>[b],([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle>)) \<turnstile>\<^sub>F \<phi>"
        unfolding `F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
        using `b \<sharp> A\<^isub>F` `A\<^isub>F \<sharp>* \<Psi>\<^isub>c` `a \<sharp> A\<^isub>F` `b \<sharp> \<Psi>\<^isub>F` `A\<^isub>F \<sharp>* \<phi>` `b \<sharp> \<phi>`
        apply(rule_tac frameImpI[where A\<^isub>F = "A\<^isub>F@[b]" and \<Psi>\<^isub>F="\<Psi>\<^isub>F\<otimes>([(a,b)]\<bullet>\<Psi>\<^isub>c)"])
        by(rule mergeFrames) auto
      thus ?thesis using `b \<sharp> \<Psi>\<^isub>c` `b \<noteq> a`
        by(subst frameChainAlpha[where p="[(a,b)]"]) (auto simp add: eqvt calc_atm)
    qed
  }
  ultimately show ?thesis
    unfolding FrameStatEq_def FrameStatImp_def
    by blast
qed  

lemma hosum':
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   P  :: "('a, 'b::fs_name, 'c::fs_name) psi"
  and   Q  :: "('a, 'b, 'c) psi"
  and   R  :: "('a, 'b, 'c) psi"
  and   \<Psi>\<^isub>c :: 'b
  and   \<Psi>  :: 'b
  and   \<phi>  :: 'c
  assumes "a \<sharp> P"
  and     "a \<sharp> Q"
  and     "guarded P"
  and     "guarded Q"
  and     "supp P \<subseteq> (supp M\<^isub>a::name set)"
  and     "supp Q \<subseteq> (supp M\<^isub>a::name set)"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  and     "\<And> \<Psi>. \<Psi> \<turnstile> \<phi>"
  and     "\<not> clauseDom \<phi>"
  and    char: "characteristic \<Psi>\<^isub>c M\<^isub>a [P,Q]"
  shows "\<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<sim> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
proof(rule_tac hosum)
  show "a \<sharp> P" by fact
  show "a \<sharp> Q" by fact
  show "guarded P" by fact
  show "guarded Q" by fact
  show "(supp P::name set) \<subseteq> supp M\<^isub>a" by fact
  show "(supp Q::name set) \<subseteq> supp M\<^isub>a" by fact
  show "supp \<Psi>\<^isub>c = (supp M\<^isub>a::name set)" using char
    by(simp add: characteristic_def)
next
  fix \<Psi>
  show "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" using char
    by(simp add: characteristic_def)
next
  fix \<Psi>
  show "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" using char
    by(simp add: characteristic_def)
next
  fix \<Psi> \<phi>
  assume "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi>"
  thus "\<phi> = M\<^isub>a\<Leftarrow>P \<or> \<phi> = M\<^isub>a\<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>" using char
    by(auto simp add: characteristic_def)
next
  fix F
  show "F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F"
    by(rule characteristicResUnit) fact+
next
  show "\<not> a \<sharp> M\<^isub>a" by fact
  show "\<And>\<Psi>. \<Psi> \<turnstile> \<phi>" by fact
  show "\<not> clauseDom \<phi>" by fact
  show "\<And>P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')" using char
    by(simp add: characteristic_def)
next
  fix \<Psi> P
  assume "\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P"
  thus "(supp M\<^isub>a::name set) \<subseteq> supp \<Psi>" using char
    by(simp add: characteristic_def) blast
qed

lemma hocase':
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   CsP :: "('c::fs_name \<times> ('a, 'b::fs_name, 'c) psi) list"
  and   \<Psi>\<^isub>c :: 'b
  and   \<Psi>  :: 'b
  assumes "a \<sharp> CsP"
  and     "supp CsP \<subseteq> (supp M\<^isub>a::name set)"
  and     MemEnt: "\<And> \<Psi> \<phi> P. (\<phi>, P) \<in> set CsP \<Longrightarrow> guarded P"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  and     char: "characteristic \<Psi>\<^isub>c M\<^isub>a (map (\<lambda>(\<phi>,P). Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c) CsP)"
  shows "\<Psi> \<rhd> (Cases CsP) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
proof(rule_tac hocase)
  show "a \<sharp> CsP" by fact
  show "((supp CsP)::name set) \<subseteq> supp M\<^isub>a"
    by fact
  show "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" using char
    by(simp add: characteristic_def)
next
  fix \<Psi> \<phi> P
  assume "(\<phi>, P) mem CsP"
  hence "guarded P"
    by(simp add: assms)
  moreover have "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c" using char `(\<phi>, P) mem CsP`
    by(auto simp add: characteristic_def)
  ultimately show "guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c"
    by(rule conjI)
next
  fix \<Psi> \<phi>
  assume "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi>"
  thus "(\<exists>\<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or> \<Psi> \<turnstile> \<phi>" using char
    by(auto simp add: characteristic_def)
next
  fix F
  show "F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F"
    by(rule characteristicResUnit) fact+
next
  show "\<not> a \<sharp> M\<^isub>a" by fact
  show "\<And>P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')" using char
    by(simp add: characteristic_def)
next
  fix \<Psi> P
  assume "\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P"
  thus "(supp M\<^isub>a::name set) \<subseteq> supp \<Psi>" using char
    by(simp add: characteristic_def) blast
qed

lemma replication':
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   P  :: "('a, 'b::fs_name, 'c::fs_name) psi"
  and   R  :: "('a, 'b, 'c) psi"
  and   \<Psi>\<^isub>c :: 'b
  and   \<Psi>  :: 'b

  assumes EntCl: "\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> (P \<parallel> \<langle>M\<^isub>a\<rangle>)"
(*  and     Equiv2: "\<And>\<Psi> R. \<lbrakk>a \<sharp> \<Psi>\<rbrakk> \<Longrightarrow> (\<lbrakk>\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> R\<rbrakk> \<Longrightarrow> R = (P \<parallel> \<langle>M\<^isub>a\<rangle>))"*)
  and     "guarded P"
  and     "supp P \<subseteq> (supp M\<^isub>a::name set)"
  and     "a \<sharp> P"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  and      char: "characteristic \<Psi>\<^isub>c M\<^isub>a [P\<parallel>\<langle>M\<^isub>a\<rangle>]"

  shows "\<Psi> \<rhd> (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> (!P)"
proof(rule replication)
  show "\<And>\<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P \<parallel> \<langle>M\<^isub>a\<rangle>" using char
    by(simp add: characteristic_def)
next
  fix F
  show "F \<otimes>\<^sub>F (\<langle>[a],\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F"
    by(rule characteristicResUnit) fact+
next
  show "guarded P" by fact
next
  fix \<Psi> P
  assume "\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P"
  thus "(supp M\<^isub>a::name set) \<subseteq> supp \<Psi>"  using char
    by(simp add: characteristic_def) blast
next
  show "\<And>P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')" using char
    by(simp add: characteristic_def)
next
  fix \<Psi> \<phi>
  assume "\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi>"
  thus "\<phi> = M\<^isub>a\<Leftarrow>P \<parallel> \<langle>M\<^isub>a\<rangle> \<or> \<Psi> \<turnstile> \<phi>" using char
    by(simp add: characteristic_def)
next
  show "a \<sharp> P" by fact
  show "\<not> a \<sharp> M\<^isub>a" by fact
  show "(supp P::name set) \<subseteq> supp M\<^isub>a"
    by fact
  show "(supp \<Psi>\<^isub>c::name set) = supp M\<^isub>a" using char
    by(simp add: characteristic_def)
qed

lemma hobisimClausePres':
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   \<Psi>\<^isub>P :: 'b
  and   \<Psi>\<^isub>Q :: 'b
  and   M :: 'a
  assumes "legalClause M P"
  and     "legalClause M Q"
  and     "P \<sim>\<^sub>H Q"
  and     "characteristic \<Psi>\<^isub>P M [P]"
  and     "characteristic \<Psi>\<^isub>Q M [Q]"
  shows  "\<Psi> \<rhd> \<lbrace>\<Psi>\<^isub>P\<rbrace> \<sim>\<^sub>H (\<lbrace>\<Psi>\<^isub>Q\<rbrace>)"
proof(rule hobisimClausePres)
  show "legalClause M P" by fact
next
  show "legalClause M Q" by fact
next
  show "P \<sim>\<^sub>H Q" by fact
next
  fix \<Psi> \<phi>
  show "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi> = (\<phi> = M\<Leftarrow>P \<or> \<Psi> \<turnstile> \<phi>)" using `characteristic \<Psi>\<^isub>P M [P]`
    by(auto simp add: characteristic_def)
next
  fix \<Psi> \<phi>
  show "\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi> = (\<phi> = M\<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>)" using `characteristic \<Psi>\<^isub>Q M [Q]`
    by(auto simp add: characteristic_def)
next
  fix M' P'' P'
  show "M\<Leftarrow>P'' = M'\<Leftarrow>P' \<Longrightarrow> M = M' \<and> P'' = P'" using `characteristic \<Psi>\<^isub>P M [P]`
    by(simp add: characteristic_def)
qed

end

end