theory hocase
  imports hosum
begin

context env
begin

lemma hocase:
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   CsP :: "('c::fs_name \<times> ('a, 'b::fs_name, 'c) psi) list"
  and   \<Psi>\<^isub>c :: 'b
  and   \<Psi>  :: 'b
  assumes "a \<sharp> CsP"
  and     "((supp CsP)::name set) \<subseteq> supp M\<^isub>a"
  and     "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a"
  and     MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))"
  and     EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)"
  and     Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  and     Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))"
  and     EntSupp: "\<And> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set))"
  shows "\<Psi> \<rhd> (Cases CsP) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
proof -
  {
    fix a  :: name
      and   M\<^isub>a :: "'a::fs_name"
      and   CsP :: "('c::fs_name \<times> ('a, 'b::fs_name, 'c) psi) list"
      and   \<Psi>\<^isub>c :: 'b
      and   \<Psi>  :: 'b
    assume "a \<sharp> CsP"
      and     "a \<sharp> \<Psi>"
      and     "((supp CsP)::name set) \<subseteq> supp M\<^isub>a"
      and     "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a"
      and     MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))"
      and     EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)"
      and     Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F"
      and     "\<not>(a \<sharp> M\<^isub>a)"
      and     Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))"
      and     EntSupp: "\<And> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set))"
    let ?X1 = "{((\<Psi>::'b), (\<lparr>\<nu>(a::name)\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)), Cases CsP) | \<Psi> a CsP M\<^isub>a \<Psi>\<^isub>c. a \<sharp> CsP \<and> a \<sharp> \<Psi> \<and> ((supp CsP)::name set) \<subseteq> supp M\<^isub>a \<and> ((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a \<and> (\<forall> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))) \<and> (\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)) \<and> (\<forall> F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F) \<and> \<not>(a \<sharp> M\<^isub>a) \<and> (\<forall> P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')) \<and> (\<forall> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set)))}"
    let ?X2 = "{((\<Psi>::'b), Cases CsP, (\<lparr>\<nu>(a::name)\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) | \<Psi> a CsP M\<^isub>a \<Psi>\<^isub>c. a \<sharp> CsP \<and> a \<sharp> \<Psi> \<and> ((supp CsP)::name set) \<subseteq> supp M\<^isub>a \<and> ((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a \<and> (\<forall> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))) \<and> (\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)) \<and> (\<forall> F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F) \<and> \<not>(a \<sharp> M\<^isub>a) \<and> (\<forall> P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')) \<and> (\<forall> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set)))}"
    let ?X = "?X1 \<union> ?X2"
    from `a \<sharp> CsP` `a \<sharp> \<Psi>` `(supp CsP) \<subseteq> supp M\<^isub>a` `(supp \<Psi>\<^isub>c) = supp M\<^isub>a` MemEnt EntMem Equiv1 `\<not>(a \<sharp> M\<^isub>a)` Inj EntSupp
    have "(\<Psi>,(Cases CsP),(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<in> ?X2"
      by blast
    hence "(\<Psi>,(Cases CsP),(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<in> ?X"
      by(rule UnI2)
    moreover have "eqvt ?X"
    proof -
      have supp_subset_closed: "\<And> (A::('d::fs_name)) (B::('e::fs_name)) (p::name prm). (supp A::name set) \<subseteq> supp B = ((supp (p\<bullet>A)::name set) \<subseteq> supp (p\<bullet>B))"
      proof -
        fix A::"'d::fs_name"
          and B::"'e::fs_name"
          and p::"name prm"
        show "(supp A::name set) \<subseteq> supp B = ((supp (p\<bullet>A)::name set) \<subseteq> supp (p\<bullet>B))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric, where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric, where pi="p"])
          by(simp add: eqvts)
      qed
      have supp_eq_closed: "\<And> (A::('d::fs_name)) (B::('e::fs_name)) (p::name prm). ((supp A::name set) = supp B) = (((supp (p\<bullet>A)::name set) = supp (p\<bullet>B)))"
      proof -
        fix A::"'d::fs_name"
          and B::"'e::fs_name"
          and p::"name prm"
        show "(supp A::name set) = supp B = ((supp (p\<bullet>A)::name set) = supp (p\<bullet>B))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric, where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric, where pi="p"])
          by(simp add: eqvts)
      qed
      have eqvt_lol: "\<And> (p::name prm) \<Psi>\<^isub>c a. ((\<forall>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F) = (\<forall>F. (F \<otimes>\<^sub>F \<langle>[(p\<bullet>a)], (p\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F)))"
        apply(rule_tac pi1="rev p" and t = "(\<forall>F. assertionAux.FrameStatEq SImp'
          (assertionAux.mergeFrame op \<otimes> F (\<langle>[p \<bullet> a], p \<bullet> \<Psi>\<^isub>c\<rangle>))
          F)" in subst[OF perm_bool])
        by(simp add: eqvts)
      have eqvt_lol':
        "\<And> (p::name prm) \<Psi>\<^isub>c ab.
        (\<forall>F. assertionAux.FrameStatEq SImp'
        (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu> ab \<rparr> \<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) F)=
        (\<forall>F. assertionAux.FrameStatEq SImp'
        (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu>p \<bullet> ab \<rparr> \<langle>\<epsilon>, p \<bullet> \<Psi>\<^isub>c\<rangle>)) F)"
        apply(rule_tac pi1="rev p" and t = "(\<forall>F. assertionAux.FrameStatEq SImp'
          (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu>p \<bullet> ab\<rparr> \<langle>\<epsilon>, p \<bullet> \<Psi>\<^isub>c\<rangle>)) F)" in subst[OF perm_bool])
        by(simp add: eqvts)
      have eqvt_lol'': "\<And> (p::name prm) CsP \<Psi>\<^isub>c M\<^isub>a.
        (\<forall>\<Psi> \<phi> P.
        (\<phi>, P) \<in> set CsP \<longrightarrow> guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)
        =
        (\<forall>\<Psi> \<phi> P.
        (\<phi>, P) \<in> set (p\<bullet>CsP) \<longrightarrow> guarded P \<and> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>c) \<turnstile> (p\<bullet>M\<^isub>a)\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)"
      proof -
        fix p::"name prm"
          and \<Psi>\<^isub>c 
          and M\<^isub>a
          and CsP
        show "(\<forall>\<Psi> \<phi> P.
          (\<phi>, P) \<in> set CsP \<longrightarrow> guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)
          =
          (\<forall>\<Psi> \<phi> P.
          (\<phi>, P) \<in> set (p\<bullet>CsP) \<longrightarrow> guarded P \<and> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>c) \<turnstile> (p\<bullet>M\<^isub>a)\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)"
          apply(rule iffI)
          apply(subst perm_bool[symmetric, where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric, where pi="p"])
          by(simp add: eqvts)
      qed
      have eqvt_lol''': "\<And> \<Psi>\<^isub>c CsP M\<^isub>a (p::name prm).
        (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow>
        (\<exists>\<phi>' P.
        (\<phi>', P) \<in> set CsP \<and>
        \<phi> = M\<^isub>a\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or>
        \<Psi> \<turnstile> \<phi>)
        =
        (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow>
        (\<exists>\<phi>' P.
        (\<phi>', P) \<in> set (p \<bullet> CsP) \<and>
        \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or>
        \<Psi> \<turnstile> \<phi>)"
      proof -
        fix \<Psi>\<^isub>c
          and M\<^isub>a
          and CsP
          and p::"name prm"
        show "(\<forall>\<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow>
          (\<exists>\<phi>' P.
          (\<phi>', P) \<in> set CsP \<and>
          \<phi> = M\<^isub>a\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or>
          \<Psi> \<turnstile> \<phi>)
          =
          (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow>
          (\<exists>\<phi>' P.
          (\<phi>', P) \<in> set (p \<bullet> CsP) \<and>
          \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or>
          \<Psi> \<turnstile> \<phi>)"
          apply(rule iffI)
          apply(subst perm_bool[symmetric,where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric,where pi="p"])
          by(simp add: eqvts)
      qed
      have "eqvt_lol'''''": "\<And> M\<^isub>a (p::name prm).
        (\<forall>P P'. (M\<^isub>a\<Leftarrow>P = (M\<^isub>a)\<Leftarrow>P') = (P = P'))
        =
        (\<forall>P P'. ((p \<bullet> M\<^isub>a)\<Leftarrow>P = (p \<bullet> M\<^isub>a)\<Leftarrow>P') = (P = P'))"
      proof -
        fix M\<^isub>a
        and p::"name prm"
        show "(\<forall>P P'. (M\<^isub>a\<Leftarrow>P = (M\<^isub>a)\<Leftarrow>P') = (P = P')) = (\<forall>P P'. ((p \<bullet> M\<^isub>a)\<Leftarrow>P = (p \<bullet> M\<^isub>a)\<Leftarrow>P') = (P = P'))"
          apply(rule iffI)
          apply(subst (asm) perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric])
          by(simp add: eqvts)
      qed
      have "eqvt_lol''''''": "\<And> M\<^isub>a (p::name prm).
        (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P) \<longrightarrow> supp (M\<^isub>a) \<subseteq> (supp \<Psi>::name set))
        =
        (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>P) \<longrightarrow> supp (p \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set))"
      proof -
        fix M\<^isub>a
        and p::"name prm"
        show "(\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P) \<longrightarrow> supp (M\<^isub>a) \<subseteq> (supp \<Psi>::name set)) = (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>P) \<longrightarrow> supp (p \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set))"
          apply(rule iffI)
          apply(subst (asm) perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          done
      qed
      show ?thesis
      apply(rule eqvtUnion)
      apply(auto simp add: eqvt_def eqvts)
      apply(rule_tac x = "p\<bullet>ab" in exI)
      apply(rule_tac x = "p\<bullet>M\<^isub>a" in exI,
        rule_tac x = "p\<bullet>\<Psi>\<^isub>c" in exI)
      apply(simp add: pt_fresh_bij[OF pt_name_inst, OF at_name_inst] pt_fresh_star_bij[OF pt_name_inst, OF at_name_inst] clauseClosed'[symmetric] eqvt_lol'[symmetric] extractFrameNilClosed[symmetric] supp_subset_closed[symmetric] supp_eq_closed[symmetric] eqvt_lol''[symmetric] eqvt_lol'''[symmetric] eqvt_lol'''''[symmetric] eqvt_lol''''''[symmetric])
      apply(rule_tac x = "p\<bullet>ab" in exI)
      apply(rule_tac x = "p\<bullet>M\<^isub>a" in exI,
        rule_tac x = "p\<bullet>\<Psi>\<^isub>c" in exI)
      apply(simp add: pt_fresh_bij[OF pt_name_inst, OF at_name_inst] pt_fresh_star_bij[OF pt_name_inst, OF at_name_inst] clauseClosed'[symmetric] eqvt_lol'[symmetric] extractFrameNilClosed[symmetric] supp_subset_closed[symmetric] supp_eq_closed[symmetric] eqvt_lol''[symmetric] eqvt_lol'''[symmetric] eqvt_lol'''''[symmetric] eqvt_lol''''''[symmetric])
      done
  qed
  ultimately have "\<Psi> \<rhd> (Cases CsP) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
  proof(coinduct rule: bisimCoinduct)
    case(cStatEq \<Psi> S T)
    show ?case
    proof(case_tac "(\<Psi>, S, T) \<in> ?X1")
	assume "(\<Psi>, S, T) \<in> ?X1"
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have frameCoding: "extractFrame(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) = \<langle>[a], \<one> \<otimes> \<Psi>\<^isub>c\<rangle>"
          by simp
        have frameCoding': "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F \<langle>\<epsilon>, \<Psi>\<rangle>"
          apply(subst extractFrameSimps)
          apply(subst frameCoding)
          apply(subst extractFrameSimps)
          apply(subst mergeFrameSimps')
          apply(simp add: `a \<sharp> \<Psi>`)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameIntAssociativity])
          apply(rule FrameStatEqTrans[OF frameIntCommutativity])
          apply(subst mergeFrameSimps[symmetric])         
          apply(rule freshCompChain)
          apply(simp add: `a \<sharp> \<Psi>`)
          apply simp
          apply(rule FrameStatEqTrans[OF frameCommutativity])
          apply(rule FrameStatEqTrans[OF Equiv1])
          apply(subst frameNilStatEq)
          by(rule Identity)
        have frameCodingStatEq: "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F insertAssertion (extractFrame (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<Psi>"
          by simp
        show ?case
          unfolding sdef tdef
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameCodingStatEq])
          apply(rule FrameStatEqTrans[OF frameCoding'])
          unfolding extractFrameSimps insertAssertion.simps frameNilStatEq
          by(rule AssertionStatEqSym[OF Identity])
      next
        assume  "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using cStatEq
          by blast
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have frameCoding: "extractFrame(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) = \<langle>[a], \<one> \<otimes> \<Psi>\<^isub>c\<rangle>"
          by simp
        have frameCoding': "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F \<langle>\<epsilon>, \<Psi>\<rangle>"
          apply(subst extractFrameSimps)
          apply(subst frameCoding)
          apply(subst extractFrameSimps)
          apply(subst mergeFrameSimps')
          apply(simp add: `a \<sharp> \<Psi>`)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameIntAssociativity])
          apply(rule FrameStatEqTrans[OF frameIntCommutativity])
          apply(subst mergeFrameSimps[symmetric])         
          apply(rule freshCompChain)
          apply(simp add: `a \<sharp> \<Psi>`)
          apply simp
          apply(rule FrameStatEqTrans[OF frameCommutativity])
          apply(rule FrameStatEqTrans[OF Equiv1])
          apply(subst frameNilStatEq)
          by(rule Identity)
        have frameCodingStatEq: "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F insertAssertion (extractFrame (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<Psi>"
          by simp
        show ?case
          unfolding sdef tdef
          apply(rule FrameStatEqSym)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameCodingStatEq])
          apply(rule FrameStatEqTrans[OF frameCoding'])
          unfolding extractFrameSimps insertAssertion.simps frameNilStatEq
          by(rule AssertionStatEqSym[OF Identity])
      qed
    next
      case (cSym \<Psi> R S)
      thus ?case
        by blast
    next
      case (cExt \<Psi> S T \<Psi>')
      show ?case
      proof(case_tac "(\<Psi>, S, T) \<in> ?X1")
        assume "(\<Psi>, S, T) \<in> ?X1"
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        obtain b::name where "b \<sharp> CsP" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<Psi>'"
          apply(rule at_exists_fresh[where x="(CsP,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<Psi>')", OF at_name_inst])
          apply(finite_guess)
          by force
        have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
          apply(subst alphaRes[where y=b])
          apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
          by(rule refl)
        have s_def: "S = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
          unfolding sdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
          by simp
        have "b \<sharp> \<Psi> \<otimes> \<Psi>'"
          by(rule freshComp[OF `b \<sharp> \<Psi>`, OF  `b \<sharp> \<Psi>'`])
        moreover note `b \<sharp> CsP`
        moreover have "((supp CsP)::name set) \<subseteq> supp([(a,b)]\<bullet>M\<^isub>a)" using `supp CsP \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "((supp ([(a,b)]\<bullet>\<Psi>\<^isub>c))::name set) = supp([(a,b)]\<bullet>M\<^isub>a)" using `supp \<Psi>\<^isub>c = supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts)
        moreover have "\<forall> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<longrightarrow> (guarded P \<and> \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" using MemEnt
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> \<Psi>` `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" using EntMem
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> \<Psi>` `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "\<forall> F. F \<otimes>\<^sub>F \<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F" using Equiv1
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<not>(b \<sharp> ([(a,b)]\<bullet>M\<^isub>a))" using `\<not>(a \<sharp> M\<^isub>a)`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
        proof -
          fix P and P'
          show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
            apply(rule iffI)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            done
        qed
        moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
        proof -
          fix \<Psi> and P
          assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
          thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
            apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
            apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
            by(simp add: eqvts EntSupp)
        qed
        ultimately show ?case
          unfolding s_def tdef
          by blast
      next
        assume "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using cExt by blast
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        obtain b::name where "b \<sharp> CsP" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<Psi>'"
          apply(rule at_exists_fresh[where x="(CsP,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<Psi>')", OF at_name_inst])
          apply(finite_guess)
          by force
        have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
          apply(subst alphaRes[where y=b])
          apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
          by(rule refl)
        have t_def: "T = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
          unfolding tdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
          by simp
        have "b \<sharp> \<Psi> \<otimes> \<Psi>'"
          by(rule freshComp[OF `b \<sharp> \<Psi>`, OF  `b \<sharp> \<Psi>'`])
        moreover note `b \<sharp> CsP`
        moreover have "((supp CsP)::name set) \<subseteq> supp([(a,b)]\<bullet>M\<^isub>a)" using `supp CsP \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "((supp ([(a,b)]\<bullet>\<Psi>\<^isub>c))::name set) = supp([(a,b)]\<bullet>M\<^isub>a)" using `supp \<Psi>\<^isub>c = supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts)
        moreover have "\<forall> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<longrightarrow> (guarded P \<and> \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" using MemEnt
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> \<Psi>` `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" using EntMem
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> \<Psi>` `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
        moreover have "\<forall> F. F \<otimes>\<^sub>F \<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F" using Equiv1
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<not>(b \<sharp> ([(a,b)]\<bullet>M\<^isub>a))" using `\<not>(a \<sharp> M\<^isub>a)`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])        
        moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
        proof -
          fix P and P'
          show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
            apply(rule iffI)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            done
        qed
        moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
        proof -
          fix \<Psi> and P
          assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
          thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
            apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
            apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
            by(simp add: eqvts EntSupp)
        qed
        ultimately show ?case
          unfolding sdef t_def
          by blast
      qed
    next
      case(cSim \<Psi> S T)
      let ?Y = "?X \<union> bisim"
      show ?case
      proof(cases "(\<Psi>,S,T) \<in> ?X1")
        assume "(\<Psi>,S,T) \<in> ?X1"
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have "eqvt(?Y)" using `eqvt ?X` bisimEqvt
          by(rule eqvtUnion)
        have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<leadsto>[?Y] (Cases CsP)"
        proof(rule simI[where C= "a", OF `eqvt(?Y)`])
          fix \<alpha>
            and Q'::"('a,'b,'c) psi"
          assume "\<Psi> \<rhd> Cases CsP \<longmapsto> \<alpha> \<prec> Q'"
            and "bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
            and "bn \<alpha> \<sharp>* (Cases CsP)"
            and "bn \<alpha> \<sharp>* \<Psi>"
            and "distinct (bn \<alpha>)"
            and "bn \<alpha> \<sharp>* subject \<alpha>"
            and "bn \<alpha> \<sharp>* a"
          obtain b::name where "b \<sharp> CsP" and "b \<sharp> Q'" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<alpha>" and "b \<sharp> bn \<alpha>"
            apply(rule at_exists_fresh[where x="(CsP,Q',\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<alpha>,bn \<alpha>)", OF at_name_inst])
            apply(finite_guess)
            by force
          have res_def: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have res_def': "\<lparr>\<nu>a\<rparr>(Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> Q'` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have s_def: "S = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
            unfolding sdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
            by simp
          have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have MemEnt': "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" using MemEnt
            apply -
            apply(rule conjI)
            apply simp
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `b \<sharp> CsP` `a \<sharp> CsP`)
          have EntMem': "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)"
          proof -
            fix \<Psi> \<phi>
            assume "\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi>"
            thus "(\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>" using EntMem
              apply -
              apply(subst perm_bool[where pi="[(a,b)]", symmetric])
              apply(subst perm_bool[where pi="[(a,b)]" and b="\<Psi> \<turnstile> \<phi>", symmetric])
              apply(subst (asm) perm_bool[where pi="[(a,b)]", symmetric])
              by(simp add: eqvts `b \<sharp> CsP` `a \<sharp> CsP`)
          qed
          have Equiv1': "\<And>F. F \<otimes>\<^sub>F \<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F" using Equiv1
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
          have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> \<zero>"
          proof -
            let ?C1 = "{(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>)| \<Psi>. True}"
            let ?C2 = "{(\<Psi>,\<zero>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>)| \<Psi>. True}"
            let ?C = "?C1 \<union> ?C2"
            have "(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>) \<in> ?C"
              by simp
            thus ?thesis
            proof(coinduct rule: bisimCoinduct)
              case(cStatEq \<Psi>' R S)
              thus ?case
              proof(cases "(\<Psi>',R,S) \<in> ?C1")
                assume "(\<Psi>',R,S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqSym)
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              next
                assume "(\<Psi>', R, S) \<notin> ?C1"
                hence "(\<Psi>', R, S) \<in> ?C2" using cStatEq
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              qed
            next
              case(cSim \<Psi> R S)
              show ?case
              proof(cases "(\<Psi>, R, S) \<in> ?C1")
                assume "(\<Psi>, R, S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: nilTrans)
              next
                assume "(\<Psi>, R, S) \<notin> ?C1"
                hence "(\<Psi>, R, S) \<in> ?C2" using cSim
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have falseness: "\<And> \<alpha> Q'.(\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<longmapsto> \<alpha> \<prec> Q' \<Longrightarrow> False)"
                  by(cases rule: semantics.cases) (auto simp add: psi.inject alpha')
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: falseness)
              qed
            next
              case(cExt \<Psi> R S \<Psi>')
              thus ?case by blast
            next
              case(cSym \<Psi> R S)
              thus ?case by blast
            qed
          qed
          hence "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>\<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace> \<sim> \<zero>" using `b \<sharp> \<Psi>\<^isub>c`
            apply(subst alphaRes[where y=a])
            apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
            apply(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
            by(simp add: eqvts pt_swap_bij'[OF pt_name_inst, OF at_name_inst])
          note `\<Psi> \<rhd> Cases CsP \<longmapsto> \<alpha> \<prec> Q'`
          thus "\<exists> P'. \<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> ?Y"
          proof(induct rule: caseCases)
            case(cCase \<phi> P)
            have "b \<sharp> P" and "b \<sharp> \<phi>" using `b \<sharp> CsP` `(\<phi>,P) mem CsP`
              by(induct CsP) auto
            have r: "\<And> (A::('e::fs_name)) (p::name prm). p\<bullet>(supp A::name set) = supp(p\<bullet>A)"
              by(simp add: eqvts)
            have bnFresh: "bn \<alpha> \<sharp>* ([(a, b)] \<bullet> \<Psi>\<^isub>c)"
              proof -
                have "(supp([(a, b)] \<bullet> \<Psi>\<^isub>c)::name set) \<subseteq> {a} \<union> {b} \<union> supp \<Psi>\<^isub>c"
                proof -
                  have seq: "({a} \<union> {b} \<union> supp \<Psi>\<^isub>c) = (supp([(a, b)]) \<union> supp \<Psi>\<^isub>c)"
                    by(simp add: supp_list_nil supp_list_cons supp_prod supp_atm)
                  show ?thesis unfolding seq
                    by(rule permSupp)
                qed
                have "bn \<alpha> \<sharp>* \<Psi>\<^isub>c" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
                  by simp
                have "bn \<alpha> \<sharp>* ({a} \<union> {b} \<union> supp \<Psi>\<^isub>c)" using `bn \<alpha> \<sharp>* a` using `b \<sharp> bn \<alpha>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>c`
                  apply(subst fresh_chain_fin_union)
                  apply simp
                  apply(finite_guess)
                  apply(subst fresh_chain_fin_union)
                  apply(simp,simp)
                  by(auto simp add: fresh_star_def fresh_def supp_idem supp_singleton[OF pt_name_inst, OF at_name_inst] name_list_supp supp_atm)
                show ?thesis
                  apply(subst fresh_chain_supp[symmetric])
                  apply(rule fresh_star_subset')
                  apply fact+
                  apply simp
                  apply finite_guess
                  done
                qed
            hence bnFresh': "bn \<alpha> \<sharp>* \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle>"
              unfolding fresh_star_def fresh_def r[symmetric] `(supp \<Psi>\<^isub>c) = supp M\<^isub>a`
              by(simp add: eqvts psi.supp)
            have doP: "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<rhd> P \<longmapsto> \<alpha> \<prec> Q'"
            proof -
              have feq: "\<And>F. (F \<otimes>\<^sub>F (\<langle>\<epsilon>, \<Psi>\<rangle>)) \<simeq>\<^sub>F F \<otimes>\<^sub>F (\<langle>[b], \<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>)"
                apply(subst mergeFrameSimps'[symmetric])
                apply(simp add: `b \<sharp> \<Psi>`)
                apply(rule FrameStatEqSym)
                apply(rule FrameStatEqTrans[OF frameAssociativity])
                by(rule Equiv1')
              show ?thesis
                apply(rule frameStatEqTransition)
                apply fact
                apply fact
                apply fact
                apply fact
                apply(simp del: actionFresh actionFreshChain add: `b \<sharp> \<alpha>`)
                apply(simp add: `b \<sharp> P`)
                done
            qed
            have phiEnt: "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi>" using `\<Psi> \<turnstile> \<phi>`
            proof -
              have "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<simeq>\<^sub>F (\<langle>\<epsilon>, \<Psi>\<rangle>) \<otimes>\<^sub>F \<langle>[b],([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>"
                by(rule FrameStatEqSym[OF Equiv1'])
              hence "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<simeq>\<^sub>F \<langle>[b],\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>"
                apply(subst mergeFrameSimps'[symmetric])
                by(simp add: `b \<sharp> \<Psi>`)
              moreover have "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<turnstile>\<^sub>F \<phi>" using `\<Psi> \<turnstile> \<phi>`
                by simp
              ultimately have "(\<langle>[b],\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) \<turnstile>\<^sub>F \<phi>"
                by(rule frameStatEqEnt)
              thus ?thesis using `b \<sharp> \<phi>`
                apply -
                by(rule frameImpE, assumption, simp)
            qed
            have clauseEnt: "\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c" using `(\<phi>, P) mem CsP`
              by(simp add: MemEnt')
            have caseSupp: "(supp (Cases [(\<phi>, P)])::name set) \<subseteq> supp ([(a, b)] \<bullet> M\<^isub>a)"
            proof -
              have "(supp (Cases [(\<phi>, P)])::name set) \<subseteq> supp CsP" using `(\<phi>, P) mem CsP`
                by (induct CsP) (auto simp add: supp_list_cons supp_list_nil supp_prod psi.supp psiCase.supp)
              moreover have "(supp CsP::name set) \<subseteq> supp ([(a, b)] \<bullet> M\<^isub>a)" using `supp CsP \<subseteq> supp (M\<^isub>a)`
                apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
                by(simp add: eqvts `a \<sharp> CsP` `b \<sharp> CsP`)
              ultimately show ?thesis
                by simp
            qed
            have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
              apply(rule Scope)
              apply(rule cPar1[where A\<^isub>Q = "[]" and \<Psi>\<^isub>Q = "([(a, b)] \<bullet> \<Psi>\<^isub>c)"])
              apply(rule Inv)
              apply(rule clauseEnt)
              unfolding psiCases.simps[symmetric]
              apply(rule Case[where \<phi>=\<phi> and P=P])
              apply(rule doP)
              apply simp
              apply(rule phiEnt)
              apply fact
              apply fact
              apply(rule caseSupp)
              apply(fact | simp add: bnFresh)+
              done
            hence "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
              apply(subst alphaRes[where x=a and y=b])
              apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
              by(simp only: eqvts)
            moreover have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>) \<sim> Q'"
            proof -
              have "b \<sharp> Q'" using  `\<Psi> \<rhd> Cases CsP \<longmapsto> \<alpha> \<prec> Q'`
                apply(rule freeFreshDerivative)
                by(fact | simp add: `b \<sharp> CsP`)+
              hence se: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>) \<sim> Q' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>"
                by(rule bisimScopeExt)
              show ?thesis
                apply(rule bisimTransitive[OF se])
                apply(rule bisimSymmetric)
                apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
                apply(rule bisimTransitive[OF bisimParComm])
                apply(rule bisimSymmetric)
                apply(rule bisimTransitive[OF bisimParComm])
                apply(rule bisimParPres)
                by fact
            qed
            ultimately show ?case
              by blast
          qed
        qed
        thus ?case
          unfolding sdef tdef
          by assumption
      next
        assume "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using `(\<Psi>, S, T) \<in> ?X`
          by blast
        then obtain a CsP M\<^isub>a \<Psi>\<^isub>c where tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = Cases CsP" and "a \<sharp> CsP" and "a \<sharp> \<Psi>" and "((supp CsP)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and MemEnt: "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" and EntMem: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = M\<^isub>a \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" and Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F" and "\<not>(a \<sharp> M\<^isub>a)" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have "eqvt(?Y)" using `eqvt ?X` bisimEqvt
          by(rule eqvtUnion)
        have "\<Psi> \<rhd> (Cases CsP) \<leadsto>[?Y] \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
        proof(rule simI[where C= "a", OF `eqvt(?Y)`])
          fix \<alpha> Q'
          assume "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> Q'"
            and  "bn \<alpha> \<sharp>* (Cases CsP)"
            and "bn \<alpha> \<sharp>* (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)::('a,'b,'c) psi)"
            and "bn \<alpha> \<sharp>* \<Psi>"
            and "distinct (bn \<alpha>)"
            and "bn \<alpha> \<sharp>* subject \<alpha>"
            and "bn \<alpha> \<sharp>* a"
          obtain b::name where "b \<sharp> CsP" and "b \<sharp> Q'" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<alpha>" and "b \<sharp> bn \<alpha>"
            apply(rule at_exists_fresh[where x="(CsP,Q',\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<alpha>,bn \<alpha>)", OF at_name_inst])
            apply(finite_guess)
            by force
          have res_def: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have res_def': "\<lparr>\<nu>a\<rparr>(Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> Q'` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have t_def: "T = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
            unfolding tdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
            by simp
          have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have MemEnt': "\<And> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<Longrightarrow> (guarded P \<and> \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" using MemEnt
            apply -
            apply(rule conjI)
            apply simp
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `b \<sharp> CsP` `a \<sharp> CsP`)
          have EntMem': "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi> \<Longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)"
          proof -
            fix \<Psi>::'b
              and \<phi>::'c
            assume "\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi>"
            thus "(\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>" using EntMem
              apply -
              apply(subst perm_bool[where pi="[(a,b)]", symmetric])
              apply(subst perm_bool[where pi="[(a,b)]" and b="\<Psi> \<turnstile> \<phi>", symmetric])
              apply(subst (asm) perm_bool[where pi="[(a,b)]", symmetric])
              by(simp add: eqvts `b \<sharp> CsP` `a \<sharp> CsP`)
          qed
          have Equiv1': "\<And>F. F \<otimes>\<^sub>F \<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F" using Equiv1
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
          have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> \<zero>"
          proof -
            let ?C1 = "{(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>)| \<Psi>. True}"
            let ?C2 = "{(\<Psi>,\<zero>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>)| \<Psi>. True}"
            let ?C = "?C1 \<union> ?C2"
            have "(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>) \<in> ?C"
              by simp
            thus ?thesis
            proof(coinduct rule: bisimCoinduct)
              case(cStatEq \<Psi>' R S)
              thus ?case
              proof(cases "(\<Psi>',R,S) \<in> ?C1")
                assume "(\<Psi>',R,S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqSym)
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              next
                assume "(\<Psi>', R, S) \<notin> ?C1"
                hence "(\<Psi>', R, S) \<in> ?C2" using cStatEq
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              qed
            next
              case(cSim \<Psi> R S)
              show ?case
              proof(cases "(\<Psi>, R, S) \<in> ?C1")
                assume "(\<Psi>, R, S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: nilTrans)
              next
                assume "(\<Psi>, R, S) \<notin> ?C1"
                hence "(\<Psi>, R, S) \<in> ?C2" using cSim
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have falseness: "\<And> \<alpha> Q'.(\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<longmapsto> \<alpha> \<prec> Q' \<Longrightarrow> False)"
                  by(cases rule: semantics.cases) (auto simp add: psi.inject alpha')
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: falseness)
              qed
            next
              case(cExt \<Psi> R S \<Psi>')
              thus ?case by blast
            next
              case(cSym \<Psi> R S)
              thus ?case by blast
            qed
          qed
          hence "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>\<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace> \<sim> \<zero>" using `b \<sharp> \<Psi>\<^isub>c`
            apply(subst alphaRes[where y=a])
            apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
            apply(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
            by(simp add: eqvts pt_swap_bij'[OF pt_name_inst, OF at_name_inst])
          have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>) \<longmapsto> \<alpha> \<prec> Q'" using `\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> Q'`
            apply -
            apply(subst (asm) alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by(simp only: eqvts)
          moreover note `b \<sharp> \<Psi>` `b \<sharp> \<alpha>` `b \<sharp> Q'` `bn \<alpha> \<sharp>* \<Psi>`
          moreover have "bn \<alpha> \<sharp>* ((\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)::('a,'b,'c) psi)" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `b \<sharp> bn \<alpha>`
            apply -
            apply(subst (asm) alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by simp
          moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
          ultimately show "\<exists> P'. \<Psi> \<rhd> Cases CsP \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> ?Y" using `b  \<sharp> bn \<alpha>`
          proof(induct rule: resCases)
            case(cOpen M xvec yvec y N P')
have "b \<sharp> (xvec @ yvec)" using `b \<sharp> bn (M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>N\<rangle>)`
              by simp
            have "(xvec @ yvec) \<sharp>* M" using `xvec \<sharp>* M` `yvec \<sharp>* M`
              by simp
            have "distinct(xvec @ yvec)" using `distinct xvec` `distinct yvec` `xvec \<sharp>* yvec`
              by simp
            have bin: "b \<in> supp([(b,y)] \<bullet> N)" using `y \<in> supp(N)`
              apply(subst perm_bool[symmetric,where pi="[(b,y)]"])
              by(simp add: eqvts at_swap_simps[OF at_name_inst])
            note cOpen(1)
            moreover have "(xvec @ yvec) \<sharp>* \<Psi>" using `xvec \<sharp>* \<Psi>` using `yvec \<sharp>* \<Psi>`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle>" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* M" using `xvec \<sharp>* M` `yvec \<sharp>* M`
              by simp
            ultimately show ?case using bin
            proof(induct rule: parOutputCases[where C="(a,b)"])
              case (cPar1 P''' A\<^isub>Q \<Psi>\<^isub>Q)
              have "(xvec @ yvec) \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
                by simp
              have "(xvec @ yvec) \<sharp>* (\<Psi> \<otimes> \<Psi>\<^isub>Q)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>` `(xvec @ yvec) \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>` `(xvec @ yvec) \<sharp>* \<Psi>`
                by(simp add: freshCompChain)
              from cPar1(1) `(xvec @ yvec) \<sharp>* (\<Psi> \<otimes> \<Psi>\<^isub>Q)` `(xvec @ yvec) \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)` `(xvec @ yvec) \<sharp>* M`
              show ?case
              proof(induct rule: invOutputCases)
                case(cInv P'' Q'')
                have psiqdef: "\<Psi>\<^isub>Q = ([(a, b)] \<bullet> \<Psi>\<^isub>c)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                  by simp
                have "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  unfolding psiqdef[symmetric]
                  by fact
                hence "(\<exists>\<phi>' P. (\<phi>', P) mem CsP \<and> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or> \<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  by(rule EntMem')
                moreover have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<Longrightarrow> False"
                proof -
                  assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  hence "(supp(([(a, b)] \<bullet> M\<^isub>a))::name set) \<subseteq> supp \<Psi>"
                    apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
                    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
                    by(simp add: eqvts EntSupp)
                  moreover note `b \<sharp> \<Psi>` `\<not>(b \<sharp> ([(a, b)] \<bullet> M\<^isub>a))`
                  ultimately show False
                    unfolding fresh_def
                    by auto
                qed
                ultimately have "(\<exists>\<phi>' P. (\<phi>', P) mem CsP \<and> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c )"
                  by auto
                then obtain \<phi>' R where Rmem: "(\<phi>', R) mem CsP" and Rent: "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> R \<bottom>\<^sub>c"
                  by auto
                from Rent have "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>Case \<box> ([(a, b)] \<bullet> \<phi>') \<Rightarrow> ([(a, b)] \<bullet> R) \<bottom>\<^sub>c"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                hence p''d: "P'' = Case \<box> \<phi>' \<Rightarrow> R \<bottom>\<^sub>c"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    apply(subst eqvts)
                    apply(subst eqvts)
                    apply(subst eqvts)
                    by(subst Inj[symmetric])
                have "b \<sharp> P''" using `(\<phi>',R) mem CsP` `b \<sharp> CsP`
                  unfolding p''d
                  by(induct CsP) auto
                moreover have "b \<sharp> xvec" and "b \<sharp> yvec" using `b \<sharp> bn (M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>N\<rangle>)`
                  by simp+
                ultimately have "b \<sharp> ([(b, y)] \<bullet> N)" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> Q''` `xvec \<sharp>* M` `yvec \<sharp>* M` `distinct (xvec @ yvec)`
                  apply -
                  by(rule outputFreshDerivative) (simp)+
                moreover have "b \<in> supp([(b, y)] \<bullet> N)" using `y \<in> supp(N)`
                  apply(subst perm_bool[symmetric,where pi="[(b,y)]"])
                  by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                ultimately have False
                  unfolding fresh_def
                  by simp
                thus ?case by(rule FalseE)
              qed
            next
              case (cPar2 Q'  A\<^isub>P \<Psi>\<^isub>P)
              from cPar2(1) have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            qed
          next
            case(cRes P')
            note `\<Psi> \<rhd> \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> \<alpha> \<prec> P'` `bn \<alpha> \<sharp>* \<Psi>`
            moreover have "bn \<alpha> \<sharp>* \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle>" and "bn \<alpha> \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>" using `bn \<alpha> \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp+
            moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
            ultimately show ?case
            proof(induct rule: parCases[where C="(a,b)"])
              case (cPar1 P''' A\<^isub>Q \<Psi>\<^isub>Q)
              from cPar1(1) show ?case
              proof(induct rule: invCases)
                case(cInv P'' Q'')
                have psiqdef: "\<Psi>\<^isub>Q = ([(a, b)] \<bullet> \<Psi>\<^isub>c)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                  by simp
                have "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  unfolding psiqdef[symmetric]
                  by fact
                hence "(\<exists>\<phi>' P. (\<phi>', P) mem CsP \<and> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or> \<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  by(rule EntMem')
                moreover have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<Longrightarrow> False"
                proof -
                  assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                  hence "(supp(([(a, b)] \<bullet> M\<^isub>a))::name set) \<subseteq> supp \<Psi>"
                    apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
                    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
                    by(simp add: eqvts EntSupp)
                  moreover note `b \<sharp> \<Psi>` `\<not>(b \<sharp> ([(a, b)] \<bullet> M\<^isub>a))`
                  ultimately show False
                    unfolding fresh_def
                    by auto
                qed
                ultimately have "(\<exists>\<phi>' P. (\<phi>', P) mem CsP \<and> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c )"
                  by auto
                then obtain \<phi>' R where Rmem: "(\<phi>', R) mem CsP" and Rent: "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Case \<box> \<phi>' \<Rightarrow> R \<bottom>\<^sub>c"
                  by auto
                from Rent have "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>Case \<box> ([(a, b)] \<bullet> \<phi>') \<Rightarrow> ([(a, b)] \<bullet> R) \<bottom>\<^sub>c"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                hence p''eq: "P'' = Case \<box> \<phi>' \<Rightarrow> R \<bottom>\<^sub>c"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    apply(subst eqvts)
                    apply(subst eqvts)
                    apply(subst eqvts)
                    by(subst Inj[symmetric])
                have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> R \<longmapsto> \<alpha> \<prec> Q''" and "\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi>'" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> \<alpha> \<prec> Q''`
                  unfolding p''eq psiCases.simps[symmetric]
                proof(induct rule: caseCases)
                  case(cCase \<phi>'' R')
                  from `(\<phi>'', R') mem [(\<phi>', R)]` have "\<phi>'' = \<phi>'" and "R' = R"
                    by simp+
                  thus "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> R \<longmapsto> \<alpha> \<prec> Q''" and "\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi>'" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> R' \<longmapsto> \<alpha> \<prec> Q''` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi>''`
                    by simp+
                qed
                moreover have feq: "\<And>F. (F \<otimes>\<^sub>F (\<langle>\<epsilon>, \<Psi>\<rangle>)) \<simeq>\<^sub>F F \<otimes>\<^sub>F (\<langle>[b], \<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>)"
                  apply(subst mergeFrameSimps'[symmetric])
                  apply(simp add: `b \<sharp> \<Psi>`)
                  apply(rule FrameStatEqSym)
                  apply(rule FrameStatEqTrans[OF frameAssociativity])
                  by fact
                moreover have "b \<sharp> R" and "b \<sharp> \<phi>'" using Rmem `b \<sharp> CsP`
                  by(induct CsP) (auto)
                ultimately have "\<Psi> \<rhd> R \<longmapsto> \<alpha> \<prec> Q''" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` `b \<sharp> \<alpha>`
                  unfolding psiqdef
                  apply -
                  by(rule frameStatEqTransition'[where A="[b]"]) (simp+)
                moreover have "\<Psi> \<turnstile> \<phi>'"
                proof -
                  have "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi>'" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi>'`
                    unfolding psiqdef
                    by simp
                  have "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<simeq>\<^sub>F (\<langle>\<epsilon>, \<Psi>\<rangle>) \<otimes>\<^sub>F \<langle>[b],([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>"
                    by(rule FrameStatEqSym[OF Equiv1'])
                  hence "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<simeq>\<^sub>F \<langle>[b],\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>"
                    apply(subst mergeFrameSimps'[symmetric])
                    by(simp add: `b \<sharp> \<Psi>`)
                  moreover have "(\<langle>[b], \<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) \<turnstile>\<^sub>F \<phi>'" using `\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi>'` `b \<sharp> \<phi>'`
                    apply -
                    apply(rule frameImpI)
                    apply(rule refl)
                    by simp+
                  ultimately have "(\<langle>\<epsilon>,\<Psi>\<rangle>) \<turnstile>\<^sub>F \<phi>'"
                    apply -
                    apply(rule frameStatEqEnt)
                    by(rule FrameStatEqSym)
                  thus ?thesis
                    apply -
                    apply(rule frameImpE[where A\<^isub>F="[]"])
                    by simp+
                qed
                moreover have "guarded R" using `(\<phi>', R) mem CsP`
                  by(simp add: MemEnt)
                moreover have "\<not> clauseDom \<phi>'" using cInv
                  unfolding p''eq psiCases.simps[symmetric]
                  by(induct rule: caseCases) auto
                ultimately have "\<Psi> \<rhd> Cases CsP \<longmapsto> \<alpha> \<prec> Q''" using `(\<phi>', R) mem CsP`
                  by(rule_tac Case)
                moreover have "\<Psi> \<rhd> Q'' \<sim> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                proof -
                  have "b \<sharp> Q''"
                    apply(rule freeFreshDerivative[OF `\<Psi> \<rhd> R \<longmapsto> \<alpha> \<prec> Q''`])
                    by fact+
                  hence se: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) \<sim> Q'' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>"
                    by(rule bisimScopeExt)
                  show ?thesis
                    apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
                    apply(rule bisimTransitive[OF bisimParComm])
                    apply(rule bisimSymmetric)
                    apply(rule bisimTransitive[OF se])
                    apply(rule bisimTransitive[OF bisimParComm])
                    apply(rule bisimParPres)
                    by fact
                qed
                ultimately show ?case
                  by blast
              qed
            next
              case(cPar2 Q' A\<^isub>P \<Psi>\<^isub>P)
              from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> \<alpha> \<prec> Q'` have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            next
              case(cComm1 \<Psi>\<^isub>Q M N P' A\<^isub>P \<Psi>\<^isub>P K xvec Q' A\<^isub>Q)
              from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` have False 
                by(rule nilTrans)
              thus ?case by(rule FalseE)
            next
              case(cComm2 \<Psi>\<^isub>Q M xvec N P' A\<^isub>P \<Psi>\<^isub>P K Q' A\<^isub>Q)
              from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> K\<lparr>N\<rparr> \<prec> Q'` have False
                by(rule nilTrans)
              thus ?case by(rule FalseE)
            qed
          qed
        qed
        thus ?case
          unfolding sdef tdef
          by assumption
      qed
    qed
  }
  note Goal = this
  obtain b::name where "b \<sharp> CsP" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c"
    apply(rule at_exists_fresh[where x="(CsP,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c)", OF at_name_inst])
    apply(finite_guess)
    by force
  have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
    apply(subst alphaRes[where y=b])
    apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
    by(rule refl)
  hence adef: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
    by(simp only: eqvts)
  note `b \<sharp> \<Psi>`
  moreover note `b \<sharp> CsP`
  moreover have "((supp CsP)::name set) \<subseteq> supp([(a,b)]\<bullet>M\<^isub>a)" using `supp CsP \<subseteq> supp M\<^isub>a`
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts `a \<sharp> CsP` `b \<sharp> CsP`)
  moreover have "((supp ([(a,b)]\<bullet>\<Psi>\<^isub>c))::name set) = supp([(a,b)]\<bullet>M\<^isub>a)" using `supp \<Psi>\<^isub>c = supp M\<^isub>a`
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts)
  moreover have "\<forall> \<Psi> \<phi> P. ((\<phi>, P) mem CsP \<longrightarrow> (guarded P \<and> \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))" using MemEnt
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
  moreover have "\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> (\<exists> \<phi>' P. (\<phi>', P) mem CsP \<and> \<phi> = ([(a,b)]\<bullet>M\<^isub>a) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c) \<or> \<Psi> \<turnstile> \<phi>)" using EntMem
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts `b \<sharp> \<Psi>` `a \<sharp> CsP` `b \<sharp> CsP`)
  moreover have "\<forall> F. F \<otimes>\<^sub>F \<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F" using Equiv1
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
  moreover have "\<not>(b \<sharp> ([(a,b)]\<bullet>M\<^isub>a))" using `\<not>(a \<sharp> M\<^isub>a)`
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
  moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
  proof -
    fix P and P'
    show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
      apply(rule iffI)
      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
      apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
      apply(force simp add: eqvts Inj)
      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
      apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
      apply(force simp add: eqvts Inj)
      done
  qed
  moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
  proof -
    fix \<Psi> and P
    assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
    thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
      apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
      apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
      by(simp add: eqvts EntSupp)
  qed
  ultimately show ?thesis unfolding adef
    apply -
    by(rule Goal) (assumption|simp)+
qed
end
end