theory hosum
  imports sum bisimStructCong bisimPres
begin

context env
begin

lemma insertAssertionMerge: "insertAssertion F \<Psi> = (\<langle>\<epsilon>, \<Psi>\<rangle>) \<otimes>\<^sub>F F"
apply(nominal_induct F avoiding: \<Psi> rule: frame.strong_induct)
by simp+

lemma frameBottomExpand: "\<bottom>\<^sub>F = \<langle>[],\<one>\<rangle>"
  by simp

lemma mergeFrameSimps'[simp]:
  fixes A\<^isub>F :: "name list"
  and   \<Psi>\<^isub>F :: 'b
  and   \<Psi>  :: 'b

  assumes "A\<^isub>F \<sharp>* \<Psi>"

  shows "(\<langle>\<epsilon>, \<Psi>\<rangle>) \<otimes>\<^sub>F \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>= \<langle>A\<^isub>F, \<Psi> \<otimes> \<Psi>\<^isub>F\<rangle>"
using assms
by(induct A\<^isub>F arbitrary: F) auto

lemma clauseClosed':
  fixes \<Psi> :: 'b
  and   M :: 'a
  and   P :: "('a,'b,'c) psi"
  and   p :: "name prm"
 
  shows "\<Psi> \<turnstile> M \<Leftarrow> P = (p \<bullet> \<Psi>) \<turnstile> (p \<bullet> M) \<Leftarrow> (p \<bullet> P)"
apply(rule_tac t = "\<Psi> \<turnstile> M \<Leftarrow> P" and pi1 = p in subst[OF perm_bool])
by(simp add: eqvts)

lemma extractFrameNilClosed:
  fixes p :: "name prm"
  shows "(extractFrame P = \<bottom>\<^sub>F)= (extractFrame (p \<bullet> P) = \<bottom>\<^sub>F)"
  apply(rule iffI)
  apply(subst perm_bool[where pi="rev p",symmetric], simp add: eqvts)
  apply(subst (asm) perm_bool[where pi="rev p",symmetric], simp add: eqvts)
  done

lemma sjuimp7a:
  assumes a: "\<And> \<Psi>. insertAssertion (\<langle>[a], \<Psi>\<^isub>a\<rangle>) \<Psi> \<simeq>\<^sub>F (\<langle>\<epsilon>,\<Psi>\<rangle>)"
  shows "\<And> F. F \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>a\<rangle>) \<simeq>\<^sub>F F"
proof -
  fix F::"'b frame"
  obtain A\<^isub>F \<Psi>\<^isub>F where "F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "a \<sharp> A\<^isub>F" and "A\<^isub>F \<sharp>* \<Psi>\<^isub>a" and "A\<^isub>F \<sharp>* F"
    by(rule_tac freshFrame[where C="(a,\<Psi>\<^isub>a,F)" and F=F]) auto
  obtain b::name where "b\<noteq>a" and "b \<sharp> F" "b \<sharp> a" "b \<sharp> \<Psi>\<^isub>a" "b \<sharp> A\<^isub>F" "b \<sharp> \<Psi>\<^isub>F"
    by(generate_fresh "name") auto
  hence abeq: "(\<langle>[a], \<Psi>\<^isub>a\<rangle>) = (\<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>a)\<rangle>)"
    by(subst frameChainAlpha[where p="[(a,b)]"]) (auto simp add: eqvts calc_atm)
  have "A\<^isub>F \<sharp>* ([(a,b)]\<bullet>\<Psi>\<^isub>a)" using `A\<^isub>F \<sharp>* \<Psi>\<^isub>a` `b \<sharp> A\<^isub>F` `a \<sharp> A\<^isub>F`
    by(subst perm_bool[where pi="[(a,b)]",symmetric]) (simp add: eqvts)
  have "insertAssertion (\<langle>[a], \<Psi>\<^isub>a\<rangle>) \<Psi>\<^isub>F \<simeq>\<^sub>F (\<langle>\<epsilon>,\<Psi>\<^isub>F\<rangle>)"
    by fact
  hence "insertAssertion (\<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>a)\<rangle>) \<Psi>\<^isub>F \<simeq>\<^sub>F (\<langle>\<epsilon>,\<Psi>\<^isub>F\<rangle>)"
    by(subst (asm) abeq)
  hence "\<lparr>\<nu>*A\<^isub>F\<rparr>(insertAssertion (\<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>a)\<rangle>) \<Psi>\<^isub>F) \<simeq>\<^sub>F \<lparr>\<nu>*A\<^isub>F\<rparr>(\<langle>\<epsilon>,\<Psi>\<^isub>F\<rangle>)"
    by(rule frameResChainPres)
  obtain B where "B = [b]"
    by auto
  hence "A\<^isub>F \<sharp>* B" "B \<sharp>* \<Psi>\<^isub>F" using `b \<sharp> A\<^isub>F` `b \<sharp> \<Psi>\<^isub>F`
    by auto
  have "F \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>a\<rangle>) \<simeq>\<^sub>F \<lparr>\<nu>*A\<^isub>F\<rparr>(insertAssertion (\<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>a)\<rangle>) \<Psi>\<^isub>F)"
    unfolding `F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` abeq `B = [b]`[symmetric] using `B \<sharp>* \<Psi>\<^isub>F` `A\<^isub>F \<sharp>* ([(a,b)]\<bullet>\<Psi>\<^isub>a)` `A\<^isub>F \<sharp>* B`
    by(auto simp add: frameChainAppend)
  with `\<lparr>\<nu>*A\<^isub>F\<rparr>(insertAssertion (\<langle>[b], ([(a,b)]\<bullet>\<Psi>\<^isub>a)\<rangle>) \<Psi>\<^isub>F) \<simeq>\<^sub>F \<lparr>\<nu>*A\<^isub>F\<rparr>(\<langle>\<epsilon>,\<Psi>\<^isub>F\<rangle>)`
  show "F \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>a\<rangle>) \<simeq>\<^sub>F F"
    unfolding `F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
    by(auto intro: FrameStatEqTrans)
qed  

lemma hosum:
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   P  :: "('a, 'b::fs_name, 'c::fs_name) psi"
  and   Q  :: "('a, 'b, 'c) psi"
  and   R  :: "('a, 'b, 'c) psi"
  and   \<Psi>\<^isub>c :: 'b
  and   \<Psi>  :: 'b
  and   \<phi>  :: 'c
  assumes "a \<sharp> P"
  and     "a \<sharp> Q"
  and     "guarded P"
  and     "guarded Q"
  and     "((supp P)::name set) \<subseteq> supp M\<^isub>a"
  and     "((supp Q)::name set) \<subseteq> supp M\<^isub>a"
  and     "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a"
  and     "\<And> \<Psi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P)"
  and     "\<And> \<Psi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q)"
  and     "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))"
  and     Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  and     "\<And> \<Psi>. \<Psi> \<turnstile> \<phi>"
  and     "\<not> clauseDom \<phi>"
  and     Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))"
  and     EntSupp: "\<And> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set))"
  shows "\<Psi> \<rhd> (P \<oplus>\<^sub>\<phi> Q) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
proof -
  {
    fix a::name and M\<^isub>a::'a and \<Psi>\<^isub>c::'b
    assume "a \<sharp> P"
      and     "a \<sharp> Q"
      and     "a \<sharp> \<Psi>"
      and     "a \<sharp> \<phi>"
      and     "((supp P)::name set) \<subseteq> supp M\<^isub>a"
      and     "((supp Q)::name set) \<subseteq> supp M\<^isub>a"
      and     "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a"
      and     "guarded P"
      and     "guarded Q"
      and     "\<And> \<Psi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P)"
      and     "\<And> \<Psi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q)"
      and     Equiv1: "\<And>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F"
      and     Equiv2: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))"
      and     "\<not>(a \<sharp> M\<^isub>a)"
      and     "\<And> \<Psi>. \<Psi> \<turnstile> \<phi>"
      and     "\<not> clauseDom \<phi>"
      and     Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))"
      and     EntSupp: "\<And> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set))"
    let ?X1 = "{((\<Psi>::'b), (\<lparr>\<nu>(a::name)\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)), (P \<oplus>\<^sub>\<phi> Q)) | \<Psi> a P Q  M\<^isub>a \<Psi>\<^isub>c \<phi>. a \<sharp> P \<and> a \<sharp> Q \<and> a \<sharp> \<Psi> \<and> a \<sharp> \<phi> \<and> guarded P \<and> guarded Q \<and> (((supp P)::name set) \<subseteq> supp M\<^isub>a) \<and> (((supp Q)::name set) \<subseteq> supp M\<^isub>a) \<and> (((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a) \<and> (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P) \<and> (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q) \<and> (\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))) \<and> (\<forall>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)) \<and> \<not>(a \<sharp> M\<^isub>a) \<and> (\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>) \<and> (\<not> clauseDom \<phi>) \<and> (\<forall> P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')) \<and> (\<forall> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set)))}"
    let ?X2 = "{((\<Psi>::'b), (P \<oplus>\<^sub>\<phi> Q), (\<lparr>\<nu>(a::name)\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) | \<Psi> a P Q  M\<^isub>a \<Psi>\<^isub>c \<phi>. a \<sharp> P \<and> a \<sharp> Q \<and> a \<sharp> \<Psi> \<and> a \<sharp> \<phi> \<and> guarded P \<and> guarded Q \<and> (((supp P)::name set) \<subseteq> supp M\<^isub>a) \<and> (((supp Q)::name set) \<subseteq> supp M\<^isub>a) \<and> (((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a) \<and> (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P) \<and> (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q) \<and> (\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))) \<and> (\<forall>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)) \<and> \<not>(a \<sharp> M\<^isub>a) \<and> (\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>) \<and> (\<not> clauseDom \<phi>) \<and> (\<forall> P P'. (M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P')) \<and> (\<forall> \<Psi> P. (\<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> (supp M\<^isub>a) \<subseteq> ((supp \<Psi>)::name set)))}"
    let ?X = "?X1 \<union> ?X2"
    from `a \<sharp> \<Psi>` `a \<sharp> P` `a \<sharp> Q` `a \<sharp> \<phi>` `\<not>(a \<sharp> M\<^isub>a)` `((supp P)::name set) \<subseteq> supp M\<^isub>a` `((supp Q)::name set) \<subseteq> supp M\<^isub>a` `((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a` `\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P` `\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q` Equiv1 Equiv2 `guarded P`  `guarded Q` `\<And> \<Psi>. \<Psi> \<turnstile> \<phi>` Inj EntSupp `\<not> clauseDom \<phi>` have "(\<Psi>, (P \<oplus>\<^sub>\<phi> Q), \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<in> ?X2"
      by blast
    hence "(\<Psi>, (P \<oplus>\<^sub>\<phi> Q), \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<in> ?X"
      by(rule UnI2)
    moreover have "eqvt ?X"
    proof -
      have supp_subset_closed: "\<And> (A::('d::fs_name)) (B::('e::fs_name)) (p::name prm). (supp A::name set) \<subseteq> supp B = ((supp (p\<bullet>A)::name set) \<subseteq> supp (p\<bullet>B))"
      proof -
        fix A::"'d::fs_name"
        and B::"'e::fs_name"
        and p::"name prm"
        show "(supp A::name set) \<subseteq> supp B = ((supp (p\<bullet>A)::name set) \<subseteq> supp (p\<bullet>B))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric, where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric, where pi="p"])
          by(simp add: eqvts)
      qed
      have supp_eq_closed: "\<And> (A::('d::fs_name)) (B::('e::fs_name)) (p::name prm). ((supp A::name set) = supp B) = (((supp (p\<bullet>A)::name set) = supp (p\<bullet>B)))"
      proof -
        fix A::"'d::fs_name"
        and B::"'e::fs_name"
        and p::"name prm"
        show "(supp A::name set) = supp B = ((supp (p\<bullet>A)::name set) = supp (p\<bullet>B))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric, where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric, where pi="p"])
          by(simp add: eqvts)
      qed
      have eqvt_lol: "\<And> (p::name prm) \<Psi>\<^isub>c a. ((\<forall>F. F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F) = (\<forall>F. (F \<otimes>\<^sub>F \<langle>[(p\<bullet>a)], (p\<bullet>\<Psi>\<^isub>c)\<rangle> \<simeq>\<^sub>F F)))"
        apply(rule_tac pi1="rev p" and t = "(\<forall>F. assertionAux.FrameStatEq SImp'
              (assertionAux.mergeFrame op \<otimes> F (\<langle>[p \<bullet> a], p \<bullet> \<Psi>\<^isub>c\<rangle>))
              F)" in subst[OF perm_bool])
        by(simp add: eqvts)
      have eqvt_lol':
        "\<And> (p::name prm) \<Psi>\<^isub>c ab.
        (\<forall>F. assertionAux.FrameStatEq SImp'
             (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu> ab \<rparr> \<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) F)=
        (\<forall>F. assertionAux.FrameStatEq SImp'
        (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu>p \<bullet> ab \<rparr> \<langle>\<epsilon>, p \<bullet> \<Psi>\<^isub>c\<rangle>)) F)"
        apply(rule_tac pi1="rev p" and t = "(\<forall>F. assertionAux.FrameStatEq SImp'
          (assertionAux.mergeFrame op \<otimes> F (\<lparr>\<nu>p \<bullet> ab\<rparr> \<langle>\<epsilon>, p \<bullet> \<Psi>\<^isub>c\<rangle>)) F)" in subst[OF perm_bool])
        by(simp add: eqvts)
      have eqvt_lol'': "\<And> \<Psi>\<^isub>c M\<^isub>a P (p::name prm).
        (\<forall>\<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P)
        =
        (\<forall>\<Psi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> P))"
      proof -
        fix p::"name prm"
        and \<Psi>\<^isub>c 
        and M\<^isub>a
        and P
        show "(\<forall>\<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P)= (\<forall>\<Psi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> P))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric,where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric,where pi="p"])
          by(simp add: eqvts)
      qed
      have eqvt_lol''': "\<And> \<phi> (p::name prm). (\<forall>\<Psi>. \<Psi> \<turnstile> \<phi>) = (\<forall>\<Psi>. \<Psi> \<turnstile> (p \<bullet> \<phi>))"
      proof -
        fix \<phi>
        and p::"name prm"
        show "(\<forall>\<Psi>. \<Psi> \<turnstile> \<phi>) = (\<forall>\<Psi>. \<Psi> \<turnstile> (p \<bullet> \<phi>))"
          apply(rule iffI)
          apply(subst perm_bool[symmetric,where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric,where pi="p"])
          by(simp add: eqvts)
      qed
      have eqvt_lol'''': "\<And> \<Psi>\<^isub>c M\<^isub>a P Q (p::name prm).
        (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow>
                 \<phi> = M\<^isub>a\<Leftarrow>P \<or> \<phi> = M\<^isub>a\<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>)
        =
        (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow>
                 \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> P) \<or> \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> Q) \<or> \<Psi> \<turnstile> \<phi>)"
      proof -
        fix \<Psi>\<^isub>c M\<^isub>a P Q
          and p::"name prm"
        show "(\<forall>\<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow>
               \<phi> = M\<^isub>a\<Leftarrow>P \<or> \<phi> = M\<^isub>a\<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>)
              =
              (\<forall>\<Psi> \<phi>. \<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow>
               \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> P) \<or> \<phi> = (p \<bullet> M\<^isub>a)\<Leftarrow>(p \<bullet> Q) \<or> \<Psi> \<turnstile> \<phi>)"
          apply(rule iffI)
          apply(subst perm_bool[symmetric,where pi="rev p"])
          apply(simp add: eqvts)
          apply(subst perm_bool[symmetric,where pi="p"])
          by(simp add: eqvts)
      qed
      have "eqvt_lol'''''": "\<And> M\<^isub>a (p::name prm).
        (\<forall>P P'. (M\<^isub>a\<Leftarrow>P = (M\<^isub>a)\<Leftarrow>P') = (P = P'))
        =
        (\<forall>P P'. ((p \<bullet> M\<^isub>a)\<Leftarrow>P = (p \<bullet> M\<^isub>a)\<Leftarrow>P') = (P = P'))"
      proof -
        fix M\<^isub>a
        and p::"name prm"
        show "(\<forall>P P'. (M\<^isub>a\<Leftarrow>P = (M\<^isub>a)\<Leftarrow>P') = (P = P')) = (\<forall>P P'. ((p \<bullet> M\<^isub>a)\<Leftarrow>P = (p \<bullet> M\<^isub>a)\<Leftarrow>P') = (P = P'))"
          apply(rule iffI)
          apply(subst (asm) perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric])
          by(simp add: eqvts)
      qed
      have "eqvt_lol''''''": "\<And> M\<^isub>a (p::name prm).
        (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P) \<longrightarrow> supp (M\<^isub>a) \<subseteq> (supp \<Psi>::name set))
        =
        (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>P) \<longrightarrow> supp (p \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set))"
      proof -
        fix M\<^isub>a
        and p::"name prm"
        show "(\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P) \<longrightarrow> supp (M\<^isub>a) \<subseteq> (supp \<Psi>::name set)) = (\<forall>\<Psi>. (\<exists>P. \<Psi> \<turnstile> (p \<bullet> M\<^isub>a)\<Leftarrow>P) \<longrightarrow> supp (p \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set))"
          apply(rule iffI)
          apply(subst (asm) perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          done
      qed
      {
        fix p::"name prm"
          and \<phi>
        have "(\<not> clauseDom (\<phi>)) = (\<not> clauseDom (p \<bullet> \<phi>))"
          apply(rule iffI)
          apply(subst (asm) perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric])
          apply(simp add: eqvts)
          done
      }
      note eqvt_lol''''''' = this
      show ?thesis
      apply(rule eqvtUnion)
      apply(auto simp add: eqvt_def eqvts)
      apply(rule_tac x = "p\<bullet>ab" in exI)
      apply(rule_tac x = "p\<bullet>P" in exI,
        rule_tac x = "p\<bullet>Q" in exI,
        rule_tac x = "p\<bullet>M\<^isub>a" in exI,
        rule_tac x = "p\<bullet>\<Psi>\<^isub>c" in exI)
      apply(rule conjI)
      apply(rule refl)
      apply(rule_tac x = "p\<bullet>\<phi>" in exI)
      apply(simp add: pt_fresh_bij[OF pt_name_inst, OF at_name_inst] pt_fresh_star_bij[OF pt_name_inst, OF at_name_inst] clauseClosed'[symmetric] eqvt_lol'[symmetric] extractFrameNilClosed[symmetric] supp_subset_closed[symmetric] supp_eq_closed[symmetric] eqvt_lol''[symmetric] eqvt_lol'''[symmetric] eqvt_lol''''[symmetric] eqvt_lol'''''[symmetric] eqvt_lol''''''[symmetric] eqvt_lol'''''''[symmetric])
      apply(
        rule_tac x = "p\<bullet>ab" in exI,
        rule_tac x = "p\<bullet>P" in exI,
        rule_tac x = "p\<bullet>Q" in exI,
        rule_tac x = "p\<bullet>M\<^isub>a" in exI,
        rule_tac x = "p\<bullet>\<Psi>\<^isub>c" in exI,
        rule_tac x = "p\<bullet>\<phi>" in exI)
      apply(simp add: pt_fresh_bij[OF pt_name_inst, OF at_name_inst] pt_fresh_star_bij[OF pt_name_inst, OF at_name_inst] clauseClosed'[symmetric] eqvt_lol'[symmetric] extractFrameNilClosed[symmetric] supp_subset_closed[symmetric] supp_eq_closed[symmetric] eqvt_lol''[symmetric] eqvt_lol'''[symmetric] eqvt_lol''''[symmetric] eqvt_lol'''''[symmetric] eqvt_lol''''''[symmetric] eqvt_lol'''''''[symmetric])
      done
  qed
    ultimately have "\<Psi> \<rhd> (P \<oplus>\<^sub>\<phi> Q) \<sim> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
    proof(coinduct rule: bisimCoinduct)
      case(cStatEq \<Psi> S T)
      show ?case
      proof(case_tac "(\<Psi>, S, T) \<in> ?X1")
	assume "(\<Psi>, S, T) \<in> ?X1"
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where sdef: "S = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "\<not> a \<sharp> M\<^isub>a" and "(\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P)" and "(\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q)" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have Equiv1: "\<And>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" using Equiv1
          apply -
          by(drule allE)
        have Equiv2: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))" using Equiv2
          by simp
        have frameCoding: "extractFrame(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) = \<langle>[a], \<one> \<otimes> \<Psi>\<^isub>c\<rangle>"
          by simp
        have frameCoding': "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F \<langle>\<epsilon>, \<Psi>\<rangle>"
          apply(subst extractFrameSimps)
          apply(subst frameCoding)
          apply(subst extractFrameSimps)
          apply(subst mergeFrameSimps')
          apply(simp add: `a \<sharp> \<Psi>`)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameIntAssociativity])
          apply(rule FrameStatEqTrans[OF frameIntCommutativity])
          apply(subst mergeFrameSimps[symmetric])         
          apply(rule freshCompChain)
          apply(simp add: `a \<sharp> \<Psi>`)
          apply simp
          apply(rule FrameStatEqTrans[OF frameCommutativity])
          apply(rule FrameStatEqTrans[OF Equiv1])
          apply(subst frameNilStatEq)
          by(rule Identity)
        have frameCodingStatEq: "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F insertAssertion (extractFrame (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<Psi>"
          by simp
        show ?case
          unfolding sdef tdef
          apply -
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameCodingStatEq])
          apply(rule FrameStatEqTrans[OF frameCoding'])
          unfolding extractFrameSimps insertAssertion.simps frameNilStatEq
          by(rule AssertionStatEqSym[OF Identity])
      next
        assume  "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using cStatEq
          by blast
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where tdef: "T = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "\<not> a \<sharp> M\<^isub>a" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have Equiv1: "\<And>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" using Equiv1
          apply -
          by(drule allE)
        have Equiv2: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))" using Equiv2
          by simp
        have frameCoding: "extractFrame(\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) = \<langle>[a], \<one> \<otimes> \<Psi>\<^isub>c\<rangle>"
          by simp
        have frameCoding': "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F \<langle>\<epsilon>, \<Psi>\<rangle>"
          apply(subst extractFrameSimps)
          apply(subst frameCoding)
          apply(subst extractFrameSimps)
          apply(subst mergeFrameSimps')
          apply(simp add: `a \<sharp> \<Psi>`)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameIntAssociativity])
          apply(rule FrameStatEqTrans[OF frameIntCommutativity])
          apply(subst mergeFrameSimps[symmetric])         
          apply(rule freshCompChain)
          apply(simp add: `a \<sharp> \<Psi>`)
          apply simp
          apply(rule FrameStatEqTrans[OF frameCommutativity])
          apply(rule FrameStatEqTrans[OF Equiv1])
          apply(subst frameNilStatEq)
          by(rule Identity)
        have frameCodingStatEq: "extractFrame(\<lbrace>\<Psi>\<rbrace> \<parallel> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<simeq>\<^sub>F insertAssertion (extractFrame (\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))) \<Psi>"
          by simp
        show ?case
          unfolding sdef tdef
          apply -
          apply(rule FrameStatEqSym)
          apply(rule FrameStatEqTrans)
          apply(rule FrameStatEqSym[OF frameCodingStatEq])
          apply(rule FrameStatEqTrans[OF frameCoding'])
          unfolding extractFrameSimps insertAssertion.simps frameNilStatEq
          by(rule AssertionStatEqSym[OF Identity])
      qed
    next
      case (cSym \<Psi> R S)
      thus ?case
        by blast
    next
      case (cExt \<Psi> S T \<Psi>')
      show ?case
      proof(case_tac "(\<Psi>, S, T) \<in> ?X1")
        assume "(\<Psi>, S, T) \<in> ?X1"
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where sdef: "S = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "a \<sharp> \<phi>" and "\<not> a \<sharp> M\<^isub>a" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        obtain b::name where "b \<sharp> P" and "b \<sharp> Q" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<Psi>'" and "b \<sharp> \<phi>"
          apply(rule at_exists_fresh[where x="(P,Q,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<Psi>',\<phi>)", OF at_name_inst])
          apply(finite_guess)
          by force
        have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
          apply(subst alphaRes[where y=b])
          apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
          by(rule refl)
        have s_def: "S = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
          unfolding sdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
          by simp
        have "b \<sharp> \<Psi> \<otimes> \<Psi>'"
          by(rule freshComp[OF `b \<sharp> \<Psi>`, OF  `b \<sharp> \<Psi>'`])
        moreover note `b \<sharp> P` `b \<sharp> Q` `guarded P` `guarded Q` `b \<sharp> \<phi>` `\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>`
        moreover have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`            
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
        moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>Q" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "\<forall>F. (F \<otimes>\<^sub>F (\<langle>[b],[(a,b)]\<bullet>\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F)"
          using Equiv1
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<forall> \<Psi> \<phi>. \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> \<phi> = ([(a,b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> \<phi> = ([(a,b)] \<bullet> M\<^isub>a) \<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>"
          using Equiv2
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst] `a \<sharp> P` `b \<sharp> P` `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "((supp P)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp P \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
        moreover have "((supp Q)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp Q \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "((supp([(a,b)] \<bullet> \<Psi>\<^isub>c))::name set) = supp([(a,b)] \<bullet> M\<^isub>a)" using `(supp \<Psi>\<^isub>c) = supp M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts)
        moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
        proof -
          fix P and P'
          show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
            apply(rule iffI)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            done
        qed
        moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
        proof -
          fix \<Psi> and P
          assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
          thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
            apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
            apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
            by(simp add: eqvts EntSupp)
        qed
        moreover note `\<not> clauseDom \<phi>`
        ultimately show ?thesis
          unfolding s_def tdef
          by blast
      next
        assume "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using cExt by blast
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where tdef: "T = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "a \<sharp> \<phi>" and "\<not> a \<sharp> M\<^isub>a" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        obtain b::name where "b \<sharp> P" and "b \<sharp> Q" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<Psi>'" and "b \<sharp> \<phi>"
          apply(rule at_exists_fresh[where x="(P,Q,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<Psi>',\<phi>)", OF at_name_inst])
          apply(finite_guess)
          by force
        have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
          apply(subst alphaRes[where y=b])
          apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
          by(rule refl)
        have t_def: "T = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
          unfolding tdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
          by simp
        have "b \<sharp> \<Psi> \<otimes> \<Psi>'"
          by(rule freshComp[OF `b \<sharp> \<Psi>`, OF  `b \<sharp> \<Psi>'`])
        moreover note `b \<sharp> P` `b \<sharp> Q` `guarded P` `guarded Q`  `b \<sharp> \<phi>` `\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>`
        moreover have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
        moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>Q" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q`
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "\<forall>F. (F \<otimes>\<^sub>F (\<langle>[b],[(a,b)]\<bullet>\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F)"
          using Equiv1
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
        moreover have "\<forall> \<Psi> \<phi>. \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> \<phi> = ([(a,b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> \<phi> = ([(a,b)] \<bullet> M\<^isub>a) \<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>"
          using Equiv2
          apply(subst perm_bool[where pi="[(a,b)]", symmetric])
          by(simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst] `a \<sharp> P` `b \<sharp> P` `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "((supp P)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp P \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
        moreover have "((supp Q)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp Q \<subseteq> supp M\<^isub>a`
          apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
        moreover have "((supp([(a,b)] \<bullet> \<Psi>\<^isub>c))::name set) = supp([(a,b)] \<bullet> M\<^isub>a)" using `(supp \<Psi>\<^isub>c) = supp M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts)
        moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
        proof -
          fix P and P'
          show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
            apply(rule iffI)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            apply(subst perm_bool[where pi="[(a,b)]",symmetric])
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            apply(force simp add: eqvts Inj)
            done
        qed
        moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
        proof -
          fix \<Psi> and P
          assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
          thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
            apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
            apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
            by(simp add: eqvts EntSupp)
        qed
        moreover note `\<not> clauseDom \<phi>`
        ultimately show ?thesis
          unfolding sdef t_def
          by blast
      qed
    next
      case(cSim \<Psi> S T)
      let ?Y = "?X \<union> bisim"
      show ?case
      proof(cases "(\<Psi>,S,T) \<in> ?X1")
        assume "(\<Psi>,S,T) \<in> ?X1"
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where sdef: "S = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and tdef: "T = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "a \<sharp> \<phi>" and "\<not> a \<sharp> M\<^isub>a" and pent: "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" and qent: "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have Equiv1: "\<And>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" using Equiv1
          apply -
          by(drule allE)
        have Equiv2: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))" using Equiv2
          by simp
        have "eqvt(?Y)" using `eqvt ?X` bisimEqvt
          by(rule eqvtUnion)
        have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<leadsto>[?Y] (P \<oplus>\<^sub>\<phi> Q)"
        proof(rule simI[where C= "a", OF `eqvt(?Y)`])
          fix \<alpha> Q'
          assume "\<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<longmapsto> \<alpha> \<prec> Q'"
            and  "bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
            and  "bn \<alpha> \<sharp>* P \<oplus>\<^sub>\<phi> Q"
            and  "bn \<alpha> \<sharp>* \<Psi>"
            and  "distinct (bn \<alpha>)"
            and  "bn \<alpha> \<sharp>* subject \<alpha>"
            and  "bn \<alpha> \<sharp>* a"
          obtain b::name where "b \<sharp> P" and "b \<sharp> Q" "b \<sharp> Q'" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<phi>" "b \<sharp> \<alpha>" and "b \<sharp> bn \<alpha>"
            apply(rule at_exists_fresh[where x="(P,Q,Q',\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<phi>,\<alpha>,bn \<alpha>)", OF at_name_inst])
            apply(finite_guess)
            by force
          have res_def: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have res_def': "\<lparr>\<nu>a\<rparr>(Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> Q'` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have s_def: "S = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
            unfolding sdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
            by simp
          have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`            
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have pentp: "\<And> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
          have qentp: "\<And> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>Q" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
          have Equiv1': "\<And> F. (F \<otimes>\<^sub>F (\<langle>[b],[(a,b)]\<bullet>\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F)"
            using Equiv1
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have Equiv2': "\<forall> \<Psi> \<phi>. \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> \<phi> = ([(a,b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> \<phi> = ([(a,b)] \<bullet> M\<^isub>a) \<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>"
            using Equiv2
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst] `a \<sharp> P` `b \<sharp> P` `a \<sharp> Q` `b \<sharp> Q`)
          have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> \<zero>"
          proof -
            let ?C1 = "{(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>)| \<Psi>. True}"
            let ?C2 = "{(\<Psi>,\<zero>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>)| \<Psi>. True}"
            let ?C = "?C1 \<union> ?C2"
            have "(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>) \<in> ?C"
              by simp
            thus ?thesis
            proof(coinduct rule: bisimCoinduct)
              case(cStatEq \<Psi>' R S)
              thus ?case
              proof(cases "(\<Psi>',R,S) \<in> ?C1")
                assume "(\<Psi>',R,S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqSym)
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              next
                assume "(\<Psi>', R, S) \<notin> ?C1"
                hence "(\<Psi>', R, S) \<in> ?C2" using cStatEq
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              qed
            next
              case(cSim \<Psi> R S)
              show ?case
              proof(cases "(\<Psi>, R, S) \<in> ?C1")
                assume "(\<Psi>, R, S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: nilTrans)
              next
                assume "(\<Psi>, R, S) \<notin> ?C1"
                hence "(\<Psi>, R, S) \<in> ?C2" using cSim
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have falseness: "\<And> \<alpha> Q'.(\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<longmapsto> \<alpha> \<prec> Q' \<Longrightarrow> False)"
                  by(cases rule: semantics.cases) (auto simp add: psi.inject alpha')
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: falseness)
              qed
            next
              case(cExt \<Psi> R S \<Psi>')
              thus ?case by blast
            next
              case(cSym \<Psi> R S)
              thus ?case by blast
            qed
          qed
          note `\<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<longmapsto> \<alpha> \<prec> Q'`
          moreover have "\<Psi> \<turnstile> \<phi>" using `\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>` by(rule allE)
          ultimately show "\<exists> P'. \<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> ?Y"
          proof(induct rule: sumAssertCases)
            case cSum1
            have "bn \<alpha> \<sharp>* ([(a, b)] \<bullet> \<Psi>\<^isub>c)"
            proof -
              have subset: "supp([(a, b)] \<bullet> \<Psi>\<^isub>c) \<subseteq> ({a} \<union> {b} \<union> supp \<Psi>\<^isub>c)"
              proof -
                have "supp([(a, b)] \<bullet> \<Psi>\<^isub>c) \<subseteq> (supp([(a,b)]) \<union> (supp \<Psi>\<^isub>c::name set))"
                  by(rule permSupp)
                thus ?thesis
                  by(simp add: supp_list_cons supp_list_nil supp_prod supp_atm)
              qed
              have "bn \<alpha> \<sharp>* b" using `b \<sharp> bn \<alpha>`
                by simp
              have "({a} \<union> supp \<Psi>\<^isub>c) = supp \<Psi>\<^isub>c"
              proof -
                have "a \<in> supp M\<^isub>a" using `\<not> a \<sharp> M\<^isub>a`
                  by(simp add: fresh_def)
                thus ?thesis unfolding `supp \<Psi>\<^isub>c = supp M\<^isub>a`
                  by auto
              qed
              have "bn \<alpha> \<sharp>* \<Psi>\<^isub>c" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
                by simp
              have freshin: "bn \<alpha> \<sharp>* ({a} \<union> {b} \<union> supp \<Psi>\<^isub>c)" using `bn \<alpha> \<sharp>* a` `bn \<alpha> \<sharp>* b` `bn \<alpha> \<sharp>* \<Psi>\<^isub>c`
                apply(subst fresh_chain_fin_union)
                apply simp
                apply finite_guess
                apply(subst fresh_chain_fin_union)
                by(simp add: fresh_chain_singleton fresh_chain_supp)+
              show ?thesis
                apply(subst fresh_chain_supp[symmetric])
                apply(rule fresh_star_subset'[OF freshin, OF subset])
                apply auto
                apply finite_guess
                done
            qed
            have "bn \<alpha> \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)"
            proof -
              have subset: "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> ({a} \<union> {b} \<union> supp M\<^isub>a)"
              proof -
                have "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp([(a,b)]) \<union> (supp M\<^isub>a::name set))"
                  by(rule permSupp)
                thus ?thesis
                  by(simp add: supp_list_cons supp_list_nil supp_prod supp_atm)
              qed
              have "bn \<alpha> \<sharp>* b" using `b \<sharp> bn \<alpha>`
                by simp
              have "({a} \<union> supp M\<^isub>a) = supp M\<^isub>a"
              proof -
                have "a \<in> supp M\<^isub>a" using `\<not> a \<sharp> M\<^isub>a`
                  by(simp add: fresh_def)
                thus ?thesis
                  by auto
              qed
              have "bn \<alpha> \<sharp>* M\<^isub>a" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
                by simp
              have freshin: "bn \<alpha> \<sharp>* ({a} \<union> {b} \<union> supp M\<^isub>a)" using `bn \<alpha> \<sharp>* a` `bn \<alpha> \<sharp>* b` `bn \<alpha> \<sharp>* M\<^isub>a`
                apply(subst fresh_chain_fin_union)
                apply simp
                apply finite_guess
                apply(subst fresh_chain_fin_union)
                by(simp add: fresh_chain_singleton fresh_chain_supp)+
              show ?thesis
                apply(subst fresh_chain_supp[symmetric])
                apply(rule fresh_star_subset'[OF freshin, OF subset])
                apply auto
                apply finite_guess
                done
            qed
            have "bn \<alpha> \<sharp>* \<Psi>\<^isub>c" "bn \<alpha> \<sharp>* M\<^isub>a" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
              by simp+
            have feq: "(\<langle>[b], \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) = (\<langle>\<epsilon>,\<Psi>\<rangle>) \<otimes>\<^sub>F (\<langle>[b],[(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>)"
              apply(rule mergeFrameSimps'[symmetric])
              by(simp add: `b \<sharp> \<Psi>`)
            have "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<rhd> P \<longmapsto> \<alpha> \<prec> Q'"
              apply(rule frameStatEqTransition[where \<Psi>=\<Psi> and A="[b]"])
              apply fact+
              apply(subst feq)
              apply(rule FrameStatEqSym)
              apply(rule FrameStatEqTrans[OF frameAssociativity])
              apply fact
              apply(simp del: actionFresh actionFreshChain add: `b \<sharp> \<alpha>`)
              apply(simp add: `b \<sharp> P`)
              done
            have "((supp P)::name set) \<subseteq> supp ([(a, b)] \<bullet> M\<^isub>a)" using `supp P \<subseteq> supp M\<^isub>a`
              apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
              by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
            have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>([(a, b)] \<bullet> \<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
              apply(rule Scope)
              apply(simp only: eqvts)
              apply(rule cPar1[where A\<^isub>Q = "[]" and \<Psi>\<^isub>Q = "([(a,b)]\<bullet>\<Psi>\<^isub>c)"])
              apply(rule Inv[where P=P])
              apply(rule pentp)
              by(fact | simp add: add: `bn \<alpha> \<sharp>* ([(a, b)] \<bullet> \<Psi>\<^isub>c)` `bn \<alpha> \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)`)+
            have s1: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q' \<parallel> \<lparr>\<nu>b\<rparr>([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
              by(rule bisimScopeExt[OF `b \<sharp> Q'`])
            hence s2: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q' \<parallel> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
              apply(subst alphaRes[where x=a and y=b])
              by(simp add: `b \<sharp> \<Psi>\<^isub>c`)
            have s3: "\<Psi> \<rhd> Q' \<parallel> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> Q'"
              apply(rule bisimSymmetric)
              apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
              apply(rule bisimTransitive[OF bisimParComm])
              apply(rule bisimSymmetric)
              apply(rule bisimTransitive[OF bisimParComm])
              apply(rule bisimParPres)
              by fact
            have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q'"
              apply(rule bisimTransitive[OF s2])
              by(rule s3)
            moreover have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
              apply(subst alphaRes[where x=a and y=b])
              apply(simp add: `b \<sharp> \<Psi>\<^isub>c` `b \<sharp> M\<^isub>a`)
              by fact
            ultimately show ?case
              by blast
          next
            case cSum2
            have "bn \<alpha> \<sharp>* ([(a, b)] \<bullet> \<Psi>\<^isub>c)"
            proof -
              have subset: "supp([(a, b)] \<bullet> \<Psi>\<^isub>c) \<subseteq> ({a} \<union> {b} \<union> supp \<Psi>\<^isub>c)"
              proof -
                have "supp([(a, b)] \<bullet> \<Psi>\<^isub>c) \<subseteq> (supp([(a,b)]) \<union> (supp \<Psi>\<^isub>c::name set))"
                  by(rule permSupp)
                thus ?thesis
                  by(simp add: supp_list_cons supp_list_nil supp_prod supp_atm)
              qed
              have "bn \<alpha> \<sharp>* b" using `b \<sharp> bn \<alpha>`
                by simp
              have "({a} \<union> supp \<Psi>\<^isub>c) = supp \<Psi>\<^isub>c"
              proof -
                have "a \<in> supp M\<^isub>a" using `\<not> a \<sharp> M\<^isub>a`
                  by(simp add: fresh_def)
                thus ?thesis unfolding `supp \<Psi>\<^isub>c = supp M\<^isub>a`
                  by auto
              qed
              have "bn \<alpha> \<sharp>* \<Psi>\<^isub>c" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
                by simp
              have freshin: "bn \<alpha> \<sharp>* ({a} \<union> {b} \<union> supp \<Psi>\<^isub>c)" using `bn \<alpha> \<sharp>* a` `bn \<alpha> \<sharp>* b` `bn \<alpha> \<sharp>* \<Psi>\<^isub>c`
                apply(subst fresh_chain_fin_union)
                apply simp
                apply finite_guess
                apply(subst fresh_chain_fin_union)
                by(simp add: fresh_chain_singleton fresh_chain_supp)+
              show ?thesis
                apply(subst fresh_chain_supp[symmetric])
                apply(rule fresh_star_subset'[OF freshin, OF subset])
                apply auto
                apply finite_guess
                done
            qed
            have "bn \<alpha> \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)"
            proof -
              have subset: "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> ({a} \<union> {b} \<union> supp M\<^isub>a)"
              proof -
                have "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp([(a,b)]) \<union> (supp M\<^isub>a::name set))"
                  by(rule permSupp)
                thus ?thesis
                  by(simp add: supp_list_cons supp_list_nil supp_prod supp_atm)
              qed
              have "bn \<alpha> \<sharp>* b" using `b \<sharp> bn \<alpha>`
                by simp
              have "({a} \<union> supp M\<^isub>a) = supp M\<^isub>a"
              proof -
                have "a \<in> supp M\<^isub>a" using `\<not> a \<sharp> M\<^isub>a`
                  by(simp add: fresh_def)
                thus ?thesis
                  by auto
              qed
              have "bn \<alpha> \<sharp>* M\<^isub>a" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
                by simp
              have freshin: "bn \<alpha> \<sharp>* ({a} \<union> {b} \<union> supp M\<^isub>a)" using `bn \<alpha> \<sharp>* a` `bn \<alpha> \<sharp>* b` `bn \<alpha> \<sharp>* M\<^isub>a`
                apply(subst fresh_chain_fin_union)
                apply simp
                apply finite_guess
                apply(subst fresh_chain_fin_union)
                by(simp add: fresh_chain_singleton fresh_chain_supp)+
              show ?thesis
                apply(subst fresh_chain_supp[symmetric])
                apply(rule fresh_star_subset'[OF freshin, OF subset])
                apply auto
                apply finite_guess
                done
            qed
            have "bn \<alpha> \<sharp>* \<Psi>\<^isub>c" "bn \<alpha> \<sharp>* M\<^isub>a" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a`
              by simp+
            have feq: "(\<langle>[b], \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) = (\<langle>\<epsilon>,\<Psi>\<rangle>) \<otimes>\<^sub>F (\<langle>[b],[(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>)"
              apply(rule mergeFrameSimps'[symmetric])
              by(simp add: `b \<sharp> \<Psi>`)
            have "\<Psi> \<otimes> ([(a, b)] \<bullet> \<Psi>\<^isub>c) \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'"
              apply(rule frameStatEqTransition[where \<Psi>=\<Psi> and A="[b]"])
              apply fact+
              apply(subst feq)
              apply(rule FrameStatEqSym)
              apply(rule FrameStatEqTrans[OF frameAssociativity])
              apply fact
              apply(simp del: actionFresh actionFreshChain add: `b \<sharp> \<alpha>`)
              apply(simp add: `b \<sharp> Q`)
              done
            have "((supp Q)::name set) \<subseteq> supp ([(a, b)] \<bullet> M\<^isub>a)" using `supp Q \<subseteq> supp M\<^isub>a`
              apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
              by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
            have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>([(a, b)] \<bullet> \<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
              apply(rule Scope)
              apply(simp only: eqvts)
              apply(rule cPar1[where A\<^isub>Q = "[]" and \<Psi>\<^isub>Q = "([(a,b)]\<bullet>\<Psi>\<^isub>c)"])
              apply(rule Inv[where P=Q])
              apply(rule qentp)
              by(fact | simp add: add: `bn \<alpha> \<sharp>* ([(a, b)] \<bullet> \<Psi>\<^isub>c)` `bn \<alpha> \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)`)+
            have s1: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q' \<parallel> \<lparr>\<nu>b\<rparr>([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
              by(rule bisimScopeExt[OF `b \<sharp> Q'`])
            hence s2: "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q' \<parallel> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
              apply(subst alphaRes[where x=a and y=b])
              by(simp add: `b \<sharp> \<Psi>\<^isub>c`)
            have s3: "\<Psi> \<rhd> Q' \<parallel> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> Q'"
              apply(rule bisimSymmetric)
              apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
              apply(rule bisimTransitive[OF bisimParComm])
              apply(rule bisimSymmetric)
              apply(rule bisimTransitive[OF bisimParComm])
              apply(rule bisimParPres)
              by fact
            have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>)) \<sim> Q'"
              apply(rule bisimTransitive[OF s2])
              by(rule s3)
            moreover have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>b\<rparr>(Q' \<parallel> ([(a, b)] \<bullet> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
              apply(subst alphaRes[where x=a and y=b])
              apply(simp add: `b \<sharp> \<Psi>\<^isub>c` `b \<sharp> M\<^isub>a`)
              by fact
            ultimately show ?case
              by blast
          qed
        qed
        show ?case
          unfolding sdef tdef
          by fact
      next
        assume "(\<Psi>, S, T) \<notin> ?X1"
        hence "(\<Psi>, S, T) \<in> ?X2" using cSim by blast
        then obtain a P Q M\<^isub>a \<Psi>\<^isub>c \<phi> where tdef: "T = \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)" and sdef: "S = P \<oplus>\<^sub>\<phi> Q" and "a \<sharp> P" and "a \<sharp> Q" and "a \<sharp> \<Psi>" and "\<not> a \<sharp> M\<^isub>a" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>P" and "\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a\<Leftarrow>Q" and Equiv1: "\<forall> F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" and Equiv2: "(\<forall> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)))" and "guarded P" and "guarded Q" and "\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>" and "((supp P)::name set) \<subseteq> supp M\<^isub>a" and "((supp Q)::name set) \<subseteq> supp M\<^isub>a" and "((supp \<Psi>\<^isub>c)::name set) = supp M\<^isub>a" and Inj: "\<And> P P'. ((M\<^isub>a\<Leftarrow>P = M\<^isub>a\<Leftarrow>P') = (P = P'))" and EntSupp: "(\<forall>(\<Psi>\<Colon>'b\<Colon>fs_name) P\<Colon>('a\<Colon>fs_name, 'b\<Colon>fs_name, 'c\<Colon>fs_name) psi.
         \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set))" and "\<not> clauseDom \<phi>"
          by auto
        have EntSupp: "\<And> \<Psi> P. \<Psi> \<turnstile> M\<^isub>a\<Leftarrow>P \<Longrightarrow> supp M\<^isub>a \<subseteq> (supp \<Psi>::name set)" using EntSupp
          apply -
          apply(drule allE)
          apply(drule allE)
          by(rule mp)
        have Equiv1: "\<And>F. (F \<otimes>\<^sub>F \<langle>[a], \<Psi>\<^isub>c\<rangle> \<simeq>\<^sub>F F)" using Equiv1
          apply -
          by(drule allE)
        have Equiv2: "\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))" using Equiv2
          by simp
        have "eqvt(?Y)" using `eqvt ?X` bisimEqvt
          by(rule eqvtUnion)
        have "\<Psi> \<rhd> (P \<oplus>\<^sub>\<phi> Q) \<leadsto>[?Y] \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
        proof(rule simI[where C= "a", OF `eqvt(?Y)`])
          fix \<alpha> Q'
          assume "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) \<longmapsto> \<alpha> \<prec> Q'"
            and  "bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)"
            and  "bn \<alpha> \<sharp>* P \<oplus>\<^sub>\<phi> Q"
            and  "bn \<alpha> \<sharp>* \<Psi>"
            and  "distinct (bn \<alpha>)"
            and  "bn \<alpha> \<sharp>* subject \<alpha>"
            and  "bn \<alpha> \<sharp>* a"
          obtain b::name where "b \<sharp> P" and "b \<sharp> Q" "b \<sharp> Q'" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<phi>" "b \<sharp> \<alpha>" and "b \<sharp> bn \<alpha>"
            apply(rule at_exists_fresh[where x="(P,Q,Q',\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<phi>,\<alpha>,bn \<alpha>)", OF at_name_inst])
            apply(finite_guess)
            by force
          have res_def: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have res_def': "\<lparr>\<nu>a\<rparr>(Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (Q' \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
            apply(subst alphaRes[where y=b])
            apply(simp add: `b \<sharp> Q'` `b \<sharp> \<Psi>\<^isub>c`)
            by(rule refl)
          have t_def: "T = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)"
            unfolding tdef `\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))`
            by simp
          have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`            
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have pentp: "\<And> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
          have qentp: "\<And> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>Q" using `\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q`
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
          have "\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<sim> \<zero>"
          proof -
            let ?C1 = "{(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>)| \<Psi>. True}"
            let ?C2 = "{(\<Psi>,\<zero>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>)| \<Psi>. True}"
            let ?C = "?C1 \<union> ?C2"
            have "(\<Psi>,\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>,\<zero>) \<in> ?C"
              by simp
            thus ?thesis
            proof(coinduct rule: bisimCoinduct)
              case(cStatEq \<Psi>' R S)
              thus ?case
              proof(cases "(\<Psi>',R,S) \<in> ?C1")
                assume "(\<Psi>',R,S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqSym)
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              next
                assume "(\<Psi>', R, S) \<notin> ?C1"
                hence "(\<Psi>', R, S) \<in> ?C2" using cStatEq
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have reseq: "(\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<Psi>\<^isub>c\<rangle>)) = (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  by simp
                obtain b::name where "b \<sharp> \<Psi>'" and  "b \<sharp> \<Psi>\<^isub>c"
                  apply(rule at_exists_fresh[where x="(\<Psi>',\<Psi>\<^isub>c)", OF at_name_inst])
                  apply(finite_guess)
                  by force
                have "b = [(a,b)] \<bullet> a"
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                hence beq: "[b] = [(a,b)] \<bullet> [a]"
                  by simp
                have feq: "(\<langle>[a], \<Psi>\<^isub>c\<rangle>) = \<langle>[b], [(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>"
                  apply(subst beq)
                  apply(rule frameChainAlpha')
                  by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] `b \<sharp> \<Psi>\<^isub>c`)+
                have iaeq: "insertAssertion (\<langle>[a], \<Psi>\<^isub>c\<rangle>) \<Psi>' =  (\<langle>\<epsilon>,\<Psi>'\<rangle>) \<otimes>\<^sub>F (\<langle>[a], \<Psi>\<^isub>c\<rangle>)"
                  unfolding feq
                  apply(subst insertAssertionSimps)
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  apply(subst mergeFrameSimps')
                  apply(simp add: `b \<sharp> \<Psi>'`)
                  by(rule refl)
                show ?thesis
                  unfolding rdef sdef extractFrameSimps reseq iaeq insertAssertionSimps insertAssertion.simps
                  apply(rule FrameStatEqTrans)
                  apply(subst frameNilStatEq)
                  apply(rule Identity)
                  apply(rule FrameStatEqSym)
                  by(rule Equiv1)
              qed
            next
              case(cSim \<Psi> R S)
              show ?case
              proof(cases "(\<Psi>, R, S) \<in> ?C1")
                assume "(\<Psi>, R, S) \<in> ?C1"
                hence rdef: "R=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>" and sdef: "S=\<zero>"
                  by simp+
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: nilTrans)
              next
                assume "(\<Psi>, R, S) \<notin> ?C1"
                hence "(\<Psi>, R, S) \<in> ?C2" using cSim
                  by auto
                hence rdef: "R=\<zero>" and sdef: "S=\<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace>"
                  by simp+
                have falseness: "\<And> \<alpha> Q'.(\<Psi> \<rhd> \<lparr>\<nu>a\<rparr>\<lbrace>\<Psi>\<^isub>c\<rbrace> \<longmapsto> \<alpha> \<prec> Q' \<Longrightarrow> False)"
                  by(cases rule: semantics.cases) (auto simp add: psi.inject alpha')
                show ?thesis
                  unfolding simulation_def rdef sdef
                  by(auto dest: falseness)
              qed
            next
              case(cExt \<Psi> R S \<Psi>')
              thus ?case by blast
            next
              case(cSym \<Psi> R S)
              thus ?case by blast
            qed
          qed
          hence "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>\<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace> \<sim> \<zero>"
            apply -
            apply(subst (asm) alphaRes[where y=b])
            apply(simp add: `b \<sharp> \<Psi>\<^isub>c`)
            by(simp only: eqvts)
          have Equiv1': "\<And> F. (F \<otimes>\<^sub>F (\<langle>[b],[(a,b)]\<bullet>\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F)"
            using Equiv1
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
          have Equiv2': "\<forall> \<Psi> \<phi>. \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> \<phi> = ([(a,b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> \<phi> = ([(a,b)] \<bullet> M\<^isub>a) \<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>"
            using Equiv2
            apply(subst perm_bool[where pi="[(a,b)]", symmetric])
            by(simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst] `a \<sharp> P` `b \<sharp> P` `a \<sharp> Q` `b \<sharp> Q`)
          have "\<Psi> \<rhd> \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>) \<longmapsto> \<alpha> \<prec> Q'"
            apply(subst t_def[symmetric])
            apply(subst tdef)
            by fact
          moreover note `b \<sharp> \<Psi>` `b \<sharp> \<alpha>` `b \<sharp> Q'` `bn \<alpha> \<sharp>* \<Psi>`
          moreover have "bn \<alpha> \<sharp>* (\<langle>([(a,b)]\<bullet>M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)]\<bullet>\<Psi>\<^isub>c)\<rbrace>)" using `bn \<alpha> \<sharp>* \<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>)` `bn \<alpha> \<sharp>* a` `b \<sharp> bn \<alpha>`             
            by simp
          moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
          ultimately show "\<exists> P'. \<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> ?Y" using `b  \<sharp> bn \<alpha>`
          proof(induct rule: resCases)
            case(cOpen M xvec yvec y N P')
            have "b \<sharp> (xvec @ yvec)" using `b \<sharp> bn (M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>N\<rangle>)`
              by simp
            have "(xvec @ yvec) \<sharp>* M" using `xvec \<sharp>* M` `yvec \<sharp>* M`
              by simp
            have "distinct(xvec @ yvec)" using `distinct xvec` `distinct yvec` `xvec \<sharp>* yvec`
              by simp
            have bin: "b \<in> supp([(b,y)] \<bullet> N)" using `y \<in> supp(N)`
              apply(subst perm_bool[symmetric,where pi="[(b,y)]"])
              by(simp add: eqvts at_swap_simps[OF at_name_inst])
            note cOpen(1)
            moreover have "(xvec @ yvec) \<sharp>* \<Psi>" using `xvec \<sharp>* \<Psi>` using `yvec \<sharp>* \<Psi>`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle>" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp
            moreover have "(xvec @ yvec) \<sharp>* M" using `xvec \<sharp>* M` `yvec \<sharp>* M`
              by simp
            ultimately show ?case using bin
            proof(induct rule: parOutputCases[where C="(a,b)"])
              case (cPar1 P''' A\<^isub>Q \<Psi>\<^isub>Q)
              have "(xvec @ yvec) \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)" using `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
                by simp
              have "(xvec @ yvec) \<sharp>* (\<Psi> \<otimes> \<Psi>\<^isub>Q)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>` `(xvec @ yvec) \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>` `(xvec @ yvec) \<sharp>* \<Psi>`
                by(simp add: freshCompChain)
              from cPar1(1) `(xvec @ yvec) \<sharp>* (\<Psi> \<otimes> \<Psi>\<^isub>Q)` `(xvec @ yvec) \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)` `(xvec @ yvec) \<sharp>* M`
              show ?case
              proof(induct rule: invOutputCases)
                case(cInv P'' Q'')
                have psiqdef: "\<Psi>\<^isub>Q = ([(a, b)] \<bullet> \<Psi>\<^isub>c)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                  by simp
                have "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q"
                proof -
                  have "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q \<or> \<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''` Equiv2'
                    unfolding psiqdef
                    by(simp add: Equiv2')
                  moreover have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<Longrightarrow> False"
                  proof -
                    assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                    hence "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
                      apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
                      apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
                      by(simp add: eqvts EntSupp)
                    have "b \<in> supp([(a, b)] \<bullet> M\<^isub>a)" using `\<not> b \<sharp> ([(a, b)] \<bullet> M\<^isub>a)`
                      by(simp add: fresh_def)
                    hence "b \<in> (supp \<Psi>::name set)" using `supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set)`
                      by auto
                    moreover note `b \<sharp> \<Psi>`
                    ultimately show ?thesis
                      by(simp add: fresh_def)
                  qed
                  ultimately show ?thesis
                    by auto
                qed
                show ?case
                proof(cases "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P")
                  assume "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
                  hence "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P)"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                  hence p''def: "P'' = P"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    by(subst Inj[symmetric])
                  hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> Q''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> Q''`
                    by simp
                  hence "b \<sharp> ([(b, y)] \<bullet> N)" using `b \<sharp> P` `b \<sharp> (xvec@yvec)` `distinct(xvec @ yvec)` `(xvec @ yvec) \<sharp>* M`
                    apply -
                    by(rule outputFreshDerivative)
                  hence False using `b \<in> supp([(b, y)] \<bullet> N)`
                    by(simp add: fresh_def)
                  thus ?thesis by(rule FalseE)
                next
                  assume "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<noteq> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
                  hence "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q" using `([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q`
                    by simp
                  hence "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> Q)"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                  hence "P'' = Q"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    by(subst Inj[symmetric])
                  hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> Q \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> Q''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> Q''`
                    by simp
                  hence "b \<sharp> ([(b, y)] \<bullet> N)" using `b \<sharp> Q` `b \<sharp> (xvec@yvec)` `distinct(xvec @ yvec)` `(xvec @ yvec) \<sharp>* M`
                    apply -
                    by(rule outputFreshDerivative)
                  hence False using `b \<in> supp([(b, y)] \<bullet> N)`
                    by(simp add: fresh_def)
                  thus ?thesis by(rule FalseE)
                qed
              qed
            next
              case (cPar2 Q'  A\<^isub>P \<Psi>\<^isub>P)
              from cPar2(1) have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            qed
          next
            case(cRes P')
            note `\<Psi> \<rhd> \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> \<alpha> \<prec> P'` `bn \<alpha> \<sharp>* \<Psi>`
            moreover have "bn \<alpha> \<sharp>* \<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle>" and "bn \<alpha> \<sharp>* \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>" using `bn \<alpha> \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)`
              by simp+
            moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
            ultimately show ?case
            proof(induct rule: parCases[where C="(a,b)"])
              case (cPar1 P''' A\<^isub>Q \<Psi>\<^isub>Q)
              from cPar1(1) show ?case
              proof(induct rule: invCases)
                case(cInv P'' Q'')
                have psiqdef: "\<Psi>\<^isub>Q = ([(a, b)] \<bullet> \<Psi>\<^isub>c)" using `extractFrame (\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                  by simp
                have "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q"
                proof -
                  have "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q \<or> \<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''` Equiv2'
                    unfolding psiqdef
                    by(simp add: Equiv2')
                  moreover have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<Longrightarrow> False"
                  proof -
                    assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P''"
                    hence "supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
                      apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
                      apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
                      by(simp add: eqvts EntSupp)
                    have "b \<in> supp([(a, b)] \<bullet> M\<^isub>a)" using `\<not> b \<sharp> ([(a, b)] \<bullet> M\<^isub>a)`
                      by(simp add: fresh_def)
                    hence "b \<in> (supp \<Psi>::name set)" using `supp([(a, b)] \<bullet> M\<^isub>a) \<subseteq> (supp \<Psi>::name set)`
                      by auto
                    moreover note `b \<sharp> \<Psi>`
                    ultimately show ?thesis
                      by(simp add: fresh_def)
                  qed
                  ultimately show ?thesis
                    by auto
                qed
                show ?case
                proof(cases "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P")
                  assume "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
                  hence "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P)"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                  hence p''def: "P'' = P"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    by(subst Inj[symmetric])
                  have feq: "(\<langle>[b], \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) = (\<langle>\<epsilon>,\<Psi>\<rangle>) \<otimes>\<^sub>F (\<langle>[b],[(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>)"
                    apply(rule mergeFrameSimps'[symmetric])
                    by(simp add: `b \<sharp> \<Psi>`)
                  have trans: "\<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> Q''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> \<alpha> \<prec> Q''`
                    unfolding p''def psiqdef
                    apply(rule frameStatEqTransition'[where \<Psi>=\<Psi> and A="[b]"])
                    apply fact
                    apply fact
                    apply(subst feq)
                    apply(rule FrameStatEqSym)
                    apply(rule FrameStatEqTrans[OF frameAssociativity])
                    apply fact
                    apply(simp del: actionFresh actionFreshChain add: `b \<sharp> \<alpha>`)
                    apply(simp add: `b \<sharp> P`)
                    done
                  have "\<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<longmapsto> \<alpha> \<prec> Q''"
                    apply(rule SumAssert1)
                    by(fact|simp add: `\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>`)+
                  moreover have "\<Psi> \<rhd> Q'' \<sim> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                  proof -
                    have "b \<sharp> Q''"
                      apply(rule freeFreshDerivative[OF trans])
                      by fact+
                    hence s1: "\<Psi> \<rhd> (Q'' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) \<sim> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                      by(rule bisimSymmetric[OF bisimScopeExt])
                    have s2: "\<Psi> \<rhd> Q'' \<sim> (Q'' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                      apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
                      apply(rule bisimTransitive[OF bisimParComm])
                      apply(rule bisimSymmetric)
                      apply(rule bisimTransitive[OF bisimParComm])
                      apply(rule bisimParPres)
                      by fact
                    show ?thesis
                      apply(rule bisimSymmetric)
                      apply(rule bisimTransitive[OF bisimSymmetric[OF s1]])
                      by(rule bisimSymmetric[OF s2])
                  qed
                  ultimately show ?case by blast
                next
                  assume "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' \<noteq> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
                  hence "([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q" using `([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P'' = ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>Q`
                    by simp
                  hence "M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> P'') = M\<^isub>a\<Leftarrow>([(a, b)] \<bullet> Q)"
                    apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                    by(simp add: eqvts)
                  hence p''def: "P'' = Q"
                    apply(subst pt_bij[where pi="[(a,b)]",symmetric, OF pt_name_inst, OF at_name_inst])
                    by(subst Inj[symmetric])
                  have feq: "(\<langle>[b], \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rangle>) = (\<langle>\<epsilon>,\<Psi>\<rangle>) \<otimes>\<^sub>F (\<langle>[b],[(a,b)] \<bullet> \<Psi>\<^isub>c\<rangle>)"
                    apply(rule mergeFrameSimps'[symmetric])
                    by(simp add: `b \<sharp> \<Psi>`)
                  have trans: "\<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q''" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P'' \<longmapsto> \<alpha> \<prec> Q''`
                    unfolding p''def psiqdef
                    apply(rule frameStatEqTransition'[where \<Psi>=\<Psi> and A="[b]"])
                    apply fact
                    apply fact
                    apply(subst feq)
                    apply(rule FrameStatEqSym)
                    apply(rule FrameStatEqTrans[OF frameAssociativity])
                    apply fact
                    apply(simp del: actionFresh actionFreshChain add: `b \<sharp> \<alpha>`)
                    apply(simp add: `b \<sharp> Q`)
                    done
                  have "\<Psi> \<rhd> P \<oplus>\<^sub>\<phi> Q \<longmapsto> \<alpha> \<prec> Q''"
                    apply(rule SumAssert2)
                    by(fact|simp add: `\<forall> \<Psi>. \<Psi> \<turnstile> \<phi>`)+
                  moreover have "\<Psi> \<rhd> Q'' \<sim> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                  proof -
                    have "b \<sharp> Q''"
                      apply(rule freeFreshDerivative[OF trans])
                      by fact+
                    hence s1: "\<Psi> \<rhd> (Q'' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>) \<sim> \<lparr>\<nu>b\<rparr>(Q'' \<parallel> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                      by(rule bisimSymmetric[OF bisimScopeExt])
                    have s2: "\<Psi> \<rhd> Q'' \<sim> (Q'' \<parallel> \<lparr>\<nu>b\<rparr>\<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
                      apply(rule bisimTransitive[OF bisimSymmetric[OF bisimParNil]])
                      apply(rule bisimTransitive[OF bisimParComm])
                      apply(rule bisimSymmetric)
                      apply(rule bisimTransitive[OF bisimParComm])
                      apply(rule bisimParPres)
                      by fact
                    show ?thesis
                      apply(rule bisimSymmetric)
                      apply(rule bisimTransitive[OF bisimSymmetric[OF s1]])
                      by(rule bisimSymmetric[OF s2])
                  qed
                  ultimately show ?case by blast
                qed
              qed
            next
              case(cPar2 Q' A\<^isub>P \<Psi>\<^isub>P)
              from cPar2(1) have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            next
              case(cComm1 \<Psi>\<^isub>Q M' N P' A\<^isub>P \<Psi>\<^isub>P K xvec Q' A\<^isub>Q)
              from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'`
              have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            next
              case(cComm2 \<Psi>\<^isub>Q M' xvec N P' A\<^isub>P \<Psi>\<^isub>P K Q' A\<^isub>Q)
              from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lbrace>([(a, b)] \<bullet> \<Psi>\<^isub>c)\<rbrace> \<longmapsto> K\<lparr>N\<rparr> \<prec> Q'`
              have False by(rule nilTrans)
              thus ?case by(rule FalseE)
            qed
          qed
        qed
        show ?case
          unfolding sdef tdef
          by fact
      qed
    qed
  }
  note Goal = this
  obtain b::name where "b \<sharp> P" and "b \<sharp> Q" and "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" "b \<sharp> \<Psi>\<^isub>c" and "b \<sharp> \<phi>"
    apply(rule at_exists_fresh[where x="(P,Q,\<Psi>,M\<^isub>a,\<Psi>\<^isub>c,\<phi>)", OF at_name_inst])
    apply(finite_guess)
    by force
  have "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>([(a,b)] \<bullet> (\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>))"
    apply(subst alphaRes[where y=b])
    apply(simp add: `b \<sharp> M\<^isub>a` `b \<sharp> \<Psi>\<^isub>c`)
    by(rule refl)
  hence adef: "\<lparr>\<nu>a\<rparr>(\<langle>M\<^isub>a\<rangle> \<parallel> \<lbrace>\<Psi>\<^isub>c\<rbrace>) = \<lparr>\<nu>b\<rparr>(\<langle>([(a,b)] \<bullet> M\<^isub>a)\<rangle> \<parallel> \<lbrace>([(a,b)] \<bullet> \<Psi>\<^isub>c)\<rbrace>)"
    by(simp only: eqvts)
  note `b \<sharp> \<Psi>` `b \<sharp> \<phi>`
  moreover note `b \<sharp> P` `b \<sharp> Q` `guarded P` `guarded Q` `b \<sharp> \<phi>` `\<And> \<Psi>. \<Psi> \<turnstile> \<phi>`
  moreover have "\<not> b \<sharp> ([(a,b)] \<bullet> M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`            
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
  moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P" using `\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> P`
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
  moreover have "\<forall> \<Psi>. \<Psi> \<otimes> ([(a,b)]\<bullet>\<Psi>\<^isub>c) \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>Q" using `\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> M\<^isub>a \<Leftarrow> Q`
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
  moreover have "\<And>F. (F \<otimes>\<^sub>F (\<langle>[b],[(a,b)]\<bullet>\<Psi>\<^isub>c\<rangle>) \<simeq>\<^sub>F F)"
    using Equiv1
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(force simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst])
  moreover have "\<forall> \<Psi> \<phi>. \<Psi> \<otimes> ([(a,b)] \<bullet> \<Psi>\<^isub>c) \<turnstile> \<phi> \<longrightarrow> \<phi> = ([(a,b)] \<bullet> M\<^isub>a)\<Leftarrow>P \<or> \<phi> = ([(a,b)] \<bullet> M\<^isub>a) \<Leftarrow>Q \<or> \<Psi> \<turnstile> \<phi>"
    using `\<And> \<Psi> \<phi>. (\<Psi> \<otimes> \<Psi>\<^isub>c \<turnstile> \<phi> \<Longrightarrow> (\<phi> = M\<^isub>a \<Leftarrow> P \<or> \<phi> = M\<^isub>a \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>))`
    apply(subst perm_bool[where pi="[(a,b)]", symmetric])
    by(simp add: eqvts at2[OF at_name_inst] at3[OF at_name_inst] `a \<sharp> P` `b \<sharp> P` `a \<sharp> Q` `b \<sharp> Q`)
  moreover have "((supp P)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp P \<subseteq> supp M\<^isub>a`
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts `a \<sharp> P` `b \<sharp> P`)
  moreover have "((supp Q)::name set) \<subseteq> supp([(a,b)] \<bullet> M\<^isub>a)" using `supp Q \<subseteq> supp M\<^isub>a`
    apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
    by(simp add: eqvts `a \<sharp> Q` `b \<sharp> Q`)
  moreover have "((supp([(a,b)] \<bullet> \<Psi>\<^isub>c))::name set) = supp([(a,b)] \<bullet> M\<^isub>a)" using `(supp \<Psi>\<^isub>c) = supp M\<^isub>a`
    apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
    by(simp add: eqvts)
  moreover have "\<And> P P'. ((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
  proof -
    fix P and P'
    show "((([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P = ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P') = (P = P'))"
      apply(rule iffI)
      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
      apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
      apply(force simp add: eqvts Inj)
      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
      apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
      apply(force simp add: eqvts Inj)
      done
  qed
  moreover have "\<And> \<Psi> P. \<Psi> \<turnstile> ([(a,b)]\<bullet>M\<^isub>a)\<Leftarrow>P \<Longrightarrow> supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
  proof -
    fix \<Psi> and P
    assume "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a)\<Leftarrow>P"
    thus "supp ([(a,b)]\<bullet>M\<^isub>a) \<subseteq> (supp \<Psi>::name set)"
      apply(subst (asm) perm_bool[symmetric,where pi="[(a,b)]"])
      apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
      by(simp add: eqvts EntSupp)
  qed
  moreover note `\<not> clauseDom \<phi>`
  ultimately show ?thesis
    unfolding adef
    apply -
    by(rule Goal) (assumption | simp)+
qed

end


end