theory canon
  imports replication hobisimPres characteristic
begin

nominal_datatype ('term,'assertion,'condition) hoassert =
  FOA "'assertion::fs_name"
| HOA "('term::fs_name,'assertion,'condition::fs_name) hoclause" "('term,'assertion,'condition) hoassert"
and ('term,'assertion,'condition) hocond =
  FOC "'condition::fs_name"
| HOC "'term::fs_name" "('term,'assertion::fs_name,'condition) hopsi"
and ('term,'assertion,'condition) hoclauseres =
  CTrm "'term::fs_name" "('term,'assertion::fs_name,'condition::fs_name) hopsi"
| CBind "\<guillemotleft>name\<guillemotright>(('term,'assertion,'condition) hoclauseres)"
and ('term,'assertion,'condition) hoclause =
  Clause "'term::fs_name" "('term,'assertion::fs_name,'condition::fs_name) hoclauseres"
and ('term,'assertion,'condition) hopsi =
  HOPsiNil
| HOOutput "'term::fs_name" 'term "('term,'assertion::fs_name,'condition::fs_name) hopsi"
| HOInput 'term "('term,'assertion,'condition) hoinput"
| HOCase "('term,'assertion,'condition) hopsiCase"
| HOPar "('term,'assertion,'condition) hopsi" "('term,'assertion,'condition) hopsi"
| HORes "\<guillemotleft>name\<guillemotright>('term,'assertion,'condition) hopsi"
| HOAssert "('term,'assertion,'condition) hoassert"
| HOBang "('term, 'assertion, 'condition) hopsi"
| HOInvoke 'term
and ('term,'assertion,'condition) hoinput = 
  HOTrm 'term "(('term, 'assertion, 'condition) hopsi)"
| HOBind "\<guillemotleft>name\<guillemotright>(('term, 'assertion, 'condition) hoinput)"
and ('term,'assertion,'condition) hopsiCase =
  HOEmptyCase
| HOCond "('term,'assertion,'condition) hocond"
         "('term,'assertion,'condition) hopsi"
         "('term,'assertion,'condition) hopsiCase"

lemma hoassertInduct[consumes 0, case_names cFOA cHOA]:
  fixes \<Psi> :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoassert"
  and   P :: "'a::fs_name \<Rightarrow> ('term,'assertion,'condition) hoassert \<Rightarrow> bool"
  and   z :: "'a::fs_name"
  assumes "\<And> \<Psi>\<^isub>F z. P z (FOA \<Psi>\<^isub>F)"
  assumes "\<And> Cl \<Psi>\<^isub>H z. P z \<Psi>\<^isub>H \<Longrightarrow> P z (HOA Cl \<Psi>\<^isub>H)"
  shows "P z \<Psi>"
apply(rule_tac z=z in hoassert_hocond_hoclauseres_hoclause_hopsi_hoinput_hopsiCase.strong_inducts(1))
by(simp add: assms)+

lemma hocondInduct[consumes 0, case_names cFOC cHOC]:
  fixes \<phi> :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hocond"
  and   P :: "'a::fs_name \<Rightarrow> ('term,'assertion,'condition) hocond \<Rightarrow> bool"
  and   z :: "'a::fs_name"
  assumes "\<And> \<phi>\<^isub>F z. P z (FOC \<phi>\<^isub>F)"
  assumes "\<And> T Q z. P z (HOC T Q)"
  shows "P z \<phi>"
apply(rule_tac za=z in hoassert_hocond_hoclauseres_hoclause_hopsi_hoinput_hopsiCase.strong_inducts(2))
by(rule assms)+

lemma psiInduct[consumes 0, case_names PsiNil Output Input Case Par Res Assert Bang Invoke]:
  fixes P :: "'a::fs_name \<Rightarrow> ('term::fs_name,'assertion::fs_name,'condition::fs_name) psi \<Rightarrow> bool"
  and   z :: "'a::fs_name"
  and   Q :: "('term,'assertion,'condition) psi"
  assumes "\<And>z. P z (\<zero>)"
  and     "\<And>term1 term2 psi z. (\<And>z. P z psi) \<Longrightarrow> P z (term1\<langle>term2\<rangle>.psi)"
  and     "\<And>term input z. P z (term\<lparr>input)"
  and     "\<And>psiCase z. P z (Case psiCase)"
  and     " \<And>psi1 psi2 z.
              \<lbrakk>\<And>z. P z psi1; \<And>z. P z psi2\<rbrakk> \<Longrightarrow> P z (psi1 \<parallel> psi2)"
  and     "\<And>name psi z. \<lbrakk>name \<sharp> z; \<And>z. P z psi\<rbrakk> \<Longrightarrow> P z (\<lparr>\<nu>name\<rparr>psi)"
  and     "\<And>assertion z. P z (\<lbrace>assertion\<rbrace>)"
  and     "\<And>psi z. (\<And>z. P z psi) \<Longrightarrow> P z (!psi)"
  and     "\<And>term z. P z (\<langle>term\<rangle>)"
  shows   "P z Q"
apply(rule psi_input_psiCase.strong_inducts(1)[where z=z and psi=Q])
by(simp add: assms)+

fun hoassertJudge :: "'assertion::fs_name \<Rightarrow> ('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclause list \<Rightarrow> ('term,'assertion,'condition) hoassert" (*("(_,{_})" [80,80] 80)*)
where
  "hoassertJudge \<Psi> [] = FOA \<Psi>"
| "hoassertJudge \<Psi> (f#r) = HOA f (hoassertJudge \<Psi> r)"

lemma hoassertEqvt[eqvt]:
  fixes p :: "name prm"
  shows "p \<bullet> (hoassertJudge \<Psi> Cl) = hoassertJudge (p \<bullet> \<Psi>) (p \<bullet> Cl)"
by(induct \<Psi> Cl rule: hoassertJudge.induct, simp+)

nominal_primrec hoassertFOA :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoassert \<Rightarrow> 'assertion"
and hocondIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hocond \<Rightarrow> unit"
and hoclauseresIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclauseres \<Rightarrow> unit"
and hoclauseIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclause \<Rightarrow> unit"
and hopsiIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsi \<Rightarrow> unit"
and hoinputIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoinput \<Rightarrow> unit"
and hopsiCaseIgnore :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsiCase \<Rightarrow> unit"
where
  "hoassertFOA (FOA \<Psi>) = \<Psi>"
| "hoassertFOA (HOA C r) = hoassertFOA r"
| "hocondIgnore (FOC C) = ()"
| "hocondIgnore (HOC M P) = ()"
| "hoclauseresIgnore (CTrm M P) = ()"
| "hoclauseresIgnore (CBind y C) = ()"
| "hoclauseIgnore (Clause M C) = ()"
| "hopsiIgnore HOPsiNil = ()"
| "hopsiIgnore (HOOutput M N P) = ()"
| "hopsiIgnore (HOInput M I) = ()"
| "hopsiIgnore (HOCase C) = ()"
| "hopsiIgnore (HOPar P Q) = ()"
| "hopsiIgnore (HORes y P) = ()"
| "hopsiIgnore (HOAssert A) = ()"
| "hopsiIgnore (HOBang P) = ()"
| "hopsiIgnore (HOInvoke M) = ()"
| "hoinputIgnore (HOTrm M P) = ()"
| "hoinputIgnore (HOBind y I) = ()"
| "hopsiCaseIgnore HOEmptyCase = ()"
| "hopsiCaseIgnore (HOCond C P C') = ()"
apply(finite_guess)+
apply(rule TrueI)+
apply(assumption)+
apply(rule supports_fresh[of "supp({}::name set)"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: supp_set_empty,
      simp add: supp_set_empty)+
done

nominal_primrec hoassertHOA :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoassert \<Rightarrow> ('term,'assertion,'condition) hoclause list"
and hocondIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hocond \<Rightarrow> unit"
and hoclauseresIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclauseres \<Rightarrow> unit"
and hoclauseIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclause \<Rightarrow> unit"
and hopsiIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsi \<Rightarrow> unit"
and hoinputIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoinput \<Rightarrow> unit"
and hopsiCaseIgnore''' :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsiCase \<Rightarrow> unit"
where
  "hoassertHOA (FOA \<Psi>) = []"
| "hoassertHOA (HOA C r) = C#(hoassertHOA r)"
| "hocondIgnore''' (FOC C) = ()"
| "hocondIgnore''' (HOC M P) = ()"
| "hoclauseresIgnore''' (CTrm M P) = ()"
| "hoclauseresIgnore''' (CBind y C) = ()"
| "hoclauseIgnore''' (Clause M C) = ()"
| "hopsiIgnore''' HOPsiNil = ()"
| "hopsiIgnore''' (HOOutput M N P) = ()"
| "hopsiIgnore''' (HOInput M I) = ()"
| "hopsiIgnore''' (HOCase C) = ()"
| "hopsiIgnore''' (HOPar P Q) = ()"
| "hopsiIgnore''' (HORes y P) = ()"
| "hopsiIgnore''' (HOAssert A) = ()"
| "hopsiIgnore''' (HOBang P) = ()"
| "hopsiIgnore''' (HOInvoke M) = ()"
| "hoinputIgnore''' (HOTrm M P) = ()"
| "hoinputIgnore''' (HOBind y I) = ()"
| "hopsiCaseIgnore''' HOEmptyCase = ()"
| "hopsiCaseIgnore''' (HOCond C P C') = ()"
apply(finite_guess)+
apply(rule TrueI)+
apply(assumption)+
apply(rule supports_fresh[of "supp({}::name set)"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: supp_set_empty,
      simp add: supp_set_empty)+
done

(*nominal_primrec hoassertFOA :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoassert \<Rightarrow> ('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclause list"*)

lemma hoassertFOAHOAeqvt[eqvt]:
  fixes p :: "name prm"
  shows "p \<bullet> hoassertFOA \<Psi> = hoassertFOA (p \<bullet> \<Psi>)"
  and "p \<bullet> hoassertHOA \<Psi> = hoassertHOA (p \<bullet> \<Psi>)"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: eqvts)+

nominal_primrec injectPsi :: "('term::fs_name,('term, 'assertion::fs_name, 'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) psi \<Rightarrow> ('term,'assertion,'condition) hopsi" ("\<sigma> _" [80] 80)
and injectCase :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) psiCase \<Rightarrow> ('term,'assertion,'condition) hopsiCase"
and injectInput :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) input \<Rightarrow> ('term,'assertion,'condition) hoinput"
  where
  "injectPsi PsiNil = HOPsiNil"
| "injectPsi (Output M N P) = HOOutput M N (injectPsi P)"
| "injectPsi (Input M I) = HOInput M (injectInput I)"
| "injectPsi (Case C) = HOCase (injectCase C)"
| "injectPsi (Par P Q) = HOPar (injectPsi P) (injectPsi Q)"
| "injectPsi (Res y P) = HORes y (injectPsi P)"
| "injectPsi (Assert A) = HOAssert A"
| "injectPsi (Bang P) = HOBang (injectPsi P)"
| "injectPsi (Invoke M) = HOInvoke M"
| "injectInput (Trm M P) = HOTrm M (injectPsi P)"
| "injectInput (Bind x I) = HOBind x (injectInput I)"
| "injectCase EmptyCase = HOEmptyCase"
| "injectCase (Cond C P C') = HOCond C (injectPsi P) (injectCase C')"
apply(finite_guess)+
apply(rule TrueI)+
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(rule supports_fresh[of "supp({}::name set)"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: supp_set_empty,
      simp add: supp_set_empty)+
done

nominal_primrec hoassertIgnoreMi :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoassert \<Rightarrow> unit"
  and hocondIgnoreMi :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hocond \<Rightarrow> unit"
  and hoclauseresIgnoreMi :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclauseres \<Rightarrow> unit"
  and hoclauseIgnoreMi :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoclause \<Rightarrow> unit"
  and ejectPsi :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsi \<Rightarrow> ('term::fs_name,('term, 'assertion::fs_name, 'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) psi" ("\<sigma>\<^isup>-\<^isup>1 _" [80] 80)
  and ejectCase :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hopsiCase \<Rightarrow> ('term::fs_name,('term, 'assertion::fs_name, 'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and ejectInput :: "('term::fs_name,'assertion::fs_name,'condition::fs_name) hoinput \<Rightarrow> ('term::fs_name,('term, 'assertion::fs_name, 'condition::fs_name) hoassert,('term,'assertion,'condition) hocond) input"
  where
  "hoassertIgnoreMi (FOA \<Psi>) = ()"
| "hoassertIgnoreMi (HOA C r) = ()"
| "hocondIgnoreMi (FOC C) = ()"
| "hocondIgnoreMi (HOC M P) = ()"
| "hoclauseresIgnoreMi (CTrm M P) = ()"
| "hoclauseresIgnoreMi (CBind y C) = ()"
| "hoclauseIgnoreMi (Clause M C) = ()"
| "ejectPsi HOPsiNil = PsiNil"
| "ejectPsi (HOOutput M N P) = Output M N (ejectPsi P)"
| "ejectPsi (HOInput M I) = Input M (ejectInput I)"
| "ejectPsi (HOCase C) = Case (ejectCase C)"
| "ejectPsi (HOPar P Q) = Par (ejectPsi P) (ejectPsi Q)"
| "ejectPsi (HORes y P) = Res y (ejectPsi P)"
| "ejectPsi (HOAssert A) = Assert A"
| "ejectPsi (HOBang P) = Bang (ejectPsi P)"
| "ejectPsi (HOInvoke M) = Invoke M"
| "ejectInput (HOTrm M P) = Trm M (ejectPsi P)"
| "ejectInput (HOBind x I) = Bind x (ejectInput I)"
| "ejectCase HOEmptyCase = EmptyCase"
| "ejectCase (HOCond C P C') = Cond C (ejectPsi P) (ejectCase C')"
apply(finite_guess)+
apply(rule TrueI)+
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(rule supports_fresh[of "supp({}::name set)"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: supp_set_empty,
      simp add: supp_set_empty)+
done

lemma injectPsiInverse:
  fixes P :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert, ('term,'assertion,'condition) hocond) psi"
  and   C :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and   I :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) input"
  shows "\<sigma>\<^isup>-\<^isup>1(\<sigma> P) = P"
  and   "ejectInput(injectInput I) = I"
  and   "ejectCase(injectCase C) = C"
by(nominal_induct P and I and C rule: psi_input_psiCase.strong_inducts) simp+

lemma injectPsiInjective:
  shows "inj injectPsi"
by(rule inj_on_inverseI[where g=ejectPsi]) (simp add: injectPsiInverse)

lemma injectPsiPresEq:
  shows "(\<sigma> P = \<sigma> P') = (P = P')"
by(rule inj_on_iff[OF injectPsiInjective]) simp+

lemma injectEqvts[eqvt] :
  fixes p :: "name prm"
  and   P :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert, ('term,'assertion,'condition) hocond) psi"
  and   C :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and   I :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) input"
  shows "(p \<bullet> injectPsi P) = injectPsi(p\<bullet>P)"
  and   "(p \<bullet> injectInput I) = injectInput (p\<bullet>I)"
  and   "(p \<bullet> injectCase C) = injectCase (p\<bullet>C)"
apply(nominal_induct P and I and C rule: psi_input_psiCase.strong_inducts)
by(simp add: eqvts)+

lemma injectFresh:
  fixes x :: name
  and   P :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert, ('term,'assertion,'condition) hocond) psi"
  and   C :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and   I :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) input"
  shows "(x \<sharp> injectPsi P) = x \<sharp> P"
  and   "(x \<sharp> injectInput I) = x \<sharp> I"
  and   "(x \<sharp> injectCase C) = x \<sharp> C"
apply(nominal_induct P and I and C avoiding: x rule: psi_input_psiCase.strong_inducts)
apply(simp add: psi.fresh abs_fresh)+
done

lemma injectFreshStar:
  fixes xvec :: "name list"
  and   P :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert, ('term,'assertion,'condition) hocond) psi"
  and   C :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and   I :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) input"
  shows "(xvec \<sharp>* injectPsi P) = xvec \<sharp>* P"
  and   "(xvec \<sharp>* injectInput I) = xvec \<sharp>* I"
  and   "(xvec \<sharp>* injectCase C) = xvec \<sharp>* C"
apply(induct xvec)
by(simp add: injectFresh)+

lemma injectSupp:
  fixes P :: "('term::fs_name,('term,'assertion::fs_name,'condition::fs_name) hoassert, ('term,'assertion,'condition) hocond) psi"
  and   C :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) psiCase"
  and   I :: "('term,('term,'assertion,'condition) hoassert,('term,'assertion,'condition) hocond) input"
  shows "supp(injectPsi P) = (supp P::name set)"
  and   "supp(injectInput I) = (supp I::name set)"
  and   "supp(injectCase C) = (supp C::name set)"
apply(nominal_induct P and I and C rule: psi_input_psiCase.strong_inducts)
apply(simp add: psi.supp hopsi.supp)+
apply(subst abs_fun_supp[OF pt_name_inst, OF at_name_inst])
apply(finite_guess)
apply(subst abs_fun_supp[OF pt_name_inst, OF at_name_inst])
apply(finite_guess)
apply simp
apply(simp add: psi.supp hopsi.supp hoinput.supp input.supp)+
apply(subst abs_fun_supp[OF pt_name_inst, OF at_name_inst])
apply(finite_guess)
apply(subst abs_fun_supp[OF pt_name_inst, OF at_name_inst])
apply(finite_guess)
apply simp
apply(simp add: psiCase.supp hopsiCase.supp)+
done

lemma hoassertFresh:
  fixes \<Psi> :: "'b::fs_name"
  and   \<Psi>\<^isub>H :: "('a::fs_name,'b,'c::fs_name) hoassert"
  and   C :: "('a,'b::fs_name,'c::fs_name) hoclause"
  and   xvec :: "name list"
  shows "xvec \<sharp>* FOA \<Psi> = (xvec \<sharp>* \<Psi>)"
  and   "xvec \<sharp>* HOA C \<Psi>\<^isub>H = (xvec \<sharp>* C \<and> xvec \<sharp>* \<Psi>\<^isub>H)"
by(auto simp add: fresh_star_def hoassert.fresh)

lemma hocondFresh:
  fixes \<phi> :: "'c::fs_name"
  and   M :: "'a::fs_name"
  and   P :: "('a,'b::fs_name,'c::fs_name) hopsi"
  and   xvec :: "name list"
  shows "xvec \<sharp>* FOC \<phi> = (xvec \<sharp>* \<phi>)"
  and   "xvec \<sharp>* HOC M P = (xvec \<sharp>* M \<and> xvec \<sharp>* P)"
by(auto simp add: fresh_star_def hocond.fresh)

lemma hoclauseresFresh:
  fixes A :: "'a::fs_name"
  and   P :: "('a,'b::fs_name,'c::fs_name) hopsi"
  and   B :: "('a,'b,'c) hoclauseres"
  and   n :: name
  and   xvec :: "name list"
  shows "xvec \<sharp>* CTrm A P = (xvec \<sharp>* A \<and> xvec \<sharp>* P)"
  and   "xvec \<sharp>* CBind n B = xvec \<sharp>* [n].B"
by(auto simp add: fresh_star_def hoclauseres.fresh)

lemma hoclauseFresh:
  fixes M :: "'a::fs_name"
  and   Cl :: "('a,'b::fs_name,'c::fs_name) hoclauseres"
  and   xvec :: "name list"
  shows "xvec \<sharp>* Clause M Cl = (xvec \<sharp>* M \<and> xvec \<sharp>* Cl)"
by(auto simp add: fresh_star_def hoclause.fresh)

lemma hopsiFresh:
  fixes xvec :: "name list"

  shows "xvec \<sharp>* HOOutput M N P = (xvec \<sharp>* M \<and> xvec \<sharp>* N \<and> xvec \<sharp>* P)"
  and   "xvec \<sharp>* HOInput M I = (xvec \<sharp>* M \<and> xvec \<sharp>* I)"
  and   "xvec \<sharp>* HOCase C = xvec \<sharp>* C"
  and   "xvec \<sharp>* HOPar P Q = (xvec \<sharp>* P \<and> xvec \<sharp>* Q)"
  and   "xvec \<sharp>* HORes x P = (xvec \<sharp>* [x].P)"
  and   "xvec \<sharp>* HOAssert \<Psi> = xvec \<sharp>* \<Psi>"
  and   "xvec \<sharp>* HOBang P = xvec \<sharp>* P"
  and   "xvec \<sharp>* HOInvoke M = xvec \<sharp>* M"
  and   "xvec \<sharp>* HOPsiNil"

  and   "xvec \<sharp>* HOTrm N P = (xvec \<sharp>* N \<and> xvec \<sharp>* P)"
  and   "xvec \<sharp>* HOBind x I = xvec \<sharp>* ([x].I)"

  and   "xvec \<sharp>* HOEmptyCase"
  and   "xvec \<sharp>* HOCond \<Phi> P C = (xvec \<sharp>* \<Phi> \<and> xvec \<sharp>* P \<and> xvec \<sharp>* C)"
by(auto simp add: fresh_star_def hopsi.fresh hoinput.fresh hopsiCase.fresh)

fun hoclauseChain :: "name list \<Rightarrow> 'a::fs_name \<Rightarrow> ('a, 'b::fs_name, 'c::fs_name) hopsi \<Rightarrow> ('a, 'b, 'c) hoclauseres"
where
  hoclauseChainbase: "hoclauseChain [] N P = CTrm N P"
|  hoclauseChainstep: "hoclauseChain (x#xs) N P = CBind x (hoclauseChain xs N P)"

abbreviation
  hoclauseChainJudge ("\<nu>*_\<rparr>_ \<Leftarrow> _" [80,80,80] 80) where "\<nu>*xvec\<rparr>N \<Leftarrow> P \<equiv> hoclauseChain xvec N P"

lemma hoclauseChainEqvt[eqvt]:
  fixes p    :: "name prm"
  and   xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"
  
  shows "p \<bullet> (hoclauseChain xvec N P) = hoclauseChain (p \<bullet> xvec) (p \<bullet> N) (p \<bullet> P)"
by(induct_tac xvec) auto

lemma hoclauseChainFresh: 
  fixes x    :: name
  and   xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  shows "x \<sharp> (hoclauseChain xvec N P) = (x \<in> set xvec \<or> (x \<sharp> N \<and> x \<sharp> P))"
by (induct xvec) (simp_all add: abs_fresh)

lemma inductHoclauseChainSimps[simp]:
  fixes xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  shows "xvec \<sharp>* (hoclauseChain xvec N P)"
by(induct xvec) (auto simp add: abs_fresh abs_fresh_star fresh_star_def)

lemma hoclauseChainFreshSet:
  fixes Xs   :: "name set"
  and   xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  shows "Xs \<sharp>* (hoclauseChain xvec N P) = (\<forall>x\<in>Xs. x \<in> set xvec \<or> (x \<sharp> N \<and> x \<sharp> P))"
by (simp add: fresh_star_def hoclauseChainFresh)

lemma hoclauseChainAlpha:
  fixes p  :: "name prm"
  and   Xs :: "name set"
  and   Ys :: "name set"

  assumes XsFreshP: "Xs \<sharp>* (hoclauseChain xvec N P)"
  and     YsFreshN: "Ys \<sharp>* N"
  and     YsFreshP: "Ys \<sharp>* P"
  and     S: "set p \<subseteq> Xs \<times> Ys"

  shows "(hoclauseChain xvec N P) = (hoclauseChain (p \<bullet> xvec) (p \<bullet> N) (p \<bullet> P))"
proof -
  note pt_name_inst at_name_inst XsFreshP S
  moreover from YsFreshN YsFreshP have "Ys \<sharp>* (hoclauseChain xvec N P)"
    by (simp add: hoclauseChainFreshSet) (simp add: fresh_star_def)
  ultimately have "(hoclauseChain xvec N P) = p \<bullet> (hoclauseChain xvec N P)"
    by (rule_tac pt_freshs_freshs [symmetric])
  then show ?thesis by(simp add: eqvts)
qed

lemma hoclauseChainAlpha':
  fixes p    :: "name prm"
  and   xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  assumes xvecFreshP: "(p \<bullet> xvec) \<sharp>* P"
  and     xvecFreshN: "(p \<bullet> xvec) \<sharp>* N"
  and     S: "set p \<subseteq> set xvec \<times> set (p \<bullet> xvec)"

  shows "(hoclauseChain xvec N P) = (hoclauseChain (p \<bullet> xvec) (p \<bullet> N) (p \<bullet> P))"
proof -
  note pt_name_inst at_name_inst S
  moreover have "set xvec \<sharp>* (hoclauseChain xvec N P)"
    by (simp add: hoclauseChainFreshSet)
  ultimately show ?thesis using xvecFreshN xvecFreshP 
    by(rule_tac hoclauseChainAlpha) (simp add: fresh_star_def)+
qed

lemma alphaHoclause:
  fixes x :: name
  and   C :: "('a::fs_name, 'b::fs_name, 'c::fs_name) hoclauseres"
  and   c :: name

  assumes A1: "c \<sharp> C"

  shows "CBind x C = CBind c([(x, c)] \<bullet> C)"
proof(cases "x = c")
  assume "x=c"
  thus ?thesis by simp
next
  assume "x \<noteq> c"
  with A1 show ?thesis
    by(perm_simp add: hoclauseres.inject alpha calc_atm fresh_left)
qed

lemma hoclauseChainLengthEq:
  fixes xvec :: "name list"
  and   yvec :: "name list"
  and   M    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  assumes "length xvec = length yvec"
  and     "xvec \<sharp>* yvec"
  and     "distinct yvec"
  and     "yvec \<sharp>* M"
  and     "yvec \<sharp>* P"

  obtains N Q where "hoclauseChain xvec M P = hoclauseChain yvec N Q"
proof -
  assume "\<And>N Q. hoclauseChain xvec M P = hoclauseChain yvec N Q \<Longrightarrow> thesis"
  moreover obtain n where "n = length xvec" by auto
  with assms have "\<exists>N Q. hoclauseChain xvec M P = hoclauseChain yvec N Q"
  proof(induct n arbitrary: xvec yvec M P)
    case 0
    thus ?case by auto
  next
    case(Suc n xvec yvec M P)
    from `Suc n = length xvec`
    obtain x xvec' where "xvec = x#xvec'" and "length xvec' = n"
      by(case_tac xvec) auto
    with `length xvec = length yvec`
    obtain y yvec' where "yvec = y#yvec'" by(case_tac yvec) auto
    from `yvec = y#yvec'` `xvec=x#xvec'` `xvec \<sharp>* yvec` `distinct yvec` `length xvec = length yvec` `yvec \<sharp>* M` `yvec \<sharp>* P`
    have "length xvec' = length yvec'" and "xvec' \<sharp>* yvec'" and "distinct yvec'" and "yvec' \<sharp>* M" and "yvec' \<sharp>* P"
      by simp+
    then obtain N Q where Eq: "hoclauseChain xvec' M P = hoclauseChain yvec' N Q" using `length xvec' = n`
      by(drule_tac Suc) auto
    moreover from `distinct yvec` `yvec = y#yvec'` have "y \<sharp> yvec'" by auto
    moreover from `xvec \<sharp>* yvec` `xvec = x#xvec'` `yvec=y#yvec'` have "x \<noteq> y" and "x \<sharp> yvec'"
      by auto
    moreover from `yvec \<sharp>* M` `yvec \<sharp>* P` `yvec = y#yvec'` have "y \<sharp> M" and "y \<sharp> P" by auto
    hence "y \<sharp> hoclauseChain xvec' M P" by(simp add: hoclauseChainFresh)
    with Eq have "y \<sharp> hoclauseChain yvec' N Q" by(simp add: hoclauseChainFresh)
    ultimately have "CBind x (hoclauseChain xvec' M P) = CBind y (hoclauseChain yvec' ([(x, y)] \<bullet> N) ([(x, y)] \<bullet> Q))"
      by(simp add: hoclauseres.inject alpha' eqvts name_swap)
    thus ?case using `xvec = x#xvec'` `yvec=y#yvec'` by force
  qed
  ultimately show ?thesis
    by blast
qed

lemma hoclauseChainEq:
  fixes xvec :: "name list"
  and   M    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"
  and   yvec :: "name list"
  and   N    :: 'a
  and   Q    :: "('a, 'b, 'c) hopsi"

  assumes "hoclauseChain xvec M P = hoclauseChain yvec N Q"
  and     "xvec \<sharp>* yvec"
  and     "distinct xvec"
  and     "distinct yvec"

  obtains p where "(set p) \<subseteq> (set xvec) \<times> set (p \<bullet> xvec)" and "distinctPerm p" and "yvec = p \<bullet> xvec" and "N = p \<bullet> M" and "Q = p \<bullet> P"
proof -
  assume "\<And>p. \<lbrakk>set p \<subseteq> set xvec \<times> set (p \<bullet> xvec); distinctPerm p; yvec = p \<bullet> xvec; N = p \<bullet> M; Q = p \<bullet> P\<rbrakk> \<Longrightarrow> thesis"
  moreover obtain n where "n = length xvec" by auto
  with assms have "\<exists>p. (set p) \<subseteq> (set xvec) \<times> set (yvec) \<and> distinctPerm p \<and>  yvec = p \<bullet> xvec \<and> N = p \<bullet> M \<and> Q = p \<bullet> P"
  proof(induct n arbitrary: xvec yvec M N P Q)
    case(0 xvec yvec M N P Q)
    have Eq: "hoclauseChain xvec M P = hoclauseChain yvec N Q" by fact
    from `0 = length xvec` have "xvec = []" by auto
    moreover with Eq have "yvec = []"
      by(case_tac yvec) auto
    ultimately show ?case using Eq
      by(simp add: hoclauseres.inject)
  next
    case(Suc n xvec yvec M N P Q)
    from `Suc n = length xvec`
    obtain x xvec' where "xvec = x#xvec'" and "length xvec' = n"
      by(case_tac xvec) auto
    from `hoclauseChain xvec M P = hoclauseChain yvec N Q` `xvec = x # xvec'`
    obtain y yvec' where "hoclauseChain (x#xvec') M P = hoclauseChain (y#yvec') N Q"
      and "yvec = y#yvec'"
      by(case_tac yvec) auto
    hence EQ: "CBind x (hoclauseChain xvec' M P) = CBind y (hoclauseChain yvec' N Q)"
      by simp
    from `xvec = x#xvec'` `yvec=y#yvec'` `xvec \<sharp>* yvec`
    have "x \<noteq> y" and "xvec' \<sharp>* yvec'" and "x \<sharp> yvec'" and "y \<sharp> xvec'"
      by(auto simp add: fresh_list_cons)
    from `distinct xvec` `distinct yvec` `xvec=x#xvec'` `yvec=y#yvec'` have "x \<sharp> xvec'" and "y \<sharp> yvec'" and "distinct xvec'" and "distinct yvec'"
      by simp+
    have IH: "\<And>xvec yvec M N P Q. \<lbrakk>hoclauseChain xvec (M::'a) (P::('a, 'b, 'c) hopsi) = hoclauseChain yvec (N::'a) (Q::('a, 'b, 'c) hopsi); xvec \<sharp>* yvec; distinct xvec; distinct yvec; n = length xvec\<rbrakk> \<Longrightarrow> \<exists>p. (set p) \<subseteq> (set xvec) \<times> (set yvec) \<and> distinctPerm p \<and>  yvec = p \<bullet> xvec \<and> N = p \<bullet> M \<and> Q = p \<bullet> P"
      by fact
    from EQ `x \<noteq> y`  `x \<sharp> yvec'` `y \<sharp> yvec'` have "hoclauseChain xvec' M P = hoclauseChain yvec' ([(x, y)] \<bullet> N) ([(x, y)] \<bullet> Q)"
      by(simp add: hoclauseres.inject alpha eqvts)
    with `xvec' \<sharp>* yvec'` `distinct xvec'` `distinct yvec'` `length xvec' = n` IH
    obtain p where S: "(set p) \<subseteq> (set xvec') \<times> (set yvec')" and "distinctPerm p" and "yvec' = p \<bullet> xvec'" and "([(x, y)] \<bullet> N) = p \<bullet> M" and "([(x, y)] \<bullet> Q) = p \<bullet> P"
      by metis
    from S have "set((x, y)#p) \<subseteq> set(x#xvec') \<times> set(y#yvec')" by auto
    moreover from `x \<sharp> xvec'` `x \<sharp> yvec'` `y \<sharp> xvec'` `y \<sharp> yvec'` S have "x \<sharp> p" and "y \<sharp> p"
      apply(induct p)
      by(auto simp add: fresh_list_nil fresh_list_cons fresh_prod name_list_supp) (auto simp add: fresh_def) 

    with S `distinctPerm p` `x \<noteq> y` have "distinctPerm((x, y)#p)" by auto
    moreover from `yvec' = p \<bullet> xvec'` `x \<sharp> p` `y \<sharp> p` `x \<sharp> xvec'` `y \<sharp> xvec'` have "(y#yvec') = ((x, y)#p) \<bullet> (x#xvec')"
      by(simp add: calc_atm freshChainSimps)
    moreover from `([(x, y)] \<bullet> N) = p \<bullet> M` have "([(x, y)] \<bullet> [(x, y)] \<bullet> N) = [(x, y)] \<bullet> p \<bullet> M"
      by(simp add: pt_bij)
    hence "N = ((x, y)#p) \<bullet> M" by simp
    moreover from `([(x, y)] \<bullet> Q) = p \<bullet> P` have "([(x, y)] \<bullet> [(x, y)] \<bullet> Q) = [(x, y)] \<bullet> p \<bullet> P"
      by(simp add: pt_bij)
    hence "Q = ((x, y)#p) \<bullet> P" by simp
    ultimately show ?case using `xvec=x#xvec'` `yvec=y#yvec'`
      by blast
  qed
  ultimately show ?thesis by blast
qed

lemma hoclauseChainEqLength:
  fixes xvec :: "name list"
  and   M    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"
  and   yvec :: "name list"
  and   N    :: 'a
  and   Q    :: "('a, 'b, 'c) hopsi"

  assumes "hoclauseChain xvec M P = hoclauseChain yvec N Q"

  shows "length xvec = length yvec"
proof -
  obtain n where "n = length xvec" by auto
  with assms show ?thesis
  proof(induct n arbitrary: xvec yvec M P N Q)
    case(0 xvec yvec M P N Q)
    from `0 = length xvec` have "xvec = []" by auto
    moreover with `hoclauseChain xvec M P = hoclauseChain yvec N Q` have "yvec = []"
      by(case_tac yvec) auto
    ultimately show ?case by simp
  next
    case(Suc n xvec yvec M P N Q)
    from `Suc n = length xvec`
    obtain x xvec' where "xvec = x#xvec'" and "length xvec' = n"
      by(case_tac xvec) auto
    from `hoclauseChain xvec M P = hoclauseChain yvec N Q` `xvec = x # xvec'`
    obtain y yvec' where "hoclauseChain (x#xvec') M P = hoclauseChain (y#yvec') N Q"
      and "yvec = y#yvec'"
      by(case_tac yvec) auto
    hence EQ: "CBind x (hoclauseChain xvec' M P) = CBind y (hoclauseChain yvec' N Q)"
      by simp
    have IH: "\<And>xvec yvec M P N Q. \<lbrakk>hoclauseChain xvec (M::'a) (P::('a, 'b, 'c) hopsi) = hoclauseChain yvec N Q; n = length xvec\<rbrakk> \<Longrightarrow> length xvec = length yvec"
      by fact
    show ?case
    proof(case_tac "x = y")
      assume "x = y"
      with EQ have "hoclauseChain xvec' M P = hoclauseChain yvec' N Q"
	by(simp add: alpha hoclauseres.inject)
      with IH `length xvec' = n` have "length xvec' = length yvec'"
	by blast
      with `xvec = x#xvec'` `yvec=y#yvec'`
      show ?case by simp
    next
      assume "x \<noteq> y"
      with EQ have "hoclauseChain xvec' M P = hoclauseChain ([(x, y)] \<bullet> yvec') ([(x, y)] \<bullet> N) ([(x, y)] \<bullet> Q)"
	by(simp add: alpha hoclauseres.inject eqvts)
      with IH `length xvec' = n` have "length xvec' = length ([(x, y)] \<bullet> yvec')"
	by blast
      hence "length xvec' = length yvec'"
	by simp
      with `xvec = x#xvec'` `yvec=y#yvec'`
      show ?case by simp
    qed
  qed
qed

lemma alphaHoclauseChain:
  fixes yvec :: "name list"
  and   xvec :: "name list"
  and   M    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"

  assumes "length xvec = length yvec"
  and     "yvec \<sharp>* M"
  and     "yvec \<sharp>* P"
  and     "yvec \<sharp>* xvec"
  and     "distinct yvec"

  shows "hoclauseChain xvec M P = hoclauseChain yvec ([xvec yvec] \<bullet>\<^sub>v M) ([xvec yvec] \<bullet>\<^sub>v P)"
using assms
proof(induct rule: composePermInduct)
  case cBase
  show ?case by simp
next
  case(cStep x xvec y yvec)
  thus ?case 
    apply auto
    by(subst alphaHoclause[of y]) (auto simp add: hoclauseChainFresh eqvts)
qed

lemma hoclauseChainInject[simp]:

  shows "(hoclauseChain xvec M P = hoclauseChain xvec N Q) = ((M = N) \<and> (P = Q))"
by(induct xvec) (auto simp add: hoclauseres.inject alpha)

lemma alphaInputDistinct:
  fixes xvec :: "name list"
  and   M    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) hopsi"
  and   yvec :: "name list"
  and   N    :: 'a
  and   Q    :: "('a, 'b, 'c) hopsi"

  assumes Eq: "hoclauseChain xvec M P = hoclauseChain yvec N Q"
  and     xvecDist: "distinct xvec"
  and     Mem: "\<And>x. x \<in> set xvec \<Longrightarrow> x \<in> supp M"
  and     xvecFreshyvec: "xvec \<sharp>* yvec"
  and     xvecFreshN: "xvec \<sharp>* N"
  and     xvecFreshQ: "xvec \<sharp>* Q"

  shows "distinct yvec"
proof -
  from Eq have "length xvec = length yvec"
    by(rule hoclauseChainEqLength)
  with assms show ?thesis
  proof(induct n=="length xvec" arbitrary: xvec yvec N Q rule: nat.induct)
    case(zero xvec yvec N Q)
    thus ?case by simp
  next
    case(Suc n xvec yvec N Q)
    have L: "length xvec = length yvec" and "Suc n = length xvec" by fact+
    then obtain x xvec' y yvec' where xEq: "xvec = x#xvec'" and yEq: "yvec = y#yvec'"
                                  and L': "length xvec' = length yvec'"
      by(cases xvec, auto, cases yvec, auto)
    have xvecFreshyvec: "xvec \<sharp>* yvec" and xvecDist: "distinct xvec" by fact+
    with xEq yEq have xineqy: "x \<noteq> y" and xvec'Freshyvec': "xvec' \<sharp>* yvec'"
                  and xvec'Dist: "distinct xvec'" and xFreshxvec': "x \<sharp> xvec'"
                  and xFreshyvec': "x \<sharp> yvec'" and yFreshxvec': "y \<sharp> xvec'"
      by(auto simp add: fresh_list_cons)
    have Eq: "hoclauseChain xvec M P = hoclauseChain yvec N Q" by fact
    with xEq yEq xineqy have Eq': "hoclauseChain xvec' M P = hoclauseChain ([(x, y)] \<bullet> yvec') ([(x, y)] \<bullet> N) ([(x, y)] \<bullet> Q)"
      by(simp add: hoclauseres.inject alpha eqvts)
    moreover have Mem:"\<And>x. x \<in> set xvec \<Longrightarrow> x \<in> supp M" by fact
    with xEq have "\<And>x. x \<in> set xvec' \<Longrightarrow> x \<in> supp M" by simp
    moreover have xvecFreshN: "xvec \<sharp>* N" by fact
    with xEq xFreshxvec' yFreshxvec' have "xvec' \<sharp>* ([(x, y)] \<bullet> N)" by simp
    moreover have xvecFreshQ: "xvec \<sharp>* Q" by fact
    with xEq xFreshxvec' yFreshxvec' have "xvec' \<sharp>* ([(x, y)] \<bullet> Q)" by simp
    moreover have "Suc n = length xvec" by fact
    with xEq have "n = length xvec'" by simp
    moreover from xvec'Freshyvec' xFreshxvec' yFreshxvec' have "xvec' \<sharp>* ([(x, y)] \<bullet> yvec')"
      by simp
    moreover from L' have "length xvec' = length([(x, y)] \<bullet> yvec')" by simp
    moreover have "\<And>xvec yvec N Q.
                   \<lbrakk>hoclauseChain xvec (M::'a) (P::('a, 'b, 'c) hopsi) = hoclauseChain yvec N Q; distinct xvec; \<And>x. x \<in> set xvec \<Longrightarrow> x \<in> supp M; xvec \<sharp>* yvec;
                    xvec \<sharp>* N; xvec \<sharp>* Q; length xvec = length yvec; n = length xvec\<rbrakk>
                    \<Longrightarrow> distinct yvec"
      by(rule Suc)
    ultimately have "distinct([(x, y)] \<bullet> yvec')" using xvec'Dist
      by blast
    hence "distinct yvec'" by simp
    from Mem xEq have xSuppM: "x \<in> supp M" by simp
    from L xvecFreshyvec xvecDist xvecFreshN xvecFreshQ
    have "hoclauseChain yvec N Q = hoclauseChain xvec ([yvec xvec] \<bullet>\<^sub>v N) ([yvec xvec] \<bullet>\<^sub>v Q)"
      by(simp add: alphaHoclauseChain)
    with Eq have "M = [yvec xvec] \<bullet>\<^sub>v N"  by auto
    with xEq yEq have "M = [(y, x)] \<bullet> [yvec' xvec'] \<bullet>\<^sub>v N"
      by simp
    with xSuppM have ySuppN: "y \<in> supp([yvec' xvec'] \<bullet>\<^sub>v N)"
      by(drule_tac pi="[(x, y)]" in pt_set_bij2[OF pt_name_inst, OF at_name_inst])
        (simp add: calc_atm eqvts name_swap)
    have "y \<sharp> yvec'"
    proof(simp add: fresh_def, rule notI)
      assume "y \<in> supp yvec'"
      hence "y mem yvec'"
	by(induct yvec') (auto simp add: supp_list_nil supp_list_cons supp_atm)
      moreover from xvecFreshN xEq xFreshxvec' have "xvec' \<sharp>* N" by simp
      ultimately have "y \<sharp> [yvec' xvec'] \<bullet>\<^sub>v  N" using L' xvec'Freshyvec' xvec'Dist
	by(force intro: freshChainPerm simp add: freshChainSym)
      with ySuppN show "False" by(simp add: fresh_def)
    qed
    with `distinct yvec'`  yEq show ?case by simp
  qed
qed

locale canonical = substPsi FOtermSubst FOassertSubst FOcondSubst
for   FOtermSubst :: "'a::fs_name \<Rightarrow> name list \<Rightarrow> 'a list \<Rightarrow> 'a" ("_[_::=_]" [80, 80 ,80] 130)
  and FOassertSubst :: "'b::fs_name \<Rightarrow> name list \<Rightarrow> 'a list \<Rightarrow> 'b" ("_[_::=_]" [80, 80 ,80] 130)
  and FOcondSubst :: "'c::fs_name \<Rightarrow> name list \<Rightarrow> 'a list \<Rightarrow> 'c" ("_[_::=_]" [80, 80 ,80] 130)
+
fixes FOSCompose :: "'b \<Rightarrow> 'b \<Rightarrow> 'b"   (infixr "\<otimes>\<^isub>F" 80)
  and FOSImp :: "'b \<Rightarrow> 'c \<Rightarrow> bool" ("_ \<turnstile>\<^isub>F _" [70, 70] 70)
  and FOSBottom :: 'b ("\<one>\<^isub>F" 90)
  and FOSChanEq :: "'a \<Rightarrow> 'a \<Rightarrow> 'c" ("_ \<leftrightarrow>\<^isub>F _" [80, 80] 80)
  and FOPairing :: "'a \<Rightarrow> 'a \<Rightarrow> 'a" ("_\<langle>_\<rangle>" [70,70] 70)
  and FONameless :: 'a ("\<bottom>" 90)

assumes    statEqvt[eqvt]:   "\<And>p::name prm. p \<bullet> (\<Psi> \<turnstile>\<^isub>F \<Phi>) = (p \<bullet> \<Psi>) \<turnstile>\<^isub>F (p \<bullet> \<Phi>)"
  and      statEqvt'[eqvt]:  "\<And>p::name prm. p \<bullet> (\<Psi> \<otimes>\<^isub>F \<Psi>') = (p \<bullet> \<Psi>) \<otimes>\<^isub>F (p \<bullet> \<Psi>')"
  and      statEqvt''[eqvt]: "\<And>p::name prm. p \<bullet> (M \<leftrightarrow>\<^isub>F N) = (p \<bullet> M) \<leftrightarrow>\<^isub>F (p \<bullet> N)"
  and      pairingEqvt[eqvt]: "\<And>p::name prm. p \<bullet> (M\<langle>N\<rangle>::'a) = ((p\<bullet>M)\<langle>(p\<bullet>N)\<rangle>::'a)"
(*  and      pairingSupp: "(supp M) \<subseteq> (supp((M\<langle>N\<rangle>)::'a)::name set)"*)
  and      pairingEqPres: "(M\<langle>N\<rangle>::'a) = (M'\<langle>N'\<rangle>) \<Longrightarrow> M=M'"
  and      permNameless[eqvt]: "\<And>p::name prm. (p \<bullet> \<bottom>) = \<bottom>"
  and      termEmptySubst: "(M::'a)[[] ::= []] = M"
  and      assertEmptySubst: "(\<Psi>::'b)[[] ::= []] = \<Psi>"
  and      condEmptySubst: "(\<phi>::'c)[[] ::= []] = \<phi>"
  and      permBottom[eqvt]: "\<And>p::name prm. (p \<bullet> \<one>\<^isub>F) = \<one>\<^isub>F"
  and      chanEqSym:     "\<Psi> \<turnstile>\<^isub>F M \<leftrightarrow>\<^isub>F N \<Longrightarrow> \<Psi> \<turnstile>\<^isub>F N \<leftrightarrow>\<^isub>F M"
  and      chanEqTrans:   "\<lbrakk>\<Psi> \<turnstile>\<^isub>F M \<leftrightarrow>\<^isub>F N; \<Psi> \<turnstile>\<^isub>F N \<leftrightarrow>\<^isub>F L\<rbrakk> \<Longrightarrow> \<Psi> \<turnstile>\<^isub>F M \<leftrightarrow>\<^isub>F L"
  and      Composition:
  "(\<forall>\<Phi>. \<Psi> \<turnstile>\<^isub>F \<Phi> \<longrightarrow> \<Psi>' \<turnstile>\<^isub>F \<Phi>) \<and> (\<forall>\<Phi>. \<Psi>' \<turnstile>\<^isub>F \<Phi> \<longrightarrow> \<Psi> \<turnstile>\<^isub>F \<Phi>)
  \<Longrightarrow>
  (\<forall>\<Phi>. (\<Psi> \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi>' \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi>' \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi> \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi>)"
  and      Identity:      "(\<forall>\<Phi>. (\<Psi> \<otimes>\<^isub>F \<one>\<^isub>F) \<turnstile>\<^isub>F \<Phi> \<longrightarrow> \<Psi> \<turnstile>\<^isub>F \<Phi>) \<and> (\<forall>\<Phi>. \<Psi> \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi> \<otimes>\<^isub>F \<one>\<^isub>F) \<turnstile>\<^isub>F \<Phi>)"
  and      Associativity: "(\<forall>\<Phi>. ((\<Psi> \<otimes>\<^isub>F \<Psi>') \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi> \<otimes>\<^isub>F (\<Psi>' \<otimes>\<^isub>F \<Psi>'')) \<turnstile>\<^isub>F \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi> \<otimes>\<^isub>F (\<Psi>' \<otimes>\<^isub>F \<Psi>'')) \<turnstile>\<^isub>F \<Phi> \<longrightarrow> ((\<Psi> \<otimes>\<^isub>F \<Psi>') \<otimes>\<^isub>F \<Psi>'') \<turnstile>\<^isub>F \<Phi>)"

  and      Commutativity: "(\<forall>\<Phi>. (\<Psi> \<otimes>\<^isub>F \<Psi>') \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi>' \<otimes>\<^isub>F \<Psi>) \<turnstile>\<^isub>F \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi>' \<otimes>\<^isub>F \<Psi>) \<turnstile>\<^isub>F \<Phi> \<longrightarrow> (\<Psi> \<otimes>\<^isub>F \<Psi>') \<turnstile>\<^isub>F \<Phi>)"

(*  and FOSClause :: "'a \<Rightarrow> ('a,'b,'c) psi \<Rightarrow> 'c"*)
begin

(* ('a, 'b \<times> ('a, 'b, 'c) clause list,('c, 'a \<times> ('a, 'b, 'c) psi) union) psi*)

typ "'a" (* HO-terms *)
typ "('a,'b,'c) hoassert" (*HO-assertions*)
typ "('a,'b,'c) hocond" (*HO-conditions*)


notation subs  ("_[_::=_]" [80, 80 ,80] 130)

nominal_primrec hoassertSubst :: "('a,'b,'c) hoassert \<Rightarrow> name list \<Rightarrow> 'a list => ('a,'b,'c) hoassert" ("_[_::=_]" [80, 80, 80] 130)
and hocondSubst :: "('a,'b,'c) hocond \<Rightarrow> name list \<Rightarrow> 'a list => ('a,'b,'c) hocond" ("_[_::=_]" [80, 80, 80] 130)
and hoclauseresSubst :: "('a,'b,'c) hoclauseres \<Rightarrow> name list \<Rightarrow> 'a list => ('a,'b,'c) hoclauseres" ("_[_::=_]" [80, 80, 80] 130)
and hoclauseSubst :: "('a,'b,'c) hoclause \<Rightarrow> name list \<Rightarrow>  'a list \<Rightarrow> ('a,'b,'c) hoclause" ("_[_::=_]" [80, 80, 80] 130)
and hopsiSubst :: "('a,'b,'c) hopsi \<Rightarrow> name list \<Rightarrow>  'a list \<Rightarrow> ('a,'b,'c) hopsi" ("_[_::=_]" [80, 80, 80] 130)
and hoinputSubst :: "('a,'b,'c) hoinput \<Rightarrow> name list \<Rightarrow> 'a list \<Rightarrow> ('a,'b,'c) hoinput" ("_[_::=_]" [80, 80, 80] 130)
and hopsiCaseSubst :: "('a,'b,'c) hopsiCase \<Rightarrow> name list \<Rightarrow> 'a list \<Rightarrow> ('a,'b,'c) hopsiCase" ("_[_::=_]" [80, 80, 80] 130) where
  "hoassertSubst (FOA A) xvec Tvec = FOA(A[xvec::=Tvec])"
| "hoassertSubst (HOA C A) xvec Tvec = HOA (hoclauseSubst C xvec Tvec) (hoassertSubst A xvec Tvec)"
| "hocondSubst (FOC C) xvec Tvec = FOC(C[xvec::=Tvec])"
| "hocondSubst (HOC M P) xvec Tvec = HOC (M[xvec::=Tvec]) (hopsiSubst P xvec Tvec)"
| "hoclauseresSubst (CTrm M P) xvec Tvec = CTrm (M[xvec::=Tvec]) (hopsiSubst P xvec Tvec)"
| "\<lbrakk>y \<sharp> xvec; y \<sharp> Tvec\<rbrakk> \<Longrightarrow> hoclauseresSubst (CBind y C) xvec Tvec = CBind y (hoclauseresSubst C xvec Tvec)"
| "hoclauseSubst (Clause M C) xvec Tvec= Clause (M[xvec::=Tvec]) (hoclauseresSubst C xvec Tvec)"
| "hopsiSubst HOPsiNil xvec Tvec = HOPsiNil"
| "hopsiSubst (HOOutput M N P) xvec Tvec = HOOutput (M[xvec::=Tvec]) (N[xvec::=Tvec]) (hopsiSubst P xvec Tvec)"
| "hopsiSubst (HOInput M I) xvec Tvec = HOInput (M[xvec::=Tvec]) (hoinputSubst I xvec Tvec)"
| "hopsiSubst (HOCase C) xvec Tvec = HOCase (hopsiCaseSubst C xvec Tvec)"
| "hopsiSubst (HOPar P Q) xvec Tvec = HOPar (hopsiSubst P xvec Tvec) (hopsiSubst Q xvec Tvec)"
| "\<lbrakk>y \<sharp> xvec; y \<sharp> Tvec\<rbrakk> \<Longrightarrow> hopsiSubst (HORes y P) xvec Tvec = HORes y (hopsiSubst P xvec Tvec)"
| "hopsiSubst (HOAssert A) xvec Tvec = HOAssert (hoassertSubst A xvec Tvec)"
| "hopsiSubst (HOBang P) xvec Tvec = HOBang (hopsiSubst P xvec Tvec)"
| "hopsiSubst (HOInvoke M) xvec Tvec = HOInvoke (M[xvec::=Tvec])"
| "hoinputSubst (HOTrm M P) xvec Tvec = HOTrm (M[xvec::=Tvec]) (hopsiSubst P xvec Tvec)"
| "\<lbrakk>y \<sharp> xvec; y \<sharp> Tvec\<rbrakk> \<Longrightarrow> hoinputSubst (HOBind y I) xvec Tvec = HOBind y (hoinputSubst I xvec Tvec)"
| "hopsiCaseSubst HOEmptyCase xvec Tvec = HOEmptyCase"
| "hopsiCaseSubst (HOCond C P C') xvec Tvec = HOCond (hocondSubst C xvec Tvec) (hopsiSubst P xvec Tvec) (hopsiCaseSubst C' xvec Tvec)"
apply(finite_guess add: substTerm.fs substAssert.fs substCond.fs)+
apply(rule TrueI)+
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(simp add: abs_fresh)
apply(rule supports_fresh[of "supp(xvec, Tvec)"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: fs_name1,
      simp add: fresh_def[symmetric])+
done

lemma HOemptySubst:
  fixes \<Psi>  :: "('a,'b,'c) hoassert"
  and   \<phi>  :: "('a,'b,'c) hocond"
  and   Cr :: "('a,'b,'c) hoclauseres"
  and   C  :: "('a,'b,'c) hoclause"
  and   P  :: "('a,'b,'c) hopsi"
  and   I  :: "('a,'b,'c) hoinput"
  and   Ca :: "('a,'b,'c) hopsiCase"
  shows "(\<Psi>[[] ::= []]) = \<Psi>"
  and   "(\<phi>[[] ::= []]) = \<phi>"
  and   "(Cr[[] ::= []]) = Cr"
  and   "(C[[] ::= []]) = C"
  and   "(P[[] ::= []]) = P"
  and   "(I[[] ::= []]) = I"
  and   "(Ca[[] ::= []]) = Ca"
apply(nominal_induct \<Psi> and \<phi> and Cr and C and P and I and Ca rule: hoassert_hocond_hoclauseres_hoclause_hopsi_hoinput_hopsiCase.strong_inducts)
by(simp add: termEmptySubst assertEmptySubst condEmptySubst)+

lemma HOEqvts[eqvt]:
  fixes p  :: "name prm"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  and   \<phi>  :: "('a,'b,'c) hocond"
  and   Cr :: "('a,'b,'c) hoclauseres"
  and   C  :: "('a,'b,'c) hoclause"
  and   P  :: "('a,'b,'c) hopsi"
  and   I  :: "('a,'b,'c) hoinput"
  and   Ca :: "('a,'b,'c) hopsiCase"
  shows "(p \<bullet> (\<Psi>[xvec::=Tvec])) = (p \<bullet> \<Psi>)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (\<phi>[xvec::=Tvec])) = (p \<bullet> \<phi>)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (Cr[xvec::=Tvec])) = (p \<bullet> Cr)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (C[xvec::=Tvec])) = (p \<bullet> C)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (P[xvec::=Tvec])) = (p \<bullet> P)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (I[xvec::=Tvec])) = (p \<bullet> I)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
  and   "(p \<bullet> (Ca[xvec::=Tvec])) = (p \<bullet> Ca)[(p \<bullet> xvec)::=(p \<bullet> Tvec)]"
apply(nominal_induct \<Psi> and \<phi> and Cr and C and P and I and Ca avoiding: xvec Tvec rule: hoassert_hocond_hoclauseres_hoclause_hopsi_hoinput_hopsiCase.strong_inducts)
apply(auto simp add: eqvts)
apply(drule_tac pi=p in pt_fresh_bij1[OF pt_name_inst, OF at_name_inst],
      drule_tac pi=p in pt_fresh_bij1[OF pt_name_inst, OF at_name_inst],
      simp)+
done

lemma HORenaming[rule_format]:
  fixes p    :: "name prm"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  and   \<phi>  :: "('a,'b,'c) hocond"
  and   Cr :: "('a,'b,'c) hoclauseres"
  and   C  :: "('a,'b,'c) hoclause"
  and   P  :: "('a,'b,'c) hopsi"
  and   I  :: "('a,'b,'c) hoinput"
  and   Ca :: "('a,'b,'c) hopsiCase"
  and   xvec :: "name list"
  and   Tvec :: "'a list"

  assumes "length xvec = length Tvec"
  and     "set p \<subseteq> set xvec \<times> set(p \<bullet> xvec)"
  and     "distinctPerm p"

  shows   "(p \<bullet> xvec) \<sharp>* \<Psi> \<Longrightarrow> \<Psi>[xvec::=Tvec] = (p \<bullet> \<Psi>)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* \<phi> \<Longrightarrow> \<phi>[xvec::=Tvec] = (p \<bullet> \<phi>)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* Cr \<Longrightarrow> Cr[xvec::=Tvec] = (p \<bullet> Cr)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* C \<Longrightarrow> C[xvec::=Tvec] = (p \<bullet> C)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* P \<Longrightarrow> P[xvec::=Tvec] = (p \<bullet> P)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* I \<Longrightarrow> I[xvec::=Tvec] = (p \<bullet> I)[(p \<bullet> xvec)::=Tvec]"
  and     "(p \<bullet> xvec) \<sharp>* Ca \<Longrightarrow> Ca[xvec::=Tvec] = (p \<bullet> Ca)[(p \<bullet> xvec)::=Tvec]"
using assms
apply(nominal_induct \<Psi> and \<phi> and Cr and C and P and I and Ca avoiding: p xvec Tvec rule: hoassert_hocond_hoclauseres_hoclause_hopsi_hoinput_hopsiCase.strong_inducts)
by(simp add: hoassertFresh hocondFresh hoclauseresFresh hoclauseFresh hopsiFresh substAssert.renaming substCond.renaming substTerm.renaming hoassert.inject hocond.inject hoclauseres.inject hoclause.inject hopsi.inject hoinput.inject hopsiCase.inject fresh_perm_app)+

lemma fsCompose[simp]: "finite((supp FOSCompose)::name set)"
by(simp add: supp_def perm_fun_def eqvts)

nominal_primrec HOSCompose' :: "('a,'b,'c) hoassert \<Rightarrow> 'b \<Rightarrow> ('a,'b,'c) hoassert"
and hocondIgnore' :: "('a,'b,'c) hocond \<Rightarrow> 'b \<Rightarrow> unit"
and hoclauseresIgnore' :: "('a,'b,'c) hoclauseres \<Rightarrow> 'b \<Rightarrow> unit"
and hoclauseIgnore' :: "('a,'b,'c) hoclause \<Rightarrow> 'b \<Rightarrow> unit"
and hopsiIgnore' :: "('a,'b,'c) hopsi \<Rightarrow> 'b \<Rightarrow> unit"
and hoinputIgnore' :: "('a,'b,'c) hoinput \<Rightarrow> 'b \<Rightarrow> unit"
and hopsiCaseIgnore' :: "('a,'b,'c) hopsiCase \<Rightarrow> 'b \<Rightarrow> unit"
where
  "HOSCompose' (FOA \<Psi>) \<Psi>' = FOA (\<Psi> \<otimes>\<^isub>F \<Psi>')"
| "HOSCompose' (HOA C \<Psi>\<^isub>H) \<Psi>' = HOA C (HOSCompose' \<Psi>\<^isub>H \<Psi>')"
| "hocondIgnore' (FOC C) \<Psi>' = ()"
| "hocondIgnore' (HOC M P) \<Psi>' = ()"
| "hoclauseresIgnore' (CTrm M P) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hoclauseresIgnore' (CBind y C) \<Psi>' = ()"
| "hoclauseIgnore' (Clause M C) \<Psi>' = ()"
| "hopsiIgnore' HOPsiNil \<Psi>' = ()"
| "hopsiIgnore' (HOOutput M N P) \<Psi>' = ()"
| "hopsiIgnore' (HOInput M I) \<Psi>' = ()"
| "hopsiIgnore' (HOCase C) \<Psi>' = ()"
| "hopsiIgnore' (HOPar P Q) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hopsiIgnore' (HORes y P) \<Psi>' = ()"
| "hopsiIgnore' (HOAssert A) \<Psi>' = ()"
| "hopsiIgnore' (HOBang P) \<Psi>' = ()"
| "hopsiIgnore' (HOInvoke M) \<Psi>' = ()"
| "hoinputIgnore' (HOTrm M P) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hoinputIgnore' (HOBind y I) \<Psi>' = ()"
| "hopsiCaseIgnore' HOEmptyCase \<Psi>' = ()"
| "hopsiCaseIgnore' (HOCond C P C') \<Psi>' = ()"
apply(finite_guess add: fsCompose)+
apply(rule TrueI)+
apply(assumption)+
apply(rule supports_fresh[of "supp(\<Psi>')"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: fs_name1,
      simp add: fresh_def[symmetric])+
done

lemma HOSCompose'Eqvt[eqvt]:
  fixes p  :: "name prm"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  shows "(p \<bullet> (HOSCompose' \<Psi> \<Psi>')) = HOSCompose' (p \<bullet> \<Psi>) (p \<bullet> \<Psi>')"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: eqvts)+

lemma fsCompose'[simp]: "finite((supp HOSCompose')::name set)"
by(simp add: supp_def perm_fun_def eqvts)

lemma fsCompose''[simp]: "finite((supp FOSImp)::name set)"
by(simp add: supp_def perm_fun_def eqvts)

lemma fsfoassert: "finite (supp (\<Psi>\<Colon>'b)::name set)"
proof -
  have "\<forall> \<Psi>. finite (supp (\<Psi>\<Colon>'b)::name set)"
    apply(subst fs_def[symmetric])
    apply(rule fs_name_inst)
    done
  thus ?thesis
    by(rule allE)
qed

lemma fshoassert: "finite (supp (\<Psi>\<Colon>('a, 'b, 'c) hoassert)::name set)"
proof -
  have "\<forall> \<Psi>. finite (supp (\<Psi>\<Colon>('a, 'b, 'c) hoassert)::name set)"
    apply(subst fs_def[symmetric])
    apply(rule fs_name_inst)
    done
  thus ?thesis
    by(rule allE)
qed

lemma fsCompose'Split: "finite((supp (HOSCompose' \<Psi>))::name set)"
apply(rule finite_subset[OF pt_supp_fun_subset[OF pt_name_inst, OF pt_name_inst, OF at_name_inst, OF fsCompose', OF fshoassert]])
apply(subst finite_Un)
apply(rule conjI)
apply(rule fsCompose')
apply(rule fshoassert)
done

lemma fsFOSImp: "finite((supp (FOSImp \<Psi>))::name set)"
apply(rule finite_subset[OF pt_supp_fun_subset[OF pt_name_inst, OF pt_name_inst, OF at_name_inst, OF fsCompose'', OF fsfoassert]])
apply(subst finite_Un)
apply(rule conjI)
apply(rule fsCompose'')
apply(rule fsfoassert)
done

nominal_primrec HOSCompose :: "('a,'b,'c) hoassert \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> ('a,'b,'c) hoassert" (infixr "\<otimes>" 80)
and hocondIgnore'' :: "('a,'b,'c) hocond \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
and hoclauseresIgnore'' :: "('a,'b,'c) hoclauseres \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
and hoclauseIgnore'' :: "('a,'b,'c) hoclause \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
and hopsiIgnore'' :: "('a,'b,'c) hopsi \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
and hoinputIgnore'' :: "('a,'b,'c) hoinput \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
and hopsiCaseIgnore'' :: "('a,'b,'c) hopsiCase \<Rightarrow> ('a,'b,'c) hoassert \<Rightarrow> unit"
where
  "HOSCompose (FOA \<Psi>) \<Psi>' = HOSCompose' \<Psi>' \<Psi>"
| "HOSCompose (HOA C \<Psi>\<^isub>H) \<Psi>' = HOA C (HOSCompose \<Psi>\<^isub>H \<Psi>')"
| "hocondIgnore'' (FOC C) \<Psi>' = ()"
| "hocondIgnore'' (HOC M P) \<Psi>' = ()"
| "hoclauseresIgnore'' (CTrm M P) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hoclauseresIgnore'' (CBind y C) \<Psi>' = ()"
| "hoclauseIgnore'' (Clause M C) \<Psi>' = ()"
| "hopsiIgnore'' HOPsiNil \<Psi>' = ()"
| "hopsiIgnore'' (HOOutput M N P) \<Psi>' = ()"
| "hopsiIgnore'' (HOInput M I) \<Psi>' = ()"
| "hopsiIgnore'' (HOCase C) \<Psi>' = ()"
| "hopsiIgnore'' (HOPar P Q) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hopsiIgnore'' (HORes y P) \<Psi>' = ()"
| "hopsiIgnore'' (HOAssert A) \<Psi>' = ()"
| "hopsiIgnore'' (HOBang P) \<Psi>' = ()"
| "hopsiIgnore'' (HOInvoke M) \<Psi>' = ()"
| "hoinputIgnore'' (HOTrm M P) \<Psi>' = ()"
| "y \<sharp> \<Psi>' \<Longrightarrow> hoinputIgnore'' (HOBind y I) \<Psi>' = ()"
| "hopsiCaseIgnore'' HOEmptyCase \<Psi>' = ()"
| "hopsiCaseIgnore'' (HOCond C P C'') \<Psi>' = ()"
apply(rule fsCompose'Split)
apply(finite_guess)+
apply(rule TrueI)+
apply(assumption)+
apply(rule supports_fresh[of "supp(\<Psi>')::name set"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def,
      simp add: fs_name1,
      simp add: fresh_def[symmetric])+
done

lemma HOSComposeEqvts[eqvt]:
  fixes p  :: "name prm"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  shows "(p \<bullet> (HOSCompose \<Psi> \<Psi>')) = HOSCompose (p \<bullet> \<Psi>) (p \<bullet> \<Psi>')"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: eqvts)+

fun HOSChanEq :: "'a \<Rightarrow> 'a \<Rightarrow> ('a,'b,'c) hocond" ("_ \<leftrightarrow> _" [80, 80] 80)
  where
  "HOSChanEq M N = FOC(M \<leftrightarrow>\<^isub>F N)"

definition HOSBottom :: "('a,'b,'c) hoassert" ("\<one>" 90)
  where
  "HOSBottom = FOA(\<one>\<^isub>F)"

fun HOSClause :: "'a \<Rightarrow> ('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi \<Rightarrow> ('a,'b,'c) hocond"  ("_ \<Leftarrow> _" [80, 80] 80)
  where
  "HOSClause M P = HOC M (\<sigma> P)"


fun HOSImp'' :: "(('a,'b,'c) hoclause list) \<Rightarrow> 'a \<Rightarrow> ('a,'b,'c) hopsi \<Rightarrow> bool"
  where "HOSImp'' Cl M P = (\<exists> xvec Tvec (K::'a) (N::'a) Q. (length xvec = length Tvec \<and> distinct xvec \<and> M = K\<langle>N[xvec::=Tvec]\<rangle> \<and> P=Q[xvec::=Tvec] \<and> Clause K (\<nu>*xvec\<rparr>N \<Leftarrow> P) mem Cl))"(* \<and> K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> P) mem Cl))"*)

lemma HOSImp''eqvt[eqvt]:
  fixes p :: "name prm"
  shows "(p \<bullet> HOSImp'' Cl M P) = HOSImp'' (p\<bullet> Cl) (p\<bullet>M) (p\<bullet>P)"
by(simp add: eqvts)

lemma fsHOSImp'': "finite(supp (HOSImp'')::name set)"
by(simp add: supp_def perm_fun_def eqvts del: HOSImp''.simps)

lemma supp_lambda_comm: "supp(\<lambda> x y. P x y) = supp(\<lambda> y x. P x y)"
apply(auto simp add: supp_def perm_fun_def fun_eq_iff)
apply(subst HOL.ex_comm)
apply assumption
by(subst HOL.ex_comm)

lemma supp_lam_unit: "supp(\<lambda> (x::unit). P) = supp P"
by(auto simp add: supp_def perm_fun_def fun_eq_iff)

lemma exhack: "(\<exists> x y z z'. P x y z z') = (\<exists> z' x y z. P x y z z')"
by auto

lemma supphack: "supp(\<lambda> x y z z'. P x y z z') = supp(\<lambda> z' x y z. P x y z z')"
apply(auto simp add: fun_eq_iff supp_def perm_fun_def)
apply(subst exhack[symmetric])
apply force
apply(subst exhack)
apply force
done

lemma exhack3: "(\<exists> x y z. P x y z) = (\<exists> z x y. P x y z)"
by auto

lemma supphack3: "supp(\<lambda> x y z'. P x y z') = supp(\<lambda> z' x y. P x y z')"
apply(auto simp add: fun_eq_iff supp_def perm_fun_def)
apply(subst exhack3[symmetric])
apply force
apply(subst exhack3)
apply force
done

lemma supphack': "(supp (\<lambda>a b c (d::unit). HOSImp'' a b c)) = (supp (\<lambda>a b c. HOSImp'' a b c))"
apply(subst supphack)
apply(rule supp_lam_unit)
done

lemma supphack'': "(supp (\<lambda>a c (d::unit). HOSImp'' b a c)) = (supp (\<lambda>a c. HOSImp'' b a c))"
apply(subst supphack3)
apply(rule supp_lam_unit)
done


lemma setLamPerm:
  fixes a::name
  and   b::name
  and   Cl::"('e::fs_name) list"
  assumes "a \<sharp> Cl"
  and "b \<sharp> Cl"
  shows "(\<lambda>x. [(a, b)] \<bullet> set Cl ([(a, b)] \<bullet> x)) = set Cl"
using assms
proof -
  {
    fix x::'e
    assume "x \<in> set Cl"
    hence "a \<sharp> x" and "b \<sharp> x"
      using assms by(induct Cl) auto
    hence "([(a,b)]\<bullet>x) \<in> set Cl" using `x \<in> set Cl`
      by(simp add: eqvts)
    hence "x \<in> (\<lambda>x. set Cl ([(a, b)] \<bullet> x))"
      by(auto simp add: Set.mem_def)
  }
  moreover
  {
    fix x::'e
    assume "x \<in> (\<lambda>x. set Cl ([(a, b)] \<bullet> x))"
    hence "([(a,b)]\<bullet>x) \<in> set Cl"
      by(auto simp add: Set.mem_def)
    moreover hence "a \<sharp> [(a, b)] \<bullet> x" and "b \<sharp> [(a, b)] \<bullet> x"
      using assms by(induct Cl) auto
    ultimately have "x \<in> set Cl" using assms
      by(subst perm_bool[where pi="([(a,b)])",symmetric]) (simp add: eqvts)
  }
  moreover note assms
  ultimately show ?thesis
    by(auto simp add: perm_bool)
qed

nominal_primrec hoassertIgnore''' :: "('a,'b,'c) hoassert \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
and HOSImp' :: "('a,'b,'c) hocond \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> bool"
and hoclauseresIgnore''' :: "('a,'b,'c) hoclauseres \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
and hoclauseIgnore''' :: "('a,'b,'c) hoclause \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
and hopsiIgnore''' :: "('a,'b,'c) hopsi \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
and hoinputIgnore''' :: "('a,'b,'c) hoinput \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
and hopsiCaseIgnore''' :: "('a,'b,'c) hopsiCase \<Rightarrow> 'b \<Rightarrow> (('a,'b,'c) hoclause list) \<Rightarrow> unit"
  where
  "hoassertIgnore''' (FOA \<Psi>') \<Psi> Cl = ()"
| "hoassertIgnore''' (HOA C \<Psi>\<^isub>H) \<Psi> Cl = ()"
| "HOSImp' (FOC \<phi>) \<Psi> Cl = \<Psi> \<turnstile>\<^isub>F \<phi>"
| "HOSImp' (HOC M P) \<Psi> Cl = HOSImp'' Cl M P"
| "hoclauseresIgnore''' (CTrm M P) \<Psi> Cl = ()"
| "\<lbrakk>y \<sharp> \<Psi>; y \<sharp> Cl\<rbrakk> \<Longrightarrow> hoclauseresIgnore''' (CBind y C) \<Psi> Cl = ()"
| "hoclauseIgnore''' (Clause M C) \<Psi> Cl = ()"
| "hopsiIgnore''' HOPsiNil \<Psi> Cl = ()"
| "hopsiIgnore''' (HOOutput M N P) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOInput M I) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOCase C) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOPar P Q) \<Psi> Cl = ()"
| "\<lbrakk>y \<sharp> \<Psi>; y \<sharp> Cl\<rbrakk> \<Longrightarrow> hopsiIgnore''' (HORes y P) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOAssert A) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOBang P) \<Psi> Cl = ()"
| "hopsiIgnore''' (HOInvoke M) \<Psi> Cl = ()"
| "hoinputIgnore''' (HOTrm M P) \<Psi> Cl = ()"
| "\<lbrakk>y \<sharp> \<Psi>; y \<sharp> Cl\<rbrakk> \<Longrightarrow> hoinputIgnore''' (HOBind y I) \<Psi> Cl = ()"
| "hopsiCaseIgnore''' HOEmptyCase \<Psi> Cl = ()"
| "hopsiCaseIgnore''' (HOCond C P C'') \<Psi> Cl = ()"
apply(finite_guess add: chain.fin_supp | rule fsFOSImp)+
apply(rule finite_subset[OF pt_supp_fun_subset[OF pt_name_inst, OF pt_name_inst, OF at_name_inst]])
apply(subst supphack')
apply(rule fsHOSImp'')
apply(rule chain.fin_supp)
apply(subst finite_Un)
apply(rule conjI)
apply(subst supphack')
apply(rule fsHOSImp'')
apply(rule chain.fin_supp)
apply(finite_guess)+
apply(rule TrueI)+
apply(assumption)+
apply(rule supports_fresh[of "supp((\<Psi>,Cl))::name set"],
      force simp add: perm_fun_def eqvts fresh_def[symmetric] supports_def setLamPerm,
      simp add: fs_name1,
      simp add: fresh_def[symmetric])+
done

lemma HOSImp'Eqvt[eqvt]:
  fixes p :: "name prm"
  and \<phi> :: "('a,'b,'c) hocond"
  and \<Psi> :: 'b
  and Cl :: "('a,'b,'c) hoclause list"
  shows "p \<bullet> (HOSImp' \<phi> \<Psi> Cl) = HOSImp' (p \<bullet> \<phi>) (p \<bullet> \<Psi>) (p \<bullet> Cl)"
apply(nominal_induct \<phi> rule: hocondInduct)
by(simp add: eqvts)+

fun HOSImp :: "('a,'b,'c) hoassert \<Rightarrow> ('a,'b,'c) hocond \<Rightarrow> bool" ("_ \<turnstile> _" [70, 70] 70)
  where
  "HOSImp \<Psi> \<phi> = HOSImp' \<phi> (hoassertFOA \<Psi>) (hoassertHOA \<Psi>)"

lemma HOSImpEqvt[eqvt]:
  fixes p :: "name prm"
  and \<Psi> :: "('a,'b,'c) hoassert"
  and \<phi> :: "('a,'b,'c) hocond"
  shows "p \<bullet> (\<Psi> \<turnstile> \<phi>) = (p \<bullet> \<Psi>) \<turnstile> (p \<bullet> \<phi>)"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: eqvts)+

lemma HOchanEqEqvt[eqvt]:
  fixes p :: "name prm"
  and M :: 'a
  and N :: 'a
  shows "p \<bullet> (M \<leftrightarrow> N) = (p \<bullet> M) \<leftrightarrow> (p \<bullet> N)"
by(simp add: eqvts)

lemma HOclauseEqvt[eqvt]:
  fixes p :: "name prm"
  and M :: 'a
  and P :: "('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
  shows "p \<bullet> (M \<Leftarrow> P) = (p \<bullet> M) \<Leftarrow> (p \<bullet> P)"
by(simp add: eqvts)

lemma HOpermBottom[eqvt]:
  fixes p :: "name prm"
  shows "p \<bullet> \<one> = \<one>"
by(simp add: HOSBottom_def eqvts)

lemma HOassertionAux: "assertionAux HOSCompose HOSImp HOSBottom HOSChanEq HOSClause"
apply(unfold_locales)
by(rule eqvts)+

lemma HOchanEqSym:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and   M :: 'a
  and   N :: 'a
  assumes "\<Psi> \<turnstile> M \<leftrightarrow> N"
  shows "\<Psi> \<turnstile> N \<leftrightarrow> M"
using assms
by(simp add: chanEqSym)

lemma HOchanEqTrans:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and   M :: 'a
  and   N :: 'a
  and   L :: 'a
  assumes "\<Psi> \<turnstile> M \<leftrightarrow> N"
  assumes "\<Psi> \<turnstile> N \<leftrightarrow> L"
  shows "\<Psi> \<turnstile> M \<leftrightarrow> L"
proof -
  have "hoassertFOA \<Psi> \<turnstile>\<^isub>F M \<leftrightarrow>\<^isub>F N"
   and "hoassertFOA \<Psi> \<turnstile>\<^isub>F N \<leftrightarrow>\<^isub>F L"
    using assms by simp+
  hence "hoassertFOA \<Psi> \<turnstile>\<^isub>F M \<leftrightarrow>\<^isub>F L"
    by(rule chanEqTrans)
  thus ?thesis by simp
qed

lemma HOSComposeHOInv: "hoassertHOA (HOSCompose' \<Psi> \<Psi>\<^isub>F) = hoassertHOA \<Psi>"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by simp+

lemma HOSComposeHOA':
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  shows "set (hoassertHOA (\<Psi> \<otimes> \<Psi>') @ Cl) = set(hoassertHOA \<Psi> @ hoassertHOA \<Psi>' @ Cl)"
by(nominal_induct \<Psi> rule: hoassertInduct) (auto simp add: HOSComposeHOInv)+

(*
lemma HOSComposeHOA:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  shows "member (hoassertHOA (\<Psi> \<otimes> \<Psi>')) = member(hoassertHOA \<Psi> @ hoassertHOA \<Psi>')"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: HOSComposeHOInv)+
*)
lemma HOSComposeHOASet:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  shows "set (hoassertHOA (\<Psi> \<otimes> \<Psi>')) = set(hoassertHOA \<Psi> @ hoassertHOA \<Psi>')"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp add: HOSComposeHOInv)+

lemma HOSComposeHOA'':
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  shows "set (Cl @ hoassertHOA (\<Psi> \<otimes> \<Psi>')) = set(Cl @ hoassertHOA \<Psi> @ hoassertHOA \<Psi>')"
apply(nominal_induct \<Psi> rule: hoassertInduct)
apply(simp add: HOSComposeHOInv)
by(simp add: HOSComposeHOInv HOSComposeHOASet)

lemma HOSComposeFOA: "hoassertFOA (\<Psi> \<otimes> \<Psi>') = (hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>)"
apply(nominal_induct \<Psi> rule: hoassertInduct)
apply(nominal_induct \<Psi>' rule: hoassertInduct)
by simp+

lemma HOSComposeFOA': "hoassertFOA (\<Psi> \<otimes> \<Psi>') \<turnstile>\<^isub>F \<phi> = (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>') \<turnstile>\<^isub>F \<phi>"
proof -
  have com: "hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>' \<turnstile>\<^isub>F \<phi> = hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>"
    apply(subst HOL.iff_conv_conj_imp)
    apply(rule conjI)
    by(rule allE[OF conjunct1[OF Commutativity]], assumption)+
  show ?thesis
    apply(subst com)
    apply(subst HOSComposeFOA)
    by(rule refl)
qed

lemma HOSComposeJudge:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  and  \<phi>  :: "('a,'b,'c) hocond"
  shows "\<Psi> \<otimes> \<Psi>' \<turnstile> \<phi> = HOSImp' \<phi> (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>') (hoassertHOA \<Psi> @ hoassertHOA \<Psi>')"
apply(nominal_induct \<phi> rule: hocondInduct)
apply(simp add: HOSComposeFOA')
apply(simp add: HOSComposeHOASet)
done

lemma HOSImpFullyAbstract':
  assumes "\<forall> \<phi>. (\<Psi> \<turnstile> \<phi> \<longrightarrow> \<Psi>' \<turnstile> \<phi>)"
  shows   "hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi> \<longrightarrow> hoassertFOA \<Psi>' \<turnstile>\<^isub>F \<phi>"
using assms
apply -
apply(drule_tac x = "FOC \<phi>" in spec)
by simp

lemma HOSImpFullyAbstract:
  assumes "\<forall> \<phi>. ((\<Psi> \<turnstile> \<phi> \<longrightarrow> \<Psi>' \<turnstile> \<phi>) \<and> (\<Psi>' \<turnstile> \<phi> \<longrightarrow> \<Psi> \<turnstile> \<phi>))"
  shows   "hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi> \<longrightarrow> hoassertFOA \<Psi>' \<turnstile>\<^isub>F \<phi>"
  and     "hoassertFOA \<Psi>' \<turnstile>\<^isub>F \<phi> \<longrightarrow> hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>"
using assms
apply -
apply(rule HOSImpFullyAbstract', simp)
apply(rule HOSImpFullyAbstract', simp)
done

lemma HOSCompose':
  assumes "(\<forall>\<Phi>. \<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi>' \<turnstile> \<Phi>)"
  and     "(\<forall>\<Phi>. \<Psi>' \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<turnstile> \<Phi>)"
  shows
  "(\<forall>\<Phi>. (\<Psi> \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi>' \<otimes> \<Psi>'') \<turnstile> \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi>' \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> \<Psi>'') \<turnstile> \<Phi>)"
proof -
  have "(\<forall> \<phi> . HOSImp' \<phi> (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') \<longrightarrow> HOSImp' \<phi> (hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>''))"
  proof(rule allI)
    fix \<phi> :: "('a,'b,'c) hocond"
    have "\<And>\<phi>\<^isub>F. hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'' \<turnstile>\<^isub>F \<phi>\<^isub>F \<longrightarrow>
      hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'' \<turnstile>\<^isub>F \<phi>\<^isub>F" using assms
      apply -
      apply(rule_tac \<Psi>2 = "hoassertFOA \<Psi>" and \<Psi>'2 = "hoassertFOA \<Psi>'" and \<Psi>''2 = "hoassertFOA \<Psi>''" in allE[OF conjunct1[OF Composition]])
      apply(rule conjI)
      apply(rule allI)
      apply(rule HOSImpFullyAbstract)
      apply simp
      apply(rule allI)
      apply(rule HOSImpFullyAbstract)
      apply simp
      apply assumption
      done
    moreover have "\<And> M P. HOSImp'' (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') M P \<longrightarrow>
      HOSImp'' (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') M P" using assms(2)
      apply -
      apply(drule_tac x = "HOC M P" in spec)
      apply(subst (asm) (1 2) HOSImp.simps)
      apply(subst (asm) (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
      apply(simp)
      by blast
    moreover have "\<And> M P. HOSImp'' (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') M P \<longrightarrow>
      HOSImp'' (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') M P" using assms(1)
      apply -
      apply(drule_tac x = "HOC M P" in spec)
      apply(subst (asm) (1 2) HOSImp.simps)
      apply(subst (asm) (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
      apply(simp)
      by blast
    ultimately show "HOSImp' \<phi> (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') \<longrightarrow> HOSImp' \<phi> (hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'')"
      apply -
      apply(nominal_induct \<phi> rule: hocondInduct)
      by simp+
  qed
  hence fst: "(\<forall>\<Phi>. (\<Psi> \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi>' \<otimes> \<Psi>'') \<turnstile> \<Phi>)"
    by(subst (1 2) HOSComposeJudge)
  have "(\<forall> \<phi> . HOSImp' \<phi> (hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') \<longrightarrow> HOSImp' \<phi> (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi> @ hoassertHOA \<Psi>''))"
  proof(rule allI)
    fix \<phi> :: "('a,'b,'c) hocond"
    have "\<And>\<phi>\<^isub>F. hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'' \<turnstile>\<^isub>F \<phi>\<^isub>F \<longrightarrow>
      hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'' \<turnstile>\<^isub>F \<phi>\<^isub>F" using assms
      apply -
      apply(rule_tac \<Psi>2 = "hoassertFOA \<Psi>'" and \<Psi>'2 = "hoassertFOA \<Psi>" and \<Psi>''2 = "hoassertFOA \<Psi>''" in allE[OF conjunct1[OF Composition]])
      apply(rule conjI)
      apply(rule allI)
      apply(rule HOSImpFullyAbstract)
      apply simp
      apply(rule allI)
      apply(rule HOSImpFullyAbstract)
      apply simp
      apply assumption
      done
    moreover have "\<And> M P. HOSImp'' (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') M P \<longrightarrow>
      HOSImp'' (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') M P" using assms(1)
      apply -
      apply(drule_tac x = "HOC M P" in spec)
      apply(subst (asm) (1 2) HOSImp.simps)
      apply(subst (asm) (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
      apply(simp)
      by blast
    moreover have "\<And> M P. HOSImp'' (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') M P \<longrightarrow>
      HOSImp'' (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'') M P" using assms(2)
      apply -
      apply(drule_tac x = "HOC M P" in spec)
      apply(subst (asm) (1 2) HOSImp.simps)
      apply(subst (asm) (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
      apply(simp)
      by blast
    ultimately show "HOSImp' \<phi> (hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi>' @ hoassertHOA \<Psi>'') \<longrightarrow> HOSImp' \<phi> (hoassertFOA \<Psi> \<otimes>\<^isub>F hoassertFOA \<Psi>'') (hoassertHOA \<Psi> @ hoassertHOA \<Psi>'')"
      apply -
      apply(nominal_induct \<phi> rule: hocondInduct)
      by simp+
  qed
  hence "(\<forall>\<Phi>. (\<Psi>' \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> \<Psi>'') \<turnstile> \<Phi>)"
    by(subst (1 2) HOSComposeJudge)
  thus ?thesis using fst
    by simp
qed

lemma HOSComposition:
  fixes \<Psi> :: "('a,'b,'c) hoassert"
  and  \<Psi>' :: "('a,'b,'c) hoassert"
  and \<Psi>'' :: "('a,'b,'c) hoassert"
  assumes "assertionAux.AssertionStatEq HOSImp \<Psi> \<Psi>'"
  shows "assertionAux.AssertionStatEq HOSImp (\<Psi> \<otimes> \<Psi>'') (\<Psi>' \<otimes> \<Psi>'')"
using assms
unfolding assertionAux.AssertionStatEq_def[OF HOassertionAux] assertionAux.AssertionStatImp_def[OF HOassertionAux]
apply -
apply(erule conjE)
by(rule HOSCompose')

lemma HOAFOAInv: "hoassertHOA (\<Psi> \<otimes> FOA \<Psi>\<^isub>F) = hoassertHOA \<Psi>"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by simp+

lemma HOAFOUnit:
  "hoassertFOA (\<Psi> \<otimes> FOA (\<one>\<^isub>F)) = \<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi>"
apply(nominal_induct \<Psi> rule: hoassertInduct)
by(simp)+

lemma HOSIdentity':
  shows
  "(\<forall>\<Phi>. (\<Psi> \<otimes> \<one>) \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<turnstile> \<Phi>) \<and> (\<forall>\<Phi>. \<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<otimes> \<one> \<turnstile> \<Phi>)"
unfolding HOSBottom_def
proof(rule conjI)
  show "\<forall>\<Phi>. \<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<otimes> FOA (\<one>\<^isub>F) \<turnstile> \<Phi>"
  proof(rule allI)
    fix \<Phi>
    show "\<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<otimes> FOA (\<one>\<^isub>F) \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      thus ?case
        apply(subst HOSComposeJudge)
        apply(subst HOSImp.simps)
        apply(subst canon.hoassertFOA_hocondIgnore_hoclauseresIgnore_hoclauseIgnore_hopsiIgnore_hoinputIgnore_hopsiCaseIgnore.simps)
        apply(subst (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
        by(rule allE[OF conjunct2[OF Identity]])
    next
      case(cHOC T P)
      thus ?case
        apply(subst HOSComposeJudge)
        by simp
    qed
  qed
next
  show "\<forall>\<Phi>. \<Psi> \<otimes> FOA (\<one>\<^isub>F) \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<turnstile> \<Phi>"
  proof(rule allI)
    fix \<Phi>
    show "\<Psi> \<otimes> FOA (\<one>\<^isub>F) \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      thus ?case
        apply(subst HOSComposeJudge)
        apply(subst HOSImp.simps)
        apply(subst canon.hoassertFOA_hocondIgnore_hoclauseresIgnore_hoclauseIgnore_hopsiIgnore_hoinputIgnore_hopsiCaseIgnore.simps)
        apply(subst (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
        by(rule allE[OF conjunct1[OF Identity]])
    next
      case(cHOC T P)
      thus ?case
        apply(subst HOSComposeJudge)
        by simp
    qed
  qed
qed

lemma HOSIdentity:
shows "assertionAux.AssertionStatEq HOSImp (\<Psi> \<otimes> \<one>) \<Psi>"
unfolding assertionAux.AssertionStatEq_def[OF HOassertionAux] assertionAux.AssertionStatImp_def[OF HOassertionAux]
by(rule HOSIdentity')

lemma HOSTransitivity':
  shows
  "(\<forall>\<Phi>. ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi> \<longrightarrow> ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi>)"
proof(rule conjI)
  show "\<forall>\<Phi>. ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi>"
  proof(rule allI)
    fix \<Phi>
    show "((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      have "hoassertFOA \<Psi>'' \<otimes>\<^isub>F hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F \<longrightarrow>
    (hoassertFOA \<Psi>'' \<otimes>\<^isub>F hoassertFOA \<Psi>') \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
        by(rule_tac allE[OF conjunct2[OF Associativity]])
      thus ?case
        by(simp add: HOSComposeFOA)
    next
      case(cHOC T Q)
      thus ?case
        by(simp add: HOSComposeHOASet HOSComposeHOA' HOSComposeHOA'')
    qed
  qed
next
  show "\<forall>\<Phi>. (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi> \<longrightarrow> ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi>"
  proof(rule allI)
    fix \<Phi>
    show "(\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>'')) \<turnstile> \<Phi> \<longrightarrow> ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      have "(hoassertFOA \<Psi>'' \<otimes>\<^isub>F hoassertFOA \<Psi>') \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F \<longrightarrow>
    hoassertFOA \<Psi>'' \<otimes>\<^isub>F hoassertFOA \<Psi>' \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
        by(rule_tac allE[OF conjunct1[OF Associativity]])
      thus ?case
        by(simp add: HOSComposeFOA)
    next
      case(cHOC T Q)
      thus ?case
        by(simp add: HOSComposeHOASet HOSComposeHOA' HOSComposeHOA'')
    qed
  qed
qed

lemma HOSTransitivity:
shows "assertionAux.AssertionStatEq HOSImp ((\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>'') (\<Psi> \<otimes> (\<Psi>' \<otimes> \<Psi>''))"
unfolding assertionAux.AssertionStatEq_def[OF HOassertionAux] assertionAux.AssertionStatImp_def[OF HOassertionAux]
by(rule HOSTransitivity')

lemma HOSCommutativity':
  shows
  "(\<forall>\<Phi>. (\<Psi> \<otimes> \<Psi>') \<turnstile> \<Phi> \<longrightarrow> (\<Psi>' \<otimes> \<Psi>) \<turnstile> \<Phi>) \<and> (\<forall>\<Phi>. (\<Psi>' \<otimes> \<Psi>) \<turnstile> \<Phi> \<longrightarrow> (\<Psi> \<otimes> \<Psi>') \<turnstile> \<Phi>)"
proof(rule conjI)
  show "\<forall>\<Phi>. ((\<Psi> \<otimes> \<Psi>') \<turnstile> \<Phi> \<longrightarrow> (\<Psi>' \<otimes> \<Psi>) \<turnstile> \<Phi>)"
  proof(rule allI)
    fix \<Phi>
    show "(\<Psi> \<otimes> \<Psi>') \<turnstile> \<Phi> \<longrightarrow> (\<Psi>' \<otimes> \<Psi>) \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      thus ?case
        apply(subst (1 2) HOSComposeJudge)
        apply(subst (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
        by(rule allE[OF conjunct1[OF Commutativity]])
    next
      case(cHOC T P)
      thus ?case
        apply(subst (1 2) HOSComposeJudge)
        by(simp add: disj_commute)
    qed
  qed
next
  show "\<forall>\<Phi>. \<Psi>' \<otimes> \<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<otimes> \<Psi>' \<turnstile> \<Phi>"
  proof(rule allI)
    fix \<Phi>
    show "\<Psi>' \<otimes> \<Psi> \<turnstile> \<Phi> \<longrightarrow> \<Psi> \<otimes> \<Psi>' \<turnstile> \<Phi>"
    proof(nominal_induct \<Phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      thus ?case
        apply(subst (1 2) HOSComposeJudge)
        apply(subst (1 2) hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps)
        by(rule allE[OF conjunct1[OF Commutativity]])
    next
      case(cHOC T P)
      thus ?case
        apply(subst (1 2) HOSComposeJudge)
        by(simp add: disj_commute)
    qed
  qed
qed

lemma HOSCommutativity:
shows "assertionAux.AssertionStatEq HOSImp (\<Psi> \<otimes> \<Psi>') (\<Psi>' \<otimes> \<Psi>)"
unfolding assertionAux.AssertionStatEq_def[OF HOassertionAux] assertionAux.AssertionStatImp_def[OF HOassertionAux]
by(rule HOSCommutativity')

lemma HOassertion: "assertion HOSCompose HOSImp HOSBottom HOSChanEq HOSClause"
apply(unfold_locales)
apply(rule eqvts)+
apply(rule HOchanEqSym, assumption)
apply(rule HOchanEqTrans, assumption, assumption)
apply(rule HOSComposition, assumption)
apply(rule HOSIdentity)
apply(rule HOSTransitivity)
apply(rule HOSCommutativity)
by simp

lemma substHOAssert: "substType hoassertSubst"
apply(unfold_locales)
apply(rule eqvts)
by(rule HORenaming)

lemma substHOCond: "substType hocondSubst"
apply(unfold_locales)
apply(rule eqvts)
by(rule HORenaming)

lemma hoEnv: "env FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause"
apply(unfold_locales)
apply(rule eqvts)
apply(rule HORenaming,assumption+)
apply(rule eqvts)
apply(rule HORenaming,assumption+)
apply(rule eqvts)+
apply(rule HOchanEqSym, assumption)
apply(rule HOchanEqTrans, assumption, assumption)
apply(rule HOSComposition, assumption)
apply(rule HOSIdentity)
apply(rule HOSTransitivity)
apply(rule HOSCommutativity)
by simp

abbreviation
  hoclauseJudge ("_\<lparr>_" [80,80] 80) where "M\<lparr>P \<equiv> Clause M P"

abbreviation
  bisimJudge ("_ \<rhd> _ \<sim> _" [70, 70, 70] 65) where "\<Psi> \<rhd> P \<sim> Q \<equiv> (\<Psi>, P, Q) \<in> env.bisim FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause"

abbreviation sumAssertJudge ("_ \<oplus>\<^sub>_ _" [150, 50, 50] 150) 
  where "(P::('a, ('a,'b,'c) hoassert, ('a,'b,'c) hocond) psi) \<oplus>\<^sub>\<phi> Q \<equiv> Cases [(\<phi>, P), (\<phi>, Q)]"

lemma memAppend:
  "set (A@B) e = (set A e \<or> set B e)"
  by auto

lemma suppNameless: "(supp(\<bottom>)::name set) = {}" using permNameless
  by(simp add: supp_def)

lemma freshNameless[simp]: "(a::name) \<sharp> \<bottom> = True"
  unfolding fresh_def suppNameless
  by simp

lemma freshNamelessChain[simp]:
  fixes xvec :: "name list"
  shows "xvec \<sharp>* (\<bottom>) = True"
by(induct xvec) simp+

lemma suppUnit: "(supp(\<one>\<^isub>F)::name set) = {}" using permBottom
  by(simp add: supp_def)

lemma freshUnit[simp]: "(a::name) \<sharp> \<one>\<^isub>F = True"
  unfolding fresh_def suppUnit
  by simp

lemma freshUnitChain[simp]:
  fixes xvec :: "name list"
  shows "xvec \<sharp>* (\<one>\<^isub>F) = True"
by(induct xvec) simp+


lemma pairingSupp': "(supp((M\<langle>N\<rangle>)::'a)::name set) \<subseteq> supp(M) \<union> supp(N)"
proof(auto simp add: eqvts supp_def)
  fix x::name
  let ?P = "\<lambda>y. ([(x, y)] \<bullet> M)\<langle>([(x, y)] \<bullet> N)\<rangle> \<noteq> ((M\<langle>N\<rangle>)::'a)"
  let ?Q = "\<lambda>y M. ([(x, y)] \<bullet> M) \<noteq> M"
  assume "finite {y. ?Q y N}"
  moreover assume "finite {y. ?Q y M}" and "infinite {y. ?P(y)}"
  hence "infinite({y. ?P(y)} - {y. ?Q y M})" by(rule Diff_infinite_finite)
  ultimately have "infinite(({y. ?P(y)} - {y. ?Q y M}) - {y. ?Q y N})" by(rule Diff_infinite_finite)
  hence "infinite({y. ?P(y) \<and> \<not>(?Q y M) \<and> \<not> (?Q y N)})" by(simp add: set_diff_eq)
  moreover have "{y. ?P(y) \<and> \<not>(?Q y M) \<and> \<not> (?Q y N)} = {}" by auto
  ultimately have "infinite {}" by(drule_tac Infinite_cong) auto
  thus False by simp
qed

lemma pairingSupp: "(supp M) \<subseteq> (supp((M\<langle>N\<rangle>)::'a)::name set)"
proof(cases "supp M = ({}::name set)")
  assume "supp M = ({}::name set)"
  thus ?thesis
    by simp
next
  assume "supp M \<noteq> ({}::name set)"
  show ?thesis
  proof(rule ccontr)
    assume "\<not>(supp M \<subseteq> (supp (M\<langle>N\<rangle>::'a)::name set))"
    then obtain a::name where "a \<in> supp M" and "a \<notin> (supp (M\<langle>N\<rangle>::'a)::name set)"
      by auto
    obtain b::name where "a \<noteq> b" and "b \<sharp> M" and "b \<sharp> N"
      apply(rule at_exists_fresh[where x="(a, M, N)", OF at_name_inst])
      apply finite_guess
      by force
    have "a \<sharp> (M\<langle>N\<rangle>::'a)" using `a \<notin> (supp (M\<langle>N\<rangle>::'a)::name set)`
      by(subst fresh_def)
    have "b \<sharp> (M\<langle>N\<rangle>::'a)" using `b \<sharp> M` and `b \<sharp> N` pairingSupp'[where M=M and N=N]
      unfolding fresh_def
      by auto
    have "(M\<langle>N\<rangle>::'a) = (([(a,b)]\<bullet>M)\<langle>([(a,b)]\<bullet>N)\<rangle>)"
    proof -
      have "(M\<langle>N\<rangle>::'a) = ([(a,b)]\<bullet>(M\<langle>N\<rangle>))"
        by(simp add: `a \<sharp> (M\<langle>N\<rangle>::'a)` `b \<sharp> (M\<langle>N\<rangle>::'a)`)
      thus ?thesis unfolding eqvts
        by -
    qed
    hence meq: "M = ([(a,b)]\<bullet>M)"
      by(rule pairingEqPres)
    have "b \<in> supp M" using `a \<in> supp M`
      apply(subst meq)
      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
      by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
    thus False using `b \<sharp> M`
      unfolding fresh_def
      by simp
  qed
qed

lemma hoassertFOAJudge:
  "hoassertFOA(hoassertJudge \<Psi> L) = \<Psi>"
by(induct L) simp+


abbreviation characteristic where "characteristic \<equiv> env.characteristic HOSCompose HOSImp HOSClause"

lemma HOSImp'monoAdHoc:
  assumes "HOSImp' \<phi> (hoassertFOA (\<Psi>' \<otimes> \<Psi>))
        (hoassertHOA (\<Psi>' \<otimes> \<Psi>))"
  shows "HOSImp' \<phi> (hoassertFOA (\<Psi>' \<otimes> HOA Cl \<Psi>))
        (hoassertHOA (\<Psi>' \<otimes> HOA Cl \<Psi>))"
using assms
proof(nominal_induct \<phi> rule: hocondInduct)
  case (cFOC \<phi>) thus ?case
    by(nominal_induct \<Psi>' rule: hoassertInduct) auto
next
  case (cHOC M P)
  have "set (hoassertHOA (\<Psi>' \<otimes> \<Psi>)) \<subseteq> set (hoassertHOA (\<Psi>' \<otimes> HOA Cl \<Psi>))"
    by(nominal_induct \<Psi>' rule: hoassertInduct) auto
  thus ?case using cHOC
    by auto blast
qed

lemma adHocInject:
  assumes "length xvec = length Tvec"
  shows "(\<nu>*xvec\<rparr>N \<Leftarrow> (Q[xvec::=Tvec]) = CTrm M P) = (N=M \<and> Q=P \<and> xvec=[] \<and> Tvec=[])"
  using assms
proof(induct xvec)
  case Nil thus ?case
    by(auto simp add: HOemptySubst hoclauseres.inject)
next
  case(Cons x xvec) thus ?case
    by auto
qed

lemma HOSImp'AdHoc:
  assumes "\<not> HOSImp' \<phi> (hoassertFOA (\<Psi>' \<otimes> \<Psi>))
        (hoassertHOA (\<Psi>' \<otimes> \<Psi>))"
  and "HOSImp' \<phi> (hoassertFOA (\<Psi>' \<otimes> HOA (M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) \<Psi>))
        (hoassertHOA (\<Psi>' \<otimes> HOA (M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) \<Psi>))"
  shows "\<phi> = HOC (M\<^isub>a\<langle>\<bottom>\<rangle>) (\<sigma> P)"
using assms
proof(nominal_induct \<phi> rule: hocondInduct) 
  case (cFOC \<phi>) thus ?case
    by(nominal_induct \<Psi>' rule: hoassertInduct) auto
next
  case (cHOC M P) thus ?case
  proof(nominal_induct \<Psi>' rule: hoassertInduct)
    case(cFOA \<Psi>\<^isub>F)
    thus ?case
      by(auto simp add: adHocInject hoclause.inject termEmptySubst HOemptySubst) blast
  next
    case(cHOA Cl \<Psi>\<^isub>H)
    thus ?case
      by(auto simp add: adHocInject hoclause.inject termEmptySubst HOemptySubst) blast+
  qed
qed

lemma canonChar:
  assumes "\<And> P. P \<in> set Pvec \<Longrightarrow> (supp P::name set) \<subseteq> supp M\<^isub>a"
  and "Pvec \<noteq> []"
  shows "characteristic (hoassertJudge (\<one>\<^isub>F) (map (\<lambda> P. M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) Pvec)) (M\<^isub>a\<langle>\<bottom>\<rangle>) Pvec"
proof(rule_tac env.characteristicI[OF hoEnv])
  fix \<Psi> and P
  assume "\<Psi> \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
  thus "supp(M\<^isub>a\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
  proof(nominal_induct \<Psi> rule: hoassertInduct)
    case(cFOA \<Psi>\<^isub>F)
    thus ?case
      by simp
  next
    case(cHOA Cl \<Psi>\<^isub>H)
    let ?A = "\<exists>xvec Tvec.
      length xvec = length Tvec \<and>
      distinct xvec \<and>
      (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
      (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
      (Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)))"
    let ?B = "\<exists>xvec Tvec.
      length xvec = length Tvec \<and>
      distinct xvec \<and>
      (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
      (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
      ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P) \<in> set (hoassertHOA \<Psi>\<^isub>H) )))"
    have "?A \<or> ?B" using `HOA Cl \<Psi>\<^isub>H \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P`
      by simp blast
    from cHOA show ?case
    proof(cases ?A)
      assume ?A
      then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and cldef: "Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)"
        by auto
      from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
        by(rule pairingEqPres[symmetric])
      show ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
        unfolding cldef kdef
        by(force simp add: hoassert.supp hoclause.supp)
    next
      assume "\<not>?A"
      hence "?B" using `?A \<or> ?B`
        by blast
      then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and mem: "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P) \<in> set (hoassertHOA \<Psi>\<^isub>H) )"
        by auto
      from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
        by(rule pairingEqPres[symmetric])
      from mem have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp(hoassertHOA \<Psi>\<^isub>H)::name set)"
        by(induct rule: list.induct) (auto simp add: supp_list_cons hoassert.supp)
      moreover have "supp(hoassertHOA \<Psi>\<^isub>H) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"          
        by(nominal_induct rule: hoassertInduct) (auto simp add: supp_list_nil supp_list_cons hoassert.supp)
      ultimately have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"
        by simp
      thus ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
        unfolding kdef
        by(force simp add: hoassert.supp hoclause.supp)
    qed
  qed
next
  fix P
  show "(supp (M\<^isub>a\<langle>\<bottom>\<rangle>)::name set) \<subseteq> supp ((M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P)"
    by(auto simp add: hocond.supp)
next
  fix P P' M'
  show "((M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P = M' \<Leftarrow> P') = ((P = P') \<and> (M\<^isub>a\<langle>\<bottom>\<rangle> = M'))"
    by(auto simp add: hocond.inject injectPsiPresEq)
next
  show "(supp (M\<^isub>a\<langle>\<bottom>\<rangle>)::name set) = supp (hoassertJudge (\<one>\<^isub>F) (map (\<lambda> P. M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) Pvec))"
  proof -
    have "supp (hoassertJudge (\<one>\<^isub>F) (map (\<lambda> P. M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) Pvec)) = supp M\<^isub>a \<union> (supp Pvec::name set)" using `Pvec \<noteq> []`
      by(induct Pvec rule: list_nonempty_induct) (auto simp add: hoassert.supp hoclause.supp  hoclauseres.supp suppNameless supp_list_cons injectSupp suppUnit supp_list_nil)
    moreover have "(supp Pvec::name set) \<subseteq> supp M\<^isub>a" using `\<And> P. P \<in> set Pvec \<Longrightarrow> (supp P::name set) \<subseteq> supp M\<^isub>a`
      apply(subst pt_list_set_supp[symmetric, OF pt_name_inst, OF at_name_inst, OF fs_name_inst])
      apply(subst supp_of_fin_sets[OF pt_name_inst, OF at_name_inst, OF fs_name_inst])
      by auto
    ultimately show ?thesis using pairingSupp'[where M=M\<^isub>a and N=\<bottom>] pairingSupp[where M=M\<^isub>a and N=\<bottom>]
      by(auto simp add: suppNameless)
  qed
next
  fix \<Psi>' \<phi>
  show "\<Psi>' \<otimes> (hoassertJudge (\<one>\<^isub>F) (map (\<lambda> P. M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)) Pvec)) \<turnstile> \<phi> =
       ((\<exists>P. P \<in> set Pvec \<and> \<phi> = (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P) \<or> \<Psi>' \<turnstile> \<phi>)"
    using `Pvec \<noteq> []`
  proof(induct Pvec rule: list_nonempty_induct)
    case(single P)
    thus ?case
    proof(nominal_induct rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      thus ?case
        apply(auto simp add: HOSComposeFOA)
        apply(rule allE[OF conjunct1[OF Commutativity[where \<Psi>="\<one>\<^isub>F" and \<Psi>'="hoassertFOA \<Psi>'"]]])
        apply(drule mp)
        apply assumption
        apply(rule allE[OF conjunct1[OF Identity]])
        apply(drule mp)
        apply assumption
        apply assumption
        apply(rule allE[OF conjunct2[OF Identity]])
        apply(drule mp)
        apply assumption
        apply(rule allE[OF conjunct1[OF Commutativity[where \<Psi>'="\<one>\<^isub>F" and \<Psi>="hoassertFOA \<Psi>'"]]])
        apply(drule mp)
        apply assumption
        apply assumption
        done
    next
      case(cHOC T Q)
      thus ?case
        apply(auto simp add: HOSComposeHOASet hoclauseres.inject hoclause.inject hocond.inject adHocInject termEmptySubst HOemptySubst HOSImp'AdHoc)
        apply(drule_tac x=xvec in spec)
        apply(drule mp,assumption)
        apply(drule_tac x=Tvec in spec)
        apply(drule mp,assumption)
        apply(drule_tac x=K in spec)
        apply(drule_tac x=N in spec)
        apply auto
        apply(drule_tac x=xvec in spec)
        apply(drule mp,assumption)
        apply(drule_tac x=Tvec in spec)
        apply(drule mp,assumption)
        apply(drule_tac x=K in spec)
        apply(drule_tac x=N in spec)
        apply auto
        apply(rule_tac exI[where x="[]"])
        apply(rule_tac exI[where x="[]"])
        apply simp
        apply(rule_tac exI[where x="M\<^isub>a"])
        apply(rule_tac exI[where x="\<bottom>"])
        apply(simp add: termEmptySubst HOemptySubst)
        apply(rule_tac x=xvec in exI)
        apply(rule_tac x=Tvec in exI)
        apply(rule conjI,assumption)
        apply(rule conjI,assumption)
        apply(rule_tac x=K in exI)
        apply(rule_tac x=N in exI)
        by auto
    qed
  next
    case(cons P Pvec)
    thus ?case
      apply(auto simp add: HOSComposeHOASet hoclauseres.inject hoclause.inject hocond.inject adHocInject termEmptySubst HOemptySubst HOSImp'monoAdHoc HOSImp'AdHoc)
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x=xvec in exI)
      apply(rule_tac x=Tvec in exI)
      apply(rule conjI,assumption)
      apply(rule conjI,assumption)
      apply(rule_tac x=K in exI)
      apply(rule_tac x=N in exI)
      apply force
      apply(rule_tac x="[]" in exI)
      apply(rule_tac x="[]" in exI)
      apply(rule conjI,simp)
      apply(rule conjI,simp)
      apply(rule_tac x=M\<^isub>a in exI)
      apply(rule_tac x=\<bottom> in exI)
      by(simp add: HOemptySubst termEmptySubst)
  qed
qed

lemma hoSum:
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   P  :: "('a, ('a,'b,'c) hoassert, ('a,'b,'c) hocond) psi"
  and   Q  :: "('a, ('a,'b,'c) hoassert, ('a,'b,'c) hocond) psi"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  and   \<phi>  :: "('a,'b,'c) hocond"
  assumes "a \<sharp> P"
  and     "a \<sharp> Q"
  and     "guarded P"
  and     "guarded Q"
  and     "((supp P)::name set) \<subseteq> supp(M\<^isub>a\<langle>\<bottom>\<rangle>)"
  and     "((supp Q)::name set) \<subseteq> supp(M\<^isub>a\<langle>\<bottom>\<rangle>)"
  and     "\<not> env.clauseDom HOSClause \<phi>"
  and     "\<not>(a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>))"
  and     "\<And> \<Psi>. \<Psi> \<turnstile> \<phi>"
  shows   "\<Psi> \<rhd> (P \<oplus>\<^sub>\<phi> Q) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P),M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rbrace>))"
proof -
  interpret hoEnv: env FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause
    by(rule hoEnv)
  have "(supp P::name set) \<subseteq> supp M\<^isub>a" using `(supp P::name set) \<subseteq> supp (M\<^isub>a\<langle>\<bottom>\<rangle>)` pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
    by simp
  have "(supp Q::name set) \<subseteq> supp M\<^isub>a" using `(supp Q::name set) \<subseteq> supp (M\<^isub>a\<langle>\<bottom>\<rangle>)` pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
    by simp
  have "\<not>(a \<sharp> M\<^isub>a)" using `\<not>(a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>))` pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"]
    unfolding fresh_def not_not suppNameless
    by force
  have "supp (hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]) =
    (supp (M\<^isub>a\<langle>\<bottom>\<rangle>)::name set)" using `(supp P) \<subseteq> supp M\<^isub>a` `(supp Q) \<subseteq> supp M\<^isub>a` pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] suppUnit pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"]
    by(auto simp add: hoassert.supp hoclause.supp hoclauseres.supp injectSupp suppNameless)
  {
    fix \<Psi>::"('a,'b,'c) hoassert"
    and   \<phi>::"('a,'b,'c) hocond"
    assume "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)] \<turnstile> \<phi>"
    hence "\<phi> = (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P \<or> \<phi> = (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>"
    proof(nominal_induct rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      have "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F \<Longrightarrow> hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
      proof -
        assume "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
        hence "hoassertFOA \<Psi> \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          apply -
          apply(rule allE[OF conjunct1[OF Commutativity[where \<Psi>="\<one>\<^isub>F" and \<Psi>'="hoassertFOA \<Psi>"]]])
          by(erule mp)
        thus ?thesis
          apply -
          apply(rule allE[OF conjunct1[OF Identity]])
          by(erule mp)
      qed
      with cFOC show ?case
        by(simp add: HOSComposeFOA)
    next
      case(cHOC T Qa)
      {
(*
        fix   T::'a
          and M\<^isub>a::'a
          and Qa::"('a,'b,'c) hopsi"
          and P::"('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
          and Q::"('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
*)
        assume "\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa) \<in> (set (hoassertHOA \<Psi>)) \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> P) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> Q) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa)"
        then obtain xvec Tvec K N where "T = K\<langle>N[xvec::=Tvec]\<rangle>"
          and disj: "((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa) \<in> set (hoassertHOA \<Psi>)) \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> P) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> Q) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa)"
          and "length xvec = length Tvec"
          and "distinct xvec"
          and exists: "(\<exists>Q. Qa = Q[xvec::=Tvec])"
          by blast
        note disj
        moreover have "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> P) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa \<Longrightarrow> T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> P"
        proof -
          assume "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> P) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa"
          thus ?thesis using `T = K\<langle>N[xvec::=Tvec]\<rangle>` `length xvec = length Tvec`
            by(induct xvec) (simp add: hoclauseres.inject termEmptySubst)+
        qed
        moreover have "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> Q) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa \<Longrightarrow> T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> Q"
        proof -
          assume "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> Q) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa"
          thus ?thesis using `T = K\<langle>N[xvec::=Tvec]\<rangle>` `length xvec = length Tvec`
            by(induct xvec) (simp add: hoclauseres.inject termEmptySubst)+
        qed
        moreover have "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa) \<in> set (hoassertHOA \<Psi>)) \<Longrightarrow>
          (\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa) \<in> set (hoassertHOA \<Psi>) ))" using `T = K\<langle>N[xvec::=Tvec]\<rangle>` exists `length xvec = length Tvec` `distinct xvec`
          by blast
        ultimately have "T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> P \<or>
          T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> Q \<or>
          (\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa) \<in> set (hoassertHOA \<Psi>) ))"
          by blast
      }
      note rool = this
      show ?case using cHOC rool (*rool[where Qaa2=Qa and Ta2=T and Pa2=P and Qb2=Q and M\<^isub>a'2=M\<^isub>a]*)
        apply(simp add: HOSComposeHOASet memAppend hocond.inject hoclause.inject hoclauseres.inject)
        by(metis pairingEqPres)
    qed
  }
  note ents = this
  {
    fix \<Psi>::"('a,'b,'c) hoassert"
    and \<phi>::"('a,'b,'c) hocond"
    and p::"name prm"
    assume "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) [(p\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(p\<bullet>P)), (p\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (p\<bullet>Q))] \<turnstile> \<phi>"
    hence "\<phi> =  ((p\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> (p\<bullet>P) \<or> \<phi> = ((p\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> (p\<bullet>Q) \<or> \<Psi> \<turnstile> \<phi>"
      apply(subst perm_bool[where pi="rev p" and b="\<phi> = (p \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> p \<bullet> P \<or> \<phi> = (p \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> p \<bullet> Q \<or> \<Psi> \<turnstile> \<phi>",symmetric])
      apply(simp only: eqvts pt_rev_pi[OF pt_name_inst, OF at_name_inst])
      apply(rule ents[of "rev p\<bullet>\<Psi>" "rev p\<bullet>\<phi>"])
      apply(subst perm_bool[where pi="p",symmetric])
      by(simp only: eqvts pt_pi_rev[OF pt_name_inst, OF at_name_inst])
  }
  note entsp = this
  have "\<not> a \<sharp> ((M\<^isub>a\<langle>\<bottom>\<rangle>)::'a)" using `\<not> a \<sharp> M\<^isub>a` pairingSupp[where M="M\<^isub>a" and N="\<bottom>"]
    unfolding fresh_def not_not
    apply -
    by(rule subsetD)
  {
    fix \<Psi> and P
    assume "\<Psi> \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
    hence "supp(M\<^isub>a\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
    proof(nominal_induct \<Psi> rule: hoassertInduct)
      case(cFOA \<Psi>\<^isub>F)
      thus ?case
        by simp
    next
      case(cHOA Cl \<Psi>\<^isub>H)
      let ?A = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        (Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)))"
      let ?B = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P) \<in> set (hoassertHOA \<Psi>\<^isub>H) )))"
      have "?A \<or> ?B" using `HOA Cl \<Psi>\<^isub>H \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P`
        by simp blast
      from cHOA show ?case
      proof(cases ?A)
        assume ?A
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and cldef: "Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        show ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding cldef kdef
          by(force simp add: hoassert.supp hoclause.supp)
      next
        assume "\<not>?A"
        hence "?B" using `?A \<or> ?B`
          by blast
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and mem: "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P) \<in> set (hoassertHOA \<Psi>\<^isub>H) )"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        from mem have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp(hoassertHOA \<Psi>\<^isub>H)::name set)"
          by(induct rule: list.induct) (auto simp add: supp_list_cons hoassert.supp)
        moreover have "supp(hoassertHOA \<Psi>\<^isub>H) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"          
          by(nominal_induct rule: hoassertInduct) (auto simp add: supp_list_nil supp_list_cons hoassert.supp)
        ultimately have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"
          by simp
        thus ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding kdef
          by(force simp add: hoassert.supp hoclause.supp)
      qed
    qed
  }
  note EntSupp = this
  {
    fix F::"('a,'b,'c) hoassert frame"
    obtain A\<^isub>F \<Psi>\<^isub>F where "F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* a" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* P" and "A\<^isub>F \<sharp>* Q"
      by(rule freshFrame[where C="(a,M\<^isub>a,P,Q)"]) auto
    from `A\<^isub>F \<sharp>* a` have "a \<sharp> A\<^isub>F" by simp
    {
      fix \<phi>
      assume "hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
      obtain A\<^isub>G \<Psi>\<^isub>G where afdef: "(\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) = \<langle>A\<^isub>G, \<Psi>\<^isub>G\<rangle>" and "distinct A\<^isub>G" "A\<^isub>G \<sharp>* a" and "A\<^isub>G \<sharp>* M\<^isub>a" and "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* Q" and "A\<^isub>G \<sharp>* \<phi>"
        by(rule freshFrame[where C="(a,M\<^isub>a,P,Q,\<phi>)"]) auto
      from `A\<^isub>G \<sharp>* a` have "a \<sharp> A\<^isub>G" by simp
      obtain b::name where "b \<sharp> A\<^isub>G" and "b \<sharp> \<Psi>\<^isub>G" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> P" and "b \<sharp> Q"
        apply(rule at_exists_fresh[where x="(A\<^isub>G, M\<^isub>a, P, Q, \<Psi>\<^isub>G, \<phi>)", OF at_name_inst])
        apply finite_guess
        by force
      have fdef: "(\<langle>[a],hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rangle>) = (\<langle>[b],hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> P)), ([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> Q))]\<rangle>)"
        apply(subst frameChainAlpha'[where p="[(a,b)]"])
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] injectFresh `b \<sharp> P` `b \<sharp> Q` `b \<sharp> M\<^isub>a`)
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
      from `A\<^isub>G \<sharp>* \<phi>` `b \<sharp> A\<^isub>G` `b \<sharp> \<phi>` `b \<sharp> \<Psi>\<^isub>G` `hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>`
      have "hoEnv.FrameImp (hoEnv.mergeFrame (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rangle>)) \<phi>"
        unfolding fdef afdef
      proof(nominal_induct \<phi> rule: hocondInduct)
        case(cFOC \<phi>\<^isub>F)
        hence "\<Psi>\<^isub>G \<turnstile> (FOC \<phi>\<^isub>F)"
          apply -
          by(rule hoEnv.frameImpE)
        hence "hoassertFOA \<Psi>\<^isub>G \<turnstile>\<^isub>F \<phi>\<^isub>F"
          by simp
        hence "hoassertFOA \<Psi>\<^isub>G \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          apply -
          apply(rule allE[OF conjunct2[OF Identity[where \<Psi>="hoassertFOA \<Psi>\<^isub>G"]]])
          by(drule mp)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)" using `A\<^isub>G \<sharp>* Q`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "b \<sharp> \<phi>\<^isub>F" using `b \<sharp> FOC \<phi>\<^isub>F`
          by simp
        show ?case
          apply(subst hoEnv.mergeFrames)
          apply(simp add: `b \<sharp> A\<^isub>G`)
          apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh injectFreshStar hoclauseFresh hoclauseresFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)`)
          apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
          apply(rule hoEnv.frameImpI[OF refl])
          apply(simp add: cFOC `b \<sharp> \<phi>\<^isub>F`)
          apply(simp add: HOSComposeFOA' `hoassertFOA \<Psi>\<^isub>G \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F`)
          done
      next
        case(cHOC T R)
        hence "\<Psi>\<^isub>G \<turnstile> (HOC T R)"
          apply -
          by(rule hoEnv.frameImpE)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)" using `A\<^isub>G \<sharp>* Q`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "b \<sharp> T" and "b \<sharp> R" using `b \<sharp> HOC T R` by simp+
        show ?case using `\<Psi>\<^isub>G \<turnstile> (HOC T R)`
          apply(subst hoEnv.mergeFrames)
          apply(simp add: `b \<sharp> A\<^isub>G`)
          apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh injectFreshStar hoclauseFresh hoclauseresFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)`)
          apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
          apply(rule hoEnv.frameImpI[OF refl])
          apply(simp add: cHOC `b \<sharp> T` `b \<sharp> R`)
          apply(subst HOSComposeJudge)
          apply(simp add: memAppend)
          apply blast
          done
      qed
    }
    note w1 = this
    {
      fix \<phi>
      assume faimp: "hoEnv.FrameImp (hoEnv.mergeFrame (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rangle>)) \<phi>"
      obtain A\<^isub>G \<Psi>\<^isub>G where afdef: "(\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) = \<langle>A\<^isub>G, \<Psi>\<^isub>G\<rangle>" and "distinct A\<^isub>G" "A\<^isub>G \<sharp>* a" and "A\<^isub>G \<sharp>* M\<^isub>a" and "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* Q" and "A\<^isub>G \<sharp>* \<phi>"
        by(rule freshFrame[where C="(a,M\<^isub>a,P,Q,\<phi>)"]) auto
      from `A\<^isub>G \<sharp>* a` have "a \<sharp> A\<^isub>G" by simp
      obtain b::name where "b \<sharp> A\<^isub>G" and "b \<sharp> \<Psi>\<^isub>G" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> P" and "b \<sharp> Q"
        apply(rule at_exists_fresh[where x="(A\<^isub>G, M\<^isub>a, P, Q, \<Psi>\<^isub>G, \<phi>)", OF at_name_inst])
        apply finite_guess
        by force
      have fdef: "(\<langle>[a],hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rangle>) = (\<langle>[b],hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> P)), ([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> Q))]\<rangle>)"
        apply(subst frameChainAlpha'[where p="[(a,b)]"])
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] injectFresh `b \<sharp> P` `b \<sharp> Q` `b \<sharp> M\<^isub>a`)
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)" using `A\<^isub>G \<sharp>* Q`
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
      from faimp have "\<Psi>\<^isub>G \<otimes> hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>([(a,b)] \<bullet> P)), ([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>([(a,b)] \<bullet> Q))] \<turnstile> \<phi>"
        unfolding fdef afdef
        apply -
        apply(subst (asm) hoEnv.mergeFrames)
        apply(simp add: `b \<sharp> A\<^isub>G`)
        apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> Q)` `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh hoclauseFresh hoclauseresFresh injectFreshStar)
        apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
        apply(rule hoEnv.frameImpE)
        apply assumption
        apply(simp add: `b \<sharp> \<phi>` `A\<^isub>G \<sharp>* \<phi>`)
        done
      hence "\<phi> =  (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>P) \<or> \<phi> = (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>Q) \<or> \<Psi>\<^isub>G \<turnstile> \<phi>"
        by(rule entsp)
      moreover have "\<Psi>\<^isub>G \<turnstile> \<phi> \<Longrightarrow> hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>" using `A\<^isub>G \<sharp>* \<phi>`
        unfolding afdef
        apply -
        by(rule hoEnv.frameImpI[OF refl])
      moreover have "\<phi> = (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>P) \<Longrightarrow> hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
      proof -
        assume ass: "\<phi> = ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> [(a, b)] \<bullet> P"
        have "\<not> b \<sharp> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)"
        proof -
          have "\<not> a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)" using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] using pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] `\<not> a \<sharp> M\<^isub>a`
            unfolding fresh_def
            by auto
          thus ?thesis
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        qed
        hence "\<not> b \<sharp> \<phi>" unfolding ass
          by simp
        hence False using `b \<sharp> \<phi>` by simp
        thus ?thesis by(rule FalseE)
      qed
      moreover have "\<phi> = (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>Q) \<Longrightarrow> hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
      proof -
        assume ass: "\<phi> = ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> [(a, b)] \<bullet> Q"
        have "\<not> b \<sharp> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)"
        proof -
          have "\<not> a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)" using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] using pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] `\<not> a \<sharp> M\<^isub>a`
            unfolding fresh_def
            by auto
          thus ?thesis
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        qed
        hence "\<not> b \<sharp> \<phi>" unfolding ass
          by simp
        hence False using `b \<sharp> \<phi>` by simp
        thus ?thesis by(rule FalseE)
      qed
      ultimately have "hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
        by blast
    }
    note w2 = this
    have "hoEnv.FrameStatEq (hoEnv.mergeFrame F (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P), M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Q)]\<rangle>)) F"
      unfolding `F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>` hoEnv.FrameStatEq_def hoEnv.FrameStatImp_def
      apply(rule conjI)
      apply(rule allI)
      apply(rule impI)
      apply(rule w2)
      apply assumption
      apply(rule allI)
      apply(rule impI)
      apply(rule w1)
      apply assumption
      done
  }
  note seq = this
  show ?thesis
    apply(rule env.hosum)
    apply(rule hoEnv)
    apply fact+
    apply simp
    apply(rule_tac x="[]" in exI)
    apply(rule_tac x="[]" in exI)
    apply(rule conjI,simp)
    apply(rule conjI,simp)
    apply(rule_tac x="M\<^isub>a" in exI)
    apply(rule_tac x="\<bottom>" in exI)
    apply(simp add: termEmptySubst HOemptySubst HOSComposeHOASet memAppend)
    apply simp
    apply(rule_tac x="[]" in exI)
    apply(rule_tac x="[]" in exI)
    apply(rule conjI,simp)
    apply(rule conjI,simp)
    apply(rule_tac x="M\<^isub>a" in exI)
    apply(rule_tac x="\<bottom>" in exI)
    apply(simp add: termEmptySubst HOemptySubst HOSComposeHOASet memAppend)
    apply(rule ents, assumption)
    apply(rule seq)
    apply fact+
    apply(simp add: hocond.inject injectPsiPresEq)
    by(rule EntSupp)
qed

lemma hoclauseChainJudgeInject:
  assumes "CTrm L Q = \<nu>*xvec\<rparr>M \<Leftarrow> P "
  shows "xvec = []"
  and   "M = L"
  and "P = Q"
using assms
by(induct xvec) (simp add: hoclauseres.inject)+

lemma hoassertJudgeFresh:
  fixes x :: "name"
  shows "x \<sharp> (hoassertJudge \<Psi> Cl) = (x \<sharp> \<Psi> \<and> x \<sharp> Cl)"
by(induct \<Psi> Cl rule: hoassertJudge.induct, auto)

lemma hoassertJudgeFreshChain:
  fixes xvec :: "name list"
  shows "xvec \<sharp>* (hoassertJudge \<Psi> Cl) = (xvec \<sharp>* \<Psi> \<and> xvec \<sharp>* Cl)"
by(induct xvec, auto simp add: hoassertJudgeFresh)

lemma hocase:
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   CsP :: "(('a,'b,'c) hocond \<times> ('a, ('a, 'b, 'c) hoassert, ('a, 'b, 'c) hocond) psi) list"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  assumes "a \<sharp> CsP"
  and     "((supp CsP)::name set) \<subseteq> supp M\<^isub>a"
  and     "\<And> \<phi> P. (\<phi>,P) \<in> set CsP  \<Longrightarrow> guarded P"
  and     "\<not>(a \<sharp> M\<^isub>a)"
  shows "\<Psi> \<rhd> (Cases CsP) \<sim> (\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>,P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))) CsP)\<rbrace>))"
proof -
  interpret hoEnv: env FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause
    by(rule hoEnv)
  have mabsupp: "supp(M\<^isub>a\<langle>\<bottom>\<rangle>) = (supp M\<^isub>a::name set)" using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] and pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] and suppNameless
    by simp
  have "((supp CsP)::name set) \<subseteq> supp(M\<^isub>a\<langle>\<bottom>\<rangle>)"
    unfolding mabsupp by fact
  have "\<not>(a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>))" using `\<not>(a \<sharp> M\<^isub>a)`
    unfolding fresh_def mabsupp
    by -
  {
    fix \<Psi> and \<phi> and P
    assume asm: "(\<phi>,P) \<in> set CsP"
    have "guarded P \<and> \<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c"
    proof -
      have "guarded P" using asm
        thm assms
        by(rule assms)
      moreover have "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c" using asm
        apply(simp add: HOSComposeHOASet memAppend)
        apply(rule exI[where x="[]"])
        apply(rule exI[where x="[]"])
        apply(rule conjI,simp)
        apply(rule conjI,simp)
        apply(rule exI[where x="M\<^isub>a"])
        apply(rule exI[where x="\<bottom>"])
        apply(rule conjI, simp add: termEmptySubst)
        apply(rule conjI)
        apply(simp add: HOemptySubst)
        apply(rule disjI2)
        by(induct CsP) auto
      ultimately show ?thesis
        by simp
    qed
  }
  note MemEnt = this
  {
    fix \<Psi> and \<phi>
    assume "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> \<phi>"
    hence "(\<exists>\<phi>' P. (\<phi>', P) \<in> set CsP \<and> \<phi> = (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> Case \<box> \<phi>' \<Rightarrow> P \<bottom>\<^sub>c ) \<or> \<Psi> \<turnstile> \<phi>"
    proof(nominal_induct \<phi> rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      have hofeq: "hoassertFOA (hoassertJudge (\<one>\<^isub>F)
          (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)) = \<one>\<^isub>F"
        by(induct CsP) simp+
      from cFOC have "\<Psi> \<turnstile> FOC \<phi>\<^isub>F"
        apply(subst HOSImp.simps)
        unfolding HOSComposeJudge hoassertIgnore'''_HOSImp'_hoclauseresIgnore'''_hoclauseIgnore'''_hopsiIgnore'''_hoinputIgnore'''_hopsiCaseIgnore'''.simps hofeq
        apply(rule allE[OF conjunct1[OF Identity]])
        by(erule mp)
      thus ?case by simp
    next
      case(cHOC T Q)
      {
        fix T::'a
          and Q::"('a,'b,'c) hopsi"
        assume
          disj: "\<exists>xvec Tvec.
          ((length xvec = length Tvec) \<and>
          distinct xvec \<and>
          (\<exists>(K::'a) (N::'a). T = (K\<langle>N[xvec::=Tvec]\<rangle>) \<and>
          (\<exists>Qa. Q = Qa[xvec::=Tvec]) \<and>
          ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Q)) \<in> set (hoassertHOA \<Psi>) \<or> (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Q)) \<in> set (hoassertHOA (hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP))) )))"
        let ?A = "\<exists>xvec Tvec.
          ((length xvec = length Tvec) \<and>
          distinct xvec \<and>
          (\<exists>(K::'a) (N::'a). T = (K\<langle>N[xvec::=Tvec]\<rangle>) \<and>
          (\<exists>Qa. Q = Qa[xvec::=Tvec]) \<and>
          ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Q)) \<in> set (hoassertHOA \<Psi>) )))"
        let ?B = "\<exists>xvec Tvec.
          ((length xvec = length Tvec) \<and>
          distinct xvec \<and>
          (\<exists>(K::'a) (N::'a). T = (K\<langle>N[xvec::=Tvec]\<rangle>) \<and>
          (\<exists>Qa. Q = Qa[xvec::=Tvec]) \<and>
          ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Q)) \<in> set (hoassertHOA (hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP))) )))"
        from disj have "?A \<or> ?B"
          by blast
        hence "\<Psi> \<turnstile> HOC T Q \<or> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> HOC T Q"
          by simp
      }
      note disj=this
      from cHOC have disj: "\<Psi> \<turnstile> HOC T Q \<or> hoassertJudge (\<one>\<^isub>F)
   (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> HOC T Q"
        apply -
        by(rule disj) (simp add: HOSComposeHOASet memAppend)
      thus ?case
      proof(cases "\<Psi> \<turnstile> HOC T Q")
        case True
        thus ?thesis by simp
      next
        case False
        hence "hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP) \<turnstile> HOC T Q" using disj
          by blast
        thus ?thesis
        proof(induct CsP)
          case Nil
          hence False by simp
          thus ?case by(rule FalseE)
        next
          case(Cons a CsP)
          let ?C = "hoassertJudge (\<one>\<^isub>F)
   (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) [a]) \<turnstile> HOC T Q"
          let ?D = "hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) (CsP)) \<turnstile> HOC T Q"
          from `hoassertJudge (\<one>\<^isub>F)
   (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) (a # CsP)) \<turnstile> HOC T Q`
          have "?C \<or> ?D"
            by simp blast
          thus ?case
          proof(cases ?C)
            assume ?C
            thus ?thesis
              apply(induct a)
              apply(auto simp add: hocond.inject hoclause.inject)
              apply(frule hoclauseChainJudgeInject(1)[OF sym])
              apply(frule hoclauseChainJudgeInject(2)[OF sym])
              apply(frule hoclauseChainJudgeInject(3)[OF sym])
              apply(auto simp add: termEmptySubst HOemptySubst)
              done
          next
            assume "\<not>?C"
            hence ?D using `?C \<or> ?D`
              by blast
            thus ?thesis
              apply -
              by(frule Cons) auto
          qed
        qed
      qed
    qed
  }
  note EntMem = this
  {
    fix \<Psi> and P and M\<^isub>a
    assume "\<Psi> \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
    hence "supp(M\<^isub>a\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
    proof(nominal_induct \<Psi> rule: hoassertInduct)
      case(cFOA \<Psi>\<^isub>F)
      thus ?case
        by simp
    next
      case(cHOA Cl \<Psi>\<^isub>H)
      let ?A = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        (Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)))"
      let ?B = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<in> set (hoassertHOA \<Psi>\<^isub>H) ))"
      have "?A \<or> ?B" using `HOA Cl \<Psi>\<^isub>H \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P`
        by simp blast
      from cHOA show ?case
      proof(cases ?A)
        assume ?A
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and cldef: "Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        show ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding cldef kdef
          by(force simp add: hoassert.supp hoclause.supp)
      next
        assume "\<not>?A"
        hence "?B" using `?A \<or> ?B`
          by blast
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and mem: "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<in> set (hoassertHOA \<Psi>\<^isub>H)"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        from mem have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (hoassertHOA \<Psi>\<^isub>H)::name set)"
          by(induct rule: list.induct[where list="hoassertHOA \<Psi>\<^isub>H"]) (auto simp add: supp_list_cons)
        moreover have "supp(hoassertHOA \<Psi>\<^isub>H) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"          
          by(nominal_induct rule: hoassertInduct) (auto simp add: supp_list_nil supp_list_cons hoassert.supp)
        ultimately have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"
          by simp
        thus ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding kdef
          by(force simp add: hoassert.supp hoclause.supp)
      qed
    qed
  }
  note EntSupp = this
  {
    fix F::"('a,'b,'c) hoassert frame"
    have "hoEnv.FrameStatEq (hoEnv.mergeFrame F (\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>)) F"
    proof -
      {
        fix \<phi>::"('a,'b,'c) hocond"
        assume "hoEnv.FrameImp F \<phi>"
        obtain A\<^isub>F \<Psi>\<^isub>F where fdef: "F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* a" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* CsP" and "A\<^isub>F \<sharp>* \<phi>"
          by(rule freshFrame[where C="(a,M\<^isub>a,CsP,\<phi>)"]) auto
        from `A\<^isub>F \<sharp>* a` have "a \<sharp> A\<^isub>F" by simp
        obtain b :: name where "b \<sharp> F" and "b \<sharp> A\<^isub>F" and "b \<sharp> \<Psi>\<^isub>F" and "b \<sharp> M\<^isub>a" and "b \<noteq> a" and "b \<sharp> CsP" and "b \<sharp> \<phi>"
          apply(rule at_exists_fresh[where x="(a, F, A\<^isub>F,\<Psi>\<^isub>F,M\<^isub>a,CsP,\<phi>)", OF at_name_inst])
          apply finite_guess
          by force
        have bfresh: "b \<sharp> map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase))) CsP" using `b \<sharp> CsP`
        proof(induct CsP)
          case Nil thus ?case by simp
        next
          case(Cons C CsP) thus ?case
          proof(induct C)
            case(Pair fs sn) thus ?case
              by(simp add: injectFresh `b \<sharp> M\<^isub>a`)
          qed
        qed
        {
          fix E :: "('a,'b,'c) hocond \<times> ('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
          have "([(a, b)] \<bullet> (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))) E = (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase))) E"
          proof(induct E)
            case(Pair \<Psi> P)
            have psipd: "(\<Psi>,P) = [(a,b)]\<bullet>([(a,b)]\<bullet>(\<Psi>,P))"
              by simp
            show ?case
              apply(subst psipd)
              apply(subst pt_fun_app_eq[symmetric, OF pt_name_inst, OF at_name_inst])
              by(simp add: eqvts)
          qed
        }
        note fEq = this
        have lameq: "([(a, b)] \<bullet> (\<lambda>((\<phi>::('a,'b,'c) hocond), P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))) = (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))"
          apply(subst fun_eq_iff)
          apply(rule allI)
          by(rule fEq)
        have bdef: "(\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>) = (\<langle>[b], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>CsP))\<rangle>)"
          apply(subst frameChainAlpha'[where p="[(a,b)]"])
          apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] hoassertJudgeFresh bfresh)
          apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
          by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] eqvts lameq)
        have cspabd:"[(a,b)]\<bullet>CsP = CsP" using `a \<sharp> CsP` `b \<sharp> CsP`
          by simp
        have aff: "A\<^isub>F \<sharp>* hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a, b)] \<bullet> CsP))" using `A\<^isub>F \<sharp>* CsP`
          unfolding cspabd
        proof(induct CsP)
          case Nil thus ?case by(simp add: hoassertFresh)
        next
          case(Cons C CsP)
          thus ?case
          proof(induct C)
            case(Pair \<phi> P)
            have afeq: "A\<^isub>F = ([(a,b)])\<bullet>A\<^isub>F" using `a \<sharp> A\<^isub>F` `b \<sharp> A\<^isub>F`
              by simp
            have "A\<^isub>F \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)"
              apply(subst afeq)
              apply(subst fresh_star_bij)
              by fact
            with Pair show ?case
              by(simp add: hoassertFresh hocondFresh hoclauseFresh hoclauseresFresh hopsiFresh injectFreshStar)
          qed
        qed
        from `hoEnv.FrameImp F \<phi>` have "hoEnv.FrameImp (hoEnv.mergeFrame F (\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>)) \<phi>" using `b \<sharp> \<phi>` `A\<^isub>F \<sharp>* \<phi>`
        proof(nominal_induct \<phi> rule: hocondInduct)
          case(cFOC \<phi>\<^isub>F)
          have "hoassertFOA \<Psi>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          proof -
            from `hoEnv.FrameImp F (FOC \<phi>\<^isub>F)` have "\<Psi>\<^isub>F \<turnstile> FOC \<phi>\<^isub>F"
              unfolding fdef
              apply(rule hoEnv.frameImpE)
              by fact
            thus ?thesis by simp
          qed
          hence "hoassertFOA \<Psi>\<^isub>F \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
            apply -
            apply(rule allE[OF conjunct2[OF Identity]])
            by(rule mp)
          hence gl: "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
            apply -
            apply(rule allE[OF conjunct1[OF Commutativity]])
            by(rule mp)
          from cFOC show ?case
            unfolding fdef bdef
            apply(subst hoEnv.mergeFrames)
            apply(simp add: `b \<sharp> A\<^isub>F`)
            apply(rule aff)
            apply(simp add: `b \<sharp> \<Psi>\<^isub>F`)
            apply(rule hoEnv.frameImpI[OF refl])
            apply simp
            apply(simp add: HOSComposeFOA hoassertFOAJudge gl)
            done
        next
          case(cHOC H \<Psi>)
          from `hoEnv.FrameImp F (HOC H \<Psi>)` have "\<Psi>\<^isub>F \<turnstile> (HOC H \<Psi>)"
            unfolding fdef
            apply(rule hoEnv.frameImpE)
            by fact
          with cHOC show ?case unfolding fdef bdef
            apply(subst hoEnv.mergeFrames)
            apply(simp add: `b \<sharp> A\<^isub>F`)
            apply(rule aff)
            apply(simp add: `b \<sharp> \<Psi>\<^isub>F`)
            apply(rule hoEnv.frameImpI[OF refl])
            apply simp
            by(simp add: HOSComposeHOASet memAppend) blast
        qed
      }
      note lhs = this
      {
        fix \<phi>::"('a,'b,'c) hocond"
        assume "hoEnv.FrameImp (hoEnv.mergeFrame F (\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>)) \<phi>"
        obtain A\<^isub>F \<Psi>\<^isub>F where fdef: "F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* a" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* CsP" and "A\<^isub>F \<sharp>* \<phi>"
          by(rule freshFrame[where C="(a,M\<^isub>a,CsP,\<phi>)"]) auto
        from `A\<^isub>F \<sharp>* a` have "a \<sharp> A\<^isub>F" by simp
        obtain b :: name where "b \<sharp> F" and "b \<sharp> A\<^isub>F" and "b \<sharp> \<Psi>\<^isub>F" and "b \<sharp> M\<^isub>a" and "b \<noteq> a" and "b \<sharp> CsP" and "b \<sharp> \<phi>"
          apply(rule at_exists_fresh[where x="(a, F, A\<^isub>F,\<Psi>\<^isub>F,M\<^isub>a,CsP,\<phi>)", OF at_name_inst])
          apply finite_guess
          by force
        have bfresh: "b \<sharp> map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase))) CsP" using `b \<sharp> CsP`
        proof(induct CsP)
          case Nil thus ?case by simp
        next
          case(Cons C CsP) thus ?case
          proof(induct C)
            case(Pair fs sn) thus ?case
              by(simp add: injectFresh `b \<sharp> M\<^isub>a`)
          qed
        qed
        {
          fix E :: "('a,'b,'c) hocond \<times> ('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
          have "([(a, b)] \<bullet> (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))) E = (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase))) E"
          proof(induct E)
            case(Pair \<Psi> P)
            have psipd: "(\<Psi>,P) = [(a,b)]\<bullet>([(a,b)]\<bullet>(\<Psi>,P))"
              by simp
            show ?case
              apply(subst psipd)
              apply(subst pt_fun_app_eq[symmetric, OF pt_name_inst, OF at_name_inst])
              by(simp add: eqvts)
          qed
        }
        note fEq = this
        have lameq: "([(a, b)] \<bullet> (\<lambda>((\<phi>::('a,'b,'c) hocond), P). M\<^isub>a\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))) = (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>CTrm (\<bottom>) (HOCase (HOCond \<phi> (\<sigma> P) HOEmptyCase)))"
          apply(subst fun_eq_iff)
          apply(rule allI)
          by(rule fEq)
        have bdef: "(\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>) = (\<langle>[b], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>CsP))\<rangle>)"
          apply(subst frameChainAlpha'[where p="[(a,b)]"])
          apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] hoassertJudgeFresh bfresh)
          apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
          by(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] eqvts lameq)
        have cspabd:"[(a,b)]\<bullet>CsP = CsP" using `a \<sharp> CsP` `b \<sharp> CsP`
          by simp
        have aff: "A\<^isub>F \<sharp>* hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a, b)] \<bullet> CsP))" using `A\<^isub>F \<sharp>* CsP`
          unfolding cspabd
        proof(induct CsP)
          case Nil thus ?case by(simp add: hoassertFresh)
        next
          case(Cons C CsP)
          thus ?case
          proof(induct C)
            case(Pair \<phi> P)
            have afeq: "A\<^isub>F = ([(a,b)])\<bullet>A\<^isub>F" using `a \<sharp> A\<^isub>F` `b \<sharp> A\<^isub>F`
              by simp
            have "A\<^isub>F \<sharp>* ([(a, b)] \<bullet> M\<^isub>a)"
              apply(subst afeq)
              apply(subst fresh_star_bij)
              by fact
            with Pair show ?case
              by(simp add: hoassertFresh hocondFresh hoclauseFresh hoclauseresFresh hopsiFresh injectFreshStar)
          qed
        qed
        from `hoEnv.FrameImp (hoEnv.mergeFrame F (\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>)) \<phi>` have "hoEnv.FrameImp F \<phi>" using `b \<sharp> \<phi>` `A\<^isub>F \<sharp>* \<phi>`
        proof(nominal_induct \<phi> rule: hocondInduct)
          case(cFOC \<phi>\<^isub>F)
          have "hoassertFOA \<Psi>\<^isub>F \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          proof -
            from `hoEnv.FrameImp (hoEnv.mergeFrame F (\<langle>[a], hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)\<rangle>)) (FOC \<phi>\<^isub>F)` have "\<Psi>\<^isub>F \<otimes> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a, b)] \<bullet> CsP)) \<turnstile> (FOC \<phi>\<^isub>F)" using `A\<^isub>F \<sharp>* FOC \<phi>\<^isub>F` `b \<sharp> FOC \<phi>\<^isub>F`
              unfolding fdef bdef
              apply(subst (asm) hoEnv.mergeFrames)
              apply(simp add: `b \<sharp> A\<^isub>F`)
              apply(rule aff)
              apply(simp add: `b \<sharp> \<Psi>\<^isub>F`)
              apply(rule hoEnv.frameImpE, assumption)
              by simp
            hence "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
              by(simp add: HOSComposeFOA hoassertFOAJudge)
            thus ?thesis
              apply -
              apply(rule allE[OF conjunct1[OF Commutativity]])
              by(rule mp)
          qed
          hence "hoassertFOA \<Psi>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
            apply -
            apply(rule allE[OF conjunct1[OF Identity]])
            by(rule mp)
          thus ?case
            unfolding fdef
            apply -
            apply(rule hoEnv.frameImpI[OF refl])
            apply(rule cFOC)
            by simp
        next
          case(cHOC M Q)
          hence "\<Psi>\<^isub>F \<otimes> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a, b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a, b)] \<bullet> CsP)) \<turnstile> HOC M Q"
            unfolding bdef fdef
            apply(subst (asm) hoEnv.mergeFrames)
            apply(simp add: `b \<sharp> A\<^isub>F`)
            apply(rule aff)
            apply(simp add: `b \<sharp> \<Psi>\<^isub>F`)
            apply(rule hoEnv.frameImpE, assumption)
            by simp
          hence disj: "\<Psi>\<^isub>F \<turnstile> HOC M Q \<or> hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>CsP)) \<turnstile> HOC M Q"
            apply(subst (asm) HOSComposeJudge)
            apply(subst (asm) hoassertFOAJudge)
            by(simp add: memAppend) blast
          show ?case
          proof(cases "\<Psi>\<^isub>F \<turnstile> HOC M Q")
            case True
            thus ?thesis
              apply -
              apply(rule hoEnv.frameImpI[OF fdef])
              by(rule cHOC)
          next
            case False
            hence "hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>CsP)) \<turnstile> HOC M Q" using disj by blast
            hence "M = ([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>"
            proof(induct CsP)
              case Nil thus ?case by simp
            next
              case(Cons C CsP)
              thus ?case
              proof(induct C)
                case(Pair \<phi> P)
                thus ?case
                proof(cases "HOSImp'' [([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> ([(a,b)]\<bullet>\<phi>) \<Rightarrow> ([(a,b)]\<bullet>P) \<bottom>\<^sub>c)] M Q")
                  case True
                  then obtain xvec Tvec K N Qa where "length xvec = length Tvec" and "distinct xvec" and meq: "M = K\<langle>N[xvec::=Tvec]\<rangle>" and "Q = Qa[xvec::=Tvec]" and big: "([(a, b)] \<bullet> M\<^isub>a)\<lparr>CTrm (\<bottom>) (HOCase (HOCond ([(a, b)] \<bullet> \<phi>) (\<sigma> [(a, b)] \<bullet> P) HOEmptyCase)) =
                    K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Q)"
                    by auto
                  have keq: "K = ([(a,b)]\<bullet>M\<^isub>a)" and xveceq: "xvec=[]" using big
                    apply -
                    apply(simp add: hoclause.inject)
                    apply(induct xvec)
                    by(simp add: hoclause.inject)+
                  have neq: "N = \<bottom>" and qeq: "Q = (HOCase (HOCond ([(a, b)] \<bullet> \<phi>) (\<sigma> [(a, b)] \<bullet> P) HOEmptyCase))" using big
                    unfolding keq xveceq
                    apply -
                    by(simp add: hoclause.inject hoclauseres.inject)+
                  have tveceq:"Tvec=[]" using `length xvec = length Tvec` `xvec = []`
                    by simp
                  show ?thesis
                    unfolding meq keq neq xveceq tveceq
                    apply(subst termEmptySubst)
                    by(rule refl)
                next
                  case False
                  hence "hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>CsP)) \<turnstile> HOC M Q" using `hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). ([(a,b)]\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) ([(a,b)]\<bullet>((\<phi>, P) # CsP))) \<turnstile> HOC M Q`
                    by(simp add: eqvts) blast
                  thus ?thesis by(rule Cons)
                qed
              qed
            qed
            moreover have "\<not> b \<sharp> (([(a,b)]\<bullet> M\<^isub>a)\<langle>\<bottom>\<rangle>)" using `\<not> a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)`
              apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
              by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
            ultimately have "b \<in> supp(HOC M Q)"
              unfolding fresh_def
              by(simp add: hocond.supp)
            moreover have "b \<notin> supp(HOC M Q)" using `b \<sharp> HOC M Q`
              unfolding fresh_def
              by -
            ultimately have False by simp
            thus ?thesis
              by(rule FalseE)
        qed
      qed
      }
      note rhs = this
      show ?thesis using lhs rhs
        unfolding hoEnv.FrameStatEq_def hoEnv.FrameStatImp_def
        by blast
    qed

  }
  show ?thesis
  proof(cases "CsP=[]")
    case True
    have "\<Psi> \<rhd> Case \<bottom>\<^sub>c \<sim> \<lbrace>FOA(\<one>\<^isub>F)\<rbrace>"
    proof -
      let ?X1 = "{(\<Psi>,Case \<bottom>\<^sub>c,\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>)| \<Psi>. True}"
      let ?X2 = "{(\<Psi>,\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>,Case \<bottom>\<^sub>c)| \<Psi>. True}"
      let ?X = "?X1 \<union> ?X2"
      have "eqvt(?X1 \<union> ?X2)"
        unfolding eqvt_def
        by(force simp add: eqvts)
      have "(\<Psi>,Case \<bottom>\<^sub>c,\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>) \<in> ?X" by simp
      thus ?thesis
      proof(coinduct rule: hoEnv.bisimCoinduct)
        case cStatEq
        thus ?case
          by(auto simp add: HOSBottom_def[symmetric])
      next
        case cSym thus ?case by blast
      next
        case cExt thus ?case by blast
      next
        case (cSim \<Psi> R S)
        let ?Y = "?X \<union> hoEnv.bisim"
        have "eqvt(?Y)" using `eqvt ?X` hoEnv.bisimEqvt
          by(rule eqvtUnion)
        show ?case
        proof(cases "(\<Psi>,R,S) \<in> ?X1")
          assume "(\<Psi>,R,S) \<in> ?X1"
          hence rdef: "R=Case \<bottom>\<^sub>c" and sdef: "S=\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>"
            by auto
          show ?case
            unfolding rdef sdef
            apply(rule hoEnv.simI[where C="()", OF `eqvt(?Y)`])
            by(drule hoEnv.nilTrans) (rule FalseE)
        next
          assume "(\<Psi>,R,S) \<notin> ?X1"
          hence "(\<Psi>,R,S) \<in> ?X2" using `(\<Psi>,R,S) \<in> ?X`
            by blast
          hence sdef: "S=Case \<bottom>\<^sub>c" and rdef: "R=\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>"
            by auto
          show ?case
            unfolding rdef sdef
            apply(rule hoEnv.simI[where C="()", OF `eqvt(?Y)`])
            unfolding psiCases.simps[symmetric]
            apply(rule hoEnv.caseCases)
            by assumption simp
        qed
      qed
    qed
    have "\<Psi> \<rhd> \<lbrace>FOA(\<one>\<^isub>F)\<rbrace> \<sim> \<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)"
    proof -
      {
        fix \<Psi>::"('a,'b,'c) hoassert"
        and a::name
        and M\<^isub>a::'a
        assume "a \<sharp> \<Psi>"
          and  "a \<in> (supp M\<^isub>a)"
        have "\<Psi> \<rhd> \<lbrace>FOA(\<one>\<^isub>F)\<rbrace> \<sim> \<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)"
        proof -
          let ?X1 = "{(\<Psi>,\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>,\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)) | \<Psi> a M\<^isub>a. a \<sharp> \<Psi> \<and> a \<in> (supp M\<^isub>a)}"
          let ?X2 = "{(\<Psi>,\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>),\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>) | \<Psi> a M\<^isub>a. a \<sharp> \<Psi> \<and> a \<in> (supp M\<^isub>a)}"
          let ?X = "?X1 \<union> ?X2"
          have "eqvt ?X"
          proof -
            {
              fix   a::name
                and M::'a
                and p::"name prm"
              assume "a \<in> supp M"
              hence "(p\<bullet>a) \<in> supp(p\<bullet>M)"
                apply(subst (asm) perm_bool[where pi=p,symmetric])
                unfolding eqvts
                by -
            }
            note lolg = this
            show ?thesis
            unfolding eqvt_def
            apply(auto simp add: eqvts)
            apply(rule_tac x="p\<bullet>ab" in exI)
            apply(rule_tac x="p\<bullet>M\<^isub>a" in exI)
            apply(simp add: pt_fresh_bij[OF pt_name_inst, OF at_name_inst] eqvts lolg)
            apply(drule_tac x="(p\<bullet> ab)" in spec)
            apply(drule mp)
            apply(subst pt_fresh_bij[OF pt_name_inst, OF at_name_inst], assumption)
            apply(subgoal_tac "p \<bullet> ab \<notin> supp(p\<bullet>M\<^isub>a)")
            apply(frule lolg, force)
            apply(drule_tac x="(p\<bullet>M\<^isub>a)" in spec, simp)
            done
        qed
        have "(\<Psi>,\<lbrace>FOA(\<one>\<^isub>F)\<rbrace>,\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)) \<in> ?X" using `a \<sharp> \<Psi>` `a \<in> supp M\<^isub>a`
          by blast
        thus ?thesis
        proof(coinduct rule: hoEnv.bisimCoinduct)
          case (cStatEq \<Psi> S T) thus ?case
          proof(cases "(\<Psi>,S,T) \<in> ?X1")
            assume "(\<Psi>,S,T) \<in> ?X1"
            then obtain a M\<^isub>a where sdef: "S = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            have step: "hoEnv.FrameStatEq (\<langle>\<epsilon>, \<Psi> \<otimes> FOA (\<one>\<^isub>F)\<rangle>) (hoEnv.insertAssertion (\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<one> \<otimes> FOA (\<one>\<^isub>F)\<rangle>)) \<Psi>)"
              apply(subst hoEnv.insertAssertion.simps)
              apply fact
              apply(subst hoEnv.insertAssertion.simps)
              apply(rule hoEnv.FrameStatEqSym)
              apply(rule hoEnv.FrameStatEqTrans)
              apply(rule hoEnv.frameResPres)
              apply(subst hoEnv.frameNilStatEq)
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Commutativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Associativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Commutativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Identity])
              apply(rule hoEnv.Commutativity)
              apply(rule hoEnv.frameResFresh)
              by(auto simp add: `a \<sharp> \<Psi>`)
            show ?case
              unfolding sdef tdef
              by(simp add: step)
          next
            assume "(\<Psi>,S,T) \<notin> ?X1"
            hence "(\<Psi>,S,T) \<in> ?X2" using `(\<Psi>,S,T) \<in> ?X`
              by blast
            then obtain a M\<^isub>a where tdef: "T = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            have step: "hoEnv.FrameStatEq (\<langle>\<epsilon>, \<Psi> \<otimes> FOA (\<one>\<^isub>F)\<rangle>) (hoEnv.insertAssertion (\<lparr>\<nu>a\<rparr>(\<langle>\<epsilon>, \<one> \<otimes> FOA (\<one>\<^isub>F)\<rangle>)) \<Psi>)"
              apply(subst hoEnv.insertAssertion.simps)
              apply fact
              apply(subst hoEnv.insertAssertion.simps)
              apply(rule hoEnv.FrameStatEqSym)
              apply(rule hoEnv.FrameStatEqTrans)
              apply(rule hoEnv.frameResPres)
              apply(subst hoEnv.frameNilStatEq)
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Commutativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Associativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Commutativity])
              apply(rule hoEnv.AssertionStatEqTrans[OF hoEnv.Identity])
              apply(rule hoEnv.Commutativity)
              apply(rule hoEnv.frameResFresh)
              by(auto simp add: `a \<sharp> \<Psi>`)
            show ?case
              unfolding sdef tdef
              apply(rule hoEnv.FrameStatEqSym)
              by(simp add: step)
          qed
        next
          case cSym thus ?case by blast
        next
          case(cExt \<Psi> S T \<Psi>')
          thus ?case
          proof(cases "(\<Psi>,S,T) \<in> ?X1")
            assume "(\<Psi>,S,T) \<in> ?X1"
            then obtain a M\<^isub>a where sdef: "S = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            obtain b::name where "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> \<Psi>'"
              apply(rule at_exists_fresh[where x="(\<Psi>,M\<^isub>a,\<Psi>')", OF at_name_inst])
              apply(finite_guess)
              by force
            have bfmn: "b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>::'a)" using `b \<sharp> M\<^isub>a` suppNameless pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"]
              unfolding fresh_def
              by blast
            have "b \<sharp> \<Psi> \<otimes> \<Psi>'" using `b \<sharp> \<Psi>` `b \<sharp> \<Psi>'`
              by auto
            moreover have "b \<in> supp([(a,b)]\<bullet>M\<^isub>a)" using ainma
              apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
              by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
            ultimately show ?case
              unfolding sdef tdef
              apply(subst alphaRes[where y=b and x=a])
              apply(simp add: `b \<sharp> M\<^isub>a` bfmn)
              unfolding eqvts
              by blast
          next
            assume "(\<Psi>,S,T) \<notin> ?X1"
            hence "(\<Psi>,S,T) \<in> ?X2" using `(\<Psi>,S,T) \<in> ?X`
              by blast
            then obtain a M\<^isub>a where tdef: "T = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            obtain b::name where "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> \<Psi>'"
              apply(rule at_exists_fresh[where x="(\<Psi>,M\<^isub>a,\<Psi>')", OF at_name_inst])
              apply(finite_guess)
              by force
            have bfmn: "b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>::'a)" using `b \<sharp> M\<^isub>a` suppNameless pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"]
              unfolding fresh_def
              by blast
            have "b \<sharp> \<Psi> \<otimes> \<Psi>'" using `b \<sharp> \<Psi>` `b \<sharp> \<Psi>'`
              by auto
            moreover have "b \<in> supp([(a,b)]\<bullet>M\<^isub>a)" using ainma
              apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
              by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
            ultimately show ?case
              unfolding sdef tdef
              apply(subst alphaRes[where y=b and x=a])
              apply(simp add: `b \<sharp> M\<^isub>a` bfmn)
              unfolding eqvts
              by blast
          qed
        next
          case(cSim \<Psi> S T)
          let ?Y = "?X \<union> hoEnv.bisim"
          have "eqvt(?Y)" using `eqvt ?X` hoEnv.bisimEqvt
            by(rule eqvtUnion)
          show ?case
          proof(cases "(\<Psi>,S,T) \<in> ?X1")
            assume "(\<Psi>,S,T) \<in> ?X1"
            then obtain a::name and M\<^isub>a where sdef: "S = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and tdef: "T=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            show ?case
            proof(induct rule: hoEnv.simI[where C="a", OF `eqvt(?Y)`])
              fix \<alpha> Q'
              assume tt: "hoEnv.semantics \<Psi> T (\<alpha> \<prec> Q')"
                and  "bn \<alpha> \<sharp>* S"
                and  "bn \<alpha> \<sharp>* T"
                and  "bn \<alpha> \<sharp>* \<Psi>"
                and  "distinct (bn \<alpha>)"
                and  "bn \<alpha> \<sharp>* subject \<alpha>"
                and  "bn \<alpha> \<sharp>* a"
              obtain b::name where "b \<sharp> \<alpha>" and "b \<sharp> S" and "b \<sharp> T" and "b \<sharp> M\<^isub>a" and "b \<sharp> \<Psi>" and "b \<sharp> Q'" and "b \<sharp> bn \<alpha>" and "a \<noteq> b"
                apply(rule at_exists_fresh[where x="(\<Psi>,M\<^isub>a,\<alpha>,S,T,Q',bn \<alpha>,a)", OF at_name_inst])
                apply(finite_guess)
                by force
              have tdef': "T=\<lparr>\<nu>b\<rparr>(\<langle>(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" using `b \<sharp> M\<^isub>a` pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"]
                unfolding tdef
                apply(subst alphaRes[where x=a and y=b])
                unfolding fresh_def
                apply(force simp add: psi.supp hoassert.supp suppUnit suppNameless)
                by(simp only: eqvts)
              have "bn \<alpha> \<sharp>* (\<langle>(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>::('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi)" using `bn \<alpha> \<sharp>* T` `b \<sharp> bn \<alpha>`
                unfolding tdef'
                by(simp add: hoassertFresh)
              hence "bn \<alpha> \<sharp>* (\<langle>(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)\<rangle>::('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi)" and "bn \<alpha> \<sharp>* (\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>::('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi)"
                by simp+
              from tt show "\<exists> P'. (hoEnv.semantics \<Psi> S (\<alpha> \<prec> P')) \<and> (\<Psi>, P', Q') \<in> ?Y" using `b \<sharp> \<Psi>` `b \<sharp> \<alpha>` `b \<sharp> Q'` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* (\<langle>(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)` `bn \<alpha> \<sharp>* subject \<alpha>`
                unfolding sdef tdef'
              proof(induct rule: hoEnv.resCases)
                case(cOpen M xvec yvec y N P')
                have "(xvec @ yvec) \<sharp>* \<Psi>" using `xvec \<sharp>* \<Psi>` `yvec \<sharp>* \<Psi>`
                  by simp
                from `xvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)` `yvec \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)` have "(xvec@yvec) \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)" and "(xvec@yvec) \<sharp>* \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>"
                  by(simp add: hoassertFresh)+
                have "(xvec @ yvec) \<sharp>* M" using `xvec \<sharp>* M` `yvec \<sharp>* M`
                  by simp
                from `hoEnv.semantics \<Psi> (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>) (M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>([(b, y)] \<bullet> N)\<rangle> \<prec> [(b, y)] \<bullet> P')` show ?case using `(xvec @ yvec) \<sharp>* \<Psi>` `(xvec@yvec) \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)` `(xvec@yvec) \<sharp>* \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>` `(xvec @ yvec) \<sharp>* M`
                proof(induct rule: hoEnv.parOutputCases[of _ _ _ _ _ _ _ "b"])
                  case(cPar1 P'' A\<^isub>Q \<Psi>\<^isub>Q)
                  thus ?thesis
                  proof(induct rule: hoEnv.invCases)
                    case(cInv P Q)
                    have psiqdef: "\<Psi>\<^isub>Q = FOA(\<one>\<^isub>F)" using `hoEnv.extractFrame (\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                      by simp
                    from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P` have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
                      unfolding psiqdef
                      apply(subst (asm) HOSComposeJudge)
                      by simp
                    hence "supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
                      by(rule EntSupp)
                    from `a \<in> supp M\<^isub>a` have "b \<in> supp([(a,b)]\<bullet>M\<^isub>a)"
                      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                      by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                    hence "b \<in> supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)" using pairingSupp
                      by auto
                    hence "b \<in> supp \<Psi>" using `supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)`
                      by auto
                    hence False using `b \<sharp> \<Psi>`
                      unfolding fresh_def
                      by simp
                    thus ?thesis by(rule FalseE)
                  qed
                next
                  case(cPar2 Q' A\<^isub>P \<Psi>\<^isub>P)
                  hence False by(auto dest: hoEnv.nilTrans)
                  thus ?thesis by(rule FalseE)
                qed
              next
                case(cRes P')
                thus ?case using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* (\<langle>([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)` `bn \<alpha> \<sharp>* \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>` `bn \<alpha> \<sharp>* subject \<alpha>`
                proof(induct rule: hoEnv.parCases[of _ _ _ _ _ "()"])
                  case(cPar1 P' A\<^isub>Q \<Psi>\<^isub>Q)
                  thus ?case
                  proof(induct rule: hoEnv.invCases)
                    case(cInv P Q)
                    have psiqdef: "\<Psi>\<^isub>Q = FOA(\<one>\<^isub>F)" using `hoEnv.extractFrame (\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>) = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                      by simp
                    from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> (([(a, b)] \<bullet> M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> P` have "\<Psi> \<turnstile> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
                      unfolding psiqdef
                      apply(subst (asm) HOSComposeJudge)
                      by simp
                    hence "supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
                      by(rule EntSupp)
                    from `a \<in> supp M\<^isub>a` have "b \<in> supp([(a,b)]\<bullet>M\<^isub>a)"
                      apply(subst perm_bool[where pi="[(a,b)]",symmetric])
                      by(force simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
                    hence "b \<in> supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>)" using pairingSupp
                      by auto
                    hence "b \<in> supp \<Psi>" using `supp(([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)`
                      by auto
                    hence False using `b \<sharp> \<Psi>`
                      unfolding fresh_def
                      by simp
                    thus ?case by(rule FalseE)
                  qed
                next
                  case cPar2 hence False by(auto dest: hoEnv.nilTrans)
                  thus ?case by(rule FalseE)
                next
                  case cComm1 hence False by(auto dest: hoEnv.nilTrans)
                  thus ?case by(rule FalseE)
                next
                  case cComm2 hence False by(auto dest: hoEnv.nilTrans)
                  thus ?case by(rule FalseE)
                qed
              qed
            qed
          next
            assume "(\<Psi>,S,T) \<notin> ?X1"
            hence "(\<Psi>,S,T) \<in> ?X2" using `(\<Psi>,S,T) \<in> ?X`
              by blast
            then obtain a M\<^isub>a where tdef: "T = \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>" and sdef: "S=\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)" and afpsi: "a \<sharp> \<Psi>" and ainma: "a \<in> supp (M\<^isub>a)"
              by force
            show ?case
            proof(induct rule: hoEnv.simI[where C="a", OF `eqvt(?Y)`])
              fix \<alpha> Q'
              assume tt: "hoEnv.semantics \<Psi> T (\<alpha> \<prec> Q')"
                and  "bn \<alpha> \<sharp>* S"
                and  "bn \<alpha> \<sharp>* T"
                and  "bn \<alpha> \<sharp>* \<Psi>"
                and  "distinct (bn \<alpha>)"
                and  "bn \<alpha> \<sharp>* subject \<alpha>"
                and  "bn \<alpha> \<sharp>* a"
              from tt have False unfolding tdef by(auto dest: hoEnv.nilTrans)
              thus "\<exists> P'. (hoEnv.semantics \<Psi> S (\<alpha> \<prec> P')) \<and> (\<Psi>, P', Q') \<in> ?Y"
                by(rule FalseE)
            qed
          qed
        qed
      qed
      }
      note Goal = this
      obtain b::name where "b \<sharp> \<Psi>" and "b \<sharp> M\<^isub>a"
        apply(rule at_exists_fresh[where x="(\<Psi>,M\<^isub>a)", OF at_name_inst])
        apply(finite_guess)
        by force
      note `b \<sharp> M\<^isub>a`
      moreover have "b \<in> supp([(a,b)]\<bullet>M\<^isub>a)" using `\<not> a \<sharp> M\<^isub>a`
        unfolding fresh_def
        apply(subst perm_bool[symmetric,where pi="[(a,b)]"])
        by(auto simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
      thus ?thesis using `b \<sharp> M\<^isub>a` pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] `b \<sharp> \<Psi>`
        apply(subst alphaRes[where y=b])
        apply(simp add: fresh_def psi.supp suppNameless suppUnit hoassert.supp)
        unfolding eqvts
        by(rule Goal)
    qed
    have "\<Psi> \<rhd> Case \<bottom>\<^sub>c \<sim> \<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>FOA (\<one>\<^isub>F)\<rbrace>)"
      by(rule hoEnv.bisimTransitive[where Q="\<lbrace>FOA (\<one>\<^isub>F)\<rbrace>"]) fact+
    thus ?thesis unfolding `CsP = []`
      by simp
  next
    case False
    hence "supp(hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>,P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c))) CsP)) = (supp(M\<^isub>a\<langle>\<bottom>\<rangle>)::name set)" using `((supp CsP)::name set) \<subseteq> supp(M\<^isub>a)`
      unfolding mabsupp
    proof(induct CsP rule: list_nonempty_induct)
      case(single a)
      thus ?case
        apply(induct a)
        by(force simp add: hoassert.supp hoclause.supp hoclauseres.supp suppNameless suppUnit hopsi.supp hopsiCase.supp injectSupp supp_list_nil supp_list_cons supp_prod)
    next
      case(cons a CsP)
      have "supp (hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) CsP)) = (supp(M\<^isub>a)::name set)" using `supp (a # CsP) \<subseteq> supp M\<^isub>a`
        apply -
        by(rule cons) (simp add: supp_list_cons)
      moreover have "supp (hoassertJudge (\<one>\<^isub>F) (map (\<lambda>(\<phi>, P). M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> Case \<box> \<phi> \<Rightarrow> P \<bottom>\<^sub>c)) [a])) = (supp(M\<^isub>a)::name set)"
      proof -
        have "supp (a) \<subseteq> (supp M\<^isub>a::name set)" using `supp (a # CsP) \<subseteq> supp M\<^isub>a`
          by(simp add: supp_list_cons)
        thus ?thesis
          by(induct a) (force simp add: hoassert.supp hoclause.supp hoclauseres.supp suppNameless suppUnit hopsi.supp hopsiCase.supp injectSupp supp_prod)
      qed
      ultimately show ?case
        by(simp add: hoassert.supp suppUnit)
    qed
    show ?thesis
      apply(rule hoEnv.hocase)
      unfolding mem.simps
      by(fact|simp add: hocond.inject injectPsiPresEq)+
  qed
qed

lemma hoReplication:
  fixes a  :: name
  and   M\<^isub>a :: "'a::fs_name"
  and   P  :: "('a, ('a,'b,'c) hoassert, ('a,'b,'c) hocond) psi"
  and   Q  :: "('a, ('a,'b,'c) hoassert, ('a,'b,'c) hocond) psi"
  and   \<Psi>  :: "('a,'b,'c) hoassert"
  and   \<phi>  :: "('a,'b,'c) hocond"
  assumes "a \<sharp> P"
  and     "guarded P"
  and     "((supp P)::name set) \<subseteq> supp(M\<^isub>a\<langle>\<bottom>\<rangle>)"
  and     "\<not>(a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>))"
  shows   "\<Psi> \<rhd> (\<lparr>\<nu>a\<rparr>(\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<parallel> \<lbrace>hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rbrace>)) \<sim> !P"
proof -
  interpret hoEnv: env FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause
    by(rule hoEnv)
  have seq: "(supp(M\<^isub>a\<langle>\<bottom>\<rangle>)::name set) = supp M\<^isub>a" using pairingSupp[where M=M\<^isub>a and N=\<bottom>] pairingSupp'[where M=M\<^isub>a and N=\<bottom>]
    by(auto simp add: suppNameless)
  have "supp (hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P \<parallel> \<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)]) = (supp (M\<^isub>a\<langle>\<bottom>\<rangle>)::name set)" using `supp P \<subseteq> supp(M\<^isub>a\<langle>\<bottom>\<rangle>)`
    by(force simp add: hoassert.supp hoclause.supp hoclauseres.supp hopsi.supp suppNameless suppUnit injectSupp seq)
  {
    fix \<Psi>::"('a,'b,'c) hoassert"
    and   \<phi>::"('a,'b,'c) hocond"
    assume "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))] \<turnstile> \<phi>"
    hence "\<phi> = (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle> \<or> \<Psi> \<turnstile> \<phi>"
    proof(nominal_induct rule: hocondInduct)
      case(cFOC \<phi>\<^isub>F)
      have "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F \<Longrightarrow> hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
      proof -
        assume "\<one>\<^isub>F \<otimes>\<^isub>F hoassertFOA \<Psi> \<turnstile>\<^isub>F \<phi>\<^isub>F"
        hence "hoassertFOA \<Psi> \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          apply -
          apply(rule allE[OF conjunct1[OF Commutativity[where \<Psi>="\<one>\<^isub>F" and \<Psi>'="hoassertFOA \<Psi>"]]])
          by(erule mp)
        thus ?thesis
          apply -
          apply(rule allE[OF conjunct1[OF Identity]])
          by(erule mp)
      qed
      with cFOC show ?case
        by(simp add: HOSComposeFOA)
    next
      case(cHOC T Qa)
      {
        fix   T::'a
          and M\<^isub>a::'a
          and Qa::"('a,'b,'c) hopsi"
          and P::"('a,('a,'b,'c) hoassert,('a,'b,'c) hocond) psi"
        assume "\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa)) \<in> set (hoassertHOA \<Psi>)  \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa)"
        then obtain xvec Tvec K N where "T = K\<langle>N[xvec::=Tvec]\<rangle>"
          and disj: "((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa)) \<in> set (hoassertHOA \<Psi>) \<or>
          M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa)"
          and "length xvec = length Tvec"
          and "distinct xvec"
          and exists: "(\<exists>Q. Qa = Q[xvec::=Tvec])"
          by blast
        note disj
        moreover have "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa \<Longrightarrow> T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)"
        proof -
          assume "M\<^isub>a = K \<and> CTrm (\<bottom>) (\<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) = \<nu>*xvec\<rparr>N \<Leftarrow> Qa"
          thus ?thesis using `T = K\<langle>N[xvec::=Tvec]\<rangle>` `length xvec = length Tvec`
            by(induct xvec) (auto simp add: hoclauseres.inject termEmptySubst)
        qed
        moreover have "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa)) \<in> set (hoassertHOA \<Psi>) \<Longrightarrow>
          (\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa)) \<in> set (hoassertHOA \<Psi>))" using `T = K\<langle>N[xvec::=Tvec]\<rangle>` exists `length xvec = length Tvec` `distinct xvec`
          by blast
        ultimately have "T = M\<^isub>a\<langle>\<bottom>\<rangle> \<and> Qa = \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>) \<or>
          (\<exists>xvec Tvec K N.
          length xvec = length Tvec \<and>
          distinct xvec \<and>
          T = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
          (\<exists>Q. Qa = Q[xvec::=Tvec]) \<and>
          (K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> Qa)) \<in> set (hoassertHOA \<Psi>))"
          by blast
      }
      thus ?case using cHOC
        apply(simp add: HOSComposeHOASet memAppend hocond.inject hoclause.inject hoclauseres.inject)
        unfolding hoclauseChainJudgeInject hoclauseChainJudgeInject[OF sym]
        by metis
    qed
  }
  note ents = this
  {
    fix \<Psi> and P
    assume "\<Psi> \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P"
    hence "supp(M\<^isub>a\<langle>\<bottom>\<rangle>) \<subseteq> (supp \<Psi>::name set)"
    proof(nominal_induct \<Psi> rule: hoassertInduct)
      case(cFOA \<Psi>\<^isub>F)
      thus ?case
        by simp
    next
      case(cHOA Cl \<Psi>\<^isub>H)
      let ?A = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        (Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)))"
      let ?B = "\<exists>xvec Tvec.
        length xvec = length Tvec \<and>
        distinct xvec \<and>
        (\<exists>K N. M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle> \<and>
        (\<exists>Q. \<sigma> P = Q[xvec::=Tvec]) \<and>
        ((K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<in> set (hoassertHOA \<Psi>\<^isub>H)))"
      have "?A \<or> ?B" using `HOA Cl \<Psi>\<^isub>H \<turnstile> (M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> P`
        by simp blast
      from cHOA show ?case
      proof(cases ?A)
        assume ?A
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and cldef: "Cl = K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        show ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding cldef kdef
          by(force simp add: hoassert.supp hoclause.supp)
      next
        assume "\<not>?A"
        hence "?B" using `?A \<or> ?B`
          by blast
        then obtain xvec Tvec K N Q where "length xvec = length Tvec" and "distinct xvec" and "M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>" and "\<sigma> P = Q[xvec::=Tvec]" and mem: "(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<in> set (hoassertHOA \<Psi>\<^isub>H)"
          by auto
        from `M\<^isub>a\<langle>\<bottom>\<rangle> = K\<langle>N[xvec::=Tvec]\<rangle>` have kdef: "K = M\<^isub>a"
          by(rule pairingEqPres[symmetric])
        from mem have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (hoassertHOA \<Psi>\<^isub>H)::name set)"
          by(induct rule: list.induct[where list="hoassertHOA \<Psi>\<^isub>H"]) (auto simp add: supp_list_cons)
        moreover have "supp(hoassertHOA \<Psi>\<^isub>H) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"          
          by(nominal_induct rule: hoassertInduct) (auto simp add: supp_list_nil supp_list_cons hoassert.supp)
        ultimately have "supp(K\<lparr>(\<nu>*xvec\<rparr>N \<Leftarrow> \<sigma> P)) \<subseteq> (supp (\<Psi>\<^isub>H)::name set)"
          by simp
        thus ?case using pairingSupp[where M="M\<^isub>a" and N="\<bottom>"] pairingSupp'[where M="M\<^isub>a" and N="\<bottom>"] suppNameless
          unfolding kdef
          by(force simp add: hoassert.supp hoclause.supp)
      qed
    qed
  }
  note EntSupp = this
  {
    fix \<Psi>::"('a,'b,'c) hoassert"
    and \<phi>::"('a,'b,'c) hocond"
    and p::"name prm"
    assume "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) [(p\<bullet>M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(p\<bullet>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)))] \<turnstile> \<phi>"
    hence "\<phi> =  ((p\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> (p\<bullet>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) \<or> \<Psi> \<turnstile> \<phi>"
      apply(subst perm_bool[where pi="rev p" and b="\<phi> = (p \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> p \<bullet> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>) \<or> \<Psi> \<turnstile> \<phi>",symmetric])
      apply(simp only: eqvts pt_rev_pi[OF pt_name_inst, OF at_name_inst])
      apply(rule ents[of "rev p\<bullet>\<Psi>" "rev p\<bullet>\<phi>"])
      apply(subst perm_bool[where pi="p",symmetric])
      by(simp only: eqvts pt_pi_rev[OF pt_name_inst, OF at_name_inst])
  }
  note entsp = this
  {
    fix F::"('a,'b,'c) hoassert frame"
    obtain A\<^isub>F \<Psi>\<^isub>F where "F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* a" and "A\<^isub>F \<sharp>* M\<^isub>a" and "A\<^isub>F \<sharp>* P"
      by(rule freshFrame[where C="(a,M\<^isub>a,P)"]) auto
    from `A\<^isub>F \<sharp>* a` have "a \<sharp> A\<^isub>F" by simp
    {
      fix \<phi>
      assume "hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
      obtain A\<^isub>G \<Psi>\<^isub>G where afdef: "(\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) = \<langle>A\<^isub>G, \<Psi>\<^isub>G\<rangle>" and "distinct A\<^isub>G" "A\<^isub>G \<sharp>* a" and "A\<^isub>G \<sharp>* M\<^isub>a" and "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* \<phi>"
        by(rule freshFrame[where C="(a,M\<^isub>a,P,\<phi>)"]) auto
      from `A\<^isub>G \<sharp>* a` have "a \<sharp> A\<^isub>G" by simp
      obtain b::name where "b \<sharp> A\<^isub>G" and "b \<sharp> \<Psi>\<^isub>G" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> P"
        apply(rule at_exists_fresh[where x="(A\<^isub>G, M\<^isub>a, P, \<Psi>\<^isub>G, \<phi>)", OF at_name_inst])
        apply finite_guess
        by force
      have "b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)" unfolding fresh_def seq
        apply(subst fresh_def[symmetric])
        by fact
      have fdef: "(\<langle>[a],hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rangle>) = (\<langle>[b],hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)))]\<rangle>)"
        apply(subst frameChainAlpha'[where p="[(a,b)]"])
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] injectFresh `b \<sharp> P` `b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)` `b \<sharp> M\<^isub>a`)
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
      from `A\<^isub>G \<sharp>* \<phi>` `b \<sharp> A\<^isub>G` `b \<sharp> \<phi>` `b \<sharp> \<Psi>\<^isub>G` `hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>`
      have "hoEnv.FrameImp (hoEnv.mergeFrame (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rangle>)) \<phi>"
        unfolding fdef afdef
      proof(nominal_induct \<phi> rule: hocondInduct)
        case(cFOC \<phi>\<^isub>F)
        hence "\<Psi>\<^isub>G \<turnstile> (FOC \<phi>\<^isub>F)"
          apply -
          by(rule hoEnv.frameImpE)
        hence "hoassertFOA \<Psi>\<^isub>G \<turnstile>\<^isub>F \<phi>\<^isub>F"
          by simp
        hence "hoassertFOA \<Psi>\<^isub>G \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F"
          apply -
          apply(rule allE[OF conjunct2[OF Identity[where \<Psi>="hoassertFOA \<Psi>\<^isub>G"]]])
          by(drule mp)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))" using `A\<^isub>G \<sharp>* M\<^isub>a` pairingSupp'[where M=M\<^isub>a and N=\<bottom>]
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          apply(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
          unfolding fresh_def fresh_star_def
          by(auto simp add: suppNameless)
        have "b \<sharp> \<phi>\<^isub>F" using `b \<sharp> FOC \<phi>\<^isub>F`
          by simp
        show ?case
          apply(subst hoEnv.mergeFrames)
          apply(simp add: `b \<sharp> A\<^isub>G`)
          apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh injectFreshStar hoclauseFresh hoclauseresFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` hopsiFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))`)
          apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
          apply(rule hoEnv.frameImpI[OF refl])
          apply(simp add: cFOC `b \<sharp> \<phi>\<^isub>F`)
          apply(simp add: HOSComposeFOA' `hoassertFOA \<Psi>\<^isub>G \<otimes>\<^isub>F \<one>\<^isub>F \<turnstile>\<^isub>F \<phi>\<^isub>F`)
          done
      next
        case(cHOC T R)
        hence "\<Psi>\<^isub>G \<turnstile> (HOC T R)"
          apply -
          by(rule hoEnv.frameImpE)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))" using `A\<^isub>G \<sharp>* M\<^isub>a` pairingSupp'[where M=M\<^isub>a and N=\<bottom>]
          apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
          apply(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
          unfolding fresh_def fresh_star_def
          by(auto simp add: suppNameless)
        have "b \<sharp> T" and "b \<sharp> R" using `b \<sharp> HOC T R` by simp+
        show ?case using `\<Psi>\<^isub>G \<turnstile> (HOC T R)`
          apply(subst hoEnv.mergeFrames)
          apply(simp add: `b \<sharp> A\<^isub>G`)
          apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh injectFreshStar hoclauseFresh hoclauseresFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` hopsiFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))`)
          apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
          apply(rule hoEnv.frameImpI[OF refl])
          apply(simp add: cHOC `b \<sharp> T` `b \<sharp> R`)
          apply(subst HOSComposeJudge)
          apply(simp add: memAppend)
          apply blast
          done
      qed
    }
    note w1 = this
    {
      fix \<phi>
      assume faimp: "hoEnv.FrameImp (hoEnv.mergeFrame (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rangle>)) \<phi>"
      obtain A\<^isub>G \<Psi>\<^isub>G where afdef: "(\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) = \<langle>A\<^isub>G, \<Psi>\<^isub>G\<rangle>" and "distinct A\<^isub>G" "A\<^isub>G \<sharp>* a" and "A\<^isub>G \<sharp>* M\<^isub>a" and "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* \<phi>"
        by(rule freshFrame[where C="(a,M\<^isub>a,P,\<phi>)"]) auto
      from `A\<^isub>G \<sharp>* a` have "a \<sharp> A\<^isub>G" by simp
      obtain b::name where "b \<sharp> A\<^isub>G" and "b \<sharp> \<Psi>\<^isub>G" and "b \<sharp> \<phi>" and "b \<sharp> M\<^isub>a" and "b \<sharp> P"
        apply(rule at_exists_fresh[where x="(A\<^isub>G, M\<^isub>a, P, \<Psi>\<^isub>G, \<phi>)", OF at_name_inst])
        apply finite_guess
        by force
      have "b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)" unfolding fresh_def seq
        by(subst fresh_def[symmetric]) fact
      have fdef: "(\<langle>[a],hoassertJudge (\<one>\<^isub>F) [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rangle>) = (\<langle>[b],hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> ([(a,b)] \<bullet> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)))]\<rangle>)"
        apply(subst frameChainAlpha'[where p="[(a,b)]"])
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst] injectFresh `b \<sharp> P` `b \<sharp> M\<^isub>a` `b \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)`)
        apply(simp add: at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)" using `A\<^isub>G \<sharp>* M\<^isub>a`
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)" using `A\<^isub>G \<sharp>* P`
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        by(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
      have "A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))" using `A\<^isub>G \<sharp>* M\<^isub>a` pairingSupp'[where M=M\<^isub>a and N=\<bottom>]
        apply(subst perm_bool[symmetric, where pi="[(a,b)]"])
        apply(simp add: eqvts `a \<sharp> A\<^isub>G` `b \<sharp> A\<^isub>G`)
        unfolding fresh_def fresh_star_def
        by(auto simp add: suppNameless)
      from faimp have "\<Psi>\<^isub>G \<otimes> hoassertJudge (\<one>\<^isub>F) [([(a,b)] \<bullet> M\<^isub>a)\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>([(a,b)] \<bullet> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)))] \<turnstile> \<phi>"
        unfolding fdef afdef
        apply -
        apply(subst (asm) hoEnv.mergeFrames)
        apply(simp add: `b \<sharp> A\<^isub>G`)
        apply(simp add: `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> P)` `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> M\<^isub>a)` hoassertFresh hoclauseFresh hoclauseresFresh injectFreshStar hopsiFresh `A\<^isub>G \<sharp>* ([(a,b)] \<bullet> (M\<^isub>a\<langle>\<bottom>\<rangle>))`)
        apply(simp add: `b \<sharp> \<Psi>\<^isub>G`)
        apply(rule hoEnv.frameImpE)
        apply assumption
        apply(simp add: `b \<sharp> \<phi>` `A\<^isub>G \<sharp>* \<phi>`)
        done
      hence "\<phi> =  (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) \<or> \<Psi>\<^isub>G \<turnstile> \<phi>"
        by(rule entsp)
      moreover have "\<Psi>\<^isub>G \<turnstile> \<phi> \<Longrightarrow> hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>" using `A\<^isub>G \<sharp>* \<phi>`
        unfolding afdef
        apply -
        by(rule hoEnv.frameImpI[OF refl])
      moreover have "\<phi> = (([(a,b)]\<bullet>M\<^isub>a)\<langle>\<bottom>\<rangle>) \<Leftarrow> ([(a,b)]\<bullet>(P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)) \<Longrightarrow> hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
      proof -
        assume ass: "\<phi> = ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>) \<Leftarrow> [(a, b)] \<bullet> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>)"
        have "\<not> b \<sharp> ([(a, b)] \<bullet> M\<^isub>a\<langle>\<bottom>\<rangle>)"
        proof -
          note `\<not> a \<sharp> (M\<^isub>a\<langle>\<bottom>\<rangle>)`
          thus ?thesis
            apply(subst (asm) perm_bool[where pi="[(a,b)]",symmetric])
            by(simp add: eqvts at1[OF at_name_inst] at2[OF at_name_inst] at3[OF at_name_inst])
        qed
        hence "\<not> b \<sharp> \<phi>" unfolding ass
          by simp
        hence False using `b \<sharp> \<phi>` by simp
        thus ?thesis by(rule FalseE)
      qed
      ultimately have "hoEnv.FrameImp (\<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>) \<phi>"
        by blast
    }
    note w2 = this
    have "hoEnv.FrameStatEq (hoEnv.mergeFrame F (\<langle>[a],hoassertJudge (\<one>\<^isub>F)
                        [M\<^isub>a\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> (P\<parallel>\<langle>(M\<^isub>a\<langle>\<bottom>\<rangle>)\<rangle>))]\<rangle>)) F"
      unfolding `F = \<langle>A\<^isub>F, \<Psi>\<^isub>F\<rangle>` hoEnv.FrameStatEq_def hoEnv.FrameStatImp_def
      apply(rule conjI)
      apply(rule allI)
      apply(rule impI)
      apply(rule w2)
      apply assumption
      apply(rule allI)
      apply(rule impI)
      apply(rule w1)
      apply assumption
      done
  }
  note seq = this
  show ?thesis
    apply(rule hoEnv.replication)
    apply simp
    apply(rule_tac x="[]" in exI)
    apply(rule_tac x="[]" in exI)
    apply(rule conjI,simp)
    apply(rule conjI,simp)
    apply(rule_tac x="M\<^isub>a" in exI)
    apply(rule_tac x="\<bottom>" in exI)
    apply(simp add: termEmptySubst HOemptySubst HOSComposeHOASet memAppend)
    apply fact
    apply fact
    apply fact
    apply(simp add: hocond.inject injectPsiPresEq)
    apply fact
    apply fact
    apply fact
    apply fact
    apply fact
    done
qed

abbreviation
  hobisimJudge ("_ \<rhd> _ \<sim>\<^sub>H _" [70, 70, 70] 65) where "\<Psi> \<rhd> P \<sim>\<^sub>H Q \<equiv> (\<Psi>, P, Q) \<in> env.hobisim FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause"

lemma hobisimClausePres:
  fixes \<Psi> :: "('a, 'b, 'c) hoassert"
  and   P :: "('a, ('a, 'b, 'c) hoassert, ('a, 'b, 'c) hocond) psi"
  and   Q :: "('a, ('a, 'b, 'c) hoassert, ('a, 'b, 'c) hocond) psi"
  and   M :: 'a
  assumes "guarded P"
  and     "guarded Q"
  and "supp P \<subseteq> (supp M::name set)"
  and "supp Q \<subseteq> (supp M::name set)"
  and     "\<one> \<rhd> P \<sim>\<^sub>H Q"
  shows   "\<Psi> \<rhd> \<lbrace>hoassertJudge (\<one>\<^isub>F) [M\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(P))]\<rbrace> \<sim>\<^sub>H \<lbrace>hoassertJudge (\<one>\<^isub>F) [M\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma>(Q))]\<rbrace>"
proof -
  interpret hoEnv: env FOtermSubst hoassertSubst hocondSubst HOSCompose HOSImp HOSBottom HOSChanEq HOSClause
    by(rule hoEnv)
    {
    fix P \<Psi> \<phi>
    have "\<Psi> \<otimes> hoassertJudge (\<one>\<^isub>F) [M\<lparr>(\<nu>*[]\<rparr>\<bottom> \<Leftarrow> \<sigma> P)] \<turnstile> \<phi> =
      (\<phi> = (M\<langle>\<bottom>\<rangle>) \<Leftarrow> P \<or> \<Psi> \<turnstile> \<phi>)"
    proof(nominal_induct \<Psi> rule: hoassertInduct)
      case(cFOA \<Psi>\<^isub>F)
      thus ?case
      proof(nominal_induct \<phi> rule: hocondInduct)
        case(cFOC \<phi>\<^isub>F)
        thus ?case
          by(auto intro: allE[OF conjunct1[OF Commutativity]] allE[OF conjunct1[OF Identity]] allE[OF conjunct2[OF Identity]])
      next
        case(cHOC M' P')     
        {
          fix xvec Tvec K N Q
          assume "\<nu>*xvec\<rparr>N \<Leftarrow> (Q[xvec::=Tvec]) = CTrm (\<bottom>) (\<sigma> P)"
          hence "xvec = []"
            by(cases xvec) (auto simp add: hoclause.inject)
        }
        note rool =this
        from cHOC show ?case
          apply(auto simp add: hocond.inject hoassert.inject termEmptySubst hoassert.inject hoclause.inject hoclauseres.inject)
          apply(frule_tac rool)
          apply(auto simp add: termEmptySubst hoclauseres.inject)
          apply(frule_tac rool)
          apply(auto simp add: termEmptySubst hoclauseres.inject)
          apply(rule_tac exI[where x="[]"])
          apply(simp add: termEmptySubst)
          apply(rule_tac exI[where x="\<bottom>"])
          apply simp
          apply(rule_tac exI[where x="\<sigma> P"])
          by(simp add: HOemptySubst)
      qed
    next
      case(cHOA Cl \<Psi>\<^isub>H)
      thus ?case
      proof(nominal_induct \<phi> rule: hocondInduct)
        case(cFOC \<phi>\<^isub>F)
        thus ?case
          apply(subst HOSComposeJudge)
          by(auto intro: allE[OF conjunct1[OF Commutativity]] allE[OF conjunct1[OF Identity]] allE[OF conjunct2[OF Identity]])
      next
        case(cHOC T Q)
        thus ?case
          by(auto simp add: HOSComposeHOASet HOSComposeFOA) blast+
      qed
    qed
  }
  note entDisj = this
  have "hoEnv.legalClause (M\<langle>\<bottom>\<rangle>) P"
    using `supp P \<subseteq> (supp M::name set)` `guarded P`
    unfolding hoEnv.legalClause_def
    using pairingSupp[where M=M and N=\<bottom>]
    by auto
  moreover have "hoEnv.legalClause (M\<langle>\<bottom>\<rangle>) Q"
    using `supp Q \<subseteq> (supp M::name set)` `guarded Q`
    unfolding hoEnv.legalClause_def
    using pairingSupp[where M=M and N=\<bottom>]
    by auto
  moreover note `\<one> \<rhd> P \<sim>\<^sub>H Q` entDisj entDisj
  moreover
  {
    fix M P M' P'
    have "M \<Leftarrow> P = M' \<Leftarrow> P' \<Longrightarrow> M = M' \<and> P = P'"
      by(auto simp add: hocond.inject injectPsiPresEq)
  }
  ultimately show ?thesis
    by(rule hoEnv.hobisimClausePres)
qed

end
end