theory hobisimPres
imports hobisim bisimPres
begin

context env begin


inductive_set
  rel_trancl :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> ('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"  ("(_\<^sup>\<star>)" [1000] 999)
  for r :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
where
    r_into_rel_trancl [intro, Pure.intro]: "(\<Psi>, P,Q) : r ==> (\<Psi>,P,Q) : r\<^sup>\<star>"
  | rel_trancl_into_rel_trancl [Pure.intro]: "(\<Psi>,P,Q) : r\<^sup>\<star> ==> (\<Psi>,Q,R) : r ==> (\<Psi>,P,R) : r\<^sup>\<star>"

lemma rel_trancl_induct2[consumes 1, case_names r_into_rel_trancl rel_trancl_into_rel_trancl]:
  assumes "(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>"
  and  1: "\<And>P Q. (\<Psi>,P,Q) \<in> Rel \<Longrightarrow> Prop \<Psi> P Q"
  and  0:  "\<And>P Q R. \<lbrakk>(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>; Prop \<Psi> P Q; (\<Psi>,Q,R) \<in> Rel\<rbrakk> \<Longrightarrow> Prop \<Psi> P R"

  shows "Prop \<Psi> P Q"
proof -
  note `(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>`
  moreover obtain \<Psi>' where 2: "\<Psi> = \<Psi>'" by simp
  ultimately show ?thesis
  proof(induct rule: rel_trancl.induct)
    case(r_into_rel_trancl \<Psi> P Q)
    thus ?case using 1 unfolding 2
      by simp
  next
    case(rel_trancl_into_rel_trancl \<Psi> P Q R)
    thus ?case using 0 unfolding 2
      by simp
  qed
qed

inductive_set
  fresh_rel_trancl :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> (name list \<times> 'b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"  ("(_\<^sup>\<sharp>)" [1000] 999)
  for r :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
where
    r_into_fresh_rel_trancl [intro, Pure.intro]: "(\<Psi>, P,Q) : r \<Longrightarrow> A \<sharp>* P \<Longrightarrow> A \<sharp>* Q ==> (A,\<Psi>,P,Q) : r\<^sup>\<sharp>"
  | fresh_rel_trancl_into_fresh_rel_trancl [Pure.intro]: "(A,\<Psi>,P,Q) : r\<^sup>\<sharp> ==> (\<Psi>,Q,R) : r \<Longrightarrow> A \<sharp>* R ==> (A,\<Psi>,P,R) : r\<^sup>\<sharp>"


lemma rel_trancl_transitive:
  assumes "(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>"
  and     "(\<Psi>,Q,R) \<in> Rel\<^sup>\<star>"
  shows   "(\<Psi>,P,R) \<in> Rel\<^sup>\<star>"
  using assms
  apply(rotate_tac 1)
  by(induct rule: rel_trancl.induct) (auto intro: rel_trancl_into_rel_trancl)

lemma fresh_rel_trancl_transitive:
  assumes "(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>"
  and     "(A,\<Psi>,Q,R) \<in> Rel\<^sup>\<sharp>"
  shows   "(A,\<Psi>,P,R) \<in> Rel\<^sup>\<sharp>"
  using assms
  apply(rotate_tac 1)
  by(induct rule: fresh_rel_trancl.induct) (auto intro: fresh_rel_trancl_into_fresh_rel_trancl)

lemma rel_trancl_induct[consumes 1, case_names prop_transitive r_into_rel_trancl]:
  assumes "(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>"
  and  0:  "\<And>\<Psi> P Q R. \<lbrakk>Prop \<Psi> P Q; Prop \<Psi> Q R\<rbrakk> \<Longrightarrow> Prop \<Psi> P R"
  and  1: "\<And>\<Psi> P Q. (\<Psi>,P,Q) \<in> Rel \<Longrightarrow> Prop \<Psi> P Q"
  shows "Prop \<Psi> P Q"
using `(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>`
proof(induct rule: rel_trancl.induct)
  case(r_into_rel_trancl \<Psi> P Q)
  thus ?case
    by(rule 1)
next
  case(rel_trancl_into_rel_trancl \<Psi> P Q R)
  hence "Prop \<Psi> Q R"
    by(rule_tac 1)
  thus ?case using `Prop \<Psi> P Q`
    by(rule_tac 0)
qed

lemma rel_trancl_induct'[consumes 1, case_names prop_transitive r_into_rel_trancl]:
  assumes "(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>"
  and  0:  "\<And>P Q R. \<lbrakk>Prop \<Psi> P Q; Prop \<Psi> Q R\<rbrakk> \<Longrightarrow> Prop \<Psi> P R"
  and  1: "\<And>P Q. (\<Psi>,P,Q) \<in> Rel \<Longrightarrow> Prop \<Psi> P Q"
  shows "Prop \<Psi> P Q"
using `(\<Psi>,P,Q) \<in> Rel\<^sup>\<star>`
proof(induct rule: rel_trancl_induct2)
  case(r_into_rel_trancl P Q)
  thus ?case
    by(rule 1)
next
  case(rel_trancl_into_rel_trancl P Q R)
  hence "Prop \<Psi> Q R"
    by(rule_tac 1)
  thus ?case using `Prop \<Psi> P Q`
    by(rule_tac 0)
qed

lemma rel_trancl_induct''[consumes 1, case_names prop_transitive r_into_rel_trancl]:
  assumes "(\<Psi>\<otimes>\<Psi>',P,Q) \<in> Rel\<^sup>\<star>"
  and  0:  "\<And>P Q R. \<lbrakk>Prop \<Psi> \<Psi>' P Q; Prop \<Psi> \<Psi>' Q R\<rbrakk> \<Longrightarrow> Prop \<Psi> \<Psi>' P R"
  and  1: "\<And>\<Psi>' P Q. (\<Psi>\<otimes>\<Psi>',P,Q) \<in> Rel \<Longrightarrow> Prop \<Psi> \<Psi>' P Q"
  shows "Prop \<Psi> \<Psi>' P Q"
using assms
by(rule rel_trancl_induct')


lemma fresh_rel_trancl_fresh:
  assumes "(A, \<Psi>, P, Q) \<in> Rel\<^sup>\<sharp>"
  shows "A \<sharp>* P"
  and "A \<sharp>* Q"
using assms
apply -
by(rule fresh_rel_trancl.inducts,assumption+)+

lemma fresh_rel_trancl_induct[consumes 1, case_names prop_transitive r_into_fresh_rel_trancl]:
  assumes "(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>"
  and  0:  "\<And>A \<Psi> P Q R. \<lbrakk>(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>; (A,\<Psi>,Q,R) \<in> Rel\<^sup>\<sharp>; Prop A \<Psi> P Q; Prop A \<Psi> Q R; A \<sharp>* P; A \<sharp>* Q; A \<sharp>* R\<rbrakk> \<Longrightarrow> Prop A \<Psi> P R"
  and  1: "\<And>\<Psi> P Q A. \<lbrakk>(\<Psi>,P,Q) \<in> Rel; A \<sharp>* P; A \<sharp>* Q\<rbrakk> \<Longrightarrow> Prop A \<Psi> P Q"
  shows "Prop A \<Psi> P Q"
using `(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>`
proof(induct rule: fresh_rel_trancl.induct)
  case(r_into_fresh_rel_trancl \<Psi> P Q A)
  thus ?case
    by(rule 1)
next
  case(fresh_rel_trancl_into_fresh_rel_trancl A \<Psi> P Q R)
  moreover hence "A \<sharp>* P" and "A \<sharp>* Q"
    by(simp add: fresh_rel_trancl_fresh)+
  moreover hence "Prop A \<Psi> Q R" using `(\<Psi>, Q, R) \<in> Rel` `A \<sharp>* R`
    by(rule_tac 1)
  moreover have "(A, \<Psi>, Q, R) \<in> Rel\<^sup>\<sharp>" using `(\<Psi>, Q, R) \<in> Rel` `A \<sharp>* Q` `A \<sharp>* R`
    by auto
  ultimately show ?case
    by(rule_tac 0)
qed

lemma fresh_rel_trancl_induct'[consumes 1, case_names prop_transitive r_into_fresh_rel_trancl]:
  assumes "(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>"
  and  0:  "\<And>P Q R. \<lbrakk>(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>; (A,\<Psi>,Q,R) \<in> Rel\<^sup>\<sharp>; Prop A \<Psi> P Q; Prop A \<Psi> Q R; A \<sharp>* P; A \<sharp>* Q; A \<sharp>* R\<rbrakk> \<Longrightarrow> Prop A \<Psi> P R"
  and  1: "\<And>P Q. \<lbrakk>(\<Psi>,P,Q) \<in> Rel; A \<sharp>* P; A \<sharp>* Q\<rbrakk> \<Longrightarrow> Prop A \<Psi> P Q"
  shows "Prop A \<Psi> P Q"
proof -
  note `(A,\<Psi>,P,Q) \<in> Rel\<^sup>\<sharp>`
  moreover obtain A' \<Psi>' where 2: "A=A'" and 3: "\<Psi>=\<Psi>'"
    by simp
  ultimately show ?thesis
  proof(induct rule: fresh_rel_trancl_induct)
    case(r_into_fresh_rel_trancl \<Psi> P Q A)
    thus ?case using 1 unfolding 2 3 
      by simp
  next
    case(prop_transitive A \<Psi> P Q R)
    thus ?case using 0 unfolding 2 3
      by simp
  qed
qed

lemma fresh_rel_trancl_weaken:
  assumes "(A,\<Psi>,P,Q) \<in> R\<^sup>\<sharp>"
  and "set B \<subseteq> set A"
  shows "(B,\<Psi>,P,Q) \<in> R\<^sup>\<sharp>"
  using assms
proof(induct rule: fresh_rel_trancl_induct')
  case(r_into_fresh_rel_trancl P Q)
  thus ?case
    by(rule_tac fresh_rel_trancl.intros) (auto simp add: fresh_def fresh_star_def)
next
  case(prop_transitive P Q S)
  thus ?case
    by(rule_tac fresh_rel_trancl_transitive) auto
qed

lemma fresh_rel_trancl_in_rel_trancl:
  assumes "(A,\<Psi>,P,Q) \<in> R\<^sup>\<sharp>"
  shows "(\<Psi>,P,Q) \<in> R\<^sup>\<star>"
proof -
  have "([],\<Psi>,P,Q) \<in> R\<^sup>\<sharp>" using assms
    by(simp add: fresh_rel_trancl_weaken)
  thus ?thesis
    by(rule fresh_rel_trancl_induct') (auto intro: rel_trancl_transitive)
qed

lemma empty_fresh_rel_trancl_is_rel_trancl[simp]:
  shows"(([],\<Psi>,P,Q) \<in> R\<^sup>\<sharp>) = ((\<Psi>,P,Q) \<in> R\<^sup>\<star>)"
proof(rule iffI)
 assume "([],\<Psi>,P,Q) \<in> R\<^sup>\<sharp>"
 thus   "(\<Psi>,P,Q) \<in> R\<^sup>\<star>"
   by(rule fresh_rel_trancl_in_rel_trancl)
next
 assume "(\<Psi>,P,Q) \<in> R\<^sup>\<star>"
 thus   "([],\<Psi>,P,Q) \<in> R\<^sup>\<sharp>"
   by(induct rule: rel_trancl_induct) (auto intro: fresh_rel_trancl_transitive)
qed

lemma rel_trancl_eqvt:
  assumes "eqvt X"
  shows   "eqvt(X\<^sup>\<star>)"
proof -
  {
    fix  p::"name prm"
      and \<Psi> P Q
    assume "(\<Psi>,P,Q) \<in> X\<^sup>\<star>"
    hence   "(p\<bullet>(\<Psi>,P,Q)) \<in> X\<^sup>\<star>"
    proof(induct rule: rel_trancl.induct)
      case(r_into_rel_trancl \<Psi> P Q)
      with `eqvt X` have "(p\<bullet>(\<Psi>, P, Q)) \<in> X"
        unfolding eqvt_def by auto
      thus ?case by auto
    next
      case(rel_trancl_into_rel_trancl \<Psi> P Q R)
      from `(\<Psi>, Q, R) \<in> X` `eqvt X` have "(p\<bullet>(\<Psi>, Q, R)) \<in> X"
        unfolding eqvt_def by auto
      hence "(p\<bullet>(\<Psi>, Q, R)) \<in> X\<^sup>\<star>"
        by auto
      with `p \<bullet> (\<Psi>, P, Q) \<in> X\<^sup>\<star>` show ?case by(auto dest: rel_trancl_transitive)
    qed
  }
  thus ?thesis unfolding eqvt_def
    by auto
qed

lemma fresh_rel_trancl_eqvt:
  assumes "eqvt X"
  shows   "eqvt(X\<^sup>\<sharp>)"
proof -
  {
    fix  p::"name prm"
      and A \<Psi> P Q
    assume a: "(A,\<Psi>,P,Q) \<in> X\<^sup>\<sharp>"
    hence "A \<sharp>* P" and "A \<sharp>* Q"
      by(simp add: fresh_rel_trancl_fresh)+
    from a have "(p\<bullet>(A,\<Psi>,P,Q)) \<in> X\<^sup>\<sharp>"
    proof(induct rule: fresh_rel_trancl_induct)
      case(r_into_fresh_rel_trancl \<Psi> P Q A)
      with `eqvt X` have "(p\<bullet>(\<Psi>, P, Q)) \<in> X"
        unfolding eqvt_def by auto
      moreover from `A \<sharp>* P` and `A \<sharp>* Q`
      have "(p\<bullet>A) \<sharp>* (p\<bullet>P)" and "(p\<bullet>A) \<sharp>* (p\<bullet>Q)"
        unfolding fresh_star_bij by -
      ultimately show ?case
        by auto
    next
      case(prop_transitive A \<Psi> P Q R)
      thus ?case
        unfolding eqvts
        by(rule_tac fresh_rel_trancl_transitive)
    qed
  }
  thus ?thesis unfolding eqvt_def
    by auto
qed

lemma rel_trancl_resPres:
  fixes X :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
  assumes XresPres: "\<And>\<Psi> P Q x. \<lbrakk>(\<Psi>, P, Q) \<in> X; x \<sharp> \<Psi>\<rbrakk> \<Longrightarrow> (\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> X"
  and "(\<Psi>,P,Q) \<in> X\<^sup>\<star>"
  and "x \<sharp> \<Psi>"
  shows "(\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> X\<^sup>\<star>"
using `(\<Psi>,P,Q) \<in> X\<^sup>\<star>` `x \<sharp> \<Psi>`
proof(induct rule: rel_trancl.induct)
  case(r_into_rel_trancl \<Psi> P Q)
  thus ?case
    by(auto intro: XresPres)
next
  case(rel_trancl_into_rel_trancl \<Psi> P Q R)
  moreover hence "(\<Psi>, \<lparr>\<nu>x\<rparr>Q, \<lparr>\<nu>x\<rparr>R) \<in> X\<^sup>\<star>"
    by(auto intro: XresPres)
  ultimately show ?case
    by(rule_tac rel_trancl_transitive)
qed

lemma fresh_rel_trancl_resPres:
  fixes X :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
  assumes XresPres: "\<And>\<Psi> P Q x. \<lbrakk>(\<Psi>, P, Q) \<in> X; x \<sharp> \<Psi>\<rbrakk> \<Longrightarrow> (\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> X"
  and "(A,\<Psi>,P,Q) \<in> X\<^sup>\<sharp>"
  and "x \<sharp> \<Psi>"
  shows "(A,\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> X\<^sup>\<sharp>"
using `(A,\<Psi>,P,Q) \<in> X\<^sup>\<sharp>` `x \<sharp> \<Psi>`
proof(induct rule: fresh_rel_trancl_induct)
  case(r_into_fresh_rel_trancl \<Psi> P Q A)
  thus ?case
    apply(rule_tac fresh_rel_trancl.intros)
    apply(rule XresPres)
    apply assumption
    apply assumption
    apply(auto simp add: fresh_star_def)
    apply(subst fresh_abs_fun_iff[OF pt_name_inst, OF at_name_inst])
    apply(finite_guess)
    apply simp
    apply(subst fresh_abs_fun_iff[OF pt_name_inst, OF at_name_inst])
    apply(finite_guess)
    apply simp
    done
next
  case(prop_transitive A \<Psi> P Q R)
  thus ?case
    by(blast intro: fresh_rel_trancl_transitive)
qed

lemma \<F>simps'[simp]:
  assumes "extractFrame P = \<langle>\<epsilon>,\<Psi>\<rangle>"
  shows "(\<F>(P)) = \<lbrace>\<Psi>\<rbrace>"
  using assms
  unfolding \<F>_def
  by simp

lemma frameEntResClosed:
  fixes x::name
  and   F::"'b frame"
  and   G::"'b frame"
  and   \<phi>::'c
  assumes "\<And> p::name prm. F \<turnstile>\<^sub>F (p \<bullet> \<phi>) \<Longrightarrow> G \<turnstile>\<^sub>F (p \<bullet> \<phi>)"
  and     "(\<lparr>\<nu>x\<rparr>F) \<turnstile>\<^sub>F \<phi>"
  shows   "(\<lparr>\<nu>x\<rparr>G) \<turnstile>\<^sub>F \<phi>"
using assms
proof -
  {
    fix x::name
      and   F::"'b frame"
      and   G::"'b frame"
      and   \<phi>::'c
    assume "F \<turnstile>\<^sub>F \<phi> \<Longrightarrow> G \<turnstile>\<^sub>F \<phi>"
      and  "(\<lparr>\<nu>x\<rparr>F) \<turnstile>\<^sub>F \<phi>"
      and  "x \<sharp> \<phi>"
    moreover obtain A\<^isub>F \<Psi>\<^isub>F where "F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "A\<^isub>F \<sharp>* \<phi>" and "x \<sharp> A\<^isub>F" and "distinct A\<^isub>F"
      by(rule_tac freshFrame[where C="(\<phi>,x)"]) auto
    moreover obtain A\<^isub>G \<Psi>\<^isub>G where "G = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>" and "A\<^isub>G \<sharp>* \<phi>" and "x \<sharp> A\<^isub>G" and "distinct A\<^isub>G"
      by(rule_tac freshFrame[where C="(\<phi>,x)"]) auto
    moreover from `(\<lparr>\<nu>x\<rparr>F) \<turnstile>\<^sub>F \<phi>` have "F \<turnstile>\<^sub>F \<phi>" using `x \<sharp> \<phi>` `x \<sharp> A\<^isub>F` `A\<^isub>F \<sharp>* \<phi>` unfolding `F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
      apply(drule_tac frameImpEAux[where A\<^isub>F="x#A\<^isub>F"])
      apply simp
      apply simp
      by(rule_tac frameImpI[where A\<^isub>F=A\<^isub>F and \<Psi>\<^isub>F=\<Psi>\<^isub>F]) (rule refl|assumption)+
    ultimately have "(\<lparr>\<nu>x\<rparr>G) \<turnstile>\<^sub>F \<phi>"
      apply(rule_tac frameImpI[where A\<^isub>F="x#A\<^isub>G"])
      apply simp
      apply simp
      apply simp
      apply(drule_tac frameImpEAux[where A\<^isub>F="A\<^isub>G"])
      apply simp
      apply simp
      by assumption
  }
  note rool = this
  obtain y::name where "y \<noteq> x" and "y \<sharp> \<phi>" and "y \<sharp> F" and "y \<sharp> G"
    by(generate_fresh "name") auto
  from `\<And> p::name prm. F \<turnstile>\<^sub>F (p \<bullet> \<phi>) \<Longrightarrow> G \<turnstile>\<^sub>F (p \<bullet> \<phi>)`
  have "F \<turnstile>\<^sub>F ([(x,y)]\<bullet>\<phi>) \<Longrightarrow> G \<turnstile>\<^sub>F ([(x,y)]\<bullet>\<phi>)"
    by -
  hence "([(x,y)]\<bullet>F) \<turnstile>\<^sub>F \<phi> \<Longrightarrow> ([(x,y)]\<bullet>G) \<turnstile>\<^sub>F \<phi>"
    apply(subst perm_bool[where pi="[(x,y)]",symmetric])
    apply(subst (asm) perm_bool[where pi="[(x,y)]",symmetric])
    by(simp add: eqvts)
  moreover have "(\<lparr>\<nu>y\<rparr>([(x,y)]\<bullet>F)) \<turnstile>\<^sub>F \<phi>" using `(\<lparr>\<nu>x\<rparr>F) \<turnstile>\<^sub>F \<phi>`
    by(subst (asm) alphaFrameRes[where y=y, OF `y \<sharp> F`])
  moreover note `y \<sharp> \<phi>`
  ultimately have "(\<lparr>\<nu>y\<rparr>([(x,y)]\<bullet>G)) \<turnstile>\<^sub>F \<phi>"
    by(rule rool)
  thus ?thesis
    by(subst alphaFrameRes[where y=y, OF `y \<sharp> G`])
qed 

lemma FrameImpResPres:
  fixes F::"'b frame"
  and   y::name
  and   \<phi>::'c
  assumes "F \<turnstile>\<^sub>F \<phi>"
  and     "y \<sharp> \<phi>"
  shows   "(\<lparr>\<nu>y\<rparr>F) \<turnstile>\<^sub>F \<phi>"
proof -
  obtain A\<^isub>F \<Psi>\<^isub>F where "F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* \<phi>" and "A\<^isub>F \<sharp>* y" and "A\<^isub>F \<sharp>* F"
    by(rule freshFrame[where C="(\<phi>,y,F)" and F=F]) auto
  hence "\<Psi>\<^isub>F \<turnstile> \<phi>" using assms
    by(rule_tac frameImpE) auto
  hence "(\<langle>(y#A\<^isub>F),\<Psi>\<^isub>F\<rangle>) \<turnstile>\<^sub>F \<phi>" using `y \<sharp> \<phi>` `A\<^isub>F \<sharp>* \<phi>`
    by(rule_tac frameImpI) (rule refl|simp)+
  thus ?thesis unfolding `F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
    by simp
qed

lemma FrameImpResChainPres:
  fixes F::"'b frame"
  and   yvec::"name list"
  and   \<phi>::'c
  assumes "F \<turnstile>\<^sub>F \<phi>"
  and     "yvec \<sharp>* \<phi>"
  shows   "(\<lparr>\<nu>*yvec\<rparr>F) \<turnstile>\<^sub>F \<phi>"
using assms
by(induct yvec) (simp add: FrameImpResPres)+

lemma FrameImpResDest:
  fixes F::"'b frame"
  and   y::name
  and   \<phi>::'c
  assumes "(\<lparr>\<nu>y\<rparr>F) \<turnstile>\<^sub>F \<phi>"
  and     "y \<sharp> \<phi>"
  shows   "F \<turnstile>\<^sub>F \<phi>"
proof -
  obtain A\<^isub>F \<Psi>\<^isub>F where "F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>" and "distinct A\<^isub>F" and "A\<^isub>F \<sharp>* \<phi>" and "A\<^isub>F \<sharp>* y" and "A\<^isub>F \<sharp>* F"
    by(rule freshFrame[where C="(\<phi>,y,F)" and F=F]) auto
  hence "(\<langle>(y#A\<^isub>F),\<Psi>\<^isub>F\<rangle>) \<turnstile>\<^sub>F \<phi>" using assms
    by simp
  hence "\<Psi>\<^isub>F \<turnstile> \<phi>" using assms `A\<^isub>F \<sharp>* \<phi>`
    by(rule_tac frameImpE) (assumption|simp)+
  hence "(\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>) \<turnstile>\<^sub>F \<phi>" using `A\<^isub>F \<sharp>* \<phi>`
    by(rule_tac frameImpI) (rule refl|simp)+
  thus ?thesis unfolding `F=\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`
    by simp
qed

lemma FrameImpResChainDest:
  fixes F::"'b frame"
  and   yvec::"name list"
  and   \<phi>::'c
  assumes "(\<lparr>\<nu>*yvec\<rparr>F) \<turnstile>\<^sub>F \<phi>"
  and     "yvec \<sharp>* \<phi>"
  shows   "F \<turnstile>\<^sub>F \<phi>"
using assms
by(induct yvec) (simp add: FrameImpResDest)+


lemma \<F>ResComm:
  shows "\<lparr>\<nu>a\<rparr>(\<F> P) = \<F>(\<lparr>\<nu>a\<rparr> P)"
proof -
  obtain A \<Psi> where "extractFrame P = \<langle>A,\<Psi>\<rangle>" and "A \<sharp>* a"
    by(rule_tac freshFrame[where C=a]) auto
  moreover hence "extractFrame (\<lparr>\<nu>a\<rparr>P) = \<langle>(a#A),\<Psi>\<rangle>"
    by simp
  ultimately show ?thesis
    by (metis \<F>_def extractFrameSimps processFrame.simps)
qed

lemma hobisimResPres:
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   x :: name
  
  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  and     "x \<sharp> \<Psi>"

  shows "\<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<sim>\<^sub>H \<lparr>\<nu>x\<rparr>Q"
proof -
  let ?X = "{(\<Psi>, \<lparr>\<nu>x\<rparr>P, \<lparr>\<nu>x\<rparr>Q) | \<Psi> x P Q. \<Psi> \<rhd> P \<sim>\<^sub>H Q \<and> x \<sharp> \<Psi>}"
  
  from assms have "(\<Psi>, \<lparr>\<nu>x\<rparr>P, \<lparr>\<nu>x\<rparr>Q) \<in> ?X" by auto
  moreover have "eqvt ?X"
    apply(auto simp add: eqvt_def)
    apply(rule_tac x="p\<bullet>x" in exI)
    apply(rule_tac x="p\<bullet>P" in exI)
    apply auto
    apply(rule_tac x="p\<bullet>Q" in exI)
    by(auto simp add: hobisimClosed fresh_bij)
  ultimately show ?thesis
  proof(coinduct rule: hotransitiveCoinduct'')
    case(cStatEq \<Psi> xP xQ \<phi>)
    from `(\<Psi>, xP, xQ) \<in> ?X` obtain x P Q where "\<Psi> \<rhd> P \<sim>\<^sub>H Q" and "x \<sharp> \<Psi>" and "xP = \<lparr>\<nu>x\<rparr>P" and "xQ = \<lparr>\<nu>x\<rparr>Q"
      by auto
    moreover from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have PeqQ: "\<And> p::name prm. insertAssertion(extractFrame P) \<Psi> \<turnstile>\<^sub>F (p\<bullet>\<phi>) \<Longrightarrow> insertAssertion(extractFrame Q) \<Psi> \<turnstile>\<^sub>F (p\<bullet>\<phi>)" using `\<not> clauseDom \<phi>`
    proof -
      fix p::"name prm"
      from `\<not> clauseDom \<phi>` have "\<not> clauseDom(p\<bullet>\<phi>)"
        by(subst (asm) perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      thus "insertAssertion(extractFrame P) \<Psi> \<turnstile>\<^sub>F (p\<bullet>\<phi>) \<Longrightarrow> insertAssertion(extractFrame Q) \<Psi> \<turnstile>\<^sub>F (p\<bullet>\<phi>)" using `\<Psi> \<rhd> P \<sim>\<^sub>H Q`
        by(blast dest: hobisimE)
    qed
    ultimately show ?case using `insertAssertion(extractFrame xP) \<Psi> \<turnstile>\<^sub>F \<phi>` using frameImpResPres
      by simp (metis frameEntResClosed)
  next
    case(cSim \<Psi> xP xQ)
    from `(\<Psi>, xP, xQ) \<in> ?X` obtain x P Q where "\<Psi> \<rhd> P \<sim>\<^sub>H Q" and "x \<sharp> \<Psi>" and "xP = \<lparr>\<nu>x\<rparr>P" and "xQ = \<lparr>\<nu>x\<rparr>Q"
      by auto
    from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi> \<rhd> P \<leadsto>[hobisim] Q" by(rule hobisimE)
    moreover have "eqvt ?X"
      by(force simp add: eqvt_def hobisimClosed pt_fresh_bij[OF pt_name_inst, OF at_name_inst])
    hence "eqvt(?X \<union> hobisim)" by auto
    moreover note `x \<sharp> \<Psi>`
    moreover have "hobisim \<subseteq> ?X \<union> hobisim" by auto
    moreover have "\<And>\<Psi> P Q x. \<lbrakk>(\<Psi>, P, Q) \<in> hobisim; x \<sharp> \<Psi>\<rbrakk> \<Longrightarrow> (\<Psi>, \<lparr>\<nu>x\<rparr>P, \<lparr>\<nu>x\<rparr>Q) \<in> ?X \<union> hobisim"
      by auto
    ultimately have "\<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<leadsto>[(?X \<union> hobisim)] \<lparr>\<nu>x\<rparr>Q"
      by(rule resPres)
    moreover have "(?X \<union> hobisim) \<subseteq> {(\<Psi>,P,Q)| \<Psi> P P' Q' Q. \<Psi> \<rhd> P \<sim>\<^sub>H P' \<and> (\<Psi>,P',Q') \<in> ?X \<union> hobisim \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H Q}"
    proof -
      {
        fix x
        assume "x \<in> (?X \<union> hobisim)"
        then obtain \<Psi> P Q where "x = (\<Psi>,P,Q)"
          by(induct x) auto
        hence "x \<in> {(\<Psi>,P,Q)| \<Psi> P P' Q' Q. \<Psi> \<rhd> P \<sim>\<^sub>H P' \<and> (\<Psi>,P',Q') \<in> ?X \<union> hobisim \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H Q}"          
          apply(rule_tac UnE[OF `x \<in> (?X \<union> hobisim)`])
          apply(blast intro: hobisimReflexive)
          by(auto intro: hobisimReflexive hobisimTransitive)      
      }
      thus ?thesis
        by blast
    qed
    moreover note `xP = \<lparr>\<nu>x\<rparr>P` `xQ = \<lparr>\<nu>x\<rparr>Q`
    ultimately show ?case
      by(blast intro: monotonic)
  next
    case(cExt \<Psi> xP xQ \<Psi>')
    from `(\<Psi>, xP, xQ) \<in> ?X` obtain x P Q where "\<Psi> \<rhd> P \<sim>\<^sub>H Q" and "x \<sharp> \<Psi>" and "xP = \<lparr>\<nu>x\<rparr>P" and "xQ = \<lparr>\<nu>x\<rparr>Q"
      by auto
    obtain y::name where "y \<sharp> P" and "y \<sharp> Q" and "y \<sharp> \<Psi>" and "y \<sharp> \<Psi>'"
     by(generate_fresh "name", auto simp add: fresh_prod)
   from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi> \<otimes> ([(x, y)] \<bullet> \<Psi>') \<rhd> P \<sim>\<^sub>H Q"
     by(rule hobisimE)
   hence "([(x, y)] \<bullet> (\<Psi> \<otimes> ([(x, y)] \<bullet> \<Psi>'))) \<rhd> ([(x, y)] \<bullet> P) \<sim>\<^sub>H ([(x, y)] \<bullet> Q)"
     by(rule hobisimClosed)
   with `x \<sharp> \<Psi>` `y \<sharp> \<Psi>` have "\<Psi> \<otimes> \<Psi>' \<rhd> ([(x, y)] \<bullet> P) \<sim>\<^sub>H ([(x, y)] \<bullet> Q)"
     by(simp add: eqvts)
   with `y \<sharp> \<Psi>` `y \<sharp> \<Psi>'` have "(\<Psi> \<otimes> \<Psi>', \<lparr>\<nu>y\<rparr>([(x, y)] \<bullet> P), \<lparr>\<nu>y\<rparr>([(x, y)] \<bullet> Q)) \<in> ?X"
     by auto
   moreover from `y \<sharp> P` `y \<sharp> Q` have "\<lparr>\<nu>x\<rparr>P = \<lparr>\<nu>y\<rparr>([(x, y)] \<bullet> P)" and "\<lparr>\<nu>x\<rparr>Q = \<lparr>\<nu>y\<rparr>([(x, y)] \<bullet> Q)"
     by(simp add: alphaRes)+
   ultimately show ?case using `xP = \<lparr>\<nu>x\<rparr>P` `xQ = \<lparr>\<nu>x\<rparr>Q` by simp
 next
    case(cSym \<Psi> P Q)
    thus ?case
      by(blast dest: hobisimE intro: hobisimReflexive)
  next
    case(cClauseEq \<Psi> xP xQ M R)
    from `(\<Psi>, xP, xQ) \<in> ?X` obtain x P Q where "\<Psi> \<rhd> P \<sim>\<^sub>H Q" and "x \<sharp> \<Psi>" and xP: "xP = \<lparr>\<nu>x\<rparr>P" and xQ: "xQ = \<lparr>\<nu>x\<rparr>Q"
      by auto
    obtain y::name where "y \<noteq> x" and "y \<sharp> \<Psi>" and "y \<sharp> xP" and "y \<sharp> xQ" and "y \<sharp> M" and "y \<sharp> R" and "y \<sharp> P" and "y \<sharp> Q"
      by(generate_fresh "name") auto
    have "insertAssertion (extractFrame ([(x,y)]\<bullet>P)) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> R)"
    proof -
      from `insertAssertion (extractFrame xP) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> R)` `x \<sharp> \<Psi>`
      have "(\<lparr>\<nu>x\<rparr>(insertAssertion (extractFrame P) \<Psi>)) \<turnstile>\<^sub>F (M \<Leftarrow> R)"
        unfolding `xP = \<lparr>\<nu>x\<rparr>P` by simp
      hence "(\<lparr>\<nu>y\<rparr>(insertAssertion (extractFrame ([(x,y)]\<bullet>P)) \<Psi>)) \<turnstile>\<^sub>F (M \<Leftarrow> R)" using `y \<sharp> \<Psi>` `x \<sharp> \<Psi>` `y \<sharp> P`
        by(subst (asm) alphaFrameRes[where y=y]) (auto simp add: insertAssertionFresh extractFrameFresh eqvts)
      thus ?thesis using `y \<sharp> M` `y \<sharp> R`
        by(rule_tac FrameImpResDest) auto
    qed
    moreover have "\<Psi> \<rhd> ([(x,y)]\<bullet>P) \<sim>\<^sub>H ([(x,y)]\<bullet>Q)" using `\<Psi> \<rhd> P \<sim>\<^sub>H Q` using `x \<sharp> \<Psi>` `y \<sharp> \<Psi>`
      by(subst perm_bool[where pi="[(x,y)]",symmetric]) (simp add: eqvts)
    ultimately have "\<exists> S. legalClause M S \<and> insertAssertion (extractFrame ([(x,y)]\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> S) \<and> \<one> \<rhd> R \<sim>\<^sub>H S" using `legalClause M R`
      by(blast dest: hobisimE)
    then obtain S where "legalClause M S" and "insertAssertion (extractFrame ([(x,y)]\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> S)" and "R \<sim>\<^sub>H S"
      by blast
    from `y \<sharp> M` have "y \<sharp> S" using `legalClause M S`
      unfolding legalClause_def fresh_def
      by blast
    with `insertAssertion (extractFrame ([(x,y)]\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> S)` have "(\<lparr>\<nu>y\<rparr>insertAssertion (extractFrame ([(x,y)]\<bullet>Q)) \<Psi>) \<turnstile>\<^sub>F (M \<Leftarrow> S)" using `y \<sharp> M`
      by(rule_tac FrameImpResPres) auto
    hence "insertAssertion (extractFrame xQ) \<Psi> \<turnstile>\<^sub>F (M \<Leftarrow> S)" using `y \<sharp> \<Psi>` unfolding `xQ = \<lparr>\<nu>x\<rparr>Q`
      by(subst alphaRes[OF `y \<sharp> Q`]) simp
    moreover have "(\<one>,R, S) \<in> {(\<Psi>,P,Q)| \<Psi> P P' Q' Q. \<Psi> \<rhd> P \<sim>\<^sub>H P' \<and> (\<Psi>,P',Q') \<in> ?X \<union> hobisim \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H Q}" using `R \<sim>\<^sub>H S`
      by(blast intro: hobisimTransitive hobisimReflexive)
    moreover note `legalClause M S`
    ultimately show ?case
      by blast
  qed
qed

lemma hobisimResChainPres:
  fixes \<Psi>   :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Q    :: "('a, 'b, 'c) psi"
  and   xvec :: "name list"

  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  and     "xvec \<sharp>* \<Psi>"

  shows "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>P \<sim>\<^sub>H \<lparr>\<nu>*xvec\<rparr>Q"
using assms
by(induct xvec) (auto intro: hobisimResPres)

lemma hobisimClausePres:
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   \<Psi>\<^isub>P :: 'b
  and   \<Psi>\<^isub>Q :: 'b
  and   M :: 'a
  assumes "legalClause M P"
  and     "legalClause M Q"
  and     "P \<sim>\<^sub>H Q"
  and     "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> P \<or> \<Psi> \<turnstile> \<phi>)"
  and     "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)"
  and     Inj: "\<And> P M' P'. M \<Leftarrow> P = M' \<Leftarrow> P' \<Longrightarrow> M = M' \<and> P = P'"
  shows   "\<Psi> \<rhd> \<lbrace>\<Psi>\<^isub>P\<rbrace> \<sim>\<^sub>H (\<lbrace>\<Psi>\<^isub>Q\<rbrace>)"
proof -
  let ?X = "{(\<Psi>, \<lbrace>\<Psi>\<^isub>P\<rbrace>, \<lbrace>\<Psi>\<^isub>Q\<rbrace>)| \<Psi> \<Psi>\<^isub>P \<Psi>\<^isub>Q M P Q. (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M \<Leftarrow> P) \<and> (\<forall> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<Leftarrow> Q) \<and> (\<forall> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> P \<or> \<Psi> \<turnstile> \<phi>)) \<and> (\<forall> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)) \<and> legalClause M P \<and> legalClause M Q \<and> P \<sim>\<^sub>H Q \<and> (\<forall> P M' P'. M \<Leftarrow> P = M' \<Leftarrow> P' \<longrightarrow> (M = M' \<and> P = P'))}"
  from assms have "(\<Psi>,\<lbrace>\<Psi>\<^isub>P\<rbrace>,\<lbrace>\<Psi>\<^isub>Q\<rbrace>) \<in> ?X" 
    by blast
  thus ?thesis
  proof(coinduct rule: hobisimWeakCoinductSC)
    case cSym thus ?case by(blast dest: hobisimE)
  next
    case cExt thus ?case by(blast dest: hobisimE)
  next
    case cSim thus ?case unfolding simulation_def by blast
  next
    case(cStatEq \<Psi> R S \<phi>)
    from `(\<Psi>, R, S) \<in> ?X` obtain \<Psi>\<^isub>Q \<Psi>\<^isub>P P Q M where rdef: "R=\<lbrace>\<Psi>\<^isub>P\<rbrace>" and sdef: "S=\<lbrace>\<Psi>\<^isub>Q\<rbrace>" and "legalClause M P" and "legalClause M Q" and "P \<sim>\<^sub>H Q" and "\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M \<Leftarrow> P" and "\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<Leftarrow> Q" and psirent: "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> P \<or> \<Psi> \<turnstile> \<phi>)" and psipent: "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)" and Inj: "\<And> P M' P'. M \<Leftarrow> P = M' \<Leftarrow> P' \<Longrightarrow> M = M' \<and> P = P'"
      by blast
    {
      assume a: "\<phi> = M\<Leftarrow>P"
      hence False
      proof -
        from a have "clauseDom \<phi>"
          by(simp add: clauseDom.intros)
        thus False using `\<not> clauseDom \<phi>`
          by simp
      qed
    }    
    thus ?case
      using `\<not> clauseDom \<phi>` `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>`
      unfolding sdef rdef
      by(auto simp add: psirent psipent)
  next
    case(cClauseEq \<Psi> R S M' P')
    from `(\<Psi>, R, S) \<in> ?X` obtain \<Psi>\<^isub>Q \<Psi>\<^isub>P P Q M where rdef: "R=\<lbrace>\<Psi>\<^isub>P\<rbrace>" and sdef: "S=\<lbrace>\<Psi>\<^isub>Q\<rbrace>" and "legalClause M P" and "legalClause M Q" and "P \<sim>\<^sub>H Q" and "\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M \<Leftarrow> P" and "\<And> \<Psi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<Leftarrow> Q" and psirent: "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> P \<or> \<Psi> \<turnstile> \<phi>)" and psipent: "\<And> \<Psi> \<phi>. \<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> \<phi> = (\<phi> = M \<Leftarrow> Q \<or> \<Psi> \<turnstile> \<phi>)" and Inj: "\<And> P M' P'. M \<Leftarrow> P = M' \<Leftarrow> P' \<Longrightarrow> M = M' \<and> P = P'"
      by blast
    have "M' \<Leftarrow> P' = M \<Leftarrow> P \<or> \<Psi> \<turnstile> M' \<Leftarrow> P'" using `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F M' \<Leftarrow> P'` psirent unfolding rdef
      by simp
    thus ?case
    proof(rule disjE)
      assume "M'\<Leftarrow>P' = M\<Leftarrow>P"
      hence m'def: "M'= M" and p'def: "P' = P"
        by(metis Inj)+
      show ?case unfolding m'def p'def sdef rdef using `legalClause M Q` psipent `P \<sim>\<^sub>H Q`
        by auto
    next
      assume "\<Psi> \<turnstile> M'\<Leftarrow>P'"
      thus ?case unfolding sdef using psipent `legalClause M' P'` hobisimReflexive
        by auto
    qed
  qed
qed

definition TUR :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> ('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
where "TUR X = ({(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)} \<union> hobisim)\<^sup>\<star>"

definition TUR' :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> (name list \<times> 'b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
where "TUR' X = ({(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)} \<union> hobisim)\<^sup>\<sharp>"

lemma TUReqvt:
  assumes "eqvt X"
  shows   "eqvt(TUR X)"
  and     "eqvt(TUR' X)"
  and     "eqvt({(\<Psi>,(P::('a,'b,'c) psi),Q::('a,'b,'c) psi). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)})"
  and     "eqvt({(\<Psi>,P::('a,'b,'c) psi,Q::('a,'b,'c) psi). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)} \<union> hobisim)"
proof -
  let ?Y = "{(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)}"
  let ?X = "(?Y \<union> hobisim)\<^sup>\<star>"
  {
    fix \<Psi> R S
      and x::name
    assume "(\<Psi>,R,S) \<in> ?Y"
      and  "x \<sharp> \<Psi>"
    moreover then obtain P Q xvec where "R = \<lparr>\<nu>*xvec\<rparr>P" and  "S = \<lparr>\<nu>*xvec\<rparr>Q" and "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X"
      by auto
    ultimately have "(\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> ?Y"
      apply auto
      apply(rule exI[where x="x#xvec"])
      apply(rule exI[where x="P"])
      apply auto
      apply(rule exI[where x="Q"])
      apply auto
      done
  }
  note YresPres = this
  {
    fix \<Psi> P Q
      and x::name
    assume "(\<Psi>,P,Q) \<in> ?X"
      and  "x \<sharp> \<Psi>"
    have "(\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> ?X"
      apply(rule rel_trancl_resPres)
      apply(rule UnE)
      apply assumption
      apply(simp only: UnI1 YresPres)
      apply(simp only: UnI2 hobisimResPres)
      by fact+
  }
  note XresPres = this
  show "eqvt ?Y" using `eqvt X`
  proof -
    {
      fix x::"('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi)"
      assume "x \<in> ?Y"
      then obtain \<Psi> P Q xvec where "x=(\<Psi>,\<lparr>\<nu>*xvec\<rparr>P,\<lparr>\<nu>*xvec\<rparr>Q)" and "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X"
        by auto
      have "\<forall> (p::name prm). (p\<bullet>x) \<in> ?Y"
      proof(rule allI)
        fix p::"name prm"
        obtain q::"name prm" where "set q \<subseteq> set(p\<bullet>xvec) \<times> set(q\<bullet>p\<bullet>xvec)" and "distinctPerm q" and "(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>\<Psi>)" and "(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>P)" and "(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>xvec)" and "(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>Q)"
          by(rule_tac name_list_avoiding[where c="(p\<bullet>\<Psi>,p\<bullet>P,p\<bullet>Q,p\<bullet>xvec)" and xvec="p\<bullet>xvec"]) auto
        have "(p\<bullet>xvec) \<sharp>* (p\<bullet>\<Psi>)" using `xvec \<sharp>* \<Psi>`
          by(subst (asm) perm_bool[where pi=p,symmetric]) (simp only: eqvts)
        have pxdef: "(p\<bullet>x)=(p\<bullet>\<Psi>,\<lparr>\<nu>*q\<bullet>p\<bullet>xvec\<rparr>q\<bullet>p\<bullet>P,\<lparr>\<nu>*q\<bullet>p\<bullet>xvec\<rparr>q\<bullet>p\<bullet>Q)" unfolding `x=(\<Psi>,\<lparr>\<nu>*xvec\<rparr>P,\<lparr>\<nu>*xvec\<rparr>Q)` eqvts
          by((subst resChainAlpha[where xvec="p\<bullet>xvec"],fact+) | simp)+
        have "(p\<bullet>\<Psi>,q\<bullet>p\<bullet>P,q\<bullet>p\<bullet>Q) \<in> X"
        proof -
          have "q\<bullet>p\<bullet>(\<Psi>,P,Q) \<in> X" using `(\<Psi>,P,Q) \<in> X`
            by(rule_tac eqvtI[OF `eqvt X`])+
          thus ?thesis using `set q \<subseteq> set(p\<bullet>xvec) \<times> set(q\<bullet>p\<bullet>xvec)` `distinctPerm q` `(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>\<Psi>)` `(p\<bullet>xvec) \<sharp>* (p\<bullet>\<Psi>)`
            by(simp add: eqvts)
        qed
        thus "(p\<bullet>x) \<in> ?Y" using `(q\<bullet>p\<bullet>xvec) \<sharp>* (p\<bullet>\<Psi>)` unfolding pxdef
          by blast
      qed
    }
    thus ?thesis unfolding eqvt_def
      by simp
  qed
  thus "eqvt(?Y \<union> hobisim)"
    by auto
  thus "eqvt(TUR X)" and "eqvt(TUR' X)" unfolding TUR_def TUR'_def
    apply -
    apply(rule rel_trancl_eqvt, assumption)
    by(rule fresh_rel_trancl_eqvt)
qed

lemma \<F>resChainComm:
  shows "\<lparr>\<nu>*xvec\<rparr>(\<F> R) = \<F>(\<lparr>\<nu>*xvec\<rparr>R)"
by(induct xvec) (simp add: \<F>ResComm)+

lemma hobisimWeakCoinductTUR[consumes 2, case_names cStatEq cClauseEq cSim cExt cSym]:
  fixes F :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   X :: "('b \<times> ('a, 'b, 'c) psi \<times> ('a, 'b, 'c) psi) set"

  assumes "(\<Psi>, P, Q) \<in> X"
  and     "eqvt X"
  and     rStatEq: "\<And> \<Psi>' R S \<phi>. \<lbrakk>(\<Psi>', R, S) \<in> X; \<not>clauseDom \<phi>; (insertAssertion (extractFrame R)) \<Psi>' \<turnstile>\<^sub>F \<phi>\<rbrakk> \<Longrightarrow> (insertAssertion (extractFrame S)) \<Psi>' \<turnstile>\<^sub>F \<phi>"
  and     rClauseEq: "\<And>\<Psi>' R S M P. \<lbrakk>(\<Psi>', R, S) \<in> X; legalClause M P; (insertAssertion (extractFrame R)) \<Psi>' \<turnstile>\<^sub>F M \<Leftarrow> P\<rbrakk> \<Longrightarrow> \<exists>Q. legalClause M Q \<and> (insertAssertion (extractFrame S) \<Psi>') \<turnstile>\<^sub>F M \<Leftarrow> Q \<and> (\<one>,P,Q) \<in> TUR X"
  and     rSim: "\<And>\<Psi>' R S. \<lbrakk>(\<Psi>', R, S) \<in> X\<rbrakk> \<Longrightarrow> \<Psi>' \<rhd> R \<leadsto>[TUR X] S"
  and     rExt: "\<And>\<Psi>' R S \<Psi>''. (\<Psi>', R, S) \<in> X \<Longrightarrow> (\<Psi>' \<otimes> \<Psi>'', R, S) \<in> X"
  and     rSym: "\<And>\<Psi>' R S. (\<Psi>', R, S) \<in> X \<Longrightarrow> (\<Psi>', S, R) \<in> X"

  shows "(\<Psi>, P, Q) \<in> hobisim"
proof -
  let ?Y = "{(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> X)}"
  let ?X = "(?Y \<union> hobisim)\<^sup>\<star>"
  {
    fix \<Psi> R S
      and x::name
    assume "(\<Psi>,R,S) \<in> ?Y"
      and  "x \<sharp> \<Psi>"
    moreover then obtain P Q xvec where "R = \<lparr>\<nu>*xvec\<rparr>P" and  "S = \<lparr>\<nu>*xvec\<rparr>Q" and "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X"
      by auto
    ultimately have "(\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> ?Y"
      apply auto
      apply(rule exI[where x="x#xvec"])
      apply(rule exI[where x="P"])
      apply auto
      apply(rule exI[where x="Q"])
      apply auto
      done
  }
  note YresPres = this
  {
    fix \<Psi> P Q
      and x::name
    assume "(\<Psi>,P,Q) \<in> ?X"
      and  "x \<sharp> \<Psi>"
    have "(\<Psi>,\<lparr>\<nu>x\<rparr>P,\<lparr>\<nu>x\<rparr>Q) \<in> ?X"
      apply(rule rel_trancl_resPres)
      apply(rule UnE)
      apply assumption
      apply(simp only: UnI1 YresPres)
      apply(simp only: UnI2 hobisimResPres)
      by fact+
  }
  note XresPres = this
  have "eqvt(TUR X)" using `eqvt X`
    by(rule TUReqvt)
  hence "eqvt ?X" unfolding TUR_def by -
  have "(\<Psi>,P,Q) \<in> ?X" using `(\<Psi>,P,Q) \<in> X`
    by(auto simp add: exI[where x="[]"] exI[where x="P"])
  thus ?thesis
  proof(coinduct rule: hobisimWeakCoinduct)
    case(cStatEq \<Psi> R S \<phi>) thus ?case
    proof(induct rule: rel_trancl_induct)
      case(r_into_rel_trancl \<Psi> R S)
      hence "(\<Psi>, R, S) \<in> ?Y \<or> (\<Psi>, R, S) \<in> hobisim"
        by blast
      thus ?case
      proof(rule disjE)
        assume "\<Psi> \<rhd> R \<sim>\<^sub>H S"
        thus ?case using `\<not> clauseDom \<phi>` `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>`
          by(drule_tac hobisimE) auto
      next
        assume "(\<Psi>, R, S) \<in> ?Y"
        then obtain xvec P Q where "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X" and "R=\<lparr>\<nu>*xvec\<rparr>P" and "S=\<lparr>\<nu>*xvec\<rparr>Q"
          by blast
        obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "(p\<bullet>xvec) \<sharp>* \<Psi>"
          and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* \<phi>" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* S" and "distinctPerm p"
          by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,\<phi>,R,S)" and xvec=xvec]) auto
        have r: "R=\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P)" and s: "S=\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q)" unfolding `S=\<lparr>\<nu>*xvec\<rparr>Q` `R=\<lparr>\<nu>*xvec\<rparr>P`
          by(rule resChainAlpha, fact+)+
        have "(\<Psi>,p\<bullet>P,p\<bullet>Q) \<in> X"
        proof -
          from `(\<Psi>,P,Q) \<in> X` have "(p\<bullet>(\<Psi>,P,Q)) \<in> X" using `eqvt X`
            by(rule_tac eqvtI)
          thus ?thesis using `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
            by(simp add: eqvts)
        qed
        moreover from `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>` have "insertAssertion (extractFrame (p\<bullet>P)) \<Psi> \<turnstile>\<^sub>F \<phi>"
          unfolding r
          using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p \<bullet> xvec) \<sharp>* \<phi>`
          by (metis FrameImpResChainDest extractFrameEqvt(1) extractFrameResChain insertAssertionResChain)
        moreover note `\<not> clauseDom \<phi>`
        ultimately have "insertAssertion (extractFrame (p\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F \<phi>"
          by(rule_tac rStatEq)
        thus ?case unfolding s using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p \<bullet> xvec) \<sharp>* \<phi>`
          by(metis FrameImpResChainPres FrameStatEq_def FrameStatImp_def insertAssertionExtractFrameFresh)
      qed
    next
      case prop_transitive thus ?case by simp
    qed
  next
    case(cSim \<Psi> R S)
    thus ?case
    proof(induct rule: rel_trancl_induct)
      case(prop_transitive \<Psi> P Q R)
      thus ?case
        apply(rule transitive)
        apply fact
        by(auto intro: rel_trancl_transitive)
    next
      case(r_into_rel_trancl \<Psi> R S)
      hence "(\<Psi>, R, S) \<in> ?Y \<or> \<Psi> \<rhd> R \<sim>\<^sub>H S"
        by blast
      thus ?case
      proof(rule disjE)
        assume "\<Psi> \<rhd> R \<sim>\<^sub>H S"
        hence "\<Psi> \<rhd> R \<leadsto>[hobisim] S"
          by(rule hobisimE)
        moreover have "hobisim \<subseteq> ?X"
          by auto
        ultimately show ?case
          by(rule_tac monotonic)
      next
        assume "(\<Psi>,R,S) \<in> ?Y"
        then obtain xvec P Q where "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X" and "R=\<lparr>\<nu>*xvec\<rparr>P" and "S=\<lparr>\<nu>*xvec\<rparr>Q"
          by blast
        hence "\<Psi> \<rhd> P \<leadsto>[TUR X] Q"
          by(rule_tac rSim)
        hence PQs: "\<Psi> \<rhd> P \<leadsto>[(?Y \<union> hobisim)\<^sup>\<star>] Q"
          unfolding TUR_def by -
        from PQs have "\<Psi> \<rhd> R \<leadsto>[?X] S" unfolding `R=\<lparr>\<nu>*xvec\<rparr>P` `S=\<lparr>\<nu>*xvec\<rparr>Q`
          by(rule resChainPres) fact+
        thus ?case
          by auto
      qed
    qed    
  next
    case(cExt \<Psi> R S \<Psi>') thus ?case
    proof(induct rule: rel_trancl_induct)
      case(r_into_rel_trancl \<Psi> R S)
      hence "(\<Psi>,R,S) \<in> ?Y \<or> \<Psi> \<rhd> R \<sim>\<^sub>H S"
        by blast
      thus ?case
      proof(rule disjE)
        assume "(\<Psi>,R,S) \<in> ?Y"
        then obtain xvec P Q where "R = \<lparr>\<nu>*xvec\<rparr>P" and "S=\<lparr>\<nu>*xvec\<rparr>Q" and "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X"
          by blast
        then obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "distinctPerm p" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* S" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* \<Psi>'" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* xvec"
          by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,\<Psi>',xvec,R,S)" and xvec=xvec]) auto
        hence rdef: "R = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P)" and sdef: "S = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q)" unfolding `R = \<lparr>\<nu>*xvec\<rparr>P` `S=\<lparr>\<nu>*xvec\<rparr>Q`          
          by(subst resChainAlpha[where xvec=xvec and p=p]|simp)+
        have "(\<Psi>\<otimes>(p\<bullet>\<Psi>'),P,Q) \<in> X" using `(\<Psi>,P,Q) \<in> X`
          by(rule rExt)
        hence "p\<bullet>(\<Psi>\<otimes>(p\<bullet>\<Psi>'),P,Q) \<in> X" using `eqvt X`
          by(rule_tac eqvtI)
        hence "(\<Psi>\<otimes>\<Psi>',p\<bullet>P,p\<bullet>Q) \<in> X" using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>'` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `distinctPerm p` `xvec \<sharp>* \<Psi>`
          by(simp add: eqvts)
        thus ?case unfolding sdef rdef using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>'`
          by(rule_tac rel_trancl.intros) (auto intro: UnI1)
      next
        assume "\<Psi> \<rhd> R \<sim>\<^sub>H S"
        thus ?thesis
          apply(rule_tac rel_trancl.intros)
          by(rule UnI2) (rule hobisimE)
      qed
    next
      case(prop_transitive \<Psi> R' R S)
      thus ?case
        by(auto intro: rel_trancl_transitive)
    qed
  next
    case(cSym \<Psi> P Q) thus ?case
    proof(induct rule: rel_trancl_induct)
      case(r_into_rel_trancl \<Psi> P Q)
      thus ?case
        by(blast intro: rSym hobisimE)
    next
      case(prop_transitive \<Psi> P Q R)
      thus ?case
        by(blast intro: rel_trancl_transitive)
    qed
  next
    case(cClauseEq \<Psi> R S M P')
    thus ?case
    proof(induct arbitrary: P' rule: rel_trancl_induct)
      case(r_into_rel_trancl \<Psi> R S)
      hence "(\<Psi>, R, S) \<in> ?Y \<or> (\<Psi>, R, S) \<in> hobisim"
        by blast
      thus ?case
      proof(rule disjE)
        assume "\<Psi> \<rhd> R \<sim>\<^sub>H S"
        thus ?case using r_into_rel_trancl
          by(drule_tac hobisimE) auto
      next
        assume "(\<Psi>, R, S) \<in> ?Y"
        then obtain xvec P Q where "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> X" and "R=\<lparr>\<nu>*xvec\<rparr>P" and "S=\<lparr>\<nu>*xvec\<rparr>Q"
          by blast
        obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "(p\<bullet>xvec) \<sharp>* \<Psi>"
          and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* M" and "(p\<bullet>xvec) \<sharp>* P'" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* S" and "distinctPerm p"
          by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,M,P',R,S)" and xvec=xvec]) auto
        have r: "R=\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P)" and s: "S=\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q)" unfolding `S=\<lparr>\<nu>*xvec\<rparr>Q` `R=\<lparr>\<nu>*xvec\<rparr>P`
          by(rule resChainAlpha, fact+)+
        have "(\<Psi>,p\<bullet>P,p\<bullet>Q) \<in> X"
        proof -
          from `(\<Psi>,P,Q) \<in> X` have "(p\<bullet>(\<Psi>,P,Q)) \<in> X" using `eqvt X`
            by(rule_tac eqvtI)
          thus ?thesis using `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
            by(simp add: eqvts)
        qed
        moreover from `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> P'` have "insertAssertion (extractFrame (p\<bullet>P)) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> P'"
          unfolding r
          using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p \<bullet> xvec) \<sharp>* M` `(p \<bullet> xvec) \<sharp>* P`
          by (metis FrameImpResChainDest `(p \<bullet> xvec) \<sharp>* P'` extractFrameEqvt(1) extractFrameResChain freshClauseChain(1) insertAssertionResChain)
        moreover note `legalClause M P'`
        moreover note `(\<Psi>,p\<bullet>P,p\<bullet>Q) \<in> X`
        ultimately have "\<exists>Q'. legalClause M Q' \<and> insertAssertion (extractFrame (p\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q' \<and> (\<one>,P',Q') \<in> TUR X"
          by(rule_tac rClauseEq)
        then obtain Q' where "legalClause M Q'" and "insertAssertion (extractFrame(p\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q'" and "(\<one>,P',Q') \<in> TUR X"
          by blast
        from `legalClause M Q'` `(p\<bullet>xvec) \<sharp>* M` have "(p\<bullet>xvec) \<sharp>* Q'"
          by simp
        have "(\<one>,P',Q') \<in> ?X" using `(\<one>,P',Q') \<in> TUR X`
          unfolding TUR_def
          by blast
        from `legalClause M Q'` `(p \<bullet> xvec) \<sharp>* M` have "(p \<bullet> xvec) \<sharp>* Q'"
          unfolding legalClause_def fresh_star_def fresh_def
          by auto
        from `insertAssertion (extractFrame(p\<bullet>Q)) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q'`
        have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q'"
          unfolding s
          using `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p \<bullet> xvec) \<sharp>* M` `(p \<bullet> xvec) \<sharp>* Q`
          by (metis FrameImpResChainPres `(p \<bullet> xvec) \<sharp>* Q'` extractFrameResChain freshClauseChain(1) insertAssertionResChain)
        thus ?case using `legalClause M Q'` `(\<one>,P',Q') \<in> ?X`
          by blast
      qed
    next
      case(prop_transitive \<Psi> P Q R) thus ?case
        by(blast intro: rel_trancl_transitive)
    qed
  qed
qed

lemma frameResChainEqvt'[eqvt]:
  fixes perm :: "name prm"
  and   lst  :: "name list"
  and   \<Psi>    :: "'b"
  
  shows "perm \<bullet> \<langle>xvec,\<Psi>\<rangle> = \<langle>(perm \<bullet> xvec),(perm \<bullet> \<Psi>)\<rangle>"
by(induct_tac xvec, auto)

definition \<S> :: "('b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set"
where "\<S> = {(\<Psi>,P \<parallel> R,Q \<parallel> R) | \<Psi> P R Q \<Psi>\<^isub>R A\<^isub>R. extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle> \<and> A\<^isub>R \<sharp>* \<Psi> \<and> A\<^isub>R \<sharp>* P \<and> A\<^isub>R \<sharp>* Q \<and> \<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q}"

lemma RSresPres:
  fixes x::name
  and   \<Psi>::'b
  and   P::"('a,'b,'c) psi"
  and   Q::"('a,'b,'c) psi"
  assumes "(\<Psi>,R,S) \<in> {(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> \<S>)}"
  and  "x \<sharp> \<Psi>"
  shows "(\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> {(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> \<S>)}"
proof -
  note assms
  moreover then obtain P Q xvec where "R = \<lparr>\<nu>*xvec\<rparr>P" and  "S = \<lparr>\<nu>*xvec\<rparr>Q" and "xvec \<sharp>* \<Psi>" and "(\<Psi>,P,Q) \<in> \<S>"
    by auto
  ultimately show ?thesis
    apply auto
    apply(rule exI[where x="x#xvec"])
    apply(rule exI[where x="P"])
    apply auto
    apply(rule exI[where x="Q"])
    apply auto
    done
qed

lemma URSresPres:
  fixes x::name
  and   \<Psi>::'b
  and   P::"('a,'b,'c) psi"
  and   Q::"('a,'b,'c) psi"
  assumes "(\<Psi>,R,S) \<in> {(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> \<S>)} \<union> hobisim"
  and  "x \<sharp> \<Psi>"
  shows "(\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> {(\<Psi>,P,Q). \<exists> xvec P' Q'. P=\<lparr>\<nu>*xvec\<rparr>P' \<and> Q=\<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> ((\<Psi>,P',Q') \<in> \<S>)} \<union> hobisim"
  using assms
  apply(rule_tac UnE)
  apply assumption
  apply(simp only: UnI1 RSresPres)
  apply(simp only: UnI2 hobisimResPres)
  done

lemma TURSresPres:
  fixes x::name
  and   \<Psi>::'b
  and   P::"('a,'b,'c) psi"
  and   Q::"('a,'b,'c) psi"
  assumes "(\<Psi>,R,S) \<in> TUR \<S>"
  and  "x \<sharp> \<Psi>"
  shows "(\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> TUR \<S>"
using assms URSresPres
unfolding TUR_def
by(rule_tac rel_trancl_resPres)

lemma TURS'resPres:
  fixes x::name
  and   \<Psi>::'b
  and   P::"('a,'b,'c) psi"
  and   Q::"('a,'b,'c) psi"
  assumes "(A,\<Psi>,R,S) \<in> TUR' \<S>"
  and  "x \<sharp> \<Psi>"
  shows "(A,\<Psi>,\<lparr>\<nu>x\<rparr>R,\<lparr>\<nu>x\<rparr>S) \<in> TUR' \<S>"
using assms URSresPres
unfolding TUR'_def
by(rule_tac fresh_rel_trancl_resPres)

lemma TURS'resChainPres:
  fixes x::name
  and   \<Psi>::'b
  and   P::"('a,'b,'c) psi"
  and   Q::"('a,'b,'c) psi"
  assumes "(A,\<Psi>,R,S) \<in> TUR' \<S>"
  and  "xvec \<sharp>* \<Psi>"
  shows "(A,\<Psi>,\<lparr>\<nu>*xvec\<rparr>R,\<lparr>\<nu>*xvec\<rparr>S) \<in> TUR' \<S>"
using assms
by(induct xvec) (auto simp add: TURS'resPres)

lemma Seqvt:
  shows "eqvt \<S>"
  unfolding \<S>_def
    apply(auto simp add: eqvt_def)
    apply(rule_tac x="p \<bullet> P" in exI)
    apply(rule_tac x="p \<bullet> R" in exI)
    apply(simp add: eqvts)
    apply(rule_tac x="p \<bullet> Q" in exI)
    apply simp
    apply(rule_tac x="p \<bullet> \<Psi>\<^isub>R" in exI)
    apply(rule_tac x="p \<bullet> A\<^isub>R" in exI)
    apply(drule_tac p=p and \<Psi>="a\<otimes>\<Psi>\<^isub>R" in hobisimClosed)
    apply(simp add: eqvts fresh_star_bij)
    apply(rule_tac pi1="rev p" in subst[OF perm_bool])
    by(simp add: eqvts)

lemma hobisimInputPres:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Q    :: "('a, 'b, 'c) psi"
  and   M    :: 'a
  and   xvec :: "name list"
  and   N    :: 'a

  assumes "\<And>Tvec. length xvec = length Tvec \<Longrightarrow> \<Psi> \<rhd> P[xvec::=Tvec] \<sim>\<^sub>H Q[xvec::=Tvec]"

  shows "\<Psi> \<rhd> M\<lparr>\<lambda>*xvec N\<rparr>.P \<sim>\<^sub>H M\<lparr>\<lambda>*xvec N\<rparr>.Q"
proof -
  let ?X = "{(\<Psi>, M\<lparr>\<lambda>*xvec N\<rparr>.P, M\<lparr>\<lambda>*xvec N\<rparr>.Q) | \<Psi> M xvec N P Q. \<forall>Tvec. length xvec = length Tvec \<longrightarrow> \<Psi> \<rhd> P[xvec::=Tvec] \<sim>\<^sub>H Q[xvec::=Tvec]}"

  from assms have "(\<Psi>, M\<lparr>\<lambda>*xvec N\<rparr>.P, M\<lparr>\<lambda>*xvec N\<rparr>.Q) \<in> ?X" by blast
  thus ?thesis
  proof(coinduct rule: hobisimCoinduct)
    case(cStatEq \<Psi> P Q \<phi>)
    thus ?case by auto
  next
    case(cClauseEq \<Psi> R S M P)
    thus ?case
      by auto (blast intro: hobisimReflexive)
  next
    case(cSim \<Psi> P Q)
    thus ?case by(blast intro: inputPres)
  next
    case(cExt \<Psi> P Q \<Psi>')
    thus ?case by(blast dest: hobisimE)
  next
    case(cSym \<Psi> P Q)
    thus ?case by(blast dest: hobisimE)
  qed
qed

lemma hobisimOutputPres:
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   M :: 'a
  and   N :: 'a

  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"

  shows "\<Psi> \<rhd> M\<langle>N\<rangle>.P \<sim>\<^sub>H M\<langle>N\<rangle>.Q"
proof -
  let ?X = "{(\<Psi>, M\<langle>N\<rangle>.P, M\<langle>N\<rangle>.Q) | \<Psi> M N P Q. \<Psi> \<rhd> P \<sim>\<^sub>H Q}"
  from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have "(\<Psi>, M\<langle>N\<rangle>.P, M\<langle>N\<rangle>.Q) \<in> ?X" by auto
  thus ?thesis
    by(coinduct rule: hobisimCoinduct, auto simp add: hobisimReflexive) (blast intro: outputPres dest: hobisimE)+
qed

lemma hobisimCasePres:
  fixes \<Psi>   :: 'b
  and   CsP :: "('c \<times> ('a, 'b, 'c) psi) list"
  and   CsQ :: "('c \<times> ('a, 'b, 'c) psi) list"

  assumes "\<And>\<phi> P. (\<phi>, P) mem CsP \<Longrightarrow> \<exists>Q. (\<phi>, Q) mem CsQ \<and> guarded Q \<and> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
  and     "\<And>\<phi> Q. (\<phi>, Q) mem CsQ \<Longrightarrow> \<exists>P. (\<phi>, P) mem CsP \<and> guarded P \<and> \<Psi> \<rhd> P \<sim>\<^sub>H Q"

  shows "\<Psi> \<rhd> Cases CsP \<sim>\<^sub>H Cases CsQ"
proof -
  let ?X = "{(\<Psi>, Cases CsP, Cases CsQ) | \<Psi> CsP CsQ. (\<forall>\<phi> P. (\<phi>, P) mem CsP \<longrightarrow> (\<exists>Q. (\<phi>, Q) mem CsQ \<and> guarded Q \<and> \<Psi> \<rhd> P \<sim>\<^sub>H Q)) \<and>
                                                     (\<forall>\<phi> Q. (\<phi>, Q) mem CsQ \<longrightarrow> (\<exists>P. (\<phi>, P) mem CsP \<and> guarded P \<and> \<Psi> \<rhd> P \<sim>\<^sub>H Q))}"
  from assms have "(\<Psi>, Cases CsP, Cases CsQ) \<in> ?X" by auto
  thus ?thesis
  proof(coinduct rule: hobisimCoinduct)
    case(cStatEq \<Psi> P Q \<phi>)
    thus ?case by auto
  next
    case(cClauseEq \<Psi> P Q M R)
    thus ?case by(auto simp add: hobisimReflexive)
  next
    case(cSim \<Psi> CasesP CasesQ)
    then obtain CsP CsQ where C1: "\<And>\<phi> Q. (\<phi>, Q) mem CsQ \<Longrightarrow> \<exists>P. (\<phi>, P) mem CsP \<and> guarded P \<and> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
                          and A: "CasesP = Cases CsP" and B: "CasesQ = Cases CsQ"
      by auto
    note C1
    moreover have "\<And>\<Psi> P Q. \<Psi> \<rhd> P \<sim>\<^sub>H Q \<Longrightarrow> \<Psi> \<rhd> P \<leadsto>[hobisim] Q" by(rule hobisimE)
    moreover have "hobisim \<subseteq> ?X \<union> hobisim" by blast
    ultimately have "\<Psi> \<rhd> Cases CsP \<leadsto>[(?X \<union> hobisim)] Cases CsQ"
      by(rule casePres)
    thus ?case using A B by blast
  next
    case(cExt \<Psi> P Q)
    thus ?case by(blast dest: hobisimE)
  next
    case(cSym \<Psi> P Q)
    thus ?case by(blast dest: hobisimE)
  qed
qed


lemma TURS'parPres:
  assumes 1: "(A\<^isub>R,\<Psi>,P,Q) \<in> TUR' \<S>"
  and     2: "\<Psi>=\<Psi>'\<otimes>\<Psi>\<^isub>R"
  and     3: "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
  and     4: "A\<^isub>R \<sharp>* \<Psi>'"
  and     4: "A\<^isub>R \<sharp>* R"
  and     7: "distinct A\<^isub>R"

  shows "(A\<^isub>R,\<Psi>',P \<parallel> R,Q \<parallel> R) \<in> TUR' \<S>"
using assms
unfolding TUR'_def
proof(induct rule: fresh_rel_trancl_induct)
  case(prop_transitive A\<^isub>R \<Psi> P Q S)
  thus ?case
    by(rule_tac fresh_rel_trancl_transitive) simp+
next
  case(r_into_fresh_rel_trancl \<Psi> P Q A\<^isub>R)
  let ?X = "{(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}"
  from `(\<Psi>, P, Q) \<in> ?X \<union> hobisim`
  show ?case
  proof(rule UnE)
    assume "(\<Psi>,P,Q) \<in> ?X"
    then obtain P' Q' xvec S A\<^isub>S \<Psi>\<^isub>S where Pdef: "P = \<lparr>\<nu>*xvec\<rparr>(P'\<parallel>S)" and Qdef: "Q = \<lparr>\<nu>*xvec\<rparr>(Q'\<parallel>S)" and "xvec \<sharp>* \<Psi>" "extractFrame S = \<langle>A\<^isub>S, \<Psi>\<^isub>S\<rangle>" "A\<^isub>S \<sharp>* P'" "A\<^isub>S \<sharp>* Q'" "A\<^isub>S \<sharp>* \<Psi>" "\<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P' \<sim>\<^sub>H Q'"
      unfolding \<S>_def
      by blast
    obtain q::"name prm" where "set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)" and "distinctPerm q" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>" and "(q\<bullet>A\<^isub>S) \<sharp>* P" and "(q\<bullet>A\<^isub>S) \<sharp>* Q" and "(q\<bullet>A\<^isub>S) \<sharp>* R" and "(q\<bullet>A\<^isub>S) \<sharp>* P'" and "(q\<bullet>A\<^isub>S) \<sharp>* Q'" and "(q\<bullet>A\<^isub>S) \<sharp>* xvec" and "(q\<bullet>A\<^isub>S) \<sharp>* S" and "(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>S" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>S" and "(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>R" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>R" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>'"
      by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,R,P',Q',xvec,S,A\<^isub>S,\<Psi>\<^isub>S,A\<^isub>R,\<Psi>\<^isub>R,\<Psi>')" and xvec=A\<^isub>S]) auto
    moreover obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "distinctPerm p" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* P'" and "(p\<bullet>xvec) \<sharp>* Q'" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* S" and "(p\<bullet>xvec) \<sharp>* A\<^isub>S" and "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>S" and "(p\<bullet>xvec) \<sharp>* A\<^isub>R" and "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>R" and "(p\<bullet>xvec) \<sharp>* \<Psi>'" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>P)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>Q)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>P')" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>Q')" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>xvec)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>\<^isub>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>\<^isub>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>')"
      by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,R,P',Q',xvec,S,A\<^isub>S,\<Psi>\<^isub>S,A\<^isub>R,\<Psi>\<^isub>R,\<Psi>',q\<bullet>\<Psi>,q\<bullet>P,q\<bullet>Q,q\<bullet>R,q\<bullet>P',q\<bullet>Q',q\<bullet>xvec,q\<bullet>S,q\<bullet>A\<^isub>S,q\<bullet>\<Psi>\<^isub>S,q\<bullet>A\<^isub>R,q\<bullet>\<Psi>\<^isub>R,q\<bullet>\<Psi>')" and xvec=xvec]) auto
    moreover have "extractFrame(p\<bullet>S) = \<langle>p\<bullet>q\<bullet>A\<^isub>S, p\<bullet>q\<bullet>\<Psi>\<^isub>S\<rangle>" using `extractFrame S = \<langle>A\<^isub>S, \<Psi>\<^isub>S\<rangle>` `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>S` `set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)`
      apply(subst (asm) frameChainAlpha[where p=q])
      apply simp
      apply simp
      apply(subst(asm) perm_bool[where pi=p,symmetric])
      by(simp only: eqvts)
    moreover note `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
    moreover have "A\<^isub>R \<sharp>* (p \<bullet> q \<bullet> A\<^isub>S)"
    proof -
      have "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      thus ?thesis using `(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>R`
        by simp
    qed
    moreover have "A\<^isub>R \<sharp>* (p \<bullet> q \<bullet> \<Psi>\<^isub>S)"
    proof -
      have "A\<^isub>R \<sharp>* (p\<bullet>S)" using `A\<^isub>R \<sharp>* P` Pdef `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `distinctPerm p` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* A\<^isub>R`
        by(subst(asm) resChainAlpha[where p=p]) auto
      thus ?thesis using `extractFrame(p\<bullet>S) = \<langle>p\<bullet>q\<bullet>A\<^isub>S, p\<bullet>q\<bullet>\<Psi>\<^isub>S\<rangle>` `A\<^isub>R \<sharp>* (p \<bullet> q \<bullet> A\<^isub>S)`
        by(drule_tac extractFrameFreshChain) simp
    qed
    moreover have "(p \<bullet> q \<bullet> A\<^isub>S) \<sharp>* \<Psi>\<^isub>R"
    proof -
      have "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      thus ?thesis using `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>R`
        by simp
    qed
    moreover have "\<Psi>' \<otimes> \<Psi>\<^isub>R \<otimes> (p \<bullet> q \<bullet> \<Psi>\<^isub>S) \<rhd> p \<bullet> P' \<sim>\<^sub>H p \<bullet> Q'"
    proof -
      from `\<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P' \<sim>\<^sub>H Q'`
      have "\<Psi> \<otimes> (q\<bullet>\<Psi>\<^isub>S) \<rhd> P' \<sim>\<^sub>H Q'" using `set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)` `A\<^isub>S \<sharp>* P'` `A\<^isub>S \<sharp>* Q'` `A\<^isub>S \<sharp>* \<Psi>` `(q\<bullet>A\<^isub>S) \<sharp>* P'` `(q\<bullet>A\<^isub>S) \<sharp>* Q'` `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>`
        by(drule_tac hobisimClosed[where p=q]) (simp add: eqvts)
      hence "\<Psi> \<otimes> (p\<bullet>q\<bullet>\<Psi>\<^isub>S) \<rhd> p\<bullet>P' \<sim>\<^sub>H p\<bullet>Q'" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
        by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
      thus ?thesis
        unfolding `\<Psi> = \<Psi>' \<otimes> \<Psi>\<^isub>R`
        by(rule hostatEqBisim) (rule Associativity)
    qed
    moreover note `A\<^isub>R \<sharp>* \<Psi>'`
    moreover have "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> P')" and "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> Q')"
    proof -
      have pq: "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      show "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> P')" and "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> Q')"
        by(subst pq[symmetric],subst fresh_star_bij,fact)+
    qed
    moreover have "A\<^isub>R \<sharp>* (p \<bullet> P')" and "A\<^isub>R \<sharp>* (p \<bullet> Q')"
    proof -
      from `A\<^isub>R \<sharp>* P` Pdef
      have "A\<^isub>R \<sharp>* (\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (p\<bullet>S))" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst(asm) resChainAlpha[where p=p]) (simp add: eqvts)+
      moreover from `A\<^isub>R \<sharp>* Q` Qdef
      have "A\<^isub>R \<sharp>* (\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> (p\<bullet>S))" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst(asm) resChainAlpha[where p=p]) (simp add: eqvts)+
      ultimately show "A\<^isub>R \<sharp>* (p\<bullet>P')" "A\<^isub>R \<sharp>* (p\<bullet>Q')" using `(p\<bullet>xvec) \<sharp>* A\<^isub>R`
        by simp+
    qed
    ultimately have ins: "(\<Psi>', (p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), (p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> \<S>"
      unfolding \<S>_def
      apply(auto simp add: psi.inject)
      apply(rule exI[where x = "\<Psi>\<^isub>R \<otimes> (p \<bullet> q \<bullet> \<Psi>\<^isub>S)"])
      apply(rule exI[where x = "(A\<^isub>R @ p \<bullet> q \<bullet> A\<^isub>S)"])
      apply(simp add: fresh_star_bij)
      done
    have f1: "A\<^isub>R \<sharp>* (P \<parallel> R)" using `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* R`
      by simp
    hence f2: "A\<^isub>R \<sharp>* (\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S)))" unfolding Pdef  using `set p \<subseteq> set xvec \<times> set(p\<bullet> xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S`
      by(subst (asm) resChainAlpha[where p=p]) (auto simp add: fresh_def fresh_star_def psi.supp resChainSupp)
    have f3: "A\<^isub>R \<sharp>* (Q \<parallel> R)" using `A\<^isub>R \<sharp>* Q` `A\<^isub>R \<sharp>* R`
      by simp
    hence f4: "A\<^isub>R \<sharp>* (\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> Q') \<parallel> (R \<parallel> (p \<bullet> S)))" unfolding Qdef  using `set p \<subseteq> set xvec \<times> set(p\<bullet> xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst (asm) resChainAlpha[where p=p]) (auto simp add: fresh_def fresh_star_def psi.supp resChainSupp)
    from ins have "(\<Psi>', \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> ?X" using `(p\<bullet>xvec) \<sharp>* \<Psi>'`
      by(auto simp add: psi.inject)
    hence "(A\<^isub>R,\<Psi>', \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> TUR' \<S>" using f2 f4
      unfolding TUR'_def
      by(rule_tac fresh_rel_trancl.intros) auto
    moreover have "(A\<^isub>R,\<Psi>',P \<parallel> R,\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S))) \<in> TUR' \<S>"
    proof -
      have "\<Psi>' \<rhd> P \<parallel> R \<sim>\<^sub>H \<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S))"
        unfolding Pdef using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* \<Psi>'``(p \<bullet> xvec) \<sharp>* R`
        apply(subst resChainAlpha[where p=p])
        apply(simp add: eqvts)+
        apply(rule hobisimBisim)
        by(metis bisimParAssoc bisimParComm bisimParPresSym bisimResChainPres bisimScopeExtChainSym bisimSymmetric bisimTransitive)
      with f1 f2 show ?thesis
        unfolding TUR'_def
        by(rule_tac fresh_rel_trancl.intros) auto
    qed
    moreover have "(A\<^isub>R,\<Psi>',\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S))), Q \<parallel> R) \<in> TUR' \<S>"
    proof -
      have "\<Psi>' \<rhd> \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S))) \<sim>\<^sub>H Q \<parallel> R"
        unfolding Qdef using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* \<Psi>'``(p \<bullet> xvec) \<sharp>* R`
        apply(subst resChainAlpha[where p=p and xvec=xvec])
        apply(simp add: eqvts)+
        apply(rule hobisimBisim)
        by(metis bisimParAssoc bisimParComm bisimParPresSym bisimResChainPres bisimScopeExtChainSym bisimSymmetric bisimTransitive)
      with f3 f4 show ?thesis
        unfolding TUR'_def
        by(rule_tac fresh_rel_trancl.intros) auto
    qed
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  next
    assume "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
    hence "(\<Psi>',P\<parallel>R,Q\<parallel>R) \<in> \<S>" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` and `A\<^isub>R \<sharp>* P` and `A\<^isub>R \<sharp>* Q` and `A\<^isub>R \<sharp>* \<Psi>'`
      unfolding \<S>_def `\<Psi> = \<Psi>' \<otimes> \<Psi>\<^isub>R`
      by(auto simp add: psi.inject)
    hence "(\<Psi>',P\<parallel>R,Q\<parallel>R) \<in> ?X"
      by(auto simp add: exI[where x="[]"])
    thus ?thesis using `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* Q` `A\<^isub>R \<sharp>* R`
      by(rule_tac fresh_rel_trancl.intros) auto
  qed
qed



lemma TURS'parPres':
  assumes 1: "(C@A\<^isub>R,\<Psi>,P,Q) \<in> TUR' \<S>"
  and     2: "\<Psi>=\<Psi>'\<otimes>\<Psi>\<^isub>R"
  and     3: "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
  and     4: "A\<^isub>R \<sharp>* \<Psi>'"
  and     4: "A\<^isub>R \<sharp>* R"
  and     6: "C \<sharp>* R"
  and     7: "distinct A\<^isub>R"

  shows "(C@A\<^isub>R,\<Psi>',P \<parallel> R,Q \<parallel> R) \<in> TUR' \<S>"
using assms
unfolding TUR'_def
proof(induct rule: fresh_rel_trancl_induct')
  case(prop_transitive P Q S)
  thus ?case
    by(rule_tac fresh_rel_trancl_transitive) simp+
next
  case(r_into_fresh_rel_trancl P Q)
  let ?X = "{(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}"
  from `(\<Psi>, P, Q) \<in> ?X \<union> hobisim`
  show ?case
  proof(rule UnE)
    assume "(\<Psi>,P,Q) \<in> ?X"
    then obtain P' Q' xvec S A\<^isub>S \<Psi>\<^isub>S where Pdef: "P = \<lparr>\<nu>*xvec\<rparr>(P'\<parallel>S)" and Qdef: "Q = \<lparr>\<nu>*xvec\<rparr>(Q'\<parallel>S)" and "xvec \<sharp>* \<Psi>" "extractFrame S = \<langle>A\<^isub>S, \<Psi>\<^isub>S\<rangle>" "A\<^isub>S \<sharp>* P'" "A\<^isub>S \<sharp>* Q'" "A\<^isub>S \<sharp>* \<Psi>" "\<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P' \<sim>\<^sub>H Q'"
      unfolding \<S>_def
      by blast
    obtain q::"name prm" where "set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)" and "distinctPerm q" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>" and "(q\<bullet>A\<^isub>S) \<sharp>* P" and "(q\<bullet>A\<^isub>S) \<sharp>* Q" and "(q\<bullet>A\<^isub>S) \<sharp>* R" and "(q\<bullet>A\<^isub>S) \<sharp>* P'" and "(q\<bullet>A\<^isub>S) \<sharp>* Q'" and "(q\<bullet>A\<^isub>S) \<sharp>* xvec" and "(q\<bullet>A\<^isub>S) \<sharp>* S" and "(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>S" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>S" and "(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>R" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>R" and "(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>'" and "(q\<bullet>A\<^isub>S) \<sharp>* C"
      by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,R,P',Q',xvec,S,A\<^isub>S,\<Psi>\<^isub>S,A\<^isub>R,\<Psi>\<^isub>R,\<Psi>',C)" and xvec=A\<^isub>S]) auto
    moreover obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "distinctPerm p" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* P'" and "(p\<bullet>xvec) \<sharp>* Q'" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* S" and "(p\<bullet>xvec) \<sharp>* A\<^isub>S" and "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>S" and "(p\<bullet>xvec) \<sharp>* A\<^isub>R" and "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>R" and "(p\<bullet>xvec) \<sharp>* \<Psi>'" and "(p\<bullet>xvec) \<sharp>* C" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>P)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>Q)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>P')" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>Q')" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>xvec)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>\<^isub>S)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>\<^isub>R)" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>\<Psi>')" and "(p\<bullet>xvec) \<sharp>* (q\<bullet>C)"
      by(rule_tac name_list_avoiding[where c="(\<Psi>,P,Q,R,P',Q',xvec,S,A\<^isub>S,\<Psi>\<^isub>S,A\<^isub>R,\<Psi>\<^isub>R,\<Psi>',C,q\<bullet>\<Psi>,q\<bullet>P,q\<bullet>Q,q\<bullet>R,q\<bullet>P',q\<bullet>Q',q\<bullet>xvec,q\<bullet>S,q\<bullet>A\<^isub>S,q\<bullet>\<Psi>\<^isub>S,q\<bullet>A\<^isub>R,q\<bullet>\<Psi>\<^isub>R,q\<bullet>\<Psi>',q\<bullet>C)" and xvec=xvec]) auto
    moreover have "extractFrame(p\<bullet>S) = \<langle>p\<bullet>q\<bullet>A\<^isub>S, p\<bullet>q\<bullet>\<Psi>\<^isub>S\<rangle>" using `extractFrame S = \<langle>A\<^isub>S, \<Psi>\<^isub>S\<rangle>` `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>S` `set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)`
      apply(subst (asm) frameChainAlpha[where p=q])
      apply simp
      apply simp
      apply(subst(asm) perm_bool[where pi=p,symmetric])
      by(simp only: eqvts)
    moreover note `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
    moreover have "(C@A\<^isub>R) \<sharp>* (p \<bullet> q \<bullet> A\<^isub>S)"
    proof -
      have "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      thus ?thesis using `(q\<bullet>A\<^isub>S) \<sharp>* A\<^isub>R` `(q\<bullet>A\<^isub>S) \<sharp>* C`
        by simp
    qed
    moreover have "(C@A\<^isub>R) \<sharp>* (p \<bullet> q \<bullet> \<Psi>\<^isub>S)"
    proof -
      have "(C@A\<^isub>R) \<sharp>* (p\<bullet>S)" using `(C@A\<^isub>R) \<sharp>* P` Pdef `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `distinctPerm p` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* A\<^isub>R` `(p\<bullet>xvec) \<sharp>* C`
        by(subst(asm) resChainAlpha[where p=p]) auto
      thus ?thesis using `extractFrame(p\<bullet>S) = \<langle>p\<bullet>q\<bullet>A\<^isub>S, p\<bullet>q\<bullet>\<Psi>\<^isub>S\<rangle>` `(C@A\<^isub>R) \<sharp>* (p \<bullet> q \<bullet> A\<^isub>S)`
        by(drule_tac extractFrameFreshChain) simp
    qed
    moreover have "(p \<bullet> q \<bullet> A\<^isub>S) \<sharp>* \<Psi>\<^isub>R"
    proof -
      have "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      thus ?thesis using `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>\<^isub>R`
        by simp
    qed
    moreover have "\<Psi>' \<otimes> \<Psi>\<^isub>R \<otimes> (p \<bullet> q \<bullet> \<Psi>\<^isub>S) \<rhd> p \<bullet> P' \<sim>\<^sub>H p \<bullet> Q'"
    proof -
      from `\<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P' \<sim>\<^sub>H Q'`
      have "\<Psi> \<otimes> (q\<bullet>\<Psi>\<^isub>S) \<rhd> P' \<sim>\<^sub>H Q'" using `set q \<subseteq> set A\<^isub>S \<times> set(q\<bullet>A\<^isub>S)` `A\<^isub>S \<sharp>* P'` `A\<^isub>S \<sharp>* Q'` `A\<^isub>S \<sharp>* \<Psi>` `(q\<bullet>A\<^isub>S) \<sharp>* P'` `(q\<bullet>A\<^isub>S) \<sharp>* Q'` `(q\<bullet>A\<^isub>S) \<sharp>* \<Psi>`
        by(drule_tac hobisimClosed[where p=q]) (simp add: eqvts)
      hence "\<Psi> \<otimes> (p\<bullet>q\<bullet>\<Psi>\<^isub>S) \<rhd> p\<bullet>P' \<sim>\<^sub>H p\<bullet>Q'" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
        by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
      thus ?thesis
        unfolding `\<Psi> = \<Psi>' \<otimes> \<Psi>\<^isub>R`
        by(rule hostatEqBisim) (rule Associativity)
    qed
    moreover note `A\<^isub>R \<sharp>* \<Psi>'`
    moreover have "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> P')" and "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> Q')"
    proof -
      have pq: "p \<bullet> (q \<bullet> A\<^isub>S) = (q \<bullet> A\<^isub>S)" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(q\<bullet>A\<^isub>S) \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* (q\<bullet>A\<^isub>S)` `distinctPerm p`
        by simp
      show "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> P')" and "(q \<bullet> A\<^isub>S) \<sharp>* (p \<bullet> Q')"
        by(subst pq[symmetric],subst fresh_star_bij,fact)+
    qed
    moreover have "(C@A\<^isub>R) \<sharp>* (p \<bullet> P')" and "(C@A\<^isub>R) \<sharp>* (p \<bullet> Q')"
    proof -
      from `(C@A\<^isub>R) \<sharp>* P` Pdef
      have "(C@A\<^isub>R) \<sharp>* (\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (p\<bullet>S))" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst(asm) resChainAlpha[where p=p]) (simp add: eqvts)+
      moreover from `(C@A\<^isub>R) \<sharp>* Q` Qdef
      have "(C@A\<^isub>R) \<sharp>* (\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> (p\<bullet>S))" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst(asm) resChainAlpha[where p=p]) (simp add: eqvts)+
      ultimately show "(C@A\<^isub>R) \<sharp>* (p\<bullet>P')" "(C@A\<^isub>R) \<sharp>* (p\<bullet>Q')" using `(p\<bullet>xvec) \<sharp>* A\<^isub>R` `(p\<bullet>xvec) \<sharp>* C`
        by simp+
    qed
    ultimately have ins: "(\<Psi>', (p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), (p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> \<S>"
      unfolding \<S>_def
      apply(auto simp add: psi.inject)
      apply(rule exI[where x = "\<Psi>\<^isub>R \<otimes> (p \<bullet> q \<bullet> \<Psi>\<^isub>S)"])
      apply(rule exI[where x = "(A\<^isub>R @ p \<bullet> q \<bullet> A\<^isub>S)"])
      apply(simp add: fresh_star_bij)
      done
    have f1: "(C@A\<^isub>R) \<sharp>* (P \<parallel> R)" using `(C@A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* R` `C \<sharp>* R`
      by simp
    hence f2: "(C@A\<^isub>R) \<sharp>* (\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S)))" unfolding Pdef  using `set p \<subseteq> set xvec \<times> set(p\<bullet> xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S`
      by(subst (asm) resChainAlpha[where p=p]) (auto simp add: fresh_def fresh_star_def psi.supp resChainSupp)
    have f3: "(C@A\<^isub>R) \<sharp>* (Q \<parallel> R)" using `(C@A\<^isub>R) \<sharp>* Q` `A\<^isub>R \<sharp>* R` `C \<sharp>* R`
      by simp
    hence f4: "(C@A\<^isub>R) \<sharp>* (\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> Q') \<parallel> (R \<parallel> (p \<bullet> S)))" unfolding Qdef  using `set p \<subseteq> set xvec \<times> set(p\<bullet> xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S`
        by(subst (asm) resChainAlpha[where p=p]) (auto simp add: fresh_def fresh_star_def psi.supp resChainSupp)
    from ins have "(\<Psi>', \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> ?X" using `(p\<bullet>xvec) \<sharp>* \<Psi>'`
      by(auto simp add: psi.inject)
    hence "(C@A\<^isub>R,\<Psi>', \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P') \<parallel> (R \<parallel> (p\<bullet>S)), \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S)))) \<in> TUR' \<S>" using f2 f4
      unfolding TUR'_def
      by(rule_tac fresh_rel_trancl.intros) auto
    moreover have "(C@A\<^isub>R,\<Psi>',P \<parallel> R,\<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S))) \<in> TUR' \<S>"
    proof -
      have "\<Psi>' \<rhd> P \<parallel> R \<sim>\<^sub>H \<lparr>\<nu>*p \<bullet> xvec\<rparr>(p \<bullet> P') \<parallel> (R \<parallel> (p \<bullet> S))"
        unfolding Pdef using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* \<Psi>'``(p \<bullet> xvec) \<sharp>* R`
        apply(subst resChainAlpha[where p=p])
        apply(simp add: eqvts)+
        apply(rule hobisimBisim)
        by(metis bisimParAssoc bisimParComm bisimParPresSym bisimResChainPres bisimScopeExtChainSym bisimSymmetric bisimTransitive)
      with f1 f2 show ?thesis
        unfolding TUR'_def
        by(rule_tac fresh_rel_trancl.intros) auto
    qed
    moreover have "(C@A\<^isub>R,\<Psi>',\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S))), Q \<parallel> R) \<in> TUR' \<S>"
    proof -
      have "\<Psi>' \<rhd> \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q') \<parallel> ((R \<parallel> (p\<bullet>S))) \<sim>\<^sub>H Q \<parallel> R"
        unfolding Qdef using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* S` `(p\<bullet>xvec) \<sharp>* \<Psi>'``(p \<bullet> xvec) \<sharp>* R`
        apply(subst resChainAlpha[where p=p and xvec=xvec])
        apply(simp add: eqvts)+
        apply(rule hobisimBisim)
        by(metis bisimParAssoc bisimParComm bisimParPresSym bisimResChainPres bisimScopeExtChainSym bisimSymmetric bisimTransitive)
      with f3 f4 show ?thesis
        unfolding TUR'_def
        by(rule_tac fresh_rel_trancl.intros) auto
    qed
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  next
    assume "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
    hence "(\<Psi>',P\<parallel>R,Q\<parallel>R) \<in> \<S>" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` and `(C@A\<^isub>R) \<sharp>* P` and `(C@A\<^isub>R) \<sharp>* Q` and `A\<^isub>R \<sharp>* \<Psi>'`
      unfolding \<S>_def `\<Psi> = \<Psi>' \<otimes> \<Psi>\<^isub>R`
      by(auto simp add: psi.inject)
    hence "(\<Psi>',P\<parallel>R,Q\<parallel>R) \<in> ?X"
      by(auto simp add: exI[where x="[]"])
    thus ?thesis using `(C@A\<^isub>R) \<sharp>* P` `(C@A\<^isub>R) \<sharp>* Q` `A\<^isub>R \<sharp>* R` `C \<sharp>* R`
      by(rule_tac fresh_rel_trancl.intros) auto
  qed
qed


(*definition frameExt :: "'b frame \<Rightarrow> 'b frame \<Rightarrow> bool" ("_ \<prec> _" [120,120] 110) where
"frameExt F G = (\<exists> A\<^isub>F A\<^isub>G \<Psi>\<^isub>F \<Psi>\<^isub>G \<Psi>. F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle> \<and> G = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle> \<and> \<Psi>\<^isub>G \<simeq> \<Psi>\<^isub>F \<otimes> \<Psi> \<and> A\<^isub>G \<sharp>* (\<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>))"
*)

definition rStatEq :: "'b \<Rightarrow> name list \<Rightarrow> 'b \<Rightarrow> (name list \<times> 'b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> 'b \<Rightarrow> bool" ("(_ \<rhd>_\<rhd>_\<simeq>_\<simeq>_)" [50,50,50,50,50] 50)
  where
"rStatEq \<Psi> xvec \<Psi>\<^isub>1 \<R> \<Psi>\<^isub>2 = 
  (
  xvec \<sharp>* \<Psi>
  \<and>
  (\<forall>\<Psi>' \<phi>. xvec \<sharp>* \<Psi>' \<and> xvec \<sharp>* \<phi> \<and> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>1\<turnstile>\<phi> \<and> \<not>clauseDom \<phi> \<longrightarrow> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>2\<turnstile>\<phi>)
  \<and>
  (\<forall>\<Psi>' M P. xvec \<sharp>* \<Psi>' \<and> xvec \<sharp>* M \<and> legalClause M P \<and> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>1\<turnstile>M\<Leftarrow>P \<longrightarrow> (\<exists>Q. \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>2\<turnstile>M\<Leftarrow>Q \<and> legalClause M Q \<and> (xvec,\<Psi>'\<otimes>\<Psi>,P,Q) \<in> \<R>)
  )
  \<and>
  (\<forall>\<Psi>' \<phi>. xvec \<sharp>* \<Psi>' \<and> xvec \<sharp>* \<phi> \<and> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>2\<turnstile>\<phi> \<and> \<not>clauseDom \<phi> \<longrightarrow> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>1\<turnstile>\<phi>)
  \<and>
  (\<forall>\<Psi>' M P. xvec \<sharp>* \<Psi>' \<and> xvec \<sharp>* M \<and> legalClause M P \<and> \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>2\<turnstile>M\<Leftarrow>P \<longrightarrow> (\<exists>Q. \<Psi>'\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>1\<turnstile>M\<Leftarrow>Q \<and> legalClause M Q \<and> (xvec,\<Psi>'\<otimes>\<Psi>,P,Q) \<in> \<R>)
  )
  )"

definition rFrameEq :: "'b \<Rightarrow> 'b frame \<Rightarrow> (name list \<times> 'b \<times> ('a,'b,'c) psi \<times> ('a,'b,'c) psi) set \<Rightarrow> 'b frame \<Rightarrow> bool" ("(_ \<rhd>_\<simeq>_\<simeq>_)" [50,50,50,50] 50)
  where
"rFrameEq \<Psi> F \<R> G = 
  (
  \<exists>A\<^isub>F \<Psi>\<^isub>F A\<^isub>G \<Psi>\<^isub>G.
   F = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle> \<and>
   G = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle> \<and>
   distinct A\<^isub>F \<and> distinct A\<^isub>G \<and>
   A\<^isub>F \<sharp>* A\<^isub>G \<and> A\<^isub>F \<sharp>* \<Psi>\<^isub>G \<and> A\<^isub>G \<sharp>* \<Psi>\<^isub>F \<and>
   \<Psi> \<rhd>(A\<^isub>F@A\<^isub>G)\<rhd> \<Psi>\<^isub>F \<simeq>\<R>\<simeq> \<Psi>\<^isub>G
  )
"

lemma bisimAssertionComp:
  shows "\<Psi> \<rhd> \<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace> \<sim> \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>"
proof -
  let ?X = "{(\<Psi>,\<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>,\<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>)| \<Psi> \<Psi>' \<Psi>''. True}"
  let ?Y = "{(\<Psi>,\<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>,\<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>)| \<Psi> \<Psi>' \<Psi>''. True}"
  have "(\<Psi>,\<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>,\<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>) \<in> ?X \<union> ?Y"
    by blast
  thus ?thesis
  proof(coinduct rule: bisimWeakCoinduct)
    case cStatEq thus ?case
      by auto
  next
    case cSym thus ?case by auto
  next
    case(cSim \<Psi> P Q)
    hence "(\<Psi>,P,Q) \<in> ?X \<or> (\<Psi>,P,Q) \<in> ?Y"
      by blast
    thus ?case
    proof(rule disjE)
      assume "(\<Psi>,P,Q) \<in> ?X"
      then obtain \<Psi>' \<Psi>'' where P: "P = \<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>" and Q: "Q = \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>"
        by blast
      have eq: "eqvt(?X \<union> ?Y)"
        by(auto simp add: eqvt_def psi.inject statEqvt')
      show ?case unfolding P Q
      proof(rule simI[where C="[]", OF eq])
        fix \<alpha> Q'
        assume "\<Psi> \<rhd> \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace> \<longmapsto> \<alpha> \<prec> Q'"
          and  "bn \<alpha> \<sharp>* (\<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>)"
          and  "bn \<alpha> \<sharp>* \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>"
          and  "bn \<alpha> \<sharp>* \<Psi>"
          and "distinct (bn \<alpha>)"
          and "bn \<alpha> \<sharp>* subject \<alpha>"
          and "bn \<alpha> \<sharp>* []"
        thus "\<exists>P'. \<Psi> \<rhd> \<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace> \<longmapsto> \<alpha> \<prec> P' \<and>
                   (\<Psi>, P', Q')
                   \<in> ?X \<union> ?Y"
          by(auto dest: nilTrans)
      qed
    next
      assume "(\<Psi>,P,Q) \<in> ?Y"
      then obtain \<Psi>' \<Psi>'' where Q: "Q = \<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>" and P: "P = \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>"
        by blast
      have eq: "eqvt(?X \<union> ?Y)"
        by(auto simp add: eqvt_def psi.inject statEqvt')
      show ?case unfolding P Q
      proof(rule simI[where C="[]", OF eq])
        fix \<alpha> Q'
        assume "\<Psi> \<rhd> \<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace> \<longmapsto> \<alpha> \<prec> Q'"
          and  "bn \<alpha> \<sharp>* (\<lbrace>\<Psi>'\<rbrace> \<parallel> \<lbrace>\<Psi>''\<rbrace>)"
          and  "bn \<alpha> \<sharp>* \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace>"
          and  "bn \<alpha> \<sharp>* \<Psi>"
          and "distinct (bn \<alpha>)"
          and "bn \<alpha> \<sharp>* subject \<alpha>"
          and "bn \<alpha> \<sharp>* []"
        thus "\<exists>P'. \<Psi> \<rhd> \<lbrace>(\<Psi>' \<otimes> \<Psi>'')\<rbrace> \<longmapsto> \<alpha> \<prec> P' \<and>
                   (\<Psi>, P', Q')
                   \<in> ?X \<union> ?Y"
          apply(induct_tac rule: parCases)
          apply assumption
          by(auto dest: nilTrans)
      qed
    qed
  next
    case cExt thus ?case by auto
  qed
qed     

lemma hobisimAssertionContext:
  assumes "\<Psi> \<otimes> \<Psi>' \<rhd> P \<sim>\<^sub>H Q"
  shows "\<Psi> \<rhd> P \<parallel> \<lbrace>\<Psi>'\<rbrace> \<sim>\<^sub>H Q \<parallel> \<lbrace>\<Psi>'\<rbrace>"
proof -
  let ?X = "{(\<Psi>,P\<parallel>\<lbrace>\<Psi>'\<rbrace>,Q\<parallel>\<lbrace>\<Psi>'\<rbrace>) | \<Psi> P \<Psi>' Q. \<Psi> \<otimes> \<Psi>' \<rhd> P \<sim>\<^sub>H Q}"
  have "(\<Psi>,P \<parallel> \<lbrace>\<Psi>'\<rbrace>,Q \<parallel> \<lbrace>\<Psi>'\<rbrace>) \<in> ?X" using assms
    by auto
  moreover have "eqvt ?X"
    by(auto simp add: eqvt_def hobisimClosed psi.inject statEqvt'[symmetric])
  ultimately show ?thesis
  proof(coinduct rule: hotransitiveCoinduct'')
    case(cStatEq \<Psi> R S \<phi>)
    then obtain P Q \<Psi>' where Rdef: "R = P \<parallel> \<lbrace>\<Psi>'\<rbrace>" and Sdef: "S = Q \<parallel> \<lbrace>\<Psi>'\<rbrace>" and bis: "\<Psi> \<otimes> \<Psi>' \<rhd> P \<sim>\<^sub>H Q"
      by blast
    obtain A\<^isub>P \<Psi>\<^isub>P where pf: "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* R" and "A\<^isub>P \<sharp>* S" and "A\<^isub>P \<sharp>* \<phi>" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* \<Psi>'"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,\<phi>,P,Q,\<Psi>')"]) auto
    obtain A\<^isub>Q \<Psi>\<^isub>Q where qf: "extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* R" and "A\<^isub>Q \<sharp>* S" and "A\<^isub>Q \<sharp>* \<phi>" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* \<Psi>'"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,\<phi>,P,Q,\<Psi>')"]) auto
    from `insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>` have "insertAssertion (extractFrame P) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F \<phi>" unfolding Rdef using `A\<^isub>P \<sharp>* \<Psi>'`
      apply(simp add: pf)
      by (metis AssertionStatEqSym Associativity `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<phi>` associativitySym frameImpEAux frameImpI freshCompChain(1) insertAssertionSimps statEqEnt)
    hence "insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F \<phi>"
      using bis `\<not> clauseDom \<phi>`
      by(blast dest: hobisimE)
    thus ?case unfolding Sdef using `A\<^isub>Q \<sharp>* \<Psi>'`
      apply(simp add: qf)
      by (metis AssertionStatEqSym Associativity `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<phi>` associativitySym frameImpEAux frameImpI freshCompChain(1) insertAssertionSimps statEqEnt)
  next
    case(cClauseEq \<Psi> R S M P')
    then obtain P Q \<Psi>' where Rdef: "R = P \<parallel> \<lbrace>\<Psi>'\<rbrace>" and Sdef: "S = Q \<parallel> \<lbrace>\<Psi>'\<rbrace>" and bis: "\<Psi> \<otimes> \<Psi>' \<rhd> P \<sim>\<^sub>H Q"
      by blast
    moreover obtain A\<^isub>P \<Psi>\<^isub>P where pf: "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* R" and "A\<^isub>P \<sharp>* S" and "A\<^isub>P \<sharp>* M" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* \<Psi>'" "A\<^isub>P \<sharp>* P'"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,M,P,Q,\<Psi>',P')"]) auto
    ultimately have "insertAssertion (extractFrame P) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F M \<Leftarrow> P'" using `insertAssertion (extractFrame R) (\<Psi>) \<turnstile>\<^sub>F M \<Leftarrow> P'` unfolding Rdef Sdef pf extractFrameSimps
      apply(rule_tac frameStatEqEnt)
      defer
      apply assumption
      apply(subst mergeFrameSimps)
      apply assumption
      apply(subst insertAssertionSimps)
      apply assumption
      apply(subst insertAssertionSimps)
      apply force
      by (metis AssertionStatEqTrans Associativity FrameStatEqSym associativitySym frameNilStatEq frameResChainPres)
    with `\<Psi> \<otimes> \<Psi>' \<rhd> P \<sim>\<^sub>H Q` `legalClause M P'`
    have "\<exists> Q'. legalClause M Q' \<and> insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F M \<Leftarrow> Q' \<and> (\<one>,P',Q') \<in> hobisim"
      by(blast dest: hobisimE)
    then obtain Q' where "legalClause M Q'" and "insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F M \<Leftarrow> Q'" "(\<one>,P',Q') \<in> hobisim"
      by blast
    obtain A\<^isub>Q \<Psi>\<^isub>Q where qf: "extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* R" and "A\<^isub>Q \<sharp>* S" and "A\<^isub>Q \<sharp>* M" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* \<Psi>'" and "A\<^isub>Q \<sharp>* P'" and "A\<^isub>Q \<sharp>* Q'"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,M,P,Q,\<Psi>',P',Q')"]) auto
    have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q'"
      using `insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>') \<turnstile>\<^sub>F M \<Leftarrow> Q'`
      unfolding Sdef qf extractFrameSimps
      using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>'`
      apply(subst mergeFrameSimps)
      apply assumption
      apply(subst insertAssertionSimps)
      apply simp
      apply(subst (asm) insertAssertionSimps)
      apply blast
      by (metis frameStatEqEnt AssertionStatEqTrans Associativity associativitySym frameNilStatEq frameResChainPres)
    thus ?case using `legalClause M Q'` unfolding Rdef Sdef
      using `(\<one>,P',Q') \<in> hobisim`
      by(blast intro: hobisimReflexive hobisimSymmetric)
  next
    case(cExt \<Psi> R S \<Psi>')
    then obtain P Q \<Psi>'' where R: "R=P\<parallel>\<lbrace>\<Psi>''\<rbrace>" and S: "S=Q\<parallel>\<lbrace>\<Psi>''\<rbrace>" and "\<Psi>\<otimes>\<Psi>''\<rhd>P \<sim>\<^sub>H Q"
      by blast
    hence "(\<Psi>\<otimes>\<Psi>'')\<otimes>\<Psi>'\<rhd>P \<sim>\<^sub>H Q"
      by(drule_tac hobisimE)
    hence "(\<Psi>\<otimes>\<Psi>')\<otimes>\<Psi>''\<rhd> P \<sim>\<^sub>H Q"
      apply(rule hostatEqBisim)
      by(rule associativitySym)
    thus ?case unfolding R S
      by blast
  next
    case(cSym \<Psi> P Q)
    thus ?case
      by(blast intro: hobisimReflexive dest: hobisimTransitive hobisimSymmetric)
  next
    case(cSim \<Psi> R S)
    then obtain P Q \<Psi>' where R: "R=P\<parallel>\<lbrace>\<Psi>'\<rbrace>" and S: "S=Q\<parallel>\<lbrace>\<Psi>'\<rbrace>" and "\<Psi>\<otimes>\<Psi>'\<rhd>P \<sim>\<^sub>H Q"
      by blast
    have "\<Psi> \<rhd> P \<parallel> \<lbrace>\<Psi>'\<rbrace> \<leadsto>[?X] Q \<parallel> \<lbrace>\<Psi>'\<rbrace>"
    proof(rule simI[where C="P",OF `eqvt ?X`])
      fix \<alpha> Q'
      assume "\<Psi> \<rhd> Q \<parallel> \<lbrace>\<Psi>'\<rbrace> \<longmapsto> \<alpha> \<prec> Q'"
             "bn \<alpha> \<sharp>* (P \<parallel> \<lbrace>\<Psi>'\<rbrace>)"
             "bn \<alpha> \<sharp>* (Q \<parallel> \<lbrace>\<Psi>'\<rbrace>)"
             "bn \<alpha> \<sharp>* \<Psi>"
             "distinct (bn \<alpha>)"
             "bn \<alpha> \<sharp>* subject \<alpha>"
             "bn \<alpha> \<sharp>* P"
      note `\<Psi> \<rhd> Q \<parallel> \<lbrace>\<Psi>'\<rbrace> \<longmapsto> \<alpha> \<prec> Q'` `bn \<alpha> \<sharp>* \<Psi>`
      moreover have "bn \<alpha> \<sharp>* Q" and "bn \<alpha> \<sharp>* \<lbrace>\<Psi>'\<rbrace>" using `bn \<alpha> \<sharp>* (Q \<parallel> \<lbrace>\<Psi>'\<rbrace>)`
        by auto
      moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
      ultimately show "\<exists>P'. \<Psi> \<rhd> P \<parallel> \<lbrace>\<Psi>'\<rbrace> \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> ?X"
      proof(induct rule: parCases[where C="()"])
        case(cPar1 Q' A\<^isub>Q \<Psi>\<^isub>Q)
        hence "\<Psi> \<otimes> \<Psi>' \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'"
          by simp
        with `\<Psi>\<otimes>\<Psi>' \<rhd> P \<sim>\<^sub>H Q` `eqvt ?X`
        have "\<exists> P'. \<Psi>\<otimes>\<Psi>' \<rhd> P \<longmapsto> \<alpha> \<prec> P' \<and> \<Psi>\<otimes>\<Psi>' \<rhd> P' \<sim>\<^sub>H Q'" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<lbrace>\<Psi>'\<rbrace>` `bn \<alpha> \<sharp>* P`
          apply(drule_tac hobisimE(3))
          apply(drule_tac simE)
          apply assumption
          by force
        then obtain P' where "\<Psi>\<otimes>\<Psi>' \<rhd> P \<longmapsto> \<alpha> \<prec> P'" "\<Psi>\<otimes>\<Psi>' \<rhd> P' \<sim>\<^sub>H Q'"
          by blast
        thus ?case using `bn \<alpha> \<sharp>* \<lbrace>\<Psi>'\<rbrace>`
          by(rule_tac exI[where x="P'\<parallel>\<lbrace>\<Psi>'\<rbrace>"]) (auto intro: Par1)
      next
        case cPar2 thus ?case by(blast dest: nilTrans)
      next
        case cComm1 thus ?case by(blast dest: nilTrans)
      next
        case cComm2 thus ?case by(blast dest: nilTrans)
      qed
    qed
    moreover have "?X \<subseteq> {(\<Psi>,P,Q)|\<Psi> P P' Q' Q. \<Psi> \<rhd> P \<sim>\<^sub>H P' \<and> (\<Psi>,P',Q') \<in> ?X \<union> hobisim \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H Q}"
      by auto (blast intro: hobisimReflexive hobisimTransitive)+
    ultimately show ?case unfolding R S
      by(blast intro: monotonic)
  qed
qed

lemma bisim\<F>parDist:
  fixes P::"('a,'b,'c) psi"
  shows "\<Psi> \<rhd> \<F>(P\<parallel> Q) \<sim> (\<F> P) \<parallel> \<F> Q"
proof -
  obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* \<Psi>"
    by(rule_tac freshFrame[where C="(P,Q,\<Psi>)"]) auto
  moreover obtain A\<^isub>Q \<Psi>\<^isub>Q where "extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* A\<^isub>P" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>P" and "A\<^isub>Q \<sharp>* \<Psi>"
    by(rule_tac freshFrame[where C="(P,Q,A\<^isub>P,\<Psi>\<^isub>P,\<Psi>)"]) auto
  moreover hence "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q" using `A\<^isub>P \<sharp>* Q`
    by(auto dest: extractFrameFreshChain)
  ultimately show ?thesis
    apply(simp add: resChainAppend)
    apply(rule bisimSymmetric)
    apply(rule bisimTransitive)
    apply(rule bisimTransitive[OF bisimParComm])
    apply(rule bisimSymmetric[OF bisimScopeExtChain])
    apply simp
    apply simp
    apply(rule bisimResChainPres)
    apply(rule bisimTransitive[OF bisimParComm])
    apply(rule bisimTransitive[OF bisimSymmetric, OF bisimScopeExtChain])
    apply simp
    apply simp
    apply(rule bisimResChainPres)
    apply(rule bisimAssertionComp)
    by simp+
qed

lemma semanticsInductPsi[consumes 3, case_names cAlpha cInput cOutput cCase cPar1 cPar2 cComm1 cComm2 cOpen cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   \<alpha>    :: "'a action"
  and   P'   :: "('a, 'b, 'c) psi"
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow>
                'a action \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes "\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "bn \<alpha> \<sharp>* (subject \<alpha>)"
  and     "distinct(bn \<alpha>)"
  and     rAlpha: "\<And>\<Psi> P \<alpha> P' p C. \<lbrakk>bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* (subject \<alpha>); 
                                    bn \<alpha> \<sharp>* C; bn \<alpha> \<sharp>* (bn(p \<bullet> \<alpha>)); 
                                    set p \<subseteq> set(bn \<alpha>) \<times> set(bn(p \<bullet> \<alpha>)); distinctPerm p;
                                    (bn(p \<bullet> \<alpha>)) \<sharp>* \<alpha>; (bn(p \<bullet> \<alpha>)) \<sharp>* P'; Prop C \<Psi>' \<Psi> P \<alpha> P'\<rbrakk> \<Longrightarrow>
                                     Prop C \<Psi>' \<Psi> P (p \<bullet> \<alpha>) (p \<bullet> P')"
  and     rInput: "\<And>\<Psi> M K xvec N Tvec P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K; distinct xvec; set xvec \<subseteq> supp N;
                    length xvec = length Tvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>';
                    xvec \<sharp>* M; xvec \<sharp>* K; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (M\<lparr>\<lambda>*xvec N\<rparr>.P)
                              (K\<lparr>(N[xvec::=Tvec])\<rparr>) (P[xvec::=Tvec])"
  and     rOutput: "\<And>\<Psi> M K N P C. \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<leftrightarrow> K\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (M\<langle>N\<rangle>.P) (K\<langle>N\<rangle>) P"
  and     rCase: "\<And>\<Psi> P \<alpha> P' \<phi> Cs C. \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'; \<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P'; (\<phi>, P) mem Cs; \<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>\<rbrakk> \<Longrightarrow>
                                      Prop C \<Psi>' \<Psi> (Cases Cs) \<alpha> P'"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P \<alpha> P';
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* C; distinct(bn \<alpha>); bn \<alpha> \<sharp>* Q;
                    bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P' \<parallel> Q)"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q \<alpha> Q';
                    A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* C; distinct(bn \<alpha>); bn \<alpha> \<sharp>* Q;
                    bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* \<Psi>\<^isub>P; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P \<parallel> Q')"
  and     rComm1: "\<And>\<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>N\<rparr>) P'; 
                    extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'; \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) Q'; 
                    extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q'; distinct xvec;
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau>) (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q'))"
  and     rComm2: "\<And>\<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) P'; 
                    extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P; 
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q'; \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>N\<rparr>) Q'; 
                    extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q'; distinct xvec;
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau>) (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q'))"
  and     rOpen:  "\<And>\<Psi> P M xvec yvec N P' x C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'; x \<in> supp N; \<And>C. Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle>) P';
                    x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M; x \<sharp> xvec; x \<sharp> yvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M;  distinct xvec; distinct yvec;
                    yvec \<sharp>* \<Psi>; yvec \<sharp>* \<Psi>'; yvec \<sharp>* P; yvec \<sharp>* M; yvec \<sharp>* C; x \<sharp> C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow> 
                    Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle>) P'"
  and     rScope: "\<And>\<Psi> P \<alpha> P' x C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'; \<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P';
                    x \<sharp> \<Psi>; x \<sharp> \<alpha>; bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>';
                    bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* (subject \<alpha>); x \<sharp> C; bn \<alpha> \<sharp>* C; distinct(bn \<alpha>)\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) \<alpha> (\<lparr>\<nu>x\<rparr>P')"
  and     rBang:    "\<And>\<Psi> P \<alpha> P' C.
                     \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<parallel> !P \<longmapsto>\<alpha> \<prec> P'; guarded P; \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) \<alpha> P'\<rbrakk> \<Longrightarrow>
                      Prop C \<Psi>' \<Psi> (!P) \<alpha> P'"
  and     rInv:   "\<And>\<Psi> M P \<alpha> P' C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    distinct(bn \<alpha>);
                    bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* M;
                    bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C;
                    \<And> C. Prop C \<Psi>' \<Psi> P \<alpha> P'\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) \<alpha> P'"

  shows "Prop C \<Psi>' \<Psi> P \<alpha> P'"
proof -
  obtain \<Psi>'' where n: "\<Psi>'' \<simeq> \<Psi>' \<otimes> \<Psi>"
    by(blast intro: AssertionStatEqRefl)
  with `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'` have "\<Psi>'' \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
    apply(rule_tac statEqTransition)
    apply assumption
    by(rule AssertionStatEqSym)
  moreover note `bn \<alpha> \<sharp>* (subject \<alpha>)`
    and     `distinct(bn \<alpha>)` n
  ultimately show ?thesis using rAlpha rInput rOutput rCase rPar1 rPar2 rComm1 rComm2 rOpen rScope rBang rInv
  proof(nominal_induct avoiding: \<Psi>' \<Psi> C rule: semanticsInduct)
    case(cAlpha \<Psi>'' P \<alpha> P' p \<Psi>' \<Psi>)
    thus ?case
      by blast
  next
    case(cInput \<Psi> M K xvec N Tvec P \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cInput)
      apply(rule statEqEnt)
      by fact+
  next
    case(cOutput \<Psi> M K N P \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cOutput)
      apply(rule statEqEnt)
      by fact+
  next
    case(cCase \<Psi> P \<alpha> P' \<phi> Cs \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cCase)
      apply(rule statEqTransition)
      apply fact
      apply fact
      apply(rule cCase)
      apply fact+
      apply(rule statEqEnt)
      by fact+
  next
    case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    show ?case
      apply(rule cPar1)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cPar1)
      by fact+
  next
    case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    show ?case
      apply(rule cPar2)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cPar2)
      by fact+
  next
    case(cComm1 \<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q"
      by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Composition' `\<Psi> \<simeq> \<Psi>' \<otimes> \<Psi>''`)
    show ?case
      apply(rule cComm1)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cComm1)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule cComm1)
      apply fact+
      apply(rule statEqEnt)
      by fact+
  next
    case(cComm2 \<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q"
      by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Composition' `\<Psi> \<simeq> \<Psi>' \<otimes> \<Psi>''`)
    show ?case
      apply(rule cComm2)
      back
      apply(rule statEqTransition)
      apply fact
      apply fact+
      apply(rule cComm2)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule cComm2)
      apply fact+
      apply(rule statEqEnt)
      by fact+
  next
    case(cOpen \<Psi> P M xvec yvec N P' x \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cOpen)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cOpen)
      by fact+
  next
    case(cScope \<Psi> P \<alpha> P' x \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cScope)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cScope)
      by fact+
  next
    case(cBang \<Psi> P \<alpha> P' \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cBang)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cBang)
      by fact+
  next
    case(cInv \<Psi> M P \<alpha> P' \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cInv)
      apply(rule statEqEnt)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule cInv)
      by fact+
  qed
qed

lemma semanticsPsiInduct[consumes 1, case_names cInput cOutput cCase cPar1 cPar2 cComm1 cComm2 cOpen cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Rs   :: "('a, 'b, 'c) residual"
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow>
                 ('a, 'b, 'c) residual \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes Trans: "\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> Rs"
  and     rInput: "\<And>\<Psi> M K xvec N Tvec P C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<leftrightarrow> K; distinct xvec; set xvec \<subseteq> supp N;
                    length xvec = length Tvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>';
                    xvec \<sharp>* M; xvec \<sharp>* K; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (M\<lparr>\<lambda>*xvec N\<rparr>.P)
                              (K\<lparr>(N[xvec::=Tvec])\<rparr> \<prec> (P[xvec::=Tvec]))"
  and     rOutput: "\<And>\<Psi> M K N P C. \<Psi>'\<otimes>\<Psi> \<turnstile> M \<leftrightarrow> K \<Longrightarrow> Prop C \<Psi>' \<Psi> (M\<langle>N\<rangle>.P) (K\<langle>N\<rangle> \<prec> P)"
  and     rCase: "\<And>\<Psi> P Rs \<phi> Cs C. \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> Rs; \<And>C. Prop C \<Psi>' \<Psi> P Rs;
                                            (\<phi>, P) mem Cs; \<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (Cases Cs) Rs"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (\<alpha> \<prec> P'); distinct(bn \<alpha>);
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* P';
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P' \<parallel> Q))"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (\<alpha> \<prec> Q'); distinct(bn \<alpha>);
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* Q';
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P \<parallel> Q'))"
  and     rComm1: "\<And>\<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P ((M\<lparr>N\<rparr>) \<prec> P');
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'); distinct xvec;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q'))"
  and     rComm2: "\<And>\<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P');
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>N\<rparr> \<prec> Q');
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K; distinct xvec;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q'))"
  and     rOpen: "\<And>\<Psi> P M xvec yvec N P' x C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P';
                    \<And>C. Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'); x \<in> supp N; x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M;
                     x \<sharp> xvec; x \<sharp> yvec; xvec \<sharp>* yvec; distinct xvec; distinct yvec;
                     xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M;
                     yvec \<sharp>* \<Psi>; yvec \<sharp>* \<Psi>'; yvec \<sharp>* P; yvec \<sharp>* M; x \<sharp> C; xvec \<sharp>* C; yvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P')"
  and     rScope: "\<And>\<Psi> P \<alpha> P' x C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                    \<And>C. Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P');
                     x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> \<alpha>; distinct(bn \<alpha>);
                     bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>;
                     x \<sharp> C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (\<alpha> \<prec> (\<lparr>\<nu>x\<rparr>P'))"
  and     rBang:    "\<And>\<Psi> P Rs C.
                     \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> Rs; guarded P;
                      \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) Rs\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (!P) Rs"
  and     rInv:   "\<And>\<Psi> M P \<alpha> P' C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    distinct(bn \<alpha>);
                    bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* M;
                    bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C;
                    \<And> C. Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P')\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) (\<alpha> \<prec> P')"
  shows "Prop C \<Psi>' \<Psi> P Rs"
proof -
  obtain \<Psi>'' where n: "\<Psi>'' \<simeq> \<Psi>' \<otimes> \<Psi>"
    by(blast intro: AssertionStatEqRefl)
  with `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>Rs` have "\<Psi>'' \<rhd> P \<longmapsto>Rs"
    apply(rule_tac statEqTransition)
    apply assumption
    by(rule AssertionStatEqSym)
  thus ?thesis using n rInput rOutput rCase rPar1 rPar2 rComm1 rComm2 rOpen rScope rBang rInv
  proof(nominal_induct avoiding: \<Psi>' \<Psi> C rule: semantics.strong_induct)
    case(cInput \<Psi> M K xvec N Tvec P \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cInput)
      apply(rule statEqEnt)
      by fact+
  next
    case(Output \<Psi> M K N P \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule Output)
      apply(rule statEqEnt)
      by fact+
  next
    case(Case \<Psi> P Rs \<phi> Cs \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule Case)
      apply(rule statEqTransition)
      apply fact
      apply fact
      apply(rule Case)
      apply fact+
      apply(rule statEqEnt)
      by fact+
  next
    case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    show ?case
      apply(rule cPar1)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cPar1)
      by fact+
  next
    case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    show ?case
      apply(rule cPar2)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cPar2)
      by fact+
  next
    case(cComm1 \<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q"
      by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Composition' `\<Psi> \<simeq> \<Psi>' \<otimes> \<Psi>''`)
    show ?case
      apply(rule cComm1)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cComm1)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule statEqEnt)
      apply fact+
      apply(rule cComm1)
      by fact+
  next
    case(cComm2 \<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q \<Psi>' \<Psi>'' C)
    have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>Q"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>Q"
      by(metis AssertionStatEqTrans Associativity)
    have "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> (\<Psi>' \<otimes> \<Psi>'') \<otimes> \<Psi>\<^isub>P"
      apply(rule Composition)
      apply fact
      done
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P"
      by(metis AssertionStatEqTrans Associativity)
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<simeq> \<Psi>' \<otimes> \<Psi>'' \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q"
      by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Composition' `\<Psi> \<simeq> \<Psi>' \<otimes> \<Psi>''`)
    show ?case
      apply(rule cComm2)
      back
      apply(rule statEqTransition)
      apply fact
      apply fact+
      apply(rule cComm2)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule cComm2)
      apply fact+
      apply(rule statEqEnt)
      by fact+
  next
    case(cOpen \<Psi> P M xvec yvec N P' x \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cOpen)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cOpen)
      by fact+
  next
    case(cScope \<Psi> P \<alpha> P' x \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cScope)
      apply(rule statEqTransition)
      apply fact+
      apply(rule cScope)
      by fact+
  next
    case(Bang \<Psi> P Rs \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule Bang)
      apply(rule statEqTransition)
      apply fact+
      apply(rule Bang)
      by fact+
  next
    case(cInv \<Psi> M P \<alpha> P' \<Psi>' \<Psi>'' C)
    show ?case
      apply(rule cInv)
      apply(rule statEqEnt)
      apply fact+
      apply(rule statEqTransition)
      apply fact+
      apply(rule cInv)
      by fact+
  qed
qed

lemma semanticsFrameCompInduct[consumes 3, case_names cAlpha cInput cOutput cCase cPar1 cPar2 cComm1 cComm2 cOpen cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Rs   :: "('a, 'b, 'c) residual"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow>
                 ('a, 'b, 'c) residual \<Rightarrow> name list \<Rightarrow> 'b \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes Trans: "\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> Rs"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     rAlpha: "\<And>\<Psi> P A\<^isub>P \<Psi>\<^isub>P p Rs C. \<lbrakk>A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* (p \<bullet> A\<^isub>P); A\<^isub>P \<sharp>* Rs; A\<^isub>P \<sharp>* C;
                                         set p \<subseteq> set A\<^isub>P \<times> set(p \<bullet> A\<^isub>P); distinctPerm p;
                                          Prop C \<Psi>' \<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P Rs (p \<bullet> A\<^isub>P) (p \<bullet> \<Psi>\<^isub>P)"
  and     rInput: "\<And>\<Psi> M K xvec N Tvec P C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<leftrightarrow> K; distinct xvec; set xvec \<subseteq> supp N;
                    length xvec = length Tvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>';
                    xvec \<sharp>* M; xvec \<sharp>* K; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (M\<lparr>\<lambda>*xvec N\<rparr>.P)
                              (K\<lparr>(N[xvec::=Tvec])\<rparr> \<prec> (P[xvec::=Tvec])) ([]) (\<one>)"
  and     rOutput: "\<And>\<Psi> M K N P C. \<Psi>'\<otimes>\<Psi> \<turnstile> M \<leftrightarrow> K \<Longrightarrow> Prop C \<Psi>' \<Psi> (M\<langle>N\<rangle>.P) (K\<langle>N\<rangle> \<prec> P) ([]) (\<one>)"
  and     rCase: "\<And>\<Psi> P Rs \<phi> Cs A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> Rs; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P; \<And>C. Prop C \<Psi>' \<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P;
                                            (\<phi>, P) mem Cs; \<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>;  \<Psi>\<^isub>P \<simeq> \<one>; (supp \<Psi>\<^isub>P) = ({}::name set);
                                            A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Rs; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (Cases Cs) Rs ([]) (\<one>)"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P; distinct(bn \<alpha>);
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P' \<parallel> Q)) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (\<alpha> \<prec> Q') A\<^isub>Q \<Psi>\<^isub>Q; distinct(bn \<alpha>);
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* Q'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rComm1: "\<And>\<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P ((M\<lparr>N\<rparr>) \<prec> P') A\<^isub>P \<Psi>\<^isub>P;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q') A\<^isub>Q \<Psi>\<^isub>Q; distinct xvec;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rComm2: "\<And>\<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P') A\<^isub>P \<Psi>\<^isub>P;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>N\<rparr> \<prec> Q') A\<^isub>Q \<Psi>\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K; distinct xvec;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rOpen: "\<And>\<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P') A\<^isub>P \<Psi>\<^isub>P; x \<in> supp N; x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M;
                     x \<sharp> A\<^isub>P; x \<sharp> xvec; x \<sharp> yvec; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';
                     A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* yvec; xvec \<sharp>* yvec; distinct xvec; distinct yvec;
                     xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P; yvec \<sharp>* \<Psi>\<^isub>P;
                     yvec \<sharp>* \<Psi>; yvec \<sharp>* \<Psi>'; yvec \<sharp>* P; yvec \<sharp>* M; A\<^isub>P \<sharp>* C; x \<sharp> C; xvec \<sharp>* C; yvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P') (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rScope: "\<And>\<Psi> P \<alpha> P' x A\<^isub>P \<Psi>\<^isub>P C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P;
                     x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> \<alpha>; x \<sharp> A\<^isub>P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P;
                     A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; distinct(bn \<alpha>);
                     bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P;
                     A\<^isub>P \<sharp>* C; x \<sharp> C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (\<alpha> \<prec> (\<lparr>\<nu>x\<rparr>P')) (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rBang:    "\<And>\<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P C.
                     \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> Rs; guarded P; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                      \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) Rs A\<^isub>P (\<Psi>\<^isub>P \<otimes> \<one>); \<Psi>\<^isub>P \<simeq> \<one>; supp \<Psi>\<^isub>P = ({}::name set);
                      A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Rs; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (!P) Rs ([]) (\<one>)"
  and     rInv:   "\<And>\<Psi> M P \<alpha> P' A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    distinct(bn \<alpha>);
                    extractFrame (P) = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>; distinct A\<^isub>P\<^isub>S;
                    A\<^isub>P\<^isub>S \<sharp>* P; A\<^isub>P\<^isub>S \<sharp>* \<Psi>; A\<^isub>P\<^isub>S \<sharp>* \<Psi>'; A\<^isub>P\<^isub>S \<sharp>* \<alpha>; A\<^isub>P\<^isub>S \<sharp>* P'; A\<^isub>P\<^isub>S \<sharp>* M; A\<^isub>P\<^isub>S \<sharp>* C;
                    bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* M;
                    bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C;
                    \<And> C. Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P') A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) (\<alpha> \<prec> P') ([]) (\<one>)"
  shows "Prop C \<Psi>' \<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P"
  using Trans FrP `distinct A\<^isub>P`
proof(nominal_induct avoiding: A\<^isub>P \<Psi>\<^isub>P C rule: semanticsPsiInduct)
  case(cInput \<Psi> M K xvec N Tvec P A\<^isub>P \<Psi>\<^isub>P C)
  from `extractFrame (M\<lparr>\<lambda>*xvec N\<rparr>.P) = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>`
  have "A\<^isub>P = []" and "\<Psi>\<^isub>P = \<one>"
    by auto
  with `\<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K` `distinct xvec` `set xvec \<subseteq> supp N` `length xvec = length Tvec`
       `xvec \<sharp>* \<Psi>` `xvec \<sharp>* M` `xvec \<sharp>* K` `xvec \<sharp>* C` `xvec \<sharp>* \<Psi>'`
  show ?case by(blast intro: rInput)
next
  case(cOutput \<Psi> M K N P A\<^isub>P \<Psi>\<^isub>P)
  from `extractFrame (M\<langle>N\<rangle>.P) = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>`
  have "A\<^isub>P = []" and "\<Psi>\<^isub>P = \<one>"
    by auto
  with `\<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K` show ?case
    by(blast intro: rOutput)
next
  case(cCase \<Psi> P Rs \<phi> Cs A\<^isub>c\<^isub>P \<Psi>\<^isub>c\<^isub>P C)
  obtain A\<^isub>P \<Psi>\<^isub>P where FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P"
                  and "A\<^isub>P \<sharp>* (\<Psi>, \<Psi>', P, Rs, C)"
    by(rule freshFrame)
  hence "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* \<Psi>'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Rs" and "A\<^isub>P \<sharp>* C"
    by simp+
  note `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> Rs` FrP `distinct A\<^isub>P`
  moreover from FrP `distinct A\<^isub>P` `\<And>A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P` 
  have "\<And>C. Prop C \<Psi>' \<Psi> P Rs A\<^isub>P \<Psi>\<^isub>P" by simp
  moreover note `(\<phi>, P) mem Cs` `\<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>` `guarded P` `\<not> clauseDom \<phi>`
  moreover from `guarded P` FrP have "\<Psi>\<^isub>P \<simeq> \<one>" and "supp \<Psi>\<^isub>P = ({}::name set)" by(metis guardedStatEq)+
  moreover note `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Rs` `A\<^isub>P \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (Cases Cs) Rs ([]) (\<one>)"
    by(rule rCase)
  thus ?case using `extractFrame(Cases Cs) = \<langle>A\<^isub>c\<^isub>P, \<Psi>\<^isub>c\<^isub>P\<rangle>` by simp
next
  case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P\<^isub>Q \<Psi>\<^isub>P\<^isub>Q C)
  obtain A\<^isub>P \<Psi>\<^isub>P where FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P"
                           "A\<^isub>P \<sharp>* (P, Q, \<Psi>, \<Psi>', \<alpha>, P', A\<^isub>Q, A\<^isub>P\<^isub>Q, C, \<Psi>\<^isub>Q)"
    by(rule freshFrame)
  hence "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* \<Psi>'" and "A\<^isub>P \<sharp>* \<alpha>" and "A\<^isub>P \<sharp>* P'"
    and "A\<^isub>P \<sharp>* A\<^isub>Q" and "A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q" and "A\<^isub>P \<sharp>* C" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q"
    by simp+
  have FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>" by fact

  from `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>Q` FrP have "A\<^isub>Q \<sharp>* \<Psi>\<^isub>P"
    by(force dest: extractFrameFreshChain)
  from `bn \<alpha> \<sharp>* P` `A\<^isub>P \<sharp>* \<alpha>` FrP have "bn \<alpha> \<sharp>* \<Psi>\<^isub>P"
    by(force dest: extractFrameFreshChain)

  from `extractFrame(P \<parallel> Q) = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>` FrP FrQ `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P`
  have "\<langle>(A\<^isub>P@A\<^isub>Q), \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q\<rangle> = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>"
    by simp
  moreover from `distinct A\<^isub>P` `distinct A\<^isub>Q` `A\<^isub>P \<sharp>* A\<^isub>Q` have "distinct(A\<^isub>P@A\<^isub>Q)"
    by(auto simp add: fresh_star_def fresh_def name_list_supp)
  ultimately obtain p where S: "set p \<subseteq> set(A\<^isub>P@A\<^isub>Q) \<times> set((p \<bullet> A\<^isub>P)@(p \<bullet> A\<^isub>Q))"  and "distinctPerm p"
                        and \<Psi>eq: "\<Psi>\<^isub>P\<^isub>Q = p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)" and Aeq: "A\<^isub>P\<^isub>Q = (p \<bullet> A\<^isub>P)@(p \<bullet> A\<^isub>Q)"
    using `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `distinct A\<^isub>P\<^isub>Q`
    by(rule_tac frameChainEq') (assumption | simp add: eqvts)+
  
  note `\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P'` FrP `distinct A\<^isub>P` FrQ `distinct A\<^isub>Q`

  moreover from FrP `distinct A\<^isub>P` `\<And>A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P`
  have "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P" by simp

  moreover note `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q`
                `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* P'` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `distinct(bn \<alpha>)`
                `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* P`  `bn \<alpha> \<sharp>* Q`  `bn \<alpha> \<sharp>* subject \<alpha>`  `bn \<alpha> \<sharp>* \<Psi>\<^isub>P`  `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` 
                `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C` `bn \<alpha> \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P' \<parallel> Q)) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule_tac rPar1)
  with `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>P \<sharp>* C`
       `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* P'` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* C`
       S `distinctPerm p` Aeq
  have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P' \<parallel> Q)) (p \<bullet> (A\<^isub>P@A\<^isub>Q)) (p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q))"
    by(rule_tac rAlpha) (assumption | simp add: eqvts)+
  with \<Psi>eq Aeq show ?case by(simp add: eqvts)
next
  case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>P\<^isub>Q \<Psi>\<^isub>P\<^isub>Q C)
  obtain A\<^isub>Q \<Psi>\<^isub>Q where FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q"
                           "A\<^isub>Q \<sharp>* (P, Q, \<Psi>', \<Psi>, \<alpha>, Q', A\<^isub>P, A\<^isub>P\<^isub>Q, C, \<Psi>\<^isub>P)"
    by(rule freshFrame)
  hence "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* \<Psi>'" and "A\<^isub>Q \<sharp>* \<alpha>" and "A\<^isub>Q \<sharp>* Q'"
    and "A\<^isub>Q \<sharp>* A\<^isub>P" and "A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q" and "A\<^isub>Q \<sharp>* C" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>P"
    by simp+

  from `A\<^isub>Q \<sharp>* A\<^isub>P` have "A\<^isub>P \<sharp>* A\<^isub>Q" by simp
  have FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" by fact

  from `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* A\<^isub>P` FrQ have "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q"
    by(force dest: extractFrameFreshChain)
  from `bn \<alpha> \<sharp>* Q` `A\<^isub>Q \<sharp>* \<alpha>` FrQ have "bn \<alpha> \<sharp>* \<Psi>\<^isub>Q"
    by(force dest: extractFrameFreshChain)

  from `extractFrame(P \<parallel> Q) = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>` FrP FrQ `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P`
  have "\<langle>(A\<^isub>P@A\<^isub>Q), \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q\<rangle> = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>"
    by simp
  moreover from `distinct A\<^isub>P` `distinct A\<^isub>Q` `A\<^isub>P \<sharp>* A\<^isub>Q` have "distinct(A\<^isub>P@A\<^isub>Q)"
    by(auto simp add: fresh_star_def fresh_def name_list_supp)
  ultimately obtain p where S: "(set p \<subseteq> (set(A\<^isub>P@A\<^isub>Q)) \<times> (set A\<^isub>P\<^isub>Q))"  and "distinctPerm p"
                        and \<Psi>eq: "\<Psi>\<^isub>P\<^isub>Q = p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)" and Aeq: "A\<^isub>P\<^isub>Q = ((p \<bullet> A\<^isub>P)@(p \<bullet> A\<^isub>Q))"
    using `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `distinct A\<^isub>P\<^isub>Q`
    by(rule_tac frameChainEq') (assumption | simp add: eqvts)+

  note `\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q'` FrP `distinct A\<^isub>P` FrQ `distinct A\<^isub>Q`

  moreover from FrQ `distinct A\<^isub>Q` `\<And>A\<^isub>Q \<Psi>\<^isub>Q C. \<lbrakk>extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q\<rbrakk> \<Longrightarrow> Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (\<alpha> \<prec> Q') A\<^isub>Q \<Psi>\<^isub>Q`
  have "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (\<alpha> \<prec> Q') A\<^isub>Q \<Psi>\<^isub>Q" by simp

  moreover note `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* Q'` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q`
                `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `distinct(bn \<alpha>)`
                `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* P`  `bn \<alpha> \<sharp>* Q`  `bn \<alpha> \<sharp>* subject \<alpha>`  `bn \<alpha> \<sharp>* \<Psi>\<^isub>P`  `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` 
                `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C` `bn \<alpha> \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule_tac rPar2)

  with `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* Q'` `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>P \<sharp>* C`
       `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* C`
       S `distinctPerm p` Aeq
  have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<alpha> \<prec> (P \<parallel> Q')) (p \<bullet> (A\<^isub>P@A\<^isub>Q)) (p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q))"
    by(rule_tac rAlpha) (assumption | simp add: eqvts)+
  with \<Psi>eq Aeq show ?case by(simp add: eqvts)
next
  case(cComm1 \<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q A\<^isub>P\<^isub>Q \<Psi>\<^isub>P\<^isub>Q C)
  from `distinct A\<^isub>P` `distinct A\<^isub>Q` `A\<^isub>P \<sharp>* A\<^isub>Q` have "distinct(A\<^isub>P@A\<^isub>Q)"
    by(auto simp add: fresh_star_def fresh_def name_list_supp)
  from cComm1 have  "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule_tac rComm1)
  moreover from `extractFrame(P \<parallel> Q) = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P`
  have "\<langle>(A\<^isub>P@A\<^isub>Q), (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)\<rangle> = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>"
    by simp
  with `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `distinct(A\<^isub>P@A\<^isub>Q)` `distinct A\<^isub>P\<^isub>Q`
  obtain p where S: "(set p \<subseteq> (set(A\<^isub>P@A\<^isub>Q)) \<times> (set A\<^isub>P\<^isub>Q))"  and "distinctPerm p"
             and \<Psi>eq: "\<Psi>\<^isub>P\<^isub>Q = p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)" and Aeq: "A\<^isub>P\<^isub>Q = p \<bullet> (A\<^isub>P@A\<^isub>Q)"
    by(rule_tac frameChainEq') (assumption | simp)+
  moreover note `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>P \<sharp>* xvec`
                `A\<^isub>Q \<sharp>* xvec` `A\<^isub>P \<sharp>* P'` `A\<^isub>Q \<sharp>* P'` `A\<^isub>P \<sharp>* Q'` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q`
                `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (p \<bullet> (A\<^isub>P@A\<^isub>Q)) (p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q))"
    by(rule_tac rAlpha) auto
  with \<Psi>eq Aeq show ?case by simp
next
  case(cComm2 \<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q A\<^isub>P\<^isub>Q \<Psi>\<^isub>P\<^isub>Q C)
  from `distinct A\<^isub>P` `distinct A\<^isub>Q` `A\<^isub>P \<sharp>* A\<^isub>Q` have "distinct(A\<^isub>P@A\<^isub>Q)"
    by(auto simp add: fresh_star_def fresh_def name_list_supp)
  from cComm2 have  "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule_tac rComm2)
  moreover from `extractFrame(P \<parallel> Q) = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>`
                `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P`
  have "\<langle>(A\<^isub>P@A\<^isub>Q), (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)\<rangle> = \<langle>A\<^isub>P\<^isub>Q, \<Psi>\<^isub>P\<^isub>Q\<rangle>"
    by simp
  with `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q` `distinct(A\<^isub>P@A\<^isub>Q)` `distinct A\<^isub>P\<^isub>Q`
  obtain p where S: "(set p \<subseteq> (set(A\<^isub>P@A\<^isub>Q)) \<times> (set A\<^isub>P\<^isub>Q))"  and "distinctPerm p"
             and \<Psi>eq: "\<Psi>\<^isub>P\<^isub>Q = p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)" and Aeq: "A\<^isub>P\<^isub>Q = p \<bullet> (A\<^isub>P@A\<^isub>Q)"
    by(rule_tac frameChainEq') (assumption | simp)+
  moreover note `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>P \<sharp>* xvec`
                `A\<^isub>Q \<sharp>* xvec` `A\<^isub>P \<sharp>* P'` `A\<^isub>Q \<sharp>* P'` `A\<^isub>P \<sharp>* Q'` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>P \<sharp>* A\<^isub>P\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>P\<^isub>Q`
                `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (p \<bullet> (A\<^isub>P@A\<^isub>Q)) (p \<bullet> (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q))"
    by(rule_tac rAlpha) auto
  with \<Psi>eq Aeq show ?case by simp
next
  case(cOpen \<Psi> P M xvec yvec N P' x A\<^isub>x\<^isub>P \<Psi>\<^isub>x\<^isub>P C)
  obtain A\<^isub>P \<Psi>\<^isub>P where FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P"
                  and "A\<^isub>P \<sharp>* (\<Psi>, \<Psi>', P, M, xvec, yvec, N, P', A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P, C, x)"
    by(rule freshFrame)
  hence "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* \<Psi>'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* M" and "A\<^isub>P \<sharp>* xvec"and "A\<^isub>P \<sharp>* yvec" and "A\<^isub>P \<sharp>* N" and "A\<^isub>P \<sharp>* P'"
    and "A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>x\<^isub>P" and "A\<^isub>P \<sharp>* C" and "x \<sharp> A\<^isub>P"
    by simp+

  from `xvec \<sharp>* P` `A\<^isub>P \<sharp>* xvec` FrP have "xvec \<sharp>* \<Psi>\<^isub>P"
    by(force dest: extractFrameFreshChain)
  from `yvec \<sharp>* P` `A\<^isub>P \<sharp>* yvec` FrP have "yvec \<sharp>* \<Psi>\<^isub>P"
    by(force dest: extractFrameFreshChain)

  from `extractFrame(\<lparr>\<nu>x\<rparr>P) = \<langle>A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P\<rangle>` FrP
  have "\<langle>(x#A\<^isub>P), \<Psi>\<^isub>P\<rangle> = \<langle>A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P\<rangle>"
    by simp
  moreover from `x \<sharp> A\<^isub>P` `distinct A\<^isub>P` have "distinct(x#A\<^isub>P)" by simp
  ultimately obtain p where S: "set p \<subseteq> set (x#A\<^isub>P) \<times> set (p \<bullet> (x#A\<^isub>P))" and "distinctPerm p"
                        and \<Psi>eq: "\<Psi>\<^isub>x\<^isub>P = p \<bullet> \<Psi>\<^isub>P" and Aeq: "A\<^isub>x\<^isub>P = (p \<bullet> x)#(p \<bullet> A\<^isub>P)"
    using `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P``x \<sharp> A\<^isub>x\<^isub>P` `distinct A\<^isub>x\<^isub>P`
    by(rule_tac frameChainEq') (assumption | simp add: eqvts)+

  note `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'` FrP `distinct A\<^isub>P`
  moreover from FrP `distinct A\<^isub>P` `\<And>A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P') A\<^isub>P \<Psi>\<^isub>P`
  have "\<And>C. Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P') A\<^isub>P \<Psi>\<^isub>P" by simp
  moreover note `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> M` `x \<sharp> xvec` `x \<sharp> yvec` `x \<in> supp N` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* P'`
                `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>'` `xvec \<sharp>* P`  `xvec \<sharp>* M`  `xvec \<sharp>* \<Psi>\<^isub>P` `yvec \<sharp>* \<Psi>` `yvec \<sharp>* P`  `yvec \<sharp>* M`  `yvec \<sharp>* \<Psi>\<^isub>P`  `yvec \<sharp>* \<Psi>'`
                `A\<^isub>P \<sharp>* C` `x \<sharp> C` `xvec \<sharp>* C` `yvec \<sharp>* C` `xvec \<sharp>* yvec` `distinct xvec` `distinct yvec`
  ultimately have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P') (x#A\<^isub>P) \<Psi>\<^isub>P"
    by(rule_tac rOpen) assumption+
  with `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P` `A\<^isub>P \<sharp>* C` `x \<sharp> A\<^isub>x\<^isub>P` `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P` `x \<sharp> A\<^isub>P`
       `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> M` `x \<sharp> C` `x \<sharp> xvec` `x \<sharp> yvec` Aeq
       S `distinctPerm p`
  have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P') (p \<bullet> (x#A\<^isub>P)) (p \<bullet> \<Psi>\<^isub>P)"
    by(rule_tac A\<^isub>P="x#A\<^isub>P" in rAlpha) (assumption | simp add: abs_fresh fresh_star_def boundOutputFresh)+
  with \<Psi>eq Aeq show ?case by(simp add: eqvts)
next
  case(cScope \<Psi> P \<alpha> P' x A\<^isub>x\<^isub>P \<Psi>\<^isub>x\<^isub>P C)
  obtain A\<^isub>P \<Psi>\<^isub>P where FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P"
                  and "A\<^isub>P \<sharp>* (\<Psi>',\<Psi>, P, \<alpha>, P', A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P, C, x)"
    by(rule freshFrame)
  hence "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* \<Psi>'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* \<alpha>" and "A\<^isub>P \<sharp>* P'"
    and "A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>x\<^isub>P" and "A\<^isub>P \<sharp>* C" and "x \<sharp> A\<^isub>P"
    by simp+

  from `bn \<alpha> \<sharp>* P` `A\<^isub>P \<sharp>* \<alpha>` FrP have "bn \<alpha> \<sharp>* \<Psi>\<^isub>P"
    by(force dest: extractFrameFreshChain)

  from `extractFrame(\<lparr>\<nu>x\<rparr>P) = \<langle>A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P\<rangle>` FrP
  have "\<langle>(x#A\<^isub>P), \<Psi>\<^isub>P\<rangle> = \<langle>A\<^isub>x\<^isub>P, \<Psi>\<^isub>x\<^isub>P\<rangle>"
    by simp
  moreover from `x \<sharp> A\<^isub>P` `distinct A\<^isub>P` have "distinct(x#A\<^isub>P)" by simp
  ultimately obtain p where S: "set p \<subseteq> set (x#A\<^isub>P) \<times> set (p \<bullet> (x#A\<^isub>P))" and "distinctPerm p"
                        and \<Psi>eq: "\<Psi>\<^isub>x\<^isub>P = p \<bullet> \<Psi>\<^isub>P" and Aeq: "A\<^isub>x\<^isub>P = (p \<bullet> x)#(p \<bullet> A\<^isub>P)"
    using `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P``x \<sharp> A\<^isub>x\<^isub>P` `distinct A\<^isub>x\<^isub>P`
    by(rule_tac frameChainEq') (assumption | simp add: eqvts)+

  note `\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'` FrP `distinct A\<^isub>P`
  moreover from FrP `distinct A\<^isub>P` `\<And>A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P`
  have "\<And>C. Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P') A\<^isub>P \<Psi>\<^isub>P" by simp
  moreover note `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> \<alpha>` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* P'` `distinct(bn \<alpha>)`
                `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* P`  `bn \<alpha> \<sharp>* subject \<alpha>`  `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `A\<^isub>P \<sharp>* C` `x \<sharp> C` `bn \<alpha> \<sharp>* C` 
  ultimately have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (\<alpha> \<prec> (\<lparr>\<nu>x\<rparr>P')) (x#A\<^isub>P) \<Psi>\<^isub>P"
    by(rule_tac rScope)
  with `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P` `A\<^isub>P \<sharp>* C` `x \<sharp> A\<^isub>x\<^isub>P` `A\<^isub>P \<sharp>* A\<^isub>x\<^isub>P` `x \<sharp> A\<^isub>P`
       `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> \<alpha>` `x \<sharp> C` Aeq
       S `distinctPerm p`
  have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (\<alpha> \<prec> (\<lparr>\<nu>x\<rparr>P')) (p \<bullet> (x#A\<^isub>P)) (p \<bullet> \<Psi>\<^isub>P)"
    by(rule_tac A\<^isub>P="x#A\<^isub>P" in rAlpha) (assumption | simp add: abs_fresh fresh_star_def)+
  with \<Psi>eq Aeq show ?case by(simp add: eqvts)
next
  case(cBang \<Psi> P Rs A\<^isub>b\<^isub>P \<Psi>\<^isub>b\<^isub>P C)

  obtain A\<^isub>P \<Psi>\<^isub>P where FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P"
                  and "A\<^isub>P \<sharp>* (\<Psi>',\<Psi>, P, Rs, C)"
    by(rule freshFrame)
  hence "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* \<Psi>'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Rs" and "A\<^isub>P \<sharp>* C" 
    by simp+
  note `\<Psi>'\<otimes>\<Psi> \<rhd> P \<parallel> !P \<longmapsto> Rs` `guarded P` FrP `distinct A\<^isub>P`
  moreover from FrP have "extractFrame (P \<parallel> !P) = \<langle>A\<^isub>P, \<Psi>\<^isub>P \<otimes> \<one>\<rangle>"
    by simp
  with `distinct A\<^isub>P` `\<And>A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>extractFrame (P \<parallel> !P) = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (P \<parallel> !P) Rs A\<^isub>P \<Psi>\<^isub>P`
  have "\<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) Rs A\<^isub>P (\<Psi>\<^isub>P \<otimes> \<one>)" by simp
  moreover from `guarded P` FrP have "\<Psi>\<^isub>P \<simeq> \<one>" and "supp \<Psi>\<^isub>P = ({}::name set)" by(metis guardedStatEq)+
  moreover note `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Rs` `A\<^isub>P \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (!P) Rs ([]) (\<one>)"
    by(rule rBang)
  thus ?case using `extractFrame(!P) = \<langle>A\<^isub>b\<^isub>P, \<Psi>\<^isub>b\<^isub>P\<rangle>` by simp
next
  case(cInv \<Psi> M P \<alpha> P' A\<^isub>I \<Psi>\<^isub>I C)
  (* Could perhaps be done simpler. *)
  obtain A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S where FrPS: "extractFrame (P) = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>" and "distinct A\<^isub>P\<^isub>S"
                           "A\<^isub>P\<^isub>S \<sharp>* (P, \<Psi>',\<Psi>, \<alpha>, P', A\<^isub>I, C, M)"
    by(rule freshFrame)
  hence "A\<^isub>P\<^isub>S \<sharp>* P"
    and "A\<^isub>P\<^isub>S \<sharp>* \<Psi>" and "A\<^isub>P\<^isub>S \<sharp>* \<Psi>'" and "A\<^isub>P\<^isub>S \<sharp>* \<alpha>" and "A\<^isub>P\<^isub>S \<sharp>* P'"
    and "A\<^isub>P\<^isub>S \<sharp>* A\<^isub>I" and "A\<^isub>P\<^isub>S \<sharp>* C"  and "A\<^isub>P\<^isub>S \<sharp>* M"
    by simp+
  from `bn \<alpha> \<sharp>* P` `A\<^isub>P\<^isub>S \<sharp>* \<alpha>` FrPS have "bn \<alpha> \<sharp>* \<Psi>\<^isub>P\<^isub>S"
    by(force dest: extractFrameFreshChain)
  from `extractFrame(\<langle>M\<rangle>) = \<langle>A\<^isub>I, \<Psi>\<^isub>I\<rangle>` have "A\<^isub>I = []" and "\<Psi>\<^isub>I = \<one>"
    by (-, (nominal_induct P rule: psi_input_psiCase.strong_inducts(1)), auto) (* or simp+ *)

  note `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'` FrPS `distinct A\<^isub>P\<^isub>S` (*FrQ `distinct A\<^isub>Q`*)

  moreover from FrPS `distinct A\<^isub>P\<^isub>S` `\<And>A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S C.\<lbrakk>extractFrame P = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>; distinct A\<^isub>P\<^isub>S\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P (\<alpha> \<prec> P') A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S`
  have "\<And>C. Prop C \<Psi>' \<Psi> (P) (\<alpha> \<prec> P') A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S" by simp

  with `\<Psi>'\<otimes>\<Psi> \<turnstile> M \<Leftarrow> P` `\<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'`
       `guarded P`
       `supp P \<subseteq> supp M` `distinct (bn \<alpha>)`
       `extractFrame P = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>` `distinct A\<^isub>P\<^isub>S`
       `A\<^isub>P\<^isub>S \<sharp>* P` `A\<^isub>P\<^isub>S \<sharp>* \<Psi>` `A\<^isub>P\<^isub>S \<sharp>* \<Psi>'` `A\<^isub>P\<^isub>S \<sharp>* \<alpha>` `A\<^isub>P\<^isub>S \<sharp>* P'`  `A\<^isub>P\<^isub>S \<sharp>* C`  `A\<^isub>P\<^isub>S \<sharp>* M`
       `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* M`
       `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C`
  have "Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) (\<alpha> \<prec> P') [] (\<one>)"
    by(rule_tac rInv)
  with `A\<^isub>I = []` `\<Psi>\<^isub>I = (\<one>)`
  show ?case
    by simp
qed

lemma semanticsFramePsiInduct'[consumes 5, case_names cAlpha cFrameAlpha cInput cOutput cCase cPar1 cPar2 cComm1 cComm2 cOpen cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Rs   :: "('a, 'b, 'c) residual"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow> 'a action \<Rightarrow>
                 ('a, 'b, 'c) psi \<Rightarrow> name list \<Rightarrow> 'b \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes Trans: "\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"
  and     rAlpha: "\<And>\<Psi> P \<alpha> P' p A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P;
                                           bn \<alpha> \<sharp>* C; bn \<alpha> \<sharp>* (p \<bullet> \<alpha>); A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C;
                                           set p \<subseteq> set(bn \<alpha>) \<times> set(bn(p \<bullet> \<alpha>)); distinctPerm p;
                                           bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>; (bn(p \<bullet> \<alpha>)) \<sharp>* P'; Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk> \<Longrightarrow>
                                           Prop C \<Psi>' \<Psi> P (p \<bullet> \<alpha>) (p \<bullet> P') A\<^isub>P \<Psi>\<^isub>P"
  and     rFrameAlpha: "\<And>\<Psi> P A\<^isub>P \<Psi>\<^isub>P p \<alpha> P' C. \<lbrakk>A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>';A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* (p \<bullet> A\<^isub>P); A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C;
                                                set p \<subseteq> set A\<^isub>P \<times> set(p \<bullet> A\<^isub>P); distinctPerm p; A\<^isub>P \<sharp>* subject \<alpha>;
                                                Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P \<alpha> P' (p \<bullet> A\<^isub>P) (p \<bullet> \<Psi>\<^isub>P)"
  and     rInput: "\<And>\<Psi> M K xvec N Tvec P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K; distinct xvec; set xvec \<subseteq> supp N;
                    length xvec = length Tvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>';
                    xvec \<sharp>* M; xvec \<sharp>* K; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (M\<lparr>\<lambda>*xvec N\<rparr>.P)
                              (K\<lparr>(N[xvec::=Tvec])\<rparr>) (P[xvec::=Tvec]) ([]) (\<one>)"
  and     rOutput: "\<And> \<Psi> M K N P C. \<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K \<Longrightarrow> Prop C \<Psi>' \<Psi> (M\<langle>N\<rangle>.P) (K\<langle>N\<rangle>) P ([]) (\<one>)"
  and     rCase: "\<And>\<Psi> P \<alpha> P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P; \<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P;
                                            (\<phi>, P) mem Cs; \<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>;  \<Psi>\<^isub>P \<simeq> \<one>; (supp \<Psi>\<^isub>P) = ({}::name set);
                                            A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (Cases Cs) \<alpha> P' ([]) (\<one>)"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P' \<parallel> Q) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q \<alpha> Q' A\<^isub>Q \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<alpha>; A\<^isub>Q \<sharp>* Q'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* Q; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P; bn \<alpha> \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P \<parallel> Q') (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rComm1: "\<And>\<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>N\<rparr>) P' A\<^isub>P \<Psi>\<^isub>P;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K; distinct xvec;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) Q' A\<^isub>Q \<Psi>\<^isub>Q;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau>) (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rComm2: "\<And>\<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) P' A\<^isub>P \<Psi>\<^isub>P;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q'; extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>N\<rparr>) Q' A\<^isub>Q \<Psi>\<^isub>Q;
                    \<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K; distinct xvec;
                    A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; 
                    A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* xvec; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P; 
                    A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* K; A\<^isub>Q \<sharp>* Q';
                    A\<^isub>Q \<sharp>* xvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q; xvec \<sharp>* P; xvec \<sharp>* M; 
                    xvec \<sharp>* Q; xvec \<sharp>* K; A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (P \<parallel> Q) (\<tau>) (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rOpen: "\<And>\<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P y C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle>) P' A\<^isub>P \<Psi>\<^isub>P; x \<in> supp N; x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M;
                     x \<sharp> A\<^isub>P; x \<sharp> xvec; x \<sharp> yvec; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';
                     A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* yvec; xvec \<sharp>* yvec; distinct xvec; distinct yvec;
                     xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P; 
                     yvec \<sharp>* \<Psi>; yvec \<sharp>* \<Psi>'; yvec \<sharp>* P; yvec \<sharp>* M; yvec \<sharp>* \<Psi>\<^isub>P; A\<^isub>P \<sharp>* C; x \<sharp> C; xvec \<sharp>* C; yvec \<sharp>* C;
                     y \<noteq> x; y \<sharp> \<Psi>; y \<sharp> \<Psi>'; y \<sharp> P; y \<sharp> M; y \<sharp> xvec; y \<sharp> yvec; y \<sharp> N; y \<sharp> P'; y \<sharp> A\<^isub>P; y \<sharp> \<Psi>\<^isub>P; y \<sharp> C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@y#yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>) ([(x, y)] \<bullet> P') (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rScope: "\<And>\<Psi> P \<alpha> P' x A\<^isub>P \<Psi>\<^isub>P C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P;
                     x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> \<alpha>; x \<sharp> A\<^isub>P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* P;
                     A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P';
                     bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* \<Psi>\<^isub>P;
                     A\<^isub>P \<sharp>* C; x \<sharp> C; bn \<alpha> \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) \<alpha> (\<lparr>\<nu>x\<rparr>P') (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rBang:    "\<And>\<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P C.
                     \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<parallel> !P \<longmapsto>\<alpha> \<prec> P'; guarded P; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                      \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) \<alpha> P' A\<^isub>P (\<Psi>\<^isub>P \<otimes> \<one>); \<Psi>\<^isub>P \<simeq> \<one>; supp \<Psi>\<^isub>P = ({}::name set);
                      A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (!P) \<alpha> P' ([]) (\<one>)"
  and     rInv:   "\<And>\<Psi> M P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    distinct(bn \<alpha>);
                    extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* \<alpha>; A\<^isub>P \<sharp>* P';  A\<^isub>P \<sharp>* C;  A\<^isub>P \<sharp>* M;
                    bn \<alpha> \<sharp>* P; bn \<alpha> \<sharp>* \<Psi>; bn \<alpha> \<sharp>* \<Psi>'; bn \<alpha> \<sharp>* M;
                    bn \<alpha> \<sharp>* subject \<alpha>; bn \<alpha> \<sharp>* C;
                    \<And> C. Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) \<alpha> P' ([]) (\<one>)"
  shows "Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P"
using Trans FrP `distinct A\<^isub>P` `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
proof(nominal_induct \<Psi>' \<Psi> P Rs=="\<alpha> \<prec> P'" A\<^isub>P \<Psi>\<^isub>P avoiding: C \<alpha> P' rule: semanticsFrameCompInduct)
  case(cAlpha \<Psi> P A\<^isub>P \<Psi>\<^isub>P p C \<alpha> P')
  thus ?case using rFrameAlpha
    by auto
next
  case cInput
  thus ?case using rInput
    by(auto simp add: residualInject)
next
  case cOutput
  thus ?case using rOutput
    by(auto simp add: residualInject)
next
  case cCase
  thus ?case using rCase
    by(auto simp add: residualInject)
next
  case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P C \<alpha>' P'')
  note `\<alpha> \<prec> (P' \<parallel> Q) = \<alpha>' \<prec> P''`
  moreover from `bn \<alpha> \<sharp>* \<alpha>'` have "bn \<alpha> \<sharp>* (bn \<alpha>')" by auto
  moreover note `distinct (bn \<alpha>)` `distinct(bn \<alpha>')`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha>' \<sharp>* subject \<alpha>'`
  have "bn \<alpha> \<sharp>* (\<alpha> \<prec> P' \<parallel> Q)" and "bn \<alpha>' \<sharp>* (\<alpha>' \<prec> P'')" by simp+
  ultimately obtain p where S: "(set p) \<subseteq> (set(bn \<alpha>)) \<times> (set(bn(p \<bullet> \<alpha>)))" and "distinctPerm p"
                        and \<alpha>Eq: "\<alpha>' = p \<bullet> \<alpha>" and P'eq: "P'' = p \<bullet> (P' \<parallel> Q)" and "(bn(p \<bullet> \<alpha>)) \<sharp>* \<alpha>"
                        and "(bn(p \<bullet> \<alpha>)) \<sharp>* (P' \<parallel> Q)"
    by(rule residualEq)    
  note `\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>\<alpha> \<prec> P'` `extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` `A\<^isub>P \<sharp>* \<alpha>`
  have "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P"
    using cPar1
    by auto
  have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P' \<parallel> Q) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule rPar1) fact+
  with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* Q` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C` `bn \<alpha> \<sharp>* (bn \<alpha>')` S `distinctPerm p` `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn(p \<bullet> \<alpha>) \<sharp>* (P' \<parallel> Q)` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* \<alpha>'` `A\<^isub>Q \<sharp>* \<alpha>'` \<alpha>Eq `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* \<alpha>'` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>P \<sharp>* P'` `A\<^isub>Q \<sharp>* P'` `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C` `bn \<alpha> \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>'`
  have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (p \<bullet> \<alpha>) (p \<bullet> (P' \<parallel> Q)) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
   by(rule_tac rAlpha) auto
  with \<alpha>Eq P'eq `distinctPerm p` show ?case by simp
next
  case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q C \<alpha>' Q'')
  note `\<alpha> \<prec> (P \<parallel> Q') = \<alpha>' \<prec> Q''`
  moreover from `bn \<alpha> \<sharp>* \<alpha>'` have "bn \<alpha> \<sharp>* (bn \<alpha>')" by auto
  moreover note `distinct (bn \<alpha>)` `distinct(bn \<alpha>')`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha>' \<sharp>* subject \<alpha>'`
  have "bn \<alpha> \<sharp>* (\<alpha> \<prec> P \<parallel> Q')" and "bn \<alpha>' \<sharp>* (\<alpha>' \<prec> Q'')" by simp+
  ultimately obtain p where S: "(set p) \<subseteq> (set(bn \<alpha>)) \<times> (set(bn(p \<bullet> \<alpha>)))" and "distinctPerm p"
                        and \<alpha>Eq: "\<alpha>' = p \<bullet> \<alpha>" and Q'eq: "Q'' = p \<bullet> (P \<parallel> Q')" and "(bn(p \<bullet> \<alpha>)) \<sharp>* \<alpha>"
                        and "(bn(p \<bullet> \<alpha>)) \<sharp>* (P \<parallel> Q')"
    by(rule residualEq)
  note `\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>\<alpha> \<prec> Q'` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` `A\<^isub>Q \<sharp>* \<alpha>`
  have "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q \<alpha> Q' A\<^isub>Q \<Psi>\<^isub>Q" by(rule_tac cPar2) auto
  moreover note `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>Q \<sharp>* C` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* Q'` `A\<^isub>P \<sharp>* C`
                `bn \<alpha> \<sharp>* Q` `distinct(bn \<alpha>)` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C`
                `extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* \<Psi>'`
  ultimately have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) \<alpha> (P \<parallel> Q') (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
    by(rule_tac rPar2) auto
  with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* Q` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C` `bn \<alpha> \<sharp>* (bn \<alpha>')` S `distinctPerm p` `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn(p \<bullet> \<alpha>) \<sharp>* (P \<parallel> Q')` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* \<alpha>'` `A\<^isub>Q \<sharp>* \<alpha>'` \<alpha>Eq `bn \<alpha> \<sharp>* \<alpha>'` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>P \<sharp>* Q'` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>P \<sharp>* C` `A\<^isub>Q \<sharp>* C` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>Q \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* \<Psi>'`
  have "Prop C \<Psi>' \<Psi> (P \<parallel> Q) (p \<bullet> \<alpha>) (p \<bullet> (P \<parallel> Q')) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
   by(rule_tac rAlpha) auto
  with \<alpha>Eq Q'eq `distinctPerm p` show ?case by simp
next
  case(cComm1 \<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q C \<alpha> P'')
  thus ?case using rComm1
    apply(auto simp add: residualInject)
    apply(drule_tac x="M\<lparr>N\<rparr>" in meta_spec)
    apply(drule_tac x="K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>" in meta_spec)
    apply(drule_tac x=P' in meta_spec)
    apply(drule_tac x=Q' in meta_spec)
    apply auto
    apply(drule_tac x=\<Psi> in meta_spec)
    apply(drule_tac x=\<Psi>\<^isub>Q in meta_spec)
    apply(drule_tac x=P in meta_spec)
    apply(drule_tac x=M in meta_spec)
    apply(drule_tac x=N in meta_spec)
    apply(drule_tac x=P' in meta_spec)
    apply(drule_tac x=A\<^isub>P in meta_spec)
    apply(drule_tac x=\<Psi>\<^isub>P in meta_spec)
    apply(drule_tac x=Q in meta_spec)
    apply(drule_tac x=K in meta_spec)
    apply(drule_tac x=xvec in meta_spec)
    apply(drule_tac x=Q' in meta_spec)
    apply(drule_tac x=A\<^isub>Q in meta_spec)
    apply auto
    apply(subgoal_tac "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) Q' A\<^isub>Q \<Psi>\<^isub>Q")
    apply(subgoal_tac "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>N\<rparr>) P' A\<^isub>P \<Psi>\<^isub>P")
    by auto
next
  case(cComm2 \<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>P \<Psi>\<^isub>P Q K Q' A\<^isub>Q C \<alpha> Q'')
  thus ?case using rComm2
    apply(drule_tac x="M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>" in meta_spec)
    apply(drule_tac x="K\<lparr>N\<rparr>" in meta_spec)
    apply(drule_tac x=P' in meta_spec)
    apply(drule_tac x=Q' in meta_spec)
    apply auto
    apply(drule_tac x=\<Psi> in meta_spec)
    apply(drule_tac x=\<Psi>\<^isub>Q in meta_spec)
    apply(drule_tac x=P in meta_spec)
    apply(drule_tac x=M in meta_spec)
    apply(drule_tac x=xvec in meta_spec)
    apply(drule_tac x=N in meta_spec)
    apply(drule_tac x=P' in meta_spec)
    apply(drule_tac x=A\<^isub>P in meta_spec)
    apply(drule_tac x=\<Psi>\<^isub>P in meta_spec)
    apply(drule_tac x=Q in meta_spec)
    apply(drule_tac x=K in meta_spec)
    apply(drule_tac x=Q' in meta_spec)
    apply(drule_tac x=A\<^isub>Q in meta_spec)
    apply auto
    apply(subgoal_tac "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) P' A\<^isub>P \<Psi>\<^isub>P")
    apply(subgoal_tac "\<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q (K\<lparr>N\<rparr>) Q' A\<^isub>Q \<Psi>\<^isub>Q")
    by(auto simp add: residualInject)
next
  case(cOpen \<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P C \<alpha> P'')
  note `M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P' = \<alpha> \<prec> P''`
  moreover from `xvec \<sharp>* \<alpha>` `x \<sharp> \<alpha>` `yvec \<sharp>* \<alpha>` have "(xvec@x#yvec) \<sharp>* (bn \<alpha>)"
    by auto
  moreover from `xvec \<sharp>* yvec` `x \<sharp> xvec` `x \<sharp> yvec` `distinct xvec` `distinct yvec`
  have "distinct(xvec@x#yvec)"
    by(auto simp add: fresh_star_def)
  moreover note `distinct(bn \<alpha>)`
  moreover from `xvec \<sharp>* M` `x \<sharp> M` `yvec \<sharp>* M` have "(xvec@x#yvec) \<sharp>* M" by auto
  hence "(xvec@x#yvec) \<sharp>* (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> P')" by auto
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` have "bn \<alpha> \<sharp>* (\<alpha> \<prec> P'')" by simp
  ultimately obtain p where S: "(set p) \<subseteq> (set(xvec@x#yvec)) \<times> (set(p \<bullet> (xvec@x#yvec)))" and "distinctPerm p"
             and \<alpha>eq: "\<alpha> = (p \<bullet> M)\<lparr>\<nu>*(p \<bullet> (xvec@x#yvec))\<rparr>\<langle>(p \<bullet> N)\<rangle>" and P'eq: "P'' = (p \<bullet> P')"
             and A: "(xvec@x#yvec) \<sharp>* ((p \<bullet> M)\<lparr>\<nu>*(p \<bullet> (xvec@x#yvec))\<rparr>\<langle>(p \<bullet> N)\<rangle>)"
             and B: "(p \<bullet> (xvec@x#yvec)) \<sharp>* (M\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle>)"
             and C: "(p \<bullet> (xvec@x#yvec)) \<sharp>* P'"
    by(rule_tac residualEq) (assumption | simp)+

  note `\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'` `x \<in> (supp N)`

  moreover {
    fix C
    from `xvec \<sharp>* M` `yvec \<sharp>* M` have "(xvec@yvec) \<sharp>* M" by simp
    moreover from `distinct xvec` `distinct yvec` `xvec \<sharp>* yvec` have "distinct(xvec@yvec)"
      by auto
    ultimately have "Prop C \<Psi>' \<Psi> P (M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle>) P' A\<^isub>P \<Psi>\<^isub>P" using `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* N`
      by(rule_tac cOpen) auto
  }
  moreover obtain y::name where "y \<sharp> \<Psi>" and "y \<sharp> \<Psi>'" and "y \<noteq> x" and "y \<sharp> P" and "y \<sharp> xvec" and "y \<sharp> yvec" and "y \<sharp> \<alpha>" and "y \<sharp> P'" and "y \<sharp> A\<^isub>P" and "y \<sharp> \<Psi>\<^isub>P" and "y \<sharp> M" and "y \<sharp> N" and "y \<sharp> C" and "y \<sharp> p"
    by(generate_fresh "name") auto
  moreover note `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> M` `x \<sharp> xvec` `x \<sharp> yvec` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` `xvec \<sharp>* M`
                 `yvec \<sharp>* \<Psi>` `yvec \<sharp>* P` `yvec \<sharp>* M` `yvec \<sharp>* C` `x \<sharp> C` `xvec \<sharp>* C` `distinct xvec` `distinct yvec`
                 `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `x \<sharp> A\<^isub>P` `xvec \<sharp>* yvec` `xvec \<sharp>* \<Psi>\<^isub>P`
                 `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* C` `A\<^isub>P \<sharp>* \<Psi>'`  `xvec \<sharp>* \<Psi>'` `yvec \<sharp>* \<Psi>'` `yvec \<sharp>* \<Psi>\<^isub>P`
  ultimately have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (M\<lparr>\<nu>*(xvec@y#yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>) ([(x, y)] \<bullet> P') (x#A\<^isub>P) \<Psi>\<^isub>P"
    by(rule_tac rOpen)
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> M) = [(x, y)] \<bullet> p \<bullet> M"
    by(subst perm_compose[symmetric]) simp
  with `y \<sharp> M` `x \<sharp> \<alpha>` \<alpha>eq `y \<sharp> p` `x \<sharp> M` have D: "(([(x, y)] \<bullet> p) \<bullet> M) = p \<bullet> M"
    by(auto simp add: eqvts freshChainSimps)
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> xvec) = [(x, y)] \<bullet> p \<bullet> xvec"
    by(subst perm_compose[symmetric]) simp
  with `y \<sharp> xvec` `x \<sharp> \<alpha>` \<alpha>eq `y \<sharp> p` `x \<sharp> xvec` have E: "(([(x, y)] \<bullet> p) \<bullet> xvec) = p \<bullet> xvec"
    by(auto simp add: eqvts freshChainSimps)
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> yvec) = [(x, y)] \<bullet> p \<bullet> yvec"
    by(subst perm_compose[symmetric]) simp
  with `y \<sharp> yvec` `x \<sharp> \<alpha>` \<alpha>eq `y \<sharp> p` `x \<sharp> yvec` have F: "(([(x, y)] \<bullet> p) \<bullet> yvec) = p \<bullet> yvec"
    by(auto simp add: eqvts freshChainSimps)
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> x) = [(x, y)] \<bullet> p \<bullet> x"
    by(subst perm_compose[symmetric]) simp
  with `y \<noteq> x` `y \<sharp> p` have G: "(([(x, y)] \<bullet> p) \<bullet> y) = p \<bullet> x"
    apply(simp add: freshChainSimps calc_atm)
    apply(subgoal_tac "y \<noteq> p \<bullet> x")
    apply(clarsimp)
    using A \<alpha>eq
    apply(simp add: eqvts)
    apply(subst fresh_atm[symmetric])
    apply(simp only: freshChainSimps)
    by simp
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> N) = [(x, y)] \<bullet> p \<bullet> N"
    by(subst perm_compose[symmetric]) simp
  with `y \<sharp> N` `x \<sharp> \<alpha>` `y \<sharp> p` \<alpha>eq have H: "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> N) = p \<bullet> N"
    by(auto simp add: eqvts freshChainSimps)
  moreover have "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> P') = [(x, y)] \<bullet> p \<bullet> P'"
    by(subst perm_compose[symmetric]) simp
  with `y \<sharp> P'` `x \<sharp> P''` `y \<sharp> p` P'eq have I: "(([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> P') = p \<bullet> P'"
    by(auto simp add: eqvts freshChainSimps)
  from `y \<sharp> p` `y \<noteq> x` have "y \<noteq> p \<bullet> x"
    apply(subst fresh_atm[symmetric])
    apply(simp only: freshChainSimps)
    by simp
  moreover from S have "([(x, y)] \<bullet> set p) \<subseteq> [(x, y)] \<bullet> (set(xvec@x#yvec) \<times> set(p \<bullet> (xvec@x#yvec)))"
    by(simp)
  with `y \<noteq> p \<bullet> x` `(([(x, y)] \<bullet> p) \<bullet> y) = p \<bullet> x` `x \<sharp> xvec` `y \<sharp> xvec` `x \<sharp> yvec` `y \<sharp> yvec` `y \<sharp> p` `x \<sharp> \<alpha>` \<alpha>eq have 
    "set([(x, y)] \<bullet> p) \<subseteq> set(xvec@y#yvec) \<times> set(([(x, y)] \<bullet> p) \<bullet> (xvec@y#yvec))"
    by(simp add: eqvts calc_atm perm_compose)
  moreover note `xvec \<sharp>* \<Psi>` `yvec \<sharp>* \<Psi>` `xvec \<sharp>* P` `yvec \<sharp>* P` `xvec \<sharp>* M` `yvec \<sharp>* M` 
                `yvec \<sharp>* C`  S `distinctPerm p` `x \<sharp> C` `xvec \<sharp>* C` `xvec \<sharp>* \<Psi>\<^isub>P` `yvec \<sharp>* \<Psi>\<^isub>P` `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'`
                `A\<^isub>P \<sharp>* xvec` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* M` `x \<sharp> xvec` `x \<sharp> yvec` `x \<sharp> M` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* N`
                 A B C  \<alpha>eq `A\<^isub>P \<sharp>* \<alpha>` `y \<sharp> \<Psi>` `y \<sharp> \<Psi>'` `y \<noteq> x` `y \<sharp> P` `y \<sharp> M` `y \<sharp> \<Psi>\<^isub>P` `y \<sharp> C` `xvec \<sharp>* \<alpha>` `x \<sharp> \<alpha>` `yvec \<sharp>* \<alpha>` `y \<sharp> \<alpha>` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>` `y \<sharp> A\<^isub>P` `y \<sharp> N` `A\<^isub>P \<sharp>* P'` `y \<sharp> P'` `A\<^isub>P \<sharp>* C` P'eq `A\<^isub>P \<sharp>* \<Psi>'`  `xvec \<sharp>* \<Psi>'` `yvec \<sharp>* \<Psi>'`
  ultimately have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (([(x, y)] \<bullet> p) \<bullet> (M\<lparr>\<nu>*(xvec@y#yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>)) (([(x, y)] \<bullet> p) \<bullet> [(x, y)] \<bullet> P') (x#A\<^isub>P) \<Psi>\<^isub>P"
    apply(rule_tac \<alpha>="M\<lparr>\<nu>*(xvec@y#yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>" in rAlpha)
    apply(assumption | simp)+
    apply(simp add: eqvts)
    apply(assumption | simp add: abs_fresh)+
    apply(simp add: fresh_left calc_atm)
    apply(assumption | simp)+
    apply(simp add: fresh_left calc_atm)
    apply(assumption | simp)+
    by(simp add: eqvts fresh_left)+
  with \<alpha>eq P'eq D E F G H I show ?case
    by(simp add: eqvts)
next
 case(cScope \<Psi> P \<alpha> P' x A\<^isub>P \<Psi>\<^isub>P C \<alpha>' P'')
  note `\<alpha> \<prec> (\<lparr>\<nu>x\<rparr>P') = \<alpha>' \<prec> P''`
  moreover from `bn \<alpha> \<sharp>* \<alpha>'` have "bn \<alpha> \<sharp>* (bn \<alpha>')" by auto
  moreover note `distinct (bn \<alpha>)` `distinct(bn \<alpha>')`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha>' \<sharp>* subject \<alpha>'`
  have "bn \<alpha> \<sharp>* (\<alpha> \<prec> \<lparr>\<nu>x\<rparr>P')" and "bn \<alpha>' \<sharp>* (\<alpha>' \<prec> P'')" by simp+
  ultimately obtain p where S: "(set p) \<subseteq> (set(bn \<alpha>)) \<times> (set(bn(p \<bullet> \<alpha>)))" and "distinctPerm p"
                        and \<alpha>Eq: "\<alpha>' = p \<bullet> \<alpha>" and P'eq: "P'' = p \<bullet> (\<lparr>\<nu>x\<rparr>P')" and "(bn(p \<bullet> \<alpha>)) \<sharp>* \<alpha>"
                        and "(bn(p \<bullet> \<alpha>)) \<sharp>* (\<lparr>\<nu>x\<rparr>P')"
    by(rule residualEq)
    
  note `\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
  have "\<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P" by(rule_tac cScope) auto

  moreover note `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `x \<sharp> \<alpha>` `bn \<alpha> \<sharp>* \<Psi>`  `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P`
                `x \<sharp> C` `bn \<alpha> \<sharp>* C` `distinct(bn \<alpha>)` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>`
                `distinct A\<^isub>P` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* C`
  ultimately have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) \<alpha> (\<lparr>\<nu>x\<rparr>P') (x#A\<^isub>P) \<Psi>\<^isub>P"
    by(rule_tac rScope) 
  with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* P` `x \<sharp> \<alpha>` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C` `bn \<alpha> \<sharp>* (bn \<alpha>')` S `distinctPerm p` `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn(p \<bullet> \<alpha>) \<sharp>* (\<lparr>\<nu>x\<rparr>P')` `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* \<alpha>'` \<alpha>Eq `x \<sharp> \<alpha>'` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* \<alpha>'` `x \<sharp> \<Psi>` `x \<sharp> \<Psi>'` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* P'` `x \<sharp> C` `A\<^isub>P \<sharp>* C`
  have "Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) (p \<bullet> \<alpha>) (p \<bullet> (\<lparr>\<nu>x\<rparr>P'))  (x#A\<^isub>P) \<Psi>\<^isub>P"
    by(rule_tac rAlpha) (auto simp add: abs_fresh)
  with \<alpha>Eq P'eq `distinctPerm p` show ?case by simp
next
  case(cBang \<Psi> P A\<^isub>P \<Psi>\<^isub>P C \<alpha> P')
  thus ?case by(rule_tac rBang) auto 
next
  case(cInv \<Psi> M P \<alpha> P' A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S C \<alpha>' P'')
  note `\<alpha> \<prec> P' = \<alpha>' \<prec> P''`
  moreover from `bn \<alpha> \<sharp>* \<alpha>'` have "bn \<alpha> \<sharp>* (bn \<alpha>')" by auto
  moreover note `distinct (bn \<alpha>)` `distinct(bn \<alpha>')`
  moreover from `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha>' \<sharp>* subject \<alpha>'`
  have "bn \<alpha> \<sharp>* (\<alpha> \<prec> P')" and "bn \<alpha>' \<sharp>* (\<alpha>' \<prec> P'')" by simp+
  ultimately obtain p where S: "(set p) \<subseteq> (set(bn \<alpha>)) \<times> (set(bn(p \<bullet> \<alpha>)))" and "distinctPerm p"
                        and \<alpha>Eq: "\<alpha>' = p \<bullet> \<alpha>" and P'eq: "P'' = p \<bullet> P'" and "(bn(p \<bullet> \<alpha>)) \<sharp>* \<alpha>"
                        and "(bn(p \<bullet> \<alpha>)) \<sharp>* P'"
    by(rule residualEq)
  from `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
  have "\<And>C. Prop C \<Psi>' \<Psi> P \<alpha> P' A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S"
    by(rule_tac cInv) auto
  moreover note `\<Psi>' \<otimes> \<Psi> \<turnstile> M \<Leftarrow> P` `\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'`
    `guarded P` `supp P \<subseteq> supp M` `distinct (bn \<alpha>)`
    `extractFrame P = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>` `distinct A\<^isub>P\<^isub>S`
    `A\<^isub>P\<^isub>S \<sharp>* P` `A\<^isub>P\<^isub>S \<sharp>* \<Psi>` `A\<^isub>P\<^isub>S \<sharp>* \<Psi>'` `A\<^isub>P\<^isub>S \<sharp>* \<alpha>` `A\<^isub>P\<^isub>S \<sharp>* P'` `A\<^isub>P\<^isub>S \<sharp>* C`
    `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* M`
    `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C` `A\<^isub>P\<^isub>S \<sharp>* M`
  ultimately have nonalpha: "Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) \<alpha> P' [] (\<one>)"
    by(rule_tac rInv)
  with `bn \<alpha> \<sharp>* \<Psi>`  `bn \<alpha> \<sharp>* \<Psi>'``bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* C`
    `bn \<alpha> \<sharp>* (bn \<alpha>')` S `distinctPerm p` `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn(p \<bullet> \<alpha>) \<sharp>* P'` \<alpha>Eq `bn \<alpha> \<sharp>* \<alpha>'`
    `bn \<alpha> \<sharp>* M`
  have "Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) (p \<bullet> \<alpha>) (p \<bullet> P') [] (\<one>)"
    by(rule_tac rAlpha) auto
  with \<alpha>Eq P'eq `distinctPerm p`
  show ?case by simp
qed

lemma chanEqNotClause[intro]:
  fixes M::'a
   and  K::'a
  assumes "clauseDom(M \<leftrightarrow> K)"
  shows False
proof -
  {
    fix \<phi>::'c
    assume "clauseDom \<phi>"
      and  "\<phi> = M \<leftrightarrow> K"
    hence "False"
    proof(induct rule: clauseDom.inducts)
      fix N P
      assume "N \<Leftarrow> P = M \<leftrightarrow> K"
      thus False using DisjointCCl[where M=M and N=K and L=N and P=P]
        by auto
    qed
  }
  thus ?thesis using assms
    by auto
qed

lemma SstatEq:
  assumes "(\<Psi>,P,Q) \<in> \<S>"
  and "\<Psi> \<simeq> \<Psi>'"
  shows "(\<Psi>',P,Q) \<in> \<S>"
proof -
  from assms obtain P' Q' A\<^isub>R \<Psi>\<^isub>R R where "P = P'\<parallel>R" "Q = Q'\<parallel>R" "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* P'" "A\<^isub>R \<sharp>* Q'" "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'"
    unfolding \<S>_def
    by blast
  obtain A\<^isub>R' \<Psi>\<^isub>R' where "extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>" and "distinct A\<^isub>R'" and "A\<^isub>R' \<sharp>* \<Psi>" and "A\<^isub>R' \<sharp>* R" and "A\<^isub>R' \<sharp>* P" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* A\<^isub>R" and "A\<^isub>R' \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>R' \<sharp>* P'" and "A\<^isub>R' \<sharp>* Q'" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* \<Psi>'"
    by(rule_tac freshFrame[where C="(\<Psi>,\<Psi>',R,P,Q,\<Psi>\<^isub>R,A\<^isub>R,P',Q',Q)"]) auto
  have "\<Psi> \<otimes> \<Psi>\<^isub>R' \<rhd> P' \<sim>\<^sub>H Q'"
  proof -
    from `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` have "\<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle> = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
      by simp
    with `A\<^isub>R' \<sharp>* A\<^isub>R`
    obtain p::"name prm" where "(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)" and "distinctPerm p" and "\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'"
      by(rule_tac frameChainEq) (assumption|simp)+
    from `\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'` show ?thesis unfolding `\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'` using `(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P'` `A\<^isub>R \<sharp>* Q'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* P'` `A\<^isub>R' \<sharp>* Q'`
      by(drule_tac p=p in hobisimClosed) (simp add: eqvts)
  qed
  hence "\<Psi>' \<otimes> \<Psi>\<^isub>R' \<rhd> P' \<sim>\<^sub>H Q'" using `\<Psi> \<simeq> \<Psi>'`
    by(blast intro: hostatEqBisim Composition)
  hence "(\<Psi>',P'\<parallel>R,Q'\<parallel>R) \<in> \<S>"
    unfolding \<S>_def
    using `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `A\<^isub>R' \<sharp>* \<Psi>'` `A\<^isub>R' \<sharp>* P'` `A\<^isub>R' \<sharp>* Q'`
    by blast
  thus ?thesis
    unfolding `P = P'\<parallel>R` `Q = Q'\<parallel>R`
    by -
qed

  
lemma TURS'statEq:
  assumes "(A,\<Psi>,P,Q) \<in> TUR' \<S>"
  and "\<Psi> \<simeq> \<Psi>'"
  shows "(A,\<Psi>',P,Q) \<in> TUR' \<S>"
using assms
unfolding TUR'_def
proof(induct rule: fresh_rel_trancl_induct)
  case(prop_transitive A \<Psi> P Q R)
  thus ?case
    by(blast intro: fresh_rel_trancl_transitive)
next
  case(r_into_fresh_rel_trancl \<Psi> P Q A)
  from `(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>} \<union> hobisim`
  have "(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>} \<or> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
    by blast
  thus ?case
  proof(rule disjE)
    assume "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
    hence "\<Psi>' \<rhd> P \<sim>\<^sub>H Q" using `\<Psi> \<simeq> \<Psi>'`
      by(rule hostatEqBisim)
    thus ?thesis using `A \<sharp>* P` `A \<sharp>* Q`
      by blast
  next
    assume "(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}"
    then obtain xvec P' Q' where "P = \<lparr>\<nu>*xvec\<rparr>P'" "Q = \<lparr>\<nu>*xvec\<rparr>Q'" "xvec \<sharp>* \<Psi>" "(\<Psi>,P',Q') \<in> \<S>"
      by blast
    obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "distinctPerm p" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* \<Psi>'" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* P'" and "(p\<bullet>xvec) \<sharp>* Q'"
      by(rule name_list_avoiding[where c="(xvec,\<Psi>',\<Psi>,P,Q,P',Q')"]) auto
    hence "(\<Psi>,p\<bullet>P',p\<bullet>Q') \<in> \<S>" using `(\<Psi>,P',Q') \<in> \<S>` `xvec \<sharp>* \<Psi>`
      by(drule_tac eqvtI[where p=p, OF Seqvt]) (simp add: eqvts)
    hence "(\<Psi>',p\<bullet>P',p\<bullet>Q') \<in> \<S>" using `\<Psi> \<simeq> \<Psi>'`
      by(rule SstatEq)
    have 1: "\<lparr>\<nu>*xvec\<rparr>P' = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P')" using `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* xvec` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
      by(subst resChainAlpha[where p=p]) (auto simp add: eqvts)     
    have 2: "\<lparr>\<nu>*xvec\<rparr>Q' = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q')" using `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* xvec` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
      by(subst resChainAlpha[where p=p]) (auto simp add: eqvts)
    have "(\<Psi>',\<lparr>\<nu>*xvec\<rparr>P',\<lparr>\<nu>*xvec\<rparr>Q') \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}" using `(p\<bullet>xvec) \<sharp>* \<Psi>'` `(\<Psi>',p\<bullet>P',p\<bullet>Q') \<in> \<S>`
      unfolding 1 2
      by blast
    thus ?thesis unfolding `P = \<lparr>\<nu>*xvec\<rparr>P'`[symmetric] `Q = \<lparr>\<nu>*xvec\<rparr>Q'`[symmetric] using `A \<sharp>* P` `A \<sharp>* Q`
      by blast
  qed
qed

lemma freeFreshDerivative':
  fixes \<Psi>  :: 'b
  and   P  :: "('a, 'b, 'c) psi"
  and   \<alpha>  :: "'a action"
  and   P' :: "('a, 'b, 'c) psi"
  and   x  :: name

  assumes "\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"
  and     "x \<sharp> bn \<alpha>"
  and     "x \<sharp> object \<alpha>"
  and     "x \<sharp> P"

  shows   "x \<sharp> P'"
using assms
by(rule_tac actionCases[where \<alpha>=\<alpha>])
  (auto intro: inputFreshDerivative tauFreshDerivative outputFreshDerivative)

lemma freeFreshChainDerivative':
  fixes \<Psi>     :: 'b
  and   P     :: "('a, 'b, 'c) psi"
  and   \<alpha>     :: "'a action"
  and   P'    :: "('a, 'b, 'c) psi"
  and   xvec  :: "name list"

  assumes "\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"
  and     "xvec \<sharp>* P" 
  and     "xvec \<sharp>* bn \<alpha>"
  and     "xvec \<sharp>* object \<alpha>"

  shows   "xvec \<sharp>* P'"
using assms
by(auto intro: freeFreshDerivative' simp add: fresh_star_def)
      
lemma transferHONonTauFrame:
  fixes \<Psi>\<^isub>F  :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   \<alpha>    :: "'a action"
  and   P'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>F   :: "name list"
  and   A\<^isub>G   :: "name list"
  and   \<Psi>\<^isub>G   :: 'b

  assumes "\<Psi>\<^isub>F\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"
  and     "extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>"
  and     "extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>"
  and     "\<Psi>\<otimes>\<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
  and     "A\<^isub>F \<sharp>* P"
  and     "A\<^isub>F \<sharp>* \<Psi>"
  and     "A\<^isub>G \<sharp>* P"
  and     "A\<^isub>G \<sharp>* \<Psi>"
  and     "A\<^isub>F \<sharp>* \<alpha>"
  and     "A\<^isub>G \<sharp>* \<alpha>"
  and     "A\<^isub>P \<sharp>* A\<^isub>F"
  and     "A\<^isub>P \<sharp>* A\<^isub>G"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>F"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>G"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* S"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* P'"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* \<alpha>"
  and     "B \<sharp>* S"
  and     "B \<sharp>* P"
  and     "B \<sharp>* P'"
  and     "B \<sharp>* R"
  and     "B \<sharp>* object \<alpha>"
  and     "B \<sharp>* A\<^isub>P"
  and     "bn \<alpha> \<sharp>* P"
  and     "bn \<alpha> \<sharp>* R"
  and     "bn \<alpha> \<sharp>* S"
  and     "bn \<alpha> \<sharp>* \<Psi>"
  and     "bn \<alpha> \<sharp>* B"
  and     "\<alpha> \<noteq> \<tau>"

  shows "\<exists> P''. \<Psi>\<^isub>G\<otimes>\<Psi>  \<rhd> P \<longmapsto>\<alpha> \<prec> P'' \<and> (B,\<Psi>,S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>"
using assms `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
proof(nominal_induct \<Psi>\<^isub>F \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P avoiding: \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B rule: semanticsFramePsiInduct')
  case(cFrameAlpha \<Psi> P A\<^isub>P \<Psi>\<^isub>P p \<alpha> P' \<Psi>\<^isub>G A\<^isub>F A\<^isub>G)
  from `\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>P) \<rhd> R \<sim>\<^sub>H S`
  have "(p\<bullet>(\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>P))) \<rhd> (p\<bullet>R) \<sim>\<^sub>H (p\<bullet>S)"
    by(rule hobisimClosed)
  with `A\<^isub>P \<sharp>* \<Psi>` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* R` `(p \<bullet> A\<^isub>P) \<sharp>* R` `A\<^isub>P \<sharp>* S` `(p \<bullet> A\<^isub>P) \<sharp>* S`
    `distinctPerm p` `set p \<subseteq> set A\<^isub>P \<times> set (p \<bullet> A\<^isub>P)` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
    by(simp add: eqvts)
  hence "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using cFrameAlpha
    by force
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "A\<^isub>P \<sharp>* P''" "(p\<bullet>A\<^isub>P) \<sharp>* P''" using `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>\<^isub>G` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<alpha>` `(p\<bullet>A\<^isub>P) \<sharp>* P` `(p\<bullet>A\<^isub>P) \<sharp>* \<Psi>\<^isub>G` `(p\<bullet>A\<^isub>P) \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>P) \<sharp>* \<alpha>` `bn \<alpha> \<sharp>* subject \<alpha>`
    by(auto intro: freeFreshChainDerivative boundOutputDistinct)
  hence "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `distinctPerm p` `set p \<subseteq> set A\<^isub>P \<times> set (p \<bullet> A\<^isub>P)` `A\<^isub>P \<sharp>* \<Psi>` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* R` `(p \<bullet> A\<^isub>P) \<sharp>* R` `A\<^isub>P \<sharp>* S` `(p \<bullet> A\<^isub>P) \<sharp>* S` `A\<^isub>P \<sharp>* P'` `(p \<bullet> A\<^isub>P) \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G` `(p \<bullet> A\<^isub>P) \<sharp>* A\<^isub>G` `A\<^isub>P \<sharp>* B` `B \<sharp>* (p \<bullet> A\<^isub>P)`
    by(drule_tac eqvtI[where p=p,OF TUReqvt(2),OF Seqvt]) (simp add: eqvts)
  thus ?case using `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''`
    by blast
next
  case(cAlpha \<Psi> P \<alpha> P' p A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `bn \<alpha> \<sharp>* B` `bn (p \<bullet> \<alpha>) \<sharp>* B` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>B) = B"
    by(simp add: fresh_star_bij)
  with `B \<sharp>* (p \<bullet> P')` have "B \<sharp>* P'"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>F \<sharp>* (p \<bullet> \<alpha>)` `bn \<alpha> \<sharp>* A\<^isub>F` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>F) = A\<^isub>F"
    by(simp add: fresh_star_bij)
  with `A\<^isub>F \<sharp>* (p\<bullet>\<alpha>)` have "A\<^isub>F \<sharp>* \<alpha>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>G \<sharp>* (p \<bullet> \<alpha>)` `bn \<alpha> \<sharp>* A\<^isub>G` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>G) = A\<^isub>G"
    by(simp add: fresh_star_bij)
  with `A\<^isub>G \<sharp>* (p\<bullet>\<alpha>)` have "A\<^isub>G \<sharp>* \<alpha>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* (p \<bullet> \<alpha>)` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>P) = A\<^isub>P"
    by simp
  have "B \<sharp>* object \<alpha>" using `B \<sharp>* object(p\<bullet>\<alpha>)` `(p\<bullet>B)=B`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `(p\<bullet>\<alpha>) \<noteq> \<tau>` have "\<alpha> \<noteq> \<tau>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "subject(p\<bullet>\<alpha>) = subject(\<alpha>)" using `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* (p\<bullet>\<alpha>)` `bn(p\<bullet>\<alpha>) \<sharp>* subject(p\<bullet>\<alpha>)`
    apply simp
    apply(subst perm_bool[where pi=p,symmetric])
    unfolding eqvts
    apply(subst subjectEqvt[symmetric])
    by simp
  have "distinct (bn \<alpha>)" using `distinct(bn(p\<bullet>\<alpha>))`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cAlpha) fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "bn(p\<bullet>\<alpha>) \<sharp>* P''" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` `bn(p\<bullet>\<alpha>) \<sharp>* P` `bn(p\<bullet>\<alpha>) \<sharp>* \<alpha>`
    by(rule_tac freeFreshChainDerivative)
  have "bn(p\<bullet>\<alpha>) \<sharp>* object \<alpha>" using `bn(p\<bullet>\<alpha>) \<sharp>* \<alpha>` by simp
  have "bn(p\<bullet>\<alpha>) \<sharp>* subject \<alpha>" using `bn(p\<bullet>\<alpha>) \<sharp>* subject(p\<bullet>\<alpha>)` unfolding `subject(p\<bullet>\<alpha>) = subject(\<alpha>)` by -
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> (p\<bullet>\<alpha>) \<prec> (p\<bullet>P'')"
    by(subst residualAlpha[symmetric]) fact+
  moreover have "(B, \<Psi>, S \<parallel> (p\<bullet>P''), R \<parallel> (p \<bullet> P')) \<in> TUR' \<S>"
    using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `(p\<bullet>B)=B` `(p\<bullet>A\<^isub>P) = A\<^isub>P` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` `bn \<alpha> \<sharp>* R` `bn(p\<bullet>\<alpha>) \<sharp>* R` `bn \<alpha> \<sharp>* S` `bn(p\<bullet>\<alpha>) \<sharp>* S` `bn \<alpha> \<sharp>* \<Psi>` `bn(p\<bullet>\<alpha>) \<sharp>* \<Psi>`
    by(drule_tac eqvtI[where p=p, OF TUReqvt(2), OF Seqvt]) (simp add: eqvts)
  ultimately show ?case by blast
next
  case(cInput \<Psi> M K xvec N Tvec P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G)
  from cInput have "A\<^isub>F \<sharp>* K" and "A\<^isub>G \<sharp>* K" by(auto simp add: residualInject)

  from `A\<^isub>F \<sharp>* (M\<lparr>\<lambda>*xvec N\<rparr>.P)` `A\<^isub>G \<sharp>* (M\<lparr>\<lambda>*xvec N\<rparr>.P)` have "A\<^isub>F \<sharp>* M" and "A\<^isub>G \<sharp>* M" by simp+
  from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(metis hostatEqBisim Identity)
  moreover from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K` `A\<^isub>F \<sharp>* M` `A\<^isub>F \<sharp>* K` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F M \<leftrightarrow> K"
    unfolding `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`   
    by(auto intro: Commutativity statEqEnt frameImpI)
  moreover have "\<not> clauseDom(M \<leftrightarrow> K)"
    by auto
  ultimately have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<leftrightarrow> K"
    by(blast dest: hobisimE)
  with `A\<^isub>G \<sharp>* M` `A\<^isub>G \<sharp>* K` `A\<^isub>G \<sharp>* \<Psi>`
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K"
    unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
    by(auto intro: Commutativity statEqEnt frameImpE)
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> M\<lparr>\<lambda>*xvec N\<rparr>.P \<longmapsto> K\<lparr>N[xvec::=Tvec]\<rparr> \<prec> P[xvec::=Tvec]" using `distinct xvec` `set xvec \<subseteq> supp N` `length xvec = length Tvec`
    by(rule Input)
  moreover have "(B, \<Psi>, S \<parallel> P[xvec::=Tvec], R \<parallel> P[xvec::=Tvec]) \<in> TUR' \<S>"
  proof -
    obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame(P[xvec::=Tvec]) = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* S" and "A\<^isub>P \<sharp>* R" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* B" and "A\<^isub>P \<sharp>* xvec" and "A\<^isub>P \<sharp>* Tvec"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,P,B,xvec,Tvec)"]) auto
    hence "(B@A\<^isub>P, \<Psi>\<otimes>\<Psi>\<^isub>P, S, R) \<in> TUR' \<S>" using `\<Psi> \<rhd> R \<sim>\<^sub>H S` `B \<sharp>* S` `B \<sharp>* R`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      by(auto intro: hobisimE)
    hence "(B@A\<^isub>P, \<Psi>, S \<parallel> P[xvec::=Tvec], R \<parallel> P[xvec::=Tvec]) \<in> TUR' \<S>" using `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* Tvec` `extractFrame(P[xvec::=Tvec]) = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<Psi>` `B \<sharp>* P[xvec::=Tvec]` `distinct A\<^isub>P`
      by(rule_tac TURS'parPres') auto
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by auto
next
  case(cOutput \<Psi> M K N P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  from cOutput have "A\<^isub>F \<sharp>* K" and "A\<^isub>G \<sharp>* K" by(auto simp add: residualInject)
  from `A\<^isub>F \<sharp>* M\<langle>N\<rangle>.P` `A\<^isub>G \<sharp>* M\<langle>N\<rangle>.P` have "A\<^isub>F \<sharp>* M" "A\<^isub>F \<sharp>* N" "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* M" "A\<^isub>G \<sharp>* N" "A\<^isub>G \<sharp>* P"
    by simp+
  from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(metis hostatEqBisim Identity)
  moreover from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K` `A\<^isub>F \<sharp>* M` `A\<^isub>F \<sharp>* K` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F M \<leftrightarrow> K"
    unfolding `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`   
    by(auto intro: Commutativity statEqEnt frameImpI)
  moreover have "\<not> clauseDom(M \<leftrightarrow> K)"
    by auto
  ultimately have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<leftrightarrow> K"
    by(blast dest: hobisimE)
  with `A\<^isub>G \<sharp>* M` `A\<^isub>G \<sharp>* K` `A\<^isub>G \<sharp>* \<Psi>`
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K"
    unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
    by(auto intro: Commutativity statEqEnt frameImpE)
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> M\<langle>N\<rangle>.P \<longmapsto> K\<langle>N\<rangle> \<prec> P"
    by(rule_tac Output)
  moreover have "(B, \<Psi>, S \<parallel> P, R \<parallel> P) \<in> TUR' \<S>"
  proof -
    obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* S" and "A\<^isub>P \<sharp>* R" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* B"
      by(rule_tac freshFrame[where C="(\<Psi>,R,S,P,B)"]) auto
    hence "(B@A\<^isub>P, \<Psi>\<otimes>\<Psi>\<^isub>P, S, R) \<in> TUR' \<S>" using `\<Psi> \<rhd> R \<sim>\<^sub>H S` `B \<sharp>* S` `B \<sharp>* R`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      by(auto intro: hobisimE)
    hence "(B@A\<^isub>P, \<Psi>, S \<parallel> P, R \<parallel> P) \<in> TUR' \<S>"
      by(rule TURS'parPres') (rule refl|fact)+
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by auto
next
  case(cCase \<Psi> P \<alpha> P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  hence "B \<sharp>* A\<^isub>P" by simp
  from `B \<sharp>* (Cases Cs)` `A\<^isub>F \<sharp>* (Cases Cs)` `A\<^isub>G \<sharp>* (Cases Cs)` `bn \<alpha> \<sharp>* (Cases Cs)` `(\<phi>, P) mem Cs`
  have "A\<^isub>F \<sharp>* \<phi>" and "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* \<phi>" and "A\<^isub>G \<sharp>* P" "bn \<alpha> \<sharp>* \<phi>" and "bn \<alpha> \<sharp>* P" "B \<sharp>* \<phi>" and "B \<sharp>* P"
    by(induct Cs) auto
  from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(metis hostatEqBisim Identity)
  moreover from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> \<phi>` `A\<^isub>F \<sharp>* \<phi>` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>"
    unfolding `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`   
    by(auto intro: Commutativity statEqEnt frameImpI)
  moreover note `\<not> clauseDom \<phi>`
  ultimately have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F \<phi>"
    by(blast dest: hobisimE)
  with `A\<^isub>G \<sharp>* \<phi>` `A\<^isub>G \<sharp>* \<Psi>`
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<turnstile> \<phi>"
    unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
    by(auto intro: Commutativity statEqEnt frameImpE)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    apply(rule cCase)
    apply fact
    apply fact
    apply(rule hobisimE)
    by fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Cases Cs \<longmapsto> \<alpha> \<prec> P''"
    by(rule Case) fact+  
  thus ?case using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    unfolding TUR'_def
    by blast
next
  case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  from `A\<^isub>F \<sharp>* (P \<parallel> Q)` `A\<^isub>G \<sharp>* (P \<parallel> Q)` have "A\<^isub>F \<sharp>* P" "A\<^isub>F \<sharp>* Q" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* Q` `A\<^isub>Q \<sharp>* A\<^isub>F` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` have "A\<^isub>F \<sharp>* \<Psi>\<^isub>Q"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>F \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>F \<sharp>* \<Psi>` by blast
  from `A\<^isub>G \<sharp>* Q` `A\<^isub>Q \<sharp>* A\<^isub>G` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` have "A\<^isub>G \<sharp>* \<Psi>\<^isub>Q"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>G \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>G \<sharp>* \<Psi>` by blast
  have "A\<^isub>P \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` by blast
  from `B \<sharp>* (P' \<parallel> Q)` have "B \<sharp>* P'" and "B \<sharp>* Q" by simp+
  from `(A\<^isub>P @ A\<^isub>Q) \<sharp>* (P' \<parallel> Q)` have "A\<^isub>P \<sharp>* P'" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>Q \<sharp>* P'" and "A\<^isub>Q \<sharp>* Q"
    by simp+
  from `B \<sharp>* (A\<^isub>P @ A\<^isub>Q)` have "B \<sharp>* A\<^isub>P" and "B \<sharp>* A\<^isub>Q" by simp+
  have "A\<^isub>Q \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* A\<^isub>Q` by simp
  have "bn \<alpha> \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` by force
  from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` have "(\<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
  from `B \<sharp>* (P\<parallel>Q)` have "B \<sharp>* P"
    by simp
  from `A\<^isub>Q \<sharp>* \<alpha>` have "A\<^isub>Q \<sharp>* object \<alpha>" by simp
  have "bn \<alpha> \<sharp>* (B @ A\<^isub>Q)" using `bn \<alpha> \<sharp>* B` `A\<^isub>Q \<sharp>* \<alpha>`
    by simp
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B@A\<^isub>Q, \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cPar1) (subst freshChainAppend|rule conjI|fact)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P\<parallel>Q \<longmapsto> \<alpha> \<prec> P''\<parallel>Q"
    apply(rule Par1)
    apply(rule statEqTransition)
    apply fact
    apply(rule AssertionStatEqSym[OF Associativity])
    apply fact
    apply fact
    apply(rule freshCompChain)
    by fact+
  moreover have "(B, \<Psi>, S \<parallel> (P''\<parallel>Q), R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>"
  proof -
    from `((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    have "((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence "((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>"
      using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* Q` `B \<sharp>* Q` `A\<^isub>P \<sharp>* Q` `distinct A\<^isub>Q`
      by(rule_tac TURS'parPres') auto
    moreover have "((B@A\<^isub>Q), \<Psi>, S \<parallel> (P'' \<parallel> Q), (S \<parallel> P'') \<parallel> Q) \<in> TUR' \<S>" using `((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "((B@A\<^isub>Q), \<Psi>, (R \<parallel> P') \<parallel> Q, R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>" using `((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimParAssoc)
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately have "((B@A\<^isub>Q), \<Psi>, S \<parallel> (P'' \<parallel> Q), R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by blast
next
  case(cInv \<Psi> M P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  have "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* M" "A\<^isub>F \<sharp>* M" using `supp P \<subseteq> supp M` `A\<^isub>F \<sharp>* \<langle>M\<rangle>`  `A\<^isub>G \<sharp>* \<langle>M\<rangle>`
    by(auto simp add: psi.supp fresh_star_def fresh_def)
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> M\<Leftarrow>P` `A\<^isub>F \<sharp>* M` `A\<^isub>F \<sharp>* P` `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion(extractFrame R) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> P"
    by(auto intro: frameImpI statEqEnt Commutativity)
  moreover have "legalClause M P" unfolding legalClause_def using `guarded P` `supp P \<subseteq> supp M`
    by blast
  moreover from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (rule Identity)
  ultimately obtain Q where "legalClause M Q" and "insertAssertion(extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q" and "P \<sim>\<^sub>H Q"
    by(auto dest: hobisimE)
  
  have "B \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* B`
    by simp
  have "bn \<alpha> \<sharp>* Q" using `bn \<alpha> \<sharp>* M` `legalClause M Q` by simp
  from `B \<sharp>* \<langle>M\<rangle>` `A\<^isub>G \<sharp>* M` `A\<^isub>F \<sharp>* M` have "B \<sharp>* M" and "B \<sharp>* P" and "B \<sharp>* Q" and "A\<^isub>F \<sharp>* Q" and "A\<^isub>G \<sharp>* Q" using `legalClause M P` `legalClause M Q`
    by auto
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule_tac cInv) (fact|rule hobisimE)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "B \<sharp>* P''"
    unfolding TUR'_def
    by(auto dest: fresh_rel_trancl_fresh)
  from `P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
    apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>\<^isub>G\<otimes>\<Psi>"])
    apply(rule hostatEqBisim,assumption)
    by(metis AssertionStatEqTrans Commutativity Identity)
  with `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` obtain Q' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'" and "\<Psi>\<^isub>G\<otimes>\<Psi> \<rhd> Q' \<sim>\<^sub>H P''" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>G` `bn \<alpha> \<sharp>* Q`
    apply(drule_tac hobisimE(5))
    apply(drule_tac hobisimE(3))
    by(drule simE) auto
  hence "\<Psi>\<otimes>\<Psi>\<^isub>G \<rhd> Q' \<sim>\<^sub>H P''"
    by(blast intro: hostatEqBisim Commutativity)
  have "A\<^isub>P \<sharp>* Q" using `A\<^isub>P \<sharp>* M` `legalClause M Q`
    by simp
  from `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>P \<sharp>* P''" "A\<^isub>P \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `A\<^isub>F \<sharp>* P` `A\<^isub>F \<sharp>* Q` `A\<^isub>F \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>F \<sharp>* P''" "A\<^isub>F \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `A\<^isub>G \<sharp>* P` `A\<^isub>G \<sharp>* Q` `A\<^isub>G \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>G \<sharp>* P''" "A\<^isub>G \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `B \<sharp>* P` `B \<sharp>* Q` `B \<sharp>* object \<alpha>` `bn \<alpha> \<sharp>* B` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "B \<sharp>* P''" "B \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative')+
  have "(\<Psi>,Q'\<parallel>S,P''\<parallel>S) \<in> \<S>" unfolding \<S>_def using `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* Q'` `A\<^isub>G \<sharp>* P''` `\<Psi>\<otimes>\<Psi>\<^isub>G \<rhd> Q' \<sim>\<^sub>H P''`
    by blast
  hence "(B,\<Psi>,Q'\<parallel>S,P''\<parallel>S) \<in> TUR' \<S>" using `B \<sharp>* Q'` `B \<sharp>* P''` `B \<sharp>* S` `A\<^isub>P \<sharp>* S` `A\<^isub>P \<sharp>* P''` `A\<^isub>P \<sharp>* Q'`
    unfolding TUR'_def
    by(rule_tac r_into_fresh_rel_trancl) (auto simp add: exI[where x="[]"])
  hence "(B,\<Psi>,S\<parallel>Q',S\<parallel>P'') \<in> TUR' \<S>"
    unfolding TUR'_def
    apply(rule_tac fresh_rel_trancl_transitive)
    apply(rule r_into_fresh_rel_trancl)
    apply(rule UnI2)
    apply(rule hobisimBisim[OF bisimParComm])
    apply(force dest: fresh_rel_trancl_fresh)
    apply(force dest: fresh_rel_trancl_fresh)
    apply(rule_tac fresh_rel_trancl_transitive)
    apply assumption
    apply(rule r_into_fresh_rel_trancl)
    apply(rule UnI2)
    apply(rule hobisimBisim[OF bisimParComm])
    by(force dest: fresh_rel_trancl_fresh)+
  with `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
  have "(B, \<Psi>, S \<parallel> Q', R \<parallel> P') \<in> TUR' \<S>"
    unfolding TUR'_def
    by(rule_tac fresh_rel_trancl_transitive)
  moreover have "\<Psi>\<^isub>G \<otimes> \<Psi>  \<rhd> \<langle>M\<rangle> \<longmapsto> \<alpha> \<prec> Q'"
  proof -
    have "\<Psi> \<otimes> \<Psi>\<^isub>G \<turnstile> M\<Leftarrow>Q" using `insertAssertion (extractFrame S) \<Psi>  \<turnstile>\<^sub>F M\<Leftarrow>Q`
      unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
      using `A\<^isub>G \<sharp>* M` `A\<^isub>G \<sharp>* Q` `A\<^isub>G \<sharp>* \<Psi>`
      by(auto dest: frameImpE)
    have "supp Q \<subseteq> ((supp M)::name set)" and "guarded Q" using `legalClause M Q`
      unfolding legalClause_def
      by simp+
    show ?thesis
      apply(rule Inv)
      apply(rule statEqEnt)
      apply(rule Commutativity)
      by fact+
  qed
  ultimately show ?case by blast
next
  case(cScope \<Psi> P \<alpha> P' x A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  have "A\<^isub>F \<sharp>* P" using `A\<^isub>F \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> A\<^isub>F`
    by simp
  have "A\<^isub>G \<sharp>* P" using `A\<^isub>G \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> A\<^isub>G`
    by simp
  have "A\<^isub>P \<sharp>* \<Psi>\<^isub>F" using `(x#A\<^isub>P) \<sharp>* \<Psi>\<^isub>F`
    by simp
  have "B \<sharp>* P" using `B \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> B`
    by simp
  have "B \<sharp>* P'" using `B \<sharp>* \<lparr>\<nu>x\<rparr>P'` `x \<sharp> B`
    by simp
  have "B \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* B`
    by simp
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cScope) fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>x\<rparr>P''" using `x \<sharp> \<alpha>` `x \<sharp> \<Psi>\<^isub>G` `x \<sharp> \<Psi>`
    by(rule_tac Scope) auto
  moreover have "(B, \<Psi>, S \<parallel> \<lparr>\<nu>x\<rparr>P'', R \<parallel> \<lparr>\<nu>x\<rparr>P') \<in> TUR' \<S>"
  proof -
    have "(B, \<Psi>, S \<parallel> \<lparr>\<nu>x\<rparr>P'', \<lparr>\<nu>x\<rparr>(S \<parallel> P'')) \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> S` `x \<sharp> B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim[OF bisimSymmetric, OF bisimScopeExt])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>x\<rparr>(S \<parallel> P''), \<lparr>\<nu>x\<rparr>(R \<parallel> P')) \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> \<Psi>`
      by(rule TURS'resPres)
    moreover have "(B, \<Psi>, \<lparr>\<nu>x\<rparr>(R \<parallel> P'),R \<parallel> \<lparr>\<nu>x\<rparr>P') \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> R` `x \<sharp> B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim[OF bisimScopeExt])
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  ultimately show ?case
    by blast
next
  case cComm1
  from `\<tau> \<noteq> \<tau>` show ?case
    by simp
next
  case cComm2
  from `\<tau> \<noteq> \<tau>` show ?case
    by simp
next
  case(cBang \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `A\<^isub>F \<sharp>* !P` `A\<^isub>G \<sharp>* !P` `B \<sharp>* !P` `bn \<alpha> \<sharp>* !P` have "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* P" "B \<sharp>* P" "bn \<alpha> \<sharp>* P"
    by auto
  have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S" using `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S`
    by (metis Identity hobisimE(4) hostatEqBisim)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cBang) (fact|simp)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  thus ?case using `guarded P`
    by(blast intro: Bang)
next
  case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `A\<^isub>F \<sharp>* (P \<parallel> Q)` `A\<^isub>G \<sharp>* (P \<parallel> Q)` have "A\<^isub>F \<sharp>* P" "A\<^isub>F \<sharp>* Q" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>F` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` have "A\<^isub>F \<sharp>* \<Psi>\<^isub>P"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>F \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>F \<sharp>* \<Psi>` by blast
  from `A\<^isub>G \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>G` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` have "A\<^isub>G \<sharp>* \<Psi>\<^isub>P"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>G \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>G \<sharp>* \<Psi>` by blast
  have "A\<^isub>Q \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` by blast
  from `B \<sharp>* (P \<parallel> Q')` have "B \<sharp>* P" and "B \<sharp>* Q'" by simp+
  from `(A\<^isub>P @ A\<^isub>Q) \<sharp>* (P \<parallel> Q')` have "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q'" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q'"
    by simp+
  from `B \<sharp>* (A\<^isub>P @ A\<^isub>Q)` have "B \<sharp>* A\<^isub>P" and "B \<sharp>* A\<^isub>Q" by simp+
  have "A\<^isub>Q \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* A\<^isub>Q` by simp
  have "bn \<alpha> \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` by force
  from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` have "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
  from `B \<sharp>* (P\<parallel>Q)` have "B \<sharp>* Q"
    by simp
  have "A\<^isub>P \<sharp>* object \<alpha>" using `A\<^isub>P \<sharp>* \<alpha>`
    by simp
  have "bn \<alpha> \<sharp>* (B@A\<^isub>P)" using `bn \<alpha> \<sharp>* B` `A\<^isub>P \<sharp>* \<alpha>`
    by simp
  have "\<exists>Q''. \<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'' \<and> (B@A\<^isub>P, \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by(rule cPar2) (subst freshChainAppend|rule conjI|fact)+
  then obtain Q'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> \<alpha> \<prec> Q''" and "((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P\<parallel>Q \<longmapsto> \<alpha> \<prec> P\<parallel>Q''"
    apply(rule Par2)
    apply(rule statEqTransition)
    apply fact
    apply(rule AssertionStatEqSym[OF Associativity])
    apply fact
    apply fact
    apply(rule freshCompChain)
    by fact+
  moreover have "(B, \<Psi>, S \<parallel> (P\<parallel>Q''), R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>"
  proof -
    from `((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>`
    have "((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence "((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>"
      using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* P` `B \<sharp>* P` `A\<^isub>P \<sharp>* P` `distinct A\<^isub>P`
      by(rule_tac TURS'parPres') auto
    moreover have "((B@A\<^isub>P), \<Psi>, S \<parallel> (P \<parallel> Q''), (S \<parallel> Q'') \<parallel> P) \<in> TUR' \<S>" using `((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimParPresSym,OF bisimParComm])
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "((B@A\<^isub>P), \<Psi>, (R \<parallel> Q') \<parallel> P, R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>" using `((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimTransitive[OF bisimParPresSym,OF bisimParComm]])
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately have "((B@A\<^isub>P), \<Psi>, S \<parallel> (P \<parallel> Q''), R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by blast
next
  case(cOpen \<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P y \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  have "A\<^isub>F \<sharp>* (M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle>)" using `A\<^isub>F \<sharp>* (M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>)` `y \<sharp> A\<^isub>F` `x \<sharp> A\<^isub>F`
    apply simp
    apply(subst fresh_star_bij[where pi="[(x,y)]",symmetric])
    apply simp
    done
  have "A\<^isub>G \<sharp>* (M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle>)" using `A\<^isub>G \<sharp>* (M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>)` `y \<sharp> A\<^isub>G` `x \<sharp> A\<^isub>G`
    apply simp
    apply(subst fresh_star_bij[where pi="[(x,y)]",symmetric])
    apply simp
    done
  have "bn(M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle>) \<sharp>* B " "B \<sharp>* object (M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle>)" using `B \<sharp>* object(M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle>)` `y \<sharp> B` `x \<sharp> B` `bn(M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x,y)]\<bullet>N)\<rangle>) \<sharp>* B`
    apply -
    apply simp
    apply simp
    apply(subst fresh_star_bij[where pi="[(x,y)]",symmetric])
    by simp
  have "A\<^isub>P \<sharp>* (M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle>)" using `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* yvec` `A\<^isub>P \<sharp>* N`
    by simp
  have "A\<^isub>F \<sharp>* P" using `x \<sharp> A\<^isub>F` `A\<^isub>F \<sharp>* \<lparr>\<nu>x\<rparr>P` by simp
  have "A\<^isub>G \<sharp>* P" using `x \<sharp> A\<^isub>G` `A\<^isub>G \<sharp>* \<lparr>\<nu>x\<rparr>P` by simp
  have "B \<sharp>* P" using `x \<sharp> B` `B \<sharp>* \<lparr>\<nu>x\<rparr>P` by simp
  from `B \<sharp>* ([(x, y)] \<bullet> P')` `x \<sharp> B` `y \<sharp> B` have "B \<sharp>* P'"
    by(subst fresh_star_bij[where pi="[(x,y)]",symmetric]) simp
  from `A\<^isub>P \<sharp>* B` have "B \<sharp>* A\<^isub>P"
    by simp
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cOpen) (fact|rule conjI|simp)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> M\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<longmapsto> M\<lparr>\<nu>*(xvec @ x # yvec)\<rparr>\<langle>N\<rangle> \<prec> P''"
    by(rule Open) (fact|rule freshComp)+
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<longmapsto> M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x,y)]\<bullet>N)\<rangle> \<prec> ([(x,y)]\<bullet>P'')"
    apply(subst (asm) perm_bool[where pi="[(x,y)]",symmetric])
    apply(subst alphaRes[where y=y, OF `y \<sharp> P`])
    by(simp add: eqvts `x \<sharp> \<Psi>\<^isub>G` `x \<sharp> \<Psi>` `y \<sharp> \<Psi>\<^isub>G` `y \<sharp> \<Psi>` `y \<sharp> xvec` `x \<sharp> xvec` `y \<sharp> yvec` `x \<sharp> yvec` `y \<sharp> M` `x \<sharp> M` calc_atm)
  moreover have "(B, \<Psi>, S \<parallel> ([(x,y)]\<bullet>P''), R \<parallel> ([(x,y)]\<bullet>P')) \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    by(drule_tac eqvtI[where p="[(x,y)]", OF TUReqvt(2), OF Seqvt]) (simp add: eqvts `x \<sharp> B` `y \<sharp> B` `x \<sharp> R` `y \<sharp> R` `x \<sharp> S` `y \<sharp> S` `x \<sharp> \<Psi>` `y \<sharp> \<Psi>`)  
  ultimately show ?case
    by blast
qed

lemma \<S>extend:
  assumes "(\<Psi>,P,Q) \<in> \<S>"
  shows "(\<Psi>\<otimes>\<Psi>',P,Q) \<in> \<S>"
proof -
  from assms
  obtain P' Q' R A\<^isub>R \<Psi>\<^isub>R where "P = P'\<parallel>R" and "Q=Q'\<parallel>R" and "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'" and "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" and "A\<^isub>R \<sharp>* P'" and "A\<^isub>R \<sharp>* Q'" and "A\<^isub>R \<sharp>* \<Psi>"
    unfolding \<S>_def
    by auto
  obtain A\<^isub>R' \<Psi>\<^isub>R' where "extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>" and "distinct A\<^isub>R'" and "A\<^isub>R' \<sharp>* \<Psi>" and "A\<^isub>R' \<sharp>* R" and "A\<^isub>R' \<sharp>* P" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* A\<^isub>R" and "A\<^isub>R' \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>R' \<sharp>* P'" and "A\<^isub>R' \<sharp>* Q'" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* \<Psi>'"
    by(rule_tac freshFrame[where C="(\<Psi>,\<Psi>',R,P,Q,\<Psi>\<^isub>R,A\<^isub>R,P',Q',Q)"]) auto
  have "\<Psi> \<otimes> \<Psi>\<^isub>R' \<rhd> P' \<sim>\<^sub>H Q'"
  proof -
    from `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` have "\<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle> = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
      by simp
    with `A\<^isub>R' \<sharp>* A\<^isub>R`
    obtain p::"name prm" where "(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)" and "distinctPerm p" and "\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'"
      by(rule_tac frameChainEq) (assumption|simp)+
    from `\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'` show ?thesis unfolding `\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'` using `(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P'` `A\<^isub>R \<sharp>* Q'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* P'` `A\<^isub>R' \<sharp>* Q'`
      by(drule_tac p=p in hobisimClosed) (simp add: eqvts)
  qed
  hence "(\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>\<^isub>R' \<rhd> P' \<sim>\<^sub>H Q'"
    apply(drule_tac hobisimE(4)[where \<Psi>'=\<Psi>'])
    apply(rule hostatEqBisim)
    apply assumption
    by(metis AssertionStatEqTrans Associativity associativitySym)
  hence "(\<Psi>\<otimes>\<Psi>',P'\<parallel>R,Q'\<parallel>R) \<in> \<S>"
    unfolding \<S>_def
    using `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `A\<^isub>R' \<sharp>* \<Psi>'` `A\<^isub>R' \<sharp>* P'` `A\<^isub>R' \<sharp>* Q'` `A\<^isub>R' \<sharp>* \<Psi>`
    by(auto simp add: psi.inject)
  thus ?thesis
    unfolding `P = P'\<parallel>R` `Q = Q'\<parallel>R`
    by -
qed

lemma TURS'extend:
  assumes "(A,\<Psi>,P,Q) \<in> TUR' \<S>"
  shows "(A,\<Psi>\<otimes>\<Psi>',P,Q) \<in> TUR' \<S>"
  using assms unfolding TUR'_def
proof(induct rule: fresh_rel_trancl_induct) 
  case prop_transitive
  thus ?case by(blast intro: fresh_rel_trancl_transitive)
next
  case(r_into_fresh_rel_trancl \<Psi> P Q A)
  from `(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>} \<union> hobisim`
  have "(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>} \<or> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
    by blast
  thus ?case
  proof(rule disjE)
    assume "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
    hence "\<Psi>\<otimes>\<Psi>' \<rhd> P \<sim>\<^sub>H Q"
      by(rule hobisimE)
    thus ?thesis using `A \<sharp>* P` `A \<sharp>* Q`
      by blast
  next
    assume "(\<Psi>, P, Q) \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}"
    then obtain xvec P' Q' where "P = \<lparr>\<nu>*xvec\<rparr>P'" "Q = \<lparr>\<nu>*xvec\<rparr>Q'" "xvec \<sharp>* \<Psi>" "(\<Psi>,P',Q') \<in> \<S>"
      by blast
    obtain p::"name prm" where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "distinctPerm p" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* \<Psi>'" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* P'" and "(p\<bullet>xvec) \<sharp>* Q'"
      by(rule name_list_avoiding[where c="(xvec,\<Psi>',\<Psi>,P,Q,P',Q')"]) auto
    hence "(\<Psi>,p\<bullet>P',p\<bullet>Q') \<in> \<S>" using `(\<Psi>,P',Q') \<in> \<S>` `xvec \<sharp>* \<Psi>`
      by(drule_tac eqvtI[where p=p, OF Seqvt]) (simp add: eqvts)
    hence "(\<Psi>\<otimes>\<Psi>',p\<bullet>P',p\<bullet>Q') \<in> \<S>"
      by(rule \<S>extend)
    have 1: "\<lparr>\<nu>*xvec\<rparr>P' = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>P')" using `(p\<bullet>xvec) \<sharp>* P'` `(p\<bullet>xvec) \<sharp>* xvec` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
      by(subst resChainAlpha[where p=p]) (auto simp add: eqvts)     
    have 2: "\<lparr>\<nu>*xvec\<rparr>Q' = \<lparr>\<nu>*(p\<bullet>xvec)\<rparr>(p\<bullet>Q')" using `(p\<bullet>xvec) \<sharp>* Q'` `(p\<bullet>xvec) \<sharp>* xvec` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
      by(subst resChainAlpha[where p=p]) (auto simp add: eqvts)
    have "(\<Psi>\<otimes>\<Psi>',\<lparr>\<nu>*xvec\<rparr>P',\<lparr>\<nu>*xvec\<rparr>Q') \<in> {(\<Psi>, P, Q). \<exists>xvec P' Q'. P = \<lparr>\<nu>*xvec\<rparr>P' \<and> Q = \<lparr>\<nu>*xvec\<rparr>Q' \<and> xvec \<sharp>* \<Psi> \<and> (\<Psi>, P', Q') \<in> \<S>}" using `(p\<bullet>xvec) \<sharp>* \<Psi>'` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(\<Psi>\<otimes>\<Psi>',p\<bullet>P',p\<bullet>Q') \<in> \<S>`
      unfolding 1 2
      by auto
    thus ?thesis unfolding `P = \<lparr>\<nu>*xvec\<rparr>P'`[symmetric] `Q = \<lparr>\<nu>*xvec\<rparr>Q'`[symmetric] using `A \<sharp>* P` `A \<sharp>* Q`
      by blast
  qed
qed

lemma transferHOTauFrame:
  fixes \<Psi>\<^isub>F  :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   \<alpha>    :: "'a action"
  and   P'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>F   :: "name list"
  and   A\<^isub>G   :: "name list"
  and   \<Psi>\<^isub>G   :: 'b

  assumes "\<Psi>\<^isub>F\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"
  and     "extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>"
  and     "extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>"
  and     "\<Psi>\<otimes>\<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
  and     "A\<^isub>F \<sharp>* P"
  and     "A\<^isub>F \<sharp>* \<Psi>"
  and     "A\<^isub>G \<sharp>* P"
  and     "A\<^isub>G \<sharp>* \<Psi>"
  and     "A\<^isub>F \<sharp>* \<alpha>"
  and     "A\<^isub>G \<sharp>* \<alpha>"
  and     "A\<^isub>P \<sharp>* A\<^isub>F"
  and     "A\<^isub>P \<sharp>* A\<^isub>G"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>F"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>G"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* S"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* P'"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* \<alpha>"
  and     "B \<sharp>* S"
  and     "B \<sharp>* P"
  and     "B \<sharp>* P'"
  and     "B \<sharp>* R"
  and     "B \<sharp>* \<alpha>"
  and     "B \<sharp>* A\<^isub>P"
  and     "bn \<alpha> \<sharp>* P"
  and     "bn \<alpha> \<sharp>* R"
  and     "bn \<alpha> \<sharp>* S"
  and     "bn \<alpha> \<sharp>* \<Psi>"
  and     "\<alpha> = \<tau>"

  shows "\<exists> P''. \<Psi>\<^isub>G\<otimes>\<Psi>  \<rhd> P \<longmapsto>\<alpha> \<prec> P'' \<and> (B,\<Psi>,S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>"
using assms `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
proof(nominal_induct \<Psi>\<^isub>F \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P avoiding: \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B rule: semanticsFramePsiInduct')
  case(cFrameAlpha \<Psi> P A\<^isub>P \<Psi>\<^isub>P p \<alpha> P' \<Psi>\<^isub>G A\<^isub>F A\<^isub>G)
  from `\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>P) \<rhd> R \<sim>\<^sub>H S`
  have "(p\<bullet>(\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>P))) \<rhd> (p\<bullet>R) \<sim>\<^sub>H (p\<bullet>S)"
    by(rule hobisimClosed)
  with `A\<^isub>P \<sharp>* \<Psi>` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* R` `(p \<bullet> A\<^isub>P) \<sharp>* R` `A\<^isub>P \<sharp>* S` `(p \<bullet> A\<^isub>P) \<sharp>* S`
    `distinctPerm p` `set p \<subseteq> set A\<^isub>P \<times> set (p \<bullet> A\<^isub>P)` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
    by(simp add: eqvts)
  hence "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using cFrameAlpha
    by force
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "A\<^isub>P \<sharp>* P''" "(p\<bullet>A\<^isub>P) \<sharp>* P''" using `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>\<^isub>G` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<alpha>` `(p\<bullet>A\<^isub>P) \<sharp>* P` `(p\<bullet>A\<^isub>P) \<sharp>* \<Psi>\<^isub>G` `(p\<bullet>A\<^isub>P) \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>P) \<sharp>* \<alpha>` `bn \<alpha> \<sharp>* subject \<alpha>`
    by(auto intro: freeFreshChainDerivative boundOutputDistinct)
  hence "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `distinctPerm p` `set p \<subseteq> set A\<^isub>P \<times> set (p \<bullet> A\<^isub>P)` `A\<^isub>P \<sharp>* \<Psi>` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* R` `(p \<bullet> A\<^isub>P) \<sharp>* R` `A\<^isub>P \<sharp>* S` `(p \<bullet> A\<^isub>P) \<sharp>* S` `A\<^isub>P \<sharp>* P'` `(p \<bullet> A\<^isub>P) \<sharp>* P'` `A\<^isub>P \<sharp>* A\<^isub>F` `(p \<bullet> A\<^isub>P) \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G` `(p \<bullet> A\<^isub>P) \<sharp>* A\<^isub>G` `A\<^isub>P \<sharp>* B` `B \<sharp>* (p \<bullet> A\<^isub>P)`
    by(drule_tac eqvtI[where p=p,OF TUReqvt(2),OF Seqvt]) (simp add: eqvts)
  thus ?case using `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''`
    by blast
next
  case(cAlpha \<Psi> P \<alpha> P' p A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `bn \<alpha> \<sharp>* B` `B \<sharp>* (p \<bullet> \<alpha>)` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>B) = B"
    by(simp add: fresh_star_bij)
  with `B \<sharp>* (p \<bullet> P')` have "B \<sharp>* P'"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>F \<sharp>* (p \<bullet> \<alpha>)` `bn \<alpha> \<sharp>* A\<^isub>F` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>F) = A\<^isub>F"
    by(simp add: fresh_star_bij)
  with `A\<^isub>F \<sharp>* (p\<bullet>\<alpha>)` have "A\<^isub>F \<sharp>* \<alpha>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>G \<sharp>* (p \<bullet> \<alpha>)` `bn \<alpha> \<sharp>* A\<^isub>G` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>G) = A\<^isub>G"
    by(simp add: fresh_star_bij)
  with `A\<^isub>G \<sharp>* (p\<bullet>\<alpha>)` have "A\<^isub>G \<sharp>* \<alpha>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `A\<^isub>P \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* (p \<bullet> \<alpha>)` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` have "(p\<bullet>A\<^isub>P) = A\<^isub>P"
    by simp
  have "B \<sharp>* \<alpha>" using `B \<sharp>* (p\<bullet>\<alpha>)` `(p\<bullet>B)=B`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  from `(p\<bullet>\<alpha>) = \<tau>` have "\<alpha> = \<tau>"
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "subject(p\<bullet>\<alpha>) = subject(\<alpha>)" using `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* (p\<bullet>\<alpha>)` `bn(p\<bullet>\<alpha>) \<sharp>* subject(p\<bullet>\<alpha>)`
    apply simp
    apply(subst perm_bool[where pi=p,symmetric])
    unfolding eqvts
    apply(subst subjectEqvt[symmetric])
    by simp
  have "distinct (bn \<alpha>)" using `distinct(bn(p\<bullet>\<alpha>))`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cAlpha) fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "bn(p\<bullet>\<alpha>) \<sharp>* P''" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` `bn(p\<bullet>\<alpha>) \<sharp>* P` `bn(p\<bullet>\<alpha>) \<sharp>* \<alpha>`
    by(rule_tac freeFreshChainDerivative)
  have "bn(p\<bullet>\<alpha>) \<sharp>* object \<alpha>" using `bn(p\<bullet>\<alpha>) \<sharp>* \<alpha>` by simp
  have "bn(p\<bullet>\<alpha>) \<sharp>* subject \<alpha>" using `bn(p\<bullet>\<alpha>) \<sharp>* subject(p\<bullet>\<alpha>)` unfolding `subject(p\<bullet>\<alpha>) = subject(\<alpha>)` by -
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> (p\<bullet>\<alpha>) \<prec> (p\<bullet>P'')"
    by(subst residualAlpha[symmetric]) fact+
  moreover have "(B, \<Psi>, S \<parallel> (p\<bullet>P''), R \<parallel> (p \<bullet> P')) \<in> TUR' \<S>"
    using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `(p\<bullet>B)=B` `(p\<bullet>A\<^isub>P) = A\<^isub>P` `set p \<subseteq> set (bn \<alpha>) \<times> set (bn (p \<bullet> \<alpha>))` `distinctPerm p` `bn \<alpha> \<sharp>* R` `bn(p\<bullet>\<alpha>) \<sharp>* R` `bn \<alpha> \<sharp>* S` `bn(p\<bullet>\<alpha>) \<sharp>* S` `bn \<alpha> \<sharp>* \<Psi>` `bn(p\<bullet>\<alpha>) \<sharp>* \<Psi>`
    by(drule_tac eqvtI[where p=p, OF TUReqvt(2), OF Seqvt]) (simp add: eqvts)
  ultimately show ?case by blast
next
  case(cInput \<Psi> M K xvec N Tvec P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G)
  from `K\<lparr>N[xvec::=Tvec]\<rparr> = \<tau>` show ?case by simp
next
  case(cOutput \<Psi> M K N P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  from `K\<langle>N\<rangle> = \<tau>` show ?case by simp
next
  case(cCase \<Psi> P \<alpha> P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  hence "B \<sharp>* A\<^isub>P" by simp
  from `B \<sharp>* (Cases Cs)` `A\<^isub>F \<sharp>* (Cases Cs)` `A\<^isub>G \<sharp>* (Cases Cs)` `bn \<alpha> \<sharp>* (Cases Cs)` `(\<phi>, P) mem Cs`
  have "A\<^isub>F \<sharp>* \<phi>" and "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* \<phi>" and "A\<^isub>G \<sharp>* P" "bn \<alpha> \<sharp>* \<phi>" and "bn \<alpha> \<sharp>* P" "B \<sharp>* \<phi>" and "B \<sharp>* P"
    by(induct Cs) auto
  from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(metis hostatEqBisim Identity)
  moreover from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> \<phi>` `A\<^isub>F \<sharp>* \<phi>` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion (extractFrame R) \<Psi> \<turnstile>\<^sub>F \<phi>"
    unfolding `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>`   
    by(auto intro: Commutativity statEqEnt frameImpI)
  moreover note `\<not> clauseDom \<phi>`
  ultimately have "insertAssertion (extractFrame S) \<Psi> \<turnstile>\<^sub>F \<phi>"
    by(blast dest: hobisimE)
  with `A\<^isub>G \<sharp>* \<phi>` `A\<^isub>G \<sharp>* \<Psi>`
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<turnstile> \<phi>"
    unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
    by(auto intro: Commutativity statEqEnt frameImpE)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    apply(rule cCase)
    apply fact
    apply fact
    apply(rule hobisimE)
    by fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Cases Cs \<longmapsto> \<alpha> \<prec> P''"
    by(rule Case) fact+  
  thus ?case using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    unfolding TUR'_def
    by blast
next
  case(cPar1 \<Psi> \<Psi>\<^isub>Q P \<alpha> P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S)
  from `A\<^isub>F \<sharp>* (P \<parallel> Q)` `A\<^isub>G \<sharp>* (P \<parallel> Q)` have "A\<^isub>F \<sharp>* P" "A\<^isub>F \<sharp>* Q" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* Q` `A\<^isub>Q \<sharp>* A\<^isub>F` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` have "A\<^isub>F \<sharp>* \<Psi>\<^isub>Q"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>F \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>F \<sharp>* \<Psi>` by blast
  from `A\<^isub>G \<sharp>* Q` `A\<^isub>Q \<sharp>* A\<^isub>G` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` have "A\<^isub>G \<sharp>* \<Psi>\<^isub>Q"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>G \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>G \<sharp>* \<Psi>` by blast
  have "A\<^isub>P \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` by blast
  from `B \<sharp>* (P' \<parallel> Q)` have "B \<sharp>* P'" and "B \<sharp>* Q" by simp+
  from `(A\<^isub>P @ A\<^isub>Q) \<sharp>* (P' \<parallel> Q)` have "A\<^isub>P \<sharp>* P'" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>Q \<sharp>* P'" and "A\<^isub>Q \<sharp>* Q"
    by simp+
  from `B \<sharp>* (A\<^isub>P @ A\<^isub>Q)` have "B \<sharp>* A\<^isub>P" and "B \<sharp>* A\<^isub>Q" by simp+
  have "A\<^isub>Q \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* A\<^isub>Q` by simp
  have "bn \<alpha> \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>Q)" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>Q` by force
  from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` have "(\<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
  from `B \<sharp>* (P\<parallel>Q)` have "B \<sharp>* P"
    by simp
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B@A\<^isub>Q, \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cPar1) (subst freshChainAppend|rule conjI|fact)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P\<parallel>Q \<longmapsto> \<alpha> \<prec> P''\<parallel>Q"
    apply(rule Par1)
    apply(rule statEqTransition)
    apply fact
    apply(rule AssertionStatEqSym[OF Associativity])
    apply fact
    apply fact
    apply(rule freshCompChain)
    by fact+
  moreover have "(B, \<Psi>, S \<parallel> (P''\<parallel>Q), R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>"
  proof -
    from `((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    have "((B@A\<^isub>Q), \<Psi> \<otimes> \<Psi>\<^isub>Q, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence "((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>"
      using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* Q` `B \<sharp>* Q` `A\<^isub>P \<sharp>* Q` `distinct A\<^isub>Q`
      by(rule_tac TURS'parPres') auto
    moreover have "((B@A\<^isub>Q), \<Psi>, S \<parallel> (P'' \<parallel> Q), (S \<parallel> P'') \<parallel> Q) \<in> TUR' \<S>" using `((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "((B@A\<^isub>Q), \<Psi>, (R \<parallel> P') \<parallel> Q, R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>" using `((B@A\<^isub>Q), \<Psi>, (S \<parallel> P'') \<parallel> Q, (R \<parallel> P') \<parallel> Q) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimParAssoc)
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately have "((B@A\<^isub>Q), \<Psi>, S \<parallel> (P'' \<parallel> Q), R \<parallel> (P' \<parallel> Q)) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by blast
next
  case(cInv \<Psi> M P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  have "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* M" "A\<^isub>F \<sharp>* M" using `supp P \<subseteq> supp M` `A\<^isub>F \<sharp>* \<langle>M\<rangle>`  `A\<^isub>G \<sharp>* \<langle>M\<rangle>`
    by(auto simp add: psi.supp fresh_star_def fresh_def)
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<turnstile> M\<Leftarrow>P` `A\<^isub>F \<sharp>* M` `A\<^isub>F \<sharp>* P` `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` `A\<^isub>F \<sharp>* \<Psi>`
  have "insertAssertion(extractFrame R) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> P"
    by(auto intro: frameImpI statEqEnt Commutativity)
  moreover have "legalClause M P" unfolding legalClause_def using `guarded P` `supp P \<subseteq> supp M`
    by blast
  moreover from `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (rule Identity)
  ultimately obtain Q where "legalClause M Q" and "insertAssertion(extractFrame S) \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> Q" and "P \<sim>\<^sub>H Q"
    by(auto dest: hobisimE)
  
  have "B \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* B`
    by simp
  have "bn \<alpha> \<sharp>* Q" using `bn \<alpha> \<sharp>* M` `legalClause M Q` by simp
  from `B \<sharp>* \<langle>M\<rangle>` `A\<^isub>G \<sharp>* M` `A\<^isub>F \<sharp>* M` have "B \<sharp>* M" and "B \<sharp>* P" and "B \<sharp>* Q" and "A\<^isub>F \<sharp>* Q" and "A\<^isub>G \<sharp>* Q" using `legalClause M P` `legalClause M Q`
    by auto
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule_tac cInv) (fact|rule hobisimE)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "B \<sharp>* P''"
    unfolding TUR'_def
    by(auto dest: fresh_rel_trancl_fresh)
  from `P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
    apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>\<^isub>G\<otimes>\<Psi>"])
    apply(rule hostatEqBisim,assumption)
    by(metis AssertionStatEqTrans Commutativity Identity)
  with `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` obtain Q' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'" and "\<Psi>\<^isub>G\<otimes>\<Psi> \<rhd> Q' \<sim>\<^sub>H P''" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>G` `bn \<alpha> \<sharp>* Q`
    apply(drule_tac hobisimE(5))
    apply(drule_tac hobisimE(3))
    by(drule simE) auto
  hence "\<Psi>\<otimes>\<Psi>\<^isub>G \<rhd> Q' \<sim>\<^sub>H P''"
    by(blast intro: hostatEqBisim Commutativity)
  have "A\<^isub>P \<sharp>* Q" using `A\<^isub>P \<sharp>* M` `legalClause M Q`
    by simp
  from `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>P \<sharp>* P''" "A\<^isub>P \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `A\<^isub>F \<sharp>* P` `A\<^isub>F \<sharp>* Q` `A\<^isub>F \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>F \<sharp>* P''" "A\<^isub>F \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `A\<^isub>G \<sharp>* P` `A\<^isub>G \<sharp>* Q` `A\<^isub>G \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "A\<^isub>G \<sharp>* P''" "A\<^isub>G \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  from `B \<sharp>* P` `B \<sharp>* Q` `B \<sharp>* \<alpha>` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''` `\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` have "B \<sharp>* P''" "B \<sharp>* Q'" using `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)`
    by(simp add: freeFreshChainDerivative)+
  have "(\<Psi>,Q'\<parallel>S,P''\<parallel>S) \<in> \<S>" unfolding \<S>_def using `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* Q'` `A\<^isub>G \<sharp>* P''` `\<Psi>\<otimes>\<Psi>\<^isub>G \<rhd> Q' \<sim>\<^sub>H P''`
    by blast
  hence "(B,\<Psi>,Q'\<parallel>S,P''\<parallel>S) \<in> TUR' \<S>" using `B \<sharp>* Q'` `B \<sharp>* P''` `B \<sharp>* S` `A\<^isub>P \<sharp>* S` `A\<^isub>P \<sharp>* P''` `A\<^isub>P \<sharp>* Q'`
    unfolding TUR'_def
    by(rule_tac r_into_fresh_rel_trancl) (auto simp add: exI[where x="[]"])
  hence "(B,\<Psi>,S\<parallel>Q',S\<parallel>P'') \<in> TUR' \<S>"
    unfolding TUR'_def
    apply(rule_tac fresh_rel_trancl_transitive)
    apply(rule r_into_fresh_rel_trancl)
    apply(rule UnI2)
    apply(rule hobisimBisim[OF bisimParComm])
    apply(force dest: fresh_rel_trancl_fresh)
    apply(force dest: fresh_rel_trancl_fresh)
    apply(rule_tac fresh_rel_trancl_transitive)
    apply assumption
    apply(rule r_into_fresh_rel_trancl)
    apply(rule UnI2)
    apply(rule hobisimBisim[OF bisimParComm])
    by(force dest: fresh_rel_trancl_fresh)+
  with `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
  have "(B, \<Psi>, S \<parallel> Q', R \<parallel> P') \<in> TUR' \<S>"
    unfolding TUR'_def
    by(rule_tac fresh_rel_trancl_transitive)
  moreover have "\<Psi>\<^isub>G \<otimes> \<Psi>  \<rhd> \<langle>M\<rangle> \<longmapsto> \<alpha> \<prec> Q'"
  proof -
    have "\<Psi> \<otimes> \<Psi>\<^isub>G \<turnstile> M\<Leftarrow>Q" using `insertAssertion (extractFrame S) \<Psi>  \<turnstile>\<^sub>F M\<Leftarrow>Q`
      unfolding `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>`
      using `A\<^isub>G \<sharp>* M` `A\<^isub>G \<sharp>* Q` `A\<^isub>G \<sharp>* \<Psi>`
      by(auto dest: frameImpE)
    have "supp Q \<subseteq> ((supp M)::name set)" and "guarded Q" using `legalClause M Q`
      unfolding legalClause_def
      by simp+
    show ?thesis
      apply(rule Inv)
      apply(rule statEqEnt)
      apply(rule Commutativity)
      by fact+
  qed
  ultimately show ?case by blast
next
  case(cScope \<Psi> P \<alpha> P' x A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  have "A\<^isub>F \<sharp>* P" using `A\<^isub>F \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> A\<^isub>F`
    by simp
  have "A\<^isub>G \<sharp>* P" using `A\<^isub>G \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> A\<^isub>G`
    by simp
  have "A\<^isub>P \<sharp>* \<Psi>\<^isub>F" using `(x#A\<^isub>P) \<sharp>* \<Psi>\<^isub>F`
    by simp
  have "B \<sharp>* P" using `B \<sharp>* \<lparr>\<nu>x\<rparr>P` `x \<sharp> B`
    by simp
  have "B \<sharp>* P'" using `B \<sharp>* \<lparr>\<nu>x\<rparr>P'` `x \<sharp> B`
    by simp
  have "B \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* B`
    by simp
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cScope) fact+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> \<lparr>\<nu>x\<rparr>P \<longmapsto> \<alpha> \<prec> \<lparr>\<nu>x\<rparr>P''" using `x \<sharp> \<alpha>` `x \<sharp> \<Psi>\<^isub>G` `x \<sharp> \<Psi>`
    by(rule_tac Scope) auto
  moreover have "(B, \<Psi>, S \<parallel> \<lparr>\<nu>x\<rparr>P'', R \<parallel> \<lparr>\<nu>x\<rparr>P') \<in> TUR' \<S>"
  proof -
    have "(B, \<Psi>, S \<parallel> \<lparr>\<nu>x\<rparr>P'', \<lparr>\<nu>x\<rparr>(S \<parallel> P'')) \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> S` `x \<sharp> B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim[OF bisimSymmetric, OF bisimScopeExt])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>x\<rparr>(S \<parallel> P''), \<lparr>\<nu>x\<rparr>(R \<parallel> P')) \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> \<Psi>`
      by(rule TURS'resPres)
    moreover have "(B, \<Psi>, \<lparr>\<nu>x\<rparr>(R \<parallel> P'),R \<parallel> \<lparr>\<nu>x\<rparr>P') \<in> TUR' \<S>" using `(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>` `x \<sharp> R` `x \<sharp> B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim[OF bisimScopeExt])
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  ultimately show ?case
    by blast
next
  case(cBang \<Psi> P \<alpha> P' A\<^isub>P \<Psi>\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `A\<^isub>F \<sharp>* !P` `A\<^isub>G \<sharp>* !P` `B \<sharp>* !P` `bn \<alpha> \<sharp>* !P` have "A\<^isub>F \<sharp>* P" "A\<^isub>G \<sharp>* P" "B \<sharp>* P" "bn \<alpha> \<sharp>* P"
    by auto
  have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S" using `\<Psi> \<otimes> \<one> \<rhd> R \<sim>\<^sub>H S`
    by (metis Identity hobisimE(4) hostatEqBisim)
  have "\<exists>P''. \<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> \<alpha> \<prec> P'' \<and> (B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by(rule cBang) (fact|simp)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto> \<alpha> \<prec> P''" and "(B, \<Psi>, S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  thus ?case using `guarded P`
    by(blast intro: Bang)
next
  case(cPar2 \<Psi> \<Psi>\<^isub>P Q \<alpha> Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `A\<^isub>F \<sharp>* (P \<parallel> Q)` `A\<^isub>G \<sharp>* (P \<parallel> Q)` have "A\<^isub>F \<sharp>* P" "A\<^isub>F \<sharp>* Q" "A\<^isub>G \<sharp>* P" "A\<^isub>G \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>F` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` have "A\<^isub>F \<sharp>* \<Psi>\<^isub>P"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>F \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>F \<sharp>* \<Psi>` by blast
  from `A\<^isub>G \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>G` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` have "A\<^isub>G \<sharp>* \<Psi>\<^isub>P"
    by(drule_tac extractFrameFreshChain) simp
  hence "A\<^isub>G \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>G \<sharp>* \<Psi>` by blast
  have "A\<^isub>Q \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` by blast
  from `B \<sharp>* (P \<parallel> Q')` have "B \<sharp>* P" and "B \<sharp>* Q'" by simp+
  from `(A\<^isub>P @ A\<^isub>Q) \<sharp>* (P \<parallel> Q')` have "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q'" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q'"
    by simp+
  from `B \<sharp>* (A\<^isub>P @ A\<^isub>Q)` have "B \<sharp>* A\<^isub>P" and "B \<sharp>* A\<^isub>Q" by simp+
  have "A\<^isub>Q \<sharp>* A\<^isub>P" using `A\<^isub>P \<sharp>* A\<^isub>Q` by simp
  have "bn \<alpha> \<sharp>* (\<Psi>\<otimes>\<Psi>\<^isub>P)" using `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` by force
  from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` have "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S"
    by(rule hostatEqBisim) (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
  from `B \<sharp>* (P\<parallel>Q)` have "B \<sharp>* Q"
    by simp
  have "\<exists>Q''. \<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'' \<and> (B@A\<^isub>P, \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by(rule cPar2) (subst freshChainAppend|rule conjI|fact)+
  then obtain Q'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> \<alpha> \<prec> Q''" and "((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by blast
  have "\<Psi>\<^isub>G \<otimes> \<Psi> \<rhd> P\<parallel>Q \<longmapsto> \<alpha> \<prec> P\<parallel>Q''"
    apply(rule Par2)
    apply(rule statEqTransition)
    apply fact
    apply(rule AssertionStatEqSym[OF Associativity])
    apply fact
    apply fact
    apply(rule freshCompChain)
    by fact+
  moreover have "(B, \<Psi>, S \<parallel> (P\<parallel>Q''), R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>"
  proof -
    from `((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>`
    have "((B@A\<^isub>P), \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence "((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>"
      using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* P` `B \<sharp>* P` `A\<^isub>P \<sharp>* P` `distinct A\<^isub>P`
      by(rule_tac TURS'parPres') auto
    moreover have "((B@A\<^isub>P), \<Psi>, S \<parallel> (P \<parallel> Q''), (S \<parallel> Q'') \<parallel> P) \<in> TUR' \<S>" using `((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimParPresSym,OF bisimParComm])
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "((B@A\<^isub>P), \<Psi>, (R \<parallel> Q') \<parallel> P, R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>" using `((B@A\<^isub>P), \<Psi>, (S \<parallel> Q'') \<parallel> P, (R \<parallel> Q') \<parallel> P) \<in> TUR' \<S>`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimTransitive[OF bisimParPresSym,OF bisimParComm]])
      apply(rule bisimSymmetric[OF bisimParAssoc])
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately have "((B@A\<^isub>P), \<Psi>, S \<parallel> (P \<parallel> Q''), R \<parallel> (P \<parallel> Q')) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
    thus ?thesis
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
  qed
  ultimately show ?case
    by blast
next
  case(cOpen \<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P y \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle> = \<tau>` show ?case by simp
next
  case(cComm1 \<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>P \<Psi>\<^isub>P Q K xvec Q' A\<^isub>Q \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `B \<sharp>* (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q')` `xvec \<sharp>* B` have "B \<sharp>* P'" "B \<sharp>* Q'"
    by simp+
  from `B \<sharp>* (P \<parallel> Q)` have "B \<sharp>* P" and "B \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* (P \<parallel> Q)` have "A\<^isub>F \<sharp>* P" and "A\<^isub>F \<sharp>* Q"
    by simp+
  from `A\<^isub>G \<sharp>* (P \<parallel> Q)` have "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* Q"
    by simp+
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> M\<lparr>N\<rparr> \<prec> P'`
  obtain M' where "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'" and "B \<sharp>* M'" and "A\<^isub>Q \<sharp>* M'" and "xvec \<sharp>* M'" and "A\<^isub>F \<sharp>* M'" and "A\<^isub>G \<sharp>* M'" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `B \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* P` `xvec \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* B` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P \<sharp>* M` `A\<^isub>F \<sharp>* P` `A\<^isub>G \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G`
    by(rule_tac obtainPrefix[where B="(B@A\<^isub>Q@xvec@A\<^isub>F@A\<^isub>G)" and \<Psi>="\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q" and \<alpha> = "M\<lparr>N\<rparr>"]) auto
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `distinct xvec`
  obtain K' where "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'" and "B \<sharp>* K'" and "A\<^isub>P \<sharp>* K'" and "xvec \<sharp>* K'" and "A\<^isub>G \<sharp>* K'" and "A\<^isub>F \<sharp>* K'" using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q` `B \<sharp>* Q` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>F \<sharp>* Q` `A\<^isub>G \<sharp>* Q` `xvec \<sharp>* Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* B` `A\<^isub>Q \<sharp>* xvec` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>Q \<sharp>* K` `xvec \<sharp>* K` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G`
    by(rule_tac obtainPrefix[where B="(B@A\<^isub>P@xvec@A\<^isub>F@A\<^isub>G)" and \<Psi>="\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P" and \<alpha> = "K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>"]) auto
  have "\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
  proof -
    note `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* K` `A\<^isub>Q \<sharp>* Q`
    moreover from `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'` `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K`
    have "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> M'"
      apply(rule_tac chanEqTrans[where N=K'])
      apply assumption
      apply(rule_tac chanEqTrans[where N=M])
      apply(rule_tac chanEqTrans[where N=K])
      apply(rule chanEqSym,assumption)
      by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
    ultimately show ?thesis
      by(rule_tac outputRenameSubject[where M=K]) auto
  qed
  note `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> M\<lparr>N\<rparr> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* K'` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* P`
  moreover from `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'` `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> M \<leftrightarrow> K`
  have "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> K'"
    apply(rule_tac chanEqTrans[where N=M'])
    apply assumption
    apply(rule_tac chanEqTrans[where N=M])
    apply(rule chanEqSym,assumption)
    apply(rule_tac chanEqTrans[where N=K])
    by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
  ultimately have "\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> K'\<lparr>N\<rparr> \<prec> P'"
    by(rule_tac inputRenameSubject[where M=M]) auto
  have "A\<^isub>F \<sharp>* \<Psi>\<^isub>P" "A\<^isub>G \<sharp>* \<Psi>\<^isub>P" using `A\<^isub>F \<sharp>* P` `A\<^isub>G \<sharp>* P` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G`
    by(drule_tac extractFrameFreshChain,force)+
  have "A\<^isub>F \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>G \<sharp>* \<Psi>\<^isub>Q" using `A\<^isub>F \<sharp>* Q` `A\<^isub>G \<sharp>* Q` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G`
    by(drule_tac extractFrameFreshChain,force)+
  have "(\<Psi>\<^isub>F \<otimes> \<Psi>) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> K' \<leftrightarrow> M'" using `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'`
    apply(rule_tac chanEqTrans[where N=M])
    by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
  hence "insertAssertion (extractFrame R) (\<Psi>\<otimes>\<Psi>\<^isub>P\<otimes>\<Psi>\<^isub>Q) \<turnstile>\<^sub>F K' \<leftrightarrow> M'" using `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` `A\<^isub>F \<sharp>* \<Psi>` `A\<^isub>F \<sharp>* \<Psi>\<^isub>P` `A\<^isub>F \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>F \<sharp>* K'` `A\<^isub>F \<sharp>* M'`
    apply simp
    apply(subst insertAssertionSimps)
    apply force
    apply(rule frameImpI)
    apply(rule refl)
    apply force
    by (metis Associativity Commutativity statEqEnt)
  moreover have "\<not> clauseDom(K' \<leftrightarrow> M')" by auto
  moreover note `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S`
  ultimately have "insertAssertion (extractFrame S) (\<Psi>\<otimes>\<Psi>\<^isub>P\<otimes>\<Psi>\<^isub>Q) \<turnstile>\<^sub>F K' \<leftrightarrow> M'"
    by(blast dest: hobisimE)
  hence "(\<Psi>\<^isub>G \<otimes> \<Psi>) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> K' \<leftrightarrow> M'" using `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* \<Psi>\<^isub>P` `A\<^isub>G \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>G \<sharp>* M'` `A\<^isub>G \<sharp>* K'`
    apply simp
    apply(subst (asm) insertAssertionSimps)
    apply force
    apply(drule frameImpE)
    apply force
    by (metis Associativity Commutativity statEqEnt)
  obtain A\<^isub>P' \<Psi>\<^isub>P' \<Psi>' where "\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'" and "extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>" and "A\<^isub>P' \<sharp>* P'" and "A\<^isub>P' \<sharp>* K'" "A\<^isub>P' \<sharp>* N" "A\<^isub>P' \<sharp>* xvec" and "distinct A\<^isub>P'" "A\<^isub>P' \<sharp>* S" "A\<^isub>P' \<sharp>* P'" "A\<^isub>P' \<sharp>* Q" "A\<^isub>P' \<sharp>* \<Psi>"  "A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>P' \<sharp>* B" "A\<^isub>P' \<sharp>* \<Psi>\<^isub>F" "A\<^isub>P' \<sharp>* \<Psi>\<^isub>G" "A\<^isub>P' \<sharp>* A\<^isub>F" "A\<^isub>P' \<sharp>* A\<^isub>G" "A\<^isub>P' \<sharp>* R" "A\<^isub>P' \<sharp>* A\<^isub>Q" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `A\<^isub>P \<sharp>* K'` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* S` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* \<Psi>`  `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* B` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* \<Psi>\<^isub>G` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G` `A\<^isub>P \<sharp>* R` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* A\<^isub>Q`
    by(rule_tac expandFrame[where C="(S,Q,P',\<Psi>,\<Psi>\<^isub>Q,B,\<Psi>\<^isub>F,\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,A\<^isub>Q,R,xvec)" and C'="[]", OF `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q  \<rhd> P \<longmapsto>K'\<lparr>N\<rparr> \<prec> P'`]) auto
  have "A\<^isub>F \<sharp>* N" "A\<^isub>F \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* A\<^isub>F` `A\<^isub>F \<sharp>* \<Psi>` `A\<^isub>F \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "A\<^isub>G \<sharp>* N" "A\<^isub>G \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* A\<^isub>G` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "B \<sharp>* N" "B \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* B` `B \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "A\<^isub>P' \<sharp>* N" "A\<^isub>P' \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `A\<^isub>P' \<sharp>* xvec` `A\<^isub>P' \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "\<exists> Q''. \<Psi>\<^isub>G\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'' \<and> (B@A\<^isub>P',\<Psi>\<otimes>\<Psi>\<^isub>P,S\<parallel>Q'',R\<parallel>Q') \<in> TUR' \<S>"
    apply(rule_tac transferHONonTauFrame)
    apply(fact|simp)+
    apply(rule hostatEqBisim)
    apply fact
    apply (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
    apply(fact|rule freshCompChain|simp|rule conjI|subst freshChainSym)+
    done
  then obtain Q'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''" and "(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by blast
  from `(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>` have "(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P', S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>" using `\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'`
    apply(drule_tac TURS'extend[where \<Psi>'=\<Psi>'])
    apply(rule TURS'statEq)
    apply assumption
    by (metis AssertionStatEqTrans Associativity compositionSym)
  hence "(B @ A\<^isub>P', \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>" using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* \<Psi>` `A\<^isub>P' \<sharp>* P'` `A\<^isub>P' \<sharp>* Q'` `distinct A\<^isub>P'` `B \<sharp>* P'`
    by(rule_tac TURS'parPres') auto
  have "B \<sharp>* Q''" and "A\<^isub>P' \<sharp>* Q''" using `(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>`
    unfolding TUR'_def
    by(auto dest: fresh_rel_trancl_fresh)
  from `\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `xvec \<sharp>* M'` `distinct xvec` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* xvec` `A\<^isub>Q \<sharp>* N` `A\<^isub>Q \<sharp>* Q` `distinct A\<^isub>Q` `xvec \<sharp>* Q`
  `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* P'` `A\<^isub>Q \<sharp>* K` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>G` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G` `A\<^isub>Q \<sharp>* R` `A\<^isub>Q \<sharp>* S` `A\<^isub>Q \<sharp>* B` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>P' \<sharp>* A\<^isub>Q`
  `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>F` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* P` `xvec \<sharp>* K` `xvec \<sharp>* \<Psi>\<^isub>G` `xvec \<sharp>* A\<^isub>F` `xvec \<sharp>* A\<^isub>G` `xvec \<sharp>* R` `xvec \<sharp>* S` `xvec \<sharp>* B` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P' \<sharp>* xvec`

  obtain p \<Psi>'' A\<^isub>Q'' \<Psi>\<^isub>Q'' where "set p \<subseteq> set(xvec) \<times> set(p\<bullet>xvec)" and "(p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>Q''" and "distinctPerm p" and
    "extractFrame Q'' = \<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>" and "A\<^isub>Q'' \<sharp>* Q''" and "A\<^isub>Q'' \<sharp>* M'"  and "A\<^isub>Q'' \<sharp>* xvec"  and "A\<^isub>Q'' \<sharp>* N" and "A\<^isub>Q'' \<sharp>* (p\<bullet>M')" and
    "A\<^isub>Q'' \<sharp>* (p\<bullet>xvec)"  and "A\<^isub>Q'' \<sharp>* (p\<bullet>N)"  and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* Q''" and "distinct A\<^isub>Q''"
    and "A\<^isub>Q'' \<sharp>* \<Psi>" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>F" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P" "A\<^isub>Q'' \<sharp>* P" "A\<^isub>Q'' \<sharp>* P'" "A\<^isub>Q'' \<sharp>* K" "A\<^isub>Q'' \<sharp>* Q'" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>G" "A\<^isub>Q'' \<sharp>* A\<^isub>F" "A\<^isub>Q'' \<sharp>* A\<^isub>G" "A\<^isub>Q'' \<sharp>* R" "A\<^isub>Q'' \<sharp>* S" "A\<^isub>Q'' \<sharp>* B" "A\<^isub>P \<sharp>* A\<^isub>Q''" "A\<^isub>P' \<sharp>* A\<^isub>Q''" "A\<^isub>Q'' \<sharp>* Q"
    and "(p\<bullet>xvec) \<sharp>* \<Psi>" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>F" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P" "(p\<bullet>xvec) \<sharp>* P" "(p\<bullet>xvec) \<sharp>* K" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>G" "(p\<bullet>xvec) \<sharp>* A\<^isub>F" "(p\<bullet>xvec) \<sharp>* A\<^isub>G" "(p\<bullet>xvec) \<sharp>* R" "(p\<bullet>xvec) \<sharp>* S" "(p\<bullet>xvec) \<sharp>* B" "A\<^isub>P \<sharp>* (p\<bullet>xvec)" "A\<^isub>P' \<sharp>* (p\<bullet>xvec)" "(p\<bullet>xvec) \<sharp>* Q"
    apply(rule_tac expandFrame[where C="(\<Psi>,\<Psi>\<^isub>F,\<Psi>\<^isub>P,P,P',K,Q',\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,R,S,B,A\<^isub>P,A\<^isub>P',Q)" and C'="(\<Psi>,\<Psi>\<^isub>F,\<Psi>\<^isub>P,P,K,\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,R,S,B,A\<^isub>P,A\<^isub>P',Q)" and \<alpha>="M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>"])
    unfolding eqvts
    by auto
  have "\<Psi> \<otimes> (\<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>Q'') \<rhd> R \<sim>\<^sub>H S"
  proof -
    from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<rhd> R \<sim>\<^sub>H S" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R` `xvec \<sharp>* S` `(p\<bullet>xvec) \<sharp>* S`
      by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
    thus ?thesis using `\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'` `(p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>Q''`
      apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>'\<otimes>\<Psi>''"])
      apply(rule hostatEqBisim)
      apply assumption
      apply(rule AssertionStatEqTrans[OF Associativity])
      apply(rule compositionSym)
      apply(rule AssertionStatEqSym)
      apply(rule AssertionStatEqTrans[OF Composition, OF AssertionStatEqSym], assumption)
      apply(rule AssertionStatEqTrans[OF compositionSym, OF AssertionStatEqSym], assumption)
      by(metis AssertionStatEqSym AssertionStatEqTrans Associativity Composition associativitySym)
  qed
  have "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P'" using `A\<^isub>Q'' \<sharp>* P'` `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''`
    by(drule_tac extractFrameFreshChain) force
  have "A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q''" using `A\<^isub>P' \<sharp>* Q''` `extractFrame Q'' = \<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''`
    by(drule_tac extractFrameFreshChain) force
  from `\<Psi> \<otimes> (\<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>Q'') \<rhd> R \<sim>\<^sub>H S` have "(\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q''),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q'')) \<in> \<S>"
    using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `extractFrame Q''=\<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''` `A\<^isub>P' \<sharp>* \<Psi>` `A\<^isub>Q'' \<sharp>* \<Psi>` `A\<^isub>P' \<sharp>* R` `A\<^isub>Q'' \<sharp>* R` `A\<^isub>P' \<sharp>* S` `A\<^isub>Q'' \<sharp>* S` `A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P'` `A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q''` `A\<^isub>P' \<sharp>* xvec` `A\<^isub>Q'' \<sharp>* xvec` `xvec \<sharp>* R` `xvec \<sharp>* S` `xvec \<sharp>* \<Psi>`
    unfolding \<S>_def
    apply(auto simp add: psi.inject frameChainAppend[symmetric])
    apply(rule_tac exI)
    apply(rule_tac exI)
    apply(rule conjI)
    apply(rule refl)
    by auto
  hence "(B,\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q''),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q'')) \<in> TUR' \<S>"
    unfolding TUR'_def using `B \<sharp>* R` `B \<sharp>* S` `xvec \<sharp>* B` `B \<sharp>* P'` `B \<sharp>* Q''`
    by(auto simp add: exI[where x="[]"])
  from `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q  \<rhd> P \<longmapsto>K'\<lparr>N\<rparr> \<prec> P'`
  have "(p\<bullet>(\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q))  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'"
    by(rule inputPermFrameSubject) (simp|fact)+
  hence "\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q)  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>\<^isub>F` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>F` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
    by(simp add: eqvts)
  have "(\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>Q)) \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<rhd> R \<sim>\<^sub>H S` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R` `xvec \<sharp>* S` `(p\<bullet>xvec) \<sharp>* S`    
    apply(rule_tac hostatEqBisim[where \<Psi>="\<Psi>\<otimes>\<Psi>\<^isub>P\<otimes>(p\<bullet>\<Psi>\<^isub>Q)"])
    apply(drule_tac hobisimClosed[where p=p])
    apply(simp add: eqvts)
    by(metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
  have "A\<^isub>F \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>F \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>F` `(p\<bullet>xvec) \<sharp>* A\<^isub>F`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>G \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>G \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>G` `(p\<bullet>xvec) \<sharp>* A\<^isub>G`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>P \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* (p\<bullet>xvec)`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>F \<sharp>* (p \<bullet> K')" using `A\<^isub>F \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>F` `(p\<bullet>xvec) \<sharp>* A\<^isub>F`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>G \<sharp>* (p \<bullet> K')" using `A\<^isub>G \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>G` `(p\<bullet>xvec) \<sharp>* A\<^isub>G`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>P \<sharp>* (p \<bullet> K')" using `A\<^isub>P \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`  `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* (p\<bullet>xvec)`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "\<exists> P''. \<Psi>\<^isub>G\<otimes>\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q)  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'' \<and> (B@A\<^isub>Q'',\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q),S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>"
    by(rule_tac transferHONonTauFrame) (fact|rule freshCompChain|simp|rule conjI|subst freshChainSym|simp)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<rhd> P \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> P''" "(B @ A\<^isub>Q'', \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q), S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  from `\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<rhd> P \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> P''` have "(p\<bullet>(\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q))) \<rhd> P \<longmapsto> (p\<bullet>p\<bullet>K')\<lparr>N\<rparr> \<prec> P''"
    by(rule inputPermFrameSubject) (fact|simp)+
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> K'\<lparr>N\<rparr> \<prec> P''" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>\<^isub>G` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>G` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
    by(simp add: eqvts)
  have "(B @ A\<^isub>Q'', \<Psi> \<otimes> \<Psi>\<^isub>Q'', S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>Q'', \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q), S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    show "(B @ A\<^isub>Q'', \<Psi> \<otimes> \<Psi>\<^isub>Q'', S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using `(p\<bullet>\<Psi>\<^isub>Q)\<otimes>\<Psi>'' \<simeq> \<Psi>\<^isub>Q''`
      apply(drule_tac TURS'extend[where \<Psi>'=\<Psi>''])
      apply(rule TURS'statEq)
      apply assumption
      by (metis AssertionStatEqTrans Associativity compositionSym)
  qed
  hence "(B @ A\<^isub>Q'', \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>"
    by(rule TURS'parPres') (rule refl|fact)+
  hence "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>P'' \<parallel> Q''), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q'')) \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>Q'', \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>`
    have "(B, \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence 1: "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>((S \<parallel> P'') \<parallel> Q''), \<lparr>\<nu>*xvec\<rparr>((R \<parallel> P') \<parallel> Q'')) \<in> TUR' \<S>" using `xvec \<sharp>* \<Psi>`
      by(rule TURS'resChainPres)
    moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>P'' \<parallel> Q''), \<lparr>\<nu>*xvec\<rparr>(S \<parallel> P'') \<parallel> Q'') \<in> TUR' \<S>"  using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* S` `xvec \<sharp>* B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>((R \<parallel> P') \<parallel> Q''), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q'')) \<in> TUR' \<S>"  using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* R` `xvec \<sharp>* B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric)
      apply(rule bisimTransitive[OF bisimSymmetric, OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q''), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q')) \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>P', \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>`
    have "(B, \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence 1: "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>S \<parallel> Q'' \<parallel> P', \<lparr>\<nu>*xvec\<rparr>R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>" using `xvec \<sharp>* \<Psi>`
      by(rule TURS'resChainPres)
    moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q''), \<lparr>\<nu>*xvec\<rparr>S \<parallel> Q'' \<parallel> P') \<in> TUR' \<S>" using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* B` `xvec \<sharp>* S`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimTransitive, OF bisimParAssoc])
      apply(rule bisimParPresSym)
      apply(rule bisimParComm)
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>R \<parallel> Q' \<parallel> P', R \<parallel> (\<lparr>\<nu>*xvec\<rparr>P' \<parallel> Q')) \<in> TUR' \<S>" using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* B` `xvec \<sharp>* R`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain]],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimTransitive, OF bisimParAssoc])
      apply(rule bisimParPresSym)
      apply(rule bisimParComm)
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  moreover note `(B,\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q''),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q'')) \<in> TUR' \<S>`
  ultimately have "(B,\<Psi>,S\<parallel>(\<lparr>\<nu>*xvec\<rparr>P''\<parallel>Q''),R\<parallel>(\<lparr>\<nu>*xvec\<rparr>P'\<parallel>Q')) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  moreover have "\<Psi>\<^isub>G \<otimes> \<Psi>  \<rhd> P \<parallel> Q \<longmapsto> \<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P''\<parallel>Q'')"
    apply(rule statEqTransition[where \<Psi>="\<Psi> \<otimes> \<Psi>\<^isub>G"])
    apply(rule Comm1[where \<Psi>\<^isub>Q=\<Psi>\<^isub>Q and M=K' and K=M'])
    apply(rule statEqTransition)
    apply fact
    apply (metis AssertionStatEqTrans Commutativity associativitySym)
    apply fact
    apply(rule statEqTransition)
    apply fact
    apply (metis AssertionStatEqTrans Commutativity associativitySym)
    apply fact
    apply(rule statEqEnt)
    defer
    apply fact
    apply(rule freshCompChain)
    apply fact+
    apply(rule freshCompChain)
    apply fact+
    by(metis Commutativity Composition)+
  ultimately show ?case by blast
next
  case(cComm2 \<Psi> \<Psi>\<^isub>P Q K xvec N Q' A\<^isub>Q \<Psi>\<^isub>Q P M P' A\<^isub>P \<Psi>\<^isub>G A\<^isub>F A\<^isub>G R S B)
  from `B \<sharp>* (\<lparr>\<nu>*xvec\<rparr>Q' \<parallel> P')` `xvec \<sharp>* B` have "B \<sharp>* P'" "B \<sharp>* Q'"
    by simp+
  from `B \<sharp>* (Q \<parallel> P)` have "B \<sharp>* P" and "B \<sharp>* Q"
    by simp+
  from `A\<^isub>F \<sharp>* (Q \<parallel> P)` have "A\<^isub>F \<sharp>* P" and "A\<^isub>F \<sharp>* Q"
    by simp+
  from `A\<^isub>G \<sharp>* (Q \<parallel> P)` have "A\<^isub>G \<sharp>* P" and "A\<^isub>G \<sharp>* Q"
    by simp+
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> M\<lparr>N\<rparr> \<prec> P'`
  obtain M' where "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'" and "B \<sharp>* M'" and "A\<^isub>Q \<sharp>* M'" and "xvec \<sharp>* M'" and "A\<^isub>F \<sharp>* M'" and "A\<^isub>G \<sharp>* M'" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `B \<sharp>* P` `A\<^isub>Q \<sharp>* P` `A\<^isub>P \<sharp>* P` `xvec \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* B` `A\<^isub>P \<sharp>* xvec` `A\<^isub>Q \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* M` `A\<^isub>F \<sharp>* P` `A\<^isub>G \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G`
    by(rule_tac obtainPrefix[where B="(B@A\<^isub>Q@xvec@A\<^isub>F@A\<^isub>G)" and \<Psi>="\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q" and \<alpha> = "M\<lparr>N\<rparr>"]) auto
  from `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `distinct xvec`
  obtain K' where "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'" and "B \<sharp>* K'" and "A\<^isub>P \<sharp>* K'" and "xvec \<sharp>* K'" and "A\<^isub>G \<sharp>* K'" and "A\<^isub>F \<sharp>* K'" using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q` `B \<sharp>* Q` `A\<^isub>P \<sharp>* Q` `A\<^isub>Q \<sharp>* Q` `A\<^isub>F \<sharp>* Q` `A\<^isub>G \<sharp>* Q` `xvec \<sharp>* Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* B` `A\<^isub>Q \<sharp>* xvec` `A\<^isub>Q \<sharp>* A\<^isub>P` `A\<^isub>Q \<sharp>* K` `xvec \<sharp>* K` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G`
    by(rule_tac obtainPrefix[where B="(B@A\<^isub>P@xvec@A\<^isub>F@A\<^isub>G)" and \<Psi>="\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P" and \<alpha> = "K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>"]) auto
  have "\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
  proof -
    note `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* K` `A\<^isub>Q \<sharp>* Q`
    moreover from `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'` `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<turnstile> K \<leftrightarrow> M`
    have "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> M'"
      apply(rule_tac chanEqTrans[where N=M])
      by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
    ultimately show ?thesis
      by(rule_tac outputRenameSubject[where M=K]) auto
  qed
  note `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> M\<lparr>N\<rparr> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* K'` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* P`
  moreover from `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>Q \<turnstile> K \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'` `\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<turnstile> K \<leftrightarrow> M`
  have "(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> K'"
    apply(rule_tac chanEqTrans[where N=M'])
    apply assumption
    apply(rule_tac chanEqTrans[where N=M])
    apply(rule chanEqSym,assumption)
    apply(rule_tac chanEqTrans[where N=K])
    by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
  ultimately have "\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> K'\<lparr>N\<rparr> \<prec> P'"
    by(rule_tac inputRenameSubject[where M=M]) auto
  have "A\<^isub>F \<sharp>* \<Psi>\<^isub>P" "A\<^isub>G \<sharp>* \<Psi>\<^isub>P" using `A\<^isub>F \<sharp>* P` `A\<^isub>G \<sharp>* P` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G`
    by(drule_tac extractFrameFreshChain,force)+
  have "A\<^isub>F \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>G \<sharp>* \<Psi>\<^isub>Q" using `A\<^isub>F \<sharp>* Q` `A\<^isub>G \<sharp>* Q` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G`
    by(drule_tac extractFrameFreshChain,force)+
  have "(\<Psi>\<^isub>F \<otimes> \<Psi>) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q \<turnstile> K' \<leftrightarrow> M'" using `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> K'` `(\<Psi>\<^isub>F \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> M'`
    apply(rule_tac chanEqTrans[where N=M])
    by(metis AssertionStatEqSym AssertionStatEq_def AssertionStatImpTrans AssertionStatImp_def Associativity Commutativity Identity chanEqSym compositionSym statEqEnt)+
  hence "insertAssertion (extractFrame R) (\<Psi>\<otimes>\<Psi>\<^isub>Q\<otimes>\<Psi>\<^isub>P) \<turnstile>\<^sub>F K' \<leftrightarrow> M'" using `extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>` `A\<^isub>F \<sharp>* \<Psi>` `A\<^isub>F \<sharp>* \<Psi>\<^isub>P` `A\<^isub>F \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>F \<sharp>* K'` `A\<^isub>F \<sharp>* M'`
    apply simp
    apply(subst insertAssertionSimps)
    apply force
    apply(rule frameImpI)
    apply(rule refl)
    apply force
    by (metis Associativity Commutativity associativitySym statEqEnt)
  moreover have "\<not> clauseDom(K' \<leftrightarrow> M')" by auto
  moreover note `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S`
  ultimately have "insertAssertion (extractFrame S) (\<Psi>\<otimes>\<Psi>\<^isub>Q\<otimes>\<Psi>\<^isub>P) \<turnstile>\<^sub>F K' \<leftrightarrow> M'"
    by(blast dest: hobisimE)
  hence "(\<Psi>\<^isub>G \<otimes> \<Psi>) \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<turnstile> K' \<leftrightarrow> M'" using `extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* \<Psi>\<^isub>P` `A\<^isub>G \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>G \<sharp>* M'` `A\<^isub>G \<sharp>* K'`
    apply simp
    apply(subst (asm) insertAssertionSimps)
    apply force
    apply(drule frameImpE)
    apply force
    by (metis Associativity Commutativity statEqEnt)
  obtain A\<^isub>P' \<Psi>\<^isub>P' \<Psi>' where "\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'" and "extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>" and "A\<^isub>P' \<sharp>* P'" and "A\<^isub>P' \<sharp>* K'" "A\<^isub>P' \<sharp>* N" "A\<^isub>P' \<sharp>* xvec" and "distinct A\<^isub>P'" "A\<^isub>P' \<sharp>* S" "A\<^isub>P' \<sharp>* P'" "A\<^isub>P' \<sharp>* Q" "A\<^isub>P' \<sharp>* \<Psi>"  "A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>P' \<sharp>* B" "A\<^isub>P' \<sharp>* \<Psi>\<^isub>F" "A\<^isub>P' \<sharp>* \<Psi>\<^isub>G" "A\<^isub>P' \<sharp>* A\<^isub>F" "A\<^isub>P' \<sharp>* A\<^isub>G" "A\<^isub>P' \<sharp>* R" "A\<^isub>P' \<sharp>* A\<^isub>Q" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `A\<^isub>P \<sharp>* K'` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* S` `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* \<Psi>`  `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>P \<sharp>* B` `A\<^isub>P \<sharp>* \<Psi>\<^isub>F` `A\<^isub>P \<sharp>* \<Psi>\<^isub>G` `A\<^isub>P \<sharp>* A\<^isub>F` `A\<^isub>P \<sharp>* A\<^isub>G` `A\<^isub>P \<sharp>* R` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* xvec` `A\<^isub>Q \<sharp>* A\<^isub>P`
    by(rule_tac expandFrame[where C="(S,Q,P',\<Psi>,\<Psi>\<^isub>Q,B,\<Psi>\<^isub>F,\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,A\<^isub>Q,R,xvec)" and C'="[]", OF `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q  \<rhd> P \<longmapsto>K'\<lparr>N\<rparr> \<prec> P'`]) auto
  have "A\<^isub>F \<sharp>* N" "A\<^isub>F \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* A\<^isub>F` `A\<^isub>F \<sharp>* \<Psi>` `A\<^isub>F \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "A\<^isub>G \<sharp>* N" "A\<^isub>G \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* A\<^isub>G` `A\<^isub>G \<sharp>* \<Psi>` `A\<^isub>G \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "B \<sharp>* N" "B \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `xvec \<sharp>* B` `B \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "A\<^isub>P' \<sharp>* N" "A\<^isub>P' \<sharp>* Q'" using `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `A\<^isub>P' \<sharp>* xvec` `A\<^isub>P' \<sharp>* Q` `distinct xvec` `xvec \<sharp>* K`
    by(auto dest: outputFreshChainDerivative)
  have "\<exists> Q''. \<Psi>\<^isub>G\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>P  \<rhd> Q \<longmapsto>M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'' \<and> (B@A\<^isub>P',\<Psi>\<otimes>\<Psi>\<^isub>P,S\<parallel>Q'',R\<parallel>Q') \<in> TUR' \<S>"
    apply(rule_tac transferHONonTauFrame)
    apply(fact|simp)+
    apply(rule hostatEqBisim)
    apply fact
    apply (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
    apply(fact|rule freshCompChain|simp|rule conjI|subst freshChainSym)+
    done
  then obtain Q'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''" and "(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>"
    by blast
  from `(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>` have "(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P', S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>" using `\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'`
    apply(drule_tac TURS'extend[where \<Psi>'=\<Psi>'])
    apply(rule TURS'statEq)
    apply assumption
    by (metis AssertionStatEqTrans Associativity compositionSym)
  hence "(B @ A\<^isub>P', \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>" using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* \<Psi>` `A\<^isub>P' \<sharp>* P'` `A\<^isub>P' \<sharp>* Q'` `distinct A\<^isub>P'` `B \<sharp>* P'`
    by(rule_tac TURS'parPres') auto
  have "B \<sharp>* Q''" and "A\<^isub>P' \<sharp>* Q''" using `(B @ A\<^isub>P', \<Psi> \<otimes> \<Psi>\<^isub>P, S \<parallel> Q'', R \<parallel> Q') \<in> TUR' \<S>`
    unfolding TUR'_def
    by(auto dest: fresh_rel_trancl_fresh)
  from `\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto> M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `xvec \<sharp>* M'` `distinct xvec` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* xvec` `A\<^isub>Q \<sharp>* N` `A\<^isub>Q \<sharp>* Q` `distinct A\<^isub>Q` `xvec \<sharp>* Q`
  `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>F` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>P` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* P'` `A\<^isub>Q \<sharp>* K` `A\<^isub>Q \<sharp>* Q'` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>G` `A\<^isub>Q \<sharp>* A\<^isub>F` `A\<^isub>Q \<sharp>* A\<^isub>G` `A\<^isub>Q \<sharp>* R` `A\<^isub>Q \<sharp>* S` `A\<^isub>Q \<sharp>* B` `A\<^isub>Q \<sharp>* A\<^isub>P` `A\<^isub>P' \<sharp>* A\<^isub>Q`
  `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>F` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* P` `xvec \<sharp>* K` `xvec \<sharp>* \<Psi>\<^isub>G` `xvec \<sharp>* A\<^isub>F` `xvec \<sharp>* A\<^isub>G` `xvec \<sharp>* R` `xvec \<sharp>* S` `xvec \<sharp>* B` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P' \<sharp>* xvec`
  obtain p \<Psi>'' A\<^isub>Q'' \<Psi>\<^isub>Q'' where "set p \<subseteq> set(xvec) \<times> set(p\<bullet>xvec)" and "(p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>Q''" and "distinctPerm p" and
    "extractFrame Q'' = \<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>" and "A\<^isub>Q'' \<sharp>* Q''" and "A\<^isub>Q'' \<sharp>* M'"  and "A\<^isub>Q'' \<sharp>* xvec"  and "A\<^isub>Q'' \<sharp>* N" and "A\<^isub>Q'' \<sharp>* (p\<bullet>M')" and
    "A\<^isub>Q'' \<sharp>* (p\<bullet>xvec)"  and "A\<^isub>Q'' \<sharp>* (p\<bullet>N)"  and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* Q''" and "distinct A\<^isub>Q''"
    and "A\<^isub>Q'' \<sharp>* \<Psi>" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>F" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P" "A\<^isub>Q'' \<sharp>* P" "A\<^isub>Q'' \<sharp>* P'" "A\<^isub>Q'' \<sharp>* K" "A\<^isub>Q'' \<sharp>* Q'" "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>G" "A\<^isub>Q'' \<sharp>* A\<^isub>F" "A\<^isub>Q'' \<sharp>* A\<^isub>G" "A\<^isub>Q'' \<sharp>* R" "A\<^isub>Q'' \<sharp>* S" "A\<^isub>Q'' \<sharp>* B" "A\<^isub>P \<sharp>* A\<^isub>Q''" "A\<^isub>P' \<sharp>* A\<^isub>Q''" "A\<^isub>Q'' \<sharp>* Q"
    and "(p\<bullet>xvec) \<sharp>* \<Psi>" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>F" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P" "(p\<bullet>xvec) \<sharp>* P" "(p\<bullet>xvec) \<sharp>* K" "(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>G" "(p\<bullet>xvec) \<sharp>* A\<^isub>F" "(p\<bullet>xvec) \<sharp>* A\<^isub>G" "(p\<bullet>xvec) \<sharp>* R" "(p\<bullet>xvec) \<sharp>* S" "(p\<bullet>xvec) \<sharp>* B" "A\<^isub>P \<sharp>* (p\<bullet>xvec)" "A\<^isub>P' \<sharp>* (p\<bullet>xvec)" "(p\<bullet>xvec) \<sharp>* Q"
    apply(rule_tac expandFrame[where C="(\<Psi>,\<Psi>\<^isub>F,\<Psi>\<^isub>P,P,P',K,Q',\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,R,S,B,A\<^isub>P,A\<^isub>P',Q)" and C'="(\<Psi>,\<Psi>\<^isub>F,\<Psi>\<^isub>P,P,K,\<Psi>\<^isub>G,A\<^isub>F,A\<^isub>G,R,S,B,A\<^isub>P,A\<^isub>P',Q)" and \<alpha>="M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>"])
    unfolding eqvts
    by auto
  have "\<Psi> \<otimes> (\<Psi>\<^isub>Q'' \<otimes> \<Psi>\<^isub>P') \<rhd> R \<sim>\<^sub>H S"
  proof -
    from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S` have "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R` `xvec \<sharp>* S` `(p\<bullet>xvec) \<sharp>* S`
      by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
    thus ?thesis using `\<Psi>\<^isub>P \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'` `(p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>Q''`
      apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>'\<otimes>\<Psi>''"])
      apply(rule hostatEqBisim)
      apply assumption
      apply(rule AssertionStatEqTrans[OF Associativity])
      apply(rule compositionSym)
      apply(rule AssertionStatEqSym)
      apply(rule AssertionStatEqTrans[OF Composition, OF AssertionStatEqSym], assumption)
      apply(rule AssertionStatEqTrans[OF compositionSym, OF AssertionStatEqSym], assumption)
      by(metis AssertionStatEqSym AssertionStatEqTrans Associativity Composition associativitySym)
  qed
  have "A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P'" using `A\<^isub>Q'' \<sharp>* P'` `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''`
    by(drule_tac extractFrameFreshChain) force
  have "A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q''" using `A\<^isub>P' \<sharp>* Q''` `extractFrame Q'' = \<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''`
    by(drule_tac extractFrameFreshChain) force
  from `\<Psi> \<otimes> (\<Psi>\<^isub>Q'' \<otimes> \<Psi>\<^isub>P') \<rhd> R \<sim>\<^sub>H S` have "(\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P'),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P')) \<in> \<S>"
    using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `extractFrame Q''=\<langle>A\<^isub>Q'',\<Psi>\<^isub>Q''\<rangle>` `A\<^isub>P' \<sharp>* A\<^isub>Q''` `A\<^isub>P' \<sharp>* \<Psi>` `A\<^isub>Q'' \<sharp>* \<Psi>` `A\<^isub>P' \<sharp>* R` `A\<^isub>Q'' \<sharp>* R` `A\<^isub>P' \<sharp>* S` `A\<^isub>Q'' \<sharp>* S` `A\<^isub>Q'' \<sharp>* \<Psi>\<^isub>P'` `A\<^isub>P' \<sharp>* \<Psi>\<^isub>Q''` `A\<^isub>P' \<sharp>* xvec` `A\<^isub>Q'' \<sharp>* xvec` `xvec \<sharp>* R` `xvec \<sharp>* S` `xvec \<sharp>* \<Psi>`
    unfolding \<S>_def
    apply(auto simp add: psi.inject frameChainAppend[symmetric])
    apply(rule_tac exI)
    apply(rule_tac exI)
    apply(rule conjI)
    apply(rule refl)
    by auto
  hence "(B,\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P'),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P')) \<in> TUR' \<S>"
    unfolding TUR'_def using `B \<sharp>* R` `B \<sharp>* S` `xvec \<sharp>* B` `B \<sharp>* P'` `B \<sharp>* Q''`
    by(auto simp add: exI[where x="[]"])
  from `\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q  \<rhd> P \<longmapsto>K'\<lparr>N\<rparr> \<prec> P'`
  have "(p\<bullet>(\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>\<Psi>\<^isub>Q))  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'"
    by(rule inputPermFrameSubject) (simp|fact)+
  hence "\<Psi>\<^isub>F\<otimes>\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q)  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>\<^isub>F` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>F` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
    by(simp add: eqvts)
  have "(\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>Q)) \<otimes> \<Psi>\<^isub>P  \<rhd> R \<sim>\<^sub>H S" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R` `xvec \<sharp>* S` `(p\<bullet>xvec) \<sharp>* S`
    apply(rule_tac hostatEqBisim[where \<Psi>="\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<otimes> \<Psi>\<^isub>P"])
    apply(drule_tac hobisimClosed[where p=p])
    apply(simp add: eqvts)
    by(metis AssertionStatEqSym Associativity)
  have "A\<^isub>F \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>F \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>F` `(p\<bullet>xvec) \<sharp>* A\<^isub>F`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>G \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>G \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>G` `(p\<bullet>xvec) \<sharp>* A\<^isub>G`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>P \<sharp>* (p \<bullet> \<Psi>\<^isub>Q)" using `A\<^isub>P \<sharp>* \<Psi>\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* (p\<bullet>xvec)`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>F \<sharp>* (p \<bullet> K')" using `A\<^isub>F \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>F` `(p\<bullet>xvec) \<sharp>* A\<^isub>F`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>G \<sharp>* (p \<bullet> K')" using `A\<^isub>G \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* A\<^isub>G` `(p\<bullet>xvec) \<sharp>* A\<^isub>G`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "A\<^isub>P \<sharp>* (p \<bullet> K')" using `A\<^isub>P \<sharp>* K'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`  `A\<^isub>P \<sharp>* xvec` `A\<^isub>P \<sharp>* (p\<bullet>xvec)`
    by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
  have "\<exists> P''. \<Psi>\<^isub>G\<otimes>\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q)  \<rhd> P \<longmapsto>(p\<bullet>K')\<lparr>N\<rparr> \<prec> P'' \<and> (B@A\<^isub>Q'',\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>Q),S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>"
    by(rule_tac transferHONonTauFrame) (fact|rule freshCompChain|simp|rule conjI|subst freshChainSym|simp)+
  then obtain P'' where "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<rhd> P \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> P''" "(B @ A\<^isub>Q'', \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q), S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
    by blast
  from `\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q) \<rhd> P \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> P''` have "(p\<bullet>(\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q))) \<rhd> P \<longmapsto> (p\<bullet>p\<bullet>K')\<lparr>N\<rparr> \<prec> P''"
    by(rule inputPermFrameSubject) (fact|simp)+
  hence "\<Psi>\<^isub>G \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto> K'\<lparr>N\<rparr> \<prec> P''" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>\<^isub>G` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>G` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
    by(simp add: eqvts)
  have "(B @ A\<^isub>Q'', \<Psi> \<otimes> \<Psi>\<^isub>Q'', S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>Q'', \<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>Q), S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>`
    show "(B @ A\<^isub>Q'', \<Psi> \<otimes> \<Psi>\<^isub>Q'', S \<parallel> P'', R \<parallel> P') \<in> TUR' \<S>" using `(p\<bullet>\<Psi>\<^isub>Q)\<otimes>\<Psi>'' \<simeq> \<Psi>\<^isub>Q''`
      apply(drule_tac TURS'extend[where \<Psi>'=\<Psi>''])
      apply(rule TURS'statEq)
      apply assumption
      by (metis AssertionStatEqTrans Associativity compositionSym)
  qed
  hence "(B @ A\<^isub>Q'', \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>"
    by(rule TURS'parPres') (rule refl|fact)+
  hence "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P''), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P')) \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>Q'', \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>`
    have "(B, \<Psi>, (S \<parallel> P'') \<parallel> Q'', (R \<parallel> P') \<parallel> Q'') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence 1: "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>((S \<parallel> P'') \<parallel> Q''), \<lparr>\<nu>*xvec\<rparr>((R \<parallel> P') \<parallel> Q'')) \<in> TUR' \<S>" using `xvec \<sharp>* \<Psi>`
      by(rule TURS'resChainPres)
    moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P''), \<lparr>\<nu>*xvec\<rparr>(S \<parallel> P'') \<parallel> Q'') \<in> TUR' \<S>"  using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* S` `xvec \<sharp>* B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimTransitive, OF bisimParAssoc])
      apply(rule bisimParPresSym)
      apply(rule bisimParComm)
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>((R \<parallel> P') \<parallel> Q''), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P')) \<in> TUR' \<S>"  using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* R` `xvec \<sharp>* B`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric)
      apply(rule bisimTransitive[OF bisimSymmetric, OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimTransitive, OF bisimParAssoc])
      apply(rule bisimParPresSym)
      apply(rule bisimParComm)
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P'), R \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q' \<parallel> P')) \<in> TUR' \<S>"
  proof -
    from `(B @ A\<^isub>P', \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>`
    have "(B, \<Psi>, S \<parallel> Q'' \<parallel> P', R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>"
      unfolding TUR'_def
      by(rule fresh_rel_trancl_weaken) auto
    hence 1: "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>S \<parallel> Q'' \<parallel> P', \<lparr>\<nu>*xvec\<rparr>R \<parallel> Q' \<parallel> P') \<in> TUR' \<S>" using `xvec \<sharp>* \<Psi>`
      by(rule TURS'resChainPres)
    moreover have "(B, \<Psi>, S \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q'' \<parallel> P'), \<lparr>\<nu>*xvec\<rparr>S \<parallel> Q'' \<parallel> P') \<in> TUR' \<S>" using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* B` `xvec \<sharp>* S`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    moreover have "(B, \<Psi>, \<lparr>\<nu>*xvec\<rparr>R \<parallel> Q' \<parallel> P', R \<parallel> (\<lparr>\<nu>*xvec\<rparr>Q' \<parallel> P')) \<in> TUR' \<S>" using 1 `xvec \<sharp>* \<Psi>` `xvec \<sharp>* B` `xvec \<sharp>* R`
      unfolding TUR'_def
      apply(rule_tac fresh_rel_trancl.intros)
      apply(rule UnI2)
      apply(rule hobisimBisim)
      apply(rule bisimSymmetric[OF bisimTransitive[OF bisimSymmetric,OF bisimScopeExtChain]],assumption,assumption)
      apply(rule bisimResChainPres)
      apply(rule bisimSymmetric[OF bisimParAssoc])
      apply assumption
      by(auto dest: fresh_rel_trancl_fresh)
    ultimately show ?thesis
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  qed
  moreover note `(B,\<Psi>,R\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P'),S\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P')) \<in> TUR' \<S>`
  ultimately have "(B,\<Psi>,S\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q''\<parallel>P''),R\<parallel>(\<lparr>\<nu>*xvec\<rparr>Q'\<parallel>P')) \<in> TUR' \<S>"
      unfolding TUR'_def
      by(blast intro: fresh_rel_trancl_transitive)
  moreover have "\<Psi>\<^isub>G \<otimes> \<Psi>  \<rhd> Q \<parallel> P \<longmapsto> \<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(Q''\<parallel>P'')"
    apply(rule statEqTransition[where \<Psi>="\<Psi> \<otimes> \<Psi>\<^isub>G"])
    apply(rule Comm2[where \<Psi>\<^isub>Q=\<Psi>\<^isub>P and M=M' and K=K'])
    apply(rule statEqTransition)
    apply fact
    apply (metis AssertionStatEqTrans Commutativity associativitySym)
    apply fact
    apply(rule statEqTransition)
    apply fact
    apply (metis AssertionStatEqTrans Commutativity associativitySym)
    apply fact
    apply(rule statEqEnt)
    defer
    apply(rule chanEqSym)
    apply fact
    apply(rule freshCompChain)
    apply fact+
    apply(rule freshCompChain)
    apply fact+
    by(metis Commutativity Composition)+
  ultimately show ?case by blast
qed    

lemma transferHOFrame:
  fixes \<Psi>\<^isub>F  :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   \<alpha>    :: "'a action"
  and   P'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>F   :: "name list"
  and   A\<^isub>G   :: "name list"
  and   \<Psi>\<^isub>G   :: 'b

  assumes "\<Psi>\<otimes>\<Psi>\<^isub>F \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
  and     "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "extractFrame R = \<langle>A\<^isub>F,\<Psi>\<^isub>F\<rangle>"
  and     "extractFrame S = \<langle>A\<^isub>G,\<Psi>\<^isub>G\<rangle>"
  and     "\<Psi>\<otimes>\<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
  and     "A\<^isub>F \<sharp>* P"
  and     "A\<^isub>F \<sharp>* \<Psi>"
  and     "A\<^isub>G \<sharp>* P"
  and     "A\<^isub>G \<sharp>* \<Psi>"
  and     "A\<^isub>F \<sharp>* \<alpha>"
  and     "A\<^isub>G \<sharp>* \<alpha>"
  and     "A\<^isub>P \<sharp>* A\<^isub>F"
  and     "A\<^isub>P \<sharp>* A\<^isub>G"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>F"
  and     "A\<^isub>P \<sharp>* \<Psi>\<^isub>G"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* S"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* P'"
  and     "A\<^isub>P \<sharp>* \<alpha>"
  and     "bn \<alpha> \<sharp>* P"
  and     "bn \<alpha> \<sharp>* R"
  and     "bn \<alpha> \<sharp>* S"
  and     "bn \<alpha> \<sharp>* \<Psi>"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "distinct(bn \<alpha>)"

  shows "\<exists> P''. \<Psi> \<otimes> \<Psi>\<^isub>G \<rhd> P \<longmapsto>\<alpha> \<prec> P'' \<and> (\<Psi>,S\<parallel>P'',R\<parallel>P') \<in> TUR \<S>"
proof -
  have "\<Psi>\<^isub>F\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'"
    apply(rule statEqTransition)
    defer
    apply(rule Commutativity)
    by fact
  hence "\<exists> P''. \<Psi>\<^isub>G\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'' \<and> ([]::name list,\<Psi>,S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>" using assms
    apply(cases "\<alpha>=\<tau>")
    apply(rule_tac transferHOTauFrame[where \<Psi>=\<Psi> and \<Psi>\<^isub>F=\<Psi>\<^isub>F and A\<^isub>P = A\<^isub>P and A\<^isub>F = A\<^isub>F and A\<^isub>G = A\<^isub>G])
    apply auto
    apply(rule_tac transferHONonTauFrame[where \<Psi>=\<Psi> and \<Psi>\<^isub>F=\<Psi>\<^isub>F and A\<^isub>P = A\<^isub>P and A\<^isub>F = A\<^isub>F and A\<^isub>G = A\<^isub>G])
    apply auto
    done
  then obtain P'' where "\<Psi>\<^isub>G\<otimes>\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P''" and "([]::name list,\<Psi>,S\<parallel>P'',R\<parallel>P') \<in> TUR' \<S>"
    by blast
  moreover hence "\<Psi>\<otimes>\<Psi>\<^isub>G \<rhd> P \<longmapsto>\<alpha> \<prec> P''"
    apply(rule_tac statEqTransition)
    defer
    apply(rule Commutativity)
    by assumption
  ultimately show ?thesis
    unfolding TUR'_def TUR_def
    by auto
qed

lemma \<F>idem[simp]:
  shows "\<F>(\<F> P) = \<F> P"
proof -
  obtain A \<Psi> where "extractFrame P = \<langle>A,\<Psi>\<rangle>"
    by(rule_tac freshFrame[where C="()"])
  thus ?thesis
    by simp
qed

lemma hobisim\<F>Pres:
  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  shows "\<Psi> \<rhd> \<F> P \<sim>\<^sub>H \<F> Q"
proof -
  let ?X = "{(\<Psi>,\<F> P, \<F> Q)| \<Psi> P Q. \<Psi> \<rhd> P \<sim>\<^sub>H Q}"
  have "(\<Psi>,\<F> P, \<F> Q) \<in> ?X" using assms by auto
  thus ?thesis
  proof(coinduct rule: hobisimCoinduct)
    case(cStatEq \<Psi> R S \<phi>)
    thus ?case
      by(auto dest: hobisimE)
  next
    case cClauseEq thus ?case
      by auto (blast dest: hobisimE)
  next
    case cSim
    moreover have "eqvt(?X \<union> hobisim)"
      apply(auto simp add: eqvt_def eqvts hobisimClosed dest: \<F>nilTrans)
      apply(rule_tac x="p\<bullet>P" in exI)
      apply auto
      apply(rule_tac x="p\<bullet>Q" in exI)
      by(auto simp add: eqvt_def eqvts hobisimClosed)
    ultimately show ?case
      by(auto intro: simI dest: \<F>nilTrans)
  next
    case cSym thus ?case
      by(auto intro: hobisimE)
  next
    case cExt thus ?case
      by(auto intro: hobisimE)
  qed
qed

(*lemma resChainFreshSet':
  fixes   xvec :: "name list"
  and   yvec :: "name list"
  and   P    :: "('a::fs_name, 'b::fs_name, 'c::fs_name) psi"
  assumes "(set yvec \<subseteq> set xvec \<or> yvec \<sharp>* P)"
  shows   "yvec \<sharp>* (\<lparr>\<nu>*xvec\<rparr>P)"
  using assms
  by(subst resChainFreshSet) (auto simp add: fresh_star_def)*)


lemma semanticsFramePsiOutputInduct'[consumes 5, case_names cAlpha cFrameAlpha cOutput cCase cPar1 cPar2 cOpen cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   Rs   :: "('a, 'b, 'c) residual"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow> 'a \<Rightarrow> name list \<Rightarrow> 'a \<Rightarrow>
                 ('a, 'b, 'c) psi \<Rightarrow> name list \<Rightarrow> 'b \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes Trans: "\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "xvec \<sharp>* M"
  and     "distinct xvec"
  and     rAlpha: "\<And>\<Psi> P M xvec N P' p A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P;
                                           xvec \<sharp>* C; xvec \<sharp>* (p \<bullet> xvec); xvec \<sharp>* (p \<bullet> N); A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M;  A\<^isub>P \<sharp>* N;  A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C;
                                           set p \<subseteq> set(xvec) \<times> set(p\<bullet>xvec); distinctPerm p;
                                           (p \<bullet> xvec) \<sharp>* M; (p \<bullet> xvec) \<sharp>* N; (p \<bullet> xvec) \<sharp>* xvec;
                                           (p \<bullet> xvec) \<sharp>* P'; Prop C \<Psi>' \<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P; distinct xvec\<rbrakk> \<Longrightarrow>
                                           Prop C \<Psi>' \<Psi> P M (p\<bullet>xvec) (p\<bullet>N) (p \<bullet> P') A\<^isub>P \<Psi>\<^isub>P"
  and     rFrameAlpha: "\<And>\<Psi> P A\<^isub>P \<Psi>\<^isub>P p M xvec N P' C. \<lbrakk>A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>';A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* (p \<bullet> A\<^isub>P); A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C;
                                                set p \<subseteq> set A\<^isub>P \<times> set(p \<bullet> A\<^isub>P); distinctPerm p; A\<^isub>P \<sharp>* M;
                                                Prop C \<Psi>' \<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P M xvec N P' (p \<bullet> A\<^isub>P) (p \<bullet> \<Psi>\<^isub>P)"
  and     rOutput: "\<And> \<Psi> M K N P C. \<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K \<Longrightarrow> Prop C \<Psi>' \<Psi> (M\<langle>N\<rangle>.P) K [] N P ([]) (\<one>)"
  and     rCase: "\<And>\<Psi> P M xvec N P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P; \<And>C. Prop C \<Psi>' \<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P;
                                            (\<phi>, P) mem Cs; \<Psi>'\<otimes>\<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>;  \<Psi>\<^isub>P \<simeq> \<one>; (supp \<Psi>\<^isub>P) = ({}::name set);
                                            A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (Cases Cs) M xvec N P' ([]) (\<one>)"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P M xvec N P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P M xvec N P' A\<^isub>P \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* M; A\<^isub>Q \<sharp>* xvec; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* Q; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) M xvec N (P' \<parallel> Q) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q M xvec N Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q M xvec N Q' A\<^isub>Q \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* M; A\<^isub>Q \<sharp>* xvec; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* Q'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* Q; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P; xvec \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) M xvec N (P \<parallel> Q') (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rOpen: "\<And>\<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P y C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P  M (xvec@yvec) (N) P' A\<^isub>P \<Psi>\<^isub>P; x \<in> supp N; x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M;
                     x \<sharp> A\<^isub>P; x \<sharp> xvec; x \<sharp> yvec; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';
                     A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* yvec; xvec \<sharp>* yvec; distinct xvec; distinct yvec;
                     xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P; 
                     yvec \<sharp>* \<Psi>; yvec \<sharp>* \<Psi>'; yvec \<sharp>* P; yvec \<sharp>* M; A\<^isub>P \<sharp>* C; x \<sharp> C; xvec \<sharp>* C; yvec \<sharp>* C;
                     y \<noteq> x; y \<sharp> \<Psi>; y \<sharp> \<Psi>'; y \<sharp> P; y \<sharp> M; y \<sharp> xvec; y \<sharp> yvec; y \<sharp> N; y \<sharp> P'; y \<sharp> A\<^isub>P; y \<sharp> \<Psi>\<^isub>P; y \<sharp> C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) M (xvec@y#yvec) ([(x, y)] \<bullet> N) ([(x, y)] \<bullet> P') (x#A\<^isub>P) \<Psi>\<^isub>P" 
  and     rScope: "\<And>\<Psi> P M xvec N P' x A\<^isub>P \<Psi>\<^isub>P C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P;
                     x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M; x \<sharp> xvec; x \<sharp> N; x \<sharp> A\<^isub>P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* P;
                     A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';
                     xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* P; xvec \<sharp>* M; xvec \<sharp>* \<Psi>\<^isub>P;
                     A\<^isub>P \<sharp>* C; x \<sharp> C; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) M xvec N (\<lparr>\<nu>x\<rparr>P') (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rBang:    "\<And>\<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P C.
                     \<lbrakk>\<Psi>'\<otimes>\<Psi> \<rhd> P \<parallel> !P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; guarded P; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                      \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) M xvec N P' A\<^isub>P (\<Psi>\<^isub>P \<otimes> \<one>); \<Psi>\<^isub>P \<simeq> \<one>; supp \<Psi>\<^isub>P = ({}::name set);
                      A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (!P) M xvec N P' ([]) (\<one>)"
  and     rInv:   "\<And>\<Psi> M P M' xvec N P' A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>'\<otimes>\<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>'\<otimes>\<Psi> \<rhd> P \<longmapsto>M'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    distinct(xvec);
                    extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* M'; A\<^isub>P \<sharp>* xvec; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';  A\<^isub>P \<sharp>* C;  A\<^isub>P \<sharp>* M;
                    xvec \<sharp>* P; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>'; xvec \<sharp>* M';
                    xvec \<sharp>* M; xvec \<sharp>* C;
                    \<And> C. Prop C \<Psi>' \<Psi> P M' xvec N P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) M' xvec N P' ([]) (\<one>)"
  shows "Prop C \<Psi>' \<Psi> P M xvec N P' A\<^isub>P \<Psi>\<^isub>P"
proof - 
  note Trans FrP `distinct A\<^isub>P`
  moreover from `xvec \<sharp>* M` and `distinct xvec`
  have "bn(M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>) \<sharp>* subject(M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>)" and "distinct(bn(M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>))"
    by simp+
  ultimately show ?thesis using `distinct xvec`
  proof(nominal_induct \<Psi>' \<Psi> P \<alpha>\<equiv>"M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>" P' A\<^isub>P \<Psi>\<^isub>P avoiding: C arbitrary: M xvec N rule: semanticsFramePsiInduct')
    case(cAlpha \<Psi> P \<alpha> P' p A\<^isub>P \<Psi>\<^isub>P C M xvec N)
    from `(p \<bullet> \<alpha>) = M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>` have "(p \<bullet> p \<bullet> \<alpha>) = p \<bullet> (M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle>)"
      by(simp add: fresh_bij)
    with `distinctPerm p` have A: "\<alpha> = (p \<bullet> M)\<lparr>\<nu>*(p \<bullet> xvec)\<rparr>\<langle>(p \<bullet> N)\<rangle>"
      by(simp add: eqvts)
    with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* \<Psi>'` `bn \<alpha> \<sharp>* \<Psi>\<^isub>P` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* subject \<alpha> ` `bn \<alpha> \<sharp>* C` `bn \<alpha> \<sharp>* (p \<bullet> \<alpha>)` `distinctPerm p`
    have "(p \<bullet> xvec) \<sharp>* \<Psi>" and "(p \<bullet> xvec) \<sharp>* \<Psi>'" and "(p \<bullet> xvec) \<sharp>* \<Psi>\<^isub>P" and  "(p \<bullet> xvec) \<sharp>* P" and  "(p \<bullet> xvec) \<sharp>* (p \<bullet> M)" and  "(p \<bullet> xvec) \<sharp>* C" and  "(p \<bullet> xvec) \<sharp>* (p \<bullet> p \<bullet> xvec)"
      by auto
    moreover from A `set p \<subseteq> set(bn \<alpha>) \<times> set(bn(p \<bullet> \<alpha>))` `distinctPerm p`
    have S: "set p \<subseteq> set(p \<bullet> xvec) \<times> set(p \<bullet> p \<bullet> xvec)" by simp
    moreover note `distinctPerm p`
    moreover from A `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn(p \<bullet> \<alpha>) \<sharp>* P'` `distinctPerm p`
    have "(p \<bullet> xvec) \<sharp>* (p \<bullet> p\<bullet> N)" and "(p \<bullet> p \<bullet> xvec) \<sharp>* P'" and "(p \<bullet> p \<bullet> xvec) \<sharp>* (p \<bullet> M)" and "(p \<bullet> p \<bullet> xvec) \<sharp>* (p \<bullet> N)" and "(p \<bullet> p \<bullet> xvec) \<sharp>* (p\<bullet>xvec)"
      apply -
      apply(subst perm_bool[where pi=p,symmetric])
      apply(simp add: eqvts)
      apply simp+
      done
    moreover from A `distinct xvec` have "Prop C \<Psi>' \<Psi> P (p \<bullet> M) (p \<bullet> xvec) (p \<bullet> N) P'  A\<^isub>P \<Psi>\<^isub>P"
      by(rule_tac cAlpha) auto
    moreover note `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>'` `A\<^isub>P \<sharp>* P`
    moreover from `A\<^isub>P \<sharp>* \<alpha>` A have "A\<^isub>P \<sharp>* (p\<bullet>M)" "A\<^isub>P \<sharp>* (p\<bullet>N)" "A\<^isub>P \<sharp>* (p\<bullet>xvec)"
      by simp+
    moreover note `A\<^isub>P \<sharp>* P'` `A\<^isub>P \<sharp>* C`
    moreover from `distinct xvec` have "distinct(p\<bullet>xvec)"
      by simp
    ultimately have "Prop C \<Psi>' \<Psi> P (p \<bullet> M) (p \<bullet> p \<bullet> xvec) (p \<bullet> p \<bullet> N) (p \<bullet> P') A\<^isub>P \<Psi>\<^isub>P"
      by(rule_tac rAlpha)
    moreover from A `bn \<alpha> \<sharp>* subject \<alpha>` have "(p \<bullet> xvec) \<sharp>* (p \<bullet> M)" by simp
    hence "xvec \<sharp>* M" by(simp add: fresh_star_bij)
    from A `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `distinctPerm p` have "xvec \<sharp>* (p \<bullet> M)" by simp
    hence "(p \<bullet> xvec) \<sharp>* (p \<bullet> p \<bullet> M)" by(simp add: fresh_star_bij)
    with `distinctPerm p` have "(p \<bullet> xvec) \<sharp>* M" by simp
    with `xvec \<sharp>* M` S `distinctPerm p` have  "(p \<bullet> M) = M" by simp
    ultimately show ?case using S `distinctPerm p` by simp 
  next
    case(cFrameAlpha \<Psi> P A\<^isub>P \<Psi>\<^isub>P p P' C M xvec N)
    thus ?case
      by(rule_tac rFrameAlpha) auto
  next
    case cInput thus ?case
      by simp
  next
    case(cOutput \<Psi> M K N P C M' xvec N')
    hence "M' = K" and "xvec = []" and "N' = N"
      by(auto simp add: action.inject)
    thus ?case using cOutput
      by(simp add: rOutput)
  next
    case(cCase \<Psi> P P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P C M xvec N)
    thus ?case
      by(auto intro: rCase)
  next
    case cPar1
    thus ?case
      by(auto intro: rPar1)
  next
    case cPar2
    thus ?case
      by(auto intro: rPar2)
  next
    case cComm1
    thus ?case by simp
  next
    case cComm2
    thus ?case by simp
  next
    case(cOpen \<Psi> P M xvec yvec N P' x A\<^isub>P \<Psi>\<^isub>P y C M' xvec' N')
    from `M\<lparr>\<nu>*(xvec @ y # yvec)\<rparr>\<langle>([(x, y)] \<bullet> N)\<rangle> = M'\<lparr>\<nu>*xvec'\<rparr>\<langle>N'\<rangle>`
    have "M' = M" and "xvec' = (xvec @ y # yvec)" and "N' = ([(x, y)] \<bullet> N)"
      by(auto simp add: action.inject)
    thus ?case using cOpen
      by(auto intro: rOpen)
  next
    case cScope
    thus ?case by(auto intro: rScope)
  next
    case cBang
    thus ?case by(auto intro: rBang)
  next
    case cInv
    thus ?case
      by(auto intro: rInv)
  qed
qed

lemma hocomm1AuxAux:
  fixes \<Psi>    :: 'b
  and   \<Psi>\<^isub>Q   :: 'b
  and   R    :: "('a, 'b, 'c) psi"
  and   K    :: 'a
  and   xvec :: "name list"
  and   N    :: 'a
  and   R'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>R   :: "name list"
  and   \<Psi>\<^isub>R   :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   M    :: 'a
  and   L    :: 'a
  and   P'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   A\<^isub>Q   :: "name list"
  and   B   :: "name list"

  assumes RTrans: "\<Psi>\<^isub>Q \<otimes> \<Psi>  \<rhd> R \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'"
  and     FrR: "extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>"
  and     "distinct A\<^isub>R"
  and     "xvec \<sharp>* K"
  and     "distinct xvec"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "distinct A\<^isub>Q"
  and     "xvec \<sharp>* P"
  and     "xvec \<sharp>* Q"
  and     "xvec \<sharp>* R"
  and     "xvec \<sharp>* \<Psi>"
  and     "xvec \<sharp>* \<Psi>\<^isub>R"
  and     "xvec \<sharp>* \<Psi>\<^isub>Q"
  and     "xvec \<sharp>* \<Psi>\<^isub>P"
  and     "xvec \<sharp>* M"
  and     "xvec \<sharp>* A\<^isub>R"
  and     "xvec \<sharp>* A\<^isub>P"
  and     "xvec \<sharp>* A\<^isub>Q"
  and     PTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>L\<rparr> \<prec> P'"
(*  and     QTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto>M\<lparr>L\<rparr> \<prec> Q'"*)
  and     MeqK: "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
  and     PeqQ: "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
(*  and     P'eqQ': "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P' \<sim>\<^sub>H Q'"*)
  and     FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>"
  and     "A\<^isub>R \<sharp>* A\<^isub>P"
  and     "A\<^isub>R \<sharp>* A\<^isub>Q"
  and     "A\<^isub>R \<sharp>* \<Psi>"
  and     "A\<^isub>R \<sharp>* P"
  and     "A\<^isub>R \<sharp>* Q"
  and     "A\<^isub>R \<sharp>* P'"
  and     "A\<^isub>R \<sharp>* R"
  and     "A\<^isub>R \<sharp>* K"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* Q"
  and     "A\<^isub>P \<sharp>* M"
  and     "A\<^isub>P \<sharp>* A\<^isub>Q"
  and     "A\<^isub>Q \<sharp>* \<Psi>"
  and     "A\<^isub>Q \<sharp>* R"
  and     "A\<^isub>Q \<sharp>* P"
  and     "A\<^isub>Q \<sharp>* Q"
  and     "A\<^isub>Q \<sharp>* M"
  and     "B \<sharp>* R" "B \<sharp>* xvec" "B \<sharp>* N" "B \<sharp>* A\<^isub>R" "B \<sharp>* A\<^isub>Q" "B \<sharp>* P'"

  obtains K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" and "(B,\<Psi>\<otimes>\<Psi>\<^isub>P,R'',R') \<in> TUR' \<S>"
proof -
  assume A: "(\<And>K' R''. \<lbrakk>\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''; \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'; A\<^isub>R \<sharp>* K'; (B, \<Psi> \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>\<rbrakk> \<Longrightarrow> thesis)"
  {
    fix C::"name list"
    assume as: "C \<sharp>* P" "C \<sharp>* Q" "C \<sharp>* R" "C \<sharp>* xvec" "C \<sharp>* N" "C \<sharp>* A\<^isub>R" "C \<sharp>* A\<^isub>Q" "C \<sharp>* P'" "C \<sharp>* A\<^isub>P"
    from assms FrR RTrans `xvec \<sharp>* K` `distinct xvec` as
    have "\<exists> K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B,\<Psi>\<otimes>\<Psi>\<^isub>P,R'',R') \<in> TUR' \<S>"
  proof(nominal_induct avoiding: B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P arbitrary: P' L M rule: semanticsFramePsiOutputInduct')
    case(cAlpha \<Psi> R M xvec N R' p A\<^isub>P \<Psi>\<^isub>P B C Q Pa A\<^isub>P' A\<^isub>Q \<Psi>\<^isub>P' P' L Ma)
    have "(p\<bullet>A\<^isub>P) = A\<^isub>P" using `A\<^isub>P \<sharp>* xvec` `(p \<bullet> xvec) \<sharp>* A\<^isub>P` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(simp add: eqvts)
      have "(p\<bullet>A\<^isub>P') = A\<^isub>P'" using `xvec \<sharp>* A\<^isub>P'` `(p \<bullet> xvec) \<sharp>* A\<^isub>P'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(simp add: eqvts)
      hence "A\<^isub>P' \<sharp>* (p \<bullet> Ma)" using `distinctPerm p` `A\<^isub>P' \<sharp>* Ma`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "(p\<bullet>A\<^isub>Q) = A\<^isub>Q" using `xvec \<sharp>* A\<^isub>Q` `(p \<bullet> xvec) \<sharp>* A\<^isub>Q` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(simp add: eqvts)
      hence "A\<^isub>Q \<sharp>* (p \<bullet> Ma)" using `distinctPerm p` `A\<^isub>Q \<sharp>* Ma`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from `xvec \<sharp>* B` have "B \<sharp>* xvec" by simp
      from `xvec \<sharp>* B` `B \<sharp>* (p\<bullet>xvec)` have pB: "(p\<bullet>B)=B" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by simp
      from `xvec \<sharp>* C` have "C \<sharp>* xvec" by simp
      from `xvec \<sharp>* C` `C \<sharp>* (p\<bullet>xvec)` have pC: "(p\<bullet>C)=C" using `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by simp
      from pB `B \<sharp>* (p\<bullet>N)` have "B \<sharp>* N"
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from pC `C \<sharp>* (p\<bullet>N)` have "C \<sharp>* N"
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Pa \<longmapsto> (p\<bullet>Ma)\<lparr>L\<rparr> \<prec> P'" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Pa \<longmapsto> Ma\<lparr>L\<rparr> \<prec> P'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* Pa` `(p\<bullet>xvec) \<sharp>* Pa`
        by(rule_tac inputPermSubject) auto
(*      have "\<Psi>\<^isub>P \<otimes> \<Psi> \<rhd> p \<bullet> P'a \<sim>\<^sub>H p \<bullet> Q'" using `\<Psi>\<^isub>P \<otimes> \<Psi> \<rhd> P'a \<sim>\<^sub>H Q'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P`
        by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)*)
      have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<turnstile> (p \<bullet> Ma) \<leftrightarrow> M" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>P \<turnstile> Ma \<leftrightarrow> M` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>Q` `xvec \<sharp>* M` `(p\<bullet>xvec) \<sharp>* M`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from `A\<^isub>P \<sharp>* xvec` have "xvec \<sharp>* A\<^isub>P"
        by simp
      from `(p\<bullet>xvec) \<sharp>* Ma` have "xvec \<sharp>* (p\<bullet>Ma)" using `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "A\<^isub>P \<sharp>* (p \<bullet> P')" using `A\<^isub>P \<sharp>* P'`
        apply(subst `(p\<bullet>A\<^isub>P) = A\<^isub>P`[symmetric])
        by(subst fresh_star_bij)
      have "A\<^isub>P \<sharp>* (p \<bullet> N)" using `A\<^isub>P \<sharp>* N`
        apply(subst `(p\<bullet>A\<^isub>P) = A\<^isub>P`[symmetric])
        by(subst fresh_star_bij)
      have "\<Psi>\<^isub>Q \<otimes> \<Psi> \<rhd> R \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'" using `\<Psi>\<^isub>Q \<otimes> \<Psi> \<rhd> R \<longmapsto> M\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>\<langle>(p\<bullet>N)\<rangle> \<prec> (p\<bullet>R')` `(p\<bullet>xvec) \<sharp>* N` `(p\<bullet>xvec) \<sharp>* R'` `xvec \<sharp>* M` `(p\<bullet> xvec) \<sharp>* M` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(subst residualAlpha[where p=p]) (auto simp add: eqvts)
      have "B \<sharp>* (p \<bullet> P')" using `B \<sharp>* P'` `distinctPerm p` pB
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "C \<sharp>* (p \<bullet> P')" using `C \<sharp>* P'` `distinctPerm p` pC
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
(*      have "A\<^isub>P' \<sharp>* (p \<bullet> N)" using `(p\<bullet>A\<^isub>P') = A\<^isub>P'` `distinctPerm p` `A\<^isub>P' \<sharp>* N`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "A\<^isub>Q \<sharp>* (p \<bullet> L)" using `(p\<bullet>A\<^isub>Q) = A\<^isub>Q` `distinctPerm p` `A\<^isub>Q \<sharp>* L`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)*)
      have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>P \<turnstile> (p\<bullet>Ma) \<leftrightarrow> K' \<and> A\<^isub>P \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P', R'', R') \<in> TUR' \<S>"
        by(rule_tac cAlpha) fact+
      then obtain K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>P \<turnstile> (p\<bullet>Ma) \<leftrightarrow> K'" and "A\<^isub>P \<sharp>* K'" and "C \<sharp>* K'" and "(B, \<Psi>\<otimes>\<Psi>\<^isub>P', R'', R') \<in> TUR' \<S>"
        by blast
      from `\<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''`
      have "\<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> R \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*(p\<bullet>xvec)\<rparr>\<langle>(p\<bullet>N)\<rangle> \<prec> (p\<bullet>R'')" using `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P'` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P'` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      moreover from`\<Psi> \<otimes> \<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>P \<turnstile> (p\<bullet>Ma) \<leftrightarrow> K'`
      have "\<Psi> \<otimes> \<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>P \<turnstile> Ma \<leftrightarrow> (p\<bullet>K')" using `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* \<Psi>\<^isub>P'` `(p\<bullet>xvec) \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P'` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      moreover have "A\<^isub>P \<sharp>* (p\<bullet>K')" using `A\<^isub>P \<sharp>* K'` `A\<^isub>P \<sharp>* xvec` `(p\<bullet>xvec) \<sharp>* A\<^isub>P` `distinctPerm p` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      moreover have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P', (p\<bullet>R''), (p\<bullet>R')) \<in> TUR' \<S>"
        using `(B, \<Psi>\<otimes>\<Psi>\<^isub>P', R'', R') \<in> TUR' \<S>` `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `distinctPerm p`
        `B \<sharp>* xvec` `B \<sharp>* (p\<bullet>xvec)` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P'` `xvec \<sharp>* \<Psi>\<^isub>P'`
        by(drule_tac eqvtI[where p=p, OF TUReqvt(2), OF Seqvt]) (simp add: eqvts)
      moreover have "C \<sharp>* (p\<bullet>K')" using `(p\<bullet>C) = C` `C \<sharp>* K'` `distinctPerm p`
        apply(subst fresh_star_bij[where pi=p,symmetric])
        by(simp add: eqvts)
      ultimately show "\<exists>K' R''.
             \<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> R \<longmapsto> K'\<lparr>\<nu>*(p \<bullet> xvec)\<rparr>\<langle>(p \<bullet> N)\<rangle> \<prec> R'' \<and>
             \<Psi> \<otimes> \<Psi>\<^isub>P' \<otimes> \<Psi>\<^isub>P \<turnstile> Ma \<leftrightarrow> K' \<and> A\<^isub>P \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P', R'', p \<bullet> R') \<in> TUR' \<S>"
        by blast
    next
      case(cFrameAlpha \<Psi> R A\<^isub>R \<Psi>\<^isub>R p M xvec N R' B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
      have "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P" using `(p\<bullet>A\<^isub>R) \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>`
        by(auto dest: extractFrameFreshChain)
      from `\<Psi>\<^isub>Q \<otimes> \<Psi> \<rhd> R \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'` `(p \<bullet> A\<^isub>R) \<sharp>* R` `xvec \<sharp>* (p \<bullet> A\<^isub>R)`
      have "(p\<bullet>A\<^isub>R) \<sharp>* R'" and "(p\<bullet>A\<^isub>R) \<sharp>* N" using `xvec \<sharp>* M` `distinct xvec`
        by(simp add: outputFreshChainDerivative)+
      from `xvec \<sharp>* (p \<bullet> A\<^isub>R)` `A\<^isub>R \<sharp>* xvec` have "(p\<bullet>xvec) = xvec" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      hence "xvec \<sharp>* (p \<bullet> K)" using `xvec \<sharp>* K` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from `(p \<bullet> A\<^isub>R) \<sharp>* A\<^isub>P` `A\<^isub>R \<sharp>* A\<^isub>P` have "(p\<bullet>A\<^isub>P) = A\<^isub>P" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      hence "A\<^isub>P \<sharp>* (p \<bullet> K)" using `A\<^isub>P \<sharp>* K` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from `(p \<bullet> A\<^isub>R) \<sharp>* A\<^isub>Q` `A\<^isub>R \<sharp>* A\<^isub>Q` have "(p\<bullet>A\<^isub>Q) = A\<^isub>Q" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      hence "A\<^isub>Q \<sharp>* (p \<bullet> K)" using `A\<^isub>Q \<sharp>* K` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      from `(p \<bullet> A\<^isub>R) \<sharp>* P'` have "A\<^isub>R \<sharp>* (p\<bullet>P')" using `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
(*      from `(p \<bullet> A\<^isub>R) \<sharp>* Q'` have "A\<^isub>R \<sharp>* (p\<bullet>Q')" using `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)*)
      from `B \<sharp>* (p \<bullet> A\<^isub>R)` `A\<^isub>R \<sharp>* B` have "(p\<bullet>B) = B" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      from `C \<sharp>* (p \<bullet> A\<^isub>R)` `A\<^isub>R \<sharp>* C` have "(p\<bullet>C) = C" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R" by simp
      from `A\<^isub>R \<sharp>* C` have "C \<sharp>* A\<^isub>R" by simp
      from `A\<^isub>R \<sharp>* xvec` have "xvec \<sharp>* A\<^isub>R"
        by simp
      from `extractFrame R = \<langle>(p\<bullet>A\<^isub>R),(p\<bullet>\<Psi>\<^isub>R)\<rangle>` have "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" using `(p \<bullet> A\<^isub>R) \<sharp>* R` `A\<^isub>R \<sharp>* R` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        apply(subst perm_bool[where pi=p,symmetric])
        unfolding eqvts
        by simp
      from `A\<^isub>R \<sharp>* xvec` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `xvec \<sharp>* R` have "xvec \<sharp>* \<Psi>\<^isub>R"
        by(auto dest: extractFrameFreshChain)
      from `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `(p\<bullet>A\<^isub>R) \<sharp>* Q` have "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q"
        by(auto dest: extractFrameFreshChain)
      from `\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'`
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> (p \<bullet> K)\<lparr>(p\<bullet>L)\<rparr> \<prec> (p\<bullet>P')" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
(*      from `\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> Q \<longmapsto> K\<lparr>N\<rparr> \<prec> Q'`
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto> (p \<bullet> K)\<lparr>N\<rparr> \<prec> p \<bullet> Q'" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* Q` `(p\<bullet>A\<^isub>R) \<sharp>* Q` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)*)
      from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<turnstile> K \<leftrightarrow> M` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> (p \<bullet> K) \<leftrightarrow> M" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>R \<sharp>* M` `(p\<bullet>A\<^isub>R) \<sharp>* M`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `(p\<bullet>\<Psi>\<^isub>R) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* Q` `(p\<bullet>A\<^isub>R) \<sharp>* Q`
        by(drule_tac hobisimClosed[where p=p],simp add: eqvts)
(*      have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> (p\<bullet>P') \<sim>\<^sub>H (p\<bullet>Q')" using `(p\<bullet>\<Psi>\<^isub>R) \<otimes> \<Psi> \<rhd> P' \<sim>\<^sub>H Q'` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>`
        by(drule_tac hobisimClosed[where p=p],simp add: eqvts)*)
      have "B \<sharp>* (p \<bullet> P')"
        by(subst `(p\<bullet>B)=B`[symmetric], subst fresh_star_bij) fact
      have "C \<sharp>* (p \<bullet> P')"
        by(subst `(p\<bullet>C)=C`[symmetric], subst fresh_star_bij) fact
(*      have "B \<sharp>* (p \<bullet> Q')"
        by(subst `(p\<bullet>B)=B`[symmetric], subst fresh_star_bij) fact*)
(*      have "A\<^isub>P \<sharp>* (p \<bullet> N)" using `A\<^isub>P \<sharp>* N` `distinctPerm p` `(p\<bullet>A\<^isub>P) = A\<^isub>P`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "A\<^isub>Q \<sharp>* (p \<bullet> L)" using `A\<^isub>Q \<sharp>* L` `distinctPerm p` `(p\<bullet>A\<^isub>Q) = A\<^isub>Q`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)*)
      have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
        by(rule_tac cFrameAlpha) fact+
      then obtain K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'" "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" and "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
        by blast
      from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<turnstile> K \<leftrightarrow> (p\<bullet>K')" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P`
        apply(subst perm_bool[where pi=p,symmetric])
        by(simp add: eqvts)
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> (p\<bullet>R'')" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N` `A\<^isub>R \<sharp>* xvec` `xvec \<sharp>* (p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* R` `(p\<bullet>A\<^isub>R) \<sharp>* R`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      moreover from `A\<^isub>R \<sharp>* K'` have "(p\<bullet>A\<^isub>R) \<sharp>* (p\<bullet>K')" by(subst fresh_star_bij)
      moreover from `C \<sharp>* K'` have "C \<sharp>* (p\<bullet>K')" using `distinctPerm p` `(p\<bullet>C) = C`
        apply(subst fresh_star_bij[where pi=p,symmetric])
        by(simp add: eqvts)
      moreover from `(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>` have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, (p\<bullet>R''), R') \<in> TUR' \<S>" using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* R'` `(p\<bullet>A\<^isub>R) \<sharp>* R'` `A\<^isub>R \<sharp>* B` `B \<sharp>* (p\<bullet>A\<^isub>R)`
        by(drule_tac eqvtI[where p=p, OF TUReqvt(2), OF Seqvt]) (simp add: eqvts)
      ultimately show ?case
        by blast
    next
      case(cOutput \<Psi> M K N R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L M')
        from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M' \<leftrightarrow> K` `\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<turnstile> M' \<leftrightarrow> M"
          by(metis AssertionStatEqTrans Associativity Commutativity Identity chanEqSym chanEqTrans statEqEnt)
        hence "insertAssertion (extractFrame Q) \<Psi> \<turnstile>\<^sub>F M' \<leftrightarrow> M"
          unfolding `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` using `A\<^isub>Q \<sharp>* M'` `A\<^isub>Q \<sharp>* (M\<langle>N\<rangle>.R)` `A\<^isub>Q \<sharp>* \<Psi>`
          by(auto intro: frameImpI)
        moreover have "\<not> clauseDom(M' \<leftrightarrow> M)"
          by auto
        moreover have "\<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi>  \<rhd> P \<sim>\<^sub>H Q`
          apply(rule_tac hostatEqBisim)
          apply assumption
          by(rule_tac AssertionStatEqTrans[OF Commutativity, OF Identity])
        ultimately have "insertAssertion (extractFrame P) \<Psi> \<turnstile>\<^sub>F M' \<leftrightarrow> M"
          by(blast dest: hobisimE)
        hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M' \<leftrightarrow> M"
          unfolding `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` using `A\<^isub>P \<sharp>* M'` `A\<^isub>P \<sharp>* (M\<langle>N\<rangle>.R)` `A\<^isub>P \<sharp>* \<Psi>`
          by(auto intro: frameImpE)
        hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M' \<leftrightarrow> M"
          by(metis AssertionStatEqSym Identity compositionSym statEqEnt)
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> M\<langle>N\<rangle>.R \<longmapsto> M\<langle>N\<rangle> \<prec> R"
          apply(rule Output)
          apply(rule chanEqTrans[where N=M'])
          apply(rule chanEqSym)
          by fact+
        moreover have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R, R) \<in> TUR' \<S>" using `B \<sharp>* M\<langle>N\<rangle>.R`
          unfolding TUR'_def
          by(rule_tac r_into_fresh_rel_trancl[OF UnI2, OF hobisimReflexive]) auto
        moreover have "([]::name list) \<sharp>* M" by simp
        moreover have "C \<sharp>* M" using `C \<sharp>* M\<langle>N\<rangle>.R` by simp
        ultimately show ?case
          by blast
      next
        case(cCase \<Psi> R M xvec N R' \<phi> Cs A\<^isub>R \<Psi>\<^isub>R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L M')
        from `supp \<Psi>\<^isub>R = {}` have psir: "\<And>yvec::name list. yvec \<sharp>* \<Psi>\<^isub>R"
          by(auto simp add: fresh_def fresh_star_def)
        from `xvec \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs` have "xvec \<sharp>* \<phi>" "xvec \<sharp>* R"
          apply -
          by(drule_tac memFreshChain,simp,simp)+
        from `A\<^isub>P \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs` have "A\<^isub>P \<sharp>* \<phi>" "A\<^isub>P \<sharp>* R"
          apply -
          by(drule_tac memFreshChain,simp,simp)+
        from `A\<^isub>Q \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs` have "A\<^isub>Q \<sharp>* \<phi>" "A\<^isub>Q \<sharp>* R"
          apply -
          by(drule_tac memFreshChain,simp,simp)+
        from `B \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs` have "B \<sharp>* \<phi>" "B \<sharp>* R"
          apply -
          by(drule_tac memFreshChain,simp,simp)+
        from `C \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs` have "C \<sharp>* \<phi>" "C \<sharp>* R"
          apply -
          by(drule_tac memFreshChain,simp,simp)+
        have "xvec \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* xvec`
          by simp
        obtain p::"name prm" where "set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)" and "distinctPerm p" and "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>" "(p\<bullet>A\<^isub>R) \<sharp>* R" "(p\<bullet>A\<^isub>R) \<sharp>* M" "(p\<bullet>A\<^isub>R) \<sharp>* xvec" "(p\<bullet>A\<^isub>R) \<sharp>* N" "(p\<bullet>A\<^isub>R) \<sharp>* R'" "(p\<bullet>A\<^isub>R) \<sharp>* \<phi>" "(p\<bullet>A\<^isub>R) \<sharp>* Cs" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* B" "(p\<bullet>A\<^isub>R) \<sharp>* Q" "(p\<bullet>A\<^isub>R) \<sharp>* P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* L" "(p\<bullet>A\<^isub>R) \<sharp>* P'" "(p\<bullet>A\<^isub>R) \<sharp>* M'" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* C"
          by(rule_tac name_list_avoiding[where c="(\<Psi>,R,M,xvec,N,R',\<phi>,Cs,A\<^isub>R,\<Psi>\<^isub>R,B,C,Q,P,A\<^isub>P,A\<^isub>Q,\<Psi>\<^isub>P,L,P',M',\<Psi>\<^isub>Q)"]) auto
        from `\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M'\<lparr>L\<rparr> \<prec> P'` have "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<longmapsto> M'\<lparr>L\<rparr> \<prec> P'" using `\<Psi>\<^isub>R \<simeq> \<one>`
          by(metis AssertionStatEqSym compositionSym statEqTransition)
        hence "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<longmapsto> (p\<bullet>M')\<lparr>(p\<bullet>L)\<rparr> \<prec> (p\<bullet>P')" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N`
          by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
        have "(p\<bullet>xvec) = xvec" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec`
          by simp
        hence "xvec \<sharp>* (p\<bullet>M')" using `xvec \<sharp>* M'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "(p\<bullet>A\<^isub>P) = A\<^isub>P" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* A\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P`
          by simp
        hence "A\<^isub>P \<sharp>* (p\<bullet>M')" using `A\<^isub>P \<sharp>* M'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "(p\<bullet>A\<^isub>Q) = A\<^isub>Q" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* A\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q`
          by simp
        hence "A\<^isub>Q \<sharp>* (p\<bullet>M')" using `A\<^isub>Q \<sharp>* M'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)

        have "(p\<bullet>B) = B" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `(p\<bullet>A\<^isub>R) \<sharp>* B`
          by simp
        hence "B \<sharp>* (p\<bullet>P')" using `B \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)+
        have "B \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* B`
          by simp
        have "(p\<bullet>C) = C" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* C` `(p\<bullet>A\<^isub>R) \<sharp>* C`
          by simp
        hence "C \<sharp>* (p\<bullet>P')" using `C \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)+
        have "C \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* C`
          by simp
        have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M' \<leftrightarrow> M" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M' \<leftrightarrow> M` `\<Psi>\<^isub>R \<simeq> \<one>`
          by (metis AssertionStatEqSym compositionSym statEqEnt)
        hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> (p \<bullet> M') \<leftrightarrow> M" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>R \<sharp>* M` `(p\<bullet>A\<^isub>R) \<sharp>* M`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` `\<Psi>\<^isub>R \<simeq> \<one>`
          by (metis AssertionStatEqSym Composition hostatEqBisim)
(*        have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P' \<sim>\<^sub>H Q'" using `\<one> \<otimes> \<Psi> \<rhd> P' \<sim>\<^sub>H Q'` `\<Psi>\<^isub>R \<simeq> \<one>`
          by (metis AssertionStatEqSym Composition hostatEqBisim)
        hence "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> (p\<bullet>P') \<sim>\<^sub>H (p\<bullet>Q')" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* M` `(p\<bullet>A\<^isub>R) \<sharp>* M`
            by(drule_tac hobisimClosed[where p=p], simp add: eqvts)*)
        have "A\<^isub>R \<sharp>* (p \<bullet> P')" using `(p\<bullet>A\<^isub>R) \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
(*        have "A\<^isub>R \<sharp>* (p \<bullet> L)" using `(p\<bullet>A\<^isub>R) \<sharp>* L` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "A\<^isub>P \<sharp>* (p \<bullet> L)" using `A\<^isub>P \<sharp>* L` `(p\<bullet>A\<^isub>P) = A\<^isub>P` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "A\<^isub>Q \<sharp>* (p \<bullet> L)" using `A\<^isub>Q \<sharp>* L` `(p\<bullet>A\<^isub>Q) = A\<^isub>Q` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)*)
        have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>M') \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by(rule cCase) (rule `distinct A\<^isub>Q`|rule `distinct A\<^isub>P`|rule `xvec \<sharp>* Q`|rule `xvec \<sharp>* A\<^isub>Q`|fact)+
        then obtain K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>M') \<leftrightarrow> K'" "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by blast
        hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> (p\<bullet>R'')" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M' \<leftrightarrow> (p\<bullet>K')" and  "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, (p\<bullet>R''), R') \<in> TUR' \<S>"
          using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N` `A\<^isub>R \<sharp>* R` `(p\<bullet>A\<^isub>R) \<sharp>* R` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` psir `A\<^isub>R \<sharp>* B` `(p\<bullet>A\<^isub>R) \<sharp>* B` `A\<^isub>R \<sharp>* R'` `(p\<bullet>A\<^isub>R) \<sharp>* R'`
          apply -
          apply(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
          apply(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
          apply(drule_tac eqvtI[where p=p,OF TUReqvt(2),OF Seqvt], simp add: eqvts)
          done
        moreover have "([]::name list) \<sharp>* (p\<bullet>K')" by simp
        moreover have "C \<sharp>* (p\<bullet>K')" using `C \<sharp>* K'` `(p\<bullet>C) = C` `distinctPerm p`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
        moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M' \<leftrightarrow> (p\<bullet>K')` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M' \<leftrightarrow> (p\<bullet>K')" using `\<Psi>\<^isub>R \<simeq> \<one>`
          apply(rule_tac statEqEnt)
          apply(rule compositionSym)
          by(rule compositionSym)
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Cases Cs \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> (p\<bullet>R'')"
        proof -
          from `\<Psi>\<^isub>Q \<otimes> \<Psi>  \<turnstile> \<phi>`
          have "insertAssertion (extractFrame Q) \<Psi> \<turnstile>\<^sub>F \<phi>"
            using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<phi>`
            apply simp
            apply(rule frameImpI[OF refl])
            apply assumption
            by(rule statEqEnt[OF Commutativity])
          moreover have "\<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
            apply(rule_tac hostatEqBisim)
            apply assumption
            by(rule AssertionStatEqTrans[OF Commutativity, OF Identity])
          moreover note `\<not> clauseDom \<phi>`
          ultimately have "insertAssertion (extractFrame P) \<Psi> \<turnstile>\<^sub>F \<phi>"
            by(blast dest: hobisimE)
          hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi>"
            using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<phi>`
            by(auto intro: frameImpE)
          show ?thesis
            by(rule Case) fact+
        qed
        ultimately show ?case
          by blast
      next
        case(cPar2 \<Psi> \<Psi>\<^isub>R S M xvec N S' A\<^isub>R R A\<^isub>S \<Psi>\<^isub>S B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
        from `A\<^isub>R \<sharp>* A\<^isub>S` `A\<^isub>S \<sharp>* B` `A\<^isub>S \<sharp>* C`
        have "A\<^isub>S \<sharp>* A\<^isub>R" "B \<sharp>* A\<^isub>S" "C \<sharp>* A\<^isub>S"
          by auto
        from `B \<sharp>* (R \<parallel> S)` have "B \<sharp>* R" and "B \<sharp>* S"
          by auto
        from `C \<sharp>* (R \<parallel> S)` have "C \<sharp>* R" and "C \<sharp>* S"
          by auto
        from `A\<^isub>P \<sharp>* (R \<parallel> S)` have "A\<^isub>P \<sharp>* R" "A\<^isub>P \<sharp>* S"
          by auto
        hence "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" using `A\<^isub>R \<sharp>* A\<^isub>P` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
          by(auto dest: extractFrameFreshChain)
        from `A\<^isub>Q \<sharp>* (R \<parallel> S)` have "A\<^isub>Q \<sharp>* R" "A\<^isub>Q \<sharp>* S"
          by auto
        hence "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R" using `A\<^isub>R \<sharp>* A\<^isub>Q` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
          by(auto dest: extractFrameFreshChain)
        from `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>P`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>Q`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* P`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* Q`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* P'`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* (R \<parallel> S)`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* M`
        have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* P'" "A\<^isub>R \<sharp>* R" "A\<^isub>R \<sharp>* S" "A\<^isub>R \<sharp>* M"
          "A\<^isub>S \<sharp>* A\<^isub>P" "A\<^isub>S \<sharp>* A\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>" "A\<^isub>S \<sharp>* P" "A\<^isub>S \<sharp>* Q" "A\<^isub>S \<sharp>* P'" "A\<^isub>S \<sharp>* R" "A\<^isub>S \<sharp>* S" "A\<^isub>S \<sharp>* M"
          by auto
        have "xvec \<sharp>* A\<^isub>S" using `A\<^isub>S \<sharp>* xvec`
          by simp
        have "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'"
          apply(rule statEqTransition)
          apply fact
          by(metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
        have "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>S \<turnstile> K \<leftrightarrow> M"
          apply(rule statEqEnt)
          defer
          apply fact
          by (metis AssertionStatEqRefl AssertionStatEqSym AssertionStatEqTrans Associativity Commutativity Composition')
        have "\<Psi>\<^isub>S \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q"
          apply(rule hostatEqBisim)
          apply fact
          by(metis AssertionStatEqTrans Associativity Commutativity)
(*        have "\<Psi>\<^isub>S \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'"
          apply(rule hostatEqBisim)
          apply fact
          by(metis AssertionStatEqTrans Associativity Commutativity)*)
        have "\<exists>K' S''.
        (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>S \<turnstile> K \<leftrightarrow> K' \<and> A\<^isub>S \<sharp>* K' \<and> (C@A\<^isub>R) \<sharp>* K' \<and> (B@A\<^isub>R, (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P, S'', S') \<in> TUR' \<S>"
          by(rule cPar2) (rule `distinct A\<^isub>Q`|rule `distinct A\<^isub>P`|rule `xvec \<sharp>* Q`|rule `xvec \<sharp>* A\<^isub>Q`|rule freshCompChain|(subst freshChainAppend,rule conjI)|fact)+
        then obtain K' S'' where "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S''" and "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>S \<turnstile> K \<leftrightarrow> K'" and "C \<sharp>* K'" and "(A\<^isub>R@A\<^isub>S) \<sharp>* K'" and "A\<^isub>R \<sharp>* K'" and "(B@A\<^isub>R, (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P, S'', S') \<in> TUR' \<S>"
          by auto
        have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R\<parallel>S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R\<parallel>S''"
          apply(rule Par2[where \<Psi>\<^isub>P=\<Psi>\<^isub>R and A\<^isub>P=A\<^isub>R])
          apply(rule statEqTransition)
          apply fact
          apply(rule associativitySym)
          by(simp|rule freshCompChain|rule conjI|fact)+
        moreover have "(B, \<Psi> \<otimes> \<Psi>\<^isub>P, (R \<parallel> S''), (R \<parallel> S')) \<in> TUR' \<S>"
        proof -
          from `(B@A\<^isub>R, (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P, S'', S') \<in> TUR' \<S>`
          have "(B@A\<^isub>R, (\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>R, S'', S') \<in> TUR' \<S>"
            by(rule TURS'statEq) (rule associativitySym)
          hence "(B@A\<^isub>R, \<Psi> \<otimes> \<Psi>\<^isub>P, S'' \<parallel> R, S' \<parallel> R) \<in> TUR' \<S>"
            apply(rule TURS'parPres')
            by(rule refl) (rule freshCompChain|fact)+
          hence 1: "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, S'' \<parallel> R, S' \<parallel> R) \<in> TUR' \<S>"
            unfolding TUR'_def
            by(rule_tac fresh_rel_trancl_weaken) auto
          moreover have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, S'\<parallel>R, (R \<parallel> S')) \<in> TUR' \<S>" using 1
            unfolding TUR'_def
            apply(rule_tac fresh_rel_trancl.intros)
            apply(rule UnI2)
            apply(rule hobisimBisim[OF bisimParComm])
            by(auto dest: fresh_rel_trancl_fresh)
          moreover have "(B, \<Psi> \<otimes> \<Psi>\<^isub>P, (R\<parallel>S''), S'' \<parallel> R) \<in> TUR' \<S>" using 1
            unfolding TUR'_def
            apply(rule_tac fresh_rel_trancl.intros)
            apply(rule UnI2)
            apply(rule hobisimBisim[OF bisimParComm])
            by(auto dest: fresh_rel_trancl_fresh)
          ultimately show ?thesis
            unfolding TUR'_def
            by(blast intro: fresh_rel_trancl_transitive)
        qed
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> K \<leftrightarrow> K'"
          apply(rule statEqEnt)
          defer
          apply fact
          by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Commutativity Composition')
        moreover note `(A\<^isub>R@A\<^isub>S) \<sharp>* K'` `C \<sharp>* K'`
        ultimately show ?case
          by blast
      next
        case(cPar1 \<Psi> \<Psi>\<^isub>S R M xvec N R' A\<^isub>S S A\<^isub>R \<Psi>\<^isub>R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
        from `B \<sharp>* (R \<parallel> S)` have "B \<sharp>* R" and "B \<sharp>* S"
          by auto
        from `C \<sharp>* (R \<parallel> S)` have "C \<sharp>* R" and "C \<sharp>* S"
          by auto
        from `A\<^isub>P \<sharp>* (R \<parallel> S)` have "A\<^isub>P \<sharp>* R" "A\<^isub>P \<sharp>* S"
          by auto
        hence "A\<^isub>P \<sharp>* \<Psi>\<^isub>S" using `A\<^isub>S \<sharp>* A\<^isub>P` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>`
          by(auto dest: extractFrameFreshChain)
        from `A\<^isub>Q \<sharp>* (R \<parallel> S)` have "A\<^isub>Q \<sharp>* R" "A\<^isub>Q \<sharp>* S"
          by auto
        hence "A\<^isub>Q \<sharp>* \<Psi>\<^isub>S" using `A\<^isub>S \<sharp>* A\<^isub>Q` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>`
          by(auto dest: extractFrameFreshChain)
        from `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>P`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>Q`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* P`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* Q`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* P'`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* (R \<parallel> S)`
             `(A\<^isub>R @ A\<^isub>S) \<sharp>* M`
        have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* P'" "A\<^isub>R \<sharp>* R" "A\<^isub>R \<sharp>* S" "A\<^isub>R \<sharp>* M"
          "A\<^isub>S \<sharp>* A\<^isub>P" "A\<^isub>S \<sharp>* A\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>" "A\<^isub>S \<sharp>* P" "A\<^isub>S \<sharp>* Q" "A\<^isub>S \<sharp>* P'" "A\<^isub>S \<sharp>* R" "A\<^isub>S \<sharp>* S" "A\<^isub>S \<sharp>* M"
          by auto
        have "xvec \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* xvec`
          by simp
        have "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'"
          apply(rule statEqTransition)
          apply fact
          by(metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
        have "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> M"
          apply(rule statEqEnt)
          defer
          apply fact
          by (metis AssertionStatEqRefl AssertionStatEqSym AssertionStatEqTrans Associativity Commutativity Composition')
        have "\<Psi>\<^isub>R \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P \<sim>\<^sub>H Q"
          apply(rule hostatEqBisim)
          apply fact
          by(metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)
(*        have "\<Psi>\<^isub>R \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P' \<sim>\<^sub>H Q'"
          apply(rule hostatEqBisim)
          apply fact
          by(metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym)*)
        from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
          by simp
        from `A\<^isub>R \<sharp>* C` have "C \<sharp>* A\<^isub>R"
          by simp
        from `A\<^isub>R \<sharp>* A\<^isub>S` have "A\<^isub>S \<sharp>* A\<^isub>R"
          by simp
        have "\<exists>K' R''.
        (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> (C@A\<^isub>S) \<sharp>* K' \<and> (B@A\<^isub>S, (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by(rule cPar1) (rule `distinct A\<^isub>Q`|rule `distinct A\<^isub>P`|rule `xvec \<sharp>* Q`|rule `xvec \<sharp>* A\<^isub>Q`|rule freshCompChain|(subst freshChainAppend,rule conjI)|fact)+
        then obtain K' R'' where "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K'" and "C \<sharp>* K'" and "(A\<^isub>R@A\<^isub>S) \<sharp>* K'" and "A\<^isub>S \<sharp>* K'" and "(B@A\<^isub>S, (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by auto
        have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R\<parallel>S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''\<parallel>S"
          apply(rule Par1[where \<Psi>\<^isub>Q=\<Psi>\<^isub>S and A\<^isub>Q=A\<^isub>S])
          apply(rule statEqTransition)
          apply fact
          apply(rule associativitySym)
          by(simp|rule freshCompChain|rule conjI|fact)+
        moreover have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, (R''\<parallel>S), (R' \<parallel> S)) \<in> TUR' \<S>"
        proof -
          from `(B@A\<^isub>S, (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>`
          have "(B@A\<^isub>S, (\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>S, R'', R') \<in> TUR' \<S>"
            apply(rule TURS'statEq)
            by(rule associativitySym)
          hence "(B@A\<^isub>S, \<Psi> \<otimes> \<Psi>\<^isub>P, R'' \<parallel> S, R' \<parallel> S) \<in> TUR' \<S>"
            apply(rule TURS'parPres')
            by(rule refl) (rule freshCompChain|fact)+
          thus ?thesis
            unfolding TUR'_def
            by(rule_tac fresh_rel_trancl_weaken) auto
        qed
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> K \<leftrightarrow> K'"
          apply(rule statEqEnt)
          defer
          apply fact
          by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Commutativity Composition')
        moreover note `(A\<^isub>R@A\<^isub>S) \<sharp>* K'` `C \<sharp>* K'`
        ultimately show ?case
          by blast
      next
        case(cInv \<Psi> M' R M xvec N R' A\<^isub>R \<Psi>\<^isub>R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
        from `guarded R` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` have "\<Psi>\<^isub>R \<simeq> \<one>" and "supp \<Psi>\<^isub>R = ({}::name set)"
          by(auto dest: guardedStatEq)
        hence psir: "\<And> yvec::name list. yvec \<sharp>* \<Psi>\<^isub>R"
          by(simp add: fresh_def fresh_star_def)
        have "xvec \<sharp>* \<Psi>\<^isub>R" "xvec \<sharp>* A\<^isub>R" using `xvec \<sharp>* R` `A\<^isub>R \<sharp>* xvec` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
          by(auto dest: extractFrameFreshChain)
        obtain p::"name prm" where "set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)" and "distinctPerm p" and "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>" "(p\<bullet>A\<^isub>R) \<sharp>* R" "(p\<bullet>A\<^isub>R) \<sharp>* M" "(p\<bullet>A\<^isub>R) \<sharp>* xvec" "(p\<bullet>A\<^isub>R) \<sharp>* N" "(p\<bullet>A\<^isub>R) \<sharp>* R'" "(p\<bullet>A\<^isub>R) \<sharp>* M'" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* B" "(p\<bullet>A\<^isub>R) \<sharp>* Q" "(p\<bullet>A\<^isub>R) \<sharp>* P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* L" "(p\<bullet>A\<^isub>R) \<sharp>* P'" "(p\<bullet>A\<^isub>R) \<sharp>* M'" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* K" "(p\<bullet>A\<^isub>R) \<sharp>* C"
          by(rule_tac name_list_avoiding[where c="(\<Psi>,R,M,xvec,N,R',M',A\<^isub>R,\<Psi>\<^isub>R,B,C,Q,P,A\<^isub>P,A\<^isub>Q,\<Psi>\<^isub>P,L,P',M',\<Psi>\<^isub>Q,K)"]) auto
        have "p\<bullet>xvec = xvec" using `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
          by simp
        hence "xvec \<sharp>* (p\<bullet>K)" using `xvec \<sharp>* K` `distinctPerm p`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
        from `\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'` have "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'" using `\<Psi>\<^isub>R \<simeq> \<one>`
          by(metis AssertionStatEqSym compositionSym statEqTransition)
        hence "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<longmapsto> (p\<bullet>K)\<lparr>(p\<bullet>L)\<rparr> \<prec> (p\<bullet>P')" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N`
          by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
        have "(p\<bullet>xvec) = xvec" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec`
          by simp
        hence "xvec \<sharp>* (p\<bullet>K)" using `xvec \<sharp>* K` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "(p\<bullet>A\<^isub>P) = A\<^isub>P" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* A\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P`
          by simp
        hence "A\<^isub>P \<sharp>* (p\<bullet>K)" using `A\<^isub>P \<sharp>* K` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "(p\<bullet>A\<^isub>Q) = A\<^isub>Q" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `A\<^isub>R \<sharp>* A\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q`
          by simp
        hence "A\<^isub>Q \<sharp>* (p\<bullet>K)" using `A\<^isub>Q \<sharp>* K` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "(p\<bullet>B) = B" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* B` `(p\<bullet>A\<^isub>R) \<sharp>* B`
          by simp
        hence "B \<sharp>* (p\<bullet>P')" using `B \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)+
        have "B \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* B`
          by simp
        have "(p\<bullet>C) = C" using `distinctPerm p``set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* C` `(p\<bullet>A\<^isub>R) \<sharp>* C`
          by simp
        hence "C \<sharp>* (p\<bullet>P')" using `C \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)+
        have "C \<sharp>* A\<^isub>R" using `A\<^isub>R \<sharp>* C`
          by simp
        have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> M" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> K \<leftrightarrow> M` `\<Psi>\<^isub>R \<simeq> \<one>`
          by (metis AssertionStatEqSym compositionSym statEqEnt)
        hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> (p \<bullet> K) \<leftrightarrow> M" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` and `distinctPerm p` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>R \<sharp>* M` `(p\<bullet>A\<^isub>R) \<sharp>* M`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
        have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` `\<Psi>\<^isub>R \<simeq> \<one>`
          by (metis AssertionStatEqSym Composition hostatEqBisim)
        have "A\<^isub>R \<sharp>* (p \<bullet> P')" using `(p\<bullet>A\<^isub>R) \<sharp>* P'` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
(*        have "A\<^isub>R \<sharp>* (p \<bullet> L)" using `(p\<bullet>A\<^isub>R) \<sharp>* L` `distinctPerm p`
          by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)*)
        have "A\<^isub>P \<sharp>* R" using `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'`
          by(auto simp add: fresh_def fresh_star_def psi.supp)
        have "A\<^isub>Q \<sharp>* R" using `A\<^isub>Q \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'`
          by(auto simp add: fresh_def fresh_star_def psi.supp)
        have "B \<sharp>* R" using `B \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'`
          by(auto simp add: fresh_def fresh_star_def psi.supp)
        have "C \<sharp>* R" using `C \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'`
          by(auto simp add: fresh_def fresh_star_def psi.supp)
(*        have "A\<^isub>P \<sharp>* (p\<bullet>L)" using `A\<^isub>P \<sharp>* L` `distinctPerm p` `(p\<bullet>A\<^isub>P) = A\<^isub>P`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
        have "A\<^isub>Q \<sharp>* (p\<bullet>L)" using `A\<^isub>Q \<sharp>* L` `distinctPerm p` `(p\<bullet>A\<^isub>Q) = A\<^isub>Q`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)*)
        have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by(rule cInv) (rule `distinct A\<^isub>Q`|rule `distinct A\<^isub>P`|rule `xvec \<sharp>* Q`|rule `xvec \<sharp>* A\<^isub>Q`|fact)+
        then obtain K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'" "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by blast
        from `(p\<bullet>A\<^isub>R) \<sharp>* K` have "A\<^isub>R \<sharp>* (p\<bullet>K)" using `distinctPerm p`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
        have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p\<bullet>K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''` chanEqSym[OF `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'`] `distinct A\<^isub>R` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* (p\<bullet>K)` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* R` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* K'`
          apply(rule_tac outputRenameSubject)
          apply assumption
          by(auto intro: statEqEnt[OF AssertionStatEqSym, OF Associativity])
        from `\<Psi>\<^isub>Q \<otimes> \<Psi>   \<turnstile> M' \<Leftarrow> R`
        have "insertAssertion(extractFrame Q) \<Psi> \<turnstile>\<^sub>F M' \<Leftarrow> R"
          unfolding `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>`
          using `A\<^isub>Q \<sharp>* \<langle>M'\<rangle>` `A\<^isub>Q \<sharp>* R` `A\<^isub>Q \<sharp>* \<Psi>`
          apply simp
          apply(rule frameImpI)
          apply(rule refl)
          apply force
          by(rule statEqEnt[OF Commutativity])
        moreover have "\<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
          apply(rule hostatEqBisim)
          by(rule AssertionStatEqTrans[OF Commutativity, OF Identity])
        moreover have "legalClause M' R" using `supp R \<subseteq> (supp M'::name set)` `guarded R`
          unfolding legalClause_def
          by(rule conjI)
        ultimately obtain S where "legalClause M' S" and "insertAssertion(extractFrame P) \<Psi> \<turnstile>\<^sub>F M' \<Leftarrow> S" and "R \<sim>\<^sub>H S"
          by(blast dest: hobisimE)
        hence "xvec \<sharp>* S" "A\<^isub>R \<sharp>* S"  "A\<^isub>P \<sharp>* S" "A\<^isub>Q \<sharp>* S" "B \<sharp>* S" using `xvec \<sharp>* \<langle>M'\<rangle>` `A\<^isub>R \<sharp>* M'` `B \<sharp>* \<langle>M'\<rangle>``A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `A\<^isub>Q \<sharp>* \<langle>M'\<rangle>`
          by auto
        from `R \<sim>\<^sub>H S` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<sim>\<^sub>H S"
          apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>\<otimes>\<Psi>\<^isub>P"])
          apply(rule hostatEqBisim)
          apply assumption
          by(rule AssertionStatEqTrans[OF Commutativity, OF Identity])
        with `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''`        
        obtain S' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S' \<sim>\<^sub>H R''" using `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* S`
          apply(drule_tac hobisimE(5))
          apply(drule_tac hobisimE(3))
          apply(drule_tac simE)
          by auto
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p\<bullet>K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''` `xvec \<sharp>* (p\<bullet>K)` `xvec \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* R` `distinct xvec`
        have "A\<^isub>P \<sharp>* N" "A\<^isub>P \<sharp>* R''"
          by(auto intro: outputFreshChainDerivative)
        have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> (p\<bullet>K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'"
        proof -
          obtain A\<^isub>S \<Psi>\<^isub>S where "extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>" and "distinct A\<^isub>S" and "A\<^isub>S \<sharp>* K'" and "A\<^isub>S \<sharp>* (p\<bullet>K)" and "A\<^isub>S \<sharp>* \<Psi>" and "A\<^isub>S \<sharp>* S" and "A\<^isub>S \<sharp>* \<Psi>\<^isub>P"
            by(rule_tac freshFrame[where C="(K',p\<bullet>K,\<Psi>,S,\<Psi>\<^isub>P)"]) auto
          from `legalClause M' S` have "guarded S"
            unfolding legalClause_def
            by(erule_tac conjE)
          from `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `guarded S`
          have "supp \<Psi>\<^isub>S = ({}::name set)" and "\<Psi>\<^isub>S \<simeq> \<one>"
            by(auto dest: guardedStatEq)
          with `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'` `\<Psi>\<^isub>R \<simeq> \<one>`
          have "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>S \<turnstile> K' \<leftrightarrow> (p\<bullet>K)"
            apply(rule_tac chanEqSym)
            apply(rule statEqEnt)
            defer
            apply assumption
            by (metis AssertionStatEqRefl AssertionStatEqSym AssertionStatEqTrans Associativity Composition')
          with `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'` `distinct A\<^isub>S` `A\<^isub>S \<sharp>* \<Psi>` `A\<^isub>S \<sharp>* (p\<bullet>K)` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* S` `A\<^isub>S \<sharp>* \<Psi>\<^isub>P` `A\<^isub>S \<sharp>* K'`
          show ?thesis
            by(rule_tac outputRenameSubject) (auto intro: statEqEnt[OF AssertionStatEqSym, OF Associativity])
        qed
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> (p \<bullet> K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'`
          `xvec \<sharp>* (p\<bullet>K)` `B \<sharp>* xvec` `B \<sharp>* S` `distinct xvec`
        have "B \<sharp>* S'"
          by(auto intro: outputFreshChainDerivative)
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p \<bullet> K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''`
          `xvec \<sharp>* (p\<bullet>K)` `B \<sharp>* xvec` `B \<sharp>* R` `distinct xvec`
        have "B \<sharp>* R''"
          by(auto intro: outputFreshChainDerivative)
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p \<bullet> K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''`
          `xvec \<sharp>* (p\<bullet>K)` `A\<^isub>R \<sharp>* xvec` `A\<^isub>R \<sharp>* R` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* R` `distinct xvec`
        have "A\<^isub>R \<sharp>* R''" "(p\<bullet>A\<^isub>R) \<sharp>* R''"
          by(auto intro: outputFreshChainDerivative)
        from `legalClause M' S` `(p\<bullet>A\<^isub>R) \<sharp>* M'`
        have "(p\<bullet>A\<^isub>R) \<sharp>* S" by simp
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> (p \<bullet> K)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'`
          `xvec \<sharp>* (p\<bullet>K)` `A\<^isub>R \<sharp>* xvec` `A\<^isub>R \<sharp>* S` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* S` `distinct xvec`
        have "A\<^isub>R \<sharp>* S'" "(p\<bullet>A\<^isub>R) \<sharp>* S'"
          by(auto intro: outputFreshChainDerivative)
        from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S' \<sim>\<^sub>H R''`
        have "(B,\<Psi>\<otimes>\<Psi>\<^isub>P,S',R'') \<in> TUR' \<S>" using `B \<sharp>* S'` `B \<sharp>* R''`
          unfolding TUR'_def
          by auto
        hence "(B,\<Psi>\<otimes>\<Psi>\<^isub>P,S',R') \<in> TUR' \<S>" using `(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>`
          unfolding TUR'_def
          by(blast dest: fresh_rel_trancl_transitive)
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<langle>M'\<rangle> \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'"
        proof -
          note `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'`
          moreover from `insertAssertion(extractFrame P) \<Psi> \<turnstile>\<^sub>F M' \<Leftarrow> S`
          have "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M' \<Leftarrow> S"
            using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `legalClause M' S` `A\<^isub>P \<sharp>* \<Psi>`
            apply simp
            apply(drule_tac frameImpE)
            by force
          moreover have "supp S \<subseteq> (supp M'::name set)" and "guarded S" using `legalClause M' S`
            unfolding legalClause_def
            by simp+
          ultimately have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<langle>M'\<rangle> \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> S'"
            by(rule_tac Inv)
          thus ?thesis using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* S'` `(p\<bullet>A\<^isub>R) \<sharp>* S'` `A\<^isub>R \<sharp>* M'` `(p\<bullet>A\<^isub>R) \<sharp>* M'` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `A\<^isub>R \<sharp>* N` `(p\<bullet>A\<^isub>R) \<sharp>* N`
          by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
        qed
        moreover from `C \<sharp>* K'` have "C \<sharp>* (p\<bullet>K')" using `(p\<bullet>C) = C` `distinctPerm p`
          by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
        moreover have "([]::name list) \<sharp>* (p\<bullet>K')" by simp
        moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> K \<leftrightarrow> (p\<bullet>K')"
        proof -
          from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>K) \<leftrightarrow> K'` `\<Psi>\<^isub>R \<simeq> \<one>`
          have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'"
            by(rule_tac statEqEnt[OF compositionSym, OF compositionSym])
          thus ?thesis using `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P`
            by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
        qed
        ultimately show ?case
          by blast
      next
        case(cScope \<Psi> R M xvec N R' x A\<^isub>R \<Psi>\<^isub>R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
        from `(x # A\<^isub>R) \<sharp>* A\<^isub>P`
          `(x # A\<^isub>R) \<sharp>* A\<^isub>Q`
          `(x # A\<^isub>R) \<sharp>* \<Psi>`
          `(x # A\<^isub>R) \<sharp>* P`
          `(x # A\<^isub>R) \<sharp>* Q`
          `(x # A\<^isub>R) \<sharp>* P'`
          `(x # A\<^isub>R) \<sharp>* \<lparr>\<nu>x\<rparr>R`
          `(x # A\<^isub>R) \<sharp>* M`
        have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* P'" "A\<^isub>R \<sharp>* \<lparr>\<nu>x\<rparr>R" "A\<^isub>R \<sharp>* M"
          "x \<sharp> A\<^isub>P" "x \<sharp> A\<^isub>Q" "x \<sharp> \<Psi>" "x \<sharp> P" "x \<sharp> Q" "x \<sharp> P'" "x \<sharp> \<lparr>\<nu>x\<rparr>R" "x \<sharp> M"
          by auto
        from `A\<^isub>R \<sharp>* xvec` have "xvec \<sharp>* A\<^isub>R"
          by simp
        from `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* \<lparr>\<nu>x\<rparr>R`
        have "A\<^isub>P \<sharp>* R"
          by simp
        from `x \<sharp> A\<^isub>Q` `A\<^isub>Q \<sharp>* \<lparr>\<nu>x\<rparr>R`
        have "A\<^isub>Q \<sharp>* R"
          by simp
        from `x \<sharp> B` `B \<sharp>* \<lparr>\<nu>x\<rparr>R`
        have "B \<sharp>* R"
          by simp
        from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
          by simp
        from `x \<sharp> C` `C \<sharp>* \<lparr>\<nu>x\<rparr>R`
        have "C \<sharp>* R"
          by simp
        from `A\<^isub>R \<sharp>* C` have "C \<sharp>* A\<^isub>R"
          by simp
        have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          apply(rule cScope)
          apply fact
          apply(rule `distinct A\<^isub>P`)
          apply(rule `distinct A\<^isub>Q`)
          apply fact
          apply(rule `xvec \<sharp>* Q`)
          apply fact
          apply fact
          apply fact
          apply(rule `xvec \<sharp>* A\<^isub>Q`|fact)+
          done
        then obtain K' R'' where RTrans: "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and MeqK': "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by blast
        from `A\<^isub>R \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* (\<lparr>\<nu>x\<rparr>R)` `x \<sharp> A\<^isub>P` `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` have "A\<^isub>P \<sharp>* \<Psi>\<^isub>R"
	  by(force dest: extractFrameFreshChain)+
        from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>K\<lparr>L\<rparr> \<prec> P'` `\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
        obtain Q' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto>K\<lparr>L\<rparr> \<prec> Q'" and "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q' \<sim>\<^sub>H P'"
          apply(drule_tac hostatEqBisim)
          apply(rule Commutativity)
          apply(drule hobisimE(5))
          apply(drule hobisimE(3))
          apply(drule simE)
          by auto
        from `A\<^isub>R \<sharp>* A\<^isub>Q` `A\<^isub>Q \<sharp>* (\<lparr>\<nu>x\<rparr>R)` `x \<sharp> A\<^isub>Q` `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` have "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R"
	  by(force dest: extractFrameFreshChain)+
        from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>K\<lparr>L\<rparr> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `x \<sharp> P` `C \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>\<^isub>R` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* K` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* A\<^isub>P` `C \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* A\<^isub>Q`
        obtain K'' where MeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<turnstile> K \<leftrightarrow> K''" and "x \<sharp> K''" and "A\<^isub>R \<sharp>* K''" and "C \<sharp>* K''"
	  by(rule_tac B="(x#A\<^isub>R@C)" in obtainPrefix) (assumption | force)+
        from MeqK'' MeqK' have KeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>R \<turnstile> K' \<leftrightarrow> K''"
	  by(metis statEqEnt Associativity Composition Commutativity chanEqSym chanEqTrans)
        with RTrans `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` `distinct A\<^isub>R` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* K'` `A\<^isub>R \<sharp>* K''` `A\<^isub>R \<sharp>* R`
        have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K''\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''"
          by(rule_tac outputRenameSubject) (assumption | force)+
        hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lparr>\<nu>x\<rparr>R \<longmapsto>K''\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> \<lparr>\<nu>x\<rparr>R''" using `x \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P` `x \<sharp> K''` `x \<sharp> xvec` `x \<sharp> N` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `x \<sharp> K''`
	  by(rule_tac Scope) (assumption | force)+
        moreover from MeqK'' have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K''"
	  by(metis statEqEnt Associativity Composition Commutativity)
        moreover have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, \<lparr>\<nu>x\<rparr>R'', \<lparr>\<nu>x\<rparr>R') \<in> TUR' \<S>"
          using `(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>` using `x \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P`
          by(rule_tac TURS'resPres) auto
        moreover note `x \<sharp> K''` and `A\<^isub>R \<sharp>* K''` and `C \<sharp>* K''`
        ultimately show ?case
          apply auto
          done
      next
        case(cOpen \<Psi> R M xvec yvec N R' x A\<^isub>R \<Psi>\<^isub>R y B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
        from `(x # A\<^isub>R) \<sharp>* A\<^isub>P`
          `(x # A\<^isub>R) \<sharp>* A\<^isub>Q`
          `(x # A\<^isub>R) \<sharp>* \<Psi>`
          `(x # A\<^isub>R) \<sharp>* P`
          `(x # A\<^isub>R) \<sharp>* P'`
          `(x # A\<^isub>R) \<sharp>* Q`
          `(x # A\<^isub>R) \<sharp>* \<lparr>\<nu>x\<rparr>R`
          `(x # A\<^isub>R) \<sharp>* M`
        have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* \<lparr>\<nu>x\<rparr>R" "A\<^isub>R \<sharp>* M" "A\<^isub>R \<sharp>* P'"
          "x \<sharp> A\<^isub>P" "x \<sharp> A\<^isub>Q" "x \<sharp> \<Psi>" "x \<sharp> P" "x \<sharp> Q" "x \<sharp> \<lparr>\<nu>x\<rparr>R" "x \<sharp> M" "x \<sharp> P'"
          by auto
        from `A\<^isub>R \<sharp>* \<lparr>\<nu>x\<rparr>R` `x \<sharp> A\<^isub>R`
        have "A\<^isub>R \<sharp>* R"
          by simp
        from `A\<^isub>P \<sharp>* \<lparr>\<nu>x\<rparr>R` `x \<sharp> A\<^isub>P`
        have "A\<^isub>P \<sharp>* R"
          by simp
        from `A\<^isub>Q \<sharp>* \<lparr>\<nu>x\<rparr>R` `x \<sharp> A\<^isub>Q`
        have "A\<^isub>Q \<sharp>* R"
          by simp
        from `B \<sharp>* \<lparr>\<nu>x\<rparr>R` `x \<sharp> B`
        have "B \<sharp>* R"
          by simp
        from `C \<sharp>* \<lparr>\<nu>x\<rparr>R` `x \<sharp> C`
        have "C \<sharp>* R"
          by simp
        from `(xvec @ y # yvec) \<sharp>* P`
          `(xvec @ y # yvec) \<sharp>* Q`
          `(xvec @ y # yvec) \<sharp>* \<lparr>\<nu>x\<rparr>R`
          `(xvec @ y # yvec) \<sharp>* \<Psi>`
          `(xvec @ y # yvec) \<sharp>* \<Psi>\<^isub>R`
          `(xvec @ y # yvec) \<sharp>* \<Psi>\<^isub>Q`
          `(xvec @ y # yvec) \<sharp>* \<Psi>\<^isub>P`
          `(xvec @ y # yvec) \<sharp>* K`
          `(xvec @ y # yvec) \<sharp>* (x # A\<^isub>R)`
          `(xvec @ y # yvec) \<sharp>* A\<^isub>P`
          `(xvec @ y # yvec) \<sharp>* A\<^isub>Q`
        have "xvec \<sharp>* P" "xvec \<sharp>* Q" "xvec \<sharp>* \<lparr>\<nu>x\<rparr>R" "xvec \<sharp>* \<Psi>" "xvec \<sharp>* \<Psi>\<^isub>R" "xvec \<sharp>* \<Psi>\<^isub>Q"
          "xvec \<sharp>* \<Psi>\<^isub>P" "xvec \<sharp>* K" "x \<sharp> xvec" "xvec \<sharp>* A\<^isub>R" "xvec \<sharp>* A\<^isub>P" "xvec \<sharp>* A\<^isub>Q"
          "yvec \<sharp>* P" "yvec \<sharp>* Q" "yvec \<sharp>* \<lparr>\<nu>x\<rparr>R" "yvec \<sharp>* \<Psi>" "yvec \<sharp>* \<Psi>\<^isub>R" "yvec \<sharp>* \<Psi>\<^isub>Q"
          "yvec \<sharp>* \<Psi>\<^isub>P" "yvec \<sharp>* K" "x \<sharp> yvec" "yvec \<sharp>* A\<^isub>R" "yvec \<sharp>* A\<^isub>P" "yvec \<sharp>* A\<^isub>Q"
          "y \<sharp> P" "y \<sharp> Q" "y \<sharp> R" "y \<sharp> \<Psi>" "y \<sharp> \<Psi>\<^isub>R" "y \<sharp> \<Psi>\<^isub>Q" "y \<sharp> \<Psi>\<^isub>P" "y \<sharp> K" "y \<sharp> x"
          "y \<sharp> A\<^isub>R" "y \<sharp> A\<^isub>P" "y \<sharp> A\<^isub>Q"
          by auto
        from `xvec \<sharp>* B` `yvec \<sharp>* B` have "B \<sharp>* (xvec@yvec)"
          by simp
        from `xvec \<sharp>* C` `yvec \<sharp>* C` have "C \<sharp>* (xvec@yvec)"
          by simp
        from `B \<sharp>* ([(x, y)] \<bullet> N)` `x \<sharp> B` `y \<sharp> B`
        have "B \<sharp>* N"
          by(subst fresh_star_bij[where pi="[(x,y)]",symmetric]) simp
        from `C \<sharp>* ([(x, y)] \<bullet> N)` `x \<sharp> C` `y \<sharp> C`
        have "C \<sharp>* N"
          by(subst fresh_star_bij[where pi="[(x,y)]",symmetric]) simp
        from `A\<^isub>R \<sharp>* B`
        have "B \<sharp>* A\<^isub>R"
          by simp
        from `A\<^isub>R \<sharp>* C`
        have "C \<sharp>* A\<^isub>R"
          by simp
        from `distinct xvec` `distinct yvec` `xvec \<sharp>* yvec`
        have "distinct(xvec@yvec)"
          by simp
(*        have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> K\<lparr>([(x, y)] \<bullet> L)\<rparr> \<prec> [(x, y)] \<bullet> P'"
          using `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'` `x \<sharp> P` `y \<sharp> P` `y \<noteq> x`
          by(rule_tac inputAlpha[where xvec="[x]"]) (auto simp add: at_swap_simps[OF at_name_inst])*)
        have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle> \<prec> R'' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K' \<and>
        A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by(rule_tac cOpen) (rule `distinct A\<^isub>Q`|rule `distinct A\<^isub>P`|subst freshChainAppend|rule conjI|rule `xvec \<sharp>* Q`|rule `xvec \<sharp>* A\<^isub>Q`|fact)+
        then obtain K' R'' where RTrans: "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*(xvec @ yvec)\<rparr>\<langle>N\<rangle> \<prec> R''"
         and MeqK': "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
          by blast
        have "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" using `A\<^isub>P \<sharp>* R` `A\<^isub>R \<sharp>* A\<^isub>P` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
          by(auto dest: extractFrameFreshChain)
        from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>K\<lparr>L\<rparr> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `x \<sharp> P` `y \<sharp> P` `y \<sharp> P` `C \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>\<^isub>R` `x \<sharp> A\<^isub>P` `y \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* K` `A\<^isub>P \<sharp>* P`  `A\<^isub>P \<sharp>* \<Psi>` `C \<sharp>* A\<^isub>P` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* A\<^isub>P`
      obtain K'' where MeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<turnstile> K \<leftrightarrow> K''" and "x \<sharp> K''" and "y \<sharp> K''" and "A\<^isub>R \<sharp>* K''" and "C \<sharp>* K''"
	by(rule_tac B="(x#y#A\<^isub>R@C)" in obtainPrefix) (assumption | force)+
      from MeqK'' MeqK' have KeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>R \<turnstile> K' \<leftrightarrow> K''"
	by(metis statEqEnt Associativity Composition Commutativity chanEqSym chanEqTrans)
      with RTrans `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` `distinct A\<^isub>R` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* K'` `A\<^isub>R \<sharp>* K''` `A\<^isub>R \<sharp>* R`
      have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K''\<lparr>\<nu>*(xvec@yvec)\<rparr>\<langle>N\<rangle> \<prec> R''"
	by(rule_tac outputRenameSubject) (assumption | force)+
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lparr>\<nu>x\<rparr>R \<longmapsto>K''\<lparr>\<nu>*(xvec@x#yvec)\<rparr>\<langle>N\<rangle> \<prec> R''"
	using `x \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P` `x \<sharp> K''` `x \<sharp> xvec` ` x \<sharp> yvec` `x \<in> supp N` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` `x \<sharp> K''`      
	by(rule_tac Open) (assumption | force)+
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lparr>\<nu>x\<rparr>R \<longmapsto>K''\<lparr>\<nu>*(xvec@y#yvec)\<rparr>\<langle>([(x,y)]\<bullet>N)\<rangle> \<prec> ([(x,y)]\<bullet>R'')"
        using `x \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P` `y \<sharp> \<Psi>` `y \<sharp> \<Psi>\<^isub>P` `y \<sharp> K''` `x \<sharp> K''` `y \<sharp> xvec` `x \<sharp> xvec` `y \<sharp> yvec` `x \<sharp> yvec`
        apply(subst alphaRes[where y=y, OF `y \<sharp> R`])
        apply(subst perm_bool[where pi="[(x,y)]",symmetric])
        by(auto simp add: eqvts calc_atm)
      moreover from MeqK'' have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> K \<leftrightarrow> K''"
	by(metis statEqEnt Associativity Composition Commutativity)
      moreover from `(B, \<Psi>\<otimes>\<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>` have "(B, \<Psi>\<otimes>\<Psi>\<^isub>P, ([(x,y)])\<bullet>R'', ([(x,y)])\<bullet>R') \<in> TUR' \<S>"
        using `y \<noteq> x` `x \<sharp> B` `y \<sharp> B` `x \<sharp> \<Psi>` `y \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P` `y \<sharp> \<Psi>\<^isub>P`
        by(drule_tac eqvtI[where p="[(x,y)]",OF TUReqvt(2), OF Seqvt]) (simp add: eqvts)
      moreover have "(x#A\<^isub>R) \<sharp>* K''" using `x \<sharp> K''` `A\<^isub>R \<sharp>* K''`
        by simp
      moreover note `C \<sharp>* K''`
      ultimately show ?case
        apply blast
        done
    next
      case(cBang \<Psi> R M xvec N R' A\<^isub>R \<Psi>\<^isub>R B C Q P A\<^isub>P A\<^isub>Q \<Psi>\<^isub>P P' L K)
      from `xvec \<sharp>* !R` have "xvec \<sharp>* R"
        by simp
      have "xvec \<sharp>* \<Psi>\<^isub>R" using `xvec \<sharp>* R` `A\<^isub>R \<sharp>* xvec` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
        by(auto dest: extractFrameFreshChain)
      obtain p::"name prm" where "set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)" and "distinctPerm p" and "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>" "(p\<bullet>A\<^isub>R) \<sharp>* R" "(p\<bullet>A\<^isub>R) \<sharp>* M" "(p\<bullet>A\<^isub>R) \<sharp>* xvec" "(p\<bullet>A\<^isub>R) \<sharp>* N" "(p\<bullet>A\<^isub>R) \<sharp>* R'" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>R" "(p\<bullet>A\<^isub>R) \<sharp>* B" "(p\<bullet>A\<^isub>R) \<sharp>* Q" "(p\<bullet>A\<^isub>R) \<sharp>* P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P" "(p\<bullet>A\<^isub>R) \<sharp>* L" "(p\<bullet>A\<^isub>R) \<sharp>* P'" "(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q" "(p\<bullet>A\<^isub>R) \<sharp>* K" "(p\<bullet>A\<^isub>R) \<sharp>* C"
        by(rule_tac name_list_avoiding[where c="(\<Psi>,R,M,xvec,N,R',A\<^isub>R,\<Psi>\<^isub>R,B,C,Q,P,A\<^isub>P,A\<^isub>Q,\<Psi>\<^isub>P,L,P',\<Psi>\<^isub>Q,K)"]) auto
      have "p\<bullet>xvec = xvec" using `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by simp
      hence "xvec \<sharp>* (p\<bullet>K)" using `xvec \<sharp>* K` `distinctPerm p`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      from `supp \<Psi>\<^isub>R = {}`
      have psir: "\<And> xvec::name list. xvec \<sharp>* \<Psi>\<^isub>R"
        by(simp add: fresh_def fresh_star_def)
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'" using `\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> K\<lparr>L\<rparr> \<prec> P'` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqTransition)
        apply assumption
        by (metis AssertionStatEqSym AssertionStatEqTrans Identity compositionSym)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> P \<longmapsto> (p\<bullet>K)\<lparr>(p\<bullet>L)\<rparr> \<prec> (p\<bullet>P')" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> K \<leftrightarrow> M" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> K \<leftrightarrow> M` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqSym AssertionStatEqTrans Identity compositionSym)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> M" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` psir `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* M` `(p\<bullet>A\<^isub>R) \<sharp>* M` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      have "(\<Psi>\<^isub>R \<otimes> \<one>) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`  `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac hostatEqBisim)
        apply assumption
        by (metis AssertionStatEqSym AssertionStatEqTrans Composition Identity)
      have "A\<^isub>R \<sharp>* (p \<bullet> P')" using `distinctPerm p` `(p\<bullet>A\<^isub>R) \<sharp>* P'`
        by(subst fresh_star_bij[where pi=p,symmetric]) simp
      have "B \<sharp>* (p \<bullet> P')" using `distinctPerm p` `(p\<bullet>A\<^isub>R) \<sharp>* B` `A\<^isub>R \<sharp>* B` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `B \<sharp>* P'`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "C \<sharp>* (p \<bullet> P')" using `distinctPerm p` `(p\<bullet>A\<^isub>R) \<sharp>* C` `A\<^isub>R \<sharp>* C` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `C \<sharp>* P'`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "A\<^isub>R \<sharp>* (p \<bullet> K)" using `distinctPerm p` `(p\<bullet>A\<^isub>R) \<sharp>* K`
        by(subst fresh_star_bij[where pi=p,symmetric]) simp
      from `A\<^isub>P \<sharp>* !R` have "A\<^isub>P \<sharp>* R"
        by simp
      from `A\<^isub>Q \<sharp>* !R` have "A\<^isub>Q \<sharp>* R"
        by simp
      from `B \<sharp>* !R` have "B \<sharp>* R"
        by simp
      from `C \<sharp>* !R` have "C \<sharp>* R"
        by simp
      have "A\<^isub>P \<sharp>* (p\<bullet>K)" using `A\<^isub>P \<sharp>* K` `A\<^isub>R \<sharp>* A\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "A\<^isub>Q \<sharp>* (p\<bullet>K)" using `A\<^isub>Q \<sharp>* K` `A\<^isub>R \<sharp>* A\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q` `distinctPerm p` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp add: eqvts)
      have "extractFrame(R\<parallel>!R) = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<otimes>\<one>\<rangle>" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
        by simp
      have "\<exists>K' R''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K' \<and> A\<^isub>R \<sharp>* K' \<and> C \<sharp>* K' \<and> (B, \<Psi> \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
        by(rule cBang) (rule `xvec \<sharp>* Q`|rule `distinct A\<^isub>Q`|fact|rule freshCompChain|simp)+
      then obtain K' R'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'" "A\<^isub>R \<sharp>* K'" "C \<sharp>* K'" "(B, \<Psi> \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>"
        by blast
      from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'" using `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqTrans Identity compositionSym)
      hence "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'"
        by(rule statEqEnt[OF AssertionStatEqSym, OF Associativity])
      from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''` `guarded R` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> !R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''"
        by(rule Bang)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> !R \<longmapsto> (p\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* R` `(p\<bullet>A\<^isub>R) \<sharp>* R`
        by(rule_tac outputPermSubject) (assumption|force)+
      moreover have "C \<sharp>* (p\<bullet>K')" using `C \<sharp>* K'` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* C` `(p\<bullet>A\<^isub>R) \<sharp>* C` `distinctPerm p`
        by(subst fresh_star_bij[where pi=p,symmetric]) simp
      moreover have "([]::name list) \<sharp>* (p\<bullet>K')" by simp
      moreover note `(B, \<Psi> \<otimes> \<Psi>\<^isub>P, R'', R') \<in> TUR' \<S>`
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> K \<leftrightarrow> (p\<bullet>K')" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> (p\<bullet>K) \<leftrightarrow> K'` `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      ultimately show ?case
        by blast
    qed
  }
  note rule = this
  show ?thesis using A rule[where C2="[]"] unfolding TUR_def TUR'_def
    by auto
qed

lemma inputChainFreshChain:
  fixes B::"name list"
  assumes "B \<sharp>* xvec"
  and "B \<sharp>* N"
  and "B \<sharp>* P"
  shows "B \<sharp>* inputChain xvec N P"
proof -
  from assms
  have "(set B) \<sharp>* inputChain xvec N P"
    unfolding inputChainFreshSet fresh_star_def
    by(auto simp add: inputChainFresh)
  thus ?thesis
    by auto
qed   

lemma hocomm1Aux:
  fixes \<Psi>    :: 'b
  and   \<Psi>\<^isub>Q   :: 'b
  and   R    :: "('a, 'b, 'c) psi"
  and   K    :: 'a
  and   xvec :: "name list"
  and   N    :: 'a
  and   R'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>R   :: "name list"
  and   \<Psi>\<^isub>R   :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   M    :: 'a
  and   L    :: 'a
  and   Q'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   A\<^isub>Q   :: "name list"

  assumes RTrans: "\<Psi>\<^isub>Q \<otimes> \<Psi>  \<rhd> R \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R'"
  and     FrR: "extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>"
  and     "distinct A\<^isub>R"
  and     "xvec \<sharp>* K"
  and     "distinct xvec"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     "distinct A\<^isub>Q"
  and     "xvec \<sharp>* P"
  and     "xvec \<sharp>* Q"
  and     "xvec \<sharp>* R"
  and     "xvec \<sharp>* \<Psi>"
  and     "xvec \<sharp>* \<Psi>\<^isub>R"
  and     "xvec \<sharp>* \<Psi>\<^isub>Q"
  and     "xvec \<sharp>* \<Psi>\<^isub>P"
  and     "xvec \<sharp>* M"
  and     "xvec \<sharp>* A\<^isub>R"
  and     "xvec \<sharp>* A\<^isub>P"
  and     "xvec \<sharp>* A\<^isub>Q"
(*  and     PTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'"*)
  and     QTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto>M\<lparr>N\<rparr> \<prec> Q'"
  and     MeqK: "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
  and     PeqQ: "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q"
(*  and     P'eqQ': "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P' \<sim>\<^sub>H Q'"*)
  and     FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>"
  and     "A\<^isub>R \<sharp>* A\<^isub>P"
  and     "A\<^isub>R \<sharp>* A\<^isub>Q"
  and     "A\<^isub>R \<sharp>* \<Psi>"
  and     "A\<^isub>R \<sharp>* P"
  and     "A\<^isub>R \<sharp>* Q"
  and     "A\<^isub>R \<sharp>* N"
  and     "A\<^isub>R \<sharp>* Q'"
  and     "A\<^isub>R \<sharp>* R"
  and     "A\<^isub>R \<sharp>* K"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* Q"
  and     "A\<^isub>P \<sharp>* M"
  and     "A\<^isub>P \<sharp>* N"
  and     "A\<^isub>P \<sharp>* A\<^isub>Q"
  and     "A\<^isub>Q \<sharp>* \<Psi>"
  and     "A\<^isub>Q \<sharp>* R"
  and     "A\<^isub>Q \<sharp>* P"
  and     "A\<^isub>Q \<sharp>* Q"
  and     "A\<^isub>Q \<sharp>* M"

  obtains K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" and "(\<Psi>,P'\<parallel>R'',Q'\<parallel>R') \<in> TUR \<S>"
proof -
  note A = `(\<And>K' R'' P'. \<lbrakk>\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''; \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'; A\<^isub>R \<sharp>* K'; (\<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR \<S>\<rbrakk> \<Longrightarrow> thesis)`
  from RTrans `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `distinct A\<^isub>R` `xvec \<sharp>* K` `A\<^isub>R \<sharp>* K` `A\<^isub>R \<sharp>* K` `A\<^isub>R \<sharp>* N` `xvec \<sharp>* A\<^isub>R` `xvec \<sharp>* R` `A\<^isub>R \<sharp>* R`
  `A\<^isub>R \<sharp>* A\<^isub>P` `A\<^isub>R \<sharp>* A\<^isub>Q` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* Q` `A\<^isub>R \<sharp>* Q'`
  `xvec \<sharp>* P` `xvec \<sharp>* Q` `xvec \<sharp>* R` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* A\<^isub>R` `xvec \<sharp>* A\<^isub>P` `xvec \<sharp>* A\<^isub>Q`
  obtain p \<Psi>' A\<^isub>R' \<Psi>\<^isub>R' where "set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)" and "(p\<bullet>\<Psi>\<^isub>R)\<otimes>\<Psi>' \<simeq> \<Psi>\<^isub>R'" and "distinctPerm p" and "extractFrame R' = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>" and "A\<^isub>R' \<sharp>* R'" and "A\<^isub>R' \<sharp>* K" and "A\<^isub>R' \<sharp>* xvec" and "A\<^isub>R' \<sharp>* N" and "A\<^isub>R' \<sharp>* (p\<bullet>K)" and "A\<^isub>R' \<sharp>* (p\<bullet>N)" and "A\<^isub>R' \<sharp>* (p\<bullet>xvec)" and "(p\<bullet>xvec) \<sharp>* K" and "(p\<bullet>xvec) \<sharp>* N" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* R'" and "A\<^isub>R' \<sharp>* A\<^isub>P" and "A\<^isub>R' \<sharp>* A\<^isub>Q" and "A\<^isub>R' \<sharp>* \<Psi>" and "A\<^isub>R' \<sharp>* P" and "A\<^isub>R' \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* A\<^isub>P" and "(p\<bullet>xvec) \<sharp>* A\<^isub>Q" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* Q" and "(p\<bullet>xvec) \<sharp>* R"
    by(rule_tac expandNonTauFrame[where C="(A\<^isub>P,A\<^isub>Q,\<Psi>,P,Q,Q')" and C'="(A\<^isub>P,A\<^isub>Q,\<Psi>,P,Q,R)"]) (assumption|force)+
  from PeqQ have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q"
    by(blast intro: hostatEqBisim Commutativity)
  hence PeqQ': "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> P \<sim>\<^sub>H Q" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* P` `(p\<bullet>xvec) \<sharp>* P` `xvec \<sharp>* Q` `(p\<bullet>xvec) \<sharp>* Q`
    by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
  moreover from QTrans have "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> Q \<longmapsto> (p\<bullet>M)\<lparr>N\<rparr> \<prec> Q'" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* Q` `(p\<bullet>xvec) \<sharp>* Q` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>`
    by(drule_tac inputPermFrameSubject) (auto simp add: eqvts)
  ultimately obtain P' where "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> P \<longmapsto> (p\<bullet>M)\<lparr>N\<rparr> \<prec> P'" and "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> P' \<sim>\<^sub>H Q'"  
    apply(drule_tac hobisimE(3))
    apply(drule_tac simE)
    by auto
  hence PTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>N\<rparr> \<prec> P'" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* P` `(p\<bullet>xvec) \<sharp>* P` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `distinctPerm p`
    by(drule_tac inputPermFrameSubject) (auto simp add: eqvts)
  with QTrans have "A\<^isub>R \<sharp>* P'" "A\<^isub>R \<sharp>* Q'" using `A\<^isub>R \<sharp>* N` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* Q`
    by(auto intro: inputFreshChainDerivative)
  from PTrans `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* M`  `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* R` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `A\<^isub>R \<sharp>* A\<^isub>P` `xvec \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* A\<^isub>Q`
  obtain \<Psi>'' A\<^isub>P' \<Psi>\<^isub>P' where "\<Psi>\<^isub>P \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>P'" and "extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>" and "A\<^isub>P' \<sharp>* P'" and "A\<^isub>P' \<sharp>* M" and "A\<^isub>P' \<sharp>* R" and "A\<^isub>P' \<sharp>* A\<^isub>R" and "A\<^isub>P' \<sharp>* xvec" and "A\<^isub>P' \<sharp>* \<Psi>" and "distinct A\<^isub>P'" "A\<^isub>P' \<sharp>* N" "A\<^isub>P' \<sharp>* A\<^isub>Q"
    by(rule_tac expandNonTauFrame[where C="(R,A\<^isub>R,xvec,\<Psi>,A\<^isub>Q)" and C'="[]::name list"]) auto
  then obtain K' R'' where RTrans': "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" and "(A\<^isub>P',\<Psi>\<otimes>\<Psi>\<^isub>P,R'',R') \<in> TUR' \<S>" using assms PTrans `A\<^isub>R \<sharp>* P'` `A\<^isub>R \<sharp>* Q'`
    by(rule_tac hocomm1AuxAux[where A\<^isub>R=A\<^isub>R and A\<^isub>Q=A\<^isub>Q and A\<^isub>P=A\<^isub>P and Q=Q and xvec=xvec and N=N and L=N and R=R and M=M and K=K and B=A\<^isub>P']) assumption+
  from RTrans `xvec \<sharp>* K` `distinct xvec` `A\<^isub>P' \<sharp>* R` `A\<^isub>P' \<sharp>* xvec`
  have "A\<^isub>P' \<sharp>* R'"
    by(auto intro: outputFreshChainDerivative)
  moreover have "A\<^isub>P' \<sharp>* R''"
  proof -
    obtain q::"name prm" where "set q \<subseteq> set xvec \<times> set(q\<bullet>xvec)" and "(q\<bullet>xvec) \<sharp>* xvec" "(q\<bullet>xvec) \<sharp>* R" "(q\<bullet>xvec) \<sharp>* K'" "(q\<bullet>xvec) \<sharp>* \<Psi>" "(q\<bullet>xvec) \<sharp>* \<Psi>\<^isub>P" and "distinctPerm q"
      by(rule_tac name_list_avoiding[where c="(xvec,R,K',\<Psi>,\<Psi>\<^isub>P)" and xvec=xvec]) auto
    hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>(q\<bullet>K')\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> R''"
      using `xvec \<sharp>* \<Psi>` `xvec \<sharp>* \<Psi>\<^isub>P` `xvec \<sharp>* R` RTrans'
      by(rule_tac outputPermSubject) auto
    moreover from `(q\<bullet>xvec) \<sharp>* K'` have "xvec \<sharp>* (q\<bullet>K')" using `distinctPerm q`
      by(subst fresh_star_bij[where pi=q,symmetric]) simp
    ultimately show ?thesis using `A\<^isub>P' \<sharp>* R` `distinct xvec` `A\<^isub>P' \<sharp>* xvec`
      by(auto intro: outputFreshChainDerivative)
  qed
  moreover from `(A\<^isub>P',\<Psi>\<otimes>\<Psi>\<^isub>P,R'',R') \<in> TUR' \<S>` have "([]@A\<^isub>P',\<Psi>\<otimes>\<Psi>\<^isub>P',R'',R') \<in> TUR' \<S>" using `\<Psi>\<^isub>P \<otimes> \<Psi>'' \<simeq> \<Psi>\<^isub>P'`
    apply(drule_tac TURS'extend[where \<Psi>'=\<Psi>''])
    apply(drule_tac TURS'statEq)
    apply(rule AssertionStatEqTrans[OF Associativity, OF compositionSym])
    apply assumption
    unfolding TUR'_def
    by(rule_tac fresh_rel_trancl_weaken) auto
  ultimately have "([]@A\<^isub>P',\<Psi>,R''\<parallel>P',R'\<parallel>P') \<in> TUR' \<S>" using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* P'` `A\<^isub>P' \<sharp>* \<Psi>` `distinct A\<^isub>P'`
    by(rule_tac TURS'parPres') auto
  hence "(\<Psi>,R''\<parallel>P',R'\<parallel>P') \<in> TUR \<S>"
    unfolding TUR_def TUR'_def
    by(drule_tac fresh_rel_trancl_weaken[where B="[]"]) auto
  hence "(\<Psi>,P'\<parallel>R'',P'\<parallel>R') \<in> TUR \<S>"
    unfolding TUR_def
    apply(rule_tac rel_trancl_transitive)
    apply(rule r_into_rel_trancl)
    apply(rule UnI2[OF hobisimBisim, OF bisimParComm])
    apply(rule_tac rel_trancl_into_rel_trancl)
    apply assumption
    by(rule UnI2[OF hobisimBisim, OF bisimParComm])
  from `\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>R) \<rhd> P' \<sim>\<^sub>H Q'` `(p\<bullet>\<Psi>\<^isub>R) \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>R'`
  have "\<Psi>\<otimes>\<Psi>\<^isub>R' \<rhd> P' \<sim>\<^sub>H Q'"
    apply(drule_tac hobisimE(4)[where \<Psi>'=\<Psi>'])
    apply(rule hostatEqBisim)
    apply assumption
    by(metis AssertionStatEqTrans Associativity  compositionSym)
  moreover have "A\<^isub>R' \<sharp>* P'" "A\<^isub>R' \<sharp>* Q'" using `A\<^isub>R' \<sharp>* Q` `A\<^isub>R' \<sharp>* P` `A\<^isub>R' \<sharp>* N` PTrans QTrans
    by(auto intro: inputFreshChainDerivative)
  ultimately have "(\<Psi>,P'\<parallel>R',Q'\<parallel>R') \<in> \<S>"
    using `extractFrame R' = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* P'` `A\<^isub>R' \<sharp>* Q'` `A\<^isub>R' \<sharp>* R'`
    unfolding \<S>_def
    by blast
  hence "(\<Psi>,P'\<parallel>R',Q'\<parallel>R') \<in> TUR \<S>"
    unfolding TUR_def
    by(auto simp add: exI[where x="[]"] psi.inject)
  with `(\<Psi>,P'\<parallel>R'',P'\<parallel>R') \<in> TUR \<S>` have "(\<Psi>,P'\<parallel>R'',Q'\<parallel>R') \<in> TUR \<S>"
    unfolding TUR_def
    by(rule_tac rel_trancl_transitive)
  thus ?thesis using A RTrans' PTrans `\<Psi>\<otimes>\<Psi>\<^isub>P\<otimes>\<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'` `A\<^isub>R \<sharp>* K'`
    by blast
qed

lemma inputFramePsiInduct[consumes 3, case_names cAlpha cInput cCase cPar1 cPar2 cScope cBang cInv]:
  fixes \<Psi>    :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   M    :: 'a
  and   N    :: 'a
  and   P'   :: "('a, 'b, 'c) psi"
  and   Prop :: "'d::fs_name \<Rightarrow> 'b \<Rightarrow> 'b \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow>
                 'a \<Rightarrow> 'a \<Rightarrow> ('a, 'b, 'c) psi \<Rightarrow> name list \<Rightarrow> 'b \<Rightarrow> bool"
  and   C    :: "'d::fs_name"

  assumes Trans: "\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'"
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     "distinct A\<^isub>P"
  and     rAlpha: "\<And>\<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P p C. \<lbrakk>A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* (p \<bullet> A\<^isub>P); A\<^isub>P \<sharp>* C;
                                            set p \<subseteq> set A\<^isub>P \<times> set(p \<bullet> A\<^isub>P); distinctPerm p;
                                             Prop C \<Psi>' \<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> P M N P' (p \<bullet> A\<^isub>P) (p \<bullet> \<Psi>\<^isub>P)"
  and     rInput: "\<And>\<Psi> M K xvec N Tvec P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> K; distinct xvec; set xvec \<subseteq> supp N;
                    length xvec = length Tvec; xvec \<sharp>* \<Psi>; xvec \<sharp>* \<Psi>';
                    xvec \<sharp>* M; xvec \<sharp>* K; xvec \<sharp>* C\<rbrakk> \<Longrightarrow>
                    Prop C \<Psi>' \<Psi> (M\<lparr>\<lambda>*xvec N\<rparr>.P)
                              K (N[xvec::=Tvec]) (P[xvec::=Tvec]) ([]) (\<one>)"
  and     rCase: "\<And>\<Psi> P M N P' \<phi> Cs A\<^isub>P \<Psi>\<^isub>P C. \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P; \<And>C. Prop C \<Psi>' \<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P;
                                              (\<phi>, P) mem Cs; \<Psi>' \<otimes> \<Psi> \<turnstile> \<phi>; guarded P; \<not>clauseDom \<phi>;  \<Psi>\<^isub>P \<simeq> \<one>; (supp \<Psi>\<^isub>P) = ({}::name set);
                                              A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (Cases Cs) M N P' ([]) (\<one>)"
  and     rPar1: "\<And>\<Psi> \<Psi>\<^isub>Q P M N P' A\<^isub>Q Q A\<^isub>P \<Psi>\<^isub>P C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>Q) P M N P' A\<^isub>P \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* M; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* P'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) M N (P' \<parallel> Q) (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rPar2: "\<And>\<Psi> \<Psi>\<^isub>P Q M N Q' A\<^isub>P P A\<^isub>Q \<Psi>\<^isub>Q C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Q \<longmapsto>M\<lparr>N\<rparr> \<prec> Q';
                   extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                   extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>; distinct A\<^isub>Q;
                   \<And>C. Prop C \<Psi>' (\<Psi> \<otimes> \<Psi>\<^isub>P) Q M N Q' A\<^isub>Q \<Psi>\<^isub>Q;
                   A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* Q; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* Q'; A\<^isub>P \<sharp>* A\<^isub>Q; A\<^isub>P \<sharp>* \<Psi>\<^isub>Q;
                   A\<^isub>Q \<sharp>* P; A\<^isub>Q \<sharp>* Q; A\<^isub>Q \<sharp>* \<Psi>; A\<^isub>Q \<sharp>* \<Psi>'; A\<^isub>Q \<sharp>* M; A\<^isub>Q \<sharp>* N; A\<^isub>Q \<sharp>* Q'; A\<^isub>Q \<sharp>* \<Psi>\<^isub>P;
                   A\<^isub>P \<sharp>* C; A\<^isub>Q \<sharp>* C\<rbrakk> \<Longrightarrow>
                   Prop C \<Psi>' \<Psi> (P \<parallel> Q) M N (P \<parallel> Q') (A\<^isub>P@A\<^isub>Q) (\<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>Q)"
  and     rScope: "\<And>\<Psi> P M N P' x A\<^isub>P \<Psi>\<^isub>P C.
                    \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>; distinct A\<^isub>P;
                    \<And>C. Prop C \<Psi>' \<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P; x \<sharp> \<Psi>; x \<sharp> \<Psi>'; x \<sharp> M; x \<sharp> N; 
                     x \<sharp> A\<^isub>P; A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P';
                     A\<^isub>P \<sharp>* C; x \<sharp> C\<rbrakk> \<Longrightarrow>
                     Prop C \<Psi>' \<Psi> (\<lparr>\<nu>x\<rparr>P) M N (\<lparr>\<nu>x\<rparr>P') (x#A\<^isub>P) \<Psi>\<^isub>P"
  and     rBang:    "\<And>\<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P C.
                     \<lbrakk>\<Psi>' \<otimes> \<Psi> \<rhd> P \<parallel> !P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'; guarded P; extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>;  distinct A\<^isub>P;
                      \<And>C. Prop C \<Psi>' \<Psi> (P \<parallel> !P) M N P' A\<^isub>P (\<Psi>\<^isub>P \<otimes> \<one>); \<Psi>\<^isub>P \<simeq> \<one>; (supp \<Psi>\<^isub>P) = ({}::name set);
                      A\<^isub>P \<sharp>* \<Psi>; A\<^isub>P \<sharp>* \<Psi>'; A\<^isub>P \<sharp>* P; A\<^isub>P \<sharp>* M; A\<^isub>P \<sharp>* N; A\<^isub>P \<sharp>* P'; A\<^isub>P \<sharp>* C\<rbrakk> \<Longrightarrow> Prop C \<Psi>' \<Psi> (!P) M N P' ([]) (\<one>)"
  and     rInv:   "\<And>\<Psi> M P K L P' A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S C.
                   \<lbrakk>\<Psi>' \<otimes> \<Psi> \<turnstile> M \<Leftarrow> P; \<Psi>' \<otimes> \<Psi> \<rhd> P \<longmapsto>K\<lparr>L\<rparr> \<prec> P';
                    guarded P;
                    supp(P) \<subseteq> (supp(M)::name set);
                    extractFrame (P) = \<langle>A\<^isub>P\<^isub>S, \<Psi>\<^isub>P\<^isub>S\<rangle>; distinct A\<^isub>P\<^isub>S;
                    A\<^isub>P\<^isub>S \<sharp>* P; A\<^isub>P\<^isub>S \<sharp>* \<Psi>; A\<^isub>P\<^isub>S \<sharp>* \<Psi>'; A\<^isub>P\<^isub>S \<sharp>* P'; A\<^isub>P\<^isub>S \<sharp>* C; A\<^isub>P\<^isub>S \<sharp>* K;  A\<^isub>P\<^isub>S \<sharp>* L;
                    \<And> C. Prop C \<Psi>' \<Psi> P K L P' A\<^isub>P\<^isub>S \<Psi>\<^isub>P\<^isub>S\<rbrakk>
                    \<Longrightarrow> Prop C \<Psi>' \<Psi> (\<langle>M\<rangle>) K L P' ([]) (\<one>)"
  shows "Prop C \<Psi>' \<Psi> P M N P' A\<^isub>P \<Psi>\<^isub>P"
using assms
by(nominal_induct \<Psi>' \<Psi> P Rs=="M\<lparr>N\<rparr> \<prec> P'" A\<^isub>P \<Psi>\<^isub>P avoiding: C arbitrary: P' rule: semanticsFrameCompInduct) (auto simp add: residualInject)

lemma inputChainFreshChain': 
  fixes yvec   :: "name list"
  and   xvec :: "name list"
  and   N    :: "'a::fs_name"
  and   P    :: "('a, 'b::fs_name, 'c::fs_name) psi"

  assumes "yvec \<sharp>* xvec"
  and "yvec \<sharp>* (inputChain xvec N P)"
  shows "yvec \<sharp>* N" and "yvec \<sharp>* P"
using assms
by(induct xvec) auto

lemma hocomm2Aux:
  fixes \<Psi>    :: 'b
  and   \<Psi>\<^isub>Q   :: 'b
  and   R    :: "('a, 'b, 'c) psi"
  and   K    :: 'a
  and   N    :: 'a
  and   R'   :: "('a, 'b, 'c) psi"
  and   A\<^isub>R   :: "name list"
  and   \<Psi>\<^isub>R   :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   M    :: 'a
  and   xvec :: "name list"
  and   A\<^isub>P   :: "name list"
  and   \<Psi>\<^isub>P   :: 'b
  and   A\<^isub>Q   :: "name list"

  assumes RTrans: "\<Psi>\<^isub>Q \<otimes> \<Psi>  \<rhd> R \<longmapsto>K\<lparr>N\<rparr> \<prec> R'"
  and     FrR: "extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>"
  and     "distinct A\<^isub>R"
(*  and     PTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"*)
  and     QTrans: "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
  and     MeqK: "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
  and     QimpP: "\<Psi>\<^isub>R\<otimes>\<Psi> \<rhd> P \<sim>\<^sub>H Q"
(*  and     QimpP: "\<Psi>\<^isub>R\<otimes>\<Psi>\<^isub> \<rhd> P' \<sim>\<^sub>H Q'"*)
  and     FrP: "extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>"
  and     FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>"
  and     "distinct A\<^isub>P"
  and     "A\<^isub>R \<sharp>* A\<^isub>P"
  and     "A\<^isub>R \<sharp>* A\<^isub>Q"
  and     "A\<^isub>R \<sharp>* \<Psi>"
  and     "A\<^isub>R \<sharp>* \<Psi>\<^isub>Q"
  and     "A\<^isub>R \<sharp>* \<Psi>\<^isub>P"
  and     "A\<^isub>R \<sharp>* P"
  and     "A\<^isub>R \<sharp>* Q"
  and     "A\<^isub>R \<sharp>* R"
  and     "A\<^isub>R \<sharp>* K"
  and     "A\<^isub>R \<sharp>* xvec"
  and     "A\<^isub>P \<sharp>* \<Psi>"
  and     "A\<^isub>P \<sharp>* R"
  and     "A\<^isub>P \<sharp>* P"
  and     "A\<^isub>P \<sharp>* Q"
  and     "A\<^isub>P \<sharp>* M"
  and     "A\<^isub>P \<sharp>* N"
  and     "A\<^isub>Q \<sharp>* R"
  and     "A\<^isub>Q \<sharp>* M"
  and     "A\<^isub>Q \<sharp>* N"
  and     "A\<^isub>Q \<sharp>* \<Psi>"
  and     "A\<^isub>Q \<sharp>* P"
  and     "A\<^isub>Q \<sharp>* Q"
  and     "xvec \<sharp>* M"
  and     "xvec \<sharp>* \<Psi>"
  and     "xvec \<sharp>* P"
  and     "xvec \<sharp>* Q"
  and     "xvec \<sharp>* R"
  and     "xvec \<sharp>* A\<^isub>P"
  and     "xvec \<sharp>* A\<^isub>Q"
  and     "distinct xvec"

  obtains  K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>N\<rparr> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>R \<sharp>* K'" and "(\<Psi>,P'\<parallel>R'',Q'\<parallel>R') \<in> TUR \<S>"
proof -
  assume A: "(\<And>P' K' R''.
        \<lbrakk>\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'; \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'';
         \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'; A\<^isub>R \<sharp>* K'; (\<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR \<S>\<rbrakk>
        \<Longrightarrow> thesis)"
  {    
    fix B::"name list"
    assume as: "B \<sharp>* P" "B \<sharp>* Q" "B \<sharp>* R" "B \<sharp>* xvec" "B \<sharp>* N" "B \<sharp>* A\<^isub>R" "B \<sharp>* A\<^isub>Q" "B \<sharp>* P" "B \<sharp>* A\<^isub>Q" "B \<sharp>* Q'" "B \<sharp>* A\<^isub>P"
    from assms as
    have "\<exists> K' R'' P'. \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K'\<lparr>N\<rparr> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and> B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B,\<Psi>,P'\<parallel>R'',Q'\<parallel>R') \<in> TUR' \<S>"
    proof(nominal_induct avoiding: xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B arbitrary: M rule: inputFramePsiInduct)
      case(cAlpha \<Psi> R K N R' A\<^isub>R \<Psi>\<^isub>R p xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `A\<^isub>R \<sharp>* A\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>P` have "(p\<bullet>A\<^isub>P) = A\<^isub>P" using  `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p`
        by simp
      from `A\<^isub>R \<sharp>* A\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* A\<^isub>Q` have "(p\<bullet>A\<^isub>Q) = A\<^isub>Q" using  `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p`
        by simp
      from `A\<^isub>R \<sharp>* xvec` `(p\<bullet>A\<^isub>R) \<sharp>* xvec` have "(p\<bullet>xvec) = xvec" using  `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p`
        by simp
      from `A\<^isub>R \<sharp>* B` `B \<sharp>* (p\<bullet>A\<^isub>R)` have "(p\<bullet>B) = B" using  `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p`
        by simp
      from `\<Psi> \<otimes> (p \<bullet> \<Psi>\<^isub>R) \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'`
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto> (p\<bullet>M)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* Q` `(p\<bullet>A\<^isub>R) \<sharp>* Q`
        by(drule_tac outputPermFrameSubject[where p=p]) (assumption|simp add: eqvts)+
      have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> (p \<bullet> M) \<leftrightarrow> K" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>Q` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>R \<sharp>* K` `(p\<bullet>A\<^isub>R) \<sharp>* K` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<turnstile> M \<leftrightarrow> K`
        by(subst perm_bool[where pi=p,symmetric], simp add: eqvts)
      have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* Q` `(p\<bullet>A\<^isub>R) \<sharp>* Q` `(p\<bullet>\<Psi>\<^isub>R) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
        by(drule_tac hobisimClosed[where p=p]) (simp add: eqvts)
      from `A\<^isub>P \<sharp>* M` have "(p\<bullet>A\<^isub>P) \<sharp>* M"
        by(subst `(p\<bullet>A\<^isub>P) = A\<^isub>P`)
      hence "A\<^isub>P \<sharp>* (p\<bullet>M)" using `distinctPerm p`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp)
      from `A\<^isub>Q \<sharp>* M` have "(p\<bullet>A\<^isub>Q) \<sharp>* M"
        by(subst `(p\<bullet>A\<^isub>Q) = A\<^isub>Q`)
      hence "A\<^isub>Q \<sharp>* (p\<bullet>M)" using `distinctPerm p`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp)
      from `xvec \<sharp>* M` have "(p\<bullet>xvec) \<sharp>* M"
        by(subst `(p\<bullet>xvec) = xvec`)
      hence "xvec \<sharp>* (p\<bullet>M)" using `distinctPerm p`
        by(subst fresh_star_bij[where pi=p,symmetric]) (simp)
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
        by simp
      have "\<exists>K' R'' P'. \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> (p\<bullet>M)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and> \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>M) \<leftrightarrow> K' \<and> B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule cAlpha) fact+
      then obtain K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> (p\<bullet>M)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>M) \<leftrightarrow> K'" and "B \<sharp>* K'" and "A\<^isub>R \<sharp>* K'" and "(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by blast
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> (p\<bullet>M)\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` have "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* P` `(p\<bullet>A\<^isub>R) \<sharp>* P` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `distinctPerm p`
        by(drule_tac outputPermFrameSubject[where p=p]) (assumption|simp add: eqvts)+
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> R''" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* R` `(p\<bullet>A\<^isub>R) \<sharp>* R` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `distinctPerm p`
        by(rule_tac inputPermSubject[where p=p]) (assumption|force simp add: eqvts)+
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> (p\<bullet>M) \<leftrightarrow> K'` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> (p\<bullet>\<Psi>\<^isub>R) \<turnstile> M \<leftrightarrow> (p\<bullet>K')" using `set p \<subseteq> set A\<^isub>R \<times> set(p\<bullet>A\<^isub>R)` `A\<^isub>R \<sharp>* \<Psi>` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `(p\<bullet>A\<^isub>R) \<sharp>* \<Psi>\<^isub>P` `distinctPerm p`
        by(subst perm_bool[where pi=p,symmetric]) (simp add: eqvts)
      moreover from `B \<sharp>* K'` have "B \<sharp>* (p\<bullet>K')" using `(p\<bullet>B) = B`
        by(subst (asm) fresh_star_bij[where pi=p,symmetric]) (simp)
      moreover from `A\<^isub>R \<sharp>* K'` have "(p\<bullet>A\<^isub>R) \<sharp>* (p\<bullet>K')"
        by(subst fresh_star_bij)
      moreover note `(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
      ultimately show ?case
        by blast
    next
      case(cInput \<Psi> M' K xvec N Tvec R yvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
      have "\<Psi> \<otimes> \<one> \<rhd> P \<sim>\<^sub>H Q"
        by(metis hostatEqBisim Commutativity)
      with `\<Psi> \<otimes> \<one> \<rhd> Q \<longmapsto> M\<lparr>\<nu>*yvec\<rparr>\<langle>N[xvec::=Tvec]\<rangle> \<prec> Q'`
      obtain P' where "\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*yvec\<rparr>\<langle>N[xvec::=Tvec]\<rangle> \<prec> P'" and "\<Psi> \<otimes> \<one> \<rhd> P' \<sim>\<^sub>H Q'" using `yvec \<sharp>* P` `yvec \<sharp>* \<Psi>`
        apply(drule_tac hobisimE(3))
        by(drule_tac simE) auto
      from `\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> M' \<leftrightarrow> K` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M \<leftrightarrow> K` have "\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> M'"
        by(metis Commutativity Identity associativitySym chanEqSym chanEqTrans statEqEnt)
      hence " \<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M \<leftrightarrow> M'"
        by (metis AssertionStatEqSym Commutativity Composition Identity statEqEnt)
      hence "insertAssertion(extractFrame Q) (\<Psi>\<otimes>\<one>) \<turnstile>\<^sub>F M \<leftrightarrow> M'"
        using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* M` `A\<^isub>Q \<sharp>* (M'\<lparr>\<lambda>*xvec N\<rparr>.R)`
        by (metis AssertionStatEqSym AssertionStatEqTrans Commutativity Composition FrameImpResChainPres Identity SFreshBottom(1) `\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> M \<leftrightarrow> M'` frameImpEmpty freshChanEqChain(1) freshCompChain(1) insertAssertion.simps(1) insertAssertionResChain psiFreshVec(2) statEqEnt)
      moreover have "\<not> clauseDom(M \<leftrightarrow> M')"
        by auto
      ultimately have "insertAssertion(extractFrame P) (\<Psi>\<otimes>\<one>) \<turnstile>\<^sub>F M \<leftrightarrow> M'"
        using `\<Psi> \<otimes> \<one> \<rhd> P \<sim>\<^sub>H Q`
        by(blast dest: hobisimE)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M \<leftrightarrow> M'"
        unfolding `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>`
        using  `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* (M'\<lparr>\<lambda>*xvec N\<rparr>.R)`
        apply(subst (asm) insertAssertionSimps)
        apply force
        apply(drule_tac frameImpE)
        apply force
        apply(rule statEqEnt[OF Associativity])
        by(rule statEqEnt[OF associativitySym])
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> M' \<leftrightarrow> M'"
        apply(rule_tac statEqEnt)
        apply(rule AssertionStatEqTrans[OF AssertionStatEqSym, OF Associativity, OF Identity])
        apply(rule_tac chanEqTrans[where N=M])
        by(rule chanEqSym)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> M'\<lparr>\<lambda>*xvec N\<rparr>.R \<longmapsto> M'\<lparr>N[xvec::=Tvec]\<rparr> \<prec> R[xvec::=Tvec]"
        using `distinct xvec` `set xvec \<subseteq> supp N` `length xvec = length Tvec`
        by(rule Input)
      moreover have "B \<sharp>* M'" using `B \<sharp>* (M'\<lparr>\<lambda>*xvec N\<rparr>.R)`
        by auto
      moreover have "([]::name list) \<sharp>* M'"
        by simp
      moreover have "(B, \<Psi>, P' \<parallel> R[xvec::=Tvec], Q' \<parallel> R[xvec::=Tvec]) \<in> TUR' \<S>"
      proof -
        obtain A\<^isub>R \<Psi>\<^isub>R where "extractFrame(R[xvec::=Tvec]) = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" and "distinct A\<^isub>R" and "A\<^isub>R \<sharp>* \<Psi>" and "A\<^isub>R \<sharp>* P'" and "A\<^isub>R \<sharp>* Q'" and "A\<^isub>R \<sharp>* R[xvec::=Tvec]"
          by(rule_tac freshFrame[where C="(\<Psi>,P',Q',R[xvec::=Tvec])"]) auto
        moreover from `\<Psi>\<otimes>\<one> \<rhd> P' \<sim>\<^sub>H Q'` have "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P' \<sim>\<^sub>H Q'"
          by(metis Identity hobisimE(4) hostatEqBisim)
        ultimately have "(\<Psi>, P' \<parallel> R[xvec::=Tvec], Q' \<parallel> R[xvec::=Tvec]) \<in> \<S>"
          unfolding \<S>_def
          by blast
        moreover note `B \<sharp>* Q'`
        moreover have "B \<sharp>* P'"
          using `\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*yvec\<rparr>\<langle>N[xvec::=Tvec]\<rangle> \<prec> P'` `yvec \<sharp>* M` `B \<sharp>* yvec` `B \<sharp>* P` `distinct yvec`
          by(auto intro: outputFreshChainDerivative)
        moreover have "B \<sharp>* R[xvec::=Tvec]"
        proof -
          from `xvec \<sharp>* B` `B \<sharp>* (M'\<lparr>\<lambda>*xvec N\<rparr>.R)`
          have "B \<sharp>* N" "B \<sharp>* R"            
            by(auto simp add: inputChainFreshChain')
          from `B \<sharp>* N[xvec::=Tvec]` `B \<sharp>* N` `xvec \<sharp>* B` `distinct xvec` `length xvec = length Tvec` `set xvec \<subseteq> supp N`
          have "B \<sharp>* Tvec" 
            by(rule_tac subst3ChainVec)
          with `xvec \<sharp>* B` `B \<sharp>* R`
          show ?thesis
            by auto
        qed
        ultimately show ?thesis
          unfolding TUR'_def
          by(auto simp add: exI[where x="[]"])
      qed
      moreover note `\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*yvec\<rparr>\<langle>N[xvec::=Tvec]\<rangle> \<prec> P'` `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M \<leftrightarrow> M'`
      ultimately show ?case
        by blast
    next
      case(cInv \<Psi> M' R K N R' A\<^isub>R \<Psi>\<^isub>R xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'` have "A\<^isub>P \<sharp>* R"
        unfolding fresh_star_def fresh_def
        by(auto simp add: psi.supp)
      from `A\<^isub>Q \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'` have "A\<^isub>Q \<sharp>* R"
        unfolding fresh_star_def fresh_def
        by(auto simp add: psi.supp)
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
        by simp
      from `xvec \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'` have "xvec \<sharp>* R"
        unfolding fresh_star_def fresh_def
        by(auto simp add: psi.supp)
      from `B \<sharp>* \<langle>M'\<rangle>` `supp R \<subseteq> supp M'` have "B \<sharp>* R"
        unfolding fresh_star_def fresh_def
        by(auto simp add: psi.supp)
      from `guarded R` `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>`
      have "\<Psi>\<^isub>R \<simeq> \<one>" and "supp \<Psi>\<^isub>R = ({}::name set)"
        by(auto dest: guardedStatEq)
      with `\<Psi> \<otimes> \<one> \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` have "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
        by(metis AssertionStatEqSym compositionSym statEqTransition)
      from `\<Psi>\<^isub>R \<simeq> \<one>` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M \<leftrightarrow> K` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
        by(metis statEqEnt compositionSym AssertionStatEqSym)
      from `\<Psi>\<^isub>R \<simeq> \<one>` `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" and "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q" and "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
        by(metis hostatEqBisim Composition AssertionStatEqSym Commutativity Identity)+
      have "\<exists>K' R'' P'.
        \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and>
        B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule cInv) fact+
      then obtain K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'"
        and "B \<sharp>* K'" and "A\<^isub>R \<sharp>* K'" and "(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by blast
      from `\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> M'\<Leftarrow>R` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<langle>M'\<rangle>` `A\<^isub>Q \<sharp>* R`
      have "insertAssertion (extractFrame Q) \<Psi> \<turnstile>\<^sub>F M'\<Leftarrow>R"
        by(auto intro: frameImpI statEqEnt[OF Commutativity])
      moreover have "legalClause M' R" using `supp R \<subseteq> supp M'` `guarded R`
        unfolding legalClause_def
        by(rule conjI)
      moreover note `\<Psi> \<rhd> P \<sim>\<^sub>H Q`
      ultimately obtain S where "insertAssertion (extractFrame P) \<Psi> \<turnstile>\<^sub>F M'\<Leftarrow>S" and "legalClause M' S" and "R \<sim>\<^sub>H S"
        by(blast dest: hobisimE)
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `xvec \<sharp>* M` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* N` `xvec \<sharp>* P` `xvec \<sharp>* A\<^isub>P`
        `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `B \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* R` `B \<sharp>* A\<^isub>P` `A\<^isub>R \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* Q`
        `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` `xvec \<sharp>* Q` `xvec \<sharp>* \<langle>M'\<rangle>` `xvec \<sharp>* R` `B \<sharp>* xvec` `A\<^isub>R \<sharp>* xvec` `xvec \<sharp>* P`
      obtain p \<Psi>' A\<^isub>P' \<Psi>\<^isub>P' where "set p \<subseteq> set(xvec) \<times> set(p\<bullet>xvec)" and "(p \<bullet> \<Psi>\<^isub>P) \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'" and "distinctPerm p" and "extractFrame P' = \<langle>A\<^isub>P', \<Psi>\<^isub>P'\<rangle>" and "A\<^isub>P' \<sharp>* P'" and "A\<^isub>P' \<sharp>* M" "A\<^isub>P' \<sharp>* xvec" "A\<^isub>P' \<sharp>* N" and "A\<^isub>P' \<sharp>* (p \<bullet> M)"  and "A\<^isub>P' \<sharp>* (p \<bullet> xvec)"  and "A\<^isub>P' \<sharp>* (p \<bullet> N)" and "(p\<bullet>xvec) \<sharp>* M" and "(p\<bullet>xvec) \<sharp>* xvec" and "(p\<bullet>xvec) \<sharp>* N" and "(p\<bullet>xvec) \<sharp>* P'" and "distinct A\<^isub>P'"
        and "A\<^isub>P' \<sharp>* P" and "A\<^isub>P' \<sharp>* \<Psi>" and "A\<^isub>P' \<sharp>* M'" and "A\<^isub>P' \<sharp>* B" and "A\<^isub>P' \<sharp>* R" and "A\<^isub>P' \<sharp>* A\<^isub>R" and "A\<^isub>P' \<sharp>* Q"
        and "(p\<bullet>xvec) \<sharp>* P" and "(p\<bullet>xvec) \<sharp>* \<Psi>" and "(p\<bullet>xvec) \<sharp>* M'" and "(p\<bullet>xvec) \<sharp>* B" and "(p\<bullet>xvec) \<sharp>* R" and "(p\<bullet>xvec) \<sharp>* A\<^isub>R" and "(p\<bullet>xvec) \<sharp>* Q"
        by(rule_tac expandNonTauFrame[where C="(P,\<Psi>,M',B,R,A\<^isub>R,Q)" and C'="(P,\<Psi>,M',B,R,A\<^isub>R,Q)"]) (assumption|auto)+
      from `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''` have "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>P) \<rhd> R \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> R''" using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `xvec \<sharp>* R` `(p\<bullet>xvec) \<sharp>* R`
        by(drule_tac inputPermFrameSubject) (auto simp add: eqvts)
      moreover from `R \<sim>\<^sub>H S` have "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>P) \<rhd> R \<sim>\<^sub>H S"
        apply(drule_tac hobisimE(4)[where \<Psi>'="\<Psi>\<otimes>(p\<bullet>\<Psi>\<^isub>P)"])
        apply(rule hostatEqBisim)
        apply assumption
        by(metis AssertionStatEqTrans Commutativity Identity)
      ultimately obtain S' where "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>P) \<rhd> S \<longmapsto> (p\<bullet>K')\<lparr>N\<rparr> \<prec> S'" and "\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>P) \<rhd> S' \<sim>\<^sub>H R''"
        apply(drule_tac hobisimE(5))
        apply(drule_tac hobisimE(3))
        by(drule_tac simE) auto
      moreover from `xvec \<sharp>* \<langle>M'\<rangle>` `(p\<bullet>xvec) \<sharp>* M'` `A\<^isub>P' \<sharp>* M'` `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `legalClause M' S`
      have "guarded S" and "xvec \<sharp>* S" and "(p\<bullet>xvec) \<sharp>* S" and "A\<^isub>P' \<sharp>* S" and "A\<^isub>P \<sharp>* S"
        by(auto simp add: legalClause_def)
      ultimately have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S'"  using `set p \<subseteq> set xvec \<times> set(p\<bullet>xvec)` `xvec \<sharp>* \<Psi>` `(p\<bullet>xvec) \<sharp>* \<Psi>` `distinctPerm p`
        by(drule_tac inputPermFrameSubject) (auto simp add: eqvts)
      moreover from `insertAssertion (extractFrame P) \<Psi> \<turnstile>\<^sub>F M'\<Leftarrow>S`
      have "\<Psi>\<otimes>\<Psi>\<^isub>P \<turnstile> M'\<Leftarrow>S" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<langle>M'\<rangle>` `A\<^isub>P \<sharp>* S`
        by(auto intro: frameImpE)
      ultimately have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<langle>M'\<rangle> \<longmapsto> K'\<lparr>N\<rparr> \<prec> S'"
        using `legalClause M' S`
        unfolding legalClause_def
        by(rule_tac Inv) auto
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` have "\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        using `\<Psi>\<^isub>R \<simeq> \<one>`
        by(metis statEqTransition compositionSym)
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M \<leftrightarrow> K'"
        using `\<Psi>\<^isub>R \<simeq> \<one>`
        by(metis statEqEnt compositionSym)
      moreover note `B \<sharp>* K'`
      moreover have "([]::name list) \<sharp>* K'"
        by simp
      moreover have "(B, \<Psi>, P' \<parallel> S', Q' \<parallel> R') \<in> TUR' \<S>"
      proof -
        from `\<Psi> \<otimes> (p\<bullet>\<Psi>\<^isub>P) \<rhd> S' \<sim>\<^sub>H R''`
        have "\<Psi> \<otimes> \<Psi>\<^isub>P' \<rhd> S' \<sim>\<^sub>H R''"
          using `(p\<bullet>\<Psi>\<^isub>P) \<otimes> \<Psi>' \<simeq> \<Psi>\<^isub>P'`
          apply(drule_tac hobisimE(4)[where \<Psi>'=\<Psi>'])
          apply(rule_tac hostatEqBisim)
          apply assumption
          apply(rule AssertionStatEqTrans[OF Associativity])
          by(rule compositionSym)
        moreover have "A\<^isub>P' \<sharp>* S'" using `A\<^isub>P' \<sharp>* S` `A\<^isub>P' \<sharp>* N` `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S'`
          by(auto intro: inputFreshChainDerivative)
        moreover have "A\<^isub>P' \<sharp>* R''" using `A\<^isub>P' \<sharp>* R` `A\<^isub>P' \<sharp>* N` `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''`
          by(auto intro: inputFreshChainDerivative)
        ultimately have "(\<Psi>,S'\<parallel>P',R''\<parallel>P') \<in> \<S>"
          unfolding \<S>_def using `extractFrame P' = \<langle>A\<^isub>P',\<Psi>\<^isub>P'\<rangle>` `A\<^isub>P' \<sharp>* \<Psi>`
          by blast
        moreover have "B \<sharp>* S'" using `B \<sharp>* \<langle>M'\<rangle>` `legalClause M' S` `B \<sharp>* N` `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S'`
          by(auto intro: inputFreshChainDerivative)
        moreover have "B \<sharp>* R''" using `B \<sharp>* \<langle>M'\<rangle>` `legalClause M' R` `B \<sharp>* N` `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''`
          by(auto intro: inputFreshChainDerivative)
        moreover have "B \<sharp>* P'" using `B \<sharp>* xvec` `xvec \<sharp>* M` `distinct xvec` `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `B \<sharp>* P`
          by(auto intro: outputFreshChainDerivative)
        ultimately have "(B, \<Psi>, P' \<parallel> S', P' \<parallel> R'') \<in> TUR' \<S>"
          unfolding TUR'_def
          apply(rule_tac fresh_rel_trancl_into_fresh_rel_trancl[where Q="R'' \<parallel> P'"])
          apply(rule_tac fresh_rel_trancl_into_fresh_rel_trancl)
          apply(rule r_into_fresh_rel_trancl)
          apply(rule UnI2[OF hobisimBisim, OF bisimParComm])
          apply simp
          apply simp
          apply(rule UnI1)
          apply(force simp add: exI[where x="[]"])
          apply simp
          apply(rule UnI2[OF hobisimBisim, OF bisimParComm])
          apply simp
          done
        with `(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
        show ?thesis
          unfolding TUR'_def
          by(rule_tac fresh_rel_trancl_transitive)
      qed
      ultimately show ?case
        by blast
    next
      case(cCase \<Psi> R K N R' \<phi> Cs A\<^isub>R \<Psi>\<^isub>R xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `\<Psi> \<otimes> \<one> \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `\<Psi>\<^isub>R \<simeq> \<one>`
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
        by(metis statEqTransition compositionSym AssertionStatEqSym)
      from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M \<leftrightarrow> K` `\<Psi>\<^isub>R \<simeq> \<one>`
      have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
        by(metis statEqEnt compositionSym AssertionStatEqSym)
      from `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>R \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" "\<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<Psi>\<^isub>R \<simeq> \<one>`
        by(metis hostatEqBisim Composition AssertionStatEqSym Identity Commutativity)+
      have "A\<^isub>P \<sharp>* R" "A\<^isub>P \<sharp>* \<phi>" using `A\<^isub>P \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs`
        by(induct Cs) auto
      have "A\<^isub>Q \<sharp>* R" "A\<^isub>Q \<sharp>* \<phi>" using `A\<^isub>Q \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs`
        by(induct Cs) auto
      have "xvec \<sharp>* R" "xvec \<sharp>* \<phi>" using `xvec \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs`
        by(induct Cs) auto
      have "B \<sharp>* R" "B \<sharp>* \<phi>" using `B \<sharp>* (Cases Cs)` `(\<phi>, R) mem Cs`
        by(induct Cs) auto
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
        by simp
      have "\<exists>K' R'' P'.
        \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and>
        B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule_tac cCase) fact+
      then obtain K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "B \<sharp>* K'" and "A\<^isub>R \<sharp>* K'" and "(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by blast
      from `\<Psi>\<^isub>Q \<otimes> \<Psi> \<turnstile> \<phi>`
      have "insertAssertion (extractFrame Q) \<Psi> \<turnstile>\<^sub>F \<phi>"
        using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* \<phi>` `A\<^isub>Q \<sharp>* \<Psi>`
        by(auto intro: frameImpI statEqEnt[OF Commutativity])
      with `\<not> clauseDom \<phi>` `\<Psi> \<rhd> P \<sim>\<^sub>H Q`
      have "insertAssertion (extractFrame P) \<Psi> \<turnstile>\<^sub>F \<phi>"
        by(blast dest: hobisimE)
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi>" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* \<phi>` `A\<^isub>P \<sharp>* \<Psi>`
        by(auto intro: frameImpE)
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` have "\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        using `\<Psi>\<^isub>R \<simeq> \<one>`
        by(metis statEqTransition compositionSym AssertionStatEqSym)
      moreover from `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'` have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M \<leftrightarrow> K'"
        using `\<Psi>\<^isub>R \<simeq> \<one>`
        by(metis statEqEnt compositionSym AssertionStatEqSym)
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> Cases Cs \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''`
        using `\<Psi> \<otimes> \<Psi>\<^isub>P \<turnstile> \<phi>` `(\<phi>,R) mem Cs` `guarded R` `\<not> clauseDom \<phi>`
        by(rule_tac Case) assumption+        
      moreover note `B \<sharp>* K'`
      moreover have "([]::name list) \<sharp>* K'" by simp
      moreover note `(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
      ultimately show ?case
        by blast
    next
      case(cPar1 \<Psi> \<Psi>\<^isub>S R K N R' A\<^isub>S S A\<^isub>R \<Psi>\<^isub>R xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>\<^isub>Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>\<^isub>P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* (R \<parallel> S)`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* K`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* xvec`
      have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>\<^isub>P" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* R" "A\<^isub>R \<sharp>* S" "A\<^isub>R \<sharp>* K" "A\<^isub>R \<sharp>* xvec" "A\<^isub>S \<sharp>* A\<^isub>P" "A\<^isub>S \<sharp>* A\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>" "A\<^isub>S \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>\<^isub>P" "A\<^isub>S \<sharp>* P" "A\<^isub>S \<sharp>* Q" "A\<^isub>S \<sharp>* R" "A\<^isub>S \<sharp>* S" "A\<^isub>S \<sharp>* K" "A\<^isub>S \<sharp>* xvec"
        by auto
      from `A\<^isub>P \<sharp>* (R\<parallel>S)` have "A\<^isub>P \<sharp>* R" and  "A\<^isub>P \<sharp>* S"
        by auto
      hence "A\<^isub>P \<sharp>* \<Psi>\<^isub>S" "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* A\<^isub>P` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* A\<^isub>P`
        by(auto dest: extractFrameFreshChain)
      from `A\<^isub>Q \<sharp>* (R\<parallel>S)` have "A\<^isub>Q \<sharp>* R" and  "A\<^isub>Q \<sharp>* S"
        by auto
      hence "A\<^isub>Q \<sharp>* \<Psi>\<^isub>S" "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* A\<^isub>Q` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* A\<^isub>Q`
        by(auto dest: extractFrameFreshChain)
      from `xvec \<sharp>* (R\<parallel>S)` have "xvec \<sharp>* R" and  "xvec \<sharp>* S"
        by auto
      hence "xvec \<sharp>* \<Psi>\<^isub>S" "xvec \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* xvec` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* xvec`
        by(auto dest: extractFrameFreshChain)
      from `B \<sharp>* (R\<parallel>S)` have "B \<sharp>* R" and  "B \<sharp>* S"
        by auto
      hence "B \<sharp>* \<Psi>\<^isub>S" "B \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* B` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* B`
        by(auto dest: extractFrameFreshChain)
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'`
      have "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>R \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
        by (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym statEqTransition)
      from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K`
      have "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K"
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqRefl AssertionStatEqSym AssertionStatEqTrans Associativity Commutativity Composition')
      have "\<Psi>\<^isub>R \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>S \<rhd> P \<sim>\<^sub>H Q"
        using `(\<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
        apply(rule_tac hostatEqBisim,assumption)
        by (metis AssertionStatEqTrans Associativity associativitySym)
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
        by simp
      from `A\<^isub>R \<sharp>* A\<^isub>S` have "A\<^isub>S \<sharp>* A\<^isub>R"
        by simp
      have "\<exists>K' R'' P'.
        (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and>
        (B@A\<^isub>S) \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B@A\<^isub>S, \<Psi> \<otimes> \<Psi>\<^isub>S, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule_tac cPar1) (fact|rule freshCompChain|subst freshChainAppend|rule conjI)+
      then obtain K' R'' P' where "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        and "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" and "(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'"
        and "B \<sharp>* K'" and "(A\<^isub>R@A\<^isub>S) \<sharp>* K'" and "(B@A\<^isub>S, \<Psi> \<otimes> \<Psi>\<^isub>S, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by auto
      from `(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` have "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        by (metis AssertionStatEqTrans Associativity associativitySym statEqTransition)
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R\<parallel>S \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''\<parallel>S"
      proof -
        from `(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''`
        have "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>S \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''"
          by (metis associativitySym statEqTransition)
        thus ?thesis using `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* \<Psi>` `A\<^isub>S \<sharp>* \<Psi>\<^isub>P` `A\<^isub>S \<sharp>* R` `(A\<^isub>R@A\<^isub>S) \<sharp>* K'` `A\<^isub>S \<sharp>* N`
          by(rule_tac Par1) auto
      qed
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K'" using `(\<Psi> \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Commutativity Composition')
      moreover note `B \<sharp>* K'` `(A\<^isub>R@A\<^isub>S) \<sharp>* K'`
      moreover have "(B, \<Psi>, P' \<parallel> (R''\<parallel>S), Q' \<parallel> (R' \<parallel> S)) \<in> TUR' \<S>"
      proof -
        from `(B@A\<^isub>S, \<Psi> \<otimes> \<Psi>\<^isub>S, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
        have "(B@A\<^isub>S, \<Psi>, P' \<parallel> R'' \<parallel> S, Q' \<parallel> R' \<parallel> S) \<in> TUR' \<S>"
          apply(rule TURS'parPres')
          by(rule refl|fact)+
        hence "(B, \<Psi>, P' \<parallel> R'' \<parallel> S, Q' \<parallel> R' \<parallel> S) \<in> TUR' \<S>"
          unfolding TUR'_def
          by(rule_tac fresh_rel_trancl_weaken) auto
        thus ?thesis
          unfolding TUR'_def
          apply(rule_tac fresh_rel_trancl_transitive)
          apply(rule r_into_fresh_rel_trancl[OF UnI2, OF hobisimBisim, OF bisimSymmetric, OF bisimParAssoc])
          apply(force dest: fresh_rel_trancl_fresh)
          apply(force dest: fresh_rel_trancl_fresh)
          apply(rule_tac fresh_rel_trancl_into_fresh_rel_trancl)
          apply assumption
          apply(rule UnI2[OF hobisimBisim, OF bisimParAssoc])          
          apply(force dest: fresh_rel_trancl_fresh)
          done
      qed
      ultimately show ?case
        by blast
    next
      case(cPar2 \<Psi> \<Psi>\<^isub>R S K N S' A\<^isub>R R A\<^isub>S \<Psi>\<^isub>S xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* A\<^isub>Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>\<^isub>Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* \<Psi>\<^isub>P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* P`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* Q`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* (R \<parallel> S)`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* K`
        `(A\<^isub>R @ A\<^isub>S) \<sharp>* xvec`
      have "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>\<^isub>P" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* R" "A\<^isub>R \<sharp>* S" "A\<^isub>R \<sharp>* K" "A\<^isub>R \<sharp>* xvec" "A\<^isub>S \<sharp>* A\<^isub>P" "A\<^isub>S \<sharp>* A\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>" "A\<^isub>S \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>S \<sharp>* \<Psi>\<^isub>P" "A\<^isub>S \<sharp>* P" "A\<^isub>S \<sharp>* Q" "A\<^isub>S \<sharp>* R" "A\<^isub>S \<sharp>* S" "A\<^isub>S \<sharp>* K" "A\<^isub>S \<sharp>* xvec"
        by auto
      from `A\<^isub>P \<sharp>* (R\<parallel>S)` have "A\<^isub>P \<sharp>* R" and  "A\<^isub>P \<sharp>* S"
        by auto
      hence "A\<^isub>P \<sharp>* \<Psi>\<^isub>S" "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* A\<^isub>P` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* A\<^isub>P`
        by(auto dest: extractFrameFreshChain)
      from `A\<^isub>Q \<sharp>* (R\<parallel>S)` have "A\<^isub>Q \<sharp>* R" and  "A\<^isub>Q \<sharp>* S"
        by auto
      hence "A\<^isub>Q \<sharp>* \<Psi>\<^isub>S" "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* A\<^isub>Q` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* A\<^isub>Q`
        by(auto dest: extractFrameFreshChain)
      from `xvec \<sharp>* (R\<parallel>S)` have "xvec \<sharp>* R" and  "xvec \<sharp>* S"
        by auto
      hence "xvec \<sharp>* \<Psi>\<^isub>S" "xvec \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* xvec` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* xvec`
        by(auto dest: extractFrameFreshChain)
      from `B \<sharp>* (R\<parallel>S)` have "B \<sharp>* R" and  "B \<sharp>* S"
        by auto
      hence "B \<sharp>* \<Psi>\<^isub>S" "B \<sharp>* \<Psi>\<^isub>R" using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* B` `extractFrame S = \<langle>A\<^isub>S,\<Psi>\<^isub>S\<rangle>` `A\<^isub>S \<sharp>* B`
        by(auto dest: extractFrameFreshChain)
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'`
      have "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>S \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
        by (metis AssertionStatEqSym AssertionStatEqTrans Associativity associativitySym statEqTransition)
      from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K`
      have "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K"
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqRefl AssertionStatEqSym AssertionStatEqTrans Associativity Commutativity Composition')
      have "\<Psi>\<^isub>S \<otimes> \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q"
        using `(\<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q`
        apply(rule_tac hostatEqBisim,assumption)
        by (metis AssertionStatEqTrans Associativity Commutativity)
      from `A\<^isub>S \<sharp>* B` have "B \<sharp>* A\<^isub>S"
        by simp
      from `A\<^isub>R \<sharp>* A\<^isub>S` have "A\<^isub>S \<sharp>* A\<^isub>R"
        by simp
      have "\<exists>K' S'' P'.
        (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S'' \<and>
        (\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K' \<and>
        (B@A\<^isub>R) \<sharp>* K' \<and> A\<^isub>S \<sharp>* K' \<and> (B@A\<^isub>R, \<Psi> \<otimes> \<Psi>\<^isub>R, P' \<parallel> S'', Q' \<parallel> S') \<in> TUR' \<S>"
        by(rule_tac cPar2) (fact|rule freshCompChain|subst freshChainAppend|rule conjI)+
      then obtain K' S'' P' where "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        and "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S''" and "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K'"
        and "B \<sharp>* K'" and "(A\<^isub>R@A\<^isub>S) \<sharp>* K'" and "(B@A\<^isub>R, \<Psi> \<otimes> \<Psi>\<^isub>R, P' \<parallel> S'', Q' \<parallel> S') \<in> TUR' \<S>"
        by auto
      from `(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` have "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        by (metis AssertionStatEqTrans Associativity associativitySym statEqTransition)
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R\<parallel>S \<longmapsto> K'\<lparr>N\<rparr> \<prec> R\<parallel>S''"
      proof -
        from `(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S''`
        have "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>R \<rhd> S \<longmapsto> K'\<lparr>N\<rparr> \<prec> S''"
          by (metis associativitySym statEqTransition)
        thus ?thesis using `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* S` `(A\<^isub>R@A\<^isub>S) \<sharp>* K'` `A\<^isub>R \<sharp>* N`
          by(rule_tac Par2) auto
      qed
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K'" using `(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>S \<turnstile> M \<leftrightarrow> K'`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqRefl AssertionStatEqTrans Associativity Commutativity Composition')
      moreover note `B \<sharp>* K'` `(A\<^isub>R@A\<^isub>S) \<sharp>* K'`
      moreover have "(B, \<Psi>, P' \<parallel> (R\<parallel>S''), Q' \<parallel> (R \<parallel> S')) \<in> TUR' \<S>"
      proof -
        from `(B@A\<^isub>R, \<Psi> \<otimes> \<Psi>\<^isub>R, P' \<parallel> S'', Q' \<parallel> S') \<in> TUR' \<S>`
        have "(B@A\<^isub>R, \<Psi>, P' \<parallel> S'' \<parallel> R, Q' \<parallel> S' \<parallel> R) \<in> TUR' \<S>"
          apply(rule TURS'parPres')
          by(rule refl|fact)+
        hence "(B, \<Psi>, P' \<parallel> S'' \<parallel> R, Q' \<parallel> S' \<parallel> R) \<in> TUR' \<S>"
          unfolding TUR'_def
          by(rule_tac fresh_rel_trancl_weaken) auto
        thus ?thesis
          unfolding TUR'_def
          apply(rule_tac fresh_rel_trancl_transitive[where Q="P'\<parallel>S''\<parallel>R"])
          apply(rule r_into_fresh_rel_trancl[OF UnI2, OF hobisimBisim])
          apply(rule bisimSymmetric)
          apply(rule bisimTransitive[OF bisimParAssoc])
          apply(rule bisimParPresSym)
          apply(rule bisimParComm)
          apply(force dest: fresh_rel_trancl_fresh)
          apply(force dest: fresh_rel_trancl_fresh)
          apply(rule_tac fresh_rel_trancl_into_fresh_rel_trancl)
          apply assumption
          apply(rule UnI2[OF hobisimBisim])
          apply(rule bisimTransitive[OF bisimParAssoc])
          apply(rule bisimParPresSym)
          apply(rule bisimParComm)
          apply(force dest: fresh_rel_trancl_fresh)
          done
      qed
      ultimately show ?case
        by blast
    next
      case(cBang \<Psi> R K N R' A\<^isub>R \<Psi>\<^isub>R xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `A\<^isub>P \<sharp>* !R` `A\<^isub>Q \<sharp>* !R` `B \<sharp>* !R` `xvec \<sharp>* !R`
      have "A\<^isub>P \<sharp>* R" "A\<^isub>Q \<sharp>* R" "B \<sharp>* R" "xvec \<sharp>* R"
        by auto
      have "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'"
        using `\<Psi> \<otimes> \<one> \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqTransition)
        apply assumption
        by(metis Identity compositionSym AssertionStatEqTrans AssertionStatEqSym)
      have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> M \<leftrightarrow> K" using `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<one> \<turnstile> M \<leftrightarrow> K` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqSym AssertionStatEqTrans Identity compositionSym)
      have "(\<Psi>\<^isub>R \<otimes> \<one>) \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q" using `\<one> \<otimes> \<Psi> \<rhd> P \<sim>\<^sub>H Q` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac hostatEqBisim)
        apply assumption
        by(metis AssertionStatEqSym AssertionStatEqTrans Composition Identity)
      have "\<exists>K' R'' P'.
        \<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> M \<leftrightarrow> K' \<and>
        B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule_tac cBang) (fact|simp)+
      then obtain K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and
        "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''"
        "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> M \<leftrightarrow> K'"
        "B \<sharp>* K'" "A\<^isub>R \<sharp>* K'" "(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by blast
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `\<Psi>\<^isub>R \<simeq> \<one>`
      have "\<Psi> \<otimes> \<one> \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'"
        apply(rule_tac statEqTransition)
        apply assumption
        by(metis AssertionStatEqTrans Identity compositionSym)
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> !R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<parallel> !R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''` `guarded R`
        by(rule Bang)
      moreover have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<one> \<turnstile> M \<leftrightarrow> K'" using `\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<otimes> \<one> \<turnstile> M \<leftrightarrow> K'` `\<Psi>\<^isub>R \<simeq> \<one>`
        apply(rule_tac statEqEnt)
        defer
        apply assumption
        by (metis AssertionStatEqTrans Identity compositionSym)
      moreover note `B \<sharp>* K'`
      moreover have "([]::name list) \<sharp>* K'"
        by simp
      moreover note `(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
      ultimately show ?case
        by blast
    next
      case(cScope \<Psi> R K N R' x A\<^isub>R \<Psi>\<^isub>R xvec Q' P Q A\<^isub>Q A\<^isub>P \<Psi>\<^isub>P B M)
      from `(x # A\<^isub>R) \<sharp>* A\<^isub>P`
        `(x # A\<^isub>R) \<sharp>* A\<^isub>Q`
        `(x # A\<^isub>R) \<sharp>* \<Psi>`
        `(x # A\<^isub>R) \<sharp>* \<Psi>\<^isub>Q`
        `(x # A\<^isub>R) \<sharp>* \<Psi>\<^isub>P`
        `(x # A\<^isub>R) \<sharp>* P`
        `(x # A\<^isub>R) \<sharp>* Q`
        `(x # A\<^isub>R) \<sharp>* \<lparr>\<nu>x\<rparr>R`
        `(x # A\<^isub>R) \<sharp>* K`
        `(x # A\<^isub>R) \<sharp>* xvec`
      have "x \<sharp> A\<^isub>P" "x \<sharp> A\<^isub>Q" "x \<sharp> \<Psi>" "x \<sharp> \<Psi>\<^isub>Q" "x \<sharp> \<Psi>\<^isub>P" "x \<sharp> P" "x \<sharp> Q" "x \<sharp> \<lparr>\<nu>x\<rparr>R" "x \<sharp> K" "x \<sharp> xvec"
        "A\<^isub>R \<sharp>* A\<^isub>P" "A\<^isub>R \<sharp>* A\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>" "A\<^isub>R \<sharp>* \<Psi>\<^isub>Q" "A\<^isub>R \<sharp>* \<Psi>\<^isub>P" "A\<^isub>R \<sharp>* P" "A\<^isub>R \<sharp>* Q" "A\<^isub>R \<sharp>* \<lparr>\<nu>x\<rparr>R" "A\<^isub>R \<sharp>* K" "A\<^isub>R \<sharp>* xvec"
        by auto
      from `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* \<lparr>\<nu>x\<rparr>R` have "A\<^isub>P \<sharp>* R"
        by simp
      from `x \<sharp> A\<^isub>Q` `A\<^isub>Q \<sharp>* \<lparr>\<nu>x\<rparr>R` have "A\<^isub>Q \<sharp>* R"
        by simp
      from `x \<sharp> xvec` `xvec \<sharp>* \<lparr>\<nu>x\<rparr>R` have "xvec \<sharp>* R"
        by simp
      from `x \<sharp> B` `B \<sharp>* \<lparr>\<nu>x\<rparr>R` have "B \<sharp>* R"
        by simp
      from `A\<^isub>R \<sharp>* B` have "B \<sharp>* A\<^isub>R"
        by simp
      have "\<exists>K' R'' P'.
        \<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R'' \<and>
        \<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K' \<and>
        B \<sharp>* K' \<and> A\<^isub>R \<sharp>* K' \<and> (B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by(rule_tac cScope) fact+
      then obtain K' R'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and RTrans: "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto> K'\<lparr>N\<rparr> \<prec> R''" and MeqK': "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K'" and "B \<sharp>* K'" and "A\<^isub>R \<sharp>* K'" and "(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>"
        by blast
      from `A\<^isub>R \<sharp>* A\<^isub>P` `A\<^isub>P \<sharp>* (\<lparr>\<nu>x\<rparr>R)` `x \<sharp> A\<^isub>P` `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` have "A\<^isub>P \<sharp>* \<Psi>\<^isub>R"
	by(force dest: extractFrameFreshChain)+
      from `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `x \<sharp> P` `B \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>\<^isub>R` `x \<sharp> A\<^isub>P` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* \<Psi>` `B \<sharp>* A\<^isub>P` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* A\<^isub>P` `xvec \<sharp>* M` `distinct xvec`
      obtain K'' where MeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>R) \<otimes> \<Psi>\<^isub>P \<turnstile> M \<leftrightarrow> K''" and "x \<sharp> K''" and "A\<^isub>R \<sharp>* K''" and "B \<sharp>* K''"
	by(rule_tac B="(x#A\<^isub>R@B)" in obtainPrefix) (assumption | simp | force | metis freshChainSym)+     
      from MeqK'' MeqK' have KeqK'': "(\<Psi> \<otimes> \<Psi>\<^isub>P) \<otimes> \<Psi>\<^isub>R \<turnstile> K' \<leftrightarrow> K''"
	by(metis statEqEnt Associativity Composition Commutativity chanEqSym chanEqTrans)
      with RTrans `extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>` `distinct A\<^isub>R` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* \<Psi>\<^isub>P` `A\<^isub>R \<sharp>* K'` `A\<^isub>R \<sharp>* K''` `A\<^isub>R \<sharp>* R`
      have "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> R \<longmapsto>K''\<lparr>N\<rparr> \<prec> R''"
	by(rule_tac inputRenameSubject) (assumption | force)+
      hence "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> \<lparr>\<nu>x\<rparr>R \<longmapsto>K''\<lparr>N\<rparr> \<prec> \<lparr>\<nu>x\<rparr>R''" using `x \<sharp> \<Psi>` `x \<sharp> \<Psi>\<^isub>P` `x \<sharp> K''` `x \<sharp> N`
	by(rule_tac Scope) (assumption | force)+
      moreover from MeqK'' have "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>R \<turnstile> M \<leftrightarrow> K''"
	by(metis statEqEnt Associativity Composition Commutativity)
      moreover note `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `B \<sharp>* K''`
      moreover have "(x#A\<^isub>R) \<sharp>* K''" using `x \<sharp> K''` `A\<^isub>R \<sharp>* K''`
        by simp
      moreover have "(B, \<Psi>, P' \<parallel> \<lparr>\<nu>x\<rparr>R'', Q' \<parallel> \<lparr>\<nu>x\<rparr>R') \<in> TUR' \<S>"
      proof -
        note `x \<sharp> Q'`
        moreover have "x \<sharp> P'" using `x \<sharp> P` `x \<sharp> xvec` `xvec \<sharp>* M` `distinct xvec` `\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'`
          by(auto intro: outputFreshDerivative)
        moreover note `(B, \<Psi>, P' \<parallel> R'', Q' \<parallel> R') \<in> TUR' \<S>`
        moreover hence "B \<sharp>* P'" "B \<sharp>* R'" "B \<sharp>* Q'" "B \<sharp>* R''"
          unfolding TUR'_def
          by(auto dest: fresh_rel_trancl_fresh)
        ultimately show ?thesis using `x \<sharp> \<Psi>` `x \<sharp> B`
          apply(drule_tac TURS'resPres)
          apply assumption
          unfolding TUR'_def
          apply(rule fresh_rel_trancl_transitive)
          apply(rule fresh_rel_trancl_transitive)
          apply(rule r_into_fresh_rel_trancl[OF UnI2, OF hobisimBisim, OF bisimSymmetric, OF bisimScopeExt])
          apply assumption
          apply force
          apply force
          apply assumption
          apply(rule r_into_fresh_rel_trancl[OF UnI2, OF hobisimBisim, OF bisimScopeExt])
          by auto
      qed
      ultimately show ?case
        by blast
    qed
  }
  note rool = this
  from A rool[where B2="[]"]
  show ?thesis
    unfolding TUR'_def TUR_def
    by auto
qed

lemma hobisimParPresAux:
  fixes \<Psi>  :: 'b
  and   P  :: "('a, 'b, 'c) psi"
  and   Q  :: "('a, 'b, 'c) psi"
  and   R  :: "('a, 'b, 'c) psi"
  and   S :: "('a, 'b, 'c) psi"
  
  assumes "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q"
  and     "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
  and     "A\<^isub>R \<sharp>* \<Psi>"
  and     "A\<^isub>R \<sharp>* P"
  and     "A\<^isub>R \<sharp>* Q"

  shows "\<Psi> \<rhd> P \<parallel> R \<sim>\<^sub>H Q \<parallel> R"
proof -
  have "(\<Psi>,P\<parallel>R,Q\<parallel>R) \<in> \<S>" using assms
    unfolding \<S>_def
    by(auto simp add: psi.inject)
  thus ?thesis using Seqvt
  proof(coinduct rule: hobisimWeakCoinductTUR)
    case(cStatEq \<Psi> R' S' \<phi>)
    from cStatEq obtain P Q R A\<^isub>R \<Psi>\<^isub>R where R': "R'=P\<parallel>R" and S': "S'=Q\<parallel>R" and "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q" and "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" and "A\<^isub>R \<sharp>* \<Psi>" and "A\<^isub>R \<sharp>* P" and "A\<^isub>R \<sharp>* Q"
      unfolding \<S>_def
      by auto
    obtain A\<^isub>R' \<Psi>\<^isub>R' where "extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>" and "distinct A\<^isub>R'" and "A\<^isub>R' \<sharp>* \<Psi>" and "A\<^isub>R' \<sharp>* R'" and "A\<^isub>R' \<sharp>* S'" and "A\<^isub>R' \<sharp>* \<phi>" and "A\<^isub>R' \<sharp>* P" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* A\<^isub>R" and "A\<^isub>R' \<sharp>* \<Psi>\<^isub>R"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',\<phi>,P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R)"]) auto
    obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* R'" and "A\<^isub>P \<sharp>* S'" and "A\<^isub>P \<sharp>* \<phi>" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* A\<^isub>R" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>P \<sharp>* A\<^isub>R'" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>R'"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',\<phi>,P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R,\<Psi>\<^isub>R',A\<^isub>R')"]) auto
    obtain A\<^isub>Q \<Psi>\<^isub>Q where "extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* R'" and "A\<^isub>Q \<sharp>* S'" and "A\<^isub>Q \<sharp>* \<phi>" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* A\<^isub>R" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>Q \<sharp>* A\<^isub>R'" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R'" and "A\<^isub>Q \<sharp>* A\<^isub>P" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>P"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',\<phi>,P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R,\<Psi>\<^isub>R',A\<^isub>R',A\<^isub>P,\<Psi>\<^isub>P)"]) auto
    have "\<Psi>\<otimes>\<Psi>\<^isub>R' \<rhd> P \<sim>\<^sub>H Q"
    proof -
      from `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` have "\<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle> = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
        by simp
      with `A\<^isub>R' \<sharp>* A\<^isub>R`
      obtain p::"name prm" where "(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)" and "distinctPerm p" and "\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'"
        by(rule_tac frameChainEq) (assumption|simp)+
      from `\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q` show ?thesis unfolding `\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'` using `(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* Q` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* P` `A\<^isub>R' \<sharp>* Q`
        by(drule_tac p=p in hobisimClosed) (simp add: eqvts)
    qed
    have "A\<^isub>R' \<sharp>* \<Psi>\<^isub>P" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* A\<^isub>R'` `A\<^isub>R' \<sharp>* P`
      by(drule_tac extractFrameFreshChain) simp
    have "A\<^isub>R' \<sharp>* \<Psi>\<^isub>Q" using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* A\<^isub>R'` `A\<^isub>R' \<sharp>* Q`
      by(drule_tac extractFrameFreshChain) simp
    from `insertAssertion (extractFrame R') \<Psi> \<turnstile>\<^sub>F \<phi>` have "insertAssertion (extractFrame P) (\<Psi>\<otimes>\<Psi>\<^isub>R') \<turnstile>\<^sub>F \<phi>"
      unfolding `R'=P\<parallel>R` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` extractFrameSimps
      using `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>R'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* \<Psi>\<^isub>P` `A\<^isub>P \<sharp>* A\<^isub>R'` `A\<^isub>P \<sharp>* \<phi>` `A\<^isub>R' \<sharp>* \<phi>`
      apply(subst insertAssertionSimps, force)
      apply(subst (asm) mergeFrames,simp,simp,simp)
      apply(subst (asm) insertAssertionSimps, force)
      apply(rule frameImpI[OF refl],assumption)
      apply(drule_tac frameImpE,simp)
      by(metis Associativity Commutativity associativitySym statEqEnt)
    hence "insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>\<^isub>R') \<turnstile>\<^sub>F \<phi>" using `\<Psi>\<otimes>\<Psi>\<^isub>R' \<rhd> P \<sim>\<^sub>H Q` `\<not> clauseDom \<phi>`
      by(blast dest: hobisimE)
    thus ?case
      unfolding `S'=Q\<parallel>R` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` extractFrameSimps
      using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>R'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>R'` `A\<^isub>Q \<sharp>* \<phi>` `A\<^isub>R' \<sharp>* \<phi>`
      apply(subst (asm) insertAssertionSimps, force)
      apply(subst mergeFrames,simp,simp,simp)
      apply(subst insertAssertionSimps, force)
      apply(rule frameImpI[OF refl],simp)
      apply(drule_tac frameImpE,assumption)
      by(metis Associativity Commutativity associativitySym statEqEnt)
  next
    case(cClauseEq \<Psi> R' S' M P')
    from cClauseEq obtain P Q R A\<^isub>R \<Psi>\<^isub>R where R': "R'=P\<parallel>R" and S': "S'=Q\<parallel>R" and "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q" and "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" and "A\<^isub>R \<sharp>* \<Psi>" and "A\<^isub>R \<sharp>* P" and "A\<^isub>R \<sharp>* Q"
      unfolding \<S>_def
      by auto
    obtain A\<^isub>R' \<Psi>\<^isub>R' where "extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>" and "distinct A\<^isub>R'" and "A\<^isub>R' \<sharp>* \<Psi>" and "A\<^isub>R' \<sharp>* R'" and "A\<^isub>R' \<sharp>* S'" and "A\<^isub>R' \<sharp>* M" and "A\<^isub>R' \<sharp>* P'" and "A\<^isub>R' \<sharp>* P" and "A\<^isub>R' \<sharp>* Q" and "A\<^isub>R' \<sharp>* A\<^isub>R" and "A\<^isub>R' \<sharp>* \<Psi>\<^isub>R"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',M,P',P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R)"]) auto
    obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* R'" and "A\<^isub>P \<sharp>* S'" and "A\<^isub>P \<sharp>* M" and "A\<^isub>P \<sharp>* P'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* A\<^isub>R" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>P \<sharp>* A\<^isub>R'" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>R'"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',M,P',P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R,\<Psi>\<^isub>R',A\<^isub>R')"]) auto
    obtain A\<^isub>Q \<Psi>\<^isub>Q where "extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>" and "distinct A\<^isub>Q" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* R'" and "A\<^isub>Q \<sharp>* S'" and "A\<^isub>Q \<sharp>* M" and "A\<^isub>Q \<sharp>* P'" and "A\<^isub>Q \<sharp>* P" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* A\<^isub>R" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R" and "A\<^isub>Q \<sharp>* A\<^isub>R'" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>R'" and "A\<^isub>Q \<sharp>* A\<^isub>P" and "A\<^isub>Q \<sharp>* \<Psi>\<^isub>P"
      by(rule_tac freshFrame[where C="(\<Psi>,R',S',M,P',P,Q,R,A\<^isub>R,\<Psi>\<^isub>R,A\<^isub>R,\<Psi>\<^isub>R',A\<^isub>R',A\<^isub>P,\<Psi>\<^isub>P)"]) auto
    have "\<Psi>\<otimes>\<Psi>\<^isub>R' \<rhd> P \<sim>\<^sub>H Q"
    proof -
      from `extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` have "\<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle> = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>"
        by simp
      with `A\<^isub>R' \<sharp>* A\<^isub>R`
      obtain p::"name prm" where "(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)" and "distinctPerm p" and "\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'"
        by(rule_tac frameChainEq) (assumption|simp)+
      from `\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q` show ?thesis unfolding `\<Psi>\<^isub>R = p \<bullet> \<Psi>\<^isub>R'` using `(set p) \<subseteq> (set A\<^isub>R') \<times> set (A\<^isub>R)` `distinctPerm p` `A\<^isub>R \<sharp>* \<Psi>` `A\<^isub>R \<sharp>* P` `A\<^isub>R \<sharp>* Q` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* P` `A\<^isub>R' \<sharp>* Q`
        by(drule_tac p=p in hobisimClosed) (simp add: eqvts)
    qed
    have "A\<^isub>R' \<sharp>* \<Psi>\<^isub>P" using `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `A\<^isub>P \<sharp>* A\<^isub>R'` `A\<^isub>R' \<sharp>* P`
      by(drule_tac extractFrameFreshChain) simp
    have "A\<^isub>R' \<sharp>* \<Psi>\<^isub>Q" using `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `A\<^isub>Q \<sharp>* A\<^isub>R'` `A\<^isub>R' \<sharp>* Q`
      by(drule_tac extractFrameFreshChain) simp
    from `insertAssertion (extractFrame R') \<Psi> \<turnstile>\<^sub>F M \<Leftarrow> P'` have "insertAssertion (extractFrame P) (\<Psi>\<otimes>\<Psi>\<^isub>R') \<turnstile>\<^sub>F  M \<Leftarrow> P'"
      unfolding `R'=P\<parallel>R` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` extractFrameSimps
      using `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* \<Psi>\<^isub>R'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* \<Psi>\<^isub>P` `A\<^isub>P \<sharp>* A\<^isub>R'` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* P'` `A\<^isub>R' \<sharp>* M` `A\<^isub>R' \<sharp>* P'`
      apply(subst insertAssertionSimps, force)
      apply(subst (asm) mergeFrames,simp,simp,simp)
      apply(subst (asm) insertAssertionSimps, force)
      apply(rule frameImpI[OF refl],force)
      apply(drule_tac frameImpE,force)
      by(metis Associativity Commutativity associativitySym statEqEnt)
    then obtain Q' where "P' \<sim>\<^sub>H Q'" and "insertAssertion (extractFrame Q) (\<Psi>\<otimes>\<Psi>\<^isub>R') \<turnstile>\<^sub>F  M \<Leftarrow> Q'" and "legalClause M Q'"
      using `\<Psi>\<otimes>\<Psi>\<^isub>R' \<rhd> P \<sim>\<^sub>H Q` `legalClause M P'`
      by(blast dest: hobisimE)
    hence "insertAssertion (extractFrame S') \<Psi> \<turnstile>\<^sub>F  M \<Leftarrow> Q'"
      unfolding `S'=Q\<parallel>R` `extractFrame R = \<langle>A\<^isub>R',\<Psi>\<^isub>R'\<rangle>` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` extractFrameSimps
      using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* \<Psi>\<^isub>R'` `A\<^isub>R' \<sharp>* \<Psi>` `A\<^isub>R' \<sharp>* \<Psi>\<^isub>Q` `A\<^isub>Q \<sharp>* A\<^isub>R'` `A\<^isub>Q \<sharp>* M` `A\<^isub>R' \<sharp>* M` `A\<^isub>Q \<sharp>* P` `A\<^isub>R' \<sharp>* P`
      apply(subst (asm) insertAssertionSimps, force)
      apply(subst mergeFrames,simp,simp,simp)
      apply(subst insertAssertionSimps, force)
      apply(rule frameImpI[OF refl],force)
      apply(drule_tac frameImpE,force)
      by(metis Associativity Commutativity associativitySym statEqEnt)
    moreover from `P' \<sim>\<^sub>H Q'` have "(\<one>,P',Q') \<in> TUR \<S>"
      unfolding TUR_def
      by blast
    ultimately show ?case using `legalClause M Q'`
      by blast
  next
    case(cExt \<Psi> R S \<Psi>')
    from `(\<Psi>, R, S) \<in> \<S>`
    obtain A\<^isub>T \<Psi>\<^isub>T P Q T where Rdef: "R = P\<parallel>T" and Sdef: "S = Q\<parallel>T" and eft: "extractFrame T = \<langle>A\<^isub>T,\<Psi>\<^isub>T\<rangle>" and "A\<^isub>T \<sharp>* P" and "A\<^isub>T \<sharp>* Q" and "A\<^isub>T \<sharp>* \<Psi>" and "\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q" unfolding \<S>_def
      by auto
    obtain A\<^isub>T' \<Psi>\<^isub>T' where eft': "extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>" and "A\<^isub>T' \<sharp>* \<Psi>" and "A\<^isub>T' \<sharp>* R" and "A\<^isub>T' \<sharp>* S" and "A\<^isub>T' \<sharp>* \<Psi>'" "A\<^isub>T' \<sharp>* A\<^isub>T" and "A\<^isub>T' \<sharp>* \<Psi>\<^isub>T" and "A\<^isub>T' \<sharp>* P" and "A\<^isub>T' \<sharp>* Q" and "A\<^isub>T' \<sharp>* T" and "distinct A\<^isub>T'"
      by(rule freshFrame[where C="(\<Psi>,R,S,\<Psi>',A\<^isub>T,\<Psi>\<^isub>T,P,Q,T)"]) auto
    have "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q"
    proof -
      from eft eft' have "\<langle>A\<^isub>T, \<Psi>\<^isub>T\<rangle> = \<langle>A\<^isub>T', \<Psi>\<^isub>T'\<rangle>"
        by simp
      with `A\<^isub>T' \<sharp>* A\<^isub>T`
      obtain p where "set p \<subseteq> set A\<^isub>T \<times> set A\<^isub>T'" and "distinctPerm p" and psitd: "\<Psi>\<^isub>T' = p\<bullet>\<Psi>\<^isub>T"
        apply(rule_tac frameChainEq)
        apply assumption
        apply simp
        apply blast
        done
      thus "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `A\<^isub>T \<sharp>* P` `A\<^isub>T \<sharp>* Q` and `A\<^isub>T \<sharp>* \<Psi>` and `\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q` `A\<^isub>T' \<sharp>* P` `A\<^isub>T' \<sharp>* Q` and `A\<^isub>T' \<sharp>* \<Psi>`
        apply(drule_tac eqvtI[where p=p, OF hobisimEqvt])
        by(simp add: eqvts)
    qed
    have "(\<Psi> \<otimes> \<Psi>') \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q`
      by(metis associativitySym hostatEqBisim hobisimE)
    thus ?case unfolding Rdef Sdef using eft' `A\<^isub>T' \<sharp>* P` and `A\<^isub>T' \<sharp>* Q` and `A\<^isub>T' \<sharp>* \<Psi>` and `A\<^isub>T' \<sharp>* \<Psi>'`
      unfolding \<S>_def
      by(auto simp add: psi.inject)
  next
    case cSym thus ?case unfolding \<S>_def
      by(blast intro: hobisimSymmetric)
  next
    case(cSim \<Psi> R S)
    then obtain A\<^isub>T \<Psi>\<^isub>T P Q T where Rdef: "R = P\<parallel>T" and Sdef: "S = Q\<parallel>T" and eft: "extractFrame T = \<langle>A\<^isub>T,\<Psi>\<^isub>T\<rangle>" and "A\<^isub>T \<sharp>* P" and "A\<^isub>T \<sharp>* Q" and "A\<^isub>T \<sharp>* \<Psi>" and "\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q" unfolding \<S>_def
      by auto
    have "\<Psi> \<rhd> P \<parallel> T \<leadsto>[TUR \<S>] Q \<parallel> T"
    proof(rule simI[where C="(A\<^isub>T,\<Psi>\<^isub>T)"])
      show "eqvt (TUR \<S>)"
        by(rule TUReqvt[OF Seqvt])
    next
      fix \<alpha> Q'
      assume "\<Psi> \<rhd> Q \<parallel> T \<longmapsto> \<alpha> \<prec> Q'"
        "bn \<alpha> \<sharp>* (P \<parallel> T)"
        "bn \<alpha> \<sharp>* (Q \<parallel> T)"
        "bn \<alpha> \<sharp>* \<Psi>"
        "distinct (bn \<alpha>)"
        "bn \<alpha> \<sharp>* subject \<alpha>"
        "bn \<alpha> \<sharp>* (A\<^isub>T,\<Psi>\<^isub>T)"
      hence "bn \<alpha> \<sharp>* P" by simp
      note `\<Psi> \<rhd> Q \<parallel> T \<longmapsto> \<alpha> \<prec> Q'` `bn \<alpha> \<sharp>* \<Psi>`
      moreover have "bn \<alpha> \<sharp>* Q" and "bn \<alpha> \<sharp>* T"
        using `bn \<alpha> \<sharp>* (Q \<parallel> T)` by auto
      moreover note `bn \<alpha> \<sharp>* subject \<alpha>`
      ultimately show "\<exists>P'. \<Psi> \<rhd> P \<parallel> T \<longmapsto> \<alpha> \<prec> P' \<and> (\<Psi>, P', Q') \<in> TUR \<S>"
      proof(induct rule: parCases[where C="(bn \<alpha>,Q,P,A\<^isub>T)"])
        case(cPar1 Q' A\<^isub>T' \<Psi>\<^isub>T')
        have "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q"
        proof -
          from eft `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` have "\<langle>A\<^isub>T, \<Psi>\<^isub>T\<rangle> = \<langle>A\<^isub>T', \<Psi>\<^isub>T'\<rangle>"
            by simp
          with `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)`
          obtain p where "set p \<subseteq> set A\<^isub>T \<times> set A\<^isub>T'" and "distinctPerm p" and psitd: "\<Psi>\<^isub>T' = p\<bullet>\<Psi>\<^isub>T"
            apply(rule_tac frameChainEq)
            apply assumption
            apply simp
            apply blast
            done
          thus "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `A\<^isub>T \<sharp>* P` `A\<^isub>T \<sharp>* Q` and `A\<^isub>T \<sharp>* \<Psi>` and `\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q` `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)` `A\<^isub>T' \<sharp>* \<Psi>`
            apply(drule_tac eqvtI[where p=p, OF hobisimEqvt])
            by(simp add: eqvts)
        qed
        moreover have "bn \<alpha> \<sharp>* \<Psi>\<^isub>T'"
        proof -
          have "bn \<alpha> \<sharp>* T" using `bn \<alpha> \<sharp>* (P \<parallel> T)`
            by simp
          thus ?thesis
            using  `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)` `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>`
            by(auto dest: extractFrameFreshChain)
        qed
        moreover note `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> Q \<longmapsto> \<alpha> \<prec> Q'` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* (P \<parallel> T)`
        ultimately obtain P' where "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<longmapsto> \<alpha> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P' \<sim>\<^sub>H Q'"
          apply(drule_tac hobisimE(3))
          apply(drule simE)
          by auto
        have "A\<^isub>T' \<sharp>* P" using `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)`
          by simp
        have "A\<^isub>T' \<sharp>* P'"
          by(rule freeFreshChainDerivative) fact+
        have "\<Psi> \<rhd> P\<parallel>T \<longmapsto> \<alpha> \<prec> P'\<parallel>T" using `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<longmapsto> \<alpha> \<prec> P'`
          by(rule Par1) fact+
        moreover have "(\<Psi>,P'\<parallel>T, Q'\<parallel>T) \<in> TUR \<S>" using `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P' \<sim>\<^sub>H Q'` `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` `A\<^isub>T' \<sharp>* P'` `A\<^isub>T' \<sharp>* Q'` `A\<^isub>T' \<sharp>* \<Psi>`
          unfolding TUR_def \<S>_def
          apply(rule_tac rel_trancl.intros)
          apply(rule UnI1)
          apply auto
          apply(rule_tac exI[where x="[]"])
          by(auto simp add: psi.inject)
        ultimately show ?case
          by blast
      next
        case(cPar2 T' A\<^isub>Q \<Psi>\<^isub>Q)
        obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* T" and "A\<^isub>P \<sharp>* \<alpha>" and "A\<^isub>P \<sharp>* T'" and "A\<^isub>P \<sharp>* bn \<alpha>" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* A\<^isub>T" and "A\<^isub>P \<sharp>* A\<^isub>Q" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q"
          by(rule_tac freshFrame[where C="(\<Psi>,Q,T,\<alpha>,T',bn \<alpha>,P,A\<^isub>T,A\<^isub>Q,\<Psi>\<^isub>Q)"]) auto
        obtain A\<^isub>T' \<Psi>\<^isub>T' where eft': "extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>" and "A\<^isub>T' \<sharp>* \<Psi>" and "A\<^isub>T' \<sharp>* R" and "A\<^isub>T' \<sharp>* S" "A\<^isub>T' \<sharp>* A\<^isub>T" and "A\<^isub>T' \<sharp>* \<Psi>\<^isub>T" and "A\<^isub>T' \<sharp>* P" and "A\<^isub>T' \<sharp>* Q" and "A\<^isub>T' \<sharp>* T" and "A\<^isub>T' \<sharp>* \<alpha>" and "A\<^isub>T' \<sharp>* T'" and "A\<^isub>T' \<sharp>* A\<^isub>P" and "A\<^isub>T' \<sharp>* \<Psi>\<^isub>P" and "A\<^isub>T' \<sharp>* A\<^isub>Q" and "A\<^isub>T' \<sharp>* \<Psi>\<^isub>Q" and "distinct A\<^isub>T'"
          by(rule freshFrame[where C="(\<Psi>,R,S,A\<^isub>T,\<Psi>\<^isub>T,P,Q,T,\<alpha>,T',A\<^isub>P,\<Psi>\<^isub>P,A\<^isub>Q,\<Psi>\<^isub>Q)"]) auto
        have "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q"
        proof -
          from eft eft' have "\<langle>A\<^isub>T, \<Psi>\<^isub>T\<rangle> = \<langle>A\<^isub>T', \<Psi>\<^isub>T'\<rangle>"
            by simp
          with `A\<^isub>T' \<sharp>* A\<^isub>T`
          obtain p where "set p \<subseteq> set A\<^isub>T \<times> set A\<^isub>T'" and "distinctPerm p" and psitd: "\<Psi>\<^isub>T' = p\<bullet>\<Psi>\<^isub>T"
            apply(rule_tac frameChainEq)
            apply assumption
            apply simp
            apply blast
            done
          thus "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `A\<^isub>T \<sharp>* P` `A\<^isub>T \<sharp>* Q` and `A\<^isub>T \<sharp>* \<Psi>` and `\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q` `A\<^isub>T' \<sharp>* P` `A\<^isub>T' \<sharp>* Q` and `A\<^isub>T' \<sharp>* \<Psi>`
            apply(drule_tac eqvtI[where p=p, OF hobisimEqvt])
            by(simp add: eqvts)
        qed
        have "A\<^isub>Q \<sharp>* subject \<alpha>" and "A\<^isub>P \<sharp>* subject \<alpha>" using `A\<^isub>Q \<sharp>* \<alpha>` `A\<^isub>P \<sharp>* \<alpha>`
          by auto
        have "\<exists> T''. \<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> T \<longmapsto> \<alpha> \<prec> T'' \<and> (\<Psi>,P\<parallel>T'',Q\<parallel>T') \<in> TUR \<S>"
          
          apply(rule_tac transferHOFrame)
          by(fact|rule hobisimSymmetric)+
        then obtain T'' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> T \<longmapsto> \<alpha> \<prec> T''" and "(\<Psi>,P\<parallel>T'',Q\<parallel>T') \<in> TUR \<S>"
          by blast
        have "\<Psi> \<rhd> P\<parallel>T \<longmapsto> \<alpha> \<prec> P\<parallel>T''"
          by(rule Par2) fact+
        thus ?case using `(\<Psi>,P\<parallel>T'',Q\<parallel>T') \<in> TUR \<S>`          
          by blast
      next
        case(cComm1 \<Psi>\<^isub>T' M N Q' A\<^isub>Q \<Psi>\<^isub>Q K xvec T' A\<^isub>T')
        from `A\<^isub>Q \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "A\<^isub>Q \<sharp>* bn \<alpha>" "A\<^isub>Q \<sharp>* Q" "A\<^isub>Q \<sharp>* P" "A\<^isub>Q \<sharp>* A\<^isub>T"
          by auto
        from `A\<^isub>T' \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "A\<^isub>T' \<sharp>* bn \<alpha>" "A\<^isub>T' \<sharp>* Q" "A\<^isub>T' \<sharp>* P" "A\<^isub>T' \<sharp>* A\<^isub>T"
          by auto
        from `xvec \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "xvec \<sharp>* bn \<alpha>" "xvec \<sharp>* Q" "xvec \<sharp>* P" "xvec \<sharp>* A\<^isub>T"
          by auto
        have "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q"
        proof -
          from eft `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` have "\<langle>A\<^isub>T, \<Psi>\<^isub>T\<rangle> = \<langle>A\<^isub>T', \<Psi>\<^isub>T'\<rangle>"
            by simp
          with `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)`
          obtain p where "set p \<subseteq> set A\<^isub>T \<times> set A\<^isub>T'" and "distinctPerm p" and psitd: "\<Psi>\<^isub>T' = p\<bullet>\<Psi>\<^isub>T"
            apply(rule_tac frameChainEq)
            apply assumption
            apply simp
            apply blast
            done
          thus "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `A\<^isub>T \<sharp>* P` `A\<^isub>T \<sharp>* Q` and `A\<^isub>T \<sharp>* \<Psi>` and `\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q` `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)` `A\<^isub>T' \<sharp>* \<Psi>`
            apply(drule_tac eqvtI[where p=p, OF hobisimEqvt])
            by(simp add: eqvts)
        qed
        obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* T" and "A\<^isub>P \<sharp>* T'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* A\<^isub>T" and "A\<^isub>P \<sharp>* A\<^isub>Q" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>T" and "A\<^isub>T' \<sharp>* A\<^isub>P" and "A\<^isub>P \<sharp>* A\<^isub>T'" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>T'" and "A\<^isub>P \<sharp>* M" and "A\<^isub>P \<sharp>* N" and "A\<^isub>P \<sharp>* xvec" and "xvec \<sharp>* A\<^isub>P" and "A\<^isub>P \<sharp>* K"
          by(rule_tac freshFrame[where C="(\<Psi>,Q,T,T',P,A\<^isub>T,A\<^isub>Q,\<Psi>\<^isub>Q,\<Psi>\<^isub>T,A\<^isub>T',\<Psi>\<^isub>T',M,N,xvec,K)"]) auto
        from `A\<^isub>Q \<sharp>* A\<^isub>T'` have "A\<^isub>T' \<sharp>* A\<^isub>Q" by simp
        from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> T \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> T'` have "\<Psi>\<^isub>Q \<otimes> \<Psi> \<rhd> T \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> T'"
          by(rule statEqTransition) (rule Commutativity)        
        moreover note `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` `distinct A\<^isub>T'` `xvec \<sharp>* K` `distinct xvec` `extractFrame P = \<langle>A\<^isub>P, \<Psi>\<^isub>P\<rangle>` `distinct A\<^isub>P` `distinct A\<^isub>Q` `xvec \<sharp>* P` `xvec \<sharp>* Q` `xvec \<sharp>* T` `xvec \<sharp>* \<Psi>`
        `xvec \<sharp>* \<Psi>\<^isub>T'` `xvec \<sharp>* \<Psi>\<^isub>Q`
        moreover have "xvec \<sharp>* \<Psi>\<^isub>P" using `xvec \<sharp>* P` `A\<^isub>P \<sharp>* xvec` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>`
          by(drule_tac extractFrameFreshChain) simp
        moreover note `xvec \<sharp>* M`
        moreover have "xvec \<sharp>* A\<^isub>T'" using `A\<^isub>T' \<sharp>* xvec`
          by simp
        moreover note `xvec \<sharp>* A\<^isub>P`
        moreover have "xvec \<sharp>* A\<^isub>Q" using `A\<^isub>Q \<sharp>* xvec`
          by simp
        moreover note `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> Q \<longmapsto> M\<lparr>N\<rparr> \<prec> Q'` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>T' \<turnstile> M \<leftrightarrow> K`
        moreover from `\<Psi>\<otimes>\<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>T'\<otimes>\<Psi> \<rhd> P \<sim>\<^sub>H Q"
          by(metis hostatEqBisim Commutativity)
        moreover note `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>`
          `A\<^isub>T' \<sharp>* A\<^isub>P` `A\<^isub>T' \<sharp>* A\<^isub>Q` `A\<^isub>T' \<sharp>* \<Psi>` `A\<^isub>T' \<sharp>* P` `A\<^isub>T' \<sharp>* Q` `A\<^isub>T' \<sharp>* N` `A\<^isub>T' \<sharp>* Q'` `A\<^isub>T' \<sharp>* T` `A\<^isub>T' \<sharp>* K` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* T` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* N` `A\<^isub>P \<sharp>* A\<^isub>Q` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* T` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* M`
        ultimately obtain K' T'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> T \<longmapsto>K'\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> T''" and "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'" "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>T' \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>T' \<sharp>* K'" and "(\<Psi>,P'\<parallel>T'',Q'\<parallel>T') \<in> TUR \<S>"
          by(rule hocomm1Aux)
        have "\<Psi> \<rhd> P \<parallel> T \<longmapsto> \<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> T'')"
          by(rule Comm1) fact+
        moreover from `(\<Psi>,P'\<parallel>T'',Q'\<parallel>T') \<in> TUR \<S>` have "(\<Psi>,\<lparr>\<nu>*xvec\<rparr>P'\<parallel>T'',\<lparr>\<nu>*xvec\<rparr>Q'\<parallel>T') \<in> TUR \<S>" using `xvec \<sharp>* \<Psi>`
          by(induct xvec) (auto simp add: TURSresPres)
        ultimately show ?case
          by blast
      next
        case(cComm2 \<Psi>\<^isub>T' M xvec N Q' A\<^isub>Q \<Psi>\<^isub>Q K T' A\<^isub>T')
        from `A\<^isub>Q \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "A\<^isub>Q \<sharp>* bn \<alpha>" "A\<^isub>Q \<sharp>* Q" "A\<^isub>Q \<sharp>* P" "A\<^isub>Q \<sharp>* A\<^isub>T"
          by auto
        from `A\<^isub>T' \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "A\<^isub>T' \<sharp>* bn \<alpha>" "A\<^isub>T' \<sharp>* Q" "A\<^isub>T' \<sharp>* P" "A\<^isub>T' \<sharp>* A\<^isub>T"
          by auto
        from `xvec \<sharp>* (bn \<alpha>, Q, P, A\<^isub>T)` have "xvec \<sharp>* bn \<alpha>" "xvec \<sharp>* Q" "xvec \<sharp>* P" "xvec \<sharp>* A\<^isub>T"
          by auto
        have "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q"
        proof -
          from eft `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` have "\<langle>A\<^isub>T, \<Psi>\<^isub>T\<rangle> = \<langle>A\<^isub>T', \<Psi>\<^isub>T'\<rangle>"
            by simp
          with `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)`
          obtain p where "set p \<subseteq> set A\<^isub>T \<times> set A\<^isub>T'" and "distinctPerm p" and psitd: "\<Psi>\<^isub>T' = p\<bullet>\<Psi>\<^isub>T"
            apply(rule_tac frameChainEq)
            apply assumption
            apply simp
            apply blast
            done
          thus "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q" using `A\<^isub>T \<sharp>* P` `A\<^isub>T \<sharp>* Q` and `A\<^isub>T \<sharp>* \<Psi>` and `\<Psi> \<otimes> \<Psi>\<^isub>T \<rhd> P \<sim>\<^sub>H Q` `A\<^isub>T' \<sharp>* (bn \<alpha>,Q,P,A\<^isub>T)` `A\<^isub>T' \<sharp>* \<Psi>`
            apply(drule_tac eqvtI[where p=p, OF hobisimEqvt])
            by(simp add: eqvts)
        qed
        obtain A\<^isub>P \<Psi>\<^isub>P where "extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>" and "distinct A\<^isub>P" and "A\<^isub>P \<sharp>* \<Psi>" and "A\<^isub>P \<sharp>* Q" and "A\<^isub>P \<sharp>* T" and "A\<^isub>P \<sharp>* T'" and "A\<^isub>P \<sharp>* P" and "A\<^isub>P \<sharp>* A\<^isub>T" and "A\<^isub>P \<sharp>* A\<^isub>Q" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>Q" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>T" and "A\<^isub>T' \<sharp>* A\<^isub>P" and "A\<^isub>P \<sharp>* A\<^isub>T'" and "A\<^isub>P \<sharp>* \<Psi>\<^isub>T'" and "A\<^isub>P \<sharp>* M" and "A\<^isub>P \<sharp>* N" and "A\<^isub>P \<sharp>* xvec" and "xvec \<sharp>* A\<^isub>P" and "A\<^isub>P \<sharp>* K"
          by(rule_tac freshFrame[where C="(\<Psi>,Q,T,T',P,A\<^isub>T,A\<^isub>Q,\<Psi>\<^isub>Q,\<Psi>\<^isub>T,A\<^isub>T',\<Psi>\<^isub>T',M,N,xvec,K)"]) auto
        from `A\<^isub>Q \<sharp>* A\<^isub>T'` have "A\<^isub>T' \<sharp>* A\<^isub>Q" by simp
        from `\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> T \<longmapsto>K\<lparr>N\<rparr> \<prec> T'` have "\<Psi>\<^isub>Q \<otimes> \<Psi> \<rhd> T \<longmapsto>K\<lparr>N\<rparr> \<prec> T'"
          by(rule statEqTransition) (rule Commutativity)
        moreover note `extractFrame T = \<langle>A\<^isub>T',\<Psi>\<^isub>T'\<rangle>` `distinct A\<^isub>T'` `\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> Q \<longmapsto> M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'` `\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> \<Psi>\<^isub>T' \<turnstile> M \<leftrightarrow> K`
        moreover from `\<Psi>\<otimes>\<Psi>\<^isub>T' \<rhd> P \<sim>\<^sub>H Q` have "\<Psi>\<^isub>T'\<otimes>\<Psi> \<rhd> P \<sim>\<^sub>H Q"
          by(metis hostatEqBisim Commutativity)
        moreover note `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>` `extractFrame Q = \<langle>A\<^isub>Q,\<Psi>\<^isub>Q\<rangle>` `distinct A\<^isub>P`
          `A\<^isub>T' \<sharp>* A\<^isub>P` `A\<^isub>T' \<sharp>* A\<^isub>Q` `A\<^isub>T' \<sharp>* \<Psi>` `A\<^isub>T' \<sharp>* \<Psi>\<^isub>Q`
        moreover have "A\<^isub>T' \<sharp>* \<Psi>\<^isub>P"
          using `A\<^isub>P \<sharp>* A\<^isub>T'` `A\<^isub>T' \<sharp>* P` `extractFrame P = \<langle>A\<^isub>P,\<Psi>\<^isub>P\<rangle>`
          by(auto dest: extractFrameFreshChain)
        moreover note `A\<^isub>T' \<sharp>* P` `A\<^isub>T' \<sharp>* Q` `A\<^isub>T' \<sharp>* T` `A\<^isub>T' \<sharp>* K` `A\<^isub>T' \<sharp>* xvec` `A\<^isub>P \<sharp>* \<Psi>` `A\<^isub>P \<sharp>* T` `A\<^isub>P \<sharp>* P` `A\<^isub>P \<sharp>* Q` `A\<^isub>P \<sharp>* M` `A\<^isub>P \<sharp>* N` `A\<^isub>Q \<sharp>* T` `A\<^isub>Q \<sharp>* M` `A\<^isub>Q \<sharp>* N` `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* P` `A\<^isub>Q \<sharp>* Q`
           `xvec \<sharp>* M` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` `xvec \<sharp>* Q` `xvec \<sharp>* T` `xvec \<sharp>* A\<^isub>P`
        moreover have "xvec \<sharp>* A\<^isub>Q" using `A\<^isub>Q \<sharp>* xvec` by simp          
        moreover note `distinct xvec`
        ultimately obtain K' T'' P' where "\<Psi> \<otimes> \<Psi>\<^isub>T' \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<rhd> T \<longmapsto>K'\<lparr>N\<rparr> \<prec> T''" and "\<Psi> \<otimes> \<Psi>\<^isub>P \<otimes> \<Psi>\<^isub>T' \<turnstile> M \<leftrightarrow> K'" and "A\<^isub>T' \<sharp>* K'" and "(\<Psi>,P'\<parallel>T'',Q'\<parallel>T') \<in> TUR \<S>"
          by(rule hocomm2Aux)
        have "\<Psi> \<rhd> P \<parallel> T \<longmapsto> \<tau> \<prec> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> T'')"
          by(rule Comm2) fact+
        moreover from `(\<Psi>,P'\<parallel>T'',Q'\<parallel>T') \<in> TUR \<S>` have "(\<Psi>,\<lparr>\<nu>*xvec\<rparr>P'\<parallel>T'',\<lparr>\<nu>*xvec\<rparr>Q'\<parallel>T') \<in> TUR \<S>" using `xvec \<sharp>* \<Psi>`
          by(induct xvec) (auto simp add: TURSresPres)
        ultimately show ?case
          by blast
      qed
    qed
    thus ?case
      unfolding `R = P \<parallel> T` `S = Q \<parallel> T`
      by -
  qed
qed

lemma hobisimParPres:
  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  shows "\<Psi> \<rhd> P\<parallel>R \<sim>\<^sub>H Q\<parallel>R"
proof -
  obtain A\<^isub>R \<Psi>\<^isub>R where "extractFrame R = \<langle>A\<^isub>R,\<Psi>\<^isub>R\<rangle>" and "distinct A\<^isub>R" and "A\<^isub>R \<sharp>* \<Psi>" and "A\<^isub>R \<sharp>* P" and "A\<^isub>R \<sharp>* Q"
    by(rule_tac freshFrame[where C="(\<Psi>,P,Q)"]) auto
  moreover have "\<Psi>\<otimes>\<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q" using `\<Psi> \<rhd> P \<sim>\<^sub>H Q`
    by(rule hobisimE)
  ultimately show ?thesis
    by(rule_tac hobisimParPresAux)
qed

lemma hobisimParPresAuxSym:
  fixes \<Psi>  :: 'b
  and   \<Psi>\<^isub>R :: 'b
  and   P  :: "('a, 'b, 'c) psi"
  and   Q  :: "('a, 'b, 'c) psi"
  and   R  :: "('a, 'b, 'c) psi"
  and   A\<^isub>R :: "name list"
  
  assumes "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q"
  and     FrR: "extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>"
  and     "A\<^isub>R \<sharp>* \<Psi>"
  and     "A\<^isub>R \<sharp>* P"
  and     "A\<^isub>R \<sharp>* Q"

  shows "\<Psi> \<rhd> R \<parallel> P \<sim>\<^sub>H R \<parallel> Q"
proof -
  from assms have "\<Psi> \<rhd> P \<parallel> R \<sim>\<^sub>H Q \<parallel> R"
    by(rule hobisimParPresAux)
  show ?thesis
    apply(rule hobisimTransitive[OF hobisimBisim, OF bisimParComm])
    apply(rule hobisimSymmetric)
    apply(rule hobisimTransitive[OF hobisimBisim, OF bisimParComm])
    apply(rule hobisimSymmetric)
    by fact
qed

lemma hobisimParPresSym:
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"
  and   R :: "('a, 'b, 'c) psi"
  
  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"

  shows "\<Psi> \<rhd> R \<parallel> P \<sim>\<^sub>H R \<parallel> Q"
proof -
  obtain A\<^isub>R \<Psi>\<^isub>R where "extractFrame R = \<langle>A\<^isub>R, \<Psi>\<^isub>R\<rangle>" and "A\<^isub>R \<sharp>* \<Psi>" and "A\<^isub>R \<sharp>* P" and "A\<^isub>R \<sharp>* Q"
    by(rule_tac C="(\<Psi>, P, Q)" in freshFrame) auto
  moreover from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi> \<otimes> \<Psi>\<^isub>R \<rhd> P \<sim>\<^sub>H Q" by(rule hobisimE)
  ultimately show ?thesis by(rule_tac hobisimParPresAuxSym)
qed

lemma hobisimScopeExtChainSym:
  fixes xvec :: "name list"
  and   Q    :: "('a, 'b, 'c) psi"
  and   P    :: "('a, 'b, 'c) psi"

  assumes "xvec \<sharp>* \<Psi>"
  and     "xvec \<sharp>* Q"

  shows "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P \<parallel> Q) \<sim>\<^sub>H (\<lparr>\<nu>*xvec\<rparr>P) \<parallel> Q"
using assms
by(rule hobisimBisim[OF bisimScopeExtChainSym])

lemma hobangDerivative:
  fixes \<Psi>   :: 'b
  and   P    :: "('a, 'b, 'c) psi"
  and   \<alpha>    :: "'a action"
  and   P'   :: "('a, 'b, 'c) psi"

  assumes "\<Psi> \<rhd> !P \<longmapsto>\<alpha> \<prec> P'"
  and     "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  and     "bn \<alpha> \<sharp>* \<Psi>"
  and     "bn \<alpha> \<sharp>* P"
  and     "bn \<alpha> \<sharp>* Q"
  and     "bn \<alpha> \<sharp>* subject \<alpha>"
  and     "guarded Q"

  obtains Q' R T where "\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P" and "\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                   and "((supp R)::name set) \<subseteq> supp P'" and "((supp T)::name set) \<subseteq> supp Q'"
proof -
  from `\<Psi> \<rhd> !P \<longmapsto>\<alpha> \<prec> P'` have "guarded P" apply - by(ind_cases "\<Psi> \<rhd> !P \<longmapsto>\<alpha> \<prec> P'") (auto simp add: psi.inject)
  assume "\<And>Q' R T. \<lbrakk>\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q'; \<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P; \<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q; \<Psi> \<rhd> R \<sim>\<^sub>H T; ((supp R)::name set) \<subseteq> supp P';
                    ((supp T)::name set) \<subseteq> supp Q'\<rbrakk> \<Longrightarrow> thesis"
  moreover from `\<Psi> \<rhd> !P \<longmapsto>\<alpha> \<prec> P'` `bn \<alpha> \<sharp>* subject \<alpha>` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* P` `bn \<alpha> \<sharp>* Q` `\<Psi> \<rhd> P \<sim>\<^sub>H Q` `guarded Q` 
  have "\<exists>Q' T R . \<Psi> \<rhd> !Q \<longmapsto>\<alpha>  \<prec> Q' \<and> \<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q \<and> \<Psi> \<rhd> R \<sim>\<^sub>H T \<and>
                  ((supp R)::name set) \<subseteq> supp P' \<and> ((supp T)::name set) \<subseteq> supp Q'"
  proof(nominal_induct avoiding: Q rule: bangInduct')
    case(cAlpha \<alpha> P' p Q)
    then obtain Q' T R where QTrans: "\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> (P \<parallel> !P)" and "\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                         and suppR: "((supp R)::name set) \<subseteq> supp P'" and suppT: "((supp T)::name set) \<subseteq> supp Q'"
      by blast
    from QTrans have "distinct(bn \<alpha>)" by(rule boundOutputDistinct)
    have S: "set p \<subseteq> set(bn \<alpha>) \<times> set(bn(p \<bullet> \<alpha>))" by fact
    from QTrans `bn(p \<bullet> \<alpha>) \<sharp>* Q` `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` `bn \<alpha> \<sharp>* subject \<alpha>` `distinct(bn \<alpha>)` have "bn(p \<bullet> \<alpha>) \<sharp>* Q'"
      by(drule_tac freeFreshChainDerivative) simp+
    with QTrans `bn(p \<bullet> \<alpha>) \<sharp>* \<alpha>` S `bn \<alpha> \<sharp>* subject \<alpha>` have "\<Psi> \<rhd> !Q \<longmapsto>(p \<bullet> \<alpha>) \<prec> (p \<bullet> Q')"
      by(force simp add: residualAlpha)
    moreover from `\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> (P \<parallel> !P)` have "(p \<bullet> \<Psi>) \<rhd> (p \<bullet> P') \<sim>\<^sub>H (p \<bullet> (R \<parallel> (P \<parallel> !P)))"
      by(rule hobisimClosed)
    with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* P` `bn(p \<bullet> \<alpha>) \<sharp>* \<Psi>` `bn(p \<bullet> \<alpha>) \<sharp>* P` S have "\<Psi> \<rhd> (p \<bullet> P') \<sim>\<^sub>H (p \<bullet> R) \<parallel> (P \<parallel> !P)"
      by(simp add: eqvts)
    moreover from `\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q` have "(p \<bullet> \<Psi>) \<rhd> (p \<bullet> Q') \<sim>\<^sub>H (p \<bullet> (T \<parallel> !Q))"
      by(rule hobisimClosed)
    with `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* Q` `bn(p \<bullet> \<alpha>) \<sharp>* \<Psi>` `bn(p \<bullet> \<alpha>) \<sharp>* Q` S have "\<Psi> \<rhd> (p \<bullet> Q') \<sim>\<^sub>H (p \<bullet> T) \<parallel> !Q"
      by(simp add: eqvts)
    moreover from `\<Psi> \<rhd> R \<sim>\<^sub>H T` have "(p \<bullet> \<Psi>) \<rhd> (p \<bullet> R) \<sim>\<^sub>H (p \<bullet> T)"
      by(rule hobisimClosed)
    with `bn \<alpha> \<sharp>* \<Psi>` `bn(p \<bullet> \<alpha>) \<sharp>* \<Psi>` S have "\<Psi> \<rhd> (p \<bullet> R) \<sim>\<^sub>H (p \<bullet> T)"
      by(simp add: eqvts)
    moreover from suppR have "((supp(p \<bullet> R))::name set) \<subseteq> supp(p \<bullet> P')"
      apply(erule_tac rev_mp)
      by(subst subsetClosed[of p, symmetric]) (simp add: eqvts)
    moreover from suppT have "((supp(p \<bullet> T))::name set) \<subseteq> supp(p \<bullet> Q')"
      apply(erule_tac rev_mp)
      by(subst subsetClosed[of p, symmetric]) (simp add: eqvts)
    ultimately show ?case by blast
  next
    case(cPar1 \<alpha> P' Q)
    from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` `\<Psi> \<rhd> P \<longmapsto>\<alpha> \<prec> P'` `bn \<alpha> \<sharp>* \<Psi>` `bn \<alpha> \<sharp>* Q` 
    obtain Q' where QTrans: "\<Psi> \<rhd> Q \<longmapsto>\<alpha> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H Q'"
      by(blast dest: hobisimE simE)
    from QTrans have "\<Psi> \<otimes> SBottom' \<rhd> Q \<longmapsto>\<alpha> \<prec> Q'" by(metis statEqTransition Identity AssertionStatEqSym)
    hence "\<Psi> \<rhd> Q \<parallel> !Q \<longmapsto>\<alpha> \<prec> (Q' \<parallel> !Q)" using `bn \<alpha> \<sharp>* Q` by(rule_tac Par1) (assumption | simp)+
    hence "\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> (Q' \<parallel> !Q)" using `guarded Q` by(rule Bang)
    moreover from `guarded P` have "\<Psi> \<rhd> P' \<parallel> !P \<sim>\<^sub>H P' \<parallel> (P \<parallel> !P)" 
      by(metis hobisimBisim[OF bangExt] hobisimParPresSym)
    moreover have "\<Psi> \<rhd> Q' \<parallel> !Q \<sim>\<^sub>H Q' \<parallel> !Q" by(rule hobisimReflexive)
    ultimately show ?case using `\<Psi> \<rhd> P' \<sim>\<^sub>H Q'` by(force simp add: psi.supp)
  next
    case(cPar2 \<alpha> P' Q)
    then obtain Q' T R where QTrans: "\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P" and "\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                         and suppR: "((supp R)::name set) \<subseteq> supp P'" and suppT: "((supp T)::name set) \<subseteq> supp Q'"
      by blast
    note QTrans
    from `\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P` have "\<Psi> \<rhd> P \<parallel> P' \<sim>\<^sub>H R \<parallel> (P \<parallel> !P)"
      by(metis hobisimParPresSym hobisimBisim[OF bisimParComm] hobisimTransitive hobisimBisim[OF bisimParAssoc])
    with QTrans show ?case using `\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q` `\<Psi> \<rhd> R \<sim>\<^sub>H T` suppR suppT
      by(force simp add: psi.supp)
  next
    case(cComm1 M N P' K xvec P'' Q)
    from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` have "\<Psi> \<rhd> Q \<leadsto>[hobisim] P" by(metis hobisimE)
    with `\<Psi> \<rhd> P \<longmapsto>M\<lparr>N\<rparr> \<prec> P'` obtain Q' where QTrans: "\<Psi> \<rhd> Q \<longmapsto>M\<lparr>N\<rparr> \<prec> Q'" and "\<Psi> \<rhd> Q' \<sim>\<^sub>H P'"
      by(force dest: simE)
    from QTrans have "\<Psi> \<otimes> SBottom' \<rhd> Q \<longmapsto>M\<lparr>N\<rparr> \<prec> Q'" by(metis statEqTransition Identity AssertionStatEqSym)
    moreover obtain A\<^isub>Q \<Psi>\<^isub>Q where FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* M" 
      by(rule_tac C="(\<Psi>, Q, M)" in freshFrame) auto
    note FrQ
    moreover from FrQ `guarded Q` have "\<Psi>\<^isub>Q \<simeq> SBottom'" by(blast dest: guardedStatEq)
    from `\<Psi> \<rhd> !P \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P''` `xvec \<sharp>* K` `\<Psi> \<rhd> P \<sim>\<^sub>H Q` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` `xvec \<sharp>* Q` `guarded Q`
    obtain Q'' T R where QTrans': "\<Psi> \<rhd> !Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''" and "\<Psi> \<rhd> P'' \<sim>\<^sub>H R \<parallel> !P" and "\<Psi> \<rhd> Q'' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                     and suppR: "((supp R)::name set) \<subseteq> supp P''" and suppT: "((supp T)::name set) \<subseteq> supp Q''" using cComm1
      by fastsimp
    from QTrans' `\<Psi>\<^isub>Q \<simeq> SBottom'` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> !Q \<longmapsto>K\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q''" 
      by(metis statEqTransition Identity compositionSym AssertionStatEqSym)
    moreover from `\<Psi> \<turnstile> M \<leftrightarrow> K` `\<Psi>\<^isub>Q \<simeq> SBottom'` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> SBottom' \<turnstile> M \<leftrightarrow> K" by(metis statEqEnt Identity compositionSym AssertionStatEqSym)
    ultimately have "\<Psi> \<rhd> Q \<parallel> !Q \<longmapsto>\<tau> \<prec> (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q''))" using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* M` `xvec \<sharp>* Q`
      by(rule_tac Comm1) (assumption | simp)+
    hence "\<Psi> \<rhd> !Q \<longmapsto>\<tau> \<prec> (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q''))" using `guarded Q` by(rule Bang)
    moreover from `\<Psi> \<rhd> P'' \<sim>\<^sub>H R \<parallel> !P` `guarded P` `xvec \<sharp>* \<Psi>` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'') \<sim>\<^sub>H \<lparr>\<nu>*xvec\<rparr>((P' \<parallel> R) \<parallel> (P \<parallel> !P))"
      by(metis hobisimParPresSym hobisimBisim[OF bangExt] hobisimTransitive hobisimBisim[OF bisimParAssoc] hobisimSymmetric hobisimResChainPres)
    with `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'') \<sim>\<^sub>H (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R)) \<parallel> (P \<parallel> !P)"
      by(metis hobisimScopeExtChainSym hobisimTransitive psiFreshVec)
    moreover from `\<Psi> \<rhd> Q'' \<sim>\<^sub>H T \<parallel> !Q` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* Q` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q'') \<sim>\<^sub>H (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)) \<parallel> !Q"
      by(metis hobisimParPresSym hobisimTransitive hobisimBisim[OF bisimParAssoc] hobisimSymmetric hobisimResChainPres hobisimScopeExtChainSym psiFreshVec)
    moreover from `\<Psi> \<rhd> R \<sim>\<^sub>H T` `\<Psi> \<rhd> Q' \<sim>\<^sub>H P'` `xvec \<sharp>* \<Psi>` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R) \<sim>\<^sub>H \<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)"
      by(metis hobisimParPresSym hobisimTransitive hobisimResChainPres hobisimBisim[OF bisimParComm] hobisimE(5))
    moreover from suppR have "((supp(\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R)))::name set) \<subseteq>  supp((\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'')))"
      by(auto simp add: psi.supp resChainSupp)
    moreover from suppT have "((supp(\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)))::name set) \<subseteq>  supp((\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q'')))"
      by(auto simp add: psi.supp resChainSupp)
    ultimately show ?case by blast
  next
    case(cComm2 M xvec N P' K P'' Q)
    from `\<Psi> \<rhd> P \<sim>\<^sub>H Q` `\<Psi> \<rhd> P \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> P'` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* Q` 
    obtain Q' where QTrans: "\<Psi> \<rhd> Q \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H Q'"
      by(metis hobisimE simE bn.simps)
    from QTrans have "\<Psi> \<otimes> SBottom' \<rhd> Q \<longmapsto>M\<lparr>\<nu>*xvec\<rparr>\<langle>N\<rangle> \<prec> Q'" by(metis statEqTransition Identity AssertionStatEqSym)
    moreover obtain A\<^isub>Q \<Psi>\<^isub>Q where FrQ: "extractFrame Q = \<langle>A\<^isub>Q, \<Psi>\<^isub>Q\<rangle>" and "A\<^isub>Q \<sharp>* \<Psi>" and "A\<^isub>Q \<sharp>* Q" and "A\<^isub>Q \<sharp>* M" 
      by(rule_tac C="(\<Psi>, Q, M)" in freshFrame) auto
    note FrQ
    moreover from FrQ `guarded Q` have "\<Psi>\<^isub>Q \<simeq> SBottom'" by(blast dest: guardedStatEq)
    from `\<Psi> \<rhd> !P \<longmapsto>K\<lparr>N\<rparr> \<prec> P''` `\<Psi> \<rhd> P \<sim>\<^sub>H Q` `guarded Q`
   obtain Q'' T R where QTrans': "\<Psi> \<rhd> !Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q''" and "\<Psi> \<rhd> P'' \<sim>\<^sub>H R \<parallel> !P" and "\<Psi> \<rhd> Q'' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                    and suppR: "((supp R)::name set) \<subseteq> supp P''" and suppT: "((supp T)::name set) \<subseteq> supp Q''" using cComm2
     by fastsimp
    from QTrans' `\<Psi>\<^isub>Q \<simeq> SBottom'` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<rhd> !Q \<longmapsto>K\<lparr>N\<rparr> \<prec> Q''" 
      by(metis statEqTransition Identity compositionSym AssertionStatEqSym)
    moreover from `\<Psi> \<turnstile> M \<leftrightarrow> K` `\<Psi>\<^isub>Q \<simeq> SBottom'` have "\<Psi> \<otimes> \<Psi>\<^isub>Q \<otimes> SBottom' \<turnstile> M \<leftrightarrow> K" by(metis statEqEnt Identity compositionSym AssertionStatEqSym)
    ultimately have "\<Psi> \<rhd> Q \<parallel> !Q \<longmapsto>\<tau> \<prec> (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q''))" using `A\<^isub>Q \<sharp>* \<Psi>` `A\<^isub>Q \<sharp>* Q` `A\<^isub>Q \<sharp>* M` `xvec \<sharp>* Q`
      by(rule_tac Comm2) (assumption | simp)+
    hence "\<Psi> \<rhd> !Q \<longmapsto>\<tau> \<prec> (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q''))" using `guarded Q` by(rule Bang)
    moreover from `\<Psi> \<rhd> P'' \<sim>\<^sub>H R \<parallel> !P` `guarded P` `xvec \<sharp>* \<Psi>` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'') \<sim>\<^sub>H \<lparr>\<nu>*xvec\<rparr>((P' \<parallel> R) \<parallel> (P \<parallel> !P))"
      by(metis hobisimParPresSym hobisimBisim[OF bangExt] hobisimTransitive hobisimBisim[OF bisimParAssoc] hobisimSymmetric hobisimResChainPres)
    with `xvec \<sharp>* \<Psi>` `xvec \<sharp>* P` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'') \<sim>\<^sub>H (\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R)) \<parallel> (P \<parallel> !P)"
      by(metis hobisimScopeExtChainSym hobisimTransitive psiFreshVec)
    moreover from `\<Psi> \<rhd> Q'' \<sim>\<^sub>H T \<parallel> !Q` `xvec \<sharp>* \<Psi>` `xvec \<sharp>* Q` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q'') \<sim>\<^sub>H (\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)) \<parallel> !Q"
      by(metis hobisimParPresSym hobisimTransitive hobisimBisim[OF bisimParAssoc] hobisimSymmetric hobisimResChainPres hobisimScopeExtChainSym psiFreshVec)
    moreover from `\<Psi> \<rhd> R \<sim>\<^sub>H T` `\<Psi> \<rhd> P' \<sim>\<^sub>H Q'` `xvec \<sharp>* \<Psi>` have "\<Psi> \<rhd> \<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R) \<sim>\<^sub>H \<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)"
      by(metis hobisimParPresSym hobisimTransitive hobisimResChainPres hobisimBisim[OF bisimParComm])
    moreover from suppR have "((supp(\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> R)))::name set) \<subseteq>  supp((\<lparr>\<nu>*xvec\<rparr>(P' \<parallel> P'')))"
      by(auto simp add: psi.supp resChainSupp)
    moreover from suppT have "((supp(\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> T)))::name set) \<subseteq>  supp((\<lparr>\<nu>*xvec\<rparr>(Q' \<parallel> Q'')))"
      by(auto simp add: psi.supp resChainSupp)
    ultimately show ?case by blast
  next
    case(cBang \<alpha> P' Q)
    then obtain Q' T R where QTrans: "\<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q'" and "\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> (P \<parallel> !P)" and "\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q" and "\<Psi> \<rhd> R \<sim>\<^sub>H T"
                         and suppR: "((supp R)::name set) \<subseteq> supp P'" and suppT: "((supp T)::name set) \<subseteq> supp Q'"
      by blast
    from `\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> (P \<parallel> !P)` `guarded P` have "\<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P" by(metis hobisimBisim[OF bangExt] hobisimParPresSym hobisimTransitive hobisimSymmetric)
    with QTrans show ?case using `\<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q` `\<Psi> \<rhd> R \<sim>\<^sub>H T` suppR suppT
      by blast
  qed
  ultimately show ?thesis by blast
qed

lemma hobisimBangPres:
  fixes \<Psi> :: 'b
  and   P :: "('a, 'b, 'c) psi"
  and   Q :: "('a, 'b, 'c) psi"

  assumes "\<Psi> \<rhd> P \<sim>\<^sub>H Q"
  and     "guarded P"
  and     "guarded Q"

  shows "\<Psi> \<rhd> !P \<sim>\<^sub>H !Q"
proof -
  let ?X = "{(\<Psi>, R \<parallel> !P, R \<parallel> !Q) | \<Psi> P Q R. \<Psi> \<rhd> P \<sim>\<^sub>H Q \<and> guarded P \<and> guarded Q}"
  let ?Y = "{(\<Psi>, P, Q) | \<Psi> P P' Q' Q. \<Psi> \<rhd> P \<sim>\<^sub>H P' \<and> (\<Psi>, P', Q') \<in> ?X \<and> \<Psi> \<rhd> Q' \<sim>\<^sub>H Q}"
  from assms have "(\<Psi>, \<zero> \<parallel> !P, \<zero> \<parallel> !Q) \<in> ?X" by(blast intro: hobisimReflexive)
  moreover have "eqvt ?X" 
    apply(auto simp add: eqvt_def)
    apply(drule_tac p=p in hobisimClosed)
    by fastsimp
  ultimately have "\<Psi> \<rhd> \<zero> \<parallel> !P \<sim>\<^sub>H \<zero> \<parallel> !Q"
  proof(coinduct rule: howeakTransitiveCoinductSC)
    case(cStatEq \<Psi> P Q \<phi>)
    thus ?case by auto
  next
    case(cClauseEq \<Psi> P Q M R)
    thus ?case unfolding legalClause_def
      by(auto simp add: hobisimReflexive)
  next
    case(cSim \<Psi> RP RQ)
    from `(\<Psi>, RP, RQ) \<in> ?X` obtain P Q R where "\<Psi> \<rhd> P \<sim>\<^sub>H Q" and "guarded P" and "guarded Q"
                                           and "RP = R \<parallel> !P" and "RQ = R \<parallel> !Q"
      by auto
    note `\<Psi> \<rhd> P \<sim>\<^sub>H Q` 
    moreover from `eqvt ?X` have "eqvt ?Y" by blast
    moreover note `guarded P` `guarded Q` hobisimE(3) hobisimE(4) hobisimE(5) hostatEqBisim hobisimClosed hobisimBisim[OF bisimParAssoc[THEN bisimSymmetric]]
                  hobisimParPres hobisimParPresAuxSym hobisimResChainPres hobisimScopeExtChainSym hobisimTransitive
    moreover have "\<And>\<Psi> P Q R T. \<lbrakk>\<Psi> \<rhd> P \<sim>\<^sub>H Q; (\<Psi>, Q, R) \<in> ?Y; \<Psi> \<rhd> R \<sim>\<^sub>H T\<rbrakk> \<Longrightarrow> (\<Psi>, P, T) \<in> ?Y"
      by auto (metis hobisimTransitive)
    moreover have "\<And>\<Psi> P Q R. \<lbrakk>\<Psi> \<rhd> P \<sim>\<^sub>H Q; guarded P; guarded Q\<rbrakk> \<Longrightarrow> (\<Psi>, R \<parallel> !P, R \<parallel> !Q) \<in> ?Y" by(blast intro: hobisimReflexive)
    moreover have "\<And>\<Psi> P \<alpha> P' Q. \<lbrakk>\<Psi> \<rhd> !P \<longmapsto>\<alpha> \<prec> P'; \<Psi> \<rhd> P \<sim>\<^sub>H Q; bn \<alpha> \<sharp>* \<Psi>;  bn \<alpha> \<sharp>* P;  bn \<alpha> \<sharp>* Q; guarded Q; bn \<alpha> \<sharp>* subject \<alpha>\<rbrakk> \<Longrightarrow>
                                         \<exists>Q' R T.  \<Psi> \<rhd> !Q \<longmapsto>\<alpha> \<prec> Q' \<and> \<Psi> \<rhd> P' \<sim>\<^sub>H R \<parallel> !P \<and>  \<Psi> \<rhd> Q' \<sim>\<^sub>H T \<parallel> !Q \<and>
                                                   \<Psi> \<rhd> R \<sim>\<^sub>H T \<and> ((supp R)::name set) \<subseteq> supp P' \<and> 
                                                   ((supp T)::name set) \<subseteq> supp Q'"
      by(blast elim: hobangDerivative)
    ultimately have "\<Psi> \<rhd> R \<parallel> !P \<leadsto>[?Y] R \<parallel> !Q"
      by(rule bangPres)
    with `RP = R \<parallel> !P` `RQ = R \<parallel> !Q` show ?case
      by blast
  next
    case(cExt \<Psi> RP RQ \<Psi>')
    thus ?case by(blast dest: hobisimE)
  next
    case(cSym \<Psi> RP RQ)
    thus ?case by(blast dest: hobisimE)
  qed
  thus ?thesis
    by(metis hobisimTransitive hobisimBisim[OF bisimParNil] hobisimSymmetric hobisimBisim[OF bisimParComm])
qed

end
end